/* document-close-dialog.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gi18n-lib.h>


#define VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG (valide_abstract_close_dialog_get_type ())
#define VALIDE_ABSTRACT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG, ValideAbstractCloseDialog))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG, ValideAbstractCloseDialogClass))
#define VALIDE_IS_ABSTRACT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG))
#define VALIDE_IS_ABSTRACT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG, ValideAbstractCloseDialogClass))

typedef struct _ValideAbstractCloseDialog ValideAbstractCloseDialog;
typedef struct _ValideAbstractCloseDialogClass ValideAbstractCloseDialogClass;
typedef struct _ValideAbstractCloseDialogPrivate ValideAbstractCloseDialogPrivate;

#define VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS (valide_abstract_close_dialog_window_widgets_get_type ())
#define VALIDE_ABSTRACT_CLOSE_DIALOG_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractCloseDialogwindow_widgets))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractCloseDialogwindow_widgetsClass))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_CLOSE_DIALOG_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_CLOSE_DIALOG_TYPE_WINDOW_WIDGETS, ValideAbstractCloseDialogwindow_widgetsClass))

typedef struct _ValideAbstractCloseDialogwindow_widgets ValideAbstractCloseDialogwindow_widgets;
typedef struct _ValideAbstractCloseDialogwindow_widgetsClass ValideAbstractCloseDialogwindow_widgetsClass;

#define VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG (valide_document_close_dialog_get_type ())
#define VALIDE_DOCUMENT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, ValideDocumentCloseDialog))
#define VALIDE_DOCUMENT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, ValideDocumentCloseDialogClass))
#define VALIDE_IS_DOCUMENT_CLOSE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG))
#define VALIDE_IS_DOCUMENT_CLOSE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG))
#define VALIDE_DOCUMENT_CLOSE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, ValideDocumentCloseDialogClass))

typedef struct _ValideDocumentCloseDialog ValideDocumentCloseDialog;
typedef struct _ValideDocumentCloseDialogClass ValideDocumentCloseDialogClass;
typedef struct _ValideDocumentCloseDialogPrivate ValideDocumentCloseDialogPrivate;

#define VALIDE_TYPE_IDOCUMENT (valide_idocument_get_type ())
#define VALIDE_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocument))
#define VALIDE_IS_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_IDOCUMENT))
#define VALIDE_IDOCUMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocumentIface))

typedef struct _ValideiDocument ValideiDocument;
typedef struct _ValideiDocumentIface ValideiDocumentIface;

#define VALIDE_TYPE_UI_MANAGER (valide_ui_manager_get_type ())
#define VALIDE_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManager))
#define VALIDE_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))
#define VALIDE_IS_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_IS_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_UI_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))

typedef struct _ValideUIManager ValideUIManager;
typedef struct _ValideUIManagerClass ValideUIManagerClass;

#define VALIDE_TYPE_DOCUMENT_STATE (valide_document_state_get_type ())

#define VALIDE_DOCUMENT_CLOSE_DIALOG_TYPE_COL (valide_document_close_dialog_col_get_type ())
typedef struct _ValideAbstractCloseDialogwindow_widgetsPrivate ValideAbstractCloseDialogwindow_widgetsPrivate;

struct _ValideAbstractCloseDialog {
	GtkObject parent_instance;
	ValideAbstractCloseDialogPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractCloseDialogwindow_widgets* widgets;
};

struct _ValideAbstractCloseDialogClass {
	GtkObjectClass parent_class;
};

/**
 * DocumentCloseDialog is a dialog box that displays the unsaved document when
 * close all or close the main window
 */
struct _ValideDocumentCloseDialog {
	ValideAbstractCloseDialog parent_instance;
	ValideDocumentCloseDialogPrivate * priv;
};

struct _ValideDocumentCloseDialogClass {
	ValideAbstractCloseDialogClass parent_class;
};

typedef enum  {
	VALIDE_DOCUMENT_STATE_NORMAL,
	VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED,
	VALIDE_DOCUMENT_STATE_BAD_ENCODING,
	VALIDE_DOCUMENT_STATE_INFO
} ValideDocumentState;

/**
 * An interface for document
 */
struct _ValideiDocumentIface {
	GTypeInterface parent_iface;
	void (*open) (ValideiDocument* self, const char* path, GError** error);
	void (*save) (ValideiDocument* self, const char* current_folder);
	void (*save_as) (ValideiDocument* self, const char* current_folder);
	void (*rename) (ValideiDocument* self);
	gboolean (*close) (ValideiDocument* self);
	GdkPixbuf* (*get_icon) (ValideiDocument* self);
	char* (*get_tooltips) (ValideiDocument* self);
	void (*setup_ui) (ValideiDocument* self, ValideUIManager* ui_manager);
	ValideDocumentState (*get_state) (ValideiDocument* self);
	void (*set_state) (ValideiDocument* self, ValideDocumentState value);
	gboolean (*get_is_save) (ValideiDocument* self);
	void (*set_is_save) (ValideiDocument* self, gboolean value);
	const char* (*get_path) (ValideiDocument* self);
	void (*set_path) (ValideiDocument* self, const char* value);
	const char* (*get_title) (ValideiDocument* self);
	const char* (*get_filename) (ValideiDocument* self);
};

struct _ValideDocumentCloseDialogPrivate {
	GtkListStore* list_store;
	GList* _selected;
};

/* enum for tree model columns */
typedef enum  {
	VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE,
	VALIDE_DOCUMENT_CLOSE_DIALOG_COL_TITLE,
	VALIDE_DOCUMENT_CLOSE_DIALOG_COL_DOCUMENT,
	VALIDE_DOCUMENT_CLOSE_DIALOG_COL_NB
} ValideDocumentCloseDialogCol;

struct _ValideAbstractCloseDialogwindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractCloseDialogwindow_widgetsPrivate * priv;
	GtkListStore* list_store;
	GtkDialog* dialog;
	GtkVBox* dialog_vbox1;
	GtkVBox* vbox1;
	GtkHBox* hbox1;
	GtkImage* image1;
	GtkVBox* vbox2;
	GtkLabel* label;
	GtkLabel* label3;
	GtkTreeView* tree_view;
	GtkLabel* label1;
	GtkHButtonBox* dialog_action_area1;
	GtkButton* button1;
	GtkButton* button2;
	GtkButton* button3;
};

struct _ValideAbstractCloseDialogwindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractCloseDialogwindow_widgets *self);
};


static gpointer valide_document_close_dialog_parent_class = NULL;

GType valide_abstract_close_dialog_get_type (void);
gpointer valide_abstract_close_dialog_window_widgets_ref (gpointer instance);
void valide_abstract_close_dialog_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_close_dialog_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_close_dialog_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_close_dialog_value_get_window_widgets (const GValue* value);
GType valide_abstract_close_dialog_window_widgets_get_type (void);
GType valide_document_close_dialog_get_type (void);
GType valide_ui_manager_get_type (void);
GType valide_document_state_get_type (void);
GType valide_idocument_get_type (void);
#define VALIDE_DOCUMENT_CLOSE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, ValideDocumentCloseDialogPrivate))
enum  {
	VALIDE_DOCUMENT_CLOSE_DIALOG_DUMMY_PROPERTY,
	VALIDE_DOCUMENT_CLOSE_DIALOG_SELECTED
};
static GType valide_document_close_dialog_col_get_type (void);
static void _g_list_free_g_object_unref (GList* self);
static void valide_document_close_dialog_active_toggled (ValideDocumentCloseDialog* self, GtkCellRendererToggle* sender, const char* path_str);
gboolean valide_idocument_get_is_save (ValideiDocument* self);
static void _valide_document_close_dialog_active_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender, const char* path, gpointer self);
const char* valide_idocument_get_title (ValideiDocument* self);
ValideDocumentCloseDialog* valide_document_close_dialog_new (GList* documents);
ValideDocumentCloseDialog* valide_document_close_dialog_construct (GType object_type, GList* documents);
void valide_document_close_dialog_set_transient_for (ValideDocumentCloseDialog* self, GtkWindow* parent);
void valide_document_close_dialog_set_modal (ValideDocumentCloseDialog* self, gboolean modal);
gint valide_document_close_dialog_run (ValideDocumentCloseDialog* self);
void valide_document_close_dialog_destroy (ValideDocumentCloseDialog* self);
GList* valide_document_close_dialog_get_selected (ValideDocumentCloseDialog* self);
static void valide_document_close_dialog_finalize (GObject* obj);
static void valide_document_close_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);




static GType valide_document_close_dialog_col_get_type (void) {
	static GType valide_document_close_dialog_col_type_id = 0;
	if (G_UNLIKELY (valide_document_close_dialog_col_type_id == 0)) {
		static const GEnumValue values[] = {{VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE, "VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE", "active"}, {VALIDE_DOCUMENT_CLOSE_DIALOG_COL_TITLE, "VALIDE_DOCUMENT_CLOSE_DIALOG_COL_TITLE", "title"}, {VALIDE_DOCUMENT_CLOSE_DIALOG_COL_DOCUMENT, "VALIDE_DOCUMENT_CLOSE_DIALOG_COL_DOCUMENT", "document"}, {VALIDE_DOCUMENT_CLOSE_DIALOG_COL_NB, "VALIDE_DOCUMENT_CLOSE_DIALOG_COL_NB", "nb"}, {0, NULL, NULL}};
		valide_document_close_dialog_col_type_id = g_enum_register_static ("ValideDocumentCloseDialogCol", values);
	}
	return valide_document_close_dialog_col_type_id;
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


#line 66 "document-close-dialog.vala"
static void valide_document_close_dialog_active_toggled (ValideDocumentCloseDialog* self, GtkCellRendererToggle* sender, const char* path_str) {
#line 237 "document-close-dialog.c"
	gboolean active;
	GtkTreeIter iter = {0};
	GtkTreePath* path;
	GtkTreePath* _tmp0_;
#line 66 "document-close-dialog.vala"
	g_return_if_fail (self != NULL);
#line 66 "document-close-dialog.vala"
	g_return_if_fail (sender != NULL);
#line 66 "document-close-dialog.vala"
	g_return_if_fail (path_str != NULL);
#line 248 "document-close-dialog.c"
	active = FALSE;
	path = NULL;
	_tmp0_ = NULL;
#line 72 "document-close-dialog.vala"
	path = (_tmp0_ = gtk_tree_path_new_from_string (path_str), (path == NULL) ? NULL : (path = (gtk_tree_path_free (path), NULL)), _tmp0_);
#line 73 "document-close-dialog.vala"
	gtk_tree_model_get_iter ((GtkTreeModel*) self->priv->list_store, &iter, path);
#line 74 "document-close-dialog.vala"
	gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store, &iter, VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE, &active, -1);
#line 76 "document-close-dialog.vala"
	active = !active;
#line 78 "document-close-dialog.vala"
	gtk_list_store_set (self->priv->list_store, &iter, VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE, active, -1);
#line 262 "document-close-dialog.c"
	(path == NULL) ? NULL : (path = (gtk_tree_path_free (path), NULL));
}


#line 66 "document-close-dialog.vala"
static void _valide_document_close_dialog_active_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender, const char* path, gpointer self) {
#line 269 "document-close-dialog.c"
	valide_document_close_dialog_active_toggled (self, _sender, path);
}


#line 922 "glib-2.0.vapi"
static char* string_substring (const char* self, glong offset, glong len) {
#line 276 "document-close-dialog.c"
	char* result;
	glong string_length;
	const char* start;
#line 922 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 282 "document-close-dialog.c"
	string_length = g_utf8_strlen (self, -1);
#line 924 "glib-2.0.vapi"
	if (offset < 0) {
#line 925 "glib-2.0.vapi"
		offset = string_length + offset;
#line 926 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= 0, NULL);
#line 290 "document-close-dialog.c"
	} else {
#line 928 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 294 "document-close-dialog.c"
	}
#line 930 "glib-2.0.vapi"
	if (len < 0) {
#line 931 "glib-2.0.vapi"
		len = string_length - offset;
#line 300 "document-close-dialog.c"
	}
#line 933 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 304 "document-close-dialog.c"
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


/**
   * Create a new Valide.DocumentCloseDialog
   *
   * @param documents The list of documents
   */
#line 86 "document-close-dialog.vala"
ValideDocumentCloseDialog* valide_document_close_dialog_construct (GType object_type, GList* documents) {
#line 318 "document-close-dialog.c"
	ValideDocumentCloseDialog * self;
	gint unsave;
	GtkCellRendererToggle* toggle_render;
	GtkTreeViewColumn* column;
	GtkCellRendererText* text_render;
	char* _tmp1_;
	GtkListStore* _tmp2_;
	GtkCellRendererToggle* _tmp3_;
	GtkTreeViewColumn* _tmp4_;
	GtkCellRendererText* _tmp5_;
	GtkTreeViewColumn* _tmp6_;
	self = g_object_newv (object_type, 0, NULL);
	unsave = 0;
	toggle_render = NULL;
	column = NULL;
	text_render = NULL;
	{
		GList* document_collection;
		GList* document_it;
#line 93 "document-close-dialog.vala"
		document_collection = documents;
#line 340 "document-close-dialog.c"
		for (document_it = document_collection; document_it != NULL; document_it = document_it->next) {
			ValideiDocument* _tmp0_;
			ValideiDocument* document;
#line 86 "document-close-dialog.vala"
			_tmp0_ = NULL;
#line 93 "document-close-dialog.vala"
			document = (_tmp0_ = (ValideiDocument*) document_it->data, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 348 "document-close-dialog.c"
			{
#line 95 "document-close-dialog.vala"
				if (!valide_idocument_get_is_save (document)) {
#line 97 "document-close-dialog.vala"
					unsave++;
#line 354 "document-close-dialog.c"
				}
				(document == NULL) ? NULL : (document = (g_object_unref (document), NULL));
			}
		}
	}
#line 820 "glib-2.0.vapi"
	_tmp1_ = NULL;
#line 101 "document-close-dialog.vala"
	gtk_label_set_markup (((ValideAbstractCloseDialog*) self)->widgets->label, _tmp1_ = g_strdup_printf (_ ("<b>There are %d documents with unsaved changes. Save changes before closing?</b>"), unsave));
#line 364 "document-close-dialog.c"
	_tmp1_ = (g_free (_tmp1_), NULL);
	_tmp2_ = NULL;
#line 103 "document-close-dialog.vala"
	self->priv->list_store = (_tmp2_ = gtk_list_store_new ((gint) VALIDE_DOCUMENT_CLOSE_DIALOG_COL_NB, G_TYPE_BOOLEAN, G_TYPE_STRING, VALIDE_TYPE_IDOCUMENT, NULL), (self->priv->list_store == NULL) ? NULL : (self->priv->list_store = (g_object_unref (self->priv->list_store), NULL)), _tmp2_);
#line 106 "document-close-dialog.vala"
	gtk_tree_view_set_model (((ValideAbstractCloseDialog*) self)->widgets->tree_view, (GtkTreeModel*) self->priv->list_store);
#line 371 "document-close-dialog.c"
	_tmp3_ = NULL;
#line 108 "document-close-dialog.vala"
	toggle_render = (_tmp3_ = g_object_ref_sink ((GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ()), (toggle_render == NULL) ? NULL : (toggle_render = (g_object_unref (toggle_render), NULL)), _tmp3_);
#line 109 "document-close-dialog.vala"
	g_signal_connect_object (toggle_render, "toggled", (GCallback) _valide_document_close_dialog_active_toggled_gtk_cell_renderer_toggle_toggled, self, 0);
#line 377 "document-close-dialog.c"
	_tmp4_ = NULL;
#line 110 "document-close-dialog.vala"
	column = (_tmp4_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Save"), (GtkCellRenderer*) toggle_render, "active", VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE, NULL, NULL)), (column == NULL) ? NULL : (column = (g_object_unref (column), NULL)), _tmp4_);
#line 111 "document-close-dialog.vala"
	gtk_tree_view_append_column (((ValideAbstractCloseDialog*) self)->widgets->tree_view, column);
#line 383 "document-close-dialog.c"
	_tmp5_ = NULL;
#line 113 "document-close-dialog.vala"
	text_render = (_tmp5_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), (text_render == NULL) ? NULL : (text_render = (g_object_unref (text_render), NULL)), _tmp5_);
#line 387 "document-close-dialog.c"
	_tmp6_ = NULL;
#line 114 "document-close-dialog.vala"
	column = (_tmp6_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Filename"), (GtkCellRenderer*) text_render, "text", VALIDE_DOCUMENT_CLOSE_DIALOG_COL_TITLE, NULL, NULL)), (column == NULL) ? NULL : (column = (g_object_unref (column), NULL)), _tmp6_);
#line 115 "document-close-dialog.vala"
	gtk_tree_view_append_column (((ValideAbstractCloseDialog*) self)->widgets->tree_view, column);
#line 393 "document-close-dialog.c"
	{
		GList* document_collection;
		GList* document_it;
#line 117 "document-close-dialog.vala"
		document_collection = documents;
#line 399 "document-close-dialog.c"
		for (document_it = document_collection; document_it != NULL; document_it = document_it->next) {
			ValideiDocument* _tmp10_;
			ValideiDocument* document;
#line 86 "document-close-dialog.vala"
			_tmp10_ = NULL;
#line 117 "document-close-dialog.vala"
			document = (_tmp10_ = (ValideiDocument*) document_it->data, (_tmp10_ == NULL) ? NULL : g_object_ref (_tmp10_));
#line 407 "document-close-dialog.c"
			{
#line 119 "document-close-dialog.vala"
				if (!valide_idocument_get_is_save (document)) {
#line 411 "document-close-dialog.c"
					GtkTreeIter iter = {0};
					char* path;
					char* _tmp8_;
					const char* _tmp7_;
					path = NULL;
					_tmp8_ = NULL;
#line 124 "document-close-dialog.vala"
					_tmp7_ = NULL;
#line 124 "document-close-dialog.vala"
					path = (_tmp8_ = (_tmp7_ = valide_idocument_get_title (document), (_tmp7_ == NULL) ? NULL : g_strdup (_tmp7_)), path = (g_free (path), NULL), _tmp8_);
#line 125 "document-close-dialog.vala"
					if (g_str_has_prefix (path, "* ")) {
#line 424 "document-close-dialog.c"
						char* _tmp9_;
						_tmp9_ = NULL;
#line 127 "document-close-dialog.vala"
						path = (_tmp9_ = string_substring (path, (glong) 2, g_utf8_strlen (path, -1) - 2), path = (g_free (path), NULL), _tmp9_);
#line 429 "document-close-dialog.c"
					}
#line 129 "document-close-dialog.vala"
					gtk_list_store_append (self->priv->list_store, &iter);
#line 130 "document-close-dialog.vala"
					gtk_list_store_set (self->priv->list_store, &iter, VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE, TRUE, VALIDE_DOCUMENT_CLOSE_DIALOG_COL_TITLE, path, VALIDE_DOCUMENT_CLOSE_DIALOG_COL_DOCUMENT, document, -1);
#line 435 "document-close-dialog.c"
					path = (g_free (path), NULL);
				}
				(document == NULL) ? NULL : (document = (g_object_unref (document), NULL));
			}
		}
	}
	(toggle_render == NULL) ? NULL : (toggle_render = (g_object_unref (toggle_render), NULL));
	(column == NULL) ? NULL : (column = (g_object_unref (column), NULL));
	(text_render == NULL) ? NULL : (text_render = (g_object_unref (text_render), NULL));
	return self;
}


#line 86 "document-close-dialog.vala"
ValideDocumentCloseDialog* valide_document_close_dialog_new (GList* documents) {
#line 86 "document-close-dialog.vala"
	return valide_document_close_dialog_construct (VALIDE_TYPE_DOCUMENT_CLOSE_DIALOG, documents);
#line 453 "document-close-dialog.c"
}


/**
   * @see Gtk.Window.set_transient_for
   */
#line 138 "document-close-dialog.vala"
void valide_document_close_dialog_set_transient_for (ValideDocumentCloseDialog* self, GtkWindow* parent) {
#line 138 "document-close-dialog.vala"
	g_return_if_fail (self != NULL);
#line 138 "document-close-dialog.vala"
	g_return_if_fail (parent != NULL);
#line 140 "document-close-dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) ((ValideAbstractCloseDialog*) self)->widgets->dialog, parent);
#line 468 "document-close-dialog.c"
}


/**
   * @see Gtk.Dialog.set_transient_for
   */
#line 146 "document-close-dialog.vala"
void valide_document_close_dialog_set_modal (ValideDocumentCloseDialog* self, gboolean modal) {
#line 146 "document-close-dialog.vala"
	g_return_if_fail (self != NULL);
#line 148 "document-close-dialog.vala"
	gtk_window_set_modal ((GtkWindow*) ((ValideAbstractCloseDialog*) self)->widgets->dialog, modal);
#line 481 "document-close-dialog.c"
}


/**
   * @see Gtk.Dialog.run
   */
#line 154 "document-close-dialog.vala"
gint valide_document_close_dialog_run (ValideDocumentCloseDialog* self) {
#line 490 "document-close-dialog.c"
	gint result;
#line 154 "document-close-dialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 156 "document-close-dialog.vala"
	gtk_widget_show_all ((GtkWidget*) ((ValideAbstractCloseDialog*) self)->widgets->dialog);
#line 496 "document-close-dialog.c"
	result = gtk_dialog_run (((ValideAbstractCloseDialog*) self)->widgets->dialog);
	return result;
}


/**
   * @see Gtk.Widget.destroy
   */
#line 163 "document-close-dialog.vala"
void valide_document_close_dialog_destroy (ValideDocumentCloseDialog* self) {
#line 163 "document-close-dialog.vala"
	g_return_if_fail (self != NULL);
#line 165 "document-close-dialog.vala"
	gtk_object_destroy ((GtkObject*) ((ValideAbstractCloseDialog*) self)->widgets->dialog);
#line 511 "document-close-dialog.c"
}


GList* valide_document_close_dialog_get_selected (ValideDocumentCloseDialog* self) {
	GList* result;
	GtkTreeIter iter = {0};
	GList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = NULL;
#line 49 "document-close-dialog.vala"
	self->priv->_selected = (_tmp0_ = NULL, (self->priv->_selected == NULL) ? NULL : (self->priv->_selected = (_g_list_free_g_object_unref (self->priv->_selected), NULL)), _tmp0_);
#line 50 "document-close-dialog.vala"
	gtk_tree_model_get_iter_first ((GtkTreeModel*) self->priv->list_store, &iter);
#line 525 "document-close-dialog.c"
	{
		gboolean _tmp1_;
		_tmp1_ = TRUE;
#line 51 "document-close-dialog.vala"
		while (TRUE) {
#line 531 "document-close-dialog.c"
			gboolean active;
			ValideiDocument* document;
#line 51 "document-close-dialog.vala"
			if (!_tmp1_) {
#line 61 "document-close-dialog.vala"
				if (!gtk_tree_model_iter_next ((GtkTreeModel*) self->priv->list_store, &iter)) {
#line 61 "document-close-dialog.vala"
					break;
#line 540 "document-close-dialog.c"
				}
			}
#line 51 "document-close-dialog.vala"
			_tmp1_ = FALSE;
#line 545 "document-close-dialog.c"
			active = FALSE;
			document = NULL;
#line 56 "document-close-dialog.vala"
			gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store, &iter, VALIDE_DOCUMENT_CLOSE_DIALOG_COL_ACTIVE, &active, VALIDE_DOCUMENT_CLOSE_DIALOG_COL_DOCUMENT, &document, -1);
#line 57 "document-close-dialog.vala"
			if (active) {
#line 552 "document-close-dialog.c"
				ValideiDocument* _tmp2_;
#line 59 "document-close-dialog.vala"
				_tmp2_ = NULL;
#line 59 "document-close-dialog.vala"
				self->priv->_selected = g_list_append (self->priv->_selected, (_tmp2_ = document, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)));
#line 558 "document-close-dialog.c"
			}
			(document == NULL) ? NULL : (document = (g_object_unref (document), NULL));
		}
	}
	result = self->priv->_selected;
	return result;
}


static void valide_document_close_dialog_class_init (ValideDocumentCloseDialogClass * klass) {
	valide_document_close_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideDocumentCloseDialogPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_document_close_dialog_get_property;
	G_OBJECT_CLASS (klass)->finalize = valide_document_close_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_DOCUMENT_CLOSE_DIALOG_SELECTED, g_param_spec_pointer ("selected", "selected", "selected", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void valide_document_close_dialog_instance_init (ValideDocumentCloseDialog * self) {
	self->priv = VALIDE_DOCUMENT_CLOSE_DIALOG_GET_PRIVATE (self);
}


static void valide_document_close_dialog_finalize (GObject* obj) {
	ValideDocumentCloseDialog * self;
	self = VALIDE_DOCUMENT_CLOSE_DIALOG (obj);
	(self->priv->list_store == NULL) ? NULL : (self->priv->list_store = (g_object_unref (self->priv->list_store), NULL));
	(self->priv->_selected == NULL) ? NULL : (self->priv->_selected = (_g_list_free_g_object_unref (self->priv->_selected), NULL));
	G_OBJECT_CLASS (valide_document_close_dialog_parent_class)->finalize (obj);
}


GType valide_document_close_dialog_get_type (void) {
	static GType valide_document_close_dialog_type_id = 0;
	if (valide_document_close_dialog_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideDocumentCloseDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_document_close_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideDocumentCloseDialog), 0, (GInstanceInitFunc) valide_document_close_dialog_instance_init, NULL };
		valide_document_close_dialog_type_id = g_type_register_static (VALIDE_TYPE_ABSTRACT_CLOSE_DIALOG, "ValideDocumentCloseDialog", &g_define_type_info, 0);
	}
	return valide_document_close_dialog_type_id;
}


static void valide_document_close_dialog_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideDocumentCloseDialog * self;
	gpointer boxed;
	self = VALIDE_DOCUMENT_CLOSE_DIALOG (object);
	switch (property_id) {
		case VALIDE_DOCUMENT_CLOSE_DIALOG_SELECTED:
		g_value_set_pointer (value, valide_document_close_dialog_get_selected (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}




