/* native-builder.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>


#define VALIDE_TYPE_HELP_DIALOG (valide_help_dialog_get_type ())
#define VALIDE_HELP_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_HELP_DIALOG, ValideHelpDialog))
#define VALIDE_HELP_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_HELP_DIALOG, ValideHelpDialogClass))
#define VALIDE_IS_HELP_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_HELP_DIALOG))
#define VALIDE_IS_HELP_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_HELP_DIALOG))
#define VALIDE_HELP_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_HELP_DIALOG, ValideHelpDialogClass))

typedef struct _ValideHelpDialog ValideHelpDialog;
typedef struct _ValideHelpDialogClass ValideHelpDialogClass;
typedef struct _ValideHelpDialogPrivate ValideHelpDialogPrivate;

#define VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES (valide_abstract_native_builder_preferences_get_type ())
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES, ValideAbstractNativeBuilderPreferences))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES, ValideAbstractNativeBuilderPreferencesClass))
#define VALIDE_IS_ABSTRACT_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_IS_ABSTRACT_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES, ValideAbstractNativeBuilderPreferencesClass))

typedef struct _ValideAbstractNativeBuilderPreferences ValideAbstractNativeBuilderPreferences;
typedef struct _ValideAbstractNativeBuilderPreferencesClass ValideAbstractNativeBuilderPreferencesClass;
typedef struct _ValideAbstractNativeBuilderPreferencesPrivate ValideAbstractNativeBuilderPreferencesPrivate;

#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS (valide_abstract_native_builder_preferences_window_widgets_get_type ())
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractNativeBuilderPreferenceswindow_widgets))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractNativeBuilderPreferenceswindow_widgetsClass))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_NATIVE_BUILDER_PREFERENCES_TYPE_WINDOW_WIDGETS, ValideAbstractNativeBuilderPreferenceswindow_widgetsClass))

typedef struct _ValideAbstractNativeBuilderPreferenceswindow_widgets ValideAbstractNativeBuilderPreferenceswindow_widgets;
typedef struct _ValideAbstractNativeBuilderPreferenceswindow_widgetsClass ValideAbstractNativeBuilderPreferenceswindow_widgetsClass;

#define VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES (valide_native_builder_preferences_get_type ())
#define VALIDE_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, ValideNativeBuilderPreferences))
#define VALIDE_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, ValideNativeBuilderPreferencesClass))
#define VALIDE_IS_NATIVE_BUILDER_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_IS_NATIVE_BUILDER_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES))
#define VALIDE_NATIVE_BUILDER_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, ValideNativeBuilderPreferencesClass))

typedef struct _ValideNativeBuilderPreferences ValideNativeBuilderPreferences;
typedef struct _ValideNativeBuilderPreferencesClass ValideNativeBuilderPreferencesClass;
typedef struct _ValideNativeBuilderPreferencesPrivate ValideNativeBuilderPreferencesPrivate;

#define VALIDE_TYPE_NATIVE_BUILDER_OPTIONS (valide_native_builder_options_get_type ())
#define VALIDE_NATIVE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS, ValideNativeBuilderOptions))
#define VALIDE_NATIVE_BUILDER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS, ValideNativeBuilderOptionsClass))
#define VALIDE_IS_NATIVE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS))
#define VALIDE_IS_NATIVE_BUILDER_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS))
#define VALIDE_NATIVE_BUILDER_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS, ValideNativeBuilderOptionsClass))

typedef struct _ValideNativeBuilderOptions ValideNativeBuilderOptions;
typedef struct _ValideNativeBuilderOptionsClass ValideNativeBuilderOptionsClass;

#define VALIDE_TYPE_PROJECT (valide_project_get_type ())
#define VALIDE_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT, ValideProject))
#define VALIDE_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT, ValideProjectClass))
#define VALIDE_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT))
#define VALIDE_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT))
#define VALIDE_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT, ValideProjectClass))

typedef struct _ValideProject ValideProject;
typedef struct _ValideProjectClass ValideProjectClass;
typedef struct _ValideAbstractNativeBuilderPreferenceswindow_widgetsPrivate ValideAbstractNativeBuilderPreferenceswindow_widgetsPrivate;

#define G_YAML_TYPE_BUILDABLE (g_yaml_buildable_get_type ())
#define G_YAML_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildable))
#define G_YAML_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDABLE))
#define G_YAML_BUILDABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildableIface))

typedef struct _GYAMLBuildable GYAMLBuildable;
typedef struct _GYAMLBuildableIface GYAMLBuildableIface;

#define G_YAML_TYPE_BUILDER (g_yaml_builder_get_type ())
#define G_YAML_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilder))
#define G_YAML_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))
#define G_YAML_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDER))
#define G_YAML_IS_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_BUILDER))
#define G_YAML_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))

typedef struct _GYAMLBuilder GYAMLBuilder;
typedef struct _GYAMLBuilderClass GYAMLBuilderClass;

#define G_YAML_TYPE_NODE (g_yaml_node_get_type ())
#define G_YAML_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_NODE, GYAMLNode))
#define G_YAML_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_NODE, GYAMLNodeClass))
#define G_YAML_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_NODE))
#define G_YAML_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_NODE))
#define G_YAML_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_NODE, GYAMLNodeClass))

typedef struct _GYAMLNode GYAMLNode;
typedef struct _GYAMLNodeClass GYAMLNodeClass;
typedef struct _ValideProjectPrivate ValideProjectPrivate;

#define VALIDE_TYPE_BUILDER_MANAGER (valide_builder_manager_get_type ())
#define VALIDE_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManager))
#define VALIDE_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))
#define VALIDE_IS_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_IS_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_BUILDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))

typedef struct _ValideBuilderManager ValideBuilderManager;
typedef struct _ValideBuilderManagerClass ValideBuilderManagerClass;

#define VALIDE_TYPE_SOURCE (valide_source_get_type ())
#define VALIDE_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE, ValideSource))
#define VALIDE_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE, ValideSourceClass))
#define VALIDE_IS_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE))
#define VALIDE_IS_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE))
#define VALIDE_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE, ValideSourceClass))

typedef struct _ValideSource ValideSource;
typedef struct _ValideSourceClass ValideSourceClass;

#define VALIDE_TYPE_PACKAGE (valide_package_get_type ())
#define VALIDE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PACKAGE, ValidePackage))
#define VALIDE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PACKAGE, ValidePackageClass))
#define VALIDE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PACKAGE))
#define VALIDE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PACKAGE))
#define VALIDE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PACKAGE, ValidePackageClass))

typedef struct _ValidePackage ValidePackage;
typedef struct _ValidePackageClass ValidePackageClass;

#define VALIDE_TYPE_VAPI_DIR (valide_vapi_dir_get_type ())
#define VALIDE_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDir))
#define VALIDE_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))
#define VALIDE_IS_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_IS_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_VAPI_DIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))

typedef struct _ValideVapiDir ValideVapiDir;
typedef struct _ValideVapiDirClass ValideVapiDirClass;

#define VALIDE_TYPE_BUILDER_OPTIONS (valide_builder_options_get_type ())
#define VALIDE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptions))
#define VALIDE_IS_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_OPTIONS))
#define VALIDE_BUILDER_OPTIONS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptionsIface))

typedef struct _ValideBuilderOptions ValideBuilderOptions;
typedef struct _ValideBuilderOptionsIface ValideBuilderOptionsIface;
typedef struct _ValideNativeBuilderOptionsPrivate ValideNativeBuilderOptionsPrivate;

#define VALIDE_TYPE_BUILDER (valide_builder_get_type ())
#define VALIDE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER, ValideBuilder))
#define VALIDE_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER))
#define VALIDE_BUILDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER, ValideBuilderIface))

typedef struct _ValideBuilder ValideBuilder;
typedef struct _ValideBuilderIface ValideBuilderIface;

#define VALIDE_TYPE_EXECUTABLE_MANAGER (valide_executable_manager_get_type ())
#define VALIDE_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManager))
#define VALIDE_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))
#define VALIDE_IS_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_IS_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_EXECUTABLE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))

typedef struct _ValideExecutableManager ValideExecutableManager;
typedef struct _ValideExecutableManagerClass ValideExecutableManagerClass;

#define VALIDE_TYPE_NATIVE_BUILDER (valide_native_builder_get_type ())
#define VALIDE_NATIVE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_NATIVE_BUILDER, ValideNativeBuilder))
#define VALIDE_NATIVE_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_NATIVE_BUILDER, ValideNativeBuilderClass))
#define VALIDE_IS_NATIVE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_NATIVE_BUILDER))
#define VALIDE_IS_NATIVE_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_NATIVE_BUILDER))
#define VALIDE_NATIVE_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_NATIVE_BUILDER, ValideNativeBuilderClass))

typedef struct _ValideNativeBuilder ValideNativeBuilder;
typedef struct _ValideNativeBuilderClass ValideNativeBuilderClass;
typedef struct _ValideNativeBuilderPrivate ValideNativeBuilderPrivate;

#define VALIDE_TYPE_EXECUTABLE (valide_executable_get_type ())
#define VALIDE_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE, ValideExecutable))
#define VALIDE_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE, ValideExecutableClass))
#define VALIDE_IS_EXECUTABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE))
#define VALIDE_IS_EXECUTABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE))
#define VALIDE_EXECUTABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE, ValideExecutableClass))

typedef struct _ValideExecutable ValideExecutable;
typedef struct _ValideExecutableClass ValideExecutableClass;

#define VALIDE_TYPE_COMPILER (valide_compiler_get_type ())
#define VALIDE_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_COMPILER, ValideCompiler))
#define VALIDE_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_COMPILER, ValideCompilerClass))
#define VALIDE_IS_COMPILER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_COMPILER))
#define VALIDE_IS_COMPILER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_COMPILER))
#define VALIDE_COMPILER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_COMPILER, ValideCompilerClass))

typedef struct _ValideCompiler ValideCompiler;
typedef struct _ValideCompilerClass ValideCompilerClass;

#define VALIDE_TYPE_EXECUTABLE_OPTIONS (valide_executable_options_get_type ())
#define VALIDE_EXECUTABLE_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_OPTIONS, ValideExecutableOptions))
#define VALIDE_EXECUTABLE_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_OPTIONS, ValideExecutableOptionsClass))
#define VALIDE_IS_EXECUTABLE_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_OPTIONS))
#define VALIDE_IS_EXECUTABLE_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_OPTIONS))
#define VALIDE_EXECUTABLE_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_OPTIONS, ValideExecutableOptionsClass))

typedef struct _ValideExecutableOptions ValideExecutableOptions;
typedef struct _ValideExecutableOptionsClass ValideExecutableOptionsClass;

struct _ValideHelpDialog {
	GtkDialog parent_instance;
	ValideHelpDialogPrivate * priv;
};

struct _ValideHelpDialogClass {
	GtkDialogClass parent_class;
};

struct _ValideAbstractNativeBuilderPreferences {
	GtkObject parent_instance;
	ValideAbstractNativeBuilderPreferencesPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractNativeBuilderPreferenceswindow_widgets* widgets;
};

struct _ValideAbstractNativeBuilderPreferencesClass {
	GtkObjectClass parent_class;
};

struct _ValideNativeBuilderPreferences {
	ValideAbstractNativeBuilderPreferences parent_instance;
	ValideNativeBuilderPreferencesPrivate * priv;
};

struct _ValideNativeBuilderPreferencesClass {
	ValideAbstractNativeBuilderPreferencesClass parent_class;
};

struct _ValideNativeBuilderPreferencesPrivate {
	GtkListStore* list_store_src;
	GtkListStore* list_store_dst;
	GtkListStore* list_store_vapi;
	ValideNativeBuilderOptions* options;
	ValideProject* _project;
	GList* _pkg;
	GList* _vapi_dir;
};

struct _ValideAbstractNativeBuilderPreferenceswindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractNativeBuilderPreferenceswindow_widgetsPrivate * priv;
	GtkNotebook* notebook;
	GtkVBox* frame_general;
	GtkCheckButton* debug;
	GtkCheckButton* thread;
	GtkCheckButton* disable_assert;
	GtkCheckButton* disable_checking;
	GtkCheckButton* disable_non_null;
	GtkCheckButton* save_temps;
	GtkCheckButton* quiet;
	GtkHBox* hbox1;
	GtkLabel* label6;
	GtkEntry* other;
	GtkButton* info_button;
	GtkImage* image2;
	GtkLabel* label1;
	GtkVBox* vbox1;
	GtkFrame* frame_pkg;
	GtkAlignment* alignment1;
	GtkHBox* hbox2;
	GtkScrolledWindow* scrolledwindow1;
	GtkTreeView* tree_view_src;
	GtkVBox* vbox3;
	GtkButton* button_add;
	GtkImage* image3;
	GtkButton* button_del;
	GtkImage* image4;
	GtkScrolledWindow* scrolledwindow2;
	GtkTreeView* tree_view_dst;
	GtkLabel* label4;
	GtkFrame* frame_vapi;
	GtkAlignment* alignment2;
	GtkVBox* vbox4;
	GtkHBox* hbox3;
	GtkFileChooserButton* file_chooser_button;
	GtkButton* button3;
	GtkButton* button4;
	GtkScrolledWindow* scrolledwindow3;
	GtkTreeView* tree_view_vapi;
	GtkLabel* label5;
	GtkLabel* label2;
};

struct _ValideAbstractNativeBuilderPreferenceswindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractNativeBuilderPreferenceswindow_widgets *self);
};

/**
 * Buildable GObjects, from YAML.
 *
 *
 * Objects that implements GLib.YAML.Buildable is buildable by
 * GLib.YAML.Builder.
 *
 * This interface is almost the same as GtkBuildable.
 *
 **/
struct _GYAMLBuildableIface {
	GTypeInterface parent_iface;
	const char* (*get_name) (GYAMLBuildable* self);
	void (*set_name) (GYAMLBuildable* self, const char* name);
	void (*add_child) (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
	char** (*get_child_tags) (GYAMLBuildable* self, int* result_length1);
	GType* (*get_child_types) (GYAMLBuildable* self, int* result_length1);
	GList* (*get_children) (GYAMLBuildable* self, const char* type);
	GObject* (*get_internal_child) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
	void (*custom_node) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
};

/**
 * A class for project
 */
struct _ValideProject {
	GObject parent_instance;
	ValideProjectPrivate * priv;
	char* filename;
	ValideBuilderManager* builders;
	GList* files;
	GList* packages;
	GList* vapi_dir;
};

struct _ValideProjectClass {
	GObjectClass parent_class;
};

struct _ValideBuilderOptionsIface {
	GTypeInterface parent_iface;
};

struct _ValideNativeBuilderOptions {
	GObject parent_instance;
	ValideNativeBuilderOptionsPrivate * priv;
};

struct _ValideNativeBuilderOptionsClass {
	GObjectClass parent_class;
};

struct _ValideNativeBuilderOptionsPrivate {
	gboolean _debug;
	gboolean _thread;
	gboolean _disable_assert;
	gboolean _disable_checking;
	gboolean _disable_non_null;
	gboolean _save_temps;
	gboolean _quiet;
	char* _other;
};

/**
 * This instance use to create a new builder
 *
 * [[warning:
 *   You should register builder with BuilderManager.register_builder function.
 * ]]
 */
struct _ValideBuilderIface {
	GTypeInterface parent_iface;
	void (*configure) (ValideBuilder* self);
	void (*build) (ValideBuilder* self);
	void (*install) (ValideBuilder* self);
	void (*dist) (ValideBuilder* self);
	void (*clean) (ValideBuilder* self);
	void (*distclean) (ValideBuilder* self);
	void (*uninstall) (ValideBuilder* self);
	GtkWidget* (*preferences) (ValideBuilder* self);
	ValideProject* (*get_project) (ValideBuilder* self);
	void (*set_project) (ValideBuilder* self, ValideProject* value);
	ValideExecutableManager* (*get_executables) (ValideBuilder* self);
	void (*set_executables) (ValideBuilder* self, ValideExecutableManager* value);
};

/**
 * The native builder
 */
struct _ValideNativeBuilder {
	GObject parent_instance;
	ValideNativeBuilderPrivate * priv;
};

struct _ValideNativeBuilderClass {
	GObjectClass parent_class;
};

struct _ValideNativeBuilderPrivate {
	ValideProject* _project;
	ValideExecutableManager* _executables;
};


static gpointer valide_help_dialog_parent_class = NULL;
static gpointer valide_native_builder_preferences_parent_class = NULL;
static gpointer valide_native_builder_options_parent_class = NULL;
static ValideBuilderOptionsIface* valide_native_builder_options_valide_builder_options_parent_iface = NULL;
static GYAMLBuildableIface* valide_native_builder_options_g_yaml_buildable_parent_iface = NULL;
static ValideNativeBuilderPreferences* valide_native_builder_preferences_widget;
static ValideNativeBuilderPreferences* valide_native_builder_preferences_widget = NULL;
static gpointer valide_native_builder_parent_class = NULL;
static ValideBuilderIface* valide_native_builder_valide_builder_parent_iface = NULL;

GType valide_help_dialog_get_type (void);
enum  {
	VALIDE_HELP_DIALOG_DUMMY_PROPERTY
};
ValideHelpDialog* valide_help_dialog_new (void);
ValideHelpDialog* valide_help_dialog_construct (GType object_type);
gint valide_help_dialog_run (ValideHelpDialog* self);
GType valide_abstract_native_builder_preferences_get_type (void);
gpointer valide_abstract_native_builder_preferences_window_widgets_ref (gpointer instance);
void valide_abstract_native_builder_preferences_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_native_builder_preferences_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_native_builder_preferences_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_native_builder_preferences_value_get_window_widgets (const GValue* value);
GType valide_abstract_native_builder_preferences_window_widgets_get_type (void);
GType valide_native_builder_preferences_get_type (void);
GType valide_native_builder_options_get_type (void);
GType valide_project_get_type (void);
#define VALIDE_NATIVE_BUILDER_PREFERENCES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, ValideNativeBuilderPreferencesPrivate))
enum  {
	VALIDE_NATIVE_BUILDER_PREFERENCES_DUMMY_PROPERTY,
	VALIDE_NATIVE_BUILDER_PREFERENCES_PROJECT,
	VALIDE_NATIVE_BUILDER_PREFERENCES_PKG,
	VALIDE_NATIVE_BUILDER_PREFERENCES_VAPI_DIR
};
static void _g_list_free_g_free (GList* self);
GList* valide_native_builder_preferences_get_pkg (ValideNativeBuilderPreferences* self);
static gboolean valide_native_builder_preferences_pkg_exist (ValideNativeBuilderPreferences* self, const char* pkg);
static void valide_native_builder_preferences_populate_tree_view (ValideNativeBuilderPreferences* self, GtkTreeView* tree_view);
GList* valide_valac_get_package_list (GList* vapi_dir);
GList* valide_native_builder_preferences_get_vapi_dir (ValideNativeBuilderPreferences* self);
static void valide_native_builder_preferences_update_vapi (ValideNativeBuilderPreferences* self);
ValideProject* valide_native_builder_preferences_get_project (ValideNativeBuilderPreferences* self);
GType g_yaml_builder_get_type (void);
gpointer g_yaml_node_ref (gpointer instance);
void g_yaml_node_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_node (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_node (const GValue* value);
GType g_yaml_node_get_type (void);
GType g_yaml_buildable_get_type (void);
GType valide_builder_manager_get_type (void);
GType valide_source_get_type (void);
GType valide_package_get_type (void);
GType valide_vapi_dir_get_type (void);
ValideVapiDir* valide_vapi_dir_new (const char* path);
ValideVapiDir* valide_vapi_dir_construct (GType object_type, const char* path);
void valide_project_save (ValideProject* self);
void valide_native_builder_preferences_add_vapi_dir (GtkWidget* sender, ValideNativeBuilderPreferences* self);
static void _g_list_free_g_object_unref (GList* self);
void valide_native_builder_preferences_del_vapi_dir (GtkWidget* sender, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_add_pkg (GtkWidget* sender, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_row_add_pkg (GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_del_pkg (GtkWidget* sender, ValideNativeBuilderPreferences* self);
void valide_native_builder_preferences_row_del_pkg (GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column, ValideNativeBuilderPreferences* self);
ValidePackage* valide_package_new (const char* name);
ValidePackage* valide_package_construct (GType object_type, const char* name);
void valide_native_builder_preferences_show_help (GtkButton* sender, ValideNativeBuilderPreferences* self);
static void valide_native_builder_preferences_set_project (ValideNativeBuilderPreferences* self, ValideProject* value);
ValideNativeBuilderPreferences* valide_native_builder_preferences_new (ValideProject* project);
ValideNativeBuilderPreferences* valide_native_builder_preferences_construct (GType object_type, ValideProject* project);
GType valide_builder_options_get_type (void);
ValideBuilderOptions* valide_project_get_builder_options (ValideProject* self);
gboolean valide_native_builder_options_get_debug (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_debug (ValideNativeBuilderOptions* self, gboolean value);
static void _lambda1_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self);
static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean valide_native_builder_options_get_thread (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_thread (ValideNativeBuilderOptions* self, gboolean value);
static void _lambda2_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self);
static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean valide_native_builder_options_get_disable_assert (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_disable_assert (ValideNativeBuilderOptions* self, gboolean value);
static void _lambda3_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self);
static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean valide_native_builder_options_get_disable_checking (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_disable_checking (ValideNativeBuilderOptions* self, gboolean value);
static void _lambda4_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self);
static void __lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean valide_native_builder_options_get_disable_non_null (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_disable_non_null (ValideNativeBuilderOptions* self, gboolean value);
static void _lambda5_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self);
static void __lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean valide_native_builder_options_get_save_temps (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_save_temps (ValideNativeBuilderOptions* self, gboolean value);
static void _lambda6_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self);
static void __lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
gboolean valide_native_builder_options_get_quiet (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_quiet (ValideNativeBuilderOptions* self, gboolean value);
static void _lambda7_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self);
static void __lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self);
const char* valide_native_builder_options_get_other (ValideNativeBuilderOptions* self);
void valide_native_builder_options_set_other (ValideNativeBuilderOptions* self, const char* value);
static void _lambda8_ (GtkEditable* s, ValideNativeBuilderPreferences* self);
static void __lambda8__gtk_editable_changed (GtkEditable* _sender, gpointer self);
const char* valide_package_get_name (ValidePackage* self);
const char* valide_vapi_dir_get_path (ValideVapiDir* self);
void valide_abstract_native_builder_preferences_connect_signals (ValideAbstractNativeBuilderPreferences* self, const char* name_space);
static GObject * valide_native_builder_preferences_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_native_builder_preferences_finalize (GObject* obj);
static void valide_native_builder_preferences_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_native_builder_preferences_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
#define VALIDE_NATIVE_BUILDER_OPTIONS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_NATIVE_BUILDER_OPTIONS, ValideNativeBuilderOptionsPrivate))
enum  {
	VALIDE_NATIVE_BUILDER_OPTIONS_DUMMY_PROPERTY,
	VALIDE_NATIVE_BUILDER_OPTIONS_DEBUG,
	VALIDE_NATIVE_BUILDER_OPTIONS_THREAD,
	VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_ASSERT,
	VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_CHECKING,
	VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_NON_NULL,
	VALIDE_NATIVE_BUILDER_OPTIONS_SAVE_TEMPS,
	VALIDE_NATIVE_BUILDER_OPTIONS_QUIET,
	VALIDE_NATIVE_BUILDER_OPTIONS_OTHER
};
ValideNativeBuilderOptions* valide_native_builder_options_new (void);
ValideNativeBuilderOptions* valide_native_builder_options_construct (GType object_type);
static GObject * valide_native_builder_options_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_native_builder_options_finalize (GObject* obj);
static void valide_native_builder_options_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_native_builder_options_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType valide_executable_manager_get_type (void);
GType valide_builder_get_type (void);
GType valide_native_builder_get_type (void);
#define VALIDE_NATIVE_BUILDER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_NATIVE_BUILDER, ValideNativeBuilderPrivate))
enum  {
	VALIDE_NATIVE_BUILDER_DUMMY_PROPERTY,
	VALIDE_NATIVE_BUILDER_PROJECT,
	VALIDE_NATIVE_BUILDER_EXECUTABLES
};
ValideProject* valide_builder_get_project (ValideBuilder* self);
char* valide_project_get_executable_name (ValideProject* self);
const char* valide_source_get_path (ValideSource* self);
static char* valide_native_builder_get_compiler_options (ValideNativeBuilder* self);
void valide_builder_set_project (ValideBuilder* self, ValideProject* value);
ValideNativeBuilder* valide_native_builder_new (ValideProject* project);
ValideNativeBuilder* valide_native_builder_construct (GType object_type, ValideProject* project);
static void valide_native_builder_real_configure (ValideBuilder* base);
GType valide_executable_get_type (void);
GType valide_compiler_get_type (void);
GType valide_executable_options_get_type (void);
ValideExecutableOptions* valide_executable_options_new (void);
ValideExecutableOptions* valide_executable_options_construct (GType object_type);
void valide_executable_options_set_arguments (ValideExecutableOptions* self, const char* value);
const char* valide_project_get_path (ValideProject* self);
void valide_executable_options_set_working_dir (ValideExecutableOptions* self, const char* value);
ValideCompiler* valide_compiler_new (ValideProject* project);
ValideCompiler* valide_compiler_construct (GType object_type, ValideProject* project);
ValideExecutableManager* valide_builder_get_executables (ValideBuilder* self);
void valide_executable_manager_run (ValideExecutableManager* self, ValideExecutable* executable, ValideExecutableOptions* options);
static void valide_native_builder_real_build (ValideBuilder* base);
static void valide_native_builder_real_install (ValideBuilder* base);
static void valide_native_builder_real_dist (ValideBuilder* base);
static void valide_native_builder_real_clean (ValideBuilder* base);
char* valide_project_get_real_filename (ValideProject* self, const char* filename);
char* valide_utils_skip_extension (const char* filename);
void valide_builder_clean (ValideBuilder* self);
static void valide_native_builder_real_distclean (ValideBuilder* base);
static void valide_native_builder_real_uninstall (ValideBuilder* base);
static GtkWidget* valide_native_builder_real_preferences (ValideBuilder* base);
static void valide_native_builder_finalize (GObject* obj);
static void valide_native_builder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_native_builder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 24 "native-builder.vala"
ValideHelpDialog* valide_help_dialog_construct (GType object_type) {
#line 605 "native-builder.c"
	GError * _inner_error_;
	ValideHelpDialog * self;
	char* message;
	GtkLabel* label;
	GtkLabel* _tmp0_;
	_inner_error_ = NULL;
	self = g_object_newv (object_type, 0, NULL);
	message = NULL;
	label = NULL;
#line 29 "native-builder.vala"
	gtk_dialog_add_button ((GtkDialog*) self, GTK_STOCK_CLOSE, (gint) GTK_RESPONSE_CLOSE);
#line 30 "native-builder.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 31 "native-builder.vala"
	gtk_container_set_border_width ((GtkContainer*) self, (guint) 5);
#line 621 "native-builder.c"
	_tmp0_ = NULL;
#line 33 "native-builder.vala"
	label = (_tmp0_ = g_object_ref_sink ((GtkLabel*) gtk_label_new ("")), (label == NULL) ? NULL : (label = (g_object_unref (label), NULL)), _tmp0_);
#line 34 "native-builder.vala"
	gtk_container_add ((GtkContainer*) ((GtkDialog*) self)->vbox, (GtkWidget*) label);
#line 35 "native-builder.vala"
	gtk_widget_show ((GtkWidget*) label);
#line 629 "native-builder.c"
	{
		char* _tmp3_;
		gboolean _tmp2_;
		char* _tmp1_;
		_tmp3_ = NULL;
		_tmp1_ = NULL;
#line 39 "native-builder.vala"
		_tmp2_ = g_spawn_command_line_sync ("valac --help", &_tmp1_, NULL, NULL, &_inner_error_);
#line 39 "native-builder.vala"
		message = (_tmp3_ = _tmp1_, message = (g_free (message), NULL), _tmp3_);
#line 39 "native-builder.vala"
		_tmp2_;
#line 642 "native-builder.c"
		if (_inner_error_ != NULL) {
			goto __catch72_g_error;
			goto __finally72;
		}
	}
	goto __finally72;
	__catch72_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp5_;
			const char* _tmp4_;
#line 43 "native-builder.vala"
			g_debug (e->message);
#line 659 "native-builder.c"
			_tmp5_ = NULL;
#line 44 "native-builder.vala"
			_tmp4_ = NULL;
#line 44 "native-builder.vala"
			message = (_tmp5_ = (_tmp4_ = e->message, (_tmp4_ == NULL) ? NULL : g_strdup (_tmp4_)), message = (g_free (message), NULL), _tmp5_);
#line 665 "native-builder.c"
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally72:
	if (_inner_error_ != NULL) {
		message = (g_free (message), NULL);
		(label == NULL) ? NULL : (label = (g_object_unref (label), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return NULL;
	}
#line 46 "native-builder.vala"
	gtk_label_set_text (label, message);
#line 679 "native-builder.c"
	message = (g_free (message), NULL);
	(label == NULL) ? NULL : (label = (g_object_unref (label), NULL));
	return self;
}


#line 24 "native-builder.vala"
ValideHelpDialog* valide_help_dialog_new (void) {
#line 24 "native-builder.vala"
	return valide_help_dialog_construct (VALIDE_TYPE_HELP_DIALOG);
#line 690 "native-builder.c"
}


#line 49 "native-builder.vala"
gint valide_help_dialog_run (ValideHelpDialog* self) {
#line 696 "native-builder.c"
	gint result;
#line 49 "native-builder.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 51 "native-builder.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 702 "native-builder.c"
	result = gtk_dialog_run (GTK_DIALOG (self));
	return result;
}


static void valide_help_dialog_class_init (ValideHelpDialogClass * klass) {
	valide_help_dialog_parent_class = g_type_class_peek_parent (klass);
}


static void valide_help_dialog_instance_init (ValideHelpDialog * self) {
}


GType valide_help_dialog_get_type (void) {
	static GType valide_help_dialog_type_id = 0;
	if (valide_help_dialog_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideHelpDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_help_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideHelpDialog), 0, (GInstanceInitFunc) valide_help_dialog_instance_init, NULL };
		valide_help_dialog_type_id = g_type_register_static (GTK_TYPE_DIALOG, "ValideHelpDialog", &g_define_type_info, 0);
	}
	return valide_help_dialog_type_id;
}


static void _g_list_free_g_free (GList* self) {
	g_list_foreach (self, (GFunc) g_free, NULL);
	g_list_free (self);
}


#line 117 "native-builder.vala"
static gboolean valide_native_builder_preferences_pkg_exist (ValideNativeBuilderPreferences* self, const char* pkg) {
#line 735 "native-builder.c"
	gboolean result;
	gboolean exist;
#line 117 "native-builder.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 117 "native-builder.vala"
	g_return_val_if_fail (pkg != NULL, FALSE);
#line 742 "native-builder.c"
	exist = FALSE;
	{
		GList* p_collection;
		GList* p_it;
#line 121 "native-builder.vala"
		p_collection = valide_native_builder_preferences_get_pkg (self);
#line 749 "native-builder.c"
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
			const char* _tmp0_;
			char* p;
#line 73 "native-builder.vala"
			_tmp0_ = NULL;
#line 121 "native-builder.vala"
			p = (_tmp0_ = (const char*) p_it->data, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
#line 757 "native-builder.c"
			{
#line 123 "native-builder.vala"
				if (_vala_strcmp0 (p, pkg) == 0) {
#line 125 "native-builder.vala"
					exist = TRUE;
#line 763 "native-builder.c"
					p = (g_free (p), NULL);
#line 126 "native-builder.vala"
					break;
#line 767 "native-builder.c"
				}
				p = (g_free (p), NULL);
			}
		}
	}
	result = exist;
	return result;
}


#line 132 "native-builder.vala"
static void valide_native_builder_preferences_populate_tree_view (ValideNativeBuilderPreferences* self, GtkTreeView* tree_view) {
#line 780 "native-builder.c"
	GtkListStore* list_store;
	GtkCellRendererText* render;
	GtkTreeViewColumn* column;
	GtkListStore* _tmp0_;
	GtkCellRendererText* _tmp1_;
	GtkTreeViewColumn* _tmp2_;
#line 132 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 132 "native-builder.vala"
	g_return_if_fail (tree_view != NULL);
#line 791 "native-builder.c"
	list_store = NULL;
	render = NULL;
	column = NULL;
	_tmp0_ = NULL;
#line 138 "native-builder.vala"
	list_store = (_tmp0_ = gtk_list_store_new (1, G_TYPE_STRING, NULL), (list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL)), _tmp0_);
#line 139 "native-builder.vala"
	gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) list_store, 0, GTK_SORT_ASCENDING);
#line 141 "native-builder.vala"
	gtk_tree_view_set_model (tree_view, (GtkTreeModel*) list_store);
#line 802 "native-builder.c"
	_tmp1_ = NULL;
#line 142 "native-builder.vala"
	render = (_tmp1_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), (render == NULL) ? NULL : (render = (g_object_unref (render), NULL)), _tmp1_);
#line 806 "native-builder.c"
	_tmp2_ = NULL;
#line 143 "native-builder.vala"
	column = (_tmp2_ = g_object_ref_sink (gtk_tree_view_column_new_with_attributes ("", (GtkCellRenderer*) render, "text", 0, NULL, NULL)), (column == NULL) ? NULL : (column = (g_object_unref (column), NULL)), _tmp2_);
#line 144 "native-builder.vala"
	gtk_tree_view_append_column (tree_view, column);
#line 145 "native-builder.vala"
	gtk_tree_view_set_headers_visible (tree_view, FALSE);
#line 814 "native-builder.c"
	(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
	(render == NULL) ? NULL : (render = (g_object_unref (render), NULL));
	(column == NULL) ? NULL : (column = (g_object_unref (column), NULL));
}


#line 148 "native-builder.vala"
static void valide_native_builder_preferences_update_vapi (ValideNativeBuilderPreferences* self) {
#line 823 "native-builder.c"
	GList* pkg;
	GList* _tmp0_;
#line 148 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 828 "native-builder.c"
	pkg = NULL;
	_tmp0_ = NULL;
#line 152 "native-builder.vala"
	pkg = (_tmp0_ = valide_valac_get_package_list (valide_native_builder_preferences_get_vapi_dir (self)), (pkg == NULL) ? NULL : (pkg = (_g_list_free_g_free (pkg), NULL)), _tmp0_);
#line 153 "native-builder.vala"
	gtk_list_store_clear (self->priv->list_store_src);
#line 835 "native-builder.c"
	{
		GList* p_collection;
		GList* p_it;
#line 154 "native-builder.vala"
		p_collection = pkg;
#line 841 "native-builder.c"
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
			const char* _tmp1_;
			char* p;
#line 150 "native-builder.vala"
			_tmp1_ = NULL;
#line 154 "native-builder.vala"
			p = (_tmp1_ = (const char*) p_it->data, (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_));
#line 849 "native-builder.c"
			{
				GtkTreeIter iter = {0};
#line 158 "native-builder.vala"
				gtk_list_store_append (self->priv->list_store_src, &iter);
#line 159 "native-builder.vala"
				gtk_list_store_set (self->priv->list_store_src, &iter, 0, p, -1);
#line 856 "native-builder.c"
				p = (g_free (p), NULL);
			}
		}
	}
	(pkg == NULL) ? NULL : (pkg = (_g_list_free_g_free (pkg), NULL));
}


/* @todo Check duplicated items 
*
   * Callback for add a vapi directory
   */
#line 168 "native-builder.vala"
void valide_native_builder_preferences_add_vapi_dir (GtkWidget* sender, ValideNativeBuilderPreferences* self) {
#line 871 "native-builder.c"
	char* dirname;
	char* _tmp0_;
#line 168 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 168 "native-builder.vala"
	g_return_if_fail (sender != NULL);
#line 878 "native-builder.c"
	dirname = NULL;
	_tmp0_ = NULL;
#line 172 "native-builder.vala"
	dirname = (_tmp0_ = gtk_file_chooser_get_filename ((GtkFileChooser*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->file_chooser_button), dirname = (g_free (dirname), NULL), _tmp0_);
#line 173 "native-builder.vala"
	if (_vala_strcmp0 (dirname, "") != 0) {
#line 885 "native-builder.c"
		GtkTreeIter iter = {0};
#line 177 "native-builder.vala"
		gtk_list_store_append (self->priv->list_store_vapi, &iter);
#line 178 "native-builder.vala"
		gtk_list_store_set (self->priv->list_store_vapi, &iter, 0, dirname, -1);
#line 179 "native-builder.vala"
		self->priv->_project->vapi_dir = g_list_append (self->priv->_project->vapi_dir, valide_vapi_dir_new (dirname));
#line 180 "native-builder.vala"
		valide_project_save (self->priv->_project);
#line 181 "native-builder.vala"
		valide_native_builder_preferences_update_vapi (self);
#line 897 "native-builder.c"
	}
	dirname = (g_free (dirname), NULL);
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


/**
   * Callback for delete a vapi directory
   */
#line 189 "native-builder.vala"
void valide_native_builder_preferences_del_vapi_dir (GtkWidget* sender, ValideNativeBuilderPreferences* self) {
#line 914 "native-builder.c"
	GtkTreeIter iter = {0};
	GtkTreeSelection* selection;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp0_;
#line 189 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 189 "native-builder.vala"
	g_return_if_fail (sender != NULL);
#line 923 "native-builder.c"
	selection = NULL;
	_tmp1_ = NULL;
#line 194 "native-builder.vala"
	_tmp0_ = NULL;
#line 194 "native-builder.vala"
	selection = (_tmp1_ = (_tmp0_ = gtk_tree_view_get_selection (((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_vapi), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL)), _tmp1_);
#line 195 "native-builder.vala"
	if (gtk_tree_selection_get_selected (selection, NULL, &iter)) {
#line 932 "native-builder.c"
		char* str;
		GList* _tmp2_;
		str = NULL;
#line 199 "native-builder.vala"
		gtk_list_store_remove (self->priv->list_store_vapi, &iter);
#line 938 "native-builder.c"
		_tmp2_ = NULL;
#line 200 "native-builder.vala"
		self->priv->_project->vapi_dir = (_tmp2_ = NULL, (self->priv->_project->vapi_dir == NULL) ? NULL : (self->priv->_project->vapi_dir = (_g_list_free_g_object_unref (self->priv->_project->vapi_dir), NULL)), _tmp2_);
#line 201 "native-builder.vala"
		if (gtk_tree_model_get_iter_first ((GtkTreeModel*) self->priv->list_store_vapi, &iter)) {
#line 944 "native-builder.c"
			{
				gboolean _tmp3_;
				_tmp3_ = TRUE;
#line 203 "native-builder.vala"
				while (TRUE) {
#line 203 "native-builder.vala"
					if (!_tmp3_) {
#line 207 "native-builder.vala"
						if (!gtk_tree_model_iter_next ((GtkTreeModel*) self->priv->list_store_vapi, &iter)) {
#line 207 "native-builder.vala"
							break;
#line 956 "native-builder.c"
						}
					}
#line 203 "native-builder.vala"
					_tmp3_ = FALSE;
#line 205 "native-builder.vala"
					gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store_vapi, &iter, 0, &str, -1);
#line 206 "native-builder.vala"
					self->priv->_project->vapi_dir = g_list_append (self->priv->_project->vapi_dir, valide_vapi_dir_new (str));
#line 965 "native-builder.c"
				}
			}
		}
#line 209 "native-builder.vala"
		valide_project_save (self->priv->_project);
#line 210 "native-builder.vala"
		valide_native_builder_preferences_update_vapi (self);
#line 973 "native-builder.c"
		str = (g_free (str), NULL);
	}
	(selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL));
}


/**
   * Callback for add a package with double-clic
   */
#line 218 "native-builder.vala"
void valide_native_builder_preferences_row_add_pkg (GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column, ValideNativeBuilderPreferences* self) {
#line 218 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 218 "native-builder.vala"
	g_return_if_fail (sender != NULL);
#line 218 "native-builder.vala"
	g_return_if_fail (path != NULL);
#line 218 "native-builder.vala"
	g_return_if_fail (column != NULL);
#line 222 "native-builder.vala"
	valide_native_builder_preferences_add_pkg ((GtkWidget*) sender, self);
#line 995 "native-builder.c"
}


/**
   * Callback for delete a package with double-clic
   */
#line 229 "native-builder.vala"
void valide_native_builder_preferences_row_del_pkg (GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column, ValideNativeBuilderPreferences* self) {
#line 229 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 229 "native-builder.vala"
	g_return_if_fail (sender != NULL);
#line 229 "native-builder.vala"
	g_return_if_fail (path != NULL);
#line 229 "native-builder.vala"
	g_return_if_fail (column != NULL);
#line 233 "native-builder.vala"
	valide_native_builder_preferences_del_pkg ((GtkWidget*) sender, self);
#line 1014 "native-builder.c"
}


/**
   * Callback for add a package
   */
#line 240 "native-builder.vala"
void valide_native_builder_preferences_add_pkg (GtkWidget* sender, ValideNativeBuilderPreferences* self) {
#line 1023 "native-builder.c"
	char* pkg;
	GtkTreeIter iter = {0};
	GtkTreeSelection* selection;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp0_;
#line 240 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 240 "native-builder.vala"
	g_return_if_fail (sender != NULL);
#line 1033 "native-builder.c"
	pkg = NULL;
	selection = NULL;
	_tmp1_ = NULL;
#line 246 "native-builder.vala"
	_tmp0_ = NULL;
#line 246 "native-builder.vala"
	selection = (_tmp1_ = (_tmp0_ = gtk_tree_view_get_selection (((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_src), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL)), _tmp1_);
#line 247 "native-builder.vala"
	if (gtk_tree_selection_get_selected (selection, NULL, &iter)) {
#line 249 "native-builder.vala"
		gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store_src, &iter, 0, &pkg, -1);
#line 250 "native-builder.vala"
		if (!valide_native_builder_preferences_pkg_exist (self, pkg)) {
#line 252 "native-builder.vala"
			gtk_list_store_append (self->priv->list_store_dst, &iter);
#line 253 "native-builder.vala"
			gtk_list_store_set (self->priv->list_store_dst, &iter, 0, pkg, -1);
#line 254 "native-builder.vala"
			self->priv->_project->packages = g_list_append (self->priv->_project->packages, valide_package_new (pkg));
#line 255 "native-builder.vala"
			valide_project_save (self->priv->_project);
#line 1055 "native-builder.c"
		}
	}
	pkg = (g_free (pkg), NULL);
	(selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL));
}


/**
   * Callback for delete a package
   */
#line 264 "native-builder.vala"
void valide_native_builder_preferences_del_pkg (GtkWidget* sender, ValideNativeBuilderPreferences* self) {
#line 1068 "native-builder.c"
	GtkTreeIter iter = {0};
	GtkTreeSelection* selection;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp0_;
#line 264 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 264 "native-builder.vala"
	g_return_if_fail (sender != NULL);
#line 1077 "native-builder.c"
	selection = NULL;
	_tmp1_ = NULL;
#line 269 "native-builder.vala"
	_tmp0_ = NULL;
#line 269 "native-builder.vala"
	selection = (_tmp1_ = (_tmp0_ = gtk_tree_view_get_selection (((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_dst), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL)), _tmp1_);
#line 270 "native-builder.vala"
	if (gtk_tree_selection_get_selected (selection, NULL, &iter)) {
#line 1086 "native-builder.c"
		char* str;
		GList* _tmp2_;
		str = NULL;
#line 274 "native-builder.vala"
		gtk_list_store_remove (self->priv->list_store_dst, &iter);
#line 1092 "native-builder.c"
		_tmp2_ = NULL;
#line 275 "native-builder.vala"
		self->priv->_project->packages = (_tmp2_ = NULL, (self->priv->_project->packages == NULL) ? NULL : (self->priv->_project->packages = (_g_list_free_g_object_unref (self->priv->_project->packages), NULL)), _tmp2_);
#line 276 "native-builder.vala"
		if (gtk_tree_model_get_iter_first ((GtkTreeModel*) self->priv->list_store_dst, &iter)) {
#line 1098 "native-builder.c"
			{
				gboolean _tmp3_;
				_tmp3_ = TRUE;
#line 278 "native-builder.vala"
				while (TRUE) {
#line 278 "native-builder.vala"
					if (!_tmp3_) {
#line 282 "native-builder.vala"
						if (!gtk_tree_model_iter_next ((GtkTreeModel*) self->priv->list_store_dst, &iter)) {
#line 282 "native-builder.vala"
							break;
#line 1110 "native-builder.c"
						}
					}
#line 278 "native-builder.vala"
					_tmp3_ = FALSE;
#line 280 "native-builder.vala"
					gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store_dst, &iter, 0, &str, -1);
#line 281 "native-builder.vala"
					self->priv->_project->packages = g_list_append (self->priv->_project->packages, valide_package_new (str));
#line 1119 "native-builder.c"
				}
			}
		}
#line 284 "native-builder.vala"
		valide_project_save (self->priv->_project);
#line 1125 "native-builder.c"
		str = (g_free (str), NULL);
	}
	(selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL));
}


/**
   * Callback for show the valac help
   */
#line 292 "native-builder.vala"
void valide_native_builder_preferences_show_help (GtkButton* sender, ValideNativeBuilderPreferences* self) {
#line 1137 "native-builder.c"
	ValideHelpDialog* help_dialog;
	ValideHelpDialog* _tmp0_;
#line 292 "native-builder.vala"
	g_return_if_fail (self != NULL);
#line 292 "native-builder.vala"
	g_return_if_fail (sender != NULL);
#line 1144 "native-builder.c"
	help_dialog = NULL;
	_tmp0_ = NULL;
#line 296 "native-builder.vala"
	help_dialog = (_tmp0_ = g_object_ref_sink (valide_help_dialog_new ()), (help_dialog == NULL) ? NULL : (help_dialog = (g_object_unref (help_dialog), NULL)), _tmp0_);
#line 297 "native-builder.vala"
	valide_help_dialog_run (help_dialog);
#line 298 "native-builder.vala"
	gtk_object_destroy ((GtkObject*) help_dialog);
#line 1153 "native-builder.c"
	(help_dialog == NULL) ? NULL : (help_dialog = (g_object_unref (help_dialog), NULL));
}


#line 301 "native-builder.vala"
ValideNativeBuilderPreferences* valide_native_builder_preferences_construct (GType object_type, ValideProject* project) {
#line 1160 "native-builder.c"
	GParameter * __params;
	GParameter * __params_it;
	ValideNativeBuilderPreferences * self;
#line 301 "native-builder.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 1166 "native-builder.c"
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 303 "native-builder.vala"
	__params_it->name = "project";
#line 303 "native-builder.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_PROJECT);
#line 303 "native-builder.vala"
	g_value_set_object (&__params_it->value, project);
#line 303 "native-builder.vala"
	__params_it++;
#line 1177 "native-builder.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 301 "native-builder.vala"
ValideNativeBuilderPreferences* valide_native_builder_preferences_new (ValideProject* project) {
#line 301 "native-builder.vala"
	return valide_native_builder_preferences_construct (VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES, project);
#line 1192 "native-builder.c"
}


ValideProject* valide_native_builder_preferences_get_project (ValideNativeBuilderPreferences* self) {
	ValideProject* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_project;
	return result;
}


static void valide_native_builder_preferences_set_project (ValideNativeBuilderPreferences* self, ValideProject* value) {
	ValideProject* _tmp1_;
	ValideProject* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 66 "native-builder.vala"
	_tmp0_ = NULL;
#line 1211 "native-builder.c"
	self->priv->_project = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "project");
}


GList* valide_native_builder_preferences_get_pkg (ValideNativeBuilderPreferences* self) {
	GList* result;
	GtkTreeIter iter = {0};
	char* str;
	GList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	str = NULL;
	_tmp0_ = NULL;
#line 80 "native-builder.vala"
	self->priv->_pkg = (_tmp0_ = NULL, (self->priv->_pkg == NULL) ? NULL : (self->priv->_pkg = (_g_list_free_g_free (self->priv->_pkg), NULL)), _tmp0_);
#line 81 "native-builder.vala"
	if (gtk_tree_model_get_iter_first ((GtkTreeModel*) self->priv->list_store_dst, &iter)) {
#line 1229 "native-builder.c"
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
#line 83 "native-builder.vala"
			while (TRUE) {
#line 1235 "native-builder.c"
				const char* _tmp2_;
#line 83 "native-builder.vala"
				if (!_tmp1_) {
#line 87 "native-builder.vala"
					if (!gtk_tree_model_iter_next ((GtkTreeModel*) self->priv->list_store_dst, &iter)) {
#line 87 "native-builder.vala"
						break;
#line 1243 "native-builder.c"
					}
				}
#line 83 "native-builder.vala"
				_tmp1_ = FALSE;
#line 85 "native-builder.vala"
				gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store_dst, &iter, 0, &str, -1);
#line 86 "native-builder.vala"
				_tmp2_ = NULL;
#line 86 "native-builder.vala"
				self->priv->_pkg = g_list_append (self->priv->_pkg, (_tmp2_ = str, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)));
#line 1254 "native-builder.c"
			}
		}
	}
	result = self->priv->_pkg;
	str = (g_free (str), NULL);
	return result;
}


GList* valide_native_builder_preferences_get_vapi_dir (ValideNativeBuilderPreferences* self) {
	GList* result;
	GtkTreeIter iter = {0};
	char* str;
	GList* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	str = NULL;
	_tmp0_ = NULL;
#line 104 "native-builder.vala"
	self->priv->_vapi_dir = (_tmp0_ = NULL, (self->priv->_vapi_dir == NULL) ? NULL : (self->priv->_vapi_dir = (_g_list_free_g_free (self->priv->_vapi_dir), NULL)), _tmp0_);
#line 105 "native-builder.vala"
	if (gtk_tree_model_get_iter_first ((GtkTreeModel*) self->priv->list_store_vapi, &iter)) {
#line 1276 "native-builder.c"
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
#line 107 "native-builder.vala"
			while (TRUE) {
#line 1282 "native-builder.c"
				const char* _tmp2_;
#line 107 "native-builder.vala"
				if (!_tmp1_) {
#line 111 "native-builder.vala"
					if (!gtk_tree_model_iter_next ((GtkTreeModel*) self->priv->list_store_vapi, &iter)) {
#line 111 "native-builder.vala"
						break;
#line 1290 "native-builder.c"
					}
				}
#line 107 "native-builder.vala"
				_tmp1_ = FALSE;
#line 109 "native-builder.vala"
				gtk_tree_model_get ((GtkTreeModel*) self->priv->list_store_vapi, &iter, 0, &str, -1);
#line 110 "native-builder.vala"
				_tmp2_ = NULL;
#line 110 "native-builder.vala"
				self->priv->_vapi_dir = g_list_append (self->priv->_vapi_dir, (_tmp2_ = str, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)));
#line 1301 "native-builder.c"
			}
		}
	}
	result = self->priv->_vapi_dir;
	str = (g_free (str), NULL);
	return result;
}


static void _lambda1_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self) {
	g_return_if_fail (s != NULL);
#line 321 "native-builder.vala"
	valide_native_builder_options_set_debug (self->priv->options, gtk_toggle_button_get_active (s));
#line 322 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1317 "native-builder.c"
}


static void __lambda1__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda1_ (_sender, self);
}


static void _lambda2_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self) {
	g_return_if_fail (s != NULL);
#line 327 "native-builder.vala"
	valide_native_builder_options_set_thread (self->priv->options, gtk_toggle_button_get_active (s));
#line 328 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1332 "native-builder.c"
}


static void __lambda2__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda2_ (_sender, self);
}


static void _lambda3_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self) {
	g_return_if_fail (s != NULL);
#line 333 "native-builder.vala"
	valide_native_builder_options_set_disable_assert (self->priv->options, gtk_toggle_button_get_active (s));
#line 334 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1347 "native-builder.c"
}


static void __lambda3__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda3_ (_sender, self);
}


static void _lambda4_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self) {
	g_return_if_fail (s != NULL);
#line 339 "native-builder.vala"
	valide_native_builder_options_set_disable_checking (self->priv->options, gtk_toggle_button_get_active (s));
#line 340 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1362 "native-builder.c"
}


static void __lambda4__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda4_ (_sender, self);
}


static void _lambda5_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self) {
	g_return_if_fail (s != NULL);
#line 345 "native-builder.vala"
	valide_native_builder_options_set_disable_non_null (self->priv->options, gtk_toggle_button_get_active (s));
#line 346 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1377 "native-builder.c"
}


static void __lambda5__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda5_ (_sender, self);
}


static void _lambda6_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self) {
	g_return_if_fail (s != NULL);
#line 351 "native-builder.vala"
	valide_native_builder_options_set_save_temps (self->priv->options, gtk_toggle_button_get_active (s));
#line 352 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1392 "native-builder.c"
}


static void __lambda6__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda6_ (_sender, self);
}


static void _lambda7_ (GtkToggleButton* s, ValideNativeBuilderPreferences* self) {
	g_return_if_fail (s != NULL);
#line 357 "native-builder.vala"
	valide_native_builder_options_set_quiet (self->priv->options, gtk_toggle_button_get_active (s));
#line 358 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1407 "native-builder.c"
}


static void __lambda7__gtk_toggle_button_toggled (GtkToggleButton* _sender, gpointer self) {
	_lambda7_ (_sender, self);
}


static void _lambda8_ (GtkEditable* s, ValideNativeBuilderPreferences* self) {
	GtkEditable* _tmp0_;
	g_return_if_fail (s != NULL);
#line 363 "native-builder.vala"
	_tmp0_ = NULL;
#line 363 "native-builder.vala"
	valide_native_builder_options_set_other (self->priv->options, gtk_entry_get_text ((_tmp0_ = s, GTK_IS_ENTRY (_tmp0_) ? ((GtkEntry*) _tmp0_) : NULL)));
#line 364 "native-builder.vala"
	valide_project_save (self->priv->_project);
#line 1425 "native-builder.c"
}


static void __lambda8__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	_lambda8_ (_sender, self);
}


static GObject * valide_native_builder_preferences_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideNativeBuilderPreferencesClass * klass;
	GObjectClass * parent_class;
	ValideNativeBuilderPreferences * self;
	klass = VALIDE_NATIVE_BUILDER_PREFERENCES_CLASS (g_type_class_peek (VALIDE_TYPE_NATIVE_BUILDER_PREFERENCES));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_NATIVE_BUILDER_PREFERENCES (obj);
	{
		GtkTreeIter iter = {0};
		ValideBuilderOptions* _tmp0_;
		GtkListStore* _tmp3_;
		GtkListStore* _tmp2_;
		GtkTreeModel* _tmp1_;
		GtkListStore* _tmp6_;
		GtkListStore* _tmp5_;
		GtkTreeModel* _tmp4_;
		GtkListStore* _tmp9_;
		GtkListStore* _tmp8_;
		GtkTreeModel* _tmp7_;
#line 310 "native-builder.vala"
		_tmp0_ = NULL;
#line 310 "native-builder.vala"
		self->priv->options = (_tmp0_ = valide_project_get_builder_options (self->priv->_project), VALIDE_IS_NATIVE_BUILDER_OPTIONS (_tmp0_) ? ((ValideNativeBuilderOptions*) _tmp0_) : NULL);
#line 312 "native-builder.vala"
		valide_native_builder_preferences_populate_tree_view (self, ((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_vapi);
#line 1461 "native-builder.c"
		_tmp3_ = NULL;
#line 313 "native-builder.vala"
		_tmp2_ = NULL;
#line 313 "native-builder.vala"
		_tmp1_ = NULL;
#line 313 "native-builder.vala"
		self->priv->list_store_vapi = (_tmp3_ = (_tmp2_ = (_tmp1_ = gtk_tree_view_get_model (((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_vapi), GTK_IS_LIST_STORE (_tmp1_) ? ((GtkListStore*) _tmp1_) : NULL), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (self->priv->list_store_vapi == NULL) ? NULL : (self->priv->list_store_vapi = (g_object_unref (self->priv->list_store_vapi), NULL)), _tmp3_);
#line 314 "native-builder.vala"
		valide_native_builder_preferences_populate_tree_view (self, ((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_src);
#line 1471 "native-builder.c"
		_tmp6_ = NULL;
#line 315 "native-builder.vala"
		_tmp5_ = NULL;
#line 315 "native-builder.vala"
		_tmp4_ = NULL;
#line 315 "native-builder.vala"
		self->priv->list_store_src = (_tmp6_ = (_tmp5_ = (_tmp4_ = gtk_tree_view_get_model (((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_src), GTK_IS_LIST_STORE (_tmp4_) ? ((GtkListStore*) _tmp4_) : NULL), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_)), (self->priv->list_store_src == NULL) ? NULL : (self->priv->list_store_src = (g_object_unref (self->priv->list_store_src), NULL)), _tmp6_);
#line 316 "native-builder.vala"
		valide_native_builder_preferences_populate_tree_view (self, ((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_dst);
#line 1481 "native-builder.c"
		_tmp9_ = NULL;
#line 317 "native-builder.vala"
		_tmp8_ = NULL;
#line 317 "native-builder.vala"
		_tmp7_ = NULL;
#line 317 "native-builder.vala"
		self->priv->list_store_dst = (_tmp9_ = (_tmp8_ = (_tmp7_ = gtk_tree_view_get_model (((ValideAbstractNativeBuilderPreferences*) self)->widgets->tree_view_dst), GTK_IS_LIST_STORE (_tmp7_) ? ((GtkListStore*) _tmp7_) : NULL), (_tmp8_ == NULL) ? NULL : g_object_ref (_tmp8_)), (self->priv->list_store_dst == NULL) ? NULL : (self->priv->list_store_dst = (g_object_unref (self->priv->list_store_dst), NULL)), _tmp9_);
#line 319 "native-builder.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->debug, valide_native_builder_options_get_debug (self->priv->options));
#line 320 "native-builder.vala"
		g_signal_connect ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->debug, "toggled", (GCallback) __lambda1__gtk_toggle_button_toggled, self);
#line 325 "native-builder.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->thread, valide_native_builder_options_get_thread (self->priv->options));
#line 326 "native-builder.vala"
		g_signal_connect ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->thread, "toggled", (GCallback) __lambda2__gtk_toggle_button_toggled, self);
#line 331 "native-builder.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->disable_assert, valide_native_builder_options_get_disable_assert (self->priv->options));
#line 332 "native-builder.vala"
		g_signal_connect ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->disable_assert, "toggled", (GCallback) __lambda3__gtk_toggle_button_toggled, self);
#line 337 "native-builder.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->disable_checking, valide_native_builder_options_get_disable_checking (self->priv->options));
#line 338 "native-builder.vala"
		g_signal_connect ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->disable_checking, "toggled", (GCallback) __lambda4__gtk_toggle_button_toggled, self);
#line 343 "native-builder.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->disable_non_null, valide_native_builder_options_get_disable_non_null (self->priv->options));
#line 344 "native-builder.vala"
		g_signal_connect ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->disable_non_null, "toggled", (GCallback) __lambda5__gtk_toggle_button_toggled, self);
#line 349 "native-builder.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->save_temps, valide_native_builder_options_get_save_temps (self->priv->options));
#line 350 "native-builder.vala"
		g_signal_connect ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->save_temps, "toggled", (GCallback) __lambda6__gtk_toggle_button_toggled, self);
#line 355 "native-builder.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->quiet, valide_native_builder_options_get_quiet (self->priv->options));
#line 356 "native-builder.vala"
		g_signal_connect ((GtkToggleButton*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->quiet, "toggled", (GCallback) __lambda7__gtk_toggle_button_toggled, self);
#line 361 "native-builder.vala"
		gtk_entry_set_text (((ValideAbstractNativeBuilderPreferences*) self)->widgets->other, valide_native_builder_options_get_other (self->priv->options));
#line 362 "native-builder.vala"
		g_signal_connect ((GtkEditable*) ((ValideAbstractNativeBuilderPreferences*) self)->widgets->other, "changed", (GCallback) __lambda8__gtk_editable_changed, self);
#line 1521 "native-builder.c"
		{
			GList* package_collection;
			GList* package_it;
#line 367 "native-builder.vala"
			package_collection = self->priv->_project->packages;
#line 1527 "native-builder.c"
			for (package_it = package_collection; package_it != NULL; package_it = package_it->next) {
				ValidePackage* _tmp10_;
				ValidePackage* package;
#line 77 "project.vala"
				_tmp10_ = NULL;
#line 367 "native-builder.vala"
				package = (_tmp10_ = (ValidePackage*) package_it->data, (_tmp10_ == NULL) ? NULL : g_object_ref (_tmp10_));
#line 1535 "native-builder.c"
				{
#line 369 "native-builder.vala"
					gtk_list_store_append (self->priv->list_store_dst, &iter);
#line 370 "native-builder.vala"
					gtk_list_store_set (self->priv->list_store_dst, &iter, 0, valide_package_get_name (package), -1);
#line 1541 "native-builder.c"
					(package == NULL) ? NULL : (package = (g_object_unref (package), NULL));
				}
			}
		}
		{
			GList* vapi_dir_collection;
			GList* vapi_dir_it;
#line 373 "native-builder.vala"
			vapi_dir_collection = self->priv->_project->vapi_dir;
#line 1551 "native-builder.c"
			for (vapi_dir_it = vapi_dir_collection; vapi_dir_it != NULL; vapi_dir_it = vapi_dir_it->next) {
				ValideVapiDir* _tmp11_;
				ValideVapiDir* vapi_dir;
#line 82 "project.vala"
				_tmp11_ = NULL;
#line 373 "native-builder.vala"
				vapi_dir = (_tmp11_ = (ValideVapiDir*) vapi_dir_it->data, (_tmp11_ == NULL) ? NULL : g_object_ref (_tmp11_));
#line 1559 "native-builder.c"
				{
#line 375 "native-builder.vala"
					gtk_list_store_append (self->priv->list_store_vapi, &iter);
#line 376 "native-builder.vala"
					gtk_list_store_set (self->priv->list_store_vapi, &iter, 0, valide_vapi_dir_get_path (vapi_dir), -1);
#line 1565 "native-builder.c"
					(vapi_dir == NULL) ? NULL : (vapi_dir = (g_object_unref (vapi_dir), NULL));
				}
			}
		}
#line 379 "native-builder.vala"
		valide_native_builder_preferences_update_vapi (self);
#line 380 "native-builder.vala"
		valide_abstract_native_builder_preferences_connect_signals ((ValideAbstractNativeBuilderPreferences*) self, "valide_native_builder_preferences_");
#line 1574 "native-builder.c"
	}
	return obj;
}


static void valide_native_builder_preferences_class_init (ValideNativeBuilderPreferencesClass * klass) {
	valide_native_builder_preferences_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideNativeBuilderPreferencesPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_native_builder_preferences_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_native_builder_preferences_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_native_builder_preferences_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_native_builder_preferences_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_PREFERENCES_PROJECT, g_param_spec_object ("project", "project", "project", VALIDE_TYPE_PROJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_PREFERENCES_PKG, g_param_spec_pointer ("pkg", "pkg", "pkg", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_PREFERENCES_VAPI_DIR, g_param_spec_pointer ("vapi-dir", "vapi-dir", "vapi-dir", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void valide_native_builder_preferences_instance_init (ValideNativeBuilderPreferences * self) {
	self->priv = VALIDE_NATIVE_BUILDER_PREFERENCES_GET_PRIVATE (self);
}


static void valide_native_builder_preferences_finalize (GObject* obj) {
	ValideNativeBuilderPreferences * self;
	self = VALIDE_NATIVE_BUILDER_PREFERENCES (obj);
	(self->priv->list_store_src == NULL) ? NULL : (self->priv->list_store_src = (g_object_unref (self->priv->list_store_src), NULL));
	(self->priv->list_store_dst == NULL) ? NULL : (self->priv->list_store_dst = (g_object_unref (self->priv->list_store_dst), NULL));
	(self->priv->list_store_vapi == NULL) ? NULL : (self->priv->list_store_vapi = (g_object_unref (self->priv->list_store_vapi), NULL));
	(self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL));
	(self->priv->_pkg == NULL) ? NULL : (self->priv->_pkg = (_g_list_free_g_free (self->priv->_pkg), NULL));
	(self->priv->_vapi_dir == NULL) ? NULL : (self->priv->_vapi_dir = (_g_list_free_g_free (self->priv->_vapi_dir), NULL));
	G_OBJECT_CLASS (valide_native_builder_preferences_parent_class)->finalize (obj);
}


GType valide_native_builder_preferences_get_type (void) {
	static GType valide_native_builder_preferences_type_id = 0;
	if (valide_native_builder_preferences_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideNativeBuilderPreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_native_builder_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideNativeBuilderPreferences), 0, (GInstanceInitFunc) valide_native_builder_preferences_instance_init, NULL };
		valide_native_builder_preferences_type_id = g_type_register_static (VALIDE_TYPE_ABSTRACT_NATIVE_BUILDER_PREFERENCES, "ValideNativeBuilderPreferences", &g_define_type_info, 0);
	}
	return valide_native_builder_preferences_type_id;
}


static void valide_native_builder_preferences_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideNativeBuilderPreferences * self;
	gpointer boxed;
	self = VALIDE_NATIVE_BUILDER_PREFERENCES (object);
	switch (property_id) {
		case VALIDE_NATIVE_BUILDER_PREFERENCES_PROJECT:
		g_value_set_object (value, valide_native_builder_preferences_get_project (self));
		break;
		case VALIDE_NATIVE_BUILDER_PREFERENCES_PKG:
		g_value_set_pointer (value, valide_native_builder_preferences_get_pkg (self));
		break;
		case VALIDE_NATIVE_BUILDER_PREFERENCES_VAPI_DIR:
		g_value_set_pointer (value, valide_native_builder_preferences_get_vapi_dir (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_native_builder_preferences_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideNativeBuilderPreferences * self;
	self = VALIDE_NATIVE_BUILDER_PREFERENCES (object);
	switch (property_id) {
		case VALIDE_NATIVE_BUILDER_PREFERENCES_PROJECT:
		valide_native_builder_preferences_set_project (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 384 "native-builder.vala"
ValideNativeBuilderOptions* valide_native_builder_options_construct (GType object_type) {
#line 1658 "native-builder.c"
	ValideNativeBuilderOptions * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 384 "native-builder.vala"
ValideNativeBuilderOptions* valide_native_builder_options_new (void) {
#line 384 "native-builder.vala"
	return valide_native_builder_options_construct (VALIDE_TYPE_NATIVE_BUILDER_OPTIONS);
#line 1669 "native-builder.c"
}


gboolean valide_native_builder_options_get_debug (ValideNativeBuilderOptions* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_debug;
	return result;
}


void valide_native_builder_options_set_debug (ValideNativeBuilderOptions* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_debug = value;
	g_object_notify ((GObject *) self, "debug");
}


gboolean valide_native_builder_options_get_thread (ValideNativeBuilderOptions* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_thread;
	return result;
}


void valide_native_builder_options_set_thread (ValideNativeBuilderOptions* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_thread = value;
	g_object_notify ((GObject *) self, "thread");
}


gboolean valide_native_builder_options_get_disable_assert (ValideNativeBuilderOptions* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_disable_assert;
	return result;
}


void valide_native_builder_options_set_disable_assert (ValideNativeBuilderOptions* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_disable_assert = value;
	g_object_notify ((GObject *) self, "disable-assert");
}


gboolean valide_native_builder_options_get_disable_checking (ValideNativeBuilderOptions* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_disable_checking;
	return result;
}


void valide_native_builder_options_set_disable_checking (ValideNativeBuilderOptions* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_disable_checking = value;
	g_object_notify ((GObject *) self, "disable-checking");
}


gboolean valide_native_builder_options_get_disable_non_null (ValideNativeBuilderOptions* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_disable_non_null;
	return result;
}


void valide_native_builder_options_set_disable_non_null (ValideNativeBuilderOptions* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_disable_non_null = value;
	g_object_notify ((GObject *) self, "disable-non-null");
}


gboolean valide_native_builder_options_get_save_temps (ValideNativeBuilderOptions* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_save_temps;
	return result;
}


void valide_native_builder_options_set_save_temps (ValideNativeBuilderOptions* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_save_temps = value;
	g_object_notify ((GObject *) self, "save-temps");
}


gboolean valide_native_builder_options_get_quiet (ValideNativeBuilderOptions* self) {
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_quiet;
	return result;
}


void valide_native_builder_options_set_quiet (ValideNativeBuilderOptions* self, gboolean value) {
	g_return_if_fail (self != NULL);
	self->priv->_quiet = value;
	g_object_notify ((GObject *) self, "quiet");
}


const char* valide_native_builder_options_get_other (ValideNativeBuilderOptions* self) {
	const char* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_other;
	return result;
}


void valide_native_builder_options_set_other (ValideNativeBuilderOptions* self, const char* value) {
	char* _tmp1_;
	const char* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 425 "native-builder.vala"
	_tmp0_ = NULL;
#line 1793 "native-builder.c"
	self->priv->_other = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->priv->_other = (g_free (self->priv->_other), NULL), _tmp1_);
	g_object_notify ((GObject *) self, "other");
}


static GObject * valide_native_builder_options_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideNativeBuilderOptionsClass * klass;
	GObjectClass * parent_class;
	ValideNativeBuilderOptions * self;
	klass = VALIDE_NATIVE_BUILDER_OPTIONS_CLASS (g_type_class_peek (VALIDE_TYPE_NATIVE_BUILDER_OPTIONS));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_NATIVE_BUILDER_OPTIONS (obj);
	{
#line 429 "native-builder.vala"
		valide_native_builder_options_set_other (self, "");
#line 1811 "native-builder.c"
	}
	return obj;
}


static void valide_native_builder_options_class_init (ValideNativeBuilderOptionsClass * klass) {
	valide_native_builder_options_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideNativeBuilderOptionsPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_native_builder_options_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_native_builder_options_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_native_builder_options_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_native_builder_options_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_DEBUG, g_param_spec_boolean ("debug", "debug", "debug", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_THREAD, g_param_spec_boolean ("thread", "thread", "thread", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_ASSERT, g_param_spec_boolean ("disable-assert", "disable-assert", "disable-assert", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_CHECKING, g_param_spec_boolean ("disable-checking", "disable-checking", "disable-checking", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_NON_NULL, g_param_spec_boolean ("disable-non-null", "disable-non-null", "disable-non-null", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_SAVE_TEMPS, g_param_spec_boolean ("save-temps", "save-temps", "save-temps", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_QUIET, g_param_spec_boolean ("quiet", "quiet", "quiet", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_OPTIONS_OTHER, g_param_spec_string ("other", "other", "other", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void valide_native_builder_options_valide_builder_options_interface_init (ValideBuilderOptionsIface * iface) {
	valide_native_builder_options_valide_builder_options_parent_iface = g_type_interface_peek_parent (iface);
}


static void valide_native_builder_options_g_yaml_buildable_interface_init (GYAMLBuildableIface * iface) {
	valide_native_builder_options_g_yaml_buildable_parent_iface = g_type_interface_peek_parent (iface);
}


static void valide_native_builder_options_instance_init (ValideNativeBuilderOptions * self) {
	self->priv = VALIDE_NATIVE_BUILDER_OPTIONS_GET_PRIVATE (self);
}


static void valide_native_builder_options_finalize (GObject* obj) {
	ValideNativeBuilderOptions * self;
	self = VALIDE_NATIVE_BUILDER_OPTIONS (obj);
	self->priv->_other = (g_free (self->priv->_other), NULL);
	G_OBJECT_CLASS (valide_native_builder_options_parent_class)->finalize (obj);
}


GType valide_native_builder_options_get_type (void) {
	static GType valide_native_builder_options_type_id = 0;
	if (valide_native_builder_options_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideNativeBuilderOptionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_native_builder_options_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideNativeBuilderOptions), 0, (GInstanceInitFunc) valide_native_builder_options_instance_init, NULL };
		static const GInterfaceInfo valide_builder_options_info = { (GInterfaceInitFunc) valide_native_builder_options_valide_builder_options_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		static const GInterfaceInfo g_yaml_buildable_info = { (GInterfaceInitFunc) valide_native_builder_options_g_yaml_buildable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valide_native_builder_options_type_id = g_type_register_static (G_TYPE_OBJECT, "ValideNativeBuilderOptions", &g_define_type_info, 0);
		g_type_add_interface_static (valide_native_builder_options_type_id, VALIDE_TYPE_BUILDER_OPTIONS, &valide_builder_options_info);
		g_type_add_interface_static (valide_native_builder_options_type_id, G_YAML_TYPE_BUILDABLE, &g_yaml_buildable_info);
	}
	return valide_native_builder_options_type_id;
}


static void valide_native_builder_options_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideNativeBuilderOptions * self;
	gpointer boxed;
	self = VALIDE_NATIVE_BUILDER_OPTIONS (object);
	switch (property_id) {
		case VALIDE_NATIVE_BUILDER_OPTIONS_DEBUG:
		g_value_set_boolean (value, valide_native_builder_options_get_debug (self));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_THREAD:
		g_value_set_boolean (value, valide_native_builder_options_get_thread (self));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_ASSERT:
		g_value_set_boolean (value, valide_native_builder_options_get_disable_assert (self));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_CHECKING:
		g_value_set_boolean (value, valide_native_builder_options_get_disable_checking (self));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_NON_NULL:
		g_value_set_boolean (value, valide_native_builder_options_get_disable_non_null (self));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_SAVE_TEMPS:
		g_value_set_boolean (value, valide_native_builder_options_get_save_temps (self));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_QUIET:
		g_value_set_boolean (value, valide_native_builder_options_get_quiet (self));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_OTHER:
		g_value_set_string (value, valide_native_builder_options_get_other (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_native_builder_options_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideNativeBuilderOptions * self;
	self = VALIDE_NATIVE_BUILDER_OPTIONS (object);
	switch (property_id) {
		case VALIDE_NATIVE_BUILDER_OPTIONS_DEBUG:
		valide_native_builder_options_set_debug (self, g_value_get_boolean (value));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_THREAD:
		valide_native_builder_options_set_thread (self, g_value_get_boolean (value));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_ASSERT:
		valide_native_builder_options_set_disable_assert (self, g_value_get_boolean (value));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_CHECKING:
		valide_native_builder_options_set_disable_checking (self, g_value_get_boolean (value));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_DISABLE_NON_NULL:
		valide_native_builder_options_set_disable_non_null (self, g_value_get_boolean (value));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_SAVE_TEMPS:
		valide_native_builder_options_set_save_temps (self, g_value_get_boolean (value));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_QUIET:
		valide_native_builder_options_set_quiet (self, g_value_get_boolean (value));
		break;
		case VALIDE_NATIVE_BUILDER_OPTIONS_OTHER:
		valide_native_builder_options_set_other (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 450 "native-builder.vala"
static char* valide_native_builder_get_compiler_options (ValideNativeBuilder* self) {
#line 1945 "native-builder.c"
	char* result;
	char* opt;
	ValideNativeBuilderOptions* options;
	char* _tmp2_;
	char* _tmp1_;
	char* _tmp0_;
	ValideNativeBuilderOptions* _tmp12_;
	ValideNativeBuilderOptions* _tmp11_;
	ValideBuilderOptions* _tmp10_;
	char* _tmp21_;
	char* _tmp20_;
#line 450 "native-builder.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1959 "native-builder.c"
	opt = g_strdup ("");
	options = NULL;
	_tmp2_ = NULL;
#line 820 "glib-2.0.vapi"
	_tmp1_ = NULL;
#line 950 "project.vala"
	_tmp0_ = NULL;
#line 455 "native-builder.vala"
	opt = (_tmp2_ = g_strconcat (opt, _tmp1_ = g_strdup_printf ("-o \"%s\"", _tmp0_ = valide_project_get_executable_name (valide_builder_get_project ((ValideBuilder*) self))), NULL), opt = (g_free (opt), NULL), _tmp2_);
#line 1969 "native-builder.c"
	_tmp1_ = (g_free (_tmp1_), NULL);
	_tmp0_ = (g_free (_tmp0_), NULL);
	{
		GList* package_collection;
		GList* package_it;
#line 457 "native-builder.vala"
		package_collection = valide_builder_get_project ((ValideBuilder*) self)->packages;
#line 1977 "native-builder.c"
		for (package_it = package_collection; package_it != NULL; package_it = package_it->next) {
			ValidePackage* _tmp5_;
			ValidePackage* package;
#line 77 "project.vala"
			_tmp5_ = NULL;
#line 457 "native-builder.vala"
			package = (_tmp5_ = (ValidePackage*) package_it->data, (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_));
#line 1985 "native-builder.c"
			{
				char* _tmp4_;
				char* _tmp3_;
				_tmp4_ = NULL;
				_tmp3_ = NULL;
#line 459 "native-builder.vala"
				opt = (_tmp4_ = g_strconcat (opt, _tmp3_ = g_strconcat (" --pkg=", valide_package_get_name (package), NULL), NULL), opt = (g_free (opt), NULL), _tmp4_);
#line 1993 "native-builder.c"
				_tmp3_ = (g_free (_tmp3_), NULL);
				(package == NULL) ? NULL : (package = (g_object_unref (package), NULL));
			}
		}
	}
	{
		GList* vapi_dir_collection;
		GList* vapi_dir_it;
#line 462 "native-builder.vala"
		vapi_dir_collection = valide_builder_get_project ((ValideBuilder*) self)->vapi_dir;
#line 2004 "native-builder.c"
		for (vapi_dir_it = vapi_dir_collection; vapi_dir_it != NULL; vapi_dir_it = vapi_dir_it->next) {
			ValideVapiDir* _tmp9_;
			ValideVapiDir* vapi_dir;
#line 82 "project.vala"
			_tmp9_ = NULL;
#line 462 "native-builder.vala"
			vapi_dir = (_tmp9_ = (ValideVapiDir*) vapi_dir_it->data, (_tmp9_ == NULL) ? NULL : g_object_ref (_tmp9_));
#line 2012 "native-builder.c"
			{
				char* _tmp8_;
				char* _tmp7_;
				char* _tmp6_;
				_tmp8_ = NULL;
				_tmp7_ = NULL;
				_tmp6_ = NULL;
#line 464 "native-builder.vala"
				opt = (_tmp8_ = g_strconcat (opt, _tmp7_ = g_strconcat (_tmp6_ = g_strconcat (" --vapidir=\"", valide_vapi_dir_get_path (vapi_dir), NULL), "\"", NULL), NULL), opt = (g_free (opt), NULL), _tmp8_);
#line 2022 "native-builder.c"
				_tmp7_ = (g_free (_tmp7_), NULL);
				_tmp6_ = (g_free (_tmp6_), NULL);
				(vapi_dir == NULL) ? NULL : (vapi_dir = (g_object_unref (vapi_dir), NULL));
			}
		}
	}
	_tmp12_ = NULL;
#line 467 "native-builder.vala"
	_tmp11_ = NULL;
#line 467 "native-builder.vala"
	_tmp10_ = NULL;
#line 467 "native-builder.vala"
	options = (_tmp12_ = (_tmp11_ = (_tmp10_ = valide_project_get_builder_options (valide_builder_get_project ((ValideBuilder*) self)), VALIDE_IS_NATIVE_BUILDER_OPTIONS (_tmp10_) ? ((ValideNativeBuilderOptions*) _tmp10_) : NULL), (_tmp11_ == NULL) ? NULL : g_object_ref (_tmp11_)), (options == NULL) ? NULL : (options = (g_object_unref (options), NULL)), _tmp12_);
#line 468 "native-builder.vala"
	if (valide_native_builder_options_get_debug (options)) {
#line 2038 "native-builder.c"
		char* _tmp13_;
		_tmp13_ = NULL;
#line 470 "native-builder.vala"
		opt = (_tmp13_ = g_strconcat (opt, " -g", NULL), opt = (g_free (opt), NULL), _tmp13_);
#line 2043 "native-builder.c"
	}
#line 473 "native-builder.vala"
	if (valide_native_builder_options_get_thread (options)) {
#line 2047 "native-builder.c"
		char* _tmp14_;
		_tmp14_ = NULL;
#line 475 "native-builder.vala"
		opt = (_tmp14_ = g_strconcat (opt, " --thread", NULL), opt = (g_free (opt), NULL), _tmp14_);
#line 2052 "native-builder.c"
	}
#line 478 "native-builder.vala"
	if (valide_native_builder_options_get_disable_assert (options)) {
#line 2056 "native-builder.c"
		char* _tmp15_;
		_tmp15_ = NULL;
#line 480 "native-builder.vala"
		opt = (_tmp15_ = g_strconcat (opt, " --disable-assert", NULL), opt = (g_free (opt), NULL), _tmp15_);
#line 2061 "native-builder.c"
	}
#line 483 "native-builder.vala"
	if (valide_native_builder_options_get_disable_checking (options)) {
#line 2065 "native-builder.c"
		char* _tmp16_;
		_tmp16_ = NULL;
#line 485 "native-builder.vala"
		opt = (_tmp16_ = g_strconcat (opt, " --disable-checking", NULL), opt = (g_free (opt), NULL), _tmp16_);
#line 2070 "native-builder.c"
	}
#line 488 "native-builder.vala"
	if (valide_native_builder_options_get_disable_non_null (options)) {
#line 2074 "native-builder.c"
		char* _tmp17_;
		_tmp17_ = NULL;
#line 490 "native-builder.vala"
		opt = (_tmp17_ = g_strconcat (opt, " --disable-non-null", NULL), opt = (g_free (opt), NULL), _tmp17_);
#line 2079 "native-builder.c"
	}
#line 493 "native-builder.vala"
	if (valide_native_builder_options_get_save_temps (options)) {
#line 2083 "native-builder.c"
		char* _tmp18_;
		_tmp18_ = NULL;
#line 495 "native-builder.vala"
		opt = (_tmp18_ = g_strconcat (opt, " --save-temps", NULL), opt = (g_free (opt), NULL), _tmp18_);
#line 2088 "native-builder.c"
	}
#line 498 "native-builder.vala"
	if (valide_native_builder_options_get_quiet (options)) {
#line 2092 "native-builder.c"
		char* _tmp19_;
		_tmp19_ = NULL;
#line 500 "native-builder.vala"
		opt = (_tmp19_ = g_strconcat (opt, " -q", NULL), opt = (g_free (opt), NULL), _tmp19_);
#line 2097 "native-builder.c"
	}
	_tmp21_ = NULL;
	_tmp20_ = NULL;
#line 503 "native-builder.vala"
	opt = (_tmp21_ = g_strconcat (opt, _tmp20_ = g_strconcat (" ", valide_native_builder_options_get_other (options), NULL), NULL), opt = (g_free (opt), NULL), _tmp21_);
#line 2103 "native-builder.c"
	_tmp20_ = (g_free (_tmp20_), NULL);
	{
		GList* file_collection;
		GList* file_it;
#line 505 "native-builder.vala"
		file_collection = valide_builder_get_project ((ValideBuilder*) self)->files;
#line 2110 "native-builder.c"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			ValideSource* _tmp26_;
			ValideSource* file;
#line 72 "project.vala"
			_tmp26_ = NULL;
#line 505 "native-builder.vala"
			file = (_tmp26_ = (ValideSource*) file_it->data, (_tmp26_ == NULL) ? NULL : g_object_ref (_tmp26_));
#line 2118 "native-builder.c"
			{
				gboolean _tmp22_;
				gboolean _tmp23_;
				_tmp22_ = FALSE;
				_tmp23_ = FALSE;
#line 507 "native-builder.vala"
				if (g_str_has_suffix (valide_source_get_path (file), ".vala")) {
#line 507 "native-builder.vala"
					_tmp23_ = TRUE;
#line 2128 "native-builder.c"
				} else {
#line 508 "native-builder.vala"
					_tmp23_ = g_str_has_suffix (valide_source_get_path (file), ".gs");
#line 2132 "native-builder.c"
				}
#line 507 "native-builder.vala"
				if (_tmp23_) {
#line 507 "native-builder.vala"
					_tmp22_ = TRUE;
#line 2138 "native-builder.c"
				} else {
#line 509 "native-builder.vala"
					_tmp22_ = g_str_has_suffix (valide_source_get_path (file), ".c");
#line 2142 "native-builder.c"
				}
#line 507 "native-builder.vala"
				if (_tmp22_) {
#line 2146 "native-builder.c"
					char* _tmp25_;
					char* _tmp24_;
					_tmp25_ = NULL;
#line 820 "glib-2.0.vapi"
					_tmp24_ = NULL;
#line 511 "native-builder.vala"
					opt = (_tmp25_ = g_strconcat (opt, _tmp24_ = g_strdup_printf (" \"%s\"", valide_source_get_path (file)), NULL), opt = (g_free (opt), NULL), _tmp25_);
#line 2154 "native-builder.c"
					_tmp24_ = (g_free (_tmp24_), NULL);
				}
				(file == NULL) ? NULL : (file = (g_object_unref (file), NULL));
			}
		}
	}
	result = opt;
	(options == NULL) ? NULL : (options = (g_object_unref (options), NULL));
	return result;
}


#line 517 "native-builder.vala"
ValideNativeBuilder* valide_native_builder_construct (GType object_type, ValideProject* project) {
#line 2169 "native-builder.c"
	GParameter * __params;
	GParameter * __params_it;
	ValideNativeBuilder * self;
#line 517 "native-builder.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 2175 "native-builder.c"
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 519 "native-builder.vala"
	__params_it->name = "project";
#line 519 "native-builder.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_PROJECT);
#line 519 "native-builder.vala"
	g_value_set_object (&__params_it->value, project);
#line 519 "native-builder.vala"
	__params_it++;
#line 2186 "native-builder.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 517 "native-builder.vala"
ValideNativeBuilder* valide_native_builder_new (ValideProject* project) {
#line 517 "native-builder.vala"
	return valide_native_builder_construct (VALIDE_TYPE_NATIVE_BUILDER, project);
#line 2201 "native-builder.c"
}


/**
   * @see Builder.configure
   */
#line 525 "native-builder.vala"
static void valide_native_builder_real_configure (ValideBuilder* base) {
#line 2210 "native-builder.c"
	ValideNativeBuilder * self;
	self = (ValideNativeBuilder*) base;
#line 527 "native-builder.vala"
	g_message (_ ("This project couldn't be configurate, choose another builder"));
#line 2215 "native-builder.c"
}


/**
   * @see Builder.build
   */
#line 533 "native-builder.vala"
static void valide_native_builder_real_build (ValideBuilder* base) {
#line 2224 "native-builder.c"
	ValideNativeBuilder * self;
	ValideCompiler* compiler;
	ValideExecutableOptions* options;
	ValideExecutableOptions* _tmp0_;
	char* _tmp1_;
	ValideCompiler* _tmp2_;
	self = (ValideNativeBuilder*) base;
	compiler = NULL;
	options = NULL;
	_tmp0_ = NULL;
#line 538 "native-builder.vala"
	options = (_tmp0_ = valide_executable_options_new (), (options == NULL) ? NULL : (options = (g_object_unref (options), NULL)), _tmp0_);
#line 450 "native-builder.vala"
	_tmp1_ = NULL;
#line 539 "native-builder.vala"
	valide_executable_options_set_arguments (options, _tmp1_ = valide_native_builder_get_compiler_options (self));
#line 2241 "native-builder.c"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 540 "native-builder.vala"
	valide_executable_options_set_working_dir (options, valide_project_get_path (valide_builder_get_project ((ValideBuilder*) self)));
#line 2245 "native-builder.c"
	_tmp2_ = NULL;
#line 541 "native-builder.vala"
	compiler = (_tmp2_ = valide_compiler_new (valide_builder_get_project ((ValideBuilder*) self)), (compiler == NULL) ? NULL : (compiler = (g_object_unref (compiler), NULL)), _tmp2_);
#line 542 "native-builder.vala"
	valide_executable_manager_run (valide_builder_get_executables ((ValideBuilder*) self), (ValideExecutable*) compiler, options);
#line 2251 "native-builder.c"
	(compiler == NULL) ? NULL : (compiler = (g_object_unref (compiler), NULL));
	(options == NULL) ? NULL : (options = (g_object_unref (options), NULL));
}


/**
   * @see Builder.install
   */
#line 548 "native-builder.vala"
static void valide_native_builder_real_install (ValideBuilder* base) {
#line 2262 "native-builder.c"
	ValideNativeBuilder * self;
	self = (ValideNativeBuilder*) base;
#line 550 "native-builder.vala"
	g_message (_ ("This project couldn't be install, choose another builder"));
#line 2267 "native-builder.c"
}


/**
   * @see Builder.dist
   */
#line 556 "native-builder.vala"
static void valide_native_builder_real_dist (ValideBuilder* base) {
#line 2276 "native-builder.c"
	ValideNativeBuilder * self;
	self = (ValideNativeBuilder*) base;
#line 558 "native-builder.vala"
	g_message (_ ("This project couldn't be distribute, choose another builder"));
#line 2281 "native-builder.c"
}


/**
   * @see Builder.clean
   */
#line 564 "native-builder.vala"
static void valide_native_builder_real_clean (ValideBuilder* base) {
#line 2290 "native-builder.c"
	ValideNativeBuilder * self;
	char* _tmp0_;
	self = (ValideNativeBuilder*) base;
#line 950 "project.vala"
	_tmp0_ = NULL;
#line 566 "native-builder.vala"
	g_remove (_tmp0_ = valide_project_get_executable_name (valide_builder_get_project ((ValideBuilder*) self)));
#line 2298 "native-builder.c"
	_tmp0_ = (g_free (_tmp0_), NULL);
}


/**
   * @see Builder.distclean
   */
#line 572 "native-builder.vala"
static void valide_native_builder_real_distclean (ValideBuilder* base) {
#line 2308 "native-builder.c"
	ValideNativeBuilder * self;
	char* filename;
	self = (ValideNativeBuilder*) base;
	filename = NULL;
	{
		GList* file_collection;
		GList* file_it;
#line 576 "native-builder.vala"
		file_collection = valide_builder_get_project ((ValideBuilder*) self)->files;
#line 2318 "native-builder.c"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
			ValideSource* _tmp5_;
			ValideSource* file;
#line 72 "project.vala"
			_tmp5_ = NULL;
#line 576 "native-builder.vala"
			file = (_tmp5_ = (ValideSource*) file_it->data, (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_));
#line 2326 "native-builder.c"
			{
				gboolean _tmp0_;
				_tmp0_ = FALSE;
#line 578 "native-builder.vala"
				if (g_str_has_suffix (valide_source_get_path (file), ".vala")) {
#line 578 "native-builder.vala"
					_tmp0_ = TRUE;
#line 2334 "native-builder.c"
				} else {
#line 579 "native-builder.vala"
					_tmp0_ = g_str_has_suffix (valide_source_get_path (file), ".gs");
#line 2338 "native-builder.c"
				}
#line 578 "native-builder.vala"
				if (_tmp0_) {
#line 2342 "native-builder.c"
					char* _tmp1_;
					char* _tmp2_;
					char* _tmp3_;
					char* _tmp4_;
					_tmp1_ = NULL;
#line 581 "native-builder.vala"
					filename = (_tmp1_ = valide_project_get_real_filename (valide_builder_get_project ((ValideBuilder*) self), valide_source_get_path (file)), filename = (g_free (filename), NULL), _tmp1_);
#line 2350 "native-builder.c"
					_tmp2_ = NULL;
#line 582 "native-builder.vala"
					filename = (_tmp2_ = valide_utils_skip_extension (filename), filename = (g_free (filename), NULL), _tmp2_);
#line 2354 "native-builder.c"
					_tmp3_ = NULL;
#line 583 "native-builder.vala"
					g_remove (_tmp3_ = g_strconcat (filename, ".c", NULL));
#line 2358 "native-builder.c"
					_tmp3_ = (g_free (_tmp3_), NULL);
					_tmp4_ = NULL;
#line 584 "native-builder.vala"
					g_remove (_tmp4_ = g_strconcat (filename, ".h", NULL));
#line 2363 "native-builder.c"
					_tmp4_ = (g_free (_tmp4_), NULL);
				}
				(file == NULL) ? NULL : (file = (g_object_unref (file), NULL));
			}
		}
	}
#line 587 "native-builder.vala"
	valide_builder_clean ((ValideBuilder*) self);
#line 2372 "native-builder.c"
	filename = (g_free (filename), NULL);
}


/**
   * @see Builder.uninstall
   */
#line 593 "native-builder.vala"
static void valide_native_builder_real_uninstall (ValideBuilder* base) {
#line 2382 "native-builder.c"
	ValideNativeBuilder * self;
	self = (ValideNativeBuilder*) base;
#line 595 "native-builder.vala"
	g_message (_ ("This project couldn't be uninstall, choose another builder"));
#line 2387 "native-builder.c"
}


/**
   * @see Valide.Builder.preferences
   */
#line 601 "native-builder.vala"
static GtkWidget* valide_native_builder_real_preferences (ValideBuilder* base) {
#line 2396 "native-builder.c"
	ValideNativeBuilder * self;
	GtkWidget* result;
	ValideNativeBuilderPreferences* _tmp0_;
	GtkWidget* _tmp1_;
	self = (ValideNativeBuilder*) base;
	_tmp0_ = NULL;
#line 603 "native-builder.vala"
	valide_native_builder_preferences_widget = (_tmp0_ = g_object_ref_sink (valide_native_builder_preferences_new (valide_builder_get_project ((ValideBuilder*) self))), (valide_native_builder_preferences_widget == NULL) ? NULL : (valide_native_builder_preferences_widget = (g_object_unref (valide_native_builder_preferences_widget), NULL)), _tmp0_);
#line 604 "native-builder.vala"
	_tmp1_ = NULL;
#line 2407 "native-builder.c"
	result = (_tmp1_ = (GtkWidget*) ((ValideAbstractNativeBuilderPreferences*) valide_native_builder_preferences_widget)->widgets->notebook, (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
	return result;
}


static ValideProject* valide_native_builder_real_get_project (ValideBuilder* base) {
	ValideProject* result;
	ValideNativeBuilder* self;
	self = (ValideNativeBuilder*) base;
	result = self->priv->_project;
	return result;
}


static void valide_native_builder_real_set_project (ValideBuilder* base, ValideProject* value) {
	ValideNativeBuilder* self;
	ValideProject* _tmp1_;
	ValideProject* _tmp0_;
	self = (ValideNativeBuilder*) base;
	_tmp1_ = NULL;
#line 441 "native-builder.vala"
	_tmp0_ = NULL;
#line 2430 "native-builder.c"
	self->priv->_project = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "project");
}


static ValideExecutableManager* valide_native_builder_real_get_executables (ValideBuilder* base) {
	ValideExecutableManager* result;
	ValideNativeBuilder* self;
	self = (ValideNativeBuilder*) base;
	result = self->priv->_executables;
	return result;
}


static void valide_native_builder_real_set_executables (ValideBuilder* base, ValideExecutableManager* value) {
	ValideNativeBuilder* self;
	ValideExecutableManager* _tmp1_;
	ValideExecutableManager* _tmp0_;
	self = (ValideNativeBuilder*) base;
	_tmp1_ = NULL;
#line 446 "native-builder.vala"
	_tmp0_ = NULL;
#line 2453 "native-builder.c"
	self->priv->_executables = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_executables == NULL) ? NULL : (self->priv->_executables = (g_object_unref (self->priv->_executables), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "executables");
}


static void valide_native_builder_class_init (ValideNativeBuilderClass * klass) {
	valide_native_builder_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideNativeBuilderPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_native_builder_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_native_builder_set_property;
	G_OBJECT_CLASS (klass)->finalize = valide_native_builder_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_PROJECT, "project");
	g_object_class_override_property (G_OBJECT_CLASS (klass), VALIDE_NATIVE_BUILDER_EXECUTABLES, "executables");
}


static void valide_native_builder_valide_builder_interface_init (ValideBuilderIface * iface) {
	valide_native_builder_valide_builder_parent_iface = g_type_interface_peek_parent (iface);
	iface->configure = valide_native_builder_real_configure;
	iface->build = valide_native_builder_real_build;
	iface->install = valide_native_builder_real_install;
	iface->dist = valide_native_builder_real_dist;
	iface->clean = valide_native_builder_real_clean;
	iface->distclean = valide_native_builder_real_distclean;
	iface->uninstall = valide_native_builder_real_uninstall;
	iface->preferences = valide_native_builder_real_preferences;
	iface->get_project = valide_native_builder_real_get_project;
	iface->set_project = valide_native_builder_real_set_project;
	iface->get_executables = valide_native_builder_real_get_executables;
	iface->set_executables = valide_native_builder_real_set_executables;
}


static void valide_native_builder_instance_init (ValideNativeBuilder * self) {
	self->priv = VALIDE_NATIVE_BUILDER_GET_PRIVATE (self);
}


static void valide_native_builder_finalize (GObject* obj) {
	ValideNativeBuilder * self;
	self = VALIDE_NATIVE_BUILDER (obj);
	(self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL));
	(self->priv->_executables == NULL) ? NULL : (self->priv->_executables = (g_object_unref (self->priv->_executables), NULL));
	G_OBJECT_CLASS (valide_native_builder_parent_class)->finalize (obj);
}


GType valide_native_builder_get_type (void) {
	static GType valide_native_builder_type_id = 0;
	if (valide_native_builder_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideNativeBuilderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_native_builder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideNativeBuilder), 0, (GInstanceInitFunc) valide_native_builder_instance_init, NULL };
		static const GInterfaceInfo valide_builder_info = { (GInterfaceInitFunc) valide_native_builder_valide_builder_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valide_native_builder_type_id = g_type_register_static (G_TYPE_OBJECT, "ValideNativeBuilder", &g_define_type_info, 0);
		g_type_add_interface_static (valide_native_builder_type_id, VALIDE_TYPE_BUILDER, &valide_builder_info);
	}
	return valide_native_builder_type_id;
}


static void valide_native_builder_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideNativeBuilder * self;
	gpointer boxed;
	self = VALIDE_NATIVE_BUILDER (object);
	switch (property_id) {
		case VALIDE_NATIVE_BUILDER_PROJECT:
		g_value_set_object (value, valide_builder_get_project ((ValideBuilder*) self));
		break;
		case VALIDE_NATIVE_BUILDER_EXECUTABLES:
		g_value_set_object (value, valide_builder_get_executables ((ValideBuilder*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_native_builder_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideNativeBuilder * self;
	self = VALIDE_NATIVE_BUILDER (object);
	switch (property_id) {
		case VALIDE_NATIVE_BUILDER_PROJECT:
		valide_builder_set_project ((ValideBuilder*) self, g_value_get_object (value));
		break;
		case VALIDE_NATIVE_BUILDER_EXECUTABLES:
		valide_builder_set_executables ((ValideBuilder*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




