/* plugin-preferences.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <glib/gi18n-lib.h>
#include <pango/pango.h>


#define VALIDE_TYPE_PLUGIN_PREFERENCES (valide_plugin_preferences_get_type ())
#define VALIDE_PLUGIN_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferences))
#define VALIDE_PLUGIN_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferencesClass))
#define VALIDE_IS_PLUGIN_PREFERENCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES))
#define VALIDE_IS_PLUGIN_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_PREFERENCES))
#define VALIDE_PLUGIN_PREFERENCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferencesClass))

typedef struct _ValidePluginPreferences ValidePluginPreferences;
typedef struct _ValidePluginPreferencesClass ValidePluginPreferencesClass;
typedef struct _ValidePluginPreferencesPrivate ValidePluginPreferencesPrivate;

#define VALIDE_TYPE_PLUGIN_MANAGER (valide_plugin_manager_get_type ())
#define VALIDE_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManager))
#define VALIDE_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManagerClass))
#define VALIDE_IS_PLUGIN_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_MANAGER))
#define VALIDE_IS_PLUGIN_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_MANAGER))
#define VALIDE_PLUGIN_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_MANAGER, ValidePluginManagerClass))

typedef struct _ValidePluginManager ValidePluginManager;
typedef struct _ValidePluginManagerClass ValidePluginManagerClass;

#define VALIDE_PLUGIN_PREFERENCES_TYPE_COL (valide_plugin_preferences_col_get_type ())

#define VALIDE_TYPE_PLUGIN_REGISTRAR (valide_plugin_registrar_get_type ())
#define VALIDE_PLUGIN_REGISTRAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN_REGISTRAR, ValidePluginRegistrar))
#define VALIDE_PLUGIN_REGISTRAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PLUGIN_REGISTRAR, ValidePluginRegistrarClass))
#define VALIDE_IS_PLUGIN_REGISTRAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN_REGISTRAR))
#define VALIDE_IS_PLUGIN_REGISTRAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PLUGIN_REGISTRAR))
#define VALIDE_PLUGIN_REGISTRAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PLUGIN_REGISTRAR, ValidePluginRegistrarClass))

typedef struct _ValidePluginRegistrar ValidePluginRegistrar;
typedef struct _ValidePluginRegistrarClass ValidePluginRegistrarClass;

#define VALIDE_TYPE_PLUGIN (valide_plugin_get_type ())
#define VALIDE_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PLUGIN, ValidePlugin))
#define VALIDE_IS_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PLUGIN))
#define VALIDE_PLUGIN_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_PLUGIN, ValidePluginIface))

typedef struct _ValidePlugin ValidePlugin;
typedef struct _ValidePluginIface ValidePluginIface;

#define VALIDE_TYPE_WINDOW (valide_window_get_type ())
#define VALIDE_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_WINDOW, ValideWindow))
#define VALIDE_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_WINDOW, ValideWindowClass))
#define VALIDE_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_WINDOW))
#define VALIDE_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_WINDOW))
#define VALIDE_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_WINDOW, ValideWindowClass))

typedef struct _ValideWindow ValideWindow;
typedef struct _ValideWindowClass ValideWindowClass;

#define VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER (valide_abstract_config_manager_get_type ())
#define VALIDE_ABSTRACT_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER, ValideAbstractConfigManager))
#define VALIDE_ABSTRACT_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER, ValideAbstractConfigManagerClass))
#define VALIDE_IS_ABSTRACT_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER))
#define VALIDE_IS_ABSTRACT_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER))
#define VALIDE_ABSTRACT_CONFIG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_CONFIG_MANAGER, ValideAbstractConfigManagerClass))

typedef struct _ValideAbstractConfigManager ValideAbstractConfigManager;
typedef struct _ValideAbstractConfigManagerClass ValideAbstractConfigManagerClass;

#define VALIDE_TYPE_CONFIG_MANAGER (valide_config_manager_get_type ())
#define VALIDE_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_CONFIG_MANAGER, ValideConfigManager))
#define VALIDE_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_CONFIG_MANAGER, ValideConfigManagerClass))
#define VALIDE_IS_CONFIG_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_CONFIG_MANAGER))
#define VALIDE_IS_CONFIG_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_CONFIG_MANAGER))
#define VALIDE_CONFIG_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_CONFIG_MANAGER, ValideConfigManagerClass))

typedef struct _ValideConfigManager ValideConfigManager;
typedef struct _ValideConfigManagerClass ValideConfigManagerClass;
typedef struct _ValidePluginManagerPrivate ValidePluginManagerPrivate;

/**
 * The widget for plugin preferences
 */
struct _ValidePluginPreferences {
	GtkVBox parent_instance;
	ValidePluginPreferencesPrivate * priv;
};

struct _ValidePluginPreferencesClass {
	GtkVBoxClass parent_class;
};

struct _ValidePluginPreferencesPrivate {
	GtkTreeView* tree_view;
	GtkButton* about_button;
	GtkButton* configure_button;
	ValidePluginManager* _plugin_manager;
};

/* enum for tree model columns, not all is currently used */
typedef enum  {
	VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE,
	VALIDE_PLUGIN_PREFERENCES_COL_INFO,
	VALIDE_PLUGIN_PREFERENCES_COL_NB
} ValidePluginPreferencesCol;

/**
 * Interface for create a plugin
 */
struct _ValidePluginIface {
	GTypeInterface parent_iface;
	const char* (*get_path) (ValidePlugin* self);
	void (*set_path) (ValidePlugin* self, const char* value);
	ValideWindow* (*get_window) (ValidePlugin* self);
	void (*set_window) (ValidePlugin* self, ValideWindow* value);
};

/**
 * The plugin manager
 */
struct _ValidePluginManager {
	GObject parent_instance;
	ValidePluginManagerPrivate * priv;
	GList* plugins;
};

struct _ValidePluginManagerClass {
	GObjectClass parent_class;
};


static gpointer valide_plugin_preferences_parent_class = NULL;

GType valide_plugin_preferences_get_type (void);
GType valide_plugin_manager_get_type (void);
#define VALIDE_PLUGIN_PREFERENCES_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_PLUGIN_PREFERENCES, ValidePluginPreferencesPrivate))
enum  {
	VALIDE_PLUGIN_PREFERENCES_DUMMY_PROPERTY,
	VALIDE_PLUGIN_PREFERENCES_PLUGIN_MANAGER
};
static GType valide_plugin_preferences_col_get_type (void);
GType valide_plugin_registrar_get_type (void);
static ValidePluginRegistrar* valide_plugin_preferences_get_selected_plugin (ValidePluginPreferences* self);
static void valide_plugin_preferences_toggle_active (ValidePluginPreferences* self, GtkTreeIter* iter, GtkTreeModel* model);
static void valide_plugin_preferences_active_toggled (ValidePluginPreferences* self, GtkCellRendererToggle* sender, const char* path_str);
const char* valide_plugin_registrar_get_name (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_description (ValidePluginRegistrar* self);
gboolean valide_plugin_registrar_get_is_available (ValidePluginRegistrar* self);
static void valide_plugin_preferences_info_cell (ValidePluginPreferences* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter);
static gint valide_plugin_preferences_model_name_sort (ValidePluginPreferences* self, GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b);
static gboolean valide_plugin_preferences_name_search (GtkTreeModel* model, gint column, const char* key, GtkTreeIter* iter);
GType valide_window_get_type (void);
GType valide_plugin_get_type (void);
ValidePlugin* valide_plugin_registrar_get_plugin (ValidePluginRegistrar* self);
gboolean valide_plugin_registrar_get_is_configurable (ValidePluginRegistrar* self);
static void valide_plugin_preferences_cursor_changed (ValidePluginPreferences* self, GtkTreeView* sender);
static void valide_plugin_preferences_row_activated (ValidePluginPreferences* self, GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column);
static gboolean valide_plugin_preferences_button_press_event (ValidePluginPreferences* self, GtkWidget* sender, const GdkEventButton* event);
static gboolean valide_plugin_preferences_popup_menu (ValidePluginPreferences* self, GtkWidget* sender);
void valide_plugin_registrar_load (ValidePluginRegistrar* self, GError** error);
void valide_plugin_registrar_unload (ValidePluginRegistrar* self, GError** error);
GType valide_abstract_config_manager_get_type (void);
GType valide_config_manager_get_type (void);
ValideConfigManager* valide_config_manager_get_instance (void);
void valide_abstract_config_manager_set_boolean (ValideAbstractConfigManager* self, const char* group, const char* key, gboolean val);
static void valide_plugin_preferences_set_active (ValidePluginPreferences* self, GtkTreeIter* iter, GtkTreeModel* model, gboolean active);
ValidePluginManager* valide_plugin_preferences_get_plugin_manager (ValidePluginPreferences* self);
gboolean valide_plugin_registrar_get_is_active (ValidePluginRegistrar* self);
static void valide_plugin_preferences_populate_lists (ValidePluginPreferences* self);
const char* valide_plugin_registrar_get_website (ValidePluginRegistrar* self);
const char* valide_plugin_registrar_get_copyright (ValidePluginRegistrar* self);
static void valide_plugin_preferences_about_activated (ValidePluginPreferences* self);
void valide_plugin_registrar_preferences (ValidePluginRegistrar* self);
static void valide_plugin_preferences_configure_activated (ValidePluginPreferences* self);
static void valide_plugin_preferences_set_plugin_manager (ValidePluginPreferences* self, ValidePluginManager* value);
ValidePluginPreferences* valide_plugin_preferences_new (ValidePluginManager* plugin_manager);
ValidePluginPreferences* valide_plugin_preferences_construct (GType object_type, ValidePluginManager* plugin_manager);
static void _valide_plugin_preferences_active_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender, const char* path, gpointer self);
static void _valide_plugin_preferences_info_cell_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self);
static gint _valide_plugin_preferences_model_name_sort_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self);
static gboolean _valide_plugin_preferences_name_search_gtk_tree_view_search_equal_func (GtkTreeModel* model, gint column, const char* key, GtkTreeIter* iter, gpointer self);
static void _valide_plugin_preferences_cursor_changed_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self);
static void _valide_plugin_preferences_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, const GtkTreePath* path, GtkTreeViewColumn* column, gpointer self);
static gboolean _valide_plugin_preferences_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender, const GdkEventButton* event, gpointer self);
static gboolean _valide_plugin_preferences_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender, gpointer self);
static void _valide_plugin_preferences_about_activated_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void _valide_plugin_preferences_configure_activated_gtk_button_clicked (GtkButton* _sender, gpointer self);
static GObject * valide_plugin_preferences_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_plugin_preferences_finalize (GObject* obj);
static void valide_plugin_preferences_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_plugin_preferences_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);




static GType valide_plugin_preferences_col_get_type (void) {
	static GType valide_plugin_preferences_col_type_id = 0;
	if (G_UNLIKELY (valide_plugin_preferences_col_type_id == 0)) {
		static const GEnumValue values[] = {{VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE, "VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE", "active"}, {VALIDE_PLUGIN_PREFERENCES_COL_INFO, "VALIDE_PLUGIN_PREFERENCES_COL_INFO", "info"}, {VALIDE_PLUGIN_PREFERENCES_COL_NB, "VALIDE_PLUGIN_PREFERENCES_COL_NB", "nb"}, {0, NULL, NULL}};
		valide_plugin_preferences_col_type_id = g_enum_register_static ("ValidePluginPreferencesCol", values);
	}
	return valide_plugin_preferences_col_type_id;
}


#line 48 "plugin-preferences.vala"
static ValidePluginRegistrar* valide_plugin_preferences_get_selected_plugin (ValidePluginPreferences* self) {
#line 233 "plugin-preferences.c"
	ValidePluginRegistrar* result;
	GtkTreeIter iter = {0};
	GtkTreeModel* model;
	ValidePluginRegistrar* pr;
	GtkTreeSelection* tree_selection;
	GtkTreeSelection* _tmp1_;
	GtkTreeSelection* _tmp0_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp4_;
	gboolean _tmp3_;
	GtkTreeModel* _tmp2_;
#line 48 "plugin-preferences.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 247 "plugin-preferences.c"
	model = NULL;
	pr = NULL;
	tree_selection = NULL;
	_tmp1_ = NULL;
#line 55 "plugin-preferences.vala"
	_tmp0_ = NULL;
#line 55 "plugin-preferences.vala"
	tree_selection = (_tmp1_ = (_tmp0_ = gtk_tree_view_get_selection (self->priv->tree_view), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (tree_selection == NULL) ? NULL : (tree_selection = (g_object_unref (tree_selection), NULL)), _tmp1_);
#line 56 "plugin-preferences.vala"
	_tmp5_ = NULL;
#line 258 "plugin-preferences.c"
	_tmp4_ = NULL;
	_tmp2_ = NULL;
#line 56 "plugin-preferences.vala"
	if ((_tmp3_ = gtk_tree_selection_get_selected (tree_selection, &_tmp2_, &iter), model = (_tmp4_ = (_tmp5_ = _tmp2_, (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_)), (model == NULL) ? NULL : (model = (g_object_unref (model), NULL)), _tmp4_), _tmp3_)) {
#line 58 "plugin-preferences.vala"
		gtk_tree_model_get (model, &iter, VALIDE_PLUGIN_PREFERENCES_COL_INFO, &pr, -1);
#line 265 "plugin-preferences.c"
	}
	result = pr;
	(model == NULL) ? NULL : (model = (g_object_unref (model), NULL));
	(tree_selection == NULL) ? NULL : (tree_selection = (g_object_unref (tree_selection), NULL));
	return result;
}


#line 63 "plugin-preferences.vala"
static void valide_plugin_preferences_active_toggled (ValidePluginPreferences* self, GtkCellRendererToggle* sender, const char* path_str) {
#line 276 "plugin-preferences.c"
	GtkTreeIter iter = {0};
	GtkTreePath* path;
	GtkTreeModel* model;
	GtkTreePath* _tmp0_;
	GtkTreeModel* _tmp2_;
	GtkTreeModel* _tmp1_;
#line 63 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 63 "plugin-preferences.vala"
	g_return_if_fail (sender != NULL);
#line 63 "plugin-preferences.vala"
	g_return_if_fail (path_str != NULL);
#line 289 "plugin-preferences.c"
	path = NULL;
	model = NULL;
	_tmp0_ = NULL;
#line 69 "plugin-preferences.vala"
	path = (_tmp0_ = gtk_tree_path_new_from_string (path_str), (path == NULL) ? NULL : (path = (gtk_tree_path_free (path), NULL)), _tmp0_);
#line 295 "plugin-preferences.c"
	_tmp2_ = NULL;
#line 71 "plugin-preferences.vala"
	_tmp1_ = NULL;
#line 71 "plugin-preferences.vala"
	model = (_tmp2_ = (_tmp1_ = gtk_tree_view_get_model (self->priv->tree_view), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_)), (model == NULL) ? NULL : (model = (g_object_unref (model), NULL)), _tmp2_);
#line 72 "plugin-preferences.vala"
	g_return_if_fail (model != NULL);
#line 74 "plugin-preferences.vala"
	gtk_tree_model_get_iter (model, &iter, path);
#line 76 "plugin-preferences.vala"
	valide_plugin_preferences_toggle_active (self, &iter, model);
#line 307 "plugin-preferences.c"
	(path == NULL) ? NULL : (path = (gtk_tree_path_free (path), NULL));
	(model == NULL) ? NULL : (model = (g_object_unref (model), NULL));
}


#line 79 "plugin-preferences.vala"
static void valide_plugin_preferences_info_cell (ValidePluginPreferences* self, GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter) {
#line 315 "plugin-preferences.c"
	ValidePluginRegistrar* pr;
#line 79 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 79 "plugin-preferences.vala"
	g_return_if_fail (cell_layout != NULL);
#line 79 "plugin-preferences.vala"
	g_return_if_fail (cell != NULL);
#line 79 "plugin-preferences.vala"
	g_return_if_fail (tree_model != NULL);
#line 325 "plugin-preferences.c"
	pr = NULL;
#line 84 "plugin-preferences.vala"
	gtk_tree_model_get (tree_model, &(*iter), VALIDE_PLUGIN_PREFERENCES_COL_INFO, &pr, -1);
#line 85 "plugin-preferences.vala"
	if (pr != NULL) {
#line 331 "plugin-preferences.c"
		char* _tmp0_;
		GtkCellRenderer* _tmp1_;
#line 2767 "glib-2.0.vapi"
		_tmp0_ = NULL;
#line 87 "plugin-preferences.vala"
		_tmp1_ = NULL;
#line 87 "plugin-preferences.vala"
		g_object_set ((_tmp1_ = cell, GTK_IS_CELL_RENDERER_TEXT (_tmp1_) ? ((GtkCellRendererText*) _tmp1_) : NULL), "markup", _tmp0_ = g_markup_printf_escaped ("<b>%s</b>\n%s", valide_plugin_registrar_get_name (pr), valide_plugin_registrar_get_description (pr)), NULL);
#line 340 "plugin-preferences.c"
		_tmp0_ = (g_free (_tmp0_), NULL);
#line 90 "plugin-preferences.vala"
		g_object_set (cell, "sensitive", valide_plugin_registrar_get_is_available (pr), NULL);
#line 344 "plugin-preferences.c"
	}
	(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
}


#line 94 "plugin-preferences.vala"
static gint valide_plugin_preferences_model_name_sort (ValidePluginPreferences* self, GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b) {
#line 352 "plugin-preferences.c"
	gint result;
#line 94 "plugin-preferences.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 94 "plugin-preferences.vala"
	g_return_val_if_fail (model != NULL, 0);
#line 358 "plugin-preferences.c"
	result = 0;
	return result;
}


#line 100 "plugin-preferences.vala"
static gboolean valide_plugin_preferences_name_search (GtkTreeModel* model, gint column, const char* key, GtkTreeIter* iter) {
#line 366 "plugin-preferences.c"
	gboolean result;
	ValidePluginRegistrar* pr;
	gboolean retval;
#line 100 "plugin-preferences.vala"
	g_return_val_if_fail (model != NULL, FALSE);
#line 100 "plugin-preferences.vala"
	g_return_val_if_fail (key != NULL, FALSE);
#line 374 "plugin-preferences.c"
	pr = NULL;
	retval = FALSE;
#line 106 "plugin-preferences.vala"
	gtk_tree_model_get (model, &(*iter), VALIDE_PLUGIN_PREFERENCES_COL_INFO, &pr, -1);
#line 107 "plugin-preferences.vala"
	if (pr != NULL) {
#line 381 "plugin-preferences.c"
		char* _tmp1_;
		char* _tmp0_;
#line 873 "glib-2.0.vapi"
		_tmp1_ = NULL;
#line 873 "glib-2.0.vapi"
		_tmp0_ = NULL;
#line 109 "plugin-preferences.vala"
		retval = !(_vala_strcmp0 (_tmp0_ = g_utf8_casefold (valide_plugin_registrar_get_name (pr), -1), _tmp1_ = g_utf8_casefold (key, -1)) == 0);
#line 390 "plugin-preferences.c"
		_tmp1_ = (g_free (_tmp1_), NULL);
		_tmp0_ = (g_free (_tmp0_), NULL);
	}
	result = retval;
	(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
	return result;
}


#line 114 "plugin-preferences.vala"
static void valide_plugin_preferences_cursor_changed (ValidePluginPreferences* self, GtkTreeView* sender) {
#line 402 "plugin-preferences.c"
	ValidePluginRegistrar* pr;
#line 114 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 114 "plugin-preferences.vala"
	g_return_if_fail (sender != NULL);
#line 408 "plugin-preferences.c"
	pr = valide_plugin_preferences_get_selected_plugin (self);
#line 118 "plugin-preferences.vala"
	if (pr != NULL) {
#line 412 "plugin-preferences.c"
		gboolean _tmp0_;
#line 120 "plugin-preferences.vala"
		g_object_set ((GtkWidget*) self->priv->about_button, "sensitive", valide_plugin_registrar_get_plugin (pr) != NULL, NULL);
#line 416 "plugin-preferences.c"
		_tmp0_ = FALSE;
#line 121 "plugin-preferences.vala"
		if (valide_plugin_registrar_get_plugin (pr) != NULL) {
#line 121 "plugin-preferences.vala"
			_tmp0_ = valide_plugin_registrar_get_is_configurable (pr);
#line 422 "plugin-preferences.c"
		} else {
#line 121 "plugin-preferences.vala"
			_tmp0_ = FALSE;
#line 426 "plugin-preferences.c"
		}
#line 121 "plugin-preferences.vala"
		g_object_set ((GtkWidget*) self->priv->configure_button, "sensitive", _tmp0_, NULL);
#line 430 "plugin-preferences.c"
	}
	(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
}


#line 125 "plugin-preferences.vala"
static void valide_plugin_preferences_row_activated (ValidePluginPreferences* self, GtkTreeView* sender, const GtkTreePath* path, GtkTreeViewColumn* column) {
#line 438 "plugin-preferences.c"
	GtkTreeIter iter = {0};
	GtkTreeModel* _tmp0_;
	GtkTreeModel* model;
#line 125 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 125 "plugin-preferences.vala"
	g_return_if_fail (sender != NULL);
#line 125 "plugin-preferences.vala"
	g_return_if_fail (path != NULL);
#line 125 "plugin-preferences.vala"
	g_return_if_fail (column != NULL);
#line 129 "plugin-preferences.vala"
	_tmp0_ = NULL;
#line 452 "plugin-preferences.c"
	model = (_tmp0_ = gtk_tree_view_get_model (self->priv->tree_view), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 130 "plugin-preferences.vala"
	g_return_if_fail (model != NULL);
#line 132 "plugin-preferences.vala"
	gtk_tree_model_get_iter (model, &iter, path);
#line 134 "plugin-preferences.vala"
	valide_plugin_preferences_toggle_active (self, &iter, model);
#line 460 "plugin-preferences.c"
	(model == NULL) ? NULL : (model = (g_object_unref (model), NULL));
}


#line 137 "plugin-preferences.vala"
static gboolean valide_plugin_preferences_button_press_event (ValidePluginPreferences* self, GtkWidget* sender, const GdkEventButton* event) {
#line 467 "plugin-preferences.c"
	gboolean result;
#line 137 "plugin-preferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "plugin-preferences.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 473 "plugin-preferences.c"
	result = FALSE;
	return result;
}


#line 142 "plugin-preferences.vala"
static gboolean valide_plugin_preferences_popup_menu (ValidePluginPreferences* self, GtkWidget* sender) {
#line 481 "plugin-preferences.c"
	gboolean result;
#line 142 "plugin-preferences.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 142 "plugin-preferences.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 487 "plugin-preferences.c"
	result = TRUE;
	return result;
}


#line 147 "plugin-preferences.vala"
static void valide_plugin_preferences_set_active (ValidePluginPreferences* self, GtkTreeIter* iter, GtkTreeModel* model, gboolean active) {
#line 495 "plugin-preferences.c"
	GError * _inner_error_;
	ValidePluginRegistrar* pr;
	GtkListStore* _tmp0_;
	GtkListStore* list_store;
	ValideConfigManager* _tmp1_;
#line 147 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 147 "plugin-preferences.vala"
	g_return_if_fail (model != NULL);
#line 505 "plugin-preferences.c"
	_inner_error_ = NULL;
	pr = NULL;
#line 150 "plugin-preferences.vala"
	_tmp0_ = NULL;
#line 510 "plugin-preferences.c"
	list_store = (_tmp0_ = GTK_LIST_STORE (model), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 152 "plugin-preferences.vala"
	gtk_tree_model_get ((GtkTreeModel*) list_store, &(*iter), VALIDE_PLUGIN_PREFERENCES_COL_INFO, &pr, -1);
#line 154 "plugin-preferences.vala"
	if (active) {
#line 516 "plugin-preferences.c"
		{
#line 159 "plugin-preferences.vala"
			valide_plugin_registrar_load (pr, &_inner_error_);
#line 520 "plugin-preferences.c"
			if (_inner_error_ != NULL) {
				goto __catch29_g_error;
				goto __finally29;
			}
#line 160 "plugin-preferences.vala"
			gtk_list_store_set (list_store, &(*iter), VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE, TRUE, -1);
#line 527 "plugin-preferences.c"
		}
		goto __finally29;
		__catch29_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 164 "plugin-preferences.vala"
				g_debug (_ ("Could not activate %s : %s\n"), valide_plugin_registrar_get_name (pr), e->message);
#line 538 "plugin-preferences.c"
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally29:
		if (_inner_error_ != NULL) {
			(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
			(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return;
		}
	} else {
		{
#line 172 "plugin-preferences.vala"
			valide_plugin_registrar_unload (pr, &_inner_error_);
#line 554 "plugin-preferences.c"
			if (_inner_error_ != NULL) {
				goto __catch30_g_error;
				goto __finally30;
			}
#line 173 "plugin-preferences.vala"
			gtk_list_store_set (list_store, &(*iter), VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE, FALSE, -1);
#line 561 "plugin-preferences.c"
		}
		goto __finally30;
		__catch30_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 177 "plugin-preferences.vala"
				g_debug (_ ("Could not deactivate %s : %\n"), valide_plugin_registrar_get_name (pr), e->message);
#line 572 "plugin-preferences.c"
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally30:
		if (_inner_error_ != NULL) {
			(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
			(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return;
		}
	}
#line 88 "config-manager.vala"
	_tmp1_ = NULL;
#line 180 "plugin-preferences.vala"
	valide_abstract_config_manager_set_boolean ((ValideAbstractConfigManager*) (_tmp1_ = valide_config_manager_get_instance ()), "Plugins", valide_plugin_registrar_get_name (pr), active);
#line 589 "plugin-preferences.c"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL));
	(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
	(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
}


#line 183 "plugin-preferences.vala"
static void valide_plugin_preferences_toggle_active (ValidePluginPreferences* self, GtkTreeIter* iter, GtkTreeModel* model) {
#line 598 "plugin-preferences.c"
	gboolean active;
#line 183 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 183 "plugin-preferences.vala"
	g_return_if_fail (model != NULL);
#line 604 "plugin-preferences.c"
	active = FALSE;
#line 187 "plugin-preferences.vala"
	gtk_tree_model_get (model, &(*iter), VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE, &active, -1);
#line 189 "plugin-preferences.vala"
	active = !active;
#line 191 "plugin-preferences.vala"
	valide_plugin_preferences_set_active (self, &(*iter), model, active);
#line 612 "plugin-preferences.c"
}


#line 194 "plugin-preferences.vala"
static void valide_plugin_preferences_populate_lists (ValidePluginPreferences* self) {
#line 618 "plugin-preferences.c"
	GtkTreeIter iter = {0};
	GtkListStore* _tmp0_;
	GtkListStore* model;
#line 194 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 197 "plugin-preferences.vala"
	_tmp0_ = NULL;
#line 626 "plugin-preferences.c"
	model = (_tmp0_ = GTK_LIST_STORE (gtk_tree_view_get_model (self->priv->tree_view)), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 199 "plugin-preferences.vala"
	gtk_list_store_clear (model);
#line 630 "plugin-preferences.c"
	{
		GList* pr_collection;
		GList* pr_it;
#line 201 "plugin-preferences.vala"
		pr_collection = self->priv->_plugin_manager->plugins;
#line 636 "plugin-preferences.c"
		for (pr_it = pr_collection; pr_it != NULL; pr_it = pr_it->next) {
			ValidePluginRegistrar* _tmp1_;
			ValidePluginRegistrar* pr;
#line 39 "plugin-manager.vala"
			_tmp1_ = NULL;
#line 201 "plugin-preferences.vala"
			pr = (_tmp1_ = (ValidePluginRegistrar*) pr_it->data, (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
#line 644 "plugin-preferences.c"
			{
#line 203 "plugin-preferences.vala"
				gtk_list_store_append (model, &iter);
#line 204 "plugin-preferences.vala"
				gtk_list_store_set (model, &iter, VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE, valide_plugin_registrar_get_is_active (pr), VALIDE_PLUGIN_PREFERENCES_COL_INFO, pr, -1);
#line 650 "plugin-preferences.c"
				(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
			}
		}
	}
#line 208 "plugin-preferences.vala"
	if (gtk_tree_model_get_iter_first ((GtkTreeModel*) model, &iter)) {
#line 657 "plugin-preferences.c"
		ValidePluginRegistrar* pr;
		GtkTreeSelection* _tmp2_;
		GtkTreeSelection* selection;
		pr = NULL;
#line 211 "plugin-preferences.vala"
		_tmp2_ = NULL;
#line 664 "plugin-preferences.c"
		selection = (_tmp2_ = gtk_tree_view_get_selection (self->priv->tree_view), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
#line 212 "plugin-preferences.vala"
		g_return_if_fail (selection != NULL);
#line 214 "plugin-preferences.vala"
		gtk_tree_selection_select_iter (selection, &iter);
#line 216 "plugin-preferences.vala"
		gtk_tree_model_get ((GtkTreeModel*) model, &iter, VALIDE_PLUGIN_PREFERENCES_COL_INFO, &pr, -1);
#line 218 "plugin-preferences.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self->priv->configure_button, valide_plugin_registrar_get_is_configurable (pr));
#line 674 "plugin-preferences.c"
		(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
		(selection == NULL) ? NULL : (selection = (g_object_unref (selection), NULL));
	}
	(model == NULL) ? NULL : (model = (g_object_unref (model), NULL));
}


#line 222 "plugin-preferences.vala"
static void valide_plugin_preferences_about_activated (ValidePluginPreferences* self) {
#line 684 "plugin-preferences.c"
	ValidePluginRegistrar* pr;
#line 222 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 688 "plugin-preferences.c"
	pr = valide_plugin_preferences_get_selected_plugin (self);
#line 226 "plugin-preferences.vala"
	if (pr != NULL) {
#line 692 "plugin-preferences.c"
		GtkAboutDialog* dialog;
		dialog = g_object_ref_sink ((GtkAboutDialog*) gtk_about_dialog_new ());
		/*/ @fixme Problem with array properties
		dialog.authors = pr.authors;*/
#line 232 "plugin-preferences.vala"
		gtk_about_dialog_set_comments (dialog, valide_plugin_registrar_get_description (pr));
#line 233 "plugin-preferences.vala"
		gtk_about_dialog_set_program_name (dialog, valide_plugin_registrar_get_name (pr));
#line 234 "plugin-preferences.vala"
		gtk_about_dialog_set_website (dialog, valide_plugin_registrar_get_website (pr));
#line 235 "plugin-preferences.vala"
		gtk_about_dialog_set_copyright (dialog, valide_plugin_registrar_get_copyright (pr));
#line 237 "plugin-preferences.vala"
		gtk_dialog_run ((GtkDialog*) dialog);
#line 238 "plugin-preferences.vala"
		gtk_object_destroy ((GtkObject*) dialog);
#line 709 "plugin-preferences.c"
		(dialog == NULL) ? NULL : (dialog = (g_object_unref (dialog), NULL));
	}
	(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
}


#line 242 "plugin-preferences.vala"
static void valide_plugin_preferences_configure_activated (ValidePluginPreferences* self) {
#line 718 "plugin-preferences.c"
	ValidePluginRegistrar* pr;
#line 242 "plugin-preferences.vala"
	g_return_if_fail (self != NULL);
#line 722 "plugin-preferences.c"
	pr = valide_plugin_preferences_get_selected_plugin (self);
#line 246 "plugin-preferences.vala"
	if (pr != NULL) {
#line 248 "plugin-preferences.vala"
		if (valide_plugin_registrar_get_is_configurable (pr)) {
#line 250 "plugin-preferences.vala"
			valide_plugin_registrar_preferences (pr);
#line 730 "plugin-preferences.c"
		}
	}
	(pr == NULL) ? NULL : (pr = (g_object_unref (pr), NULL));
}


/**
   * Create a new Valide.PluginPreferences
   */
#line 258 "plugin-preferences.vala"
ValidePluginPreferences* valide_plugin_preferences_construct (GType object_type, ValidePluginManager* plugin_manager) {
#line 742 "plugin-preferences.c"
	GParameter * __params;
	GParameter * __params_it;
	ValidePluginPreferences * self;
#line 258 "plugin-preferences.vala"
	g_return_val_if_fail (plugin_manager != NULL, NULL);
#line 748 "plugin-preferences.c"
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 260 "plugin-preferences.vala"
	__params_it->name = "plugin-manager";
#line 260 "plugin-preferences.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_PLUGIN_MANAGER);
#line 260 "plugin-preferences.vala"
	g_value_set_object (&__params_it->value, plugin_manager);
#line 260 "plugin-preferences.vala"
	__params_it++;
#line 759 "plugin-preferences.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 258 "plugin-preferences.vala"
ValidePluginPreferences* valide_plugin_preferences_new (ValidePluginManager* plugin_manager) {
#line 258 "plugin-preferences.vala"
	return valide_plugin_preferences_construct (VALIDE_TYPE_PLUGIN_PREFERENCES, plugin_manager);
#line 774 "plugin-preferences.c"
}


ValidePluginManager* valide_plugin_preferences_get_plugin_manager (ValidePluginPreferences* self) {
	ValidePluginManager* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_plugin_manager;
	return result;
}


static void valide_plugin_preferences_set_plugin_manager (ValidePluginPreferences* self, ValidePluginManager* value) {
	ValidePluginManager* _tmp1_;
	ValidePluginManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 45 "plugin-preferences.vala"
	_tmp0_ = NULL;
#line 793 "plugin-preferences.c"
	self->priv->_plugin_manager = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_plugin_manager == NULL) ? NULL : (self->priv->_plugin_manager = (g_object_unref (self->priv->_plugin_manager), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "plugin-manager");
}


#line 63 "plugin-preferences.vala"
static void _valide_plugin_preferences_active_toggled_gtk_cell_renderer_toggle_toggled (GtkCellRendererToggle* _sender, const char* path, gpointer self) {
#line 801 "plugin-preferences.c"
	valide_plugin_preferences_active_toggled (self, _sender, path);
}


#line 79 "plugin-preferences.vala"
static void _valide_plugin_preferences_info_cell_gtk_cell_layout_data_func (GtkCellLayout* cell_layout, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer self) {
#line 808 "plugin-preferences.c"
	valide_plugin_preferences_info_cell (self, cell_layout, cell, tree_model, iter);
}


#line 94 "plugin-preferences.vala"
static gint _valide_plugin_preferences_model_name_sort_gtk_tree_iter_compare_func (GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer self) {
#line 815 "plugin-preferences.c"
	return valide_plugin_preferences_model_name_sort (self, model, a, b);
}


#line 100 "plugin-preferences.vala"
static gboolean _valide_plugin_preferences_name_search_gtk_tree_view_search_equal_func (GtkTreeModel* model, gint column, const char* key, GtkTreeIter* iter, gpointer self) {
#line 822 "plugin-preferences.c"
	return valide_plugin_preferences_name_search (model, column, key, iter);
}


#line 114 "plugin-preferences.vala"
static void _valide_plugin_preferences_cursor_changed_gtk_tree_view_cursor_changed (GtkTreeView* _sender, gpointer self) {
#line 829 "plugin-preferences.c"
	valide_plugin_preferences_cursor_changed (self, _sender);
}


#line 125 "plugin-preferences.vala"
static void _valide_plugin_preferences_row_activated_gtk_tree_view_row_activated (GtkTreeView* _sender, const GtkTreePath* path, GtkTreeViewColumn* column, gpointer self) {
#line 836 "plugin-preferences.c"
	valide_plugin_preferences_row_activated (self, _sender, path, column);
}


#line 137 "plugin-preferences.vala"
static gboolean _valide_plugin_preferences_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender, const GdkEventButton* event, gpointer self) {
#line 843 "plugin-preferences.c"
	return valide_plugin_preferences_button_press_event (self, _sender, event);
}


#line 142 "plugin-preferences.vala"
static gboolean _valide_plugin_preferences_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender, gpointer self) {
#line 850 "plugin-preferences.c"
	return valide_plugin_preferences_popup_menu (self, _sender);
}


#line 222 "plugin-preferences.vala"
static void _valide_plugin_preferences_about_activated_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 857 "plugin-preferences.c"
	valide_plugin_preferences_about_activated (self);
}


#line 242 "plugin-preferences.vala"
static void _valide_plugin_preferences_configure_activated_gtk_button_clicked (GtkButton* _sender, gpointer self) {
#line 864 "plugin-preferences.c"
	valide_plugin_preferences_configure_activated (self);
}


static GObject * valide_plugin_preferences_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValidePluginPreferencesClass * klass;
	GObjectClass * parent_class;
	ValidePluginPreferences * self;
	klass = VALIDE_PLUGIN_PREFERENCES_CLASS (g_type_class_peek (VALIDE_TYPE_PLUGIN_PREFERENCES));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_PLUGIN_PREFERENCES (obj);
	{
		GtkScrolledWindow* scrolled;
		GtkTreeView* _tmp0_;
		GtkListStore* list_store;
		GtkCellRendererToggle* cell_toggle;
		GtkTreeViewColumn* column;
		GtkTreeViewColumn* _tmp1_;
		GtkCellRendererText* cell_text;
		GtkHButtonBox* button_box;
		GtkButton* _tmp2_;
		GtkButton* _tmp3_;
		/* create and pack tree view */
		scrolled = g_object_ref_sink ((GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL));
#line 267 "plugin-preferences.vala"
		gtk_scrolled_window_set_policy (scrolled, GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
#line 268 "plugin-preferences.vala"
		gtk_scrolled_window_set_shadow_type (scrolled, GTK_SHADOW_IN);
#line 269 "plugin-preferences.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) scrolled, TRUE, TRUE, (guint) 0);
#line 897 "plugin-preferences.c"
		_tmp0_ = NULL;
#line 271 "plugin-preferences.vala"
		self->priv->tree_view = (_tmp0_ = g_object_ref_sink ((GtkTreeView*) gtk_tree_view_new ()), (self->priv->tree_view == NULL) ? NULL : (self->priv->tree_view = (g_object_unref (self->priv->tree_view), NULL)), _tmp0_);
#line 272 "plugin-preferences.vala"
		gtk_tree_view_set_rules_hint (self->priv->tree_view, TRUE);
#line 273 "plugin-preferences.vala"
		gtk_tree_view_set_headers_visible (self->priv->tree_view, TRUE);
#line 274 "plugin-preferences.vala"
		gtk_tree_view_set_headers_clickable (self->priv->tree_view, TRUE);
#line 275 "plugin-preferences.vala"
		gtk_container_add ((GtkContainer*) scrolled, (GtkWidget*) self->priv->tree_view);
#line 909 "plugin-preferences.c"
		list_store = gtk_list_store_new ((gint) VALIDE_PLUGIN_PREFERENCES_COL_NB, G_TYPE_BOOLEAN, VALIDE_TYPE_PLUGIN_REGISTRAR, NULL);
#line 279 "plugin-preferences.vala"
		gtk_tree_view_set_model (self->priv->tree_view, (GtkTreeModel*) list_store);
#line 913 "plugin-preferences.c"
		/* first column */
		cell_toggle = g_object_ref_sink ((GtkCellRendererToggle*) gtk_cell_renderer_toggle_new ());
#line 283 "plugin-preferences.vala"
		g_signal_connect_object (cell_toggle, "toggled", (GCallback) _valide_plugin_preferences_active_toggled_gtk_cell_renderer_toggle_toggled, self, 0);
#line 918 "plugin-preferences.c"
		column = g_object_ref_sink (gtk_tree_view_column_new_with_attributes (_ ("Enable"), (GtkCellRenderer*) cell_toggle, "active", VALIDE_PLUGIN_PREFERENCES_COL_ACTIVE, NULL));
#line 286 "plugin-preferences.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 922 "plugin-preferences.c"
		/* second column */
		_tmp1_ = NULL;
#line 289 "plugin-preferences.vala"
		column = (_tmp1_ = g_object_ref_sink (gtk_tree_view_column_new ()), (column == NULL) ? NULL : (column = (g_object_unref (column), NULL)), _tmp1_);
#line 290 "plugin-preferences.vala"
		gtk_tree_view_column_set_title (column, _ ("Plugin"));
#line 291 "plugin-preferences.vala"
		gtk_tree_view_column_set_resizable (column, TRUE);
#line 931 "plugin-preferences.c"
		cell_text = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ());
#line 294 "plugin-preferences.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) column, (GtkCellRenderer*) cell_text, TRUE);
#line 295 "plugin-preferences.vala"
		g_object_set (cell_text, "ellipsize", PANGO_ELLIPSIZE_END, NULL);
#line 296 "plugin-preferences.vala"
		gtk_cell_layout_set_cell_data_func ((GtkCellLayout*) column, (GtkCellRenderer*) cell_text, _valide_plugin_preferences_info_cell_gtk_cell_layout_data_func, g_object_ref (self), g_object_unref);
#line 298 "plugin-preferences.vala"
		gtk_tree_view_column_set_spacing (column, 6);
#line 299 "plugin-preferences.vala"
		gtk_tree_view_append_column (self->priv->tree_view, column);
#line 943 "plugin-preferences.c"
		/* Sort on the plugin names */
#line 302 "plugin-preferences.vala"
		gtk_tree_sortable_set_default_sort_func ((GtkTreeSortable*) list_store, _valide_plugin_preferences_model_name_sort_gtk_tree_iter_compare_func, g_object_ref (self), g_object_unref);
#line 947 "plugin-preferences.c"
		/* -1 == GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID */
#line 304 "plugin-preferences.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) list_store, -1, GTK_SORT_ASCENDING);
#line 951 "plugin-preferences.c"
		/* Enable search for our non-string column */
#line 307 "plugin-preferences.vala"
		gtk_tree_view_set_search_column (self->priv->tree_view, (gint) VALIDE_PLUGIN_PREFERENCES_COL_INFO);
#line 308 "plugin-preferences.vala"
		gtk_tree_view_set_search_equal_func (self->priv->tree_view, _valide_plugin_preferences_name_search_gtk_tree_view_search_equal_func, NULL, NULL);
#line 310 "plugin-preferences.vala"
		g_signal_connect_object (self->priv->tree_view, "cursor-changed", (GCallback) _valide_plugin_preferences_cursor_changed_gtk_tree_view_cursor_changed, self, 0);
#line 311 "plugin-preferences.vala"
		g_signal_connect_object (self->priv->tree_view, "row-activated", (GCallback) _valide_plugin_preferences_row_activated_gtk_tree_view_row_activated, self, 0);
#line 312 "plugin-preferences.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->tree_view, "button-press-event", (GCallback) _valide_plugin_preferences_button_press_event_gtk_widget_button_press_event, self, 0);
#line 313 "plugin-preferences.vala"
		g_signal_connect_object ((GtkWidget*) self->priv->tree_view, "popup-menu", (GCallback) _valide_plugin_preferences_popup_menu_gtk_widget_popup_menu, self, 0);
#line 965 "plugin-preferences.c"
		button_box = g_object_ref_sink ((GtkHButtonBox*) gtk_hbutton_box_new ());
#line 316 "plugin-preferences.vala"
		gtk_button_box_set_layout ((GtkButtonBox*) button_box, GTK_BUTTONBOX_END);
#line 969 "plugin-preferences.c"
		_tmp2_ = NULL;
#line 317 "plugin-preferences.vala"
		self->priv->about_button = (_tmp2_ = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock (GTK_STOCK_ABOUT)), (self->priv->about_button == NULL) ? NULL : (self->priv->about_button = (g_object_unref (self->priv->about_button), NULL)), _tmp2_);
#line 318 "plugin-preferences.vala"
		gtk_box_pack_start ((GtkBox*) button_box, (GtkWidget*) self->priv->about_button, FALSE, FALSE, (guint) 0);
#line 319 "plugin-preferences.vala"
		g_signal_connect_object (self->priv->about_button, "clicked", (GCallback) _valide_plugin_preferences_about_activated_gtk_button_clicked, self, 0);
#line 977 "plugin-preferences.c"
		_tmp3_ = NULL;
#line 320 "plugin-preferences.vala"
		self->priv->configure_button = (_tmp3_ = g_object_ref_sink ((GtkButton*) gtk_button_new_from_stock (GTK_STOCK_PREFERENCES)), (self->priv->configure_button == NULL) ? NULL : (self->priv->configure_button = (g_object_unref (self->priv->configure_button), NULL)), _tmp3_);
#line 321 "plugin-preferences.vala"
		gtk_box_pack_start ((GtkBox*) button_box, (GtkWidget*) self->priv->configure_button, FALSE, FALSE, (guint) 0);
#line 322 "plugin-preferences.vala"
		g_signal_connect_object (self->priv->configure_button, "clicked", (GCallback) _valide_plugin_preferences_configure_activated_gtk_button_clicked, self, 0);
#line 324 "plugin-preferences.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) button_box, FALSE, TRUE, (guint) 0);
#line 326 "plugin-preferences.vala"
		if (self->priv->_plugin_manager->plugins != NULL) {
#line 328 "plugin-preferences.vala"
			valide_plugin_preferences_populate_lists (self);
#line 991 "plugin-preferences.c"
		} else {
#line 332 "plugin-preferences.vala"
			gtk_widget_set_sensitive ((GtkWidget*) self->priv->about_button, FALSE);
#line 333 "plugin-preferences.vala"
			gtk_widget_set_sensitive ((GtkWidget*) self->priv->configure_button, FALSE);
#line 997 "plugin-preferences.c"
		}
		(scrolled == NULL) ? NULL : (scrolled = (g_object_unref (scrolled), NULL));
		(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
		(cell_toggle == NULL) ? NULL : (cell_toggle = (g_object_unref (cell_toggle), NULL));
		(column == NULL) ? NULL : (column = (g_object_unref (column), NULL));
		(cell_text == NULL) ? NULL : (cell_text = (g_object_unref (cell_text), NULL));
		(button_box == NULL) ? NULL : (button_box = (g_object_unref (button_box), NULL));
	}
	return obj;
}


static void valide_plugin_preferences_class_init (ValidePluginPreferencesClass * klass) {
	valide_plugin_preferences_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValidePluginPreferencesPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_plugin_preferences_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_plugin_preferences_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_plugin_preferences_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_plugin_preferences_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_PLUGIN_PREFERENCES_PLUGIN_MANAGER, g_param_spec_object ("plugin-manager", "plugin-manager", "plugin-manager", VALIDE_TYPE_PLUGIN_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valide_plugin_preferences_instance_init (ValidePluginPreferences * self) {
	self->priv = VALIDE_PLUGIN_PREFERENCES_GET_PRIVATE (self);
}


static void valide_plugin_preferences_finalize (GObject* obj) {
	ValidePluginPreferences * self;
	self = VALIDE_PLUGIN_PREFERENCES (obj);
	(self->priv->tree_view == NULL) ? NULL : (self->priv->tree_view = (g_object_unref (self->priv->tree_view), NULL));
	(self->priv->about_button == NULL) ? NULL : (self->priv->about_button = (g_object_unref (self->priv->about_button), NULL));
	(self->priv->configure_button == NULL) ? NULL : (self->priv->configure_button = (g_object_unref (self->priv->configure_button), NULL));
	(self->priv->_plugin_manager == NULL) ? NULL : (self->priv->_plugin_manager = (g_object_unref (self->priv->_plugin_manager), NULL));
	G_OBJECT_CLASS (valide_plugin_preferences_parent_class)->finalize (obj);
}


GType valide_plugin_preferences_get_type (void) {
	static GType valide_plugin_preferences_type_id = 0;
	if (valide_plugin_preferences_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValidePluginPreferencesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_plugin_preferences_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValidePluginPreferences), 0, (GInstanceInitFunc) valide_plugin_preferences_instance_init, NULL };
		valide_plugin_preferences_type_id = g_type_register_static (GTK_TYPE_VBOX, "ValidePluginPreferences", &g_define_type_info, 0);
	}
	return valide_plugin_preferences_type_id;
}


static void valide_plugin_preferences_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValidePluginPreferences * self;
	gpointer boxed;
	self = VALIDE_PLUGIN_PREFERENCES (object);
	switch (property_id) {
		case VALIDE_PLUGIN_PREFERENCES_PLUGIN_MANAGER:
		g_value_set_object (value, valide_plugin_preferences_get_plugin_manager (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_plugin_preferences_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValidePluginPreferences * self;
	self = VALIDE_PLUGIN_PREFERENCES (object);
	switch (property_id) {
		case VALIDE_PLUGIN_PREFERENCES_PLUGIN_MANAGER:
		valide_plugin_preferences_set_plugin_manager (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




