/* project-dialog-options.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <config.h>
#include <glib/gi18n-lib.h>


#define VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS (valide_abstract_project_dialog_options_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS, ValideAbstractProjectDialogOptions))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS, ValideAbstractProjectDialogOptionsClass))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS))
#define VALIDE_IS_ABSTRACT_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS, ValideAbstractProjectDialogOptionsClass))

typedef struct _ValideAbstractProjectDialogOptions ValideAbstractProjectDialogOptions;
typedef struct _ValideAbstractProjectDialogOptionsClass ValideAbstractProjectDialogOptionsClass;
typedef struct _ValideAbstractProjectDialogOptionsPrivate ValideAbstractProjectDialogOptionsPrivate;

#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS (valide_abstract_project_dialog_options_window_widgets_get_type ())
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogOptionswindow_widgets))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogOptionswindow_widgetsClass))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_IS_WINDOW_WIDGETS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_IS_WINDOW_WIDGETS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS))
#define VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_WINDOW_WIDGETS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_ABSTRACT_PROJECT_DIALOG_OPTIONS_TYPE_WINDOW_WIDGETS, ValideAbstractProjectDialogOptionswindow_widgetsClass))

typedef struct _ValideAbstractProjectDialogOptionswindow_widgets ValideAbstractProjectDialogOptionswindow_widgets;
typedef struct _ValideAbstractProjectDialogOptionswindow_widgetsClass ValideAbstractProjectDialogOptionswindow_widgetsClass;

#define VALIDE_TYPE_PROJECT_DIALOG_OPTIONS (valide_project_dialog_options_get_type ())
#define VALIDE_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptions))
#define VALIDE_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptionsClass))
#define VALIDE_IS_PROJECT_DIALOG_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS))
#define VALIDE_IS_PROJECT_DIALOG_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS))
#define VALIDE_PROJECT_DIALOG_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptionsClass))

typedef struct _ValideProjectDialogOptions ValideProjectDialogOptions;
typedef struct _ValideProjectDialogOptionsClass ValideProjectDialogOptionsClass;
typedef struct _ValideProjectDialogOptionsPrivate ValideProjectDialogOptionsPrivate;

#define VALIDE_TYPE_PROJECT (valide_project_get_type ())
#define VALIDE_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT, ValideProject))
#define VALIDE_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT, ValideProjectClass))
#define VALIDE_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT))
#define VALIDE_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT))
#define VALIDE_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT, ValideProjectClass))

typedef struct _ValideProject ValideProject;
typedef struct _ValideProjectClass ValideProjectClass;
typedef struct _ValideAbstractProjectDialogOptionswindow_widgetsPrivate ValideAbstractProjectDialogOptionswindow_widgetsPrivate;

#define VALIDE_TYPE_BUILDER (valide_builder_get_type ())
#define VALIDE_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER, ValideBuilder))
#define VALIDE_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER))
#define VALIDE_BUILDER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER, ValideBuilderIface))

typedef struct _ValideBuilder ValideBuilder;
typedef struct _ValideBuilderIface ValideBuilderIface;

#define VALIDE_TYPE_EXECUTABLE_MANAGER (valide_executable_manager_get_type ())
#define VALIDE_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManager))
#define VALIDE_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))
#define VALIDE_IS_EXECUTABLE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_IS_EXECUTABLE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_EXECUTABLE_MANAGER))
#define VALIDE_EXECUTABLE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_EXECUTABLE_MANAGER, ValideExecutableManagerClass))

typedef struct _ValideExecutableManager ValideExecutableManager;
typedef struct _ValideExecutableManagerClass ValideExecutableManagerClass;

#define G_YAML_TYPE_BUILDABLE (g_yaml_buildable_get_type ())
#define G_YAML_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildable))
#define G_YAML_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDABLE))
#define G_YAML_BUILDABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildableIface))

typedef struct _GYAMLBuildable GYAMLBuildable;
typedef struct _GYAMLBuildableIface GYAMLBuildableIface;

#define G_YAML_TYPE_BUILDER (g_yaml_builder_get_type ())
#define G_YAML_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilder))
#define G_YAML_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))
#define G_YAML_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDER))
#define G_YAML_IS_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_BUILDER))
#define G_YAML_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))

typedef struct _GYAMLBuilder GYAMLBuilder;
typedef struct _GYAMLBuilderClass GYAMLBuilderClass;

#define G_YAML_TYPE_NODE (g_yaml_node_get_type ())
#define G_YAML_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_NODE, GYAMLNode))
#define G_YAML_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_NODE, GYAMLNodeClass))
#define G_YAML_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_NODE))
#define G_YAML_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_NODE))
#define G_YAML_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_NODE, GYAMLNodeClass))

typedef struct _GYAMLNode GYAMLNode;
typedef struct _GYAMLNodeClass GYAMLNodeClass;
typedef struct _ValideProjectPrivate ValideProjectPrivate;

#define VALIDE_TYPE_BUILDER_MANAGER (valide_builder_manager_get_type ())
#define VALIDE_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManager))
#define VALIDE_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))
#define VALIDE_IS_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_IS_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_BUILDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))

typedef struct _ValideBuilderManager ValideBuilderManager;
typedef struct _ValideBuilderManagerClass ValideBuilderManagerClass;

#define VALIDE_TYPE_SOURCE (valide_source_get_type ())
#define VALIDE_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE, ValideSource))
#define VALIDE_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE, ValideSourceClass))
#define VALIDE_IS_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE))
#define VALIDE_IS_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE))
#define VALIDE_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE, ValideSourceClass))

typedef struct _ValideSource ValideSource;
typedef struct _ValideSourceClass ValideSourceClass;

#define VALIDE_TYPE_PACKAGE (valide_package_get_type ())
#define VALIDE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PACKAGE, ValidePackage))
#define VALIDE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PACKAGE, ValidePackageClass))
#define VALIDE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PACKAGE))
#define VALIDE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PACKAGE))
#define VALIDE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PACKAGE, ValidePackageClass))

typedef struct _ValidePackage ValidePackage;
typedef struct _ValidePackageClass ValidePackageClass;

#define VALIDE_TYPE_VAPI_DIR (valide_vapi_dir_get_type ())
#define VALIDE_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDir))
#define VALIDE_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))
#define VALIDE_IS_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_IS_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_VAPI_DIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))

typedef struct _ValideVapiDir ValideVapiDir;
typedef struct _ValideVapiDirClass ValideVapiDirClass;

#define VALIDE_TYPE_BUILDER_OPTIONS (valide_builder_options_get_type ())
#define VALIDE_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptions))
#define VALIDE_IS_BUILDER_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_OPTIONS))
#define VALIDE_BUILDER_OPTIONS_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_BUILDER_OPTIONS, ValideBuilderOptionsIface))

typedef struct _ValideBuilderOptions ValideBuilderOptions;
typedef struct _ValideBuilderOptionsIface ValideBuilderOptionsIface;

struct _ValideAbstractProjectDialogOptions {
	GtkObject parent_instance;
	ValideAbstractProjectDialogOptionsPrivate * priv;
	char* name_space;
	GtkBuilder* xml;
	ValideAbstractProjectDialogOptionswindow_widgets* widgets;
};

struct _ValideAbstractProjectDialogOptionsClass {
	GtkObjectClass parent_class;
};

/**
 * A dialog box widget for show/edit the option of a project
 */
struct _ValideProjectDialogOptions {
	ValideAbstractProjectDialogOptions parent_instance;
	ValideProjectDialogOptionsPrivate * priv;
};

struct _ValideProjectDialogOptionsClass {
	ValideAbstractProjectDialogOptionsClass parent_class;
};

struct _ValideProjectDialogOptionsPrivate {
	ValideProject* _project;
};

struct _ValideAbstractProjectDialogOptionswindow_widgets {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValideAbstractProjectDialogOptionswindow_widgetsPrivate * priv;
	GtkListStore* liststore1;
	GtkDialog* dialog;
	GtkVBox* dialog_vbox;
	GtkHBox* hbox;
	GtkScrolledWindow* scrolled_window;
	GtkIconView* icon_view;
	GtkNotebook* notebook;
	GtkTable* table1;
	GtkLabel* label7;
	GtkLabel* label8;
	GtkLabel* label9;
	GtkLabel* label10;
	GtkLabel* path;
	GtkEntry* name;
	GtkEntry* author;
	GtkEntry* version;
	GtkLabel* label11;
	GtkLabel* license;
	GtkLabel* label1;
	GtkComboBox* builder;
	GtkHButtonBox* dialog_action_area1;
	GtkButton* button1;
};

struct _ValideAbstractProjectDialogOptionswindow_widgetsClass {
	GTypeClass parent_class;
	void (*finalize) (ValideAbstractProjectDialogOptionswindow_widgets *self);
};

/**
 * This instance use to create a new builder
 *
 * [[warning:
 *   You should register builder with BuilderManager.register_builder function.
 * ]]
 */
struct _ValideBuilderIface {
	GTypeInterface parent_iface;
	void (*configure) (ValideBuilder* self);
	void (*build) (ValideBuilder* self);
	void (*install) (ValideBuilder* self);
	void (*dist) (ValideBuilder* self);
	void (*clean) (ValideBuilder* self);
	void (*distclean) (ValideBuilder* self);
	void (*uninstall) (ValideBuilder* self);
	GtkWidget* (*preferences) (ValideBuilder* self);
	ValideProject* (*get_project) (ValideBuilder* self);
	void (*set_project) (ValideBuilder* self, ValideProject* value);
	ValideExecutableManager* (*get_executables) (ValideBuilder* self);
	void (*set_executables) (ValideBuilder* self, ValideExecutableManager* value);
};

/**
 * Buildable GObjects, from YAML.
 *
 *
 * Objects that implements GLib.YAML.Buildable is buildable by
 * GLib.YAML.Builder.
 *
 * This interface is almost the same as GtkBuildable.
 *
 **/
struct _GYAMLBuildableIface {
	GTypeInterface parent_iface;
	const char* (*get_name) (GYAMLBuildable* self);
	void (*set_name) (GYAMLBuildable* self, const char* name);
	void (*add_child) (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
	char** (*get_child_tags) (GYAMLBuildable* self, int* result_length1);
	GType* (*get_child_types) (GYAMLBuildable* self, int* result_length1);
	GList* (*get_children) (GYAMLBuildable* self, const char* type);
	GObject* (*get_internal_child) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
	void (*custom_node) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
};

/**
 * A class for project
 */
struct _ValideProject {
	GObject parent_instance;
	ValideProjectPrivate * priv;
	char* filename;
	ValideBuilderManager* builders;
	GList* files;
	GList* packages;
	GList* vapi_dir;
};

struct _ValideProjectClass {
	GObjectClass parent_class;
};

typedef enum  {
	VALIDE_BUILDER_ERROR_NOT_FOUND
} ValideBuilderError;
#define VALIDE_BUILDER_ERROR valide_builder_error_quark ()
struct _ValideBuilderOptionsIface {
	GTypeInterface parent_iface;
};


static gpointer valide_project_dialog_options_parent_class = NULL;

GType valide_abstract_project_dialog_options_get_type (void);
gpointer valide_abstract_project_dialog_options_window_widgets_ref (gpointer instance);
void valide_abstract_project_dialog_options_window_widgets_unref (gpointer instance);
GParamSpec* valide_abstract_project_dialog_options_param_spec_window_widgets (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valide_abstract_project_dialog_options_value_set_window_widgets (GValue* value, gpointer v_object);
gpointer valide_abstract_project_dialog_options_value_get_window_widgets (const GValue* value);
GType valide_abstract_project_dialog_options_window_widgets_get_type (void);
GType valide_project_dialog_options_get_type (void);
GType valide_project_get_type (void);
#define VALIDE_PROJECT_DIALOG_OPTIONS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, ValideProjectDialogOptionsPrivate))
enum  {
	VALIDE_PROJECT_DIALOG_OPTIONS_DUMMY_PROPERTY,
	VALIDE_PROJECT_DIALOG_OPTIONS_PROJECT
};
static void valide_project_dialog_options_set_project (ValideProjectDialogOptions* self, ValideProject* value);
ValideProjectDialogOptions* valide_project_dialog_options_new (ValideProject* project, GtkWindow* parent);
ValideProjectDialogOptions* valide_project_dialog_options_construct (GType object_type, ValideProject* project, GtkWindow* parent);
gint valide_project_dialog_options_run (ValideProjectDialogOptions* self);
void valide_project_dialog_options_destroy (ValideProjectDialogOptions* self);
ValideProject* valide_project_dialog_options_get_project (ValideProjectDialogOptions* self);
GType valide_executable_manager_get_type (void);
GType valide_builder_get_type (void);
GType g_yaml_builder_get_type (void);
gpointer g_yaml_node_ref (gpointer instance);
void g_yaml_node_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_node (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_node (const GValue* value);
GType g_yaml_node_get_type (void);
GType g_yaml_buildable_get_type (void);
GType valide_builder_manager_get_type (void);
GType valide_source_get_type (void);
GType valide_package_get_type (void);
GType valide_vapi_dir_get_type (void);
GQuark valide_builder_error_quark (void);
ValideBuilder* valide_builder_manager_create_builder (ValideBuilderManager* self, ValideProject* project, GError** error);
GtkWidget* valide_builder_preferences (ValideBuilder* self);
GtkWidget* valide_executable_preferences (ValideProject* project);
static void _lambda49_ (GtkIconView* s, ValideProjectDialogOptions* self);
static void __lambda49__gtk_icon_view_selection_changed (GtkIconView* _sender, gpointer self);
const char* valide_project_get_path (ValideProject* self);
const char* valide_project_get_name (ValideProject* self);
void valide_project_set_name (ValideProject* self, const char* value);
void valide_project_save (ValideProject* self);
static void _lambda50_ (GtkEditable* s, ValideProjectDialogOptions* self);
static void __lambda50__gtk_editable_changed (GtkEditable* _sender, gpointer self);
const char* valide_project_get_author (ValideProject* self);
void valide_project_set_author (ValideProject* self, const char* value);
static void _lambda51_ (GtkEditable* s, ValideProjectDialogOptions* self);
static void __lambda51__gtk_editable_changed (GtkEditable* _sender, gpointer self);
const char* valide_project_get_version (ValideProject* self);
void valide_project_set_version (ValideProject* self, const char* value);
static void _lambda52_ (GtkEditable* s, ValideProjectDialogOptions* self);
static void __lambda52__gtk_editable_changed (GtkEditable* _sender, gpointer self);
const char* valide_project_get_license (ValideProject* self);
ValideBuilderManager* valide_builder_manager_get_instance (void);
GList* valide_builder_manager_get_builders (ValideBuilderManager* self);
const char* valide_project_get_builder (ValideProject* self);
void valide_project_set_builder (ValideProject* self, const char* value);
GType valide_builder_options_get_type (void);
void valide_project_set_builder_options (ValideProject* self, ValideBuilderOptions* value);
static void _lambda53_ (GtkComboBox* s, ValideProjectDialogOptions* self);
static void __lambda53__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self);
void valide_abstract_project_dialog_options_connect_signals (ValideAbstractProjectDialogOptions* self, const char* name_space);
static GObject * valide_project_dialog_options_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_project_dialog_options_finalize (GObject* obj);
static void valide_project_dialog_options_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_project_dialog_options_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static int _vala_strcmp0 (const char * str1, const char * str2);



/**
   * Create a new Valide.ProjectDialogOption
   *
   * @param project The attached project
   * @param parent The parent window
   */
#line 42 "project-dialog-options.vala"
ValideProjectDialogOptions* valide_project_dialog_options_construct (GType object_type, ValideProject* project, GtkWindow* parent) {
#line 385 "project-dialog-options.c"
	GParameter * __params;
	GParameter * __params_it;
	ValideProjectDialogOptions * self;
#line 42 "project-dialog-options.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 42 "project-dialog-options.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 393 "project-dialog-options.c"
	__params = g_new0 (GParameter, 1);
	__params_it = __params;
#line 44 "project-dialog-options.vala"
	__params_it->name = "project";
#line 44 "project-dialog-options.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_PROJECT);
#line 44 "project-dialog-options.vala"
	g_value_set_object (&__params_it->value, project);
#line 44 "project-dialog-options.vala"
	__params_it++;
#line 404 "project-dialog-options.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
#line 45 "project-dialog-options.vala"
	gtk_window_set_transient_for ((GtkWindow*) ((ValideAbstractProjectDialogOptions*) self)->widgets->dialog, parent);
#line 408 "project-dialog-options.c"
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 42 "project-dialog-options.vala"
ValideProjectDialogOptions* valide_project_dialog_options_new (ValideProject* project, GtkWindow* parent) {
#line 42 "project-dialog-options.vala"
	return valide_project_dialog_options_construct (VALIDE_TYPE_PROJECT_DIALOG_OPTIONS, project, parent);
#line 422 "project-dialog-options.c"
}


/**
   * @see Gtk.Dialog.run
   */
#line 192 "project-dialog-options.vala"
gint valide_project_dialog_options_run (ValideProjectDialogOptions* self) {
#line 431 "project-dialog-options.c"
	gint result;
#line 192 "project-dialog-options.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 194 "project-dialog-options.vala"
	gtk_widget_show_all ((GtkWidget*) ((ValideAbstractProjectDialogOptions*) self)->widgets->dialog);
#line 437 "project-dialog-options.c"
	result = gtk_dialog_run (((ValideAbstractProjectDialogOptions*) self)->widgets->dialog);
	return result;
}


/**
   * @see Gtk.Object.destroy
   */
#line 201 "project-dialog-options.vala"
void valide_project_dialog_options_destroy (ValideProjectDialogOptions* self) {
#line 201 "project-dialog-options.vala"
	g_return_if_fail (self != NULL);
#line 203 "project-dialog-options.vala"
	gtk_object_destroy ((GtkObject*) ((ValideAbstractProjectDialogOptions*) self)->widgets->dialog);
#line 452 "project-dialog-options.c"
}


ValideProject* valide_project_dialog_options_get_project (ValideProjectDialogOptions* self) {
	ValideProject* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_project;
	return result;
}


static void valide_project_dialog_options_set_project (ValideProjectDialogOptions* self, ValideProject* value) {
	ValideProject* _tmp1_;
	ValideProject* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 33 "project-dialog-options.vala"
	_tmp0_ = NULL;
#line 471 "project-dialog-options.c"
	self->priv->_project = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "project");
}


static void _lambda49_ (GtkIconView* s, ValideProjectDialogOptions* self) {
	GList* tabs;
	g_return_if_fail (s != NULL);
	tabs = NULL;
#line 106 "project-dialog-options.vala"
	tabs = gtk_icon_view_get_selected_items (s);
#line 107 "project-dialog-options.vala"
	if (tabs != NULL) {
#line 485 "project-dialog-options.c"
		gint index;
		GtkTreeIter iter2 = {0};
		index = 0;
#line 112 "project-dialog-options.vala"
		gtk_tree_model_get_iter (gtk_icon_view_get_model (s), &iter2, (const GtkTreePath*) tabs->data);
#line 113 "project-dialog-options.vala"
		gtk_tree_model_get (gtk_icon_view_get_model (s), &iter2, 2, &index, -1, -1);
#line 114 "project-dialog-options.vala"
		gtk_notebook_set_current_page (((ValideAbstractProjectDialogOptions*) self)->widgets->notebook, index);
#line 495 "project-dialog-options.c"
	}
}


static void __lambda49__gtk_icon_view_selection_changed (GtkIconView* _sender, gpointer self) {
	_lambda49_ (_sender, self);
}


static void _lambda50_ (GtkEditable* s, ValideProjectDialogOptions* self) {
	GtkEditable* _tmp0_;
	g_return_if_fail (s != NULL);
#line 124 "project-dialog-options.vala"
	_tmp0_ = NULL;
#line 124 "project-dialog-options.vala"
	valide_project_set_name (self->priv->_project, gtk_entry_get_text ((_tmp0_ = s, GTK_IS_ENTRY (_tmp0_) ? ((GtkEntry*) _tmp0_) : NULL)));
#line 125 "project-dialog-options.vala"
	valide_project_save (self->priv->_project);
#line 514 "project-dialog-options.c"
}


static void __lambda50__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	_lambda50_ (_sender, self);
}


static void _lambda51_ (GtkEditable* s, ValideProjectDialogOptions* self) {
	GtkEditable* _tmp0_;
	g_return_if_fail (s != NULL);
#line 130 "project-dialog-options.vala"
	_tmp0_ = NULL;
#line 130 "project-dialog-options.vala"
	valide_project_set_author (self->priv->_project, gtk_entry_get_text ((_tmp0_ = s, GTK_IS_ENTRY (_tmp0_) ? ((GtkEntry*) _tmp0_) : NULL)));
#line 131 "project-dialog-options.vala"
	valide_project_save (self->priv->_project);
#line 532 "project-dialog-options.c"
}


static void __lambda51__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	_lambda51_ (_sender, self);
}


static void _lambda52_ (GtkEditable* s, ValideProjectDialogOptions* self) {
	GtkEditable* _tmp0_;
	g_return_if_fail (s != NULL);
#line 136 "project-dialog-options.vala"
	_tmp0_ = NULL;
#line 136 "project-dialog-options.vala"
	valide_project_set_version (self->priv->_project, gtk_entry_get_text ((_tmp0_ = s, GTK_IS_ENTRY (_tmp0_) ? ((GtkEntry*) _tmp0_) : NULL)));
#line 137 "project-dialog-options.vala"
	valide_project_save (self->priv->_project);
#line 550 "project-dialog-options.c"
}


static void __lambda52__gtk_editable_changed (GtkEditable* _sender, gpointer self) {
	_lambda52_ (_sender, self);
}


static void _lambda53_ (GtkComboBox* s, ValideProjectDialogOptions* self) {
	GError * _inner_error_;
	GtkTreeIter it = {0};
	g_return_if_fail (s != NULL);
	_inner_error_ = NULL;
#line 158 "project-dialog-options.vala"
	if (gtk_combo_box_get_active_iter (s, &it)) {
#line 566 "project-dialog-options.c"
		char* b;
		GType type;
		ValideBuilder* builder;
		char* _tmp1_;
		char* _tmp0_;
		b = NULL;
		type = 0UL;
		builder = NULL;
#line 164 "project-dialog-options.vala"
		gtk_tree_model_get (gtk_combo_box_get_model (s), &it, 0, &b, -1);
#line 577 "project-dialog-options.c"
		_tmp1_ = NULL;
		_tmp0_ = NULL;
#line 165 "project-dialog-options.vala"
		type = g_type_from_name (_tmp1_ = g_strconcat (_tmp0_ = g_strconcat ("Valide", b, NULL), "BuilderOptions", NULL));
#line 582 "project-dialog-options.c"
		_tmp1_ = (g_free (_tmp1_), NULL);
		_tmp0_ = (g_free (_tmp0_), NULL);
#line 166 "project-dialog-options.vala"
		if (type != 0) {
#line 587 "project-dialog-options.c"
			ValideBuilderOptions* _tmp3_;
			GObject* _tmp2_;
			ValideBuilder* _tmp4_;
			ValideBuilder* _tmp5_;
			GtkWidget* _tmp6_;
#line 168 "project-dialog-options.vala"
			valide_project_set_builder (self->priv->_project, b);
#line 595 "project-dialog-options.c"
			/* Replace options */
#line 170 "project-dialog-options.vala"
			_tmp3_ = NULL;
#line 170 "project-dialog-options.vala"
			_tmp2_ = NULL;
#line 170 "project-dialog-options.vala"
			valide_project_set_builder_options (self->priv->_project, _tmp3_ = (_tmp2_ = g_object_new (type, NULL), VALIDE_IS_BUILDER_OPTIONS (_tmp2_) ? ((ValideBuilderOptions*) _tmp2_) : NULL));
#line 603 "project-dialog-options.c"
			(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_object_unref (_tmp3_), NULL));
			_tmp4_ = valide_builder_manager_create_builder (self->priv->_project->builders, self->priv->_project, &_inner_error_);
			if (_inner_error_ != NULL) {
				b = (g_free (b), NULL);
				(builder == NULL) ? NULL : (builder = (g_object_unref (builder), NULL));
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return;
			}
			/* Replace the builder widget */
			_tmp5_ = NULL;
#line 172 "project-dialog-options.vala"
			builder = (_tmp5_ = _tmp4_, (builder == NULL) ? NULL : (builder = (g_object_unref (builder), NULL)), _tmp5_);
#line 173 "project-dialog-options.vala"
			gtk_notebook_remove_page (((ValideAbstractProjectDialogOptions*) self)->widgets->notebook, 1);
#line 55 "builder.vala"
			_tmp6_ = NULL;
#line 174 "project-dialog-options.vala"
			gtk_notebook_insert_page (((ValideAbstractProjectDialogOptions*) self)->widgets->notebook, _tmp6_ = valide_builder_preferences (builder), NULL, 1);
#line 623 "project-dialog-options.c"
			(_tmp6_ == NULL) ? NULL : (_tmp6_ = (g_object_unref (_tmp6_), NULL));
#line 175 "project-dialog-options.vala"
			gtk_widget_show_all ((GtkWidget*) ((ValideAbstractProjectDialogOptions*) self)->widgets->notebook);
#line 177 "project-dialog-options.vala"
			valide_project_save (self->priv->_project);
#line 629 "project-dialog-options.c"
		} else {
#line 181 "project-dialog-options.vala"
			g_warning (_ ("Coulnd't use this builder"));
#line 633 "project-dialog-options.c"
		}
		b = (g_free (b), NULL);
		(builder == NULL) ? NULL : (builder = (g_object_unref (builder), NULL));
	}
}


static void __lambda53__gtk_combo_box_changed (GtkComboBox* _sender, gpointer self) {
	_lambda53_ (_sender, self);
}


static GObject * valide_project_dialog_options_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideProjectDialogOptionsClass * klass;
	GObjectClass * parent_class;
	ValideProjectDialogOptions * self;
	GError * _inner_error_;
	klass = VALIDE_PROJECT_DIALOG_OPTIONS_CLASS (g_type_class_peek (VALIDE_TYPE_PROJECT_DIALOG_OPTIONS));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_PROJECT_DIALOG_OPTIONS (obj);
	_inner_error_ = NULL;
	{
		char* opt;
		GdkPixbuf* icon;
		GtkTreeIter iter = {0};
		GtkIconView* icon_view;
		GtkListStore* list_store;
		GtkCellRendererText* cell;
		GtkIconView* _tmp1_;
		GtkIconView* _tmp0_;
		GtkListStore* _tmp2_;
		GtkTreePath* _tmp19_;
		GtkListStore* _tmp22_;
		GtkListStore* _tmp21_;
		GtkTreeModel* _tmp20_;
		GtkCellRendererText* _tmp23_;
		opt = NULL;
		icon = NULL;
		icon_view = NULL;
		list_store = NULL;
		cell = NULL;
		_tmp1_ = NULL;
#line 57 "project-dialog-options.vala"
		_tmp0_ = NULL;
#line 57 "project-dialog-options.vala"
		icon_view = (_tmp1_ = (_tmp0_ = ((ValideAbstractProjectDialogOptions*) self)->widgets->icon_view, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (icon_view == NULL) ? NULL : (icon_view = (g_object_unref (icon_view), NULL)), _tmp1_);
#line 682 "project-dialog-options.c"
		_tmp2_ = NULL;
#line 58 "project-dialog-options.vala"
		list_store = (_tmp2_ = gtk_list_store_new (3, GDK_TYPE_PIXBUF, G_TYPE_STRING, G_TYPE_INT, NULL), (list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL)), _tmp2_);
#line 61 "project-dialog-options.vala"
		gtk_icon_view_set_model (icon_view, (GtkTreeModel*) list_store);
#line 62 "project-dialog-options.vala"
		gtk_icon_view_set_pixbuf_column (icon_view, 0);
#line 63 "project-dialog-options.vala"
		gtk_icon_view_set_text_column (icon_view, 1);
#line 692 "project-dialog-options.c"
		{
			char* _tmp3_;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 67 "project-dialog-options.vala"
			gtk_list_store_append (list_store, &iter);
#line 2034 "glib-2.0.vapi"
			_tmp3_ = NULL;
#line 68 "project-dialog-options.vala"
			_tmp4_ = NULL;
#line 704 "project-dialog-options.c"
			_tmp5_ = (_tmp4_ = gdk_pixbuf_new_from_file (_tmp3_ = g_build_filename (PIXMAPS_DIR, "pref-general.png", NULL), &_inner_error_), _tmp3_ = (g_free (_tmp3_), NULL), _tmp4_);
			if (_inner_error_ != NULL) {
				goto __catch55_g_error;
				goto __finally55;
			}
			_tmp6_ = NULL;
#line 68 "project-dialog-options.vala"
			icon = (_tmp6_ = _tmp5_, (icon == NULL) ? NULL : (icon = (g_object_unref (icon), NULL)), _tmp6_);
#line 69 "project-dialog-options.vala"
			gtk_list_store_set (list_store, &iter, 0, icon, 1, _ ("General"), 2, 0, -1, -1);
#line 715 "project-dialog-options.c"
		}
		goto __finally55;
		__catch55_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 73 "project-dialog-options.vala"
				g_debug (e->message);
#line 726 "project-dialog-options.c"
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally55:
		if (_inner_error_ != NULL) {
			opt = (g_free (opt), NULL);
			(icon == NULL) ? NULL : (icon = (g_object_unref (icon), NULL));
			(icon_view == NULL) ? NULL : (icon_view = (g_object_unref (icon_view), NULL));
			(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
			(cell == NULL) ? NULL : (cell = (g_object_unref (cell), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
		}
		{
			ValideBuilder* builder;
			char* _tmp7_;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
			GdkPixbuf* _tmp10_;
			ValideBuilder* _tmp11_;
			ValideBuilder* _tmp12_;
			GtkWidget* _tmp13_;
			builder = NULL;
#line 80 "project-dialog-options.vala"
			gtk_list_store_append (list_store, &iter);
#line 2034 "glib-2.0.vapi"
			_tmp7_ = NULL;
#line 81 "project-dialog-options.vala"
			_tmp8_ = NULL;
#line 756 "project-dialog-options.c"
			_tmp9_ = (_tmp8_ = gdk_pixbuf_new_from_file (_tmp7_ = g_build_filename (PIXMAPS_DIR, "pref-compiler.png", NULL), &_inner_error_), _tmp7_ = (g_free (_tmp7_), NULL), _tmp8_);
			if (_inner_error_ != NULL) {
				(builder == NULL) ? NULL : (builder = (g_object_unref (builder), NULL));
				goto __catch56_g_error;
				goto __finally56;
			}
			_tmp10_ = NULL;
#line 81 "project-dialog-options.vala"
			icon = (_tmp10_ = _tmp9_, (icon == NULL) ? NULL : (icon = (g_object_unref (icon), NULL)), _tmp10_);
#line 82 "project-dialog-options.vala"
			gtk_list_store_set (list_store, &iter, 0, icon, 1, _ ("Builder"), 2, 1, -1, -1);
#line 768 "project-dialog-options.c"
			_tmp11_ = valide_builder_manager_create_builder (self->priv->_project->builders, self->priv->_project, &_inner_error_);
			if (_inner_error_ != NULL) {
				(builder == NULL) ? NULL : (builder = (g_object_unref (builder), NULL));
				goto __catch56_g_error;
				goto __finally56;
			}
			_tmp12_ = NULL;
#line 83 "project-dialog-options.vala"
			builder = (_tmp12_ = _tmp11_, (builder == NULL) ? NULL : (builder = (g_object_unref (builder), NULL)), _tmp12_);
#line 55 "builder.vala"
			_tmp13_ = NULL;
#line 84 "project-dialog-options.vala"
			gtk_notebook_append_page (((ValideAbstractProjectDialogOptions*) self)->widgets->notebook, _tmp13_ = valide_builder_preferences (builder), NULL);
#line 782 "project-dialog-options.c"
			(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_object_unref (_tmp13_), NULL));
			(builder == NULL) ? NULL : (builder = (g_object_unref (builder), NULL));
		}
		goto __finally56;
		__catch56_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 88 "project-dialog-options.vala"
				g_debug (e->message);
#line 795 "project-dialog-options.c"
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally56:
		if (_inner_error_ != NULL) {
			opt = (g_free (opt), NULL);
			(icon == NULL) ? NULL : (icon = (g_object_unref (icon), NULL));
			(icon_view == NULL) ? NULL : (icon_view = (g_object_unref (icon_view), NULL));
			(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
			(cell == NULL) ? NULL : (cell = (g_object_unref (cell), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
		}
		{
			char* _tmp14_;
			GdkPixbuf* _tmp15_;
			GdkPixbuf* _tmp16_;
			GdkPixbuf* _tmp17_;
			GtkWidget* _tmp18_;
#line 93 "project-dialog-options.vala"
			gtk_list_store_append (list_store, &iter);
#line 2034 "glib-2.0.vapi"
			_tmp14_ = NULL;
#line 94 "project-dialog-options.vala"
			_tmp15_ = NULL;
#line 821 "project-dialog-options.c"
			_tmp16_ = (_tmp15_ = gdk_pixbuf_new_from_file (_tmp14_ = g_build_filename (PIXMAPS_DIR, "pref-executable.png", NULL), &_inner_error_), _tmp14_ = (g_free (_tmp14_), NULL), _tmp15_);
			if (_inner_error_ != NULL) {
				goto __catch57_g_error;
				goto __finally57;
			}
			_tmp17_ = NULL;
#line 94 "project-dialog-options.vala"
			icon = (_tmp17_ = _tmp16_, (icon == NULL) ? NULL : (icon = (g_object_unref (icon), NULL)), _tmp17_);
#line 95 "project-dialog-options.vala"
			gtk_list_store_set (list_store, &iter, 0, icon, 1, _ ("Executable"), 2, 2, -1, -1);
#line 434 "executable.vala"
			_tmp18_ = NULL;
#line 96 "project-dialog-options.vala"
			gtk_notebook_append_page (((ValideAbstractProjectDialogOptions*) self)->widgets->notebook, _tmp18_ = valide_executable_preferences (self->priv->_project), NULL);
#line 836 "project-dialog-options.c"
			(_tmp18_ == NULL) ? NULL : (_tmp18_ = (g_object_unref (_tmp18_), NULL));
		}
		goto __finally57;
		__catch57_g_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 100 "project-dialog-options.vala"
				g_debug (e->message);
#line 848 "project-dialog-options.c"
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally57:
		if (_inner_error_ != NULL) {
			opt = (g_free (opt), NULL);
			(icon == NULL) ? NULL : (icon = (g_object_unref (icon), NULL));
			(icon_view == NULL) ? NULL : (icon_view = (g_object_unref (icon_view), NULL));
			(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
			(cell == NULL) ? NULL : (cell = (g_object_unref (cell), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
		}
#line 103 "project-dialog-options.vala"
		g_signal_connect (icon_view, "selection-changed", (GCallback) __lambda49__gtk_icon_view_selection_changed, self);
#line 864 "project-dialog-options.c"
		/* Set first item */
		_tmp19_ = NULL;
#line 118 "project-dialog-options.vala"
		gtk_icon_view_select_path (icon_view, _tmp19_ = gtk_tree_path_new_from_string ("0"));
#line 869 "project-dialog-options.c"
		(_tmp19_ == NULL) ? NULL : (_tmp19_ = (gtk_tree_path_free (_tmp19_), NULL));
#line 120 "project-dialog-options.vala"
		gtk_label_set_text (((ValideAbstractProjectDialogOptions*) self)->widgets->path, valide_project_get_path (self->priv->_project));
#line 122 "project-dialog-options.vala"
		gtk_entry_set_text (((ValideAbstractProjectDialogOptions*) self)->widgets->name, valide_project_get_name (self->priv->_project));
#line 123 "project-dialog-options.vala"
		g_signal_connect ((GtkEditable*) ((ValideAbstractProjectDialogOptions*) self)->widgets->name, "changed", (GCallback) __lambda50__gtk_editable_changed, self);
#line 128 "project-dialog-options.vala"
		gtk_entry_set_text (((ValideAbstractProjectDialogOptions*) self)->widgets->author, valide_project_get_author (self->priv->_project));
#line 129 "project-dialog-options.vala"
		g_signal_connect ((GtkEditable*) ((ValideAbstractProjectDialogOptions*) self)->widgets->author, "changed", (GCallback) __lambda51__gtk_editable_changed, self);
#line 134 "project-dialog-options.vala"
		gtk_entry_set_text (((ValideAbstractProjectDialogOptions*) self)->widgets->version, valide_project_get_version (self->priv->_project));
#line 135 "project-dialog-options.vala"
		g_signal_connect ((GtkEditable*) ((ValideAbstractProjectDialogOptions*) self)->widgets->version, "changed", (GCallback) __lambda52__gtk_editable_changed, self);
#line 140 "project-dialog-options.vala"
		gtk_label_set_text (((ValideAbstractProjectDialogOptions*) self)->widgets->license, valide_project_get_license (self->priv->_project));
#line 887 "project-dialog-options.c"
		_tmp22_ = NULL;
#line 142 "project-dialog-options.vala"
		_tmp21_ = NULL;
#line 142 "project-dialog-options.vala"
		_tmp20_ = NULL;
#line 142 "project-dialog-options.vala"
		list_store = (_tmp22_ = (_tmp21_ = (_tmp20_ = gtk_combo_box_get_model (((ValideAbstractProjectDialogOptions*) self)->widgets->builder), GTK_IS_LIST_STORE (_tmp20_) ? ((GtkListStore*) _tmp20_) : NULL), (_tmp21_ == NULL) ? NULL : g_object_ref (_tmp21_)), (list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL)), _tmp22_);
#line 895 "project-dialog-options.c"
		_tmp23_ = NULL;
#line 143 "project-dialog-options.vala"
		cell = (_tmp23_ = g_object_ref_sink ((GtkCellRendererText*) gtk_cell_renderer_text_new ()), (cell == NULL) ? NULL : (cell = (g_object_unref (cell), NULL)), _tmp23_);
#line 144 "project-dialog-options.vala"
		gtk_cell_layout_pack_start ((GtkCellLayout*) ((ValideAbstractProjectDialogOptions*) self)->widgets->builder, (GtkCellRenderer*) cell, TRUE);
#line 145 "project-dialog-options.vala"
		gtk_cell_layout_set_attributes ((GtkCellLayout*) ((ValideAbstractProjectDialogOptions*) self)->widgets->builder, (GtkCellRenderer*) cell, "text", 0, NULL);
#line 903 "project-dialog-options.c"
		{
			ValideBuilderManager* _tmp24_;
			GList* _tmp25_;
			GList* builder_collection;
			GList* builder_it;
#line 62 "builder-manager.vala"
			_tmp24_ = NULL;
#line 146 "project-dialog-options.vala"
			_tmp25_ = NULL;
#line 146 "project-dialog-options.vala"
			builder_collection = (_tmp25_ = valide_builder_manager_get_builders (_tmp24_ = valide_builder_manager_get_instance ()), (_tmp24_ == NULL) ? NULL : (_tmp24_ = (g_object_unref (_tmp24_), NULL)), _tmp25_);
#line 915 "project-dialog-options.c"
			for (builder_it = builder_collection; builder_it != NULL; builder_it = builder_it->next) {
				const char* _tmp29_;
				char* builder;
#line 141 "builder-manager.vala"
				_tmp29_ = NULL;
#line 146 "project-dialog-options.vala"
				builder = (_tmp29_ = (const char*) builder_it->data, (_tmp29_ == NULL) ? NULL : g_strdup (_tmp29_));
#line 923 "project-dialog-options.c"
				{
					char* _tmp27_;
					char* _tmp26_;
					gboolean _tmp28_;
#line 148 "project-dialog-options.vala"
					gtk_list_store_append (list_store, &iter);
#line 149 "project-dialog-options.vala"
					gtk_list_store_set (list_store, &iter, 0, builder, -1);
#line 871 "glib-2.0.vapi"
					_tmp27_ = NULL;
#line 871 "glib-2.0.vapi"
					_tmp26_ = NULL;
#line 150 "project-dialog-options.vala"
					if ((_tmp28_ = _vala_strcmp0 (_tmp26_ = g_utf8_strdown (builder, -1), _tmp27_ = g_utf8_strdown (valide_project_get_builder (self->priv->_project), -1)) == 0, _tmp27_ = (g_free (_tmp27_), NULL), _tmp26_ = (g_free (_tmp26_), NULL), _tmp28_)) {
#line 152 "project-dialog-options.vala"
						gtk_combo_box_set_active_iter (((ValideAbstractProjectDialogOptions*) self)->widgets->builder, &iter);
#line 940 "project-dialog-options.c"
					}
					builder = (g_free (builder), NULL);
				}
			}
		}
#line 155 "project-dialog-options.vala"
		g_signal_connect (((ValideAbstractProjectDialogOptions*) self)->widgets->builder, "changed", (GCallback) __lambda53__gtk_combo_box_changed, self);
#line 186 "project-dialog-options.vala"
		valide_abstract_project_dialog_options_connect_signals ((ValideAbstractProjectDialogOptions*) self, "valide_project_dialog_options_");
#line 950 "project-dialog-options.c"
		opt = (g_free (opt), NULL);
		(icon == NULL) ? NULL : (icon = (g_object_unref (icon), NULL));
		(icon_view == NULL) ? NULL : (icon_view = (g_object_unref (icon_view), NULL));
		(list_store == NULL) ? NULL : (list_store = (g_object_unref (list_store), NULL));
		(cell == NULL) ? NULL : (cell = (g_object_unref (cell), NULL));
	}
	return obj;
}


static void valide_project_dialog_options_class_init (ValideProjectDialogOptionsClass * klass) {
	valide_project_dialog_options_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideProjectDialogOptionsPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_project_dialog_options_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_project_dialog_options_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_project_dialog_options_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_project_dialog_options_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_PROJECT_DIALOG_OPTIONS_PROJECT, g_param_spec_object ("project", "project", "project", VALIDE_TYPE_PROJECT, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void valide_project_dialog_options_instance_init (ValideProjectDialogOptions * self) {
	self->priv = VALIDE_PROJECT_DIALOG_OPTIONS_GET_PRIVATE (self);
}


static void valide_project_dialog_options_finalize (GObject* obj) {
	ValideProjectDialogOptions * self;
	self = VALIDE_PROJECT_DIALOG_OPTIONS (obj);
	(self->priv->_project == NULL) ? NULL : (self->priv->_project = (g_object_unref (self->priv->_project), NULL));
	G_OBJECT_CLASS (valide_project_dialog_options_parent_class)->finalize (obj);
}


GType valide_project_dialog_options_get_type (void) {
	static GType valide_project_dialog_options_type_id = 0;
	if (valide_project_dialog_options_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideProjectDialogOptionsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_project_dialog_options_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideProjectDialogOptions), 0, (GInstanceInitFunc) valide_project_dialog_options_instance_init, NULL };
		valide_project_dialog_options_type_id = g_type_register_static (VALIDE_TYPE_ABSTRACT_PROJECT_DIALOG_OPTIONS, "ValideProjectDialogOptions", &g_define_type_info, 0);
	}
	return valide_project_dialog_options_type_id;
}


static void valide_project_dialog_options_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideProjectDialogOptions * self;
	gpointer boxed;
	self = VALIDE_PROJECT_DIALOG_OPTIONS (object);
	switch (property_id) {
		case VALIDE_PROJECT_DIALOG_OPTIONS_PROJECT:
		g_value_set_object (value, valide_project_dialog_options_get_project (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_project_dialog_options_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideProjectDialogOptions * self;
	self = VALIDE_PROJECT_DIALOG_OPTIONS (object);
	switch (property_id) {
		case VALIDE_PROJECT_DIALOG_OPTIONS_PROJECT:
		valide_project_dialog_options_set_project (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




