/* recent-manager-ui.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>


#define VALIDE_TYPE_RECENT_MANAGER_UI (valide_recent_manager_ui_get_type ())
#define VALIDE_RECENT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUI))
#define VALIDE_RECENT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUIClass))
#define VALIDE_IS_RECENT_MANAGER_UI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_RECENT_MANAGER_UI))
#define VALIDE_IS_RECENT_MANAGER_UI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_RECENT_MANAGER_UI))
#define VALIDE_RECENT_MANAGER_UI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUIClass))

typedef struct _ValideRecentManagerUI ValideRecentManagerUI;
typedef struct _ValideRecentManagerUIClass ValideRecentManagerUIClass;
typedef struct _ValideRecentManagerUIPrivate ValideRecentManagerUIPrivate;

#define VALIDE_TYPE_UI_MANAGER (valide_ui_manager_get_type ())
#define VALIDE_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManager))
#define VALIDE_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))
#define VALIDE_IS_UI_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_IS_UI_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_UI_MANAGER))
#define VALIDE_UI_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_UI_MANAGER, ValideUIManagerClass))

typedef struct _ValideUIManager ValideUIManager;
typedef struct _ValideUIManagerClass ValideUIManagerClass;

#define VALIDE_TYPE_DOCUMENT_MANAGER (valide_document_manager_get_type ())
#define VALIDE_DOCUMENT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_DOCUMENT_MANAGER, ValideDocumentManager))
#define VALIDE_DOCUMENT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_DOCUMENT_MANAGER, ValideDocumentManagerClass))
#define VALIDE_IS_DOCUMENT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_DOCUMENT_MANAGER))
#define VALIDE_IS_DOCUMENT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_DOCUMENT_MANAGER))
#define VALIDE_DOCUMENT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_DOCUMENT_MANAGER, ValideDocumentManagerClass))

typedef struct _ValideDocumentManager ValideDocumentManager;
typedef struct _ValideDocumentManagerClass ValideDocumentManagerClass;

#define VALIDE_TYPE_PROJECT_MANAGER (valide_project_manager_get_type ())
#define VALIDE_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManager))
#define VALIDE_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManagerClass))
#define VALIDE_IS_PROJECT_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT_MANAGER))
#define VALIDE_IS_PROJECT_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT_MANAGER))
#define VALIDE_PROJECT_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT_MANAGER, ValideProjectManagerClass))

typedef struct _ValideProjectManager ValideProjectManager;
typedef struct _ValideProjectManagerClass ValideProjectManagerClass;

#define VALIDE_TYPE_IDOCUMENT (valide_idocument_get_type ())
#define VALIDE_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocument))
#define VALIDE_IS_IDOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_IDOCUMENT))
#define VALIDE_IDOCUMENT_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALIDE_TYPE_IDOCUMENT, ValideiDocumentIface))

typedef struct _ValideiDocument ValideiDocument;
typedef struct _ValideiDocumentIface ValideiDocumentIface;

#define VALIDE_TYPE_DOCUMENT_STATE (valide_document_state_get_type ())

#define G_YAML_TYPE_BUILDABLE (g_yaml_buildable_get_type ())
#define G_YAML_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildable))
#define G_YAML_IS_BUILDABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDABLE))
#define G_YAML_BUILDABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), G_YAML_TYPE_BUILDABLE, GYAMLBuildableIface))

typedef struct _GYAMLBuildable GYAMLBuildable;
typedef struct _GYAMLBuildableIface GYAMLBuildableIface;

#define G_YAML_TYPE_BUILDER (g_yaml_builder_get_type ())
#define G_YAML_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilder))
#define G_YAML_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))
#define G_YAML_IS_BUILDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_BUILDER))
#define G_YAML_IS_BUILDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_BUILDER))
#define G_YAML_BUILDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_BUILDER, GYAMLBuilderClass))

typedef struct _GYAMLBuilder GYAMLBuilder;
typedef struct _GYAMLBuilderClass GYAMLBuilderClass;

#define G_YAML_TYPE_NODE (g_yaml_node_get_type ())
#define G_YAML_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), G_YAML_TYPE_NODE, GYAMLNode))
#define G_YAML_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), G_YAML_TYPE_NODE, GYAMLNodeClass))
#define G_YAML_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), G_YAML_TYPE_NODE))
#define G_YAML_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), G_YAML_TYPE_NODE))
#define G_YAML_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), G_YAML_TYPE_NODE, GYAMLNodeClass))

typedef struct _GYAMLNode GYAMLNode;
typedef struct _GYAMLNodeClass GYAMLNodeClass;

#define VALIDE_TYPE_PROJECT (valide_project_get_type ())
#define VALIDE_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PROJECT, ValideProject))
#define VALIDE_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PROJECT, ValideProjectClass))
#define VALIDE_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PROJECT))
#define VALIDE_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PROJECT))
#define VALIDE_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PROJECT, ValideProjectClass))

typedef struct _ValideProject ValideProject;
typedef struct _ValideProjectClass ValideProjectClass;
typedef struct _ValideProjectPrivate ValideProjectPrivate;

#define VALIDE_TYPE_BUILDER_MANAGER (valide_builder_manager_get_type ())
#define VALIDE_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManager))
#define VALIDE_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))
#define VALIDE_IS_BUILDER_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_IS_BUILDER_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_BUILDER_MANAGER))
#define VALIDE_BUILDER_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_BUILDER_MANAGER, ValideBuilderManagerClass))

typedef struct _ValideBuilderManager ValideBuilderManager;
typedef struct _ValideBuilderManagerClass ValideBuilderManagerClass;

#define VALIDE_TYPE_SOURCE (valide_source_get_type ())
#define VALIDE_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_SOURCE, ValideSource))
#define VALIDE_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_SOURCE, ValideSourceClass))
#define VALIDE_IS_SOURCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_SOURCE))
#define VALIDE_IS_SOURCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_SOURCE))
#define VALIDE_SOURCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_SOURCE, ValideSourceClass))

typedef struct _ValideSource ValideSource;
typedef struct _ValideSourceClass ValideSourceClass;

#define VALIDE_TYPE_PACKAGE (valide_package_get_type ())
#define VALIDE_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_PACKAGE, ValidePackage))
#define VALIDE_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_PACKAGE, ValidePackageClass))
#define VALIDE_IS_PACKAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_PACKAGE))
#define VALIDE_IS_PACKAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_PACKAGE))
#define VALIDE_PACKAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_PACKAGE, ValidePackageClass))

typedef struct _ValidePackage ValidePackage;
typedef struct _ValidePackageClass ValidePackageClass;

#define VALIDE_TYPE_VAPI_DIR (valide_vapi_dir_get_type ())
#define VALIDE_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDir))
#define VALIDE_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))
#define VALIDE_IS_VAPI_DIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_IS_VAPI_DIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALIDE_TYPE_VAPI_DIR))
#define VALIDE_VAPI_DIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALIDE_TYPE_VAPI_DIR, ValideVapiDirClass))

typedef struct _ValideVapiDir ValideVapiDir;
typedef struct _ValideVapiDirClass ValideVapiDirClass;

/**
 * The recent files/projects manager
 */
struct _ValideRecentManagerUI {
	GObject parent_instance;
	ValideRecentManagerUIPrivate * priv;
};

struct _ValideRecentManagerUIClass {
	GObjectClass parent_class;
};

struct _ValideRecentManagerUIPrivate {
	guint id_file;
	guint id_project;
	gint max_recents;
	GtkActionGroup* recents_action_group;
	ValideUIManager* _ui_manager;
	ValideDocumentManager* _documents;
	ValideProjectManager* _projects;
	GList* _recent_files;
	GList* _recent_projects;
};

typedef enum  {
	VALIDE_PROJECT_ERROR_NO_PROJECT,
	VALIDE_PROJECT_ERROR_MAX_OPEN
} ValideProjectError;
#define VALIDE_PROJECT_ERROR valide_project_error_quark ()
typedef enum  {
	VALIDE_DOCUMENT_STATE_NORMAL,
	VALIDE_DOCUMENT_STATE_EXTERNALLY_MODIFIED,
	VALIDE_DOCUMENT_STATE_BAD_ENCODING,
	VALIDE_DOCUMENT_STATE_INFO
} ValideDocumentState;

/**
 * An interface for document
 */
struct _ValideiDocumentIface {
	GTypeInterface parent_iface;
	void (*open) (ValideiDocument* self, const char* path, GError** error);
	void (*save) (ValideiDocument* self, const char* current_folder);
	void (*save_as) (ValideiDocument* self, const char* current_folder);
	void (*rename) (ValideiDocument* self);
	gboolean (*close) (ValideiDocument* self);
	GdkPixbuf* (*get_icon) (ValideiDocument* self);
	char* (*get_tooltips) (ValideiDocument* self);
	void (*setup_ui) (ValideiDocument* self, ValideUIManager* ui_manager);
	ValideDocumentState (*get_state) (ValideiDocument* self);
	void (*set_state) (ValideiDocument* self, ValideDocumentState value);
	gboolean (*get_is_save) (ValideiDocument* self);
	void (*set_is_save) (ValideiDocument* self, gboolean value);
	const char* (*get_path) (ValideiDocument* self);
	void (*set_path) (ValideiDocument* self, const char* value);
	const char* (*get_title) (ValideiDocument* self);
	const char* (*get_filename) (ValideiDocument* self);
};

/**
 * Buildable GObjects, from YAML.
 *
 *
 * Objects that implements GLib.YAML.Buildable is buildable by
 * GLib.YAML.Builder.
 *
 * This interface is almost the same as GtkBuildable.
 *
 **/
struct _GYAMLBuildableIface {
	GTypeInterface parent_iface;
	const char* (*get_name) (GYAMLBuildable* self);
	void (*set_name) (GYAMLBuildable* self, const char* name);
	void (*add_child) (GYAMLBuildable* self, GYAMLBuilder* builder, GObject* child, const char* type, GError** error);
	char** (*get_child_tags) (GYAMLBuildable* self, int* result_length1);
	GType* (*get_child_types) (GYAMLBuildable* self, int* result_length1);
	GList* (*get_children) (GYAMLBuildable* self, const char* type);
	GObject* (*get_internal_child) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* child_name);
	void (*custom_node) (GYAMLBuildable* self, GYAMLBuilder* builder, const char* tag, GYAMLNode* node, GError** error);
};

/**
 * A class for project
 */
struct _ValideProject {
	GObject parent_instance;
	ValideProjectPrivate * priv;
	char* filename;
	ValideBuilderManager* builders;
	GList* files;
	GList* packages;
	GList* vapi_dir;
};

struct _ValideProjectClass {
	GObjectClass parent_class;
};


static gpointer valide_recent_manager_ui_parent_class = NULL;

GType valide_recent_manager_ui_get_type (void);
GType valide_ui_manager_get_type (void);
GType valide_document_manager_get_type (void);
GType valide_project_manager_get_type (void);
#define VALIDE_RECENT_MANAGER_UI_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALIDE_TYPE_RECENT_MANAGER_UI, ValideRecentManagerUIPrivate))
enum  {
	VALIDE_RECENT_MANAGER_UI_DUMMY_PROPERTY,
	VALIDE_RECENT_MANAGER_UI_UI_MANAGER,
	VALIDE_RECENT_MANAGER_UI_DOCUMENTS,
	VALIDE_RECENT_MANAGER_UI_PROJECTS,
	VALIDE_RECENT_MANAGER_UI_RECENT_FILES,
	VALIDE_RECENT_MANAGER_UI_RECENT_PROJECTS
};
static void _g_list_free_gtk_recent_info_unref (GList* self);
ValideProjectManager* valide_recent_manager_ui_get_projects (ValideRecentManagerUI* self);
GQuark valide_project_error_quark (void);
gboolean valide_project_manager_open (ValideProjectManager* self, const char* filename, GError** error);
ValideDocumentManager* valide_recent_manager_ui_get_documents (ValideRecentManagerUI* self);
GType valide_document_state_get_type (void);
GType valide_idocument_get_type (void);
ValideiDocument* valide_document_manager_create (ValideDocumentManager* self, const char* filename, GError** error);
static void valide_recent_manager_ui_recents_menu_activate (ValideRecentManagerUI* self, GtkAction* sender);
static void valide_recent_manager_ui_add (ValideRecentManagerUI* self, const char* uri, const char* mime_type);
static void _valide_recent_manager_ui_recents_menu_activate_gtk_action_activate (GtkAction* _sender, gpointer self);
static void valide_recent_manager_ui_update (ValideRecentManagerUI* self, ValideUIManager* ui_manager, char** file_ext, int file_ext_length1, const char* ui_path, guint* id);
static void valide_recent_manager_ui_set_ui_manager (ValideRecentManagerUI* self, ValideUIManager* value);
static void valide_recent_manager_ui_set_documents (ValideRecentManagerUI* self, ValideDocumentManager* value);
static void valide_recent_manager_ui_set_projects (ValideRecentManagerUI* self, ValideProjectManager* value);
ValideRecentManagerUI* valide_recent_manager_ui_new (ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideProjectManager* projects);
ValideRecentManagerUI* valide_recent_manager_ui_construct (GType object_type, ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideProjectManager* projects);
void valide_recent_manager_ui_update_file (ValideRecentManagerUI* self);
void valide_recent_manager_ui_add_file (ValideRecentManagerUI* self, const char* uri);
void valide_recent_manager_ui_update_project (ValideRecentManagerUI* self);
void valide_recent_manager_ui_add_project (ValideRecentManagerUI* self, const char* uri);
ValideUIManager* valide_recent_manager_ui_get_ui_manager (ValideRecentManagerUI* self);
GList* valide_recent_manager_ui_get_recent_files (ValideRecentManagerUI* self);
GList* valide_recent_manager_ui_get_recent_projects (ValideRecentManagerUI* self);
const char* valide_idocument_get_path (ValideiDocument* self);
static void _lambda39_ (ValideDocumentManager* s, ValideiDocument* d, ValideRecentManagerUI* self);
static void __lambda39__valide_document_manager_tab_added (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self);
GType g_yaml_builder_get_type (void);
gpointer g_yaml_node_ref (gpointer instance);
void g_yaml_node_unref (gpointer instance);
GParamSpec* g_yaml_param_spec_node (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void g_yaml_value_set_node (GValue* value, gpointer v_object);
gpointer g_yaml_value_get_node (const GValue* value);
GType g_yaml_node_get_type (void);
GType g_yaml_buildable_get_type (void);
GType valide_project_get_type (void);
GType valide_builder_manager_get_type (void);
GType valide_source_get_type (void);
GType valide_package_get_type (void);
GType valide_vapi_dir_get_type (void);
static void _lambda40_ (ValideProjectManager* s, ValideProject* p, ValideRecentManagerUI* self);
static void __lambda40__valide_project_manager_project_opened (ValideProjectManager* _sender, ValideProject* project, gpointer self);
static GObject * valide_recent_manager_ui_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void valide_recent_manager_ui_finalize (GObject* obj);
static void valide_recent_manager_ui_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void valide_recent_manager_ui_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const char* VALIDE_PROJECT_FILE_EXT[] = {"vide"};


static void _g_list_free_gtk_recent_info_unref (GList* self) {
	g_list_foreach (self, (GFunc) gtk_recent_info_unref, NULL);
	g_list_free (self);
}


#line 147 "recent-manager-ui.vala"
static void valide_recent_manager_ui_recents_menu_activate (ValideRecentManagerUI* self, GtkAction* sender) {
#line 337 "recent-manager-ui.c"
	GError * _inner_error_;
	GtkRecentInfo* info;
	char* uri;
	GtkRecentInfo* _tmp1_;
	GtkRecentInfo* _tmp0_;
	char* _tmp3_;
	const char* _tmp2_;
#line 147 "recent-manager-ui.vala"
	g_return_if_fail (self != NULL);
#line 147 "recent-manager-ui.vala"
	g_return_if_fail (sender != NULL);
#line 349 "recent-manager-ui.c"
	_inner_error_ = NULL;
	info = NULL;
	uri = NULL;
	_tmp1_ = NULL;
#line 152 "recent-manager-ui.vala"
	_tmp0_ = NULL;
#line 152 "recent-manager-ui.vala"
	info = (_tmp1_ = (_tmp0_ = (GtkRecentInfo*) g_object_get_data ((GObject*) sender, "gtk-recent-info"), (_tmp0_ == NULL) ? NULL : gtk_recent_info_ref (_tmp0_)), (info == NULL) ? NULL : (info = (gtk_recent_info_unref (info), NULL)), _tmp1_);
#line 358 "recent-manager-ui.c"
	_tmp3_ = NULL;
#line 153 "recent-manager-ui.vala"
	_tmp2_ = NULL;
#line 153 "recent-manager-ui.vala"
	uri = (_tmp3_ = (_tmp2_ = gtk_recent_info_get_uri (info), (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), uri = (g_free (uri), NULL), _tmp3_);
#line 364 "recent-manager-ui.c"
	{
		char* _tmp4_;
		gboolean _tmp5_;
		_tmp4_ = NULL;
#line 157 "recent-manager-ui.vala"
		if ((_tmp5_ = g_str_has_suffix (uri, _tmp4_ = g_strconcat (".", VALIDE_PROJECT_FILE_EXT[0], NULL)), _tmp4_ = (g_free (_tmp4_), NULL), _tmp5_)) {
#line 159 "recent-manager-ui.vala"
			valide_project_manager_open (self->priv->_projects, uri, &_inner_error_);
#line 373 "recent-manager-ui.c"
			if (_inner_error_ != NULL) {
				goto __catch8_g_error;
				goto __finally8;
			}
		} else {
			ValideiDocument* _tmp6_;
#line 414 "document-manager.vala"
			_tmp6_ = NULL;
#line 163 "recent-manager-ui.vala"
			_tmp6_ = valide_document_manager_create (self->priv->_documents, uri, &_inner_error_);
#line 384 "recent-manager-ui.c"
			if (_inner_error_ != NULL) {
				goto __catch8_g_error;
				goto __finally8;
			}
			(_tmp6_ == NULL) ? NULL : (_tmp6_ = (g_object_unref (_tmp6_), NULL));
		}
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 168 "recent-manager-ui.vala"
			g_warning (e->message);
#line 401 "recent-manager-ui.c"
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally8:
	if (_inner_error_ != NULL) {
		(info == NULL) ? NULL : (info = (gtk_recent_info_unref (info), NULL));
		uri = (g_free (uri), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	(info == NULL) ? NULL : (info = (gtk_recent_info_unref (info), NULL));
	uri = (g_free (uri), NULL);
}


#line 172 "recent-manager-ui.vala"
static void valide_recent_manager_ui_add (ValideRecentManagerUI* self, const char* uri, const char* mime_type) {
#line 420 "recent-manager-ui.c"
	GtkRecentData _tmp0_ = {0};
	GtkRecentData data;
	char** _tmp1_;
	gint groups_size;
	gint groups_length1;
	char** groups;
	char* _tmp2_;
	char* _tmp3_;
#line 172 "recent-manager-ui.vala"
	g_return_if_fail (self != NULL);
#line 172 "recent-manager-ui.vala"
	g_return_if_fail (uri != NULL);
#line 172 "recent-manager-ui.vala"
	g_return_if_fail (mime_type != NULL);
#line 435 "recent-manager-ui.c"
	/* @bug http://bugzilla.gnome.org/show_bug.cgi?id=559647 */
	data = (memset (&_tmp0_, 0, sizeof (GtkRecentData)), _tmp0_);
#line 177 "recent-manager-ui.vala"
	data.display_name = uri;
#line 178 "recent-manager-ui.vala"
	data.description = mime_type;
#line 179 "recent-manager-ui.vala"
	data.mime_type = mime_type;
#line 180 "recent-manager-ui.vala"
	data.app_name = "Val(a)IDE";
#line 181 "recent-manager-ui.vala"
	data.app_exec = "valide";
#line 182 "recent-manager-ui.vala"
	_tmp1_ = NULL;
#line 450 "recent-manager-ui.c"
	groups = (_tmp1_ = g_new0 (char*, 2 + 1), groups_length1 = 2, groups_size = groups_length1, _tmp1_);
	_tmp2_ = NULL;
#line 183 "recent-manager-ui.vala"
	groups[0] = (_tmp2_ = g_strdup ("valide"), groups[0] = (g_free (groups[0]), NULL), _tmp2_);
#line 455 "recent-manager-ui.c"
	_tmp3_ = NULL;
#line 184 "recent-manager-ui.vala"
	groups[1] = (_tmp3_ = NULL, groups[1] = (g_free (groups[1]), NULL), _tmp3_);
#line 185 "recent-manager-ui.vala"
	data.groups = groups;
#line 186 "recent-manager-ui.vala"
	gtk_recent_manager_add_full (gtk_recent_manager_get_default (), uri, &data);
#line 463 "recent-manager-ui.c"
	groups = (_vala_array_free (groups, groups_length1, (GDestroyNotify) g_free), NULL);
}


#line 147 "recent-manager-ui.vala"
static void _valide_recent_manager_ui_recents_menu_activate_gtk_action_activate (GtkAction* _sender, gpointer self) {
#line 470 "recent-manager-ui.c"
	valide_recent_manager_ui_recents_menu_activate (self, _sender);
}


#line 189 "recent-manager-ui.vala"
static void valide_recent_manager_ui_update (ValideRecentManagerUI* self, ValideUIManager* ui_manager, char** file_ext, int file_ext_length1, const char* ui_path, guint* id) {
#line 477 "recent-manager-ui.c"
	GtkActionGroup* _tmp0_;
	GList* actions;
	GtkRecentManager* _tmp3_;
	GtkRecentManager* recent_manager;
	GList* items;
	GList* filtered_items;
	gint i;
#line 189 "recent-manager-ui.vala"
	g_return_if_fail (self != NULL);
#line 189 "recent-manager-ui.vala"
	g_return_if_fail (ui_manager != NULL);
#line 189 "recent-manager-ui.vala"
	g_return_if_fail (ui_path != NULL);
#line 192 "recent-manager-ui.vala"
	if ((*id) != 0) {
#line 194 "recent-manager-ui.vala"
		gtk_ui_manager_remove_ui ((GtkUIManager*) ui_manager, (*id));
#line 495 "recent-manager-ui.c"
	}
	_tmp0_ = NULL;
#line 197 "recent-manager-ui.vala"
	self->priv->recents_action_group = (_tmp0_ = gtk_action_group_new ("RecentActions"), (self->priv->recents_action_group == NULL) ? NULL : (self->priv->recents_action_group = (g_object_unref (self->priv->recents_action_group), NULL)), _tmp0_);
#line 198 "recent-manager-ui.vala"
	gtk_ui_manager_insert_action_group ((GtkUIManager*) ui_manager, self->priv->recents_action_group, 0);
#line 502 "recent-manager-ui.c"
	actions = gtk_action_group_list_actions (self->priv->recents_action_group);
	{
		GList* l_collection;
		GList* l_it;
#line 201 "recent-manager-ui.vala"
		l_collection = actions;
#line 509 "recent-manager-ui.c"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
			GtkAction* _tmp2_;
			GtkAction* l;
#line 200 "recent-manager-ui.vala"
			_tmp2_ = NULL;
#line 201 "recent-manager-ui.vala"
			l = (_tmp2_ = (GtkAction*) l_it->data, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
#line 517 "recent-manager-ui.c"
			{
				guint _tmp1_;
#line 203 "recent-manager-ui.vala"
				g_signal_handlers_disconnect_matched (l, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("activate", GTK_TYPE_ACTION, &_tmp1_, NULL, FALSE), _tmp1_), 0, NULL, (GCallback) _valide_recent_manager_ui_recents_menu_activate_gtk_action_activate, self);
#line 204 "recent-manager-ui.vala"
				gtk_action_group_remove_action (self->priv->recents_action_group, l);
#line 524 "recent-manager-ui.c"
				(l == NULL) ? NULL : (l = (g_object_unref (l), NULL));
			}
		}
	}
#line 207 "recent-manager-ui.vala"
	(*id) = gtk_ui_manager_new_merge_id ((GtkUIManager*) ui_manager);
#line 209 "recent-manager-ui.vala"
	_tmp3_ = NULL;
#line 533 "recent-manager-ui.c"
	recent_manager = (_tmp3_ = gtk_recent_manager_get_default (), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
	items = gtk_recent_manager_get_items (recent_manager);
	filtered_items = NULL;
	/* filter */
	{
		GList* l_collection;
		GList* l_it;
#line 214 "recent-manager-ui.vala"
		l_collection = items;
#line 543 "recent-manager-ui.c"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
			GtkRecentInfo* _tmp7_;
			GtkRecentInfo* l;
#line 210 "recent-manager-ui.vala"
			_tmp7_ = NULL;
#line 214 "recent-manager-ui.vala"
			l = (_tmp7_ = (GtkRecentInfo*) l_it->data, (_tmp7_ == NULL) ? NULL : gtk_recent_info_ref (_tmp7_));
#line 551 "recent-manager-ui.c"
			{
				gboolean _tmp4_;
				_tmp4_ = FALSE;
#line 216 "recent-manager-ui.vala"
				if (gtk_recent_info_has_group (l, "valide")) {
#line 217 "recent-manager-ui.vala"
					_tmp4_ = g_file_test (gtk_recent_info_get_uri (l), G_FILE_TEST_EXISTS);
#line 559 "recent-manager-ui.c"
				} else {
#line 216 "recent-manager-ui.vala"
					_tmp4_ = FALSE;
#line 563 "recent-manager-ui.c"
				}
#line 216 "recent-manager-ui.vala"
				if (_tmp4_) {
#line 567 "recent-manager-ui.c"
					{
						char** e_collection;
						int e_collection_length1;
						int e_it;
#line 219 "recent-manager-ui.vala"
						e_collection = file_ext;
#line 574 "recent-manager-ui.c"
						e_collection_length1 = file_ext_length1;
						for (e_it = 0; e_it < file_ext_length1; e_it = e_it + 1) {
							const char* _tmp6_;
							char* e;
#line 189 "recent-manager-ui.vala"
							_tmp6_ = NULL;
#line 581 "recent-manager-ui.c"
							e = (_tmp6_ = e_collection[e_it], (_tmp6_ == NULL) ? NULL : g_strdup (_tmp6_));
							{
#line 221 "recent-manager-ui.vala"
								if (g_str_has_suffix (gtk_recent_info_get_uri (l), e)) {
#line 586 "recent-manager-ui.c"
									GtkRecentInfo* _tmp5_;
#line 223 "recent-manager-ui.vala"
									_tmp5_ = NULL;
#line 223 "recent-manager-ui.vala"
									filtered_items = g_list_prepend (filtered_items, (_tmp5_ = l, (_tmp5_ == NULL) ? NULL : gtk_recent_info_ref (_tmp5_)));
#line 592 "recent-manager-ui.c"
									e = (g_free (e), NULL);
#line 224 "recent-manager-ui.vala"
									break;
#line 596 "recent-manager-ui.c"
								}
								e = (g_free (e), NULL);
							}
						}
					}
				}
				(l == NULL) ? NULL : (l = (gtk_recent_info_unref (l), NULL));
			}
		}
	}
	/* sort 
	
	  filtered_items = g_list_sort (filtered_items,
	        (GCompareFunc) sort_recents_mru);
	*/
	i = 0;
	{
		GList* info_collection;
		GList* info_it;
#line 235 "recent-manager-ui.vala"
		info_collection = filtered_items;
#line 618 "recent-manager-ui.c"
		for (info_it = info_collection; info_it != NULL; info_it = info_it->next) {
			GtkRecentInfo* _tmp14_;
			GtkRecentInfo* info;
#line 211 "recent-manager-ui.vala"
			_tmp14_ = NULL;
#line 235 "recent-manager-ui.vala"
			info = (_tmp14_ = (GtkRecentInfo*) info_it->data, (_tmp14_ == NULL) ? NULL : gtk_recent_info_ref (_tmp14_));
#line 626 "recent-manager-ui.c"
			{
				char* _tmp9_;
				char* _tmp8_;
				char* _tmp10_;
				char* action_name;
				char* escaped;
				char* label;
				const char* _tmp13_;
				char* uri;
				char* tip;
				GtkAction* action;
				/* clamp */
#line 238 "recent-manager-ui.vala"
				if (i >= self->priv->max_recents) {
#line 641 "recent-manager-ui.c"
					(info == NULL) ? NULL : (info = (gtk_recent_info_unref (info), NULL));
#line 240 "recent-manager-ui.vala"
					break;
#line 645 "recent-manager-ui.c"
				}
#line 242 "recent-manager-ui.vala"
				i++;
#line 820 "glib-2.0.vapi"
				_tmp9_ = NULL;
#line 651 "recent-manager-ui.c"
				_tmp8_ = NULL;
#line 244 "recent-manager-ui.vala"
				_tmp10_ = NULL;
#line 655 "recent-manager-ui.c"
				action_name = (_tmp10_ = g_strconcat (_tmp8_ = g_strconcat ("recent", file_ext[0], NULL), _tmp9_ = g_strdup_printf ("-%d", i), NULL), _tmp9_ = (g_free (_tmp9_), NULL), _tmp8_ = (g_free (_tmp8_), NULL), _tmp10_);
				escaped = g_path_get_basename (gtk_recent_info_get_display_name (info));
				label = NULL;
#line 249 "recent-manager-ui.vala"
				if (i >= 10) {
#line 661 "recent-manager-ui.c"
					char* _tmp11_;
					_tmp11_ = NULL;
#line 251 "recent-manager-ui.vala"
					label = (_tmp11_ = g_strdup_printf ("%d.  %s", i, escaped), label = (g_free (label), NULL), _tmp11_);
#line 666 "recent-manager-ui.c"
				} else {
					char* _tmp12_;
					_tmp12_ = NULL;
#line 255 "recent-manager-ui.vala"
					label = (_tmp12_ = g_strdup_printf ("_%d.  %s", i, escaped), label = (g_free (label), NULL), _tmp12_);
#line 672 "recent-manager-ui.c"
				}
#line 258 "recent-manager-ui.vala"
				_tmp13_ = NULL;
#line 676 "recent-manager-ui.c"
				uri = (_tmp13_ = gtk_recent_info_get_uri_display (info), (_tmp13_ == NULL) ? NULL : g_strdup (_tmp13_));
				/* Translators: %s is a URI */
				tip = g_strdup_printf (_ ("Open '%s'"), uri);
				action = gtk_action_new (action_name, label, tip, NULL);
#line 264 "recent-manager-ui.vala"
				g_object_set_data_full ((GObject*) action, "gtk-recent-info", info, NULL);
#line 266 "recent-manager-ui.vala"
				g_signal_connect_object (action, "activate", (GCallback) _valide_recent_manager_ui_recents_menu_activate_gtk_action_activate, self, 0);
#line 267 "recent-manager-ui.vala"
				gtk_action_group_add_action (self->priv->recents_action_group, action);
#line 269 "recent-manager-ui.vala"
				gtk_ui_manager_add_ui ((GtkUIManager*) ui_manager, (*id), ui_path, action_name, action_name, GTK_UI_MANAGER_MENUITEM, FALSE);
#line 689 "recent-manager-ui.c"
				(info == NULL) ? NULL : (info = (gtk_recent_info_unref (info), NULL));
				action_name = (g_free (action_name), NULL);
				escaped = (g_free (escaped), NULL);
				label = (g_free (label), NULL);
				uri = (g_free (uri), NULL);
				tip = (g_free (tip), NULL);
				(action == NULL) ? NULL : (action = (g_object_unref (action), NULL));
			}
		}
	}
	(recent_manager == NULL) ? NULL : (recent_manager = (g_object_unref (recent_manager), NULL));
	(filtered_items == NULL) ? NULL : (filtered_items = (_g_list_free_gtk_recent_info_unref (filtered_items), NULL));
}


/**
   * Create a new Valide.RecentManagerIU
   *
   * @param ui_manager The ui manager
   * @param documents The document manager
   * @param projects The projects manager
   */
#line 281 "recent-manager-ui.vala"
ValideRecentManagerUI* valide_recent_manager_ui_construct (GType object_type, ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideProjectManager* projects) {
#line 714 "recent-manager-ui.c"
	GParameter * __params;
	GParameter * __params_it;
	ValideRecentManagerUI * self;
#line 281 "recent-manager-ui.vala"
	g_return_val_if_fail (ui_manager != NULL, NULL);
#line 281 "recent-manager-ui.vala"
	g_return_val_if_fail (documents != NULL, NULL);
#line 281 "recent-manager-ui.vala"
	g_return_val_if_fail (projects != NULL, NULL);
#line 724 "recent-manager-ui.c"
	__params = g_new0 (GParameter, 3);
	__params_it = __params;
#line 284 "recent-manager-ui.vala"
	__params_it->name = "ui-manager";
#line 284 "recent-manager-ui.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_UI_MANAGER);
#line 284 "recent-manager-ui.vala"
	g_value_set_object (&__params_it->value, ui_manager);
#line 284 "recent-manager-ui.vala"
	__params_it++;
#line 285 "recent-manager-ui.vala"
	__params_it->name = "documents";
#line 285 "recent-manager-ui.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_DOCUMENT_MANAGER);
#line 285 "recent-manager-ui.vala"
	g_value_set_object (&__params_it->value, documents);
#line 285 "recent-manager-ui.vala"
	__params_it++;
#line 286 "recent-manager-ui.vala"
	__params_it->name = "projects";
#line 286 "recent-manager-ui.vala"
	g_value_init (&__params_it->value, VALIDE_TYPE_PROJECT_MANAGER);
#line 286 "recent-manager-ui.vala"
	g_value_set_object (&__params_it->value, projects);
#line 286 "recent-manager-ui.vala"
	__params_it++;
#line 751 "recent-manager-ui.c"
	self = g_object_newv (object_type, __params_it - __params, __params);
	while (__params_it > __params) {
		--__params_it;
		g_value_unset (&__params_it->value);
	}
	g_free (__params);
	return self;
}


#line 281 "recent-manager-ui.vala"
ValideRecentManagerUI* valide_recent_manager_ui_new (ValideUIManager* ui_manager, ValideDocumentManager* documents, ValideProjectManager* projects) {
#line 281 "recent-manager-ui.vala"
	return valide_recent_manager_ui_construct (VALIDE_TYPE_RECENT_MANAGER_UI, ui_manager, documents, projects);
#line 766 "recent-manager-ui.c"
}


/**
   * Add a file
   */
#line 302 "recent-manager-ui.vala"
void valide_recent_manager_ui_add_file (ValideRecentManagerUI* self, const char* uri) {
#line 302 "recent-manager-ui.vala"
	g_return_if_fail (self != NULL);
#line 302 "recent-manager-ui.vala"
	g_return_if_fail (uri != NULL);
#line 304 "recent-manager-ui.vala"
	if (g_str_has_suffix (uri, ".vala")) {
#line 306 "recent-manager-ui.vala"
		valide_recent_manager_ui_add (self, uri, "vala");
#line 783 "recent-manager-ui.c"
	}
#line 308 "recent-manager-ui.vala"
	if (g_str_has_suffix (uri, ".vapi")) {
#line 310 "recent-manager-ui.vala"
		valide_recent_manager_ui_add (self, uri, "vapi");
#line 789 "recent-manager-ui.c"
	} else {
#line 312 "recent-manager-ui.vala"
		if (g_str_has_suffix (uri, ".gs")) {
#line 314 "recent-manager-ui.vala"
			valide_recent_manager_ui_add (self, uri, "genie");
#line 795 "recent-manager-ui.c"
		}
	}
#line 316 "recent-manager-ui.vala"
	valide_recent_manager_ui_update_file (self);
#line 800 "recent-manager-ui.c"
}


/**
   * Add a project
   */
#line 322 "recent-manager-ui.vala"
void valide_recent_manager_ui_add_project (ValideRecentManagerUI* self, const char* uri) {
#line 322 "recent-manager-ui.vala"
	g_return_if_fail (self != NULL);
#line 322 "recent-manager-ui.vala"
	g_return_if_fail (uri != NULL);
#line 324 "recent-manager-ui.vala"
	valide_recent_manager_ui_add (self, uri, "vide");
#line 325 "recent-manager-ui.vala"
	valide_recent_manager_ui_update_project (self);
#line 817 "recent-manager-ui.c"
}


/**
   * Update the recent files
   */
#line 331 "recent-manager-ui.vala"
void valide_recent_manager_ui_update_file (ValideRecentManagerUI* self) {
#line 826 "recent-manager-ui.c"
	char** _tmp1_;
	gint ext_size;
	gint ext_length1;
	char** _tmp0_;
	char** ext;
#line 331 "recent-manager-ui.vala"
	g_return_if_fail (self != NULL);
#line 333 "recent-manager-ui.vala"
	_tmp1_ = NULL;
#line 333 "recent-manager-ui.vala"
	_tmp0_ = NULL;
#line 838 "recent-manager-ui.c"
	ext = (_tmp1_ = (_tmp0_ = g_new0 (char*, 3 + 1), _tmp0_[0] = g_strdup (".vala"), _tmp0_[1] = g_strdup (".vapi"), _tmp0_[2] = g_strdup (".gs"), _tmp0_), ext_length1 = 3, ext_size = ext_length1, _tmp1_);
#line 335 "recent-manager-ui.vala"
	valide_recent_manager_ui_update (self, self->priv->_ui_manager, ext, ext_length1, "/menubar/file/file-recents-placeholder", &self->priv->id_file);
#line 337 "recent-manager-ui.vala"
	g_signal_emit_by_name (self, "update-recent-files");
#line 844 "recent-manager-ui.c"
	ext = (_vala_array_free (ext, ext_length1, (GDestroyNotify) g_free), NULL);
}


/**
   * Update the recent projects
   */
#line 343 "recent-manager-ui.vala"
void valide_recent_manager_ui_update_project (ValideRecentManagerUI* self) {
#line 854 "recent-manager-ui.c"
	char** _tmp1_;
	gint ext_size;
	gint ext_length1;
	char** _tmp0_;
	char** ext;
#line 343 "recent-manager-ui.vala"
	g_return_if_fail (self != NULL);
#line 345 "recent-manager-ui.vala"
	_tmp1_ = NULL;
#line 345 "recent-manager-ui.vala"
	_tmp0_ = NULL;
#line 866 "recent-manager-ui.c"
	ext = (_tmp1_ = (_tmp0_ = g_new0 (char*, 1 + 1), _tmp0_[0] = g_strdup (".vide"), _tmp0_), ext_length1 = 1, ext_size = ext_length1, _tmp1_);
#line 347 "recent-manager-ui.vala"
	valide_recent_manager_ui_update (self, self->priv->_ui_manager, ext, ext_length1, "/menubar/project/project-recents-placeholder", &self->priv->id_project);
#line 349 "recent-manager-ui.vala"
	g_signal_emit_by_name (self, "update-recent-projects");
#line 872 "recent-manager-ui.c"
	ext = (_vala_array_free (ext, ext_length1, (GDestroyNotify) g_free), NULL);
}


ValideUIManager* valide_recent_manager_ui_get_ui_manager (ValideRecentManagerUI* self) {
	ValideUIManager* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_ui_manager;
	return result;
}


static void valide_recent_manager_ui_set_ui_manager (ValideRecentManagerUI* self, ValideUIManager* value) {
	ValideUIManager* _tmp1_;
	ValideUIManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 48 "recent-manager-ui.vala"
	_tmp0_ = NULL;
#line 892 "recent-manager-ui.c"
	self->priv->_ui_manager = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_ui_manager == NULL) ? NULL : (self->priv->_ui_manager = (g_object_unref (self->priv->_ui_manager), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "ui-manager");
}


ValideDocumentManager* valide_recent_manager_ui_get_documents (ValideRecentManagerUI* self) {
	ValideDocumentManager* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_documents;
	return result;
}


static void valide_recent_manager_ui_set_documents (ValideRecentManagerUI* self, ValideDocumentManager* value) {
	ValideDocumentManager* _tmp1_;
	ValideDocumentManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 57 "recent-manager-ui.vala"
	_tmp0_ = NULL;
#line 913 "recent-manager-ui.c"
	self->priv->_documents = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_documents == NULL) ? NULL : (self->priv->_documents = (g_object_unref (self->priv->_documents), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "documents");
}


ValideProjectManager* valide_recent_manager_ui_get_projects (ValideRecentManagerUI* self) {
	ValideProjectManager* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self->priv->_projects;
	return result;
}


static void valide_recent_manager_ui_set_projects (ValideRecentManagerUI* self, ValideProjectManager* value) {
	ValideProjectManager* _tmp1_;
	ValideProjectManager* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp1_ = NULL;
#line 66 "recent-manager-ui.vala"
	_tmp0_ = NULL;
#line 934 "recent-manager-ui.c"
	self->priv->_projects = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_projects == NULL) ? NULL : (self->priv->_projects = (g_object_unref (self->priv->_projects), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "projects");
}


GList* valide_recent_manager_ui_get_recent_files (ValideRecentManagerUI* self) {
	GList* result;
	gint nb_items;
	GList* items;
	GtkRecentManager* recent_manager;
	GList* _tmp0_;
	GtkRecentManager* _tmp2_;
	GtkRecentManager* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	nb_items = 0;
	items = NULL;
	recent_manager = NULL;
	_tmp0_ = NULL;
#line 81 "recent-manager-ui.vala"
	self->priv->_recent_files = (_tmp0_ = NULL, (self->priv->_recent_files == NULL) ? NULL : (self->priv->_recent_files = (_g_list_free_gtk_recent_info_unref (self->priv->_recent_files), NULL)), _tmp0_);
#line 955 "recent-manager-ui.c"
	_tmp2_ = NULL;
#line 82 "recent-manager-ui.vala"
	_tmp1_ = NULL;
#line 82 "recent-manager-ui.vala"
	recent_manager = (_tmp2_ = (_tmp1_ = gtk_recent_manager_get_default (), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_)), (recent_manager == NULL) ? NULL : (recent_manager = (g_object_unref (recent_manager), NULL)), _tmp2_);
#line 83 "recent-manager-ui.vala"
	items = gtk_recent_manager_get_items (recent_manager);
#line 963 "recent-manager-ui.c"
	/* filter */
	{
		GList* l_collection;
		GList* l_it;
#line 85 "recent-manager-ui.vala"
		l_collection = items;
#line 970 "recent-manager-ui.c"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
			GtkRecentInfo* _tmp8_;
			GtkRecentInfo* l;
#line 78 "recent-manager-ui.vala"
			_tmp8_ = NULL;
#line 85 "recent-manager-ui.vala"
			l = (_tmp8_ = (GtkRecentInfo*) l_it->data, (_tmp8_ == NULL) ? NULL : gtk_recent_info_ref (_tmp8_));
#line 978 "recent-manager-ui.c"
			{
				gboolean _tmp3_;
				gboolean _tmp4_;
				_tmp3_ = FALSE;
				_tmp4_ = FALSE;
#line 87 "recent-manager-ui.vala"
				if (gtk_recent_info_has_group (l, "valide")) {
#line 87 "recent-manager-ui.vala"
					_tmp4_ = g_file_test (gtk_recent_info_get_uri (l), G_FILE_TEST_EXISTS);
#line 988 "recent-manager-ui.c"
				} else {
#line 87 "recent-manager-ui.vala"
					_tmp4_ = FALSE;
#line 992 "recent-manager-ui.c"
				}
#line 87 "recent-manager-ui.vala"
				if (_tmp4_) {
#line 996 "recent-manager-ui.c"
					gboolean _tmp5_;
					gboolean _tmp6_;
					_tmp5_ = FALSE;
					_tmp6_ = FALSE;
#line 88 "recent-manager-ui.vala"
					if (g_str_has_suffix (gtk_recent_info_get_uri (l), ".vala")) {
#line 88 "recent-manager-ui.vala"
						_tmp6_ = TRUE;
#line 1005 "recent-manager-ui.c"
					} else {
#line 89 "recent-manager-ui.vala"
						_tmp6_ = g_str_has_suffix (gtk_recent_info_get_uri (l), ".vapi");
#line 1009 "recent-manager-ui.c"
					}
#line 88 "recent-manager-ui.vala"
					if (_tmp6_) {
#line 88 "recent-manager-ui.vala"
						_tmp5_ = TRUE;
#line 1015 "recent-manager-ui.c"
					} else {
#line 90 "recent-manager-ui.vala"
						_tmp5_ = g_str_has_suffix (gtk_recent_info_get_uri (l), ".gs");
#line 1019 "recent-manager-ui.c"
					}
#line 88 "recent-manager-ui.vala"
					_tmp3_ = _tmp5_;
#line 1023 "recent-manager-ui.c"
				} else {
#line 87 "recent-manager-ui.vala"
					_tmp3_ = FALSE;
#line 1027 "recent-manager-ui.c"
				}
#line 87 "recent-manager-ui.vala"
				if (_tmp3_) {
#line 1031 "recent-manager-ui.c"
					GtkRecentInfo* _tmp7_;
#line 92 "recent-manager-ui.vala"
					_tmp7_ = NULL;
#line 92 "recent-manager-ui.vala"
					self->priv->_recent_files = g_list_prepend (self->priv->_recent_files, (_tmp7_ = l, (_tmp7_ == NULL) ? NULL : gtk_recent_info_ref (_tmp7_)));
#line 93 "recent-manager-ui.vala"
					nb_items++;
#line 94 "recent-manager-ui.vala"
					if (nb_items >= self->priv->max_recents) {
#line 1041 "recent-manager-ui.c"
						(l == NULL) ? NULL : (l = (gtk_recent_info_unref (l), NULL));
#line 96 "recent-manager-ui.vala"
						break;
#line 1045 "recent-manager-ui.c"
					}
				}
				(l == NULL) ? NULL : (l = (gtk_recent_info_unref (l), NULL));
			}
		}
	}
	/* sort 
	
	    _recent_files = g_list_sort (_recent_files,
	          (GCompareFunc) sort_recents_mru);
	*/
	result = self->priv->_recent_files;
	(recent_manager == NULL) ? NULL : (recent_manager = (g_object_unref (recent_manager), NULL));
	return result;
}


GList* valide_recent_manager_ui_get_recent_projects (ValideRecentManagerUI* self) {
	GList* result;
	gint nb_items;
	GList* items;
	GtkRecentManager* recent_manager;
	GList* _tmp0_;
	GtkRecentManager* _tmp2_;
	GtkRecentManager* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	nb_items = 0;
	items = NULL;
	recent_manager = NULL;
	_tmp0_ = NULL;
#line 121 "recent-manager-ui.vala"
	self->priv->_recent_projects = (_tmp0_ = NULL, (self->priv->_recent_projects == NULL) ? NULL : (self->priv->_recent_projects = (_g_list_free_gtk_recent_info_unref (self->priv->_recent_projects), NULL)), _tmp0_);
#line 1078 "recent-manager-ui.c"
	/* filter */
	_tmp2_ = NULL;
#line 123 "recent-manager-ui.vala"
	_tmp1_ = NULL;
#line 123 "recent-manager-ui.vala"
	recent_manager = (_tmp2_ = (_tmp1_ = gtk_recent_manager_get_default (), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_)), (recent_manager == NULL) ? NULL : (recent_manager = (g_object_unref (recent_manager), NULL)), _tmp2_);
#line 124 "recent-manager-ui.vala"
	items = gtk_recent_manager_get_items (recent_manager);
#line 1087 "recent-manager-ui.c"
	{
		GList* l_collection;
		GList* l_it;
#line 125 "recent-manager-ui.vala"
		l_collection = items;
#line 1093 "recent-manager-ui.c"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
			GtkRecentInfo* _tmp6_;
			GtkRecentInfo* l;
#line 118 "recent-manager-ui.vala"
			_tmp6_ = NULL;
#line 125 "recent-manager-ui.vala"
			l = (_tmp6_ = (GtkRecentInfo*) l_it->data, (_tmp6_ == NULL) ? NULL : gtk_recent_info_ref (_tmp6_));
#line 1101 "recent-manager-ui.c"
			{
				gboolean _tmp3_;
				gboolean _tmp4_;
				_tmp3_ = FALSE;
				_tmp4_ = FALSE;
#line 127 "recent-manager-ui.vala"
				if (gtk_recent_info_has_group (l, "valide")) {
#line 127 "recent-manager-ui.vala"
					_tmp4_ = g_file_test (gtk_recent_info_get_uri (l), G_FILE_TEST_EXISTS);
#line 1111 "recent-manager-ui.c"
				} else {
#line 127 "recent-manager-ui.vala"
					_tmp4_ = FALSE;
#line 1115 "recent-manager-ui.c"
				}
#line 127 "recent-manager-ui.vala"
				if (_tmp4_) {
#line 128 "recent-manager-ui.vala"
					_tmp3_ = g_str_has_suffix (gtk_recent_info_get_uri (l), ".vide");
#line 1121 "recent-manager-ui.c"
				} else {
#line 127 "recent-manager-ui.vala"
					_tmp3_ = FALSE;
#line 1125 "recent-manager-ui.c"
				}
#line 127 "recent-manager-ui.vala"
				if (_tmp3_) {
#line 1129 "recent-manager-ui.c"
					GtkRecentInfo* _tmp5_;
#line 130 "recent-manager-ui.vala"
					_tmp5_ = NULL;
#line 130 "recent-manager-ui.vala"
					self->priv->_recent_projects = g_list_prepend (self->priv->_recent_projects, (_tmp5_ = l, (_tmp5_ == NULL) ? NULL : gtk_recent_info_ref (_tmp5_)));
#line 131 "recent-manager-ui.vala"
					nb_items++;
#line 132 "recent-manager-ui.vala"
					if (nb_items >= self->priv->max_recents) {
#line 1139 "recent-manager-ui.c"
						(l == NULL) ? NULL : (l = (gtk_recent_info_unref (l), NULL));
#line 134 "recent-manager-ui.vala"
						break;
#line 1143 "recent-manager-ui.c"
					}
				}
				(l == NULL) ? NULL : (l = (gtk_recent_info_unref (l), NULL));
			}
		}
	}
	/* sort 
	
	    _recent_projects = g_list_sort (_recent_projects,
	          (GCompareFunc) sort_recents_mru);
	*/
	result = self->priv->_recent_projects;
	(recent_manager == NULL) ? NULL : (recent_manager = (g_object_unref (recent_manager), NULL));
	return result;
}


static void _lambda39_ (ValideDocumentManager* s, ValideiDocument* d, ValideRecentManagerUI* self) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (d != NULL);
#line 292 "recent-manager-ui.vala"
	valide_recent_manager_ui_add_file (self, valide_idocument_get_path (d));
#line 1166 "recent-manager-ui.c"
}


static void __lambda39__valide_document_manager_tab_added (ValideDocumentManager* _sender, ValideiDocument* document, gpointer self) {
	_lambda39_ (_sender, document, self);
}


static void _lambda40_ (ValideProjectManager* s, ValideProject* p, ValideRecentManagerUI* self) {
	g_return_if_fail (s != NULL);
	g_return_if_fail (p != NULL);
#line 295 "recent-manager-ui.vala"
	valide_recent_manager_ui_add_project (self, p->filename);
#line 1180 "recent-manager-ui.c"
}


static void __lambda40__valide_project_manager_project_opened (ValideProjectManager* _sender, ValideProject* project, gpointer self) {
	_lambda40_ (_sender, project, self);
}


static GObject * valide_recent_manager_ui_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	ValideRecentManagerUIClass * klass;
	GObjectClass * parent_class;
	ValideRecentManagerUI * self;
	klass = VALIDE_RECENT_MANAGER_UI_CLASS (g_type_class_peek (VALIDE_TYPE_RECENT_MANAGER_UI));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = VALIDE_RECENT_MANAGER_UI (obj);
	{
#line 291 "recent-manager-ui.vala"
		g_signal_connect (self->priv->_documents, "tab-added", (GCallback) __lambda39__valide_document_manager_tab_added, self);
#line 294 "recent-manager-ui.vala"
		g_signal_connect (self->priv->_projects, "project-opened", (GCallback) __lambda40__valide_project_manager_project_opened, self);
#line 1203 "recent-manager-ui.c"
	}
	return obj;
}


static void valide_recent_manager_ui_class_init (ValideRecentManagerUIClass * klass) {
	valide_recent_manager_ui_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValideRecentManagerUIPrivate));
	G_OBJECT_CLASS (klass)->get_property = valide_recent_manager_ui_get_property;
	G_OBJECT_CLASS (klass)->set_property = valide_recent_manager_ui_set_property;
	G_OBJECT_CLASS (klass)->constructor = valide_recent_manager_ui_constructor;
	G_OBJECT_CLASS (klass)->finalize = valide_recent_manager_ui_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_RECENT_MANAGER_UI_UI_MANAGER, g_param_spec_object ("ui-manager", "ui-manager", "ui-manager", VALIDE_TYPE_UI_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_RECENT_MANAGER_UI_DOCUMENTS, g_param_spec_object ("documents", "documents", "documents", VALIDE_TYPE_DOCUMENT_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_RECENT_MANAGER_UI_PROJECTS, g_param_spec_object ("projects", "projects", "projects", VALIDE_TYPE_PROJECT_MANAGER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_RECENT_MANAGER_UI_RECENT_FILES, g_param_spec_pointer ("recent-files", "recent-files", "recent-files", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALIDE_RECENT_MANAGER_UI_RECENT_PROJECTS, g_param_spec_pointer ("recent-projects", "recent-projects", "recent-projects", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("update_recent_files", VALIDE_TYPE_RECENT_MANAGER_UI, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("update_recent_projects", VALIDE_TYPE_RECENT_MANAGER_UI, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void valide_recent_manager_ui_instance_init (ValideRecentManagerUI * self) {
	self->priv = VALIDE_RECENT_MANAGER_UI_GET_PRIVATE (self);
	self->priv->id_file = (guint) 0;
	self->priv->id_project = (guint) 0;
	self->priv->max_recents = 5;
	self->priv->_recent_files = NULL;
	self->priv->_recent_projects = NULL;
}


static void valide_recent_manager_ui_finalize (GObject* obj) {
	ValideRecentManagerUI * self;
	self = VALIDE_RECENT_MANAGER_UI (obj);
	(self->priv->recents_action_group == NULL) ? NULL : (self->priv->recents_action_group = (g_object_unref (self->priv->recents_action_group), NULL));
	(self->priv->_ui_manager == NULL) ? NULL : (self->priv->_ui_manager = (g_object_unref (self->priv->_ui_manager), NULL));
	(self->priv->_documents == NULL) ? NULL : (self->priv->_documents = (g_object_unref (self->priv->_documents), NULL));
	(self->priv->_projects == NULL) ? NULL : (self->priv->_projects = (g_object_unref (self->priv->_projects), NULL));
	(self->priv->_recent_files == NULL) ? NULL : (self->priv->_recent_files = (_g_list_free_gtk_recent_info_unref (self->priv->_recent_files), NULL));
	(self->priv->_recent_projects == NULL) ? NULL : (self->priv->_recent_projects = (_g_list_free_gtk_recent_info_unref (self->priv->_recent_projects), NULL));
	G_OBJECT_CLASS (valide_recent_manager_ui_parent_class)->finalize (obj);
}


GType valide_recent_manager_ui_get_type (void) {
	static GType valide_recent_manager_ui_type_id = 0;
	if (valide_recent_manager_ui_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValideRecentManagerUIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valide_recent_manager_ui_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValideRecentManagerUI), 0, (GInstanceInitFunc) valide_recent_manager_ui_instance_init, NULL };
		valide_recent_manager_ui_type_id = g_type_register_static (G_TYPE_OBJECT, "ValideRecentManagerUI", &g_define_type_info, 0);
	}
	return valide_recent_manager_ui_type_id;
}


static void valide_recent_manager_ui_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValideRecentManagerUI * self;
	gpointer boxed;
	self = VALIDE_RECENT_MANAGER_UI (object);
	switch (property_id) {
		case VALIDE_RECENT_MANAGER_UI_UI_MANAGER:
		g_value_set_object (value, valide_recent_manager_ui_get_ui_manager (self));
		break;
		case VALIDE_RECENT_MANAGER_UI_DOCUMENTS:
		g_value_set_object (value, valide_recent_manager_ui_get_documents (self));
		break;
		case VALIDE_RECENT_MANAGER_UI_PROJECTS:
		g_value_set_object (value, valide_recent_manager_ui_get_projects (self));
		break;
		case VALIDE_RECENT_MANAGER_UI_RECENT_FILES:
		g_value_set_pointer (value, valide_recent_manager_ui_get_recent_files (self));
		break;
		case VALIDE_RECENT_MANAGER_UI_RECENT_PROJECTS:
		g_value_set_pointer (value, valide_recent_manager_ui_get_recent_projects (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void valide_recent_manager_ui_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValideRecentManagerUI * self;
	self = VALIDE_RECENT_MANAGER_UI (object);
	switch (property_id) {
		case VALIDE_RECENT_MANAGER_UI_UI_MANAGER:
		valide_recent_manager_ui_set_ui_manager (self, g_value_get_object (value));
		break;
		case VALIDE_RECENT_MANAGER_UI_DOCUMENTS:
		valide_recent_manager_ui_set_documents (self, g_value_get_object (value));
		break;
		case VALIDE_RECENT_MANAGER_UI_PROJECTS:
		valide_recent_manager_ui_set_projects (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}




