/* completion.vala
 *
 * Copyright (C) 2008-2009  Nicolas Joseph
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Author:
 * 	Nicolas Joseph <nicolas.joseph@valaide.org>
 */

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <gdk-pixbuf/gdk-pixdata.h>
#include <gee.h>
#include <gdk/gdkkeysyms.h>


#define VALENCIA_TYPE_SCAN_INFO (valencia_scan_info_get_type ())
#define VALENCIA_SCAN_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCAN_INFO, ValenciaScanInfo))
#define VALENCIA_SCAN_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SCAN_INFO, ValenciaScanInfoClass))
#define VALENCIA_IS_SCAN_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCAN_INFO))
#define VALENCIA_IS_SCAN_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SCAN_INFO))
#define VALENCIA_SCAN_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SCAN_INFO, ValenciaScanInfoClass))

typedef struct _ValenciaScanInfo ValenciaScanInfo;
typedef struct _ValenciaScanInfoClass ValenciaScanInfoClass;
typedef struct _ValenciaScanInfoPrivate ValenciaScanInfoPrivate;

#define VALENCIA_TYPE_PARSE_INFO (valencia_parse_info_get_type ())
#define VALENCIA_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfo))
#define VALENCIA_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))
#define VALENCIA_IS_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_IS_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_PARSE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))

typedef struct _ValenciaParseInfo ValenciaParseInfo;
typedef struct _ValenciaParseInfoClass ValenciaParseInfoClass;

#define VALENCIA_TYPE_NODE (valencia_node_get_type ())
#define VALENCIA_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NODE, ValenciaNode))
#define VALENCIA_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NODE, ValenciaNodeClass))
#define VALENCIA_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NODE))
#define VALENCIA_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NODE))
#define VALENCIA_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NODE, ValenciaNodeClass))

typedef struct _ValenciaNode ValenciaNode;
typedef struct _ValenciaNodeClass ValenciaNodeClass;

#define VALENCIA_TYPE_SYMBOL (valencia_symbol_get_type ())
#define VALENCIA_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbol))
#define VALENCIA_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))
#define VALENCIA_IS_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_IS_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))

typedef struct _ValenciaSymbol ValenciaSymbol;
typedef struct _ValenciaSymbolClass ValenciaSymbolClass;

#define VALENCIA_TYPE_METHOD (valencia_method_get_type ())
#define VALENCIA_METHOD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_METHOD, ValenciaMethod))
#define VALENCIA_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_METHOD, ValenciaMethodClass))
#define VALENCIA_IS_METHOD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_METHOD))
#define VALENCIA_IS_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_METHOD))
#define VALENCIA_METHOD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_METHOD, ValenciaMethodClass))

typedef struct _ValenciaMethod ValenciaMethod;
typedef struct _ValenciaMethodClass ValenciaMethodClass;
typedef struct _ValenciaParseInfoPrivate ValenciaParseInfoPrivate;

#define VALENCIA_TYPE_EXPRESSION (valencia_expression_get_type ())
#define VALENCIA_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpression))
#define VALENCIA_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))
#define VALENCIA_IS_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_IS_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))

typedef struct _ValenciaExpression ValenciaExpression;
typedef struct _ValenciaExpressionClass ValenciaExpressionClass;

#define TYPE_COMPLETION (completion_get_type ())
#define COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION, Completion))
#define COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION, CompletionClass))
#define IS_COMPLETION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION))
#define IS_COMPLETION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION))
#define COMPLETION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION, CompletionClass))

typedef struct _Completion Completion;
typedef struct _CompletionClass CompletionClass;
typedef struct _CompletionPrivate CompletionPrivate;

#define TYPE_POPUP (popup_get_type ())
#define POPUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_POPUP, Popup))
#define POPUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_POPUP, PopupClass))
#define IS_POPUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_POPUP))
#define IS_POPUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_POPUP))
#define POPUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_POPUP, PopupClass))

typedef struct _Popup Popup;
typedef struct _PopupClass PopupClass;

#define TYPE_CALLTIPS (calltips_get_type ())
#define CALLTIPS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CALLTIPS, Calltips))
#define CALLTIPS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CALLTIPS, CalltipsClass))
#define IS_CALLTIPS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CALLTIPS))
#define IS_CALLTIPS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CALLTIPS))
#define CALLTIPS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CALLTIPS, CalltipsClass))

typedef struct _Calltips Calltips;
typedef struct _CalltipsClass CalltipsClass;

#define TYPE_PAIR (pair_get_type ())
#define PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAIR, Pair))
#define PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAIR, PairClass))
#define IS_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAIR))
#define IS_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAIR))
#define PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAIR, PairClass))

typedef struct _Pair Pair;
typedef struct _PairClass PairClass;

#define VALENCIA_TYPE_EXPRESSION_PARSER (valencia_expression_parser_get_type ())
#define VALENCIA_EXPRESSION_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_EXPRESSION_PARSER, ValenciaExpressionParser))
#define VALENCIA_EXPRESSION_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_EXPRESSION_PARSER, ValenciaExpressionParserClass))
#define VALENCIA_IS_EXPRESSION_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_EXPRESSION_PARSER))
#define VALENCIA_IS_EXPRESSION_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_EXPRESSION_PARSER))
#define VALENCIA_EXPRESSION_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_EXPRESSION_PARSER, ValenciaExpressionParserClass))

typedef struct _ValenciaExpressionParser ValenciaExpressionParser;
typedef struct _ValenciaExpressionParserClass ValenciaExpressionParserClass;

#define VALENCIA_TYPE_PROGRAM (valencia_program_get_type ())
#define VALENCIA_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgram))
#define VALENCIA_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))
#define VALENCIA_IS_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_IS_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_PROGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))

typedef struct _ValenciaProgram ValenciaProgram;
typedef struct _ValenciaProgramClass ValenciaProgramClass;

#define VALENCIA_TYPE_SOURCE_FILE (valencia_source_file_get_type ())
#define VALENCIA_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFile))
#define VALENCIA_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))
#define VALENCIA_IS_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_IS_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_SOURCE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))

typedef struct _ValenciaSourceFile ValenciaSourceFile;
typedef struct _ValenciaSourceFileClass ValenciaSourceFileClass;

#define VALENCIA_TYPE_SYMBOL_SET (valencia_symbol_set_get_type ())
#define VALENCIA_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSet))
#define VALENCIA_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))
#define VALENCIA_IS_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_IS_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_SYMBOL_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))

typedef struct _ValenciaSymbolSet ValenciaSymbolSet;
typedef struct _ValenciaSymbolSetClass ValenciaSymbolSetClass;

#define VALENCIA_TYPE_ID (valencia_id_get_type ())
#define VALENCIA_ID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ID, ValenciaId))
#define VALENCIA_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ID, ValenciaIdClass))
#define VALENCIA_IS_ID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ID))
#define VALENCIA_IS_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ID))
#define VALENCIA_ID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ID, ValenciaIdClass))

typedef struct _ValenciaId ValenciaId;
typedef struct _ValenciaIdClass ValenciaIdClass;

#define TYPE_PROPOSAL (proposal_get_type ())
#define PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PROPOSAL, Proposal))
#define PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PROPOSAL, ProposalClass))
#define IS_PROPOSAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PROPOSAL))
#define IS_PROPOSAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PROPOSAL))
#define PROPOSAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PROPOSAL, ProposalClass))

typedef struct _Proposal Proposal;
typedef struct _ProposalClass ProposalClass;
typedef struct _ValenciaNodePrivate ValenciaNodePrivate;
typedef struct _ValenciaSymbolPrivate ValenciaSymbolPrivate;

#define VALENCIA_TYPE_SCOPE (valencia_scope_get_type ())
#define VALENCIA_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCOPE, ValenciaScope))
#define VALENCIA_IS_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCOPE))
#define VALENCIA_SCOPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALENCIA_TYPE_SCOPE, ValenciaScopeIface))

typedef struct _ValenciaScope ValenciaScope;
typedef struct _ValenciaScopeIface ValenciaScopeIface;
typedef struct _ValenciaSourceFilePrivate ValenciaSourceFilePrivate;

#define VALENCIA_TYPE_TYPESYMBOL (valencia_typesymbol_get_type ())
#define VALENCIA_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbol))
#define VALENCIA_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))
#define VALENCIA_IS_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_IS_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_TYPESYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))

typedef struct _ValenciaTypeSymbol ValenciaTypeSymbol;
typedef struct _ValenciaTypeSymbolClass ValenciaTypeSymbolClass;

#define VALENCIA_TYPE_NAMESPACE (valencia_namespace_get_type ())
#define VALENCIA_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespace))
#define VALENCIA_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))
#define VALENCIA_IS_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_IS_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_NAMESPACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))

typedef struct _ValenciaNamespace ValenciaNamespace;
typedef struct _ValenciaNamespaceClass ValenciaNamespaceClass;

struct _ValenciaScanInfo {
	GObject parent_instance;
	ValenciaScanInfoPrivate * priv;
	ValenciaParseInfo* parse_info;
	ValenciaMethod* method;
	gint cursor_pos;
};

struct _ValenciaScanInfoClass {
	GObjectClass parent_class;
};

struct _ValenciaParseInfo {
	GObject parent_instance;
	ValenciaParseInfoPrivate * priv;
	ValenciaExpression* inner;
	ValenciaExpression* outer;
	gint outer_pos;
};

struct _ValenciaParseInfoClass {
	GObjectClass parent_class;
};

struct _Completion {
	GObject parent_instance;
	CompletionPrivate * priv;
};

struct _CompletionClass {
	GObjectClass parent_class;
};

struct _CompletionPrivate {
	guint ui_id;
	Popup* popup;
	Calltips* calltips;
	ValideSourceBuffer* buffer;
	GtkActionGroup* action_group;
	GSList* signal_handler_list;
	char* _path;
	ValideWindow* _window;
};

struct _ValenciaNode {
	GObject parent_instance;
	ValenciaNodePrivate * priv;
	gint start;
	gint end;
};

struct _ValenciaNodeClass {
	GObjectClass parent_class;
	GeeArrayList* (*children) (ValenciaNode* self);
	void (*print) (ValenciaNode* self, gint level);
};

struct _ValenciaSymbol {
	ValenciaNode parent_instance;
	ValenciaSymbolPrivate * priv;
	ValenciaSourceFile* source;
	char* name;
};

struct _ValenciaSymbolClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaScopeIface {
	GTypeInterface parent_iface;
	gboolean (*lookup) (ValenciaScope* self, ValenciaSymbolSet* symbols, gint pos);
};

struct _ValenciaSourceFile {
	ValenciaNode parent_instance;
	ValenciaSourceFilePrivate * priv;
	ValenciaProgram* program;
	char* filename;
	GeeArrayList* namespaces;
	ValenciaNamespace* top;
};

struct _ValenciaSourceFileClass {
	ValenciaNodeClass parent_class;
};


static gpointer valencia_scan_info_parent_class = NULL;
static gpointer completion_parent_class = NULL;
static ValidePluginIface* completion_valide_plugin_parent_iface = NULL;

GType valencia_scan_info_get_type (void);
GType valencia_parse_info_get_type (void);
GType valencia_node_get_type (void);
GType valencia_symbol_get_type (void);
GType valencia_method_get_type (void);
enum  {
	VALENCIA_SCAN_INFO_DUMMY_PROPERTY
};
ValenciaScanInfo* valencia_scan_info_new (ValenciaMethod* method, ValenciaParseInfo* parse_info, gint cursor_position);
ValenciaScanInfo* valencia_scan_info_construct (GType object_type, ValenciaMethod* method, ValenciaParseInfo* parse_info, gint cursor_position);
ValenciaScanInfo* valencia_scan_info_new_empty (void);
ValenciaScanInfo* valencia_scan_info_construct_empty (GType object_type);
GType valencia_expression_get_type (void);
ValenciaExpression* valencia_scan_info_inner (ValenciaScanInfo* self);
ValenciaExpression* valencia_scan_info_outer (ValenciaScanInfo* self);
static void valencia_scan_info_finalize (GObject* obj);
GType completion_get_type (void);
GType popup_get_type (void);
GType calltips_get_type (void);
GType pair_get_type (void);
#define COMPLETION_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_COMPLETION, CompletionPrivate))
enum  {
	COMPLETION_DUMMY_PROPERTY,
	COMPLETION_PATH,
	COMPLETION_WINDOW
};
static void _g_slist_free_g_object_unref (GSList* self);
static void completion_on_goto_definition (Completion* self);
static void _completion_on_goto_definition_gtk_action_callback (GtkAction* action, gpointer self);
static void completion_on_autocomplete (Completion* self);
static void _completion_on_autocomplete_gtk_action_callback (GtkAction* action, gpointer self);
#define COMPLETION_ui "\n      <ui>\n        <menubar name=\"menubar\">\n          <menu action=\"search\">\n            <placeholder name=\"search-ops-3\">\n              <menuitem action=\"edit-goto-definition\"/>\n              <separator/>\n              <menuitem action=\"edit-autocomplete\"/>\n            </placeholder>\n          </menu>\n        </menubar>\n      </ui>"
static void completion_get_window_position_in_cursor (Completion* self, GtkWindow* window, gint* x, gint* y);
static void completion_get_cursor_pos (Completion* self, GtkTextView* text_view, gint* x, gint* y);
static GdkPixbuf* completion_valencia_type_to_icon (Completion* self, ValenciaSymbol* symbol);
static void completion_get_buffer_info (Completion* self, ValideSourceBuffer* buffer, gint* pos, char** contents);
ValenciaExpressionParser* valencia_expression_parser_new (const char* input, gint pos, gboolean partial);
ValenciaExpressionParser* valencia_expression_parser_construct (GType object_type, const char* input, gint pos, gboolean partial);
gpointer valencia_expression_parser_ref (gpointer instance);
void valencia_expression_parser_unref (gpointer instance);
GParamSpec* valencia_param_spec_expression_parser (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valencia_value_set_expression_parser (GValue* value, gpointer v_object);
gpointer valencia_value_get_expression_parser (const GValue* value);
GType valencia_expression_parser_get_type (void);
ValenciaParseInfo* valencia_expression_parser_parse (ValenciaExpressionParser* self);
GType valencia_program_get_type (void);
ValenciaProgram* valencia_program_find_containing (const char* path, gboolean parse_system_vapi);
GType valencia_source_file_get_type (void);
ValenciaSourceFile* valencia_program_find_source (ValenciaProgram* self, const char* path);
ValenciaSymbol* valencia_source_file_resolve (ValenciaSourceFile* self, ValenciaExpression* name, gint pos, gboolean constructor);
static ValenciaScanInfo* completion_get_scan_info (Completion* self, gboolean partial);
char* valencia_method_to_string (ValenciaMethod* self);
void calltips_set_text (Calltips* self, const char* value);
GType valencia_symbol_set_get_type (void);
ValenciaId* valencia_id_new (const char* name);
ValenciaId* valencia_id_construct (GType object_type, const char* name);
GType valencia_id_get_type (void);
ValenciaSymbolSet* valencia_source_file_resolve_prefix (ValenciaSourceFile* self, ValenciaExpression* prefix, gint pos, gboolean constructor);
GeeHashSet* valencia_symbol_set_get_symbols (ValenciaSymbolSet* self);
GType proposal_get_type (void);
static void _g_list_free_g_object_unref (GList* self);
Proposal* proposal_new (const char* label, GdkPixbuf* icon);
Proposal* proposal_construct (GType object_type, const char* label, GdkPixbuf* icon);
void popup_set_proposals (Popup* self, GList* value);
void popup_show (Popup* self);
void popup_clear (Popup* self);
static void completion_on_parse_end (Completion* self);
void popup_hide (Popup* self);
static void completion_hide_popup (Completion* self);
gboolean valencia_program_is_parsing (ValenciaProgram* self);
static void _completion_on_parse_end_valencia_program_system_parse_complete (ValenciaProgram* _sender, gpointer self);
static void completion_show_popup (Completion* self);
GType valencia_scope_get_type (void);
GType valencia_typesymbol_get_type (void);
GType valencia_namespace_get_type (void);
gint valencia_symbol_name_length (ValenciaSymbol* self);
static void completion_jump_to_symbol_definition (Completion* self);
gboolean valencia_program_is_vala (const char* filename);
static void _completion_jump_to_symbol_definition_valencia_program_system_parse_complete (ValenciaProgram* _sender, gpointer self);
void popup_select_next (Popup* self, gint rows);
void popup_select_previous (Popup* self, gint rows);
void popup_select_first (Popup* self);
void popup_select_last (Popup* self);
gboolean popup_get_selected_proposal (Popup* self, Proposal** proposal);
const char* proposal_get_label (Proposal* self);
static gboolean completion_on_key_press (GtkWidget* sender, const GdkEventKey* event, Completion* _self_);
static void completion_on_delete_range (GtkTextBuffer* sender, const GtkTextIter* start, const GtkTextIter* end, Completion* _self_);
static void completion_on_insert_text (GtkTextBuffer* sender, const GtkTextIter* iter, const char* text, gint length, Completion* _self_);
static gboolean completion_on_button_press (GtkWidget* sender, const GdkEventButton* event, Completion* _self_);
static gboolean completion_on_focus_out (GtkWidget* sender, const GdkEventFocus* event, Completion* _self_);
static void completion_add_signal (Completion* self, GObject* object, const char* signal_name, GCallback cb, gboolean after);
static void completion_on_tab_added (ValideDocumentManager* documents, ValideiDocument* document, Completion* _self_);
static void completion_setup_ui (ValideDocumentManager* documents, ValideiDocument* document, Completion* _self_);
Pair* pair_new (GType g1_type, GBoxedCopyFunc g1_dup_func, GDestroyNotify g1_destroy_func, GType g2_type, GBoxedCopyFunc g2_dup_func, GDestroyNotify g2_destroy_func, gconstpointer object1, gconstpointer object2);
Pair* pair_construct (GType object_type, GType g1_type, GBoxedCopyFunc g1_dup_func, GDestroyNotify g1_destroy_func, GType g2_type, GBoxedCopyFunc g2_dup_func, GDestroyNotify g2_destroy_func, gconstpointer object1, gconstpointer object2);
Completion* completion_new (void);
Completion* completion_construct (GType object_type);
Popup* popup_new (void);
Popup* popup_construct (GType object_type);
Calltips* calltips_new (void);
Calltips* calltips_construct (GType object_type);
static GObject * completion_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
gconstpointer pair_get_first (Pair* self);
gconstpointer pair_get_second (Pair* self);
static void completion_finalize (GObject* obj);
static void completion_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void completion_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
GType register_plugin (void);
static int _vala_strcmp0 (const char * str1, const char * str2);

static const GtkActionEntry COMPLETION_entries[] = {{"edit-goto-definition", NULL, "Go to Definition", "<ctrl>D", "Goto the definition of the current symbol", (GCallback) _completion_on_goto_definition_gtk_action_callback}, {"edit-autocomplete", NULL, "_AutoComplete", "<ctrl>Return", "Display method or symbol information", (GCallback) _completion_on_autocomplete_gtk_action_callback}};


#line 29 "completion.vala"
ValenciaScanInfo* valencia_scan_info_construct (GType object_type, ValenciaMethod* method, ValenciaParseInfo* parse_info, gint cursor_position) {
#line 436 "completion.c"
	ValenciaScanInfo * self;
	ValenciaMethod* _tmp1_;
	ValenciaMethod* _tmp0_;
	ValenciaParseInfo* _tmp3_;
	ValenciaParseInfo* _tmp2_;
#line 29 "completion.vala"
	g_return_val_if_fail (parse_info != NULL, NULL);
#line 444 "completion.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 30 "completion.vala"
	_tmp0_ = NULL;
#line 30 "completion.vala"
	self->method = (_tmp1_ = (_tmp0_ = method, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->method == NULL) ? NULL : (self->method = (g_object_unref (self->method), NULL)), _tmp1_);
#line 451 "completion.c"
	_tmp3_ = NULL;
#line 31 "completion.vala"
	_tmp2_ = NULL;
#line 31 "completion.vala"
	self->parse_info = (_tmp3_ = (_tmp2_ = parse_info, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (self->parse_info == NULL) ? NULL : (self->parse_info = (g_object_unref (self->parse_info), NULL)), _tmp3_);
#line 32 "completion.vala"
	self->cursor_pos = cursor_position;
#line 459 "completion.c"
	return self;
}


#line 29 "completion.vala"
ValenciaScanInfo* valencia_scan_info_new (ValenciaMethod* method, ValenciaParseInfo* parse_info, gint cursor_position) {
#line 29 "completion.vala"
	return valencia_scan_info_construct (VALENCIA_TYPE_SCAN_INFO, method, parse_info, cursor_position);
#line 468 "completion.c"
}


#line 35 "completion.vala"
ValenciaScanInfo* valencia_scan_info_construct_empty (GType object_type) {
#line 474 "completion.c"
	ValenciaScanInfo * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 35 "completion.vala"
ValenciaScanInfo* valencia_scan_info_new_empty (void) {
#line 35 "completion.vala"
	return valencia_scan_info_construct_empty (VALENCIA_TYPE_SCAN_INFO);
#line 485 "completion.c"
}


#line 37 "completion.vala"
ValenciaExpression* valencia_scan_info_inner (ValenciaScanInfo* self) {
#line 491 "completion.c"
	ValenciaExpression* result;
	ValenciaExpression* _tmp0_;
#line 37 "completion.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "completion.vala"
	_tmp0_ = NULL;
#line 498 "completion.c"
	result = (_tmp0_ = self->parse_info->inner, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	return result;
}


#line 39 "completion.vala"
ValenciaExpression* valencia_scan_info_outer (ValenciaScanInfo* self) {
#line 506 "completion.c"
	ValenciaExpression* result;
	ValenciaExpression* _tmp0_;
#line 39 "completion.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "completion.vala"
	_tmp0_ = NULL;
#line 513 "completion.c"
	result = (_tmp0_ = self->parse_info->outer, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	return result;
}


static void valencia_scan_info_class_init (ValenciaScanInfoClass * klass) {
	valencia_scan_info_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_scan_info_finalize;
}


static void valencia_scan_info_instance_init (ValenciaScanInfo * self) {
}


static void valencia_scan_info_finalize (GObject* obj) {
	ValenciaScanInfo * self;
	self = VALENCIA_SCAN_INFO (obj);
	(self->parse_info == NULL) ? NULL : (self->parse_info = (g_object_unref (self->parse_info), NULL));
	(self->method == NULL) ? NULL : (self->method = (g_object_unref (self->method), NULL));
	G_OBJECT_CLASS (valencia_scan_info_parent_class)->finalize (obj);
}


GType valencia_scan_info_get_type (void) {
	static GType valencia_scan_info_type_id = 0;
	if (valencia_scan_info_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaScanInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_scan_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaScanInfo), 0, (GInstanceInitFunc) valencia_scan_info_instance_init, NULL };
		valencia_scan_info_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaScanInfo", &g_define_type_info, 0);
	}
	return valencia_scan_info_type_id;
}


static void _g_slist_free_g_object_unref (GSList* self) {
	g_slist_foreach (self, (GFunc) g_object_unref, NULL);
	g_slist_free (self);
}


#line 309 "completion.vala"
static void _completion_on_goto_definition_gtk_action_callback (GtkAction* action, gpointer self) {
#line 556 "completion.c"
	completion_on_goto_definition (self);
}


#line 254 "completion.vala"
static void _completion_on_autocomplete_gtk_action_callback (GtkAction* action, gpointer self) {
#line 563 "completion.c"
	completion_on_autocomplete (self);
}


#line 74 "completion.vala"
static void completion_get_window_position_in_cursor (Completion* self, GtkWindow* window, gint* x, gint* y) {
#line 570 "completion.c"
	gint w;
	gint h;
	gint sw;
	gint sh;
	gint xtext;
	gint ytext;
#line 74 "completion.vala"
	g_return_if_fail (self != NULL);
#line 74 "completion.vala"
	g_return_if_fail (window != NULL);
#line 581 "completion.c"
	w = 0;
	h = 0;
	sw = 0;
	sh = 0;
	xtext = 0;
	ytext = 0;
#line 81 "completion.vala"
	sw = gdk_screen_width ();
#line 82 "completion.vala"
	sh = gdk_screen_height ();
#line 84 "completion.vala"
	gtk_window_get_size (window, &w, &h);
#line 85 "completion.vala"
	if (((*x) + w) > sw) {
#line 85 "completion.vala"
		(*x) = (sw - w) - 4;
#line 598 "completion.c"
	}
	/* If we cannot show it down, we show it up.*/
#line 87 "completion.vala"
	if (((*y) + h) > sh) {
#line 603 "completion.c"
		PangoLayout* layout;
		PangoLayout* _tmp0_;
		layout = NULL;
		_tmp0_ = NULL;
#line 91 "completion.vala"
		layout = (_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) window, NULL), (layout == NULL) ? NULL : (layout = (g_object_unref (layout), NULL)), _tmp0_);
#line 92 "completion.vala"
		pango_layout_get_pixel_size (layout, &xtext, &ytext);
#line 93 "completion.vala"
		(*y) = ((*y) - ytext) - h;
#line 614 "completion.c"
		(layout == NULL) ? NULL : (layout = (g_object_unref (layout), NULL));
	}
}


#line 97 "completion.vala"
static void completion_get_cursor_pos (Completion* self, GtkTextView* text_view, gint* x, gint* y) {
#line 622 "completion.c"
	gint xx;
	gint yy;
	GdkWindow* win;
	gint win_x;
	gint win_y;
	GtkTextIter start = {0};
	GdkRectangle location = {0};
	GtkTextMark* insert_mark;
	GtkTextBuffer* text_buffer;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp0_;
	GtkTextMark* _tmp3_;
	GtkTextMark* _tmp2_;
	GdkWindow* _tmp5_;
	GdkWindow* _tmp4_;
#line 97 "completion.vala"
	g_return_if_fail (self != NULL);
#line 97 "completion.vala"
	g_return_if_fail (text_view != NULL);
#line 642 "completion.c"
	xx = 0;
	yy = 0;
	win = NULL;
	win_x = 0;
	win_y = 0;
	insert_mark = NULL;
	text_buffer = NULL;
	_tmp1_ = NULL;
#line 108 "completion.vala"
	_tmp0_ = NULL;
#line 108 "completion.vala"
	text_buffer = (_tmp1_ = (_tmp0_ = gtk_text_view_get_buffer (text_view), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (text_buffer == NULL) ? NULL : (text_buffer = (g_object_unref (text_buffer), NULL)), _tmp1_);
#line 655 "completion.c"
	_tmp3_ = NULL;
#line 109 "completion.vala"
	_tmp2_ = NULL;
#line 109 "completion.vala"
	insert_mark = (_tmp3_ = (_tmp2_ = gtk_text_buffer_get_insert (text_buffer), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (insert_mark == NULL) ? NULL : (insert_mark = (g_object_unref (insert_mark), NULL)), _tmp3_);
#line 110 "completion.vala"
	gtk_text_buffer_get_iter_at_mark (text_buffer, &start, insert_mark);
#line 111 "completion.vala"
	gtk_text_view_get_iter_location (text_view, &start, &location);
#line 112 "completion.vala"
	gtk_text_view_buffer_to_window_coords (text_view, GTK_TEXT_WINDOW_WIDGET, location.x, location.y, &win_x, &win_y);
#line 667 "completion.c"
	_tmp5_ = NULL;
#line 115 "completion.vala"
	_tmp4_ = NULL;
#line 115 "completion.vala"
	win = (_tmp5_ = (_tmp4_ = gtk_text_view_get_window (text_view, GTK_TEXT_WINDOW_WIDGET), (_tmp4_ == NULL) ? NULL : g_object_ref (_tmp4_)), (win == NULL) ? NULL : (win = (g_object_unref (win), NULL)), _tmp5_);
#line 116 "completion.vala"
	gdk_window_get_origin (win, &xx, &yy);
#line 118 "completion.vala"
	(*x) = win_x + xx;
#line 119 "completion.vala"
	(*y) = (win_y + yy) + location.height;
#line 679 "completion.c"
	(win == NULL) ? NULL : (win = (g_object_unref (win), NULL));
	(insert_mark == NULL) ? NULL : (insert_mark = (g_object_unref (insert_mark), NULL));
	(text_buffer == NULL) ? NULL : (text_buffer = (g_object_unref (text_buffer), NULL));
}


#line 922 "glib-2.0.vapi"
static char* string_substring (const char* self, glong offset, glong len) {
#line 688 "completion.c"
	char* result;
	glong string_length;
	const char* start;
#line 922 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 694 "completion.c"
	string_length = g_utf8_strlen (self, -1);
#line 924 "glib-2.0.vapi"
	if (offset < 0) {
#line 925 "glib-2.0.vapi"
		offset = string_length + offset;
#line 926 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= 0, NULL);
#line 702 "completion.c"
	} else {
#line 928 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 706 "completion.c"
	}
#line 930 "glib-2.0.vapi"
	if (len < 0) {
#line 931 "glib-2.0.vapi"
		len = string_length - offset;
#line 712 "completion.c"
	}
#line 933 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 716 "completion.c"
	start = g_utf8_offset_to_pointer (self, offset);
	result = g_strndup (start, ((gchar*) g_utf8_offset_to_pointer (start, len)) - ((gchar*) start));
	return result;
}


#line 122 "completion.vala"
static GdkPixbuf* completion_valencia_type_to_icon (Completion* self, ValenciaSymbol* symbol) {
#line 725 "completion.c"
	GdkPixbuf* result;
	char* type;
	char* valencia_type;
	char* _tmp1_;
	const char* _tmp0_;
	char* _tmp3_;
	char* _tmp2_;
#line 122 "completion.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "completion.vala"
	g_return_val_if_fail (symbol != NULL, NULL);
#line 737 "completion.c"
	type = NULL;
	valencia_type = NULL;
	_tmp1_ = NULL;
#line 127 "completion.vala"
	_tmp0_ = NULL;
#line 127 "completion.vala"
	valencia_type = (_tmp1_ = (_tmp0_ = g_type_name (G_TYPE_FROM_INSTANCE ((GObject*) symbol)), (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), valencia_type = (g_free (valencia_type), NULL), _tmp1_);
#line 745 "completion.c"
	_tmp3_ = NULL;
#line 922 "glib-2.0.vapi"
	_tmp2_ = NULL;
#line 128 "completion.vala"
	type = (_tmp3_ = g_utf8_strdown (_tmp2_ = string_substring (valencia_type, g_utf8_strlen ("Valencia", -1), -1), -1), type = (g_free (type), NULL), _tmp3_);
#line 751 "completion.c"
	_tmp2_ = (g_free (_tmp2_), NULL);
	result = valide_utils_get_symbol_pixbuf (type);
	type = (g_free (type), NULL);
	valencia_type = (g_free (valencia_type), NULL);
	return result;
}


#line 132 "completion.vala"
static void completion_get_buffer_info (Completion* self, ValideSourceBuffer* buffer, gint* pos, char** contents) {
#line 762 "completion.c"
	GtkTextIter iter = {0};
	char* _tmp0_;
#line 132 "completion.vala"
	g_return_if_fail (self != NULL);
#line 132 "completion.vala"
	g_return_if_fail (buffer != NULL);
#line 769 "completion.c"
	if (contents != NULL) {
		*contents = NULL;
	}
	_tmp0_ = NULL;
#line 137 "completion.vala"
	(*contents) = (_tmp0_ = valide_source_buffer_get_buffer_contents (buffer), (*contents) = (g_free ((*contents)), NULL), _tmp0_);
#line 138 "completion.vala"
	gtk_text_buffer_get_iter_at_mark ((GtkTextBuffer*) self->priv->buffer, &iter, gtk_text_buffer_get_insert ((GtkTextBuffer*) self->priv->buffer));
#line 139 "completion.vala"
	(*pos) = gtk_text_iter_get_offset (&iter);
#line 780 "completion.c"
}


#line 142 "completion.vala"
static ValenciaScanInfo* completion_get_scan_info (Completion* self, gboolean partial) {
#line 786 "completion.c"
	ValenciaScanInfo* result;
	gint cursor_pos;
	char* source;
	ValenciaMethod* method;
	ValenciaParseInfo* parse_info;
	char* _tmp1_;
	char* _tmp0_;
	ValenciaParseInfo* _tmp3_;
	ValenciaExpressionParser* _tmp2_;
	ValenciaProgram* program;
	ValenciaSourceFile* sf;
	ValenciaMethod* _tmp4_;
	gboolean _tmp5_;
#line 142 "completion.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 802 "completion.c"
	cursor_pos = 0;
	source = NULL;
	method = NULL;
	parse_info = NULL;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
#line 149 "completion.vala"
	completion_get_buffer_info (self, self->priv->buffer, &cursor_pos, &_tmp0_);
#line 149 "completion.vala"
	source = (_tmp1_ = _tmp0_, source = (g_free (source), NULL), _tmp1_);
#line 813 "completion.c"
	_tmp3_ = NULL;
	_tmp2_ = NULL;
#line 150 "completion.vala"
	parse_info = (_tmp3_ = valencia_expression_parser_parse (_tmp2_ = valencia_expression_parser_new (source, cursor_pos, partial)), (parse_info == NULL) ? NULL : (parse_info = (g_object_unref (parse_info), NULL)), _tmp3_);
#line 818 "completion.c"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (valencia_expression_parser_unref (_tmp2_), NULL));
	program = valencia_program_find_containing (self->priv->buffer->path, FALSE);
	sf = valencia_program_find_source (program, self->priv->buffer->path);
	/* The sourcefile may be null if the file is a vala file but hasn't been saved to disk*/
#line 155 "completion.vala"
	if (sf == NULL) {
#line 825 "completion.c"
		result = NULL;
		source = (g_free (source), NULL);
		(method == NULL) ? NULL : (method = (g_object_unref (method), NULL));
		(parse_info == NULL) ? NULL : (parse_info = (g_object_unref (parse_info), NULL));
		(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
		(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
		return result;
	}
	/* Give the method tooltip precedence over autocomplete*/
	_tmp4_ = NULL;
#line 161 "completion.vala"
	method = (_tmp4_ = NULL, (method == NULL) ? NULL : (method = (g_object_unref (method), NULL)), _tmp4_);
#line 838 "completion.c"
	_tmp5_ = FALSE;
#line 162 "completion.vala"
	if (parse_info->outer != NULL) {
#line 842 "completion.c"
		gboolean _tmp6_;
#line 163 "completion.vala"
		_tmp5_ = !(g_object_get ((GtkWidget*) self->priv->calltips, "visible", &_tmp6_, NULL), _tmp6_);
#line 846 "completion.c"
	} else {
#line 162 "completion.vala"
		_tmp5_ = FALSE;
#line 850 "completion.c"
	}
#line 162 "completion.vala"
	if (_tmp5_) {
#line 854 "completion.c"
		ValenciaSymbol* sym;
		ValenciaSymbol* _tmp7_;
		/*|| cursor_is_inside_different_function(parse_info.outer_pos)*/
		sym = NULL;
		_tmp7_ = NULL;
#line 167 "completion.vala"
		sym = (_tmp7_ = valencia_source_file_resolve (sf, parse_info->outer, cursor_pos, FALSE), (sym == NULL) ? NULL : (sym = (g_object_unref (sym), NULL)), _tmp7_);
#line 168 "completion.vala"
		if (sym != NULL) {
#line 864 "completion.c"
			ValenciaMethod* _tmp10_;
			ValenciaMethod* _tmp9_;
			ValenciaSymbol* _tmp8_;
			_tmp10_ = NULL;
#line 170 "completion.vala"
			_tmp9_ = NULL;
#line 170 "completion.vala"
			_tmp8_ = NULL;
#line 170 "completion.vala"
			method = (_tmp10_ = (_tmp9_ = (_tmp8_ = sym, VALENCIA_IS_METHOD (_tmp8_) ? ((ValenciaMethod*) _tmp8_) : NULL), (_tmp9_ == NULL) ? NULL : g_object_ref (_tmp9_)), (method == NULL) ? NULL : (method = (g_object_unref (method), NULL)), _tmp10_);
#line 875 "completion.c"
		}
		(sym == NULL) ? NULL : (sym = (g_object_unref (sym), NULL));
	}
	result = valencia_scan_info_new (method, parse_info, cursor_pos);
	source = (g_free (source), NULL);
	(method == NULL) ? NULL : (method = (g_object_unref (method), NULL));
	(parse_info == NULL) ? NULL : (parse_info = (g_object_unref (parse_info), NULL));
	(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
	(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
	return result;
}


static void _g_list_free_g_object_unref (GList* self) {
	g_list_foreach (self, (GFunc) g_object_unref, NULL);
	g_list_free (self);
}


#line 177 "completion.vala"
static void completion_on_parse_end (Completion* self) {
#line 897 "completion.c"
	ValenciaScanInfo* info;
	ValenciaScanInfo* _tmp0_;
#line 177 "completion.vala"
	g_return_if_fail (self != NULL);
#line 902 "completion.c"
	info = NULL;
	_tmp0_ = NULL;
#line 181 "completion.vala"
	info = (_tmp0_ = completion_get_scan_info (self, TRUE), (info == NULL) ? NULL : (info = (g_object_unref (info), NULL)), _tmp0_);
#line 182 "completion.vala"
	if (info != NULL) {
#line 184 "completion.vala"
		if (info->method != NULL) {
#line 911 "completion.c"
			char* _tmp1_;
			/* calltips */
#line 452 "program.vala"
			_tmp1_ = NULL;
#line 187 "completion.vala"
			calltips_set_text (self->priv->calltips, _tmp1_ = valencia_method_to_string (info->method));
#line 918 "completion.c"
			_tmp1_ = (g_free (_tmp1_), NULL);
#line 188 "completion.vala"
			gtk_widget_show ((GtkWidget*) self->priv->calltips);
#line 922 "completion.c"
		} else {
			ValenciaExpression* e;
			ValenciaSourceFile* sf;
			ValenciaProgram* program;
			ValenciaSymbolSet* symbol_set;
			GeeHashSet* symbols;
			ValenciaExpression* _tmp2_;
			ValenciaProgram* _tmp4_;
			ValenciaSourceFile* _tmp5_;
			ValenciaSymbolSet* _tmp6_;
			GeeHashSet* _tmp8_;
			GeeHashSet* _tmp7_;
			/* popup */
			e = NULL;
			sf = NULL;
			program = NULL;
			symbol_set = NULL;
			symbols = NULL;
			_tmp2_ = NULL;
#line 199 "completion.vala"
			e = (_tmp2_ = valencia_scan_info_inner (info), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp2_);
#line 200 "completion.vala"
			if (e == NULL) {
#line 946 "completion.c"
				ValenciaExpression* _tmp3_;
#line 202 "completion.vala"
				if (info->method != NULL) {
#line 950 "completion.c"
					(e == NULL) ? NULL : (e = (g_object_unref (e), NULL));
					(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
					(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
					(symbol_set == NULL) ? NULL : (symbol_set = (g_object_unref (symbol_set), NULL));
					(symbols == NULL) ? NULL : (symbols = (gee_collection_object_unref (symbols), NULL));
					(info == NULL) ? NULL : (info = (g_object_unref (info), NULL));
					return;
				}
				_tmp3_ = NULL;
#line 206 "completion.vala"
				e = (_tmp3_ = (ValenciaExpression*) valencia_id_new (""), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp3_);
#line 962 "completion.c"
			}
			_tmp4_ = NULL;
#line 209 "completion.vala"
			program = (_tmp4_ = valencia_program_find_containing (self->priv->buffer->path, FALSE), (program == NULL) ? NULL : (program = (g_object_unref (program), NULL)), _tmp4_);
#line 967 "completion.c"
			_tmp5_ = NULL;
#line 210 "completion.vala"
			sf = (_tmp5_ = valencia_program_find_source (program, self->priv->buffer->path), (sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL)), _tmp5_);
#line 971 "completion.c"
			_tmp6_ = NULL;
#line 211 "completion.vala"
			symbol_set = (_tmp6_ = valencia_source_file_resolve_prefix (sf, e, info->cursor_pos, FALSE), (symbol_set == NULL) ? NULL : (symbol_set = (g_object_unref (symbol_set), NULL)), _tmp6_);
#line 975 "completion.c"
			_tmp8_ = NULL;
#line 212 "completion.vala"
			_tmp7_ = NULL;
#line 212 "completion.vala"
			symbols = (_tmp8_ = (_tmp7_ = valencia_symbol_set_get_symbols (symbol_set), (_tmp7_ == NULL) ? NULL : gee_collection_object_ref (_tmp7_)), (symbols == NULL) ? NULL : (symbols = (gee_collection_object_unref (symbols), NULL)), _tmp8_);
#line 213 "completion.vala"
			if (symbols != NULL) {
#line 983 "completion.c"
				GList* proposals;
				GList* _tmp9_;
				proposals = NULL;
				_tmp9_ = NULL;
#line 217 "completion.vala"
				proposals = (_tmp9_ = NULL, (proposals == NULL) ? NULL : (proposals = (_g_list_free_g_object_unref (proposals), NULL)), _tmp9_);
#line 990 "completion.c"
				{
					GeeIterator* _s_it;
					_s_it = gee_iterable_iterator ((GeeIterable*) symbols);
#line 218 "completion.vala"
					while (TRUE) {
#line 996 "completion.c"
						ValenciaSymbol* s;
						GdkPixbuf* _tmp10_;
#line 218 "completion.vala"
						if (!gee_iterator_next (_s_it)) {
#line 218 "completion.vala"
							break;
#line 1003 "completion.c"
						}
						s = (ValenciaSymbol*) gee_iterator_get (_s_it);
#line 122 "completion.vala"
						_tmp10_ = NULL;
#line 220 "completion.vala"
						proposals = g_list_append (proposals, proposal_new (s->name, _tmp10_ = completion_valencia_type_to_icon (self, s)));
#line 1010 "completion.c"
						(_tmp10_ == NULL) ? NULL : (_tmp10_ = (g_object_unref (_tmp10_), NULL));
						(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
					}
					(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
				}
#line 222 "completion.vala"
				popup_set_proposals (self->priv->popup, proposals);
#line 223 "completion.vala"
				popup_show (self->priv->popup);
#line 1020 "completion.c"
				(proposals == NULL) ? NULL : (proposals = (_g_list_free_g_object_unref (proposals), NULL));
			} else {
#line 227 "completion.vala"
				popup_clear (self->priv->popup);
#line 1025 "completion.c"
			}
			(e == NULL) ? NULL : (e = (g_object_unref (e), NULL));
			(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
			(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
			(symbol_set == NULL) ? NULL : (symbol_set = (g_object_unref (symbol_set), NULL));
			(symbols == NULL) ? NULL : (symbols = (gee_collection_object_unref (symbols), NULL));
		}
	}
	(info == NULL) ? NULL : (info = (g_object_unref (info), NULL));
}


#line 233 "completion.vala"
static void completion_hide_popup (Completion* self) {
#line 233 "completion.vala"
	g_return_if_fail (self != NULL);
#line 235 "completion.vala"
	popup_hide (self->priv->popup);
#line 236 "completion.vala"
	gtk_widget_hide ((GtkWidget*) self->priv->calltips);
#line 1046 "completion.c"
}


#line 177 "completion.vala"
static void _completion_on_parse_end_valencia_program_system_parse_complete (ValenciaProgram* _sender, gpointer self) {
#line 1052 "completion.c"
	completion_on_parse_end (self);
}


#line 239 "completion.vala"
static void completion_show_popup (Completion* self) {
#line 1059 "completion.c"
	ValenciaProgram* program;
	ValenciaProgram* _tmp0_;
#line 239 "completion.vala"
	g_return_if_fail (self != NULL);
#line 1064 "completion.c"
	program = NULL;
	_tmp0_ = NULL;
#line 243 "completion.vala"
	program = (_tmp0_ = valencia_program_find_containing (self->priv->buffer->path, TRUE), (program == NULL) ? NULL : (program = (g_object_unref (program), NULL)), _tmp0_);
#line 244 "completion.vala"
	if (valencia_program_is_parsing (program)) {
#line 246 "completion.vala"
		g_signal_connect_object (program, "system-parse-complete", (GCallback) _completion_on_parse_end_valencia_program_system_parse_complete, self, 0);
#line 1073 "completion.c"
	} else {
#line 250 "completion.vala"
		completion_on_parse_end (self);
#line 1077 "completion.c"
	}
	(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
}


#line 254 "completion.vala"
static void completion_on_autocomplete (Completion* self) {
#line 1085 "completion.c"
	ValideiDocument* document;
	ValideiDocument* _tmp1_;
	ValideiDocument* _tmp0_;
#line 254 "completion.vala"
	g_return_if_fail (self != NULL);
#line 1091 "completion.c"
	document = NULL;
	_tmp1_ = NULL;
#line 258 "completion.vala"
	_tmp0_ = NULL;
#line 258 "completion.vala"
	document = (_tmp1_ = (_tmp0_ = valide_document_manager_get_current (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (document == NULL) ? NULL : (document = (g_object_unref (document), NULL)), _tmp1_);
#line 259 "completion.vala"
	if (VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (document)) {
#line 1100 "completion.c"
		gint x;
		gint y;
		ValideSourceView* source_view;
		ValideAbstractTextDocument* atd;
		ValideAbstractTextDocument* _tmp4_;
		ValideAbstractTextDocument* _tmp3_;
		ValideiDocument* _tmp2_;
		ValideSourceView* _tmp6_;
		ValideSourceView* _tmp5_;
		ValideSourceBuffer* _tmp8_;
		ValideSourceBuffer* _tmp7_;
		x = 0;
		y = 0;
		source_view = NULL;
		atd = NULL;
		_tmp4_ = NULL;
#line 265 "completion.vala"
		_tmp3_ = NULL;
#line 265 "completion.vala"
		_tmp2_ = NULL;
#line 265 "completion.vala"
		atd = (_tmp4_ = (_tmp3_ = (_tmp2_ = document, VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (_tmp2_) ? ((ValideAbstractTextDocument*) _tmp2_) : NULL), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_)), (atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL)), _tmp4_);
#line 1123 "completion.c"
		_tmp6_ = NULL;
#line 266 "completion.vala"
		_tmp5_ = NULL;
#line 266 "completion.vala"
		source_view = (_tmp6_ = (_tmp5_ = valide_abstract_text_document_get_text_view (atd), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_)), (source_view == NULL) ? NULL : (source_view = (g_object_unref (source_view), NULL)), _tmp6_);
#line 267 "completion.vala"
		completion_get_cursor_pos (self, (GtkTextView*) source_view, &x, &y);
#line 268 "completion.vala"
		completion_get_window_position_in_cursor (self, (GtkWindow*) self->priv->popup, &x, &y);
#line 269 "completion.vala"
		gtk_window_move ((GtkWindow*) self->priv->popup, x, y);
#line 270 "completion.vala"
		gtk_window_move ((GtkWindow*) self->priv->calltips, x, y);
#line 1137 "completion.c"
		_tmp8_ = NULL;
#line 271 "completion.vala"
		_tmp7_ = NULL;
#line 271 "completion.vala"
		self->priv->buffer = (_tmp8_ = (_tmp7_ = valide_source_view_get_buffer (source_view), (_tmp7_ == NULL) ? NULL : g_object_ref (_tmp7_)), (self->priv->buffer == NULL) ? NULL : (self->priv->buffer = (g_object_unref (self->priv->buffer), NULL)), _tmp8_);
#line 272 "completion.vala"
		completion_show_popup (self);
#line 1145 "completion.c"
		(source_view == NULL) ? NULL : (source_view = (g_object_unref (source_view), NULL));
		(atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL));
	}
	(document == NULL) ? NULL : (document = (g_object_unref (document), NULL));
}


#line 276 "completion.vala"
static void completion_jump_to_symbol_definition (Completion* self) {
#line 1155 "completion.c"
	GError * _inner_error_;
	gint pos;
	char* source;
	ValenciaScanInfo* info;
	char* _tmp1_;
	char* _tmp0_;
	ValenciaScanInfo* _tmp2_;
	gboolean _tmp3_;
#line 276 "completion.vala"
	g_return_if_fail (self != NULL);
#line 1166 "completion.c"
	_inner_error_ = NULL;
	pos = 0;
	source = NULL;
	info = NULL;
	_tmp1_ = NULL;
	_tmp0_ = NULL;
#line 282 "completion.vala"
	completion_get_buffer_info (self, self->priv->buffer, &pos, &_tmp0_);
#line 282 "completion.vala"
	source = (_tmp1_ = _tmp0_, source = (g_free (source), NULL), _tmp1_);
#line 1177 "completion.c"
	_tmp2_ = NULL;
#line 283 "completion.vala"
	info = (_tmp2_ = completion_get_scan_info (self, FALSE), (info == NULL) ? NULL : (info = (g_object_unref (info), NULL)), _tmp2_);
#line 1181 "completion.c"
	_tmp3_ = FALSE;
#line 284 "completion.vala"
	if (info != NULL) {
#line 1185 "completion.c"
		ValenciaExpression* _tmp4_;
#line 37 "completion.vala"
		_tmp4_ = NULL;
#line 284 "completion.vala"
		_tmp3_ = (_tmp4_ = valencia_scan_info_inner (info)) != NULL;
#line 1191 "completion.c"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_object_unref (_tmp4_), NULL));
	} else {
#line 284 "completion.vala"
		_tmp3_ = FALSE;
#line 1196 "completion.c"
	}
#line 284 "completion.vala"
	if (_tmp3_) {
#line 1200 "completion.c"
		ValenciaSymbol* sym;
		ValenciaSourceFile* sf;
		ValenciaProgram* program;
		ValenciaProgram* _tmp5_;
		ValenciaSourceFile* _tmp6_;
		ValenciaSymbol* _tmp8_;
		ValenciaExpression* _tmp7_;
		sym = NULL;
		sf = NULL;
		program = NULL;
		_tmp5_ = NULL;
#line 290 "completion.vala"
		program = (_tmp5_ = valencia_program_find_containing (self->priv->buffer->path, FALSE), (program == NULL) ? NULL : (program = (g_object_unref (program), NULL)), _tmp5_);
#line 1214 "completion.c"
		_tmp6_ = NULL;
#line 291 "completion.vala"
		sf = (_tmp6_ = valencia_program_find_source (program, self->priv->buffer->path), (sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL)), _tmp6_);
#line 1218 "completion.c"
		_tmp8_ = NULL;
#line 37 "completion.vala"
		_tmp7_ = NULL;
#line 292 "completion.vala"
		sym = (_tmp8_ = valencia_source_file_resolve (sf, _tmp7_ = valencia_scan_info_inner (info), pos, FALSE), (sym == NULL) ? NULL : (sym = (g_object_unref (sym), NULL)), _tmp8_);
#line 1224 "completion.c"
		(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_object_unref (_tmp7_), NULL));
#line 293 "completion.vala"
		if (sym != NULL) {
#line 1228 "completion.c"
			ValideiDocument* document;
			ValideiDocument* _tmp9_;
			ValideiDocument* _tmp10_;
			document = NULL;
			_tmp9_ = valide_document_manager_create (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), sym->source->filename, &_inner_error_);
			if (_inner_error_ != NULL) {
				(document == NULL) ? NULL : (document = (g_object_unref (document), NULL));
				(sym == NULL) ? NULL : (sym = (g_object_unref (sym), NULL));
				(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
				(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
				source = (g_free (source), NULL);
				(info == NULL) ? NULL : (info = (g_object_unref (info), NULL));
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp10_ = NULL;
#line 297 "completion.vala"
			document = (_tmp10_ = _tmp9_, (document == NULL) ? NULL : (document = (g_object_unref (document), NULL)), _tmp10_);
#line 298 "completion.vala"
			if (VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (document)) {
#line 1250 "completion.c"
				ValideAbstractTextDocument* atd;
				ValideAbstractTextDocument* _tmp13_;
				ValideAbstractTextDocument* _tmp12_;
				ValideiDocument* _tmp11_;
				atd = NULL;
				_tmp13_ = NULL;
#line 302 "completion.vala"
				_tmp12_ = NULL;
#line 302 "completion.vala"
				_tmp11_ = NULL;
#line 302 "completion.vala"
				atd = (_tmp13_ = (_tmp12_ = (_tmp11_ = document, VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (_tmp11_) ? ((ValideAbstractTextDocument*) _tmp11_) : NULL), (_tmp12_ == NULL) ? NULL : g_object_ref (_tmp12_)), (atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL)), _tmp13_);
#line 303 "completion.vala"
				valide_abstract_text_document_select_offsets (atd, ((ValenciaNode*) sym)->start, ((ValenciaNode*) sym)->start + valencia_symbol_name_length (sym));
#line 1265 "completion.c"
				(atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL));
			}
			(document == NULL) ? NULL : (document = (g_object_unref (document), NULL));
		}
		(sym == NULL) ? NULL : (sym = (g_object_unref (sym), NULL));
		(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
		(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
	}
	source = (g_free (source), NULL);
	(info == NULL) ? NULL : (info = (g_object_unref (info), NULL));
}


#line 276 "completion.vala"
static void _completion_jump_to_symbol_definition_valencia_program_system_parse_complete (ValenciaProgram* _sender, gpointer self) {
#line 1281 "completion.c"
	completion_jump_to_symbol_definition (self);
}


#line 309 "completion.vala"
static void completion_on_goto_definition (Completion* self) {
#line 1288 "completion.c"
	ValideiDocument* document;
	ValideiDocument* _tmp1_;
	ValideiDocument* _tmp0_;
#line 309 "completion.vala"
	g_return_if_fail (self != NULL);
#line 1294 "completion.c"
	document = NULL;
	_tmp1_ = NULL;
#line 313 "completion.vala"
	_tmp0_ = NULL;
#line 313 "completion.vala"
	document = (_tmp1_ = (_tmp0_ = valide_document_manager_get_current (valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self))), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (document == NULL) ? NULL : (document = (g_object_unref (document), NULL)), _tmp1_);
#line 314 "completion.vala"
	if (VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (document)) {
#line 1303 "completion.c"
		char* filename;
		ValideSourceView* source_view;
		ValideAbstractTextDocument* atd;
		ValideAbstractTextDocument* _tmp4_;
		ValideAbstractTextDocument* _tmp3_;
		ValideiDocument* _tmp2_;
		ValideSourceView* _tmp6_;
		ValideSourceView* _tmp5_;
		char* _tmp8_;
		const char* _tmp7_;
		gboolean _tmp9_;
		filename = NULL;
		source_view = NULL;
		atd = NULL;
		_tmp4_ = NULL;
#line 320 "completion.vala"
		_tmp3_ = NULL;
#line 320 "completion.vala"
		_tmp2_ = NULL;
#line 320 "completion.vala"
		atd = (_tmp4_ = (_tmp3_ = (_tmp2_ = document, VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (_tmp2_) ? ((ValideAbstractTextDocument*) _tmp2_) : NULL), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_)), (atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL)), _tmp4_);
#line 1325 "completion.c"
		_tmp6_ = NULL;
#line 321 "completion.vala"
		_tmp5_ = NULL;
#line 321 "completion.vala"
		source_view = (_tmp6_ = (_tmp5_ = valide_abstract_text_document_get_text_view (atd), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_)), (source_view == NULL) ? NULL : (source_view = (g_object_unref (source_view), NULL)), _tmp6_);
#line 1331 "completion.c"
		_tmp8_ = NULL;
#line 322 "completion.vala"
		_tmp7_ = NULL;
#line 322 "completion.vala"
		filename = (_tmp8_ = (_tmp7_ = valide_source_view_get_buffer (source_view)->path, (_tmp7_ == NULL) ? NULL : g_strdup (_tmp7_)), filename = (g_free (filename), NULL), _tmp8_);
#line 1337 "completion.c"
		_tmp9_ = FALSE;
#line 324 "completion.vala"
		if (filename != NULL) {
#line 324 "completion.vala"
			_tmp9_ = valencia_program_is_vala (filename);
#line 1343 "completion.c"
		} else {
#line 324 "completion.vala"
			_tmp9_ = FALSE;
#line 1347 "completion.c"
		}
#line 324 "completion.vala"
		if (_tmp9_) {
#line 1351 "completion.c"
			ValenciaProgram* program;
			ValenciaProgram* _tmp10_;
			ValideSourceBuffer* _tmp12_;
			ValideSourceBuffer* _tmp11_;
			program = NULL;
			_tmp10_ = NULL;
#line 328 "completion.vala"
			program = (_tmp10_ = valencia_program_find_containing (filename, TRUE), (program == NULL) ? NULL : (program = (g_object_unref (program), NULL)), _tmp10_);
#line 1360 "completion.c"
			_tmp12_ = NULL;
#line 329 "completion.vala"
			_tmp11_ = NULL;
#line 329 "completion.vala"
			self->priv->buffer = (_tmp12_ = (_tmp11_ = valide_source_view_get_buffer (source_view), (_tmp11_ == NULL) ? NULL : g_object_ref (_tmp11_)), (self->priv->buffer == NULL) ? NULL : (self->priv->buffer = (g_object_unref (self->priv->buffer), NULL)), _tmp12_);
#line 330 "completion.vala"
			if (valencia_program_is_parsing (program)) {
#line 332 "completion.vala"
				g_signal_connect_object (program, "system-parse-complete", (GCallback) _completion_jump_to_symbol_definition_valencia_program_system_parse_complete, self, 0);
#line 1370 "completion.c"
			} else {
#line 336 "completion.vala"
				completion_jump_to_symbol_definition (self);
#line 1374 "completion.c"
			}
			(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
		}
		filename = (g_free (filename), NULL);
		(source_view == NULL) ? NULL : (source_view = (g_object_unref (source_view), NULL));
		(atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL));
	}
	(document == NULL) ? NULL : (document = (g_object_unref (document), NULL));
}


#line 342 "completion.vala"
static gboolean completion_on_key_press (GtkWidget* sender, const GdkEventKey* event, Completion* _self_) {
#line 1388 "completion.c"
	gboolean result;
	gboolean catched;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 342 "completion.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 342 "completion.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 1397 "completion.c"
	catched = FALSE;
	_tmp0_ = FALSE;
#line 347 "completion.vala"
	if ((g_object_get ((GtkWidget*) _self_->priv->popup, "visible", &_tmp1_, NULL), _tmp1_)) {
#line 347 "completion.vala"
		_tmp0_ = TRUE;
#line 1404 "completion.c"
	} else {
		gboolean _tmp2_;
#line 347 "completion.vala"
		_tmp0_ = (g_object_get ((GtkWidget*) _self_->priv->calltips, "visible", &_tmp2_, NULL), _tmp2_);
#line 1409 "completion.c"
	}
#line 347 "completion.vala"
	if (_tmp0_) {
#line 349 "completion.vala"
		switch ((*event).keyval) {
#line 1415 "completion.c"
			case GDK_Left:
			case GDK_Right:
			{
#line 353 "completion.vala"
				catched = TRUE;
#line 354 "completion.vala"
				break;
#line 1423 "completion.c"
			}
			case GDK_Down:
			{
#line 356 "completion.vala"
				popup_select_next (_self_->priv->popup, 1);
#line 357 "completion.vala"
				catched = TRUE;
#line 358 "completion.vala"
				break;
#line 1433 "completion.c"
			}
			case GDK_Page_Down:
			{
#line 360 "completion.vala"
				popup_select_next (_self_->priv->popup, 5);
#line 361 "completion.vala"
				catched = TRUE;
#line 362 "completion.vala"
				break;
#line 1443 "completion.c"
			}
			case GDK_Up:
			{
#line 364 "completion.vala"
				popup_select_previous (_self_->priv->popup, 1);
#line 365 "completion.vala"
				catched = TRUE;
#line 366 "completion.vala"
				break;
#line 1453 "completion.c"
			}
			case GDK_Page_Up:
			{
#line 368 "completion.vala"
				popup_select_previous (_self_->priv->popup, 5);
#line 369 "completion.vala"
				catched = TRUE;
#line 370 "completion.vala"
				break;
#line 1463 "completion.c"
			}
			case GDK_Home:
			{
#line 372 "completion.vala"
				popup_select_first (_self_->priv->popup);
#line 373 "completion.vala"
				catched = TRUE;
#line 374 "completion.vala"
				break;
#line 1473 "completion.c"
			}
			case GDK_End:
			{
#line 376 "completion.vala"
				popup_select_last (_self_->priv->popup);
#line 377 "completion.vala"
				catched = TRUE;
#line 378 "completion.vala"
				break;
#line 1483 "completion.c"
			}
			case GDK_Return:
			case GDK_Tab:
			{
				Proposal* prop;
				Proposal* _tmp5_;
				gboolean _tmp4_;
				Proposal* _tmp3_;
				prop = NULL;
				_tmp5_ = NULL;
				_tmp3_ = NULL;
#line 383 "completion.vala"
				if ((_tmp4_ = popup_get_selected_proposal (_self_->priv->popup, &_tmp3_), prop = (_tmp5_ = _tmp3_, (prop == NULL) ? NULL : (prop = (g_object_unref (prop), NULL)), _tmp5_), _tmp4_)) {
#line 385 "completion.vala"
					valide_source_buffer_replace_actual_word (_self_->priv->buffer, proposal_get_label (prop));
#line 386 "completion.vala"
					popup_hide (_self_->priv->popup);
#line 387 "completion.vala"
					catched = TRUE;
#line 1503 "completion.c"
				}
				(prop == NULL) ? NULL : (prop = (g_object_unref (prop), NULL));
#line 389 "completion.vala"
				break;
#line 1508 "completion.c"
			}
			case GDK_Escape:
			{
#line 391 "completion.vala"
				completion_hide_popup (_self_);
#line 392 "completion.vala"
				catched = TRUE;
#line 393 "completion.vala"
				break;
#line 1518 "completion.c"
			}
		}
	}
	result = catched;
	return result;
}


#line 399 "completion.vala"
static void completion_on_delete_range (GtkTextBuffer* sender, const GtkTextIter* start, const GtkTextIter* end, Completion* _self_) {
#line 1529 "completion.c"
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 399 "completion.vala"
	g_return_if_fail (sender != NULL);
#line 399 "completion.vala"
	g_return_if_fail (_self_ != NULL);
#line 1536 "completion.c"
	_tmp0_ = FALSE;
#line 402 "completion.vala"
	if ((g_object_get ((GtkWidget*) _self_->priv->popup, "visible", &_tmp1_, NULL), _tmp1_)) {
#line 402 "completion.vala"
		_tmp0_ = TRUE;
#line 1542 "completion.c"
	} else {
		gboolean _tmp2_;
#line 402 "completion.vala"
		_tmp0_ = (g_object_get ((GtkWidget*) _self_->priv->calltips, "visible", &_tmp2_, NULL), _tmp2_);
#line 1547 "completion.c"
	}
#line 402 "completion.vala"
	if (_tmp0_) {
#line 404 "completion.vala"
		completion_hide_popup (_self_);
#line 405 "completion.vala"
		completion_show_popup (_self_);
#line 1555 "completion.c"
	}
}


#line 409 "completion.vala"
static void completion_on_insert_text (GtkTextBuffer* sender, const GtkTextIter* iter, const char* text, gint length, Completion* _self_) {
#line 1562 "completion.c"
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 409 "completion.vala"
	g_return_if_fail (sender != NULL);
#line 409 "completion.vala"
	g_return_if_fail (text != NULL);
#line 409 "completion.vala"
	g_return_if_fail (_self_ != NULL);
#line 412 "completion.vala"
	if ((g_object_get ((GtkWidget*) _self_->priv->popup, "visible", &_tmp0_, NULL), _tmp0_)) {
#line 414 "completion.vala"
		if (g_unichar_isspace (g_utf8_get_char (text))) {
#line 416 "completion.vala"
			popup_hide (_self_->priv->popup);
#line 1577 "completion.c"
		} else {
#line 418 "completion.vala"
			if (_vala_strcmp0 (text, "(") == 0) {
#line 420 "completion.vala"
				popup_hide (_self_->priv->popup);
#line 421 "completion.vala"
				completion_show_popup (_self_);
#line 1585 "completion.c"
			} else {
#line 425 "completion.vala"
				completion_show_popup (_self_);
#line 1589 "completion.c"
			}
		}
	}
#line 429 "completion.vala"
	if ((g_object_get ((GtkWidget*) _self_->priv->calltips, "visible", &_tmp1_, NULL), _tmp1_)) {
#line 431 "completion.vala"
		if (_vala_strcmp0 (text, ")") == 0) {
#line 433 "completion.vala"
			gtk_widget_hide ((GtkWidget*) _self_->priv->calltips);
#line 1599 "completion.c"
		}
	}
}


#line 438 "completion.vala"
static gboolean completion_on_button_press (GtkWidget* sender, const GdkEventButton* event, Completion* _self_) {
#line 1607 "completion.c"
	gboolean result;
#line 438 "completion.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 438 "completion.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 441 "completion.vala"
	completion_hide_popup (_self_);
#line 1615 "completion.c"
	result = FALSE;
	return result;
}


#line 445 "completion.vala"
static gboolean completion_on_focus_out (GtkWidget* sender, const GdkEventFocus* event, Completion* _self_) {
#line 1623 "completion.c"
	gboolean result;
#line 445 "completion.vala"
	g_return_val_if_fail (sender != NULL, FALSE);
#line 445 "completion.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 448 "completion.vala"
	completion_hide_popup (_self_);
#line 1631 "completion.c"
	result = FALSE;
	return result;
}


#line 452 "completion.vala"
static void completion_on_tab_added (ValideDocumentManager* documents, ValideiDocument* document, Completion* _self_) {
#line 452 "completion.vala"
	g_return_if_fail (documents != NULL);
#line 452 "completion.vala"
	g_return_if_fail (document != NULL);
#line 452 "completion.vala"
	g_return_if_fail (_self_ != NULL);
#line 455 "completion.vala"
	if (VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (document)) {
#line 1647 "completion.c"
		ValideSourceBuffer* buffer;
		ValideAbstractTextDocument* atd;
		ValideAbstractTextDocument* _tmp2_;
		ValideAbstractTextDocument* _tmp1_;
		ValideiDocument* _tmp0_;
		ValideSourceBuffer* _tmp4_;
		ValideSourceBuffer* _tmp3_;
		buffer = NULL;
		atd = NULL;
		_tmp2_ = NULL;
#line 460 "completion.vala"
		_tmp1_ = NULL;
#line 460 "completion.vala"
		_tmp0_ = NULL;
#line 460 "completion.vala"
		atd = (_tmp2_ = (_tmp1_ = (_tmp0_ = document, VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (_tmp0_) ? ((ValideAbstractTextDocument*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_)), (atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL)), _tmp2_);
#line 1664 "completion.c"
		_tmp4_ = NULL;
#line 461 "completion.vala"
		_tmp3_ = NULL;
#line 461 "completion.vala"
		buffer = (_tmp4_ = (_tmp3_ = valide_abstract_text_document_get_buffer (atd), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_)), (buffer == NULL) ? NULL : (buffer = (g_object_unref (buffer), NULL)), _tmp4_);
#line 463 "completion.vala"
		completion_add_signal (_self_, (GObject*) valide_abstract_text_document_get_text_view (atd), "key_press_event", (GCallback) completion_on_key_press, FALSE);
#line 465 "completion.vala"
		completion_add_signal (_self_, (GObject*) valide_abstract_text_document_get_text_view (atd), "focus_out_event", (GCallback) completion_on_focus_out, FALSE);
#line 467 "completion.vala"
		completion_add_signal (_self_, (GObject*) valide_abstract_text_document_get_text_view (atd), "button_press_event", (GCallback) completion_on_button_press, FALSE);
#line 469 "completion.vala"
		completion_add_signal (_self_, (GObject*) valide_abstract_text_document_get_buffer (atd), "insert_text", (GCallback) completion_on_insert_text, TRUE);
#line 471 "completion.vala"
		completion_add_signal (_self_, (GObject*) valide_abstract_text_document_get_buffer (atd), "delete_range", (GCallback) completion_on_delete_range, TRUE);
#line 1680 "completion.c"
		(buffer == NULL) ? NULL : (buffer = (g_object_unref (buffer), NULL));
		(atd == NULL) ? NULL : (atd = (g_object_unref (atd), NULL));
	}
}


#line 476 "completion.vala"
static void completion_setup_ui (ValideDocumentManager* documents, ValideiDocument* document, Completion* _self_) {
#line 1689 "completion.c"
	gboolean active;
	gboolean _tmp0_;
#line 476 "completion.vala"
	g_return_if_fail (documents != NULL);
#line 476 "completion.vala"
	g_return_if_fail (document != NULL);
#line 476 "completion.vala"
	g_return_if_fail (_self_ != NULL);
#line 1698 "completion.c"
	active = FALSE;
	_tmp0_ = FALSE;
#line 481 "completion.vala"
	if (valide_document_manager_get_current (documents) != NULL) {
#line 481 "completion.vala"
		_tmp0_ = VALIDE_IS_ABSTRACT_TEXT_DOCUMENT (valide_document_manager_get_current (documents));
#line 1705 "completion.c"
	} else {
#line 481 "completion.vala"
		_tmp0_ = FALSE;
#line 1709 "completion.c"
	}
#line 481 "completion.vala"
	if (_tmp0_) {
#line 483 "completion.vala"
		active = TRUE;
#line 1715 "completion.c"
	}
#line 485 "completion.vala"
	gtk_action_set_sensitive (gtk_action_group_get_action (_self_->priv->action_group, "edit-goto-definition"), active);
#line 486 "completion.vala"
	gtk_action_set_sensitive (gtk_action_group_get_action (_self_->priv->action_group, "edit-autocomplete"), active);
#line 1721 "completion.c"
}


#line 489 "completion.vala"
static void completion_add_signal (Completion* self, GObject* object, const char* signal_name, GCallback cb, gboolean after) {
#line 1727 "completion.c"
	gulong id;
#line 489 "completion.vala"
	g_return_if_fail (self != NULL);
#line 489 "completion.vala"
	g_return_if_fail (object != NULL);
#line 489 "completion.vala"
	g_return_if_fail (signal_name != NULL);
#line 1735 "completion.c"
	id = 0UL;
#line 494 "completion.vala"
	if (!after) {
#line 496 "completion.vala"
		id = g_signal_connect (object, signal_name, cb, self);
#line 1741 "completion.c"
	} else {
#line 500 "completion.vala"
		id = g_signal_connect_after (object, signal_name, cb, self);
#line 1745 "completion.c"
	}
#line 502 "completion.vala"
	self->priv->signal_handler_list = g_slist_append (self->priv->signal_handler_list, pair_new (G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, g_object_unref, G_TYPE_ULONG, NULL, NULL, object, GUINT_TO_POINTER (id)));
#line 1749 "completion.c"
}


#line 42 "completion.vala"
Completion* completion_construct (GType object_type) {
#line 1755 "completion.c"
	Completion * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 42 "completion.vala"
Completion* completion_new (void) {
#line 42 "completion.vala"
	return completion_construct (TYPE_COMPLETION);
#line 1766 "completion.c"
}


static const char* completion_real_get_path (ValidePlugin* base) {
	const char* result;
	Completion* self;
	self = (Completion*) base;
	result = self->priv->_path;
	return result;
}


static void completion_real_set_path (ValidePlugin* base, const char* value) {
	Completion* self;
	char* _tmp1_;
	const char* _tmp0_;
	self = (Completion*) base;
	_tmp1_ = NULL;
#line 71 "completion.vala"
	_tmp0_ = NULL;
#line 1787 "completion.c"
	self->priv->_path = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->priv->_path = (g_free (self->priv->_path), NULL), _tmp1_);
	g_object_notify ((GObject *) self, "path");
}


static ValideWindow* completion_real_get_window (ValidePlugin* base) {
	ValideWindow* result;
	Completion* self;
	self = (Completion*) base;
	result = self->priv->_window;
	return result;
}


static void completion_real_set_window (ValidePlugin* base, ValideWindow* value) {
	Completion* self;
	ValideWindow* _tmp1_;
	ValideWindow* _tmp0_;
	self = (Completion*) base;
	_tmp1_ = NULL;
#line 72 "completion.vala"
	_tmp0_ = NULL;
#line 1810 "completion.c"
	self->priv->_window = (_tmp1_ = (_tmp0_ = value, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->_window == NULL) ? NULL : (self->priv->_window = (g_object_unref (self->priv->_window), NULL)), _tmp1_);
	g_object_notify ((GObject *) self, "window");
}


static GObject * completion_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	CompletionClass * klass;
	GObjectClass * parent_class;
	Completion * self;
	GError * _inner_error_;
	klass = COMPLETION_CLASS (g_type_class_peek (TYPE_COMPLETION));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = COMPLETION (obj);
	_inner_error_ = NULL;
	{
		GtkUIManager* ui_manager;
		Popup* _tmp0_;
		Calltips* _tmp1_;
		GSList* _tmp2_;
		GtkUIManager* _tmp4_;
		GtkUIManager* _tmp3_;
		GtkActionGroup* _tmp5_;
		guint _tmp6_;
		ui_manager = NULL;
		_tmp0_ = NULL;
#line 509 "completion.vala"
		self->priv->popup = (_tmp0_ = g_object_ref_sink (popup_new ()), (self->priv->popup == NULL) ? NULL : (self->priv->popup = (g_object_unref (self->priv->popup), NULL)), _tmp0_);
#line 1840 "completion.c"
		_tmp1_ = NULL;
#line 510 "completion.vala"
		self->priv->calltips = (_tmp1_ = g_object_ref_sink (calltips_new ()), (self->priv->calltips == NULL) ? NULL : (self->priv->calltips = (g_object_unref (self->priv->calltips), NULL)), _tmp1_);
#line 1844 "completion.c"
		_tmp2_ = NULL;
#line 511 "completion.vala"
		self->priv->signal_handler_list = (_tmp2_ = NULL, (self->priv->signal_handler_list == NULL) ? NULL : (self->priv->signal_handler_list = (_g_slist_free_g_object_unref (self->priv->signal_handler_list), NULL)), _tmp2_);
#line 513 "completion.vala"
		completion_add_signal (self, (GObject*) valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab_added", (GCallback) completion_on_tab_added, FALSE);
#line 515 "completion.vala"
		completion_add_signal (self, (GObject*) valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab_removed", (GCallback) completion_setup_ui, FALSE);
#line 517 "completion.vala"
		completion_add_signal (self, (GObject*) valide_window_get_documents (valide_plugin_get_window ((ValidePlugin*) self)), "tab_changed", (GCallback) completion_setup_ui, FALSE);
#line 1854 "completion.c"
		/* Setup iu */
		_tmp4_ = NULL;
#line 521 "completion.vala"
		_tmp3_ = NULL;
#line 521 "completion.vala"
		ui_manager = (_tmp4_ = (_tmp3_ = (GtkUIManager*) valide_window_get_ui_manager (valide_plugin_get_window ((ValidePlugin*) self)), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_)), (ui_manager == NULL) ? NULL : (ui_manager = (g_object_unref (ui_manager), NULL)), _tmp4_);
#line 1861 "completion.c"
		_tmp5_ = NULL;
#line 522 "completion.vala"
		self->priv->action_group = (_tmp5_ = gtk_action_group_new ("completion"), (self->priv->action_group == NULL) ? NULL : (self->priv->action_group = (g_object_unref (self->priv->action_group), NULL)), _tmp5_);
#line 523 "completion.vala"
		gtk_action_group_add_actions (self->priv->action_group, COMPLETION_entries, G_N_ELEMENTS (COMPLETION_entries), self);
#line 524 "completion.vala"
		gtk_ui_manager_insert_action_group (ui_manager, self->priv->action_group, 0);
#line 1869 "completion.c"
		_tmp6_ = gtk_ui_manager_add_ui_from_string (ui_manager, COMPLETION_ui, (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			(ui_manager == NULL) ? NULL : (ui_manager = (g_object_unref (ui_manager), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
		}
#line 525 "completion.vala"
		self->priv->ui_id = _tmp6_;
#line 1878 "completion.c"
		(ui_manager == NULL) ? NULL : (ui_manager = (g_object_unref (ui_manager), NULL));
	}
	return obj;
}


static void completion_class_init (CompletionClass * klass) {
	completion_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (CompletionPrivate));
	G_OBJECT_CLASS (klass)->get_property = completion_get_property;
	G_OBJECT_CLASS (klass)->set_property = completion_set_property;
	G_OBJECT_CLASS (klass)->constructor = completion_constructor;
	G_OBJECT_CLASS (klass)->finalize = completion_finalize;
	g_object_class_override_property (G_OBJECT_CLASS (klass), COMPLETION_PATH, "path");
	g_object_class_override_property (G_OBJECT_CLASS (klass), COMPLETION_WINDOW, "window");
}


static void completion_valide_plugin_interface_init (ValidePluginIface * iface) {
	completion_valide_plugin_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_path = completion_real_get_path;
	iface->set_path = completion_real_set_path;
	iface->get_window = completion_real_get_window;
	iface->set_window = completion_real_set_window;
}


static void completion_instance_init (Completion * self) {
	self->priv = COMPLETION_GET_PRIVATE (self);
}


static void completion_finalize (GObject* obj) {
	Completion * self;
	self = COMPLETION (obj);
	{
#line 530 "completion.vala"
		gtk_ui_manager_remove_ui ((GtkUIManager*) valide_window_get_ui_manager (valide_plugin_get_window ((ValidePlugin*) self)), self->priv->ui_id);
#line 1917 "completion.c"
		{
			GSList* pair_collection;
			GSList* pair_it;
#line 532 "completion.vala"
			pair_collection = self->priv->signal_handler_list;
#line 1923 "completion.c"
			for (pair_it = pair_collection; pair_it != NULL; pair_it = pair_it->next) {
				Pair* _tmp7_;
				Pair* pair;
#line 49 "completion.vala"
				_tmp7_ = NULL;
#line 532 "completion.vala"
				pair = (_tmp7_ = (Pair*) pair_it->data, (_tmp7_ == NULL) ? NULL : g_object_ref (_tmp7_));
#line 1931 "completion.c"
				{
#line 534 "completion.vala"
					if (g_signal_handler_is_connected ((GObject*) pair_get_first (pair), GPOINTER_TO_UINT (pair_get_second (pair)))) {
#line 536 "completion.vala"
						g_signal_handler_disconnect ((GObject*) pair_get_first (pair), GPOINTER_TO_UINT (pair_get_second (pair)));
#line 1937 "completion.c"
					}
					(pair == NULL) ? NULL : (pair = (g_object_unref (pair), NULL));
				}
			}
		}
	}
	(self->priv->popup == NULL) ? NULL : (self->priv->popup = (g_object_unref (self->priv->popup), NULL));
	(self->priv->calltips == NULL) ? NULL : (self->priv->calltips = (g_object_unref (self->priv->calltips), NULL));
	(self->priv->buffer == NULL) ? NULL : (self->priv->buffer = (g_object_unref (self->priv->buffer), NULL));
	(self->priv->action_group == NULL) ? NULL : (self->priv->action_group = (g_object_unref (self->priv->action_group), NULL));
	(self->priv->signal_handler_list == NULL) ? NULL : (self->priv->signal_handler_list = (_g_slist_free_g_object_unref (self->priv->signal_handler_list), NULL));
	self->priv->_path = (g_free (self->priv->_path), NULL);
	(self->priv->_window == NULL) ? NULL : (self->priv->_window = (g_object_unref (self->priv->_window), NULL));
	G_OBJECT_CLASS (completion_parent_class)->finalize (obj);
}


GType completion_get_type (void) {
	static GType completion_type_id = 0;
	if (completion_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (CompletionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) completion_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Completion), 0, (GInstanceInitFunc) completion_instance_init, NULL };
		static const GInterfaceInfo valide_plugin_info = { (GInterfaceInitFunc) completion_valide_plugin_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		completion_type_id = g_type_register_static (G_TYPE_OBJECT, "Completion", &g_define_type_info, 0);
		g_type_add_interface_static (completion_type_id, VALIDE_TYPE_PLUGIN, &valide_plugin_info);
	}
	return completion_type_id;
}


static void completion_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Completion * self;
	gpointer boxed;
	self = COMPLETION (object);
	switch (property_id) {
		case COMPLETION_PATH:
		g_value_set_string (value, valide_plugin_get_path ((ValidePlugin*) self));
		break;
		case COMPLETION_WINDOW:
		g_value_set_object (value, valide_plugin_get_window ((ValidePlugin*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void completion_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Completion * self;
	self = COMPLETION (object);
	switch (property_id) {
		case COMPLETION_PATH:
		valide_plugin_set_path ((ValidePlugin*) self, g_value_get_string (value));
		break;
		case COMPLETION_WINDOW:
		valide_plugin_set_window ((ValidePlugin*) self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


#line 543 "completion.vala"
GType register_plugin (void) {
#line 2004 "completion.c"
	GType result;
	result = TYPE_COMPLETION;
	return result;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




