/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define VALENCIA_TYPE_EXPRESSION (valencia_expression_get_type ())
#define VALENCIA_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpression))
#define VALENCIA_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))
#define VALENCIA_IS_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_IS_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))

typedef struct _ValenciaExpression ValenciaExpression;
typedef struct _ValenciaExpressionClass ValenciaExpressionClass;
typedef struct _ValenciaExpressionPrivate ValenciaExpressionPrivate;

#define VALENCIA_TYPE_ID (valencia_id_get_type ())
#define VALENCIA_ID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ID, ValenciaId))
#define VALENCIA_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ID, ValenciaIdClass))
#define VALENCIA_IS_ID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ID))
#define VALENCIA_IS_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ID))
#define VALENCIA_ID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ID, ValenciaIdClass))

typedef struct _ValenciaId ValenciaId;
typedef struct _ValenciaIdClass ValenciaIdClass;
typedef struct _ValenciaIdPrivate ValenciaIdPrivate;

#define VALENCIA_TYPE_THIS (valencia_this_get_type ())
#define VALENCIA_THIS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_THIS, ValenciaThis))
#define VALENCIA_THIS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_THIS, ValenciaThisClass))
#define VALENCIA_IS_THIS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_THIS))
#define VALENCIA_IS_THIS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_THIS))
#define VALENCIA_THIS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_THIS, ValenciaThisClass))

typedef struct _ValenciaThis ValenciaThis;
typedef struct _ValenciaThisClass ValenciaThisClass;
typedef struct _ValenciaThisPrivate ValenciaThisPrivate;

#define VALENCIA_TYPE_BASE (valencia_base_get_type ())
#define VALENCIA_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_BASE, ValenciaBase))
#define VALENCIA_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_BASE, ValenciaBaseClass))
#define VALENCIA_IS_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_BASE))
#define VALENCIA_IS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_BASE))
#define VALENCIA_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_BASE, ValenciaBaseClass))

typedef struct _ValenciaBase ValenciaBase;
typedef struct _ValenciaBaseClass ValenciaBaseClass;
typedef struct _ValenciaBasePrivate ValenciaBasePrivate;

#define VALENCIA_TYPE_NEW (valencia_new_get_type ())
#define VALENCIA_NEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NEW, ValenciaNew))
#define VALENCIA_NEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NEW, ValenciaNewClass))
#define VALENCIA_IS_NEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NEW))
#define VALENCIA_IS_NEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NEW))
#define VALENCIA_NEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NEW, ValenciaNewClass))

typedef struct _ValenciaNew ValenciaNew;
typedef struct _ValenciaNewClass ValenciaNewClass;
typedef struct _ValenciaNewPrivate ValenciaNewPrivate;

#define VALENCIA_TYPE_METHOD_CALL (valencia_method_call_get_type ())
#define VALENCIA_METHOD_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCall))
#define VALENCIA_METHOD_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCallClass))
#define VALENCIA_IS_METHOD_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_METHOD_CALL))
#define VALENCIA_IS_METHOD_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_METHOD_CALL))
#define VALENCIA_METHOD_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCallClass))

typedef struct _ValenciaMethodCall ValenciaMethodCall;
typedef struct _ValenciaMethodCallClass ValenciaMethodCallClass;
typedef struct _ValenciaMethodCallPrivate ValenciaMethodCallPrivate;

#define VALENCIA_TYPE_COMPOUND_EXPRESSION (valencia_compound_expression_get_type ())
#define VALENCIA_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpression))
#define VALENCIA_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))
#define VALENCIA_IS_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_IS_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_COMPOUND_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))

typedef struct _ValenciaCompoundExpression ValenciaCompoundExpression;
typedef struct _ValenciaCompoundExpressionClass ValenciaCompoundExpressionClass;
typedef struct _ValenciaCompoundExpressionPrivate ValenciaCompoundExpressionPrivate;

#define VALENCIA_TYPE_EXPRESSION_PARSER (valencia_expression_parser_get_type ())
#define VALENCIA_EXPRESSION_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_EXPRESSION_PARSER, ValenciaExpressionParser))
#define VALENCIA_EXPRESSION_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_EXPRESSION_PARSER, ValenciaExpressionParserClass))
#define VALENCIA_IS_EXPRESSION_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_EXPRESSION_PARSER))
#define VALENCIA_IS_EXPRESSION_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_EXPRESSION_PARSER))
#define VALENCIA_EXPRESSION_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_EXPRESSION_PARSER, ValenciaExpressionParserClass))

typedef struct _ValenciaExpressionParser ValenciaExpressionParser;
typedef struct _ValenciaExpressionParserClass ValenciaExpressionParserClass;
typedef struct _ValenciaExpressionParserPrivate ValenciaExpressionParserPrivate;

#define VALENCIA_TYPE_SCANNER (valencia_scanner_get_type ())
#define VALENCIA_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCANNER, ValenciaScanner))
#define VALENCIA_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SCANNER, ValenciaScannerClass))
#define VALENCIA_IS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCANNER))
#define VALENCIA_IS_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SCANNER))
#define VALENCIA_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SCANNER, ValenciaScannerClass))

typedef struct _ValenciaScanner ValenciaScanner;
typedef struct _ValenciaScannerClass ValenciaScannerClass;

#define VALENCIA_TYPE_TOKEN (valencia_token_get_type ())
typedef struct _ValenciaScannerPrivate ValenciaScannerPrivate;

#define VALENCIA_TYPE_PARSE_INFO (valencia_parse_info_get_type ())
#define VALENCIA_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfo))
#define VALENCIA_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))
#define VALENCIA_IS_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_IS_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_PARSE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))

typedef struct _ValenciaParseInfo ValenciaParseInfo;
typedef struct _ValenciaParseInfoClass ValenciaParseInfoClass;
typedef struct _ValenciaParseInfoPrivate ValenciaParseInfoPrivate;
typedef struct _ValenciaParamSpecExpressionParser ValenciaParamSpecExpressionParser;

struct _ValenciaExpression {
	GObject parent_instance;
	ValenciaExpressionPrivate * priv;
};

struct _ValenciaExpressionClass {
	GObjectClass parent_class;
	char* (*to_string) (ValenciaExpression* self);
};

struct _ValenciaId {
	ValenciaExpression parent_instance;
	ValenciaIdPrivate * priv;
	char* name;
};

struct _ValenciaIdClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaThis {
	ValenciaExpression parent_instance;
	ValenciaThisPrivate * priv;
};

struct _ValenciaThisClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaBase {
	ValenciaExpression parent_instance;
	ValenciaBasePrivate * priv;
};

struct _ValenciaBaseClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaNew {
	ValenciaExpression parent_instance;
	ValenciaNewPrivate * priv;
	ValenciaExpression* class_name;
};

struct _ValenciaNewClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaMethodCall {
	ValenciaExpression parent_instance;
	ValenciaMethodCallPrivate * priv;
	ValenciaExpression* method;
};

struct _ValenciaMethodCallClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaCompoundExpression {
	ValenciaExpression parent_instance;
	ValenciaCompoundExpressionPrivate * priv;
	ValenciaExpression* left;
	char* right;
};

struct _ValenciaCompoundExpressionClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaExpressionParser {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ValenciaExpressionParserPrivate * priv;
};

struct _ValenciaExpressionParserClass {
	GTypeClass parent_class;
	void (*finalize) (ValenciaExpressionParser *self);
};

struct _ValenciaExpressionParserPrivate {
	ValenciaScanner* scanner;
	gint pos;
	gboolean partial;
};

typedef enum  {
	VALENCIA_TOKEN_NONE,
	VALENCIA_TOKEN_EOF,
	VALENCIA_TOKEN_CHAR,
	VALENCIA_TOKEN_CHAR_LITERAL,
	VALENCIA_TOKEN_STRING_LITERAL,
	VALENCIA_TOKEN_ID,
	VALENCIA_TOKEN_ASTERISK,
	VALENCIA_TOKEN_LEFT_BRACE,
	VALENCIA_TOKEN_RIGHT_BRACE,
	VALENCIA_TOKEN_LEFT_BRACKET,
	VALENCIA_TOKEN_RIGHT_BRACKET,
	VALENCIA_TOKEN_COLON,
	VALENCIA_TOKEN_COMMA,
	VALENCIA_TOKEN_EQUALS,
	VALENCIA_TOKEN_ELLIPSIS,
	VALENCIA_TOKEN_HASH,
	VALENCIA_TOKEN_LEFT_PAREN,
	VALENCIA_TOKEN_RIGHT_PAREN,
	VALENCIA_TOKEN_PERIOD,
	VALENCIA_TOKEN_QUESTION_MARK,
	VALENCIA_TOKEN_SEMICOLON,
	VALENCIA_TOKEN_LESS_THAN,
	VALENCIA_TOKEN_GREATER_THAN,
	VALENCIA_TOKEN_ABSTRACT,
	VALENCIA_TOKEN_BASE,
	VALENCIA_TOKEN_CLASS,
	VALENCIA_TOKEN_CONST,
	VALENCIA_TOKEN_CONSTRUCT,
	VALENCIA_TOKEN_DELEGATE,
	VALENCIA_TOKEN_ELSE,
	VALENCIA_TOKEN_ENUM,
	VALENCIA_TOKEN_EXTERN,
	VALENCIA_TOKEN_FOR,
	VALENCIA_TOKEN_FOREACH,
	VALENCIA_TOKEN_IF,
	VALENCIA_TOKEN_INLINE,
	VALENCIA_TOKEN_INTERFACE,
	VALENCIA_TOKEN_INTERNAL,
	VALENCIA_TOKEN_NAMESPACE,
	VALENCIA_TOKEN_NEW,
	VALENCIA_TOKEN_OUT,
	VALENCIA_TOKEN_OVERRIDE,
	VALENCIA_TOKEN_OWNED,
	VALENCIA_TOKEN_PRIVATE,
	VALENCIA_TOKEN_PROTECTED,
	VALENCIA_TOKEN_PUBLIC,
	VALENCIA_TOKEN_REF,
	VALENCIA_TOKEN_RETURN,
	VALENCIA_TOKEN_SIGNAL,
	VALENCIA_TOKEN_STATIC,
	VALENCIA_TOKEN_STRUCT,
	VALENCIA_TOKEN_THIS,
	VALENCIA_TOKEN_UNOWNED,
	VALENCIA_TOKEN_USING,
	VALENCIA_TOKEN_VIRTUAL,
	VALENCIA_TOKEN_WEAK,
	VALENCIA_TOKEN_WHILE
} ValenciaToken;

struct _ValenciaScanner {
	GObject parent_instance;
	ValenciaScannerPrivate * priv;
	gint start;
	gint end;
};

struct _ValenciaScannerClass {
	GObjectClass parent_class;
};

struct _ValenciaParseInfo {
	GObject parent_instance;
	ValenciaParseInfoPrivate * priv;
	ValenciaExpression* inner;
	ValenciaExpression* outer;
	gint outer_pos;
};

struct _ValenciaParseInfoClass {
	GObjectClass parent_class;
};

struct _ValenciaParamSpecExpressionParser {
	GParamSpec parent_instance;
};


static gpointer valencia_expression_parent_class = NULL;
static gpointer valencia_id_parent_class = NULL;
static gpointer valencia_this_parent_class = NULL;
static gpointer valencia_base_parent_class = NULL;
static gpointer valencia_new_parent_class = NULL;
static gpointer valencia_method_call_parent_class = NULL;
static gpointer valencia_compound_expression_parent_class = NULL;
static gpointer valencia_expression_parser_parent_class = NULL;

GType valencia_expression_get_type (void);
enum  {
	VALENCIA_EXPRESSION_DUMMY_PROPERTY
};
char* valencia_expression_to_string (ValenciaExpression* self);
static char* valencia_expression_real_to_string (ValenciaExpression* self);
GType valencia_id_get_type (void);
enum  {
	VALENCIA_ID_DUMMY_PROPERTY
};
ValenciaId* valencia_id_new (const char* name);
ValenciaId* valencia_id_construct (GType object_type, const char* name);
static char* valencia_id_real_to_string (ValenciaExpression* base);
static void valencia_id_finalize (GObject* obj);
GType valencia_this_get_type (void);
enum  {
	VALENCIA_THIS_DUMMY_PROPERTY
};
static char* valencia_this_real_to_string (ValenciaExpression* base);
ValenciaThis* valencia_this_new (void);
ValenciaThis* valencia_this_construct (GType object_type);
GType valencia_base_get_type (void);
enum  {
	VALENCIA_BASE_DUMMY_PROPERTY
};
static char* valencia_base_real_to_string (ValenciaExpression* base);
ValenciaBase* valencia_base_new (void);
ValenciaBase* valencia_base_construct (GType object_type);
GType valencia_new_get_type (void);
enum  {
	VALENCIA_NEW_DUMMY_PROPERTY
};
ValenciaNew* valencia_new_new (ValenciaExpression* class_name);
ValenciaNew* valencia_new_construct (GType object_type, ValenciaExpression* class_name);
static char* valencia_new_real_to_string (ValenciaExpression* base);
static void valencia_new_finalize (GObject* obj);
GType valencia_method_call_get_type (void);
enum  {
	VALENCIA_METHOD_CALL_DUMMY_PROPERTY
};
ValenciaMethodCall* valencia_method_call_new (ValenciaExpression* method);
ValenciaMethodCall* valencia_method_call_construct (GType object_type, ValenciaExpression* method);
static char* valencia_method_call_real_to_string (ValenciaExpression* base);
static void valencia_method_call_finalize (GObject* obj);
GType valencia_compound_expression_get_type (void);
enum  {
	VALENCIA_COMPOUND_EXPRESSION_DUMMY_PROPERTY
};
ValenciaCompoundExpression* valencia_compound_expression_new (ValenciaExpression* left, const char* right);
ValenciaCompoundExpression* valencia_compound_expression_construct (GType object_type, ValenciaExpression* left, const char* right);
static char* valencia_compound_expression_real_to_string (ValenciaExpression* base);
static void valencia_compound_expression_finalize (GObject* obj);
gpointer valencia_expression_parser_ref (gpointer instance);
void valencia_expression_parser_unref (gpointer instance);
GParamSpec* valencia_param_spec_expression_parser (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void valencia_value_set_expression_parser (GValue* value, gpointer v_object);
gpointer valencia_value_get_expression_parser (const GValue* value);
GType valencia_expression_parser_get_type (void);
GType valencia_scanner_get_type (void);
#define VALENCIA_EXPRESSION_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_EXPRESSION_PARSER, ValenciaExpressionParserPrivate))
enum  {
	VALENCIA_EXPRESSION_PARSER_DUMMY_PROPERTY
};
ValenciaScanner* valencia_scanner_new (const char* input);
ValenciaScanner* valencia_scanner_construct (GType object_type, const char* input);
ValenciaExpressionParser* valencia_expression_parser_new (const char* input, gint pos, gboolean partial);
ValenciaExpressionParser* valencia_expression_parser_construct (GType object_type, const char* input, gint pos, gboolean partial);
GType valencia_token_get_type (void);
gboolean valencia_scanner_accept_token (ValenciaScanner* self, ValenciaToken t);
static gboolean valencia_expression_parser_accept (ValenciaExpressionParser* self, ValenciaToken t);
ValenciaToken valencia_scanner_next_token (ValenciaScanner* self);
char* valencia_scanner_val (ValenciaScanner* self);
ValenciaParseInfo* valencia_parse_info_new (ValenciaExpression* inner);
ValenciaParseInfo* valencia_parse_info_construct (GType object_type, ValenciaExpression* inner);
GType valencia_parse_info_get_type (void);
static ValenciaParseInfo* valencia_expression_parser_parse_expr (ValenciaExpressionParser* self, gboolean nested);
ValenciaParseInfo* valencia_expression_parser_parse (ValenciaExpressionParser* self);
static void valencia_expression_parser_finalize (ValenciaExpressionParser* obj);



#line 10 "expression.vala"
static char* valencia_expression_real_to_string (ValenciaExpression* self) {
#line 394 "expression.c"
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `valencia_expression_to_string'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 10 "expression.vala"
char* valencia_expression_to_string (ValenciaExpression* self) {
#line 10 "expression.vala"
	return VALENCIA_EXPRESSION_GET_CLASS (self)->to_string (self);
#line 405 "expression.c"
}


static void valencia_expression_class_init (ValenciaExpressionClass * klass) {
	valencia_expression_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_CLASS (klass)->to_string = valencia_expression_real_to_string;
}


static void valencia_expression_instance_init (ValenciaExpression * self) {
}


GType valencia_expression_get_type (void) {
	static GType valencia_expression_type_id = 0;
	if (valencia_expression_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaExpressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_expression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaExpression), 0, (GInstanceInitFunc) valencia_expression_instance_init, NULL };
		valencia_expression_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaExpression", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return valencia_expression_type_id;
}


#line 16 "expression.vala"
ValenciaId* valencia_id_construct (GType object_type, const char* name) {
#line 431 "expression.c"
	ValenciaId * self;
	char* _tmp1_;
	const char* _tmp0_;
#line 16 "expression.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 437 "expression.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 17 "expression.vala"
	_tmp0_ = NULL;
#line 17 "expression.vala"
	self->name = (_tmp1_ = (_tmp0_ = name, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->name = (g_free (self->name), NULL), _tmp1_);
#line 444 "expression.c"
	return self;
}


#line 16 "expression.vala"
ValenciaId* valencia_id_new (const char* name) {
#line 16 "expression.vala"
	return valencia_id_construct (VALENCIA_TYPE_ID, name);
#line 453 "expression.c"
}


#line 20 "expression.vala"
static char* valencia_id_real_to_string (ValenciaExpression* base) {
#line 459 "expression.c"
	ValenciaId * self;
	char* result;
	const char* _tmp0_;
	self = (ValenciaId*) base;
#line 21 "expression.vala"
	_tmp0_ = NULL;
#line 466 "expression.c"
	result = (_tmp0_ = self->name, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	return result;
}


static void valencia_id_class_init (ValenciaIdClass * klass) {
	valencia_id_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_CLASS (klass)->to_string = valencia_id_real_to_string;
	G_OBJECT_CLASS (klass)->finalize = valencia_id_finalize;
}


static void valencia_id_instance_init (ValenciaId * self) {
}


static void valencia_id_finalize (GObject* obj) {
	ValenciaId * self;
	self = VALENCIA_ID (obj);
	self->name = (g_free (self->name), NULL);
	G_OBJECT_CLASS (valencia_id_parent_class)->finalize (obj);
}


GType valencia_id_get_type (void) {
	static GType valencia_id_type_id = 0;
	if (valencia_id_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaIdClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_id_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaId), 0, (GInstanceInitFunc) valencia_id_instance_init, NULL };
		valencia_id_type_id = g_type_register_static (VALENCIA_TYPE_EXPRESSION, "ValenciaId", &g_define_type_info, 0);
	}
	return valencia_id_type_id;
}


#line 26 "expression.vala"
static char* valencia_this_real_to_string (ValenciaExpression* base) {
#line 503 "expression.c"
	ValenciaThis * self;
	char* result;
	self = (ValenciaThis*) base;
	result = g_strdup ("this");
	return result;
}


#line 25 "expression.vala"
ValenciaThis* valencia_this_construct (GType object_type) {
#line 514 "expression.c"
	ValenciaThis * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 25 "expression.vala"
ValenciaThis* valencia_this_new (void) {
#line 25 "expression.vala"
	return valencia_this_construct (VALENCIA_TYPE_THIS);
#line 525 "expression.c"
}


static void valencia_this_class_init (ValenciaThisClass * klass) {
	valencia_this_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_CLASS (klass)->to_string = valencia_this_real_to_string;
}


static void valencia_this_instance_init (ValenciaThis * self) {
}


GType valencia_this_get_type (void) {
	static GType valencia_this_type_id = 0;
	if (valencia_this_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaThisClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_this_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaThis), 0, (GInstanceInitFunc) valencia_this_instance_init, NULL };
		valencia_this_type_id = g_type_register_static (VALENCIA_TYPE_EXPRESSION, "ValenciaThis", &g_define_type_info, 0);
	}
	return valencia_this_type_id;
}


#line 30 "expression.vala"
static char* valencia_base_real_to_string (ValenciaExpression* base) {
#line 551 "expression.c"
	ValenciaBase * self;
	char* result;
	self = (ValenciaBase*) base;
	result = g_strdup ("base");
	return result;
}


#line 29 "expression.vala"
ValenciaBase* valencia_base_construct (GType object_type) {
#line 562 "expression.c"
	ValenciaBase * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 29 "expression.vala"
ValenciaBase* valencia_base_new (void) {
#line 29 "expression.vala"
	return valencia_base_construct (VALENCIA_TYPE_BASE);
#line 573 "expression.c"
}


static void valencia_base_class_init (ValenciaBaseClass * klass) {
	valencia_base_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_CLASS (klass)->to_string = valencia_base_real_to_string;
}


static void valencia_base_instance_init (ValenciaBase * self) {
}


GType valencia_base_get_type (void) {
	static GType valencia_base_type_id = 0;
	if (valencia_base_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaBaseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_base_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaBase), 0, (GInstanceInitFunc) valencia_base_instance_init, NULL };
		valencia_base_type_id = g_type_register_static (VALENCIA_TYPE_EXPRESSION, "ValenciaBase", &g_define_type_info, 0);
	}
	return valencia_base_type_id;
}


#line 36 "expression.vala"
ValenciaNew* valencia_new_construct (GType object_type, ValenciaExpression* class_name) {
#line 599 "expression.c"
	ValenciaNew * self;
	ValenciaExpression* _tmp1_;
	ValenciaExpression* _tmp0_;
#line 36 "expression.vala"
	g_return_val_if_fail (class_name != NULL, NULL);
#line 605 "expression.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 37 "expression.vala"
	_tmp0_ = NULL;
#line 37 "expression.vala"
	self->class_name = (_tmp1_ = (_tmp0_ = class_name, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->class_name == NULL) ? NULL : (self->class_name = (g_object_unref (self->class_name), NULL)), _tmp1_);
#line 612 "expression.c"
	return self;
}


#line 36 "expression.vala"
ValenciaNew* valencia_new_new (ValenciaExpression* class_name) {
#line 36 "expression.vala"
	return valencia_new_construct (VALENCIA_TYPE_NEW, class_name);
#line 621 "expression.c"
}


#line 40 "expression.vala"
static char* valencia_new_real_to_string (ValenciaExpression* base) {
#line 627 "expression.c"
	ValenciaNew * self;
	char* result;
	char* _tmp0_;
	char* _tmp1_;
	self = (ValenciaNew*) base;
#line 10 "expression.vala"
	_tmp0_ = NULL;
#line 41 "expression.vala"
	_tmp1_ = NULL;
#line 637 "expression.c"
	result = (_tmp1_ = g_strconcat ("new ", _tmp0_ = valencia_expression_to_string (self->class_name), NULL), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	return result;
}


static void valencia_new_class_init (ValenciaNewClass * klass) {
	valencia_new_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_CLASS (klass)->to_string = valencia_new_real_to_string;
	G_OBJECT_CLASS (klass)->finalize = valencia_new_finalize;
}


static void valencia_new_instance_init (ValenciaNew * self) {
}


static void valencia_new_finalize (GObject* obj) {
	ValenciaNew * self;
	self = VALENCIA_NEW (obj);
	(self->class_name == NULL) ? NULL : (self->class_name = (g_object_unref (self->class_name), NULL));
	G_OBJECT_CLASS (valencia_new_parent_class)->finalize (obj);
}


GType valencia_new_get_type (void) {
	static GType valencia_new_type_id = 0;
	if (valencia_new_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaNewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_new_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaNew), 0, (GInstanceInitFunc) valencia_new_instance_init, NULL };
		valencia_new_type_id = g_type_register_static (VALENCIA_TYPE_EXPRESSION, "ValenciaNew", &g_define_type_info, 0);
	}
	return valencia_new_type_id;
}


#line 48 "expression.vala"
ValenciaMethodCall* valencia_method_call_construct (GType object_type, ValenciaExpression* method) {
#line 674 "expression.c"
	ValenciaMethodCall * self;
	ValenciaExpression* _tmp1_;
	ValenciaExpression* _tmp0_;
#line 48 "expression.vala"
	g_return_val_if_fail (method != NULL, NULL);
#line 680 "expression.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 49 "expression.vala"
	_tmp0_ = NULL;
#line 49 "expression.vala"
	self->method = (_tmp1_ = (_tmp0_ = method, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->method == NULL) ? NULL : (self->method = (g_object_unref (self->method), NULL)), _tmp1_);
#line 687 "expression.c"
	return self;
}


#line 48 "expression.vala"
ValenciaMethodCall* valencia_method_call_new (ValenciaExpression* method) {
#line 48 "expression.vala"
	return valencia_method_call_construct (VALENCIA_TYPE_METHOD_CALL, method);
#line 696 "expression.c"
}


#line 52 "expression.vala"
static char* valencia_method_call_real_to_string (ValenciaExpression* base) {
#line 702 "expression.c"
	ValenciaMethodCall * self;
	char* result;
	char* _tmp0_;
	char* _tmp1_;
	self = (ValenciaMethodCall*) base;
#line 10 "expression.vala"
	_tmp0_ = NULL;
#line 53 "expression.vala"
	_tmp1_ = NULL;
#line 712 "expression.c"
	result = (_tmp1_ = g_strconcat (_tmp0_ = valencia_expression_to_string (self->method), "()", NULL), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	return result;
}


static void valencia_method_call_class_init (ValenciaMethodCallClass * klass) {
	valencia_method_call_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_CLASS (klass)->to_string = valencia_method_call_real_to_string;
	G_OBJECT_CLASS (klass)->finalize = valencia_method_call_finalize;
}


static void valencia_method_call_instance_init (ValenciaMethodCall * self) {
}


static void valencia_method_call_finalize (GObject* obj) {
	ValenciaMethodCall * self;
	self = VALENCIA_METHOD_CALL (obj);
	(self->method == NULL) ? NULL : (self->method = (g_object_unref (self->method), NULL));
	G_OBJECT_CLASS (valencia_method_call_parent_class)->finalize (obj);
}


GType valencia_method_call_get_type (void) {
	static GType valencia_method_call_type_id = 0;
	if (valencia_method_call_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaMethodCallClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_method_call_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaMethodCall), 0, (GInstanceInitFunc) valencia_method_call_instance_init, NULL };
		valencia_method_call_type_id = g_type_register_static (VALENCIA_TYPE_EXPRESSION, "ValenciaMethodCall", &g_define_type_info, 0);
	}
	return valencia_method_call_type_id;
}


#line 61 "expression.vala"
ValenciaCompoundExpression* valencia_compound_expression_construct (GType object_type, ValenciaExpression* left, const char* right) {
#line 749 "expression.c"
	ValenciaCompoundExpression * self;
	ValenciaExpression* _tmp1_;
	ValenciaExpression* _tmp0_;
	char* _tmp3_;
	const char* _tmp2_;
#line 61 "expression.vala"
	g_return_val_if_fail (left != NULL, NULL);
#line 61 "expression.vala"
	g_return_val_if_fail (right != NULL, NULL);
#line 759 "expression.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 62 "expression.vala"
	_tmp0_ = NULL;
#line 62 "expression.vala"
	self->left = (_tmp1_ = (_tmp0_ = left, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->left == NULL) ? NULL : (self->left = (g_object_unref (self->left), NULL)), _tmp1_);
#line 766 "expression.c"
	_tmp3_ = NULL;
#line 63 "expression.vala"
	_tmp2_ = NULL;
#line 63 "expression.vala"
	self->right = (_tmp3_ = (_tmp2_ = right, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), self->right = (g_free (self->right), NULL), _tmp3_);
#line 772 "expression.c"
	return self;
}


#line 61 "expression.vala"
ValenciaCompoundExpression* valencia_compound_expression_new (ValenciaExpression* left, const char* right) {
#line 61 "expression.vala"
	return valencia_compound_expression_construct (VALENCIA_TYPE_COMPOUND_EXPRESSION, left, right);
#line 781 "expression.c"
}


#line 66 "expression.vala"
static char* valencia_compound_expression_real_to_string (ValenciaExpression* base) {
#line 787 "expression.c"
	ValenciaCompoundExpression * self;
	char* result;
	char* _tmp1_;
	char* _tmp0_;
	char* _tmp2_;
	self = (ValenciaCompoundExpression*) base;
	_tmp1_ = NULL;
#line 10 "expression.vala"
	_tmp0_ = NULL;
#line 67 "expression.vala"
	_tmp2_ = NULL;
#line 799 "expression.c"
	result = (_tmp2_ = g_strconcat (_tmp1_ = g_strconcat (_tmp0_ = valencia_expression_to_string (self->left), ".", NULL), self->right, NULL), _tmp1_ = (g_free (_tmp1_), NULL), _tmp0_ = (g_free (_tmp0_), NULL), _tmp2_);
	return result;
}


static void valencia_compound_expression_class_init (ValenciaCompoundExpressionClass * klass) {
	valencia_compound_expression_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_CLASS (klass)->to_string = valencia_compound_expression_real_to_string;
	G_OBJECT_CLASS (klass)->finalize = valencia_compound_expression_finalize;
}


static void valencia_compound_expression_instance_init (ValenciaCompoundExpression * self) {
}


static void valencia_compound_expression_finalize (GObject* obj) {
	ValenciaCompoundExpression * self;
	self = VALENCIA_COMPOUND_EXPRESSION (obj);
	(self->left == NULL) ? NULL : (self->left = (g_object_unref (self->left), NULL));
	self->right = (g_free (self->right), NULL);
	G_OBJECT_CLASS (valencia_compound_expression_parent_class)->finalize (obj);
}


GType valencia_compound_expression_get_type (void) {
	static GType valencia_compound_expression_type_id = 0;
	if (valencia_compound_expression_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaCompoundExpressionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_compound_expression_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaCompoundExpression), 0, (GInstanceInitFunc) valencia_compound_expression_instance_init, NULL };
		valencia_compound_expression_type_id = g_type_register_static (VALENCIA_TYPE_EXPRESSION, "ValenciaCompoundExpression", &g_define_type_info, 0);
	}
	return valencia_compound_expression_type_id;
}


#line 76 "expression.vala"
ValenciaExpressionParser* valencia_expression_parser_construct (GType object_type, const char* input, gint pos, gboolean partial) {
#line 837 "expression.c"
	ValenciaExpressionParser* self;
	ValenciaScanner* _tmp0_;
#line 76 "expression.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 842 "expression.c"
	self = (ValenciaExpressionParser*) g_type_create_instance (object_type);
	_tmp0_ = NULL;
#line 77 "expression.vala"
	self->priv->scanner = (_tmp0_ = valencia_scanner_new (input), (self->priv->scanner == NULL) ? NULL : (self->priv->scanner = (g_object_unref (self->priv->scanner), NULL)), _tmp0_);
#line 78 "expression.vala"
	self->priv->pos = pos;
#line 79 "expression.vala"
	self->priv->partial = partial;
#line 851 "expression.c"
	return self;
}


#line 76 "expression.vala"
ValenciaExpressionParser* valencia_expression_parser_new (const char* input, gint pos, gboolean partial) {
#line 76 "expression.vala"
	return valencia_expression_parser_construct (VALENCIA_TYPE_EXPRESSION_PARSER, input, pos, partial);
#line 860 "expression.c"
}


#line 82 "expression.vala"
static gboolean valencia_expression_parser_accept (ValenciaExpressionParser* self, ValenciaToken t) {
#line 866 "expression.c"
	gboolean result;
#line 82 "expression.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 870 "expression.c"
	result = valencia_scanner_accept_token (self->priv->scanner, t);
	return result;
}


#line 84 "expression.vala"
static ValenciaParseInfo* valencia_expression_parser_parse_expr (ValenciaExpressionParser* self, gboolean nested) {
#line 878 "expression.c"
	ValenciaParseInfo* result;
	gint parens;
#line 84 "expression.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 883 "expression.c"
	parens = 0;
#line 87 "expression.vala"
	while (TRUE) {
#line 887 "expression.c"
		ValenciaToken t;
		gboolean _tmp0_;
		gboolean is_new;
		gboolean _tmp1_;
		t = valencia_scanner_next_token (self->priv->scanner);
		_tmp0_ = FALSE;
#line 89 "expression.vala"
		if (t == VALENCIA_TOKEN_EOF) {
#line 89 "expression.vala"
			_tmp0_ = TRUE;
#line 898 "expression.c"
		} else {
#line 89 "expression.vala"
			_tmp0_ = self->priv->scanner->start > self->priv->pos;
#line 902 "expression.c"
		}
#line 89 "expression.vala"
		if (_tmp0_) {
#line 90 "expression.vala"
			break;
#line 908 "expression.c"
		}
		is_new = FALSE;
#line 93 "expression.vala"
		if (t == VALENCIA_TOKEN_NEW) {
#line 94 "expression.vala"
			is_new = TRUE;
#line 95 "expression.vala"
			t = valencia_scanner_next_token (self->priv->scanner);
#line 96 "expression.vala"
			if (self->priv->scanner->start > self->priv->pos) {
#line 97 "expression.vala"
				break;
#line 921 "expression.c"
			}
		} else {
#line 98 "expression.vala"
			is_new = FALSE;
#line 926 "expression.c"
		}
		_tmp1_ = FALSE;
#line 100 "expression.vala"
		if (t == VALENCIA_TOKEN_ID) {
#line 100 "expression.vala"
			_tmp1_ = TRUE;
#line 933 "expression.c"
		} else {
			gboolean _tmp2_;
			gboolean _tmp3_;
			_tmp2_ = FALSE;
			_tmp3_ = FALSE;
#line 100 "expression.vala"
			if (t == VALENCIA_TOKEN_THIS) {
#line 100 "expression.vala"
				_tmp3_ = TRUE;
#line 943 "expression.c"
			} else {
#line 100 "expression.vala"
				_tmp3_ = t == VALENCIA_TOKEN_BASE;
#line 947 "expression.c"
			}
#line 100 "expression.vala"
			if (_tmp3_) {
#line 100 "expression.vala"
				_tmp2_ = !is_new;
#line 953 "expression.c"
			} else {
#line 100 "expression.vala"
				_tmp2_ = FALSE;
#line 957 "expression.c"
			}
#line 100 "expression.vala"
			_tmp1_ = _tmp2_;
#line 961 "expression.c"
		}
#line 100 "expression.vala"
		if (_tmp1_) {
#line 965 "expression.c"
			ValenciaExpression* e;
			e = NULL;
#line 102 "expression.vala"
			if (t == VALENCIA_TOKEN_ID) {
#line 970 "expression.c"
				ValenciaExpression* _tmp5_;
				char* _tmp4_;
				_tmp5_ = NULL;
#line 301 "scanner.vala"
				_tmp4_ = NULL;
#line 103 "expression.vala"
				e = (_tmp5_ = (ValenciaExpression*) valencia_id_new (_tmp4_ = valencia_scanner_val (self->priv->scanner)), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp5_);
#line 978 "expression.c"
				_tmp4_ = (g_free (_tmp4_), NULL);
			} else {
#line 104 "expression.vala"
				if (t == VALENCIA_TOKEN_THIS) {
#line 983 "expression.c"
					ValenciaExpression* _tmp6_;
					_tmp6_ = NULL;
#line 105 "expression.vala"
					e = (_tmp6_ = (ValenciaExpression*) valencia_this_new (), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp6_);
#line 988 "expression.c"
				} else {
#line 106 "expression.vala"
					if (t == VALENCIA_TOKEN_BASE) {
#line 992 "expression.c"
						ValenciaExpression* _tmp7_;
						_tmp7_ = NULL;
#line 107 "expression.vala"
						e = (_tmp7_ = (ValenciaExpression*) valencia_base_new (), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp7_);
#line 997 "expression.c"
					}
				}
			}
#line 109 "expression.vala"
			while (TRUE) {
#line 1003 "expression.c"
				gboolean _tmp18_;
#line 110 "expression.vala"
				if (self->priv->scanner->end >= self->priv->pos) {
#line 1007 "expression.c"
					ValenciaExpression* _tmp8_;
					_tmp8_ = NULL;
#line 111 "expression.vala"
					if (is_new) {
#line 1012 "expression.c"
						ValenciaExpression* _tmp9_;
						_tmp9_ = NULL;
#line 111 "expression.vala"
						_tmp8_ = (_tmp9_ = (ValenciaExpression*) valencia_new_new (e), (_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_object_unref (_tmp8_), NULL)), _tmp9_);
#line 1017 "expression.c"
					} else {
						ValenciaExpression* _tmp11_;
						ValenciaExpression* _tmp10_;
						_tmp11_ = NULL;
#line 111 "expression.vala"
						_tmp10_ = NULL;
#line 111 "expression.vala"
						_tmp8_ = (_tmp11_ = (_tmp10_ = e, (_tmp10_ == NULL) ? NULL : g_object_ref (_tmp10_)), (_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_object_unref (_tmp8_), NULL)), _tmp11_);
#line 1026 "expression.c"
					}
					result = valencia_parse_info_new (_tmp8_);
					(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_object_unref (_tmp8_), NULL));
					(e == NULL) ? NULL : (e = (g_object_unref (e), NULL));
					return result;
				}
#line 112 "expression.vala"
				if (valencia_expression_parser_accept (self, VALENCIA_TOKEN_LEFT_PAREN)) {
#line 1035 "expression.c"
					gint paren_pos;
					ValenciaParseInfo* info;
					gboolean _tmp13_;
					gboolean _tmp14_;
					ValenciaExpression* _tmp17_;
#line 113 "expression.vala"
					if (is_new) {
#line 1043 "expression.c"
						ValenciaExpression* _tmp12_;
						_tmp12_ = NULL;
#line 114 "expression.vala"
						e = (_tmp12_ = (ValenciaExpression*) valencia_new_new (e), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp12_);
#line 115 "expression.vala"
						is_new = FALSE;
#line 1050 "expression.c"
					}
					paren_pos = self->priv->scanner->start;
					info = valencia_expression_parser_parse_expr (self, TRUE);
					_tmp13_ = FALSE;
					_tmp14_ = FALSE;
#line 119 "expression.vala"
					if (self->priv->scanner->end > self->priv->pos) {
#line 119 "expression.vala"
						_tmp14_ = TRUE;
#line 1060 "expression.c"
					} else {
#line 119 "expression.vala"
						_tmp14_ = info->inner != NULL;
#line 1064 "expression.c"
					}
#line 119 "expression.vala"
					if (_tmp14_) {
#line 119 "expression.vala"
						_tmp13_ = TRUE;
#line 1070 "expression.c"
					} else {
#line 119 "expression.vala"
						_tmp13_ = info->outer != NULL;
#line 1074 "expression.c"
					}
#line 119 "expression.vala"
					if (_tmp13_) {
#line 120 "expression.vala"
						if (info->outer == NULL) {
#line 1080 "expression.c"
							ValenciaExpression* _tmp16_;
							ValenciaExpression* _tmp15_;
							_tmp16_ = NULL;
#line 121 "expression.vala"
							_tmp15_ = NULL;
#line 121 "expression.vala"
							info->outer = (_tmp16_ = (_tmp15_ = e, (_tmp15_ == NULL) ? NULL : g_object_ref (_tmp15_)), (info->outer == NULL) ? NULL : (info->outer = (g_object_unref (info->outer), NULL)), _tmp16_);
#line 122 "expression.vala"
							info->outer_pos = paren_pos;
#line 1090 "expression.c"
						}
						result = info;
						(e == NULL) ? NULL : (e = (g_object_unref (e), NULL));
						return result;
					}
					_tmp17_ = NULL;
#line 126 "expression.vala"
					e = (_tmp17_ = (ValenciaExpression*) valencia_method_call_new (e), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp17_);
#line 1099 "expression.c"
					(info == NULL) ? NULL : (info = (g_object_unref (info), NULL));
				}
#line 128 "expression.vala"
				if (!valencia_expression_parser_accept (self, VALENCIA_TOKEN_PERIOD)) {
#line 129 "expression.vala"
					break;
#line 1106 "expression.c"
				}
				_tmp18_ = FALSE;
#line 130 "expression.vala"
				if (self->priv->partial) {
#line 130 "expression.vala"
					_tmp18_ = self->priv->scanner->end == self->priv->pos;
#line 1113 "expression.c"
				} else {
#line 130 "expression.vala"
					_tmp18_ = FALSE;
#line 1117 "expression.c"
				}
#line 130 "expression.vala"
				if (_tmp18_) {
#line 1121 "expression.c"
					ValenciaExpression* _tmp19_;
					_tmp19_ = NULL;
#line 131 "expression.vala"
					e = (_tmp19_ = (ValenciaExpression*) valencia_compound_expression_new (e, ""), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp19_);
#line 1126 "expression.c"
				} else {
					gboolean _tmp20_;
					_tmp20_ = FALSE;
#line 132 "expression.vala"
					if (valencia_expression_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 132 "expression.vala"
						_tmp20_ = self->priv->scanner->start <= self->priv->pos;
#line 1134 "expression.c"
					} else {
#line 132 "expression.vala"
						_tmp20_ = FALSE;
#line 1138 "expression.c"
					}
#line 132 "expression.vala"
					if (_tmp20_) {
#line 1142 "expression.c"
						ValenciaExpression* _tmp22_;
						char* _tmp21_;
						_tmp22_ = NULL;
#line 301 "scanner.vala"
						_tmp21_ = NULL;
#line 133 "expression.vala"
						e = (_tmp22_ = (ValenciaExpression*) valencia_compound_expression_new (e, _tmp21_ = valencia_scanner_val (self->priv->scanner)), (e == NULL) ? NULL : (e = (g_object_unref (e), NULL)), _tmp22_);
#line 1150 "expression.c"
						_tmp21_ = (g_free (_tmp21_), NULL);
					} else {
#line 134 "expression.vala"
						break;
#line 1155 "expression.c"
					}
				}
			}
			(e == NULL) ? NULL : (e = (g_object_unref (e), NULL));
		}
#line 138 "expression.vala"
		if (nested) {
#line 1163 "expression.c"
			gboolean _tmp23_;
#line 139 "expression.vala"
			if (t == VALENCIA_TOKEN_LEFT_PAREN) {
#line 140 "expression.vala"
				parens = parens + 1;
#line 141 "expression.vala"
				continue;
#line 1171 "expression.c"
			}
			_tmp23_ = FALSE;
#line 143 "expression.vala"
			if (t == VALENCIA_TOKEN_RIGHT_PAREN) {
#line 143 "expression.vala"
				_tmp23_ = (parens = parens - 1) < 0;
#line 1178 "expression.c"
			} else {
#line 143 "expression.vala"
				_tmp23_ = FALSE;
#line 1182 "expression.c"
			}
#line 143 "expression.vala"
			if (_tmp23_) {
#line 144 "expression.vala"
				break;
#line 1188 "expression.c"
			}
		}
	}
	result = valencia_parse_info_new (NULL);
	return result;
}


#line 151 "expression.vala"
ValenciaParseInfo* valencia_expression_parser_parse (ValenciaExpressionParser* self) {
#line 1199 "expression.c"
	ValenciaParseInfo* result;
#line 151 "expression.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1203 "expression.c"
	result = valencia_expression_parser_parse_expr (self, FALSE);
	return result;
}


static void valencia_value_expression_parser_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void valencia_value_expression_parser_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		valencia_expression_parser_unref (value->data[0].v_pointer);
	}
}


static void valencia_value_expression_parser_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = valencia_expression_parser_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer valencia_value_expression_parser_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* valencia_value_expression_parser_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		ValenciaExpressionParser* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = valencia_expression_parser_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* valencia_value_expression_parser_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	ValenciaExpressionParser** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags && G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = valencia_expression_parser_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* valencia_param_spec_expression_parser (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ValenciaParamSpecExpressionParser* spec;
	g_return_val_if_fail (g_type_is_a (object_type, VALENCIA_TYPE_EXPRESSION_PARSER), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer valencia_value_get_expression_parser (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALENCIA_TYPE_EXPRESSION_PARSER), NULL);
	return value->data[0].v_pointer;
}


void valencia_value_set_expression_parser (GValue* value, gpointer v_object) {
	ValenciaExpressionParser* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VALENCIA_TYPE_EXPRESSION_PARSER));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VALENCIA_TYPE_EXPRESSION_PARSER));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		valencia_expression_parser_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		valencia_expression_parser_unref (old);
	}
}


static void valencia_expression_parser_class_init (ValenciaExpressionParserClass * klass) {
	valencia_expression_parser_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_EXPRESSION_PARSER_CLASS (klass)->finalize = valencia_expression_parser_finalize;
	g_type_class_add_private (klass, sizeof (ValenciaExpressionParserPrivate));
}


static void valencia_expression_parser_instance_init (ValenciaExpressionParser * self) {
	self->priv = VALENCIA_EXPRESSION_PARSER_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void valencia_expression_parser_finalize (ValenciaExpressionParser* obj) {
	ValenciaExpressionParser * self;
	self = VALENCIA_EXPRESSION_PARSER (obj);
	(self->priv->scanner == NULL) ? NULL : (self->priv->scanner = (g_object_unref (self->priv->scanner), NULL));
}


GType valencia_expression_parser_get_type (void) {
	static GType valencia_expression_parser_type_id = 0;
	if (valencia_expression_parser_type_id == 0) {
		static const GTypeValueTable g_define_type_value_table = { valencia_value_expression_parser_init, valencia_value_expression_parser_free_value, valencia_value_expression_parser_copy_value, valencia_value_expression_parser_peek_pointer, "p", valencia_value_expression_parser_collect_value, "p", valencia_value_expression_parser_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaExpressionParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_expression_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaExpressionParser), 0, (GInstanceInitFunc) valencia_expression_parser_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		valencia_expression_parser_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ValenciaExpressionParser", &g_define_type_info, &g_define_type_fundamental_info, 0);
	}
	return valencia_expression_parser_type_id;
}


gpointer valencia_expression_parser_ref (gpointer instance) {
	ValenciaExpressionParser* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void valencia_expression_parser_unref (gpointer instance) {
	ValenciaExpressionParser* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VALENCIA_EXPRESSION_PARSER_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}




