/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <stdio.h>
#include <glib/gstdio.h>


#define VALENCIA_TYPE_SCAN_SCOPE (valencia_scan_scope_get_type ())
#define VALENCIA_SCAN_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCAN_SCOPE, ValenciaScanScope))
#define VALENCIA_SCAN_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SCAN_SCOPE, ValenciaScanScopeClass))
#define VALENCIA_IS_SCAN_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCAN_SCOPE))
#define VALENCIA_IS_SCAN_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SCAN_SCOPE))
#define VALENCIA_SCAN_SCOPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SCAN_SCOPE, ValenciaScanScopeClass))

typedef struct _ValenciaScanScope ValenciaScanScope;
typedef struct _ValenciaScanScopeClass ValenciaScanScopeClass;
typedef struct _ValenciaScanScopePrivate ValenciaScanScopePrivate;

#define VALENCIA_TYPE_PARSE_INFO (valencia_parse_info_get_type ())
#define VALENCIA_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfo))
#define VALENCIA_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))
#define VALENCIA_IS_PARSE_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_IS_PARSE_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARSE_INFO))
#define VALENCIA_PARSE_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARSE_INFO, ValenciaParseInfoClass))

typedef struct _ValenciaParseInfo ValenciaParseInfo;
typedef struct _ValenciaParseInfoClass ValenciaParseInfoClass;
typedef struct _ValenciaParseInfoPrivate ValenciaParseInfoPrivate;

#define VALENCIA_TYPE_EXPRESSION (valencia_expression_get_type ())
#define VALENCIA_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpression))
#define VALENCIA_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))
#define VALENCIA_IS_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_IS_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))

typedef struct _ValenciaExpression ValenciaExpression;
typedef struct _ValenciaExpressionClass ValenciaExpressionClass;

#define VALENCIA_TYPE_PARSER (valencia_parser_get_type ())
#define VALENCIA_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARSER, ValenciaParser))
#define VALENCIA_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARSER, ValenciaParserClass))
#define VALENCIA_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARSER))
#define VALENCIA_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARSER))
#define VALENCIA_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARSER, ValenciaParserClass))

typedef struct _ValenciaParser ValenciaParser;
typedef struct _ValenciaParserClass ValenciaParserClass;
typedef struct _ValenciaParserPrivate ValenciaParserPrivate;

#define VALENCIA_TYPE_NODE (valencia_node_get_type ())
#define VALENCIA_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NODE, ValenciaNode))
#define VALENCIA_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NODE, ValenciaNodeClass))
#define VALENCIA_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NODE))
#define VALENCIA_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NODE))
#define VALENCIA_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NODE, ValenciaNodeClass))

typedef struct _ValenciaNode ValenciaNode;
typedef struct _ValenciaNodeClass ValenciaNodeClass;

#define VALENCIA_TYPE_SOURCE_FILE (valencia_source_file_get_type ())
#define VALENCIA_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFile))
#define VALENCIA_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))
#define VALENCIA_IS_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_IS_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_SOURCE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))

typedef struct _ValenciaSourceFile ValenciaSourceFile;
typedef struct _ValenciaSourceFileClass ValenciaSourceFileClass;

#define VALENCIA_TYPE_SCANNER (valencia_scanner_get_type ())
#define VALENCIA_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCANNER, ValenciaScanner))
#define VALENCIA_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SCANNER, ValenciaScannerClass))
#define VALENCIA_IS_SCANNER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCANNER))
#define VALENCIA_IS_SCANNER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SCANNER))
#define VALENCIA_SCANNER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SCANNER, ValenciaScannerClass))

typedef struct _ValenciaScanner ValenciaScanner;
typedef struct _ValenciaScannerClass ValenciaScannerClass;

#define VALENCIA_TYPE_SYMBOL (valencia_symbol_get_type ())
#define VALENCIA_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbol))
#define VALENCIA_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))
#define VALENCIA_IS_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_IS_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))

typedef struct _ValenciaSymbol ValenciaSymbol;
typedef struct _ValenciaSymbolClass ValenciaSymbolClass;

#define VALENCIA_TYPE_TYPESYMBOL (valencia_typesymbol_get_type ())
#define VALENCIA_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbol))
#define VALENCIA_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))
#define VALENCIA_IS_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_IS_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_TYPESYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))

typedef struct _ValenciaTypeSymbol ValenciaTypeSymbol;
typedef struct _ValenciaTypeSymbolClass ValenciaTypeSymbolClass;

#define VALENCIA_TYPE_NAMESPACE (valencia_namespace_get_type ())
#define VALENCIA_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespace))
#define VALENCIA_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))
#define VALENCIA_IS_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_IS_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_NAMESPACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))

typedef struct _ValenciaNamespace ValenciaNamespace;
typedef struct _ValenciaNamespaceClass ValenciaNamespaceClass;

#define VALENCIA_TYPE_TOKEN (valencia_token_get_type ())

#define VALENCIA_TYPE_ID (valencia_id_get_type ())
#define VALENCIA_ID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ID, ValenciaId))
#define VALENCIA_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ID, ValenciaIdClass))
#define VALENCIA_IS_ID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ID))
#define VALENCIA_IS_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ID))
#define VALENCIA_ID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ID, ValenciaIdClass))

typedef struct _ValenciaId ValenciaId;
typedef struct _ValenciaIdClass ValenciaIdClass;

#define VALENCIA_TYPE_COMPOUND_EXPRESSION (valencia_compound_expression_get_type ())
#define VALENCIA_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpression))
#define VALENCIA_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))
#define VALENCIA_IS_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_IS_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_COMPOUND_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))

typedef struct _ValenciaCompoundExpression ValenciaCompoundExpression;
typedef struct _ValenciaCompoundExpressionClass ValenciaCompoundExpressionClass;
typedef struct _ValenciaScannerPrivate ValenciaScannerPrivate;

#define VALENCIA_TYPE_VARIABLE (valencia_variable_get_type ())
#define VALENCIA_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_VARIABLE, ValenciaVariable))
#define VALENCIA_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_VARIABLE, ValenciaVariableClass))
#define VALENCIA_IS_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_VARIABLE))
#define VALENCIA_IS_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_VARIABLE))
#define VALENCIA_VARIABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_VARIABLE, ValenciaVariableClass))

typedef struct _ValenciaVariable ValenciaVariable;
typedef struct _ValenciaVariableClass ValenciaVariableClass;

#define VALENCIA_TYPE_PARAMETER (valencia_parameter_get_type ())
#define VALENCIA_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARAMETER, ValenciaParameter))
#define VALENCIA_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARAMETER, ValenciaParameterClass))
#define VALENCIA_IS_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARAMETER))
#define VALENCIA_IS_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARAMETER))
#define VALENCIA_PARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARAMETER, ValenciaParameterClass))

typedef struct _ValenciaParameter ValenciaParameter;
typedef struct _ValenciaParameterClass ValenciaParameterClass;

#define VALENCIA_TYPE_LOCAL_VARIABLE (valencia_local_variable_get_type ())
#define VALENCIA_LOCAL_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariable))
#define VALENCIA_LOCAL_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariableClass))
#define VALENCIA_IS_LOCAL_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_LOCAL_VARIABLE))
#define VALENCIA_IS_LOCAL_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_LOCAL_VARIABLE))
#define VALENCIA_LOCAL_VARIABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariableClass))

typedef struct _ValenciaLocalVariable ValenciaLocalVariable;
typedef struct _ValenciaLocalVariableClass ValenciaLocalVariableClass;
typedef struct _ValenciaNodePrivate ValenciaNodePrivate;
typedef struct _ValenciaSymbolPrivate ValenciaSymbolPrivate;
typedef struct _ValenciaVariablePrivate ValenciaVariablePrivate;

#define VALENCIA_TYPE_STATEMENT (valencia_statement_get_type ())
#define VALENCIA_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_STATEMENT, ValenciaStatement))
#define VALENCIA_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_STATEMENT, ValenciaStatementClass))
#define VALENCIA_IS_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_STATEMENT))
#define VALENCIA_IS_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_STATEMENT))
#define VALENCIA_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_STATEMENT, ValenciaStatementClass))

typedef struct _ValenciaStatement ValenciaStatement;
typedef struct _ValenciaStatementClass ValenciaStatementClass;

#define VALENCIA_TYPE_DECLARATION_STATEMENT (valencia_declaration_statement_get_type ())
#define VALENCIA_DECLARATION_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatement))
#define VALENCIA_DECLARATION_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatementClass))
#define VALENCIA_IS_DECLARATION_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT))
#define VALENCIA_IS_DECLARATION_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_DECLARATION_STATEMENT))
#define VALENCIA_DECLARATION_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatementClass))

typedef struct _ValenciaDeclarationStatement ValenciaDeclarationStatement;
typedef struct _ValenciaDeclarationStatementClass ValenciaDeclarationStatementClass;

#define VALENCIA_TYPE_FOR (valencia_for_get_type ())
#define VALENCIA_FOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_FOR, ValenciaFor))
#define VALENCIA_FOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_FOR, ValenciaForClass))
#define VALENCIA_IS_FOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_FOR))
#define VALENCIA_IS_FOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_FOR))
#define VALENCIA_FOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_FOR, ValenciaForClass))

typedef struct _ValenciaFor ValenciaFor;
typedef struct _ValenciaForClass ValenciaForClass;

#define VALENCIA_TYPE_BLOCK (valencia_block_get_type ())
#define VALENCIA_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_BLOCK, ValenciaBlock))
#define VALENCIA_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_BLOCK, ValenciaBlockClass))
#define VALENCIA_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_BLOCK))
#define VALENCIA_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_BLOCK))
#define VALENCIA_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_BLOCK, ValenciaBlockClass))

typedef struct _ValenciaBlock ValenciaBlock;
typedef struct _ValenciaBlockClass ValenciaBlockClass;
typedef struct _ValenciaStatementPrivate ValenciaStatementPrivate;

#define VALENCIA_TYPE_SYMBOL_SET (valencia_symbol_set_get_type ())
#define VALENCIA_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSet))
#define VALENCIA_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))
#define VALENCIA_IS_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_IS_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_SYMBOL_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))

typedef struct _ValenciaSymbolSet ValenciaSymbolSet;
typedef struct _ValenciaSymbolSetClass ValenciaSymbolSetClass;

#define VALENCIA_TYPE_SCOPE (valencia_scope_get_type ())
#define VALENCIA_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCOPE, ValenciaScope))
#define VALENCIA_IS_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCOPE))
#define VALENCIA_SCOPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALENCIA_TYPE_SCOPE, ValenciaScopeIface))

typedef struct _ValenciaScope ValenciaScope;
typedef struct _ValenciaScopeIface ValenciaScopeIface;
typedef struct _ValenciaBlockPrivate ValenciaBlockPrivate;

#define VALENCIA_TYPE_METHOD (valencia_method_get_type ())
#define VALENCIA_METHOD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_METHOD, ValenciaMethod))
#define VALENCIA_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_METHOD, ValenciaMethodClass))
#define VALENCIA_IS_METHOD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_METHOD))
#define VALENCIA_IS_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_METHOD))
#define VALENCIA_METHOD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_METHOD, ValenciaMethodClass))

typedef struct _ValenciaMethod ValenciaMethod;
typedef struct _ValenciaMethodClass ValenciaMethodClass;
typedef struct _ValenciaMethodPrivate ValenciaMethodPrivate;

#define VALENCIA_TYPE_CLASS (valencia_class_get_type ())
#define VALENCIA_CLASS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CLASS, ValenciaClass))
#define VALENCIA_CLASS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CLASS, ValenciaClassClass))
#define VALENCIA_IS_CLASS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CLASS))
#define VALENCIA_IS_CLASS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CLASS))
#define VALENCIA_CLASS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CLASS, ValenciaClassClass))

typedef struct _ValenciaClass ValenciaClass;
typedef struct _ValenciaClassClass ValenciaClassClass;

#define VALENCIA_TYPE_CONSTRUCTOR (valencia_constructor_get_type ())
#define VALENCIA_CONSTRUCTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructor))
#define VALENCIA_CONSTRUCTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructorClass))
#define VALENCIA_IS_CONSTRUCTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONSTRUCTOR))
#define VALENCIA_IS_CONSTRUCTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONSTRUCTOR))
#define VALENCIA_CONSTRUCTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructorClass))

typedef struct _ValenciaConstructor ValenciaConstructor;
typedef struct _ValenciaConstructorClass ValenciaConstructorClass;
typedef struct _ValenciaExpressionPrivate ValenciaExpressionPrivate;
typedef struct _ValenciaCompoundExpressionPrivate ValenciaCompoundExpressionPrivate;

#define VALENCIA_TYPE_FIELD (valencia_field_get_type ())
#define VALENCIA_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_FIELD, ValenciaField))
#define VALENCIA_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_FIELD, ValenciaFieldClass))
#define VALENCIA_IS_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_FIELD))
#define VALENCIA_IS_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_FIELD))
#define VALENCIA_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_FIELD, ValenciaFieldClass))

typedef struct _ValenciaField ValenciaField;
typedef struct _ValenciaFieldClass ValenciaFieldClass;

#define VALENCIA_TYPE_VSIGNAL (valencia_vsignal_get_type ())
#define VALENCIA_VSIGNAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_VSIGNAL, ValenciaVSignal))
#define VALENCIA_VSIGNAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_VSIGNAL, ValenciaVSignalClass))
#define VALENCIA_IS_VSIGNAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_VSIGNAL))
#define VALENCIA_IS_VSIGNAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_VSIGNAL))
#define VALENCIA_VSIGNAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_VSIGNAL, ValenciaVSignalClass))

typedef struct _ValenciaVSignal ValenciaVSignal;
typedef struct _ValenciaVSignalClass ValenciaVSignalClass;

#define VALENCIA_TYPE_DELEGATE (valencia_delegate_get_type ())
#define VALENCIA_DELEGATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_DELEGATE, ValenciaDelegate))
#define VALENCIA_DELEGATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_DELEGATE, ValenciaDelegateClass))
#define VALENCIA_IS_DELEGATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_DELEGATE))
#define VALENCIA_IS_DELEGATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_DELEGATE))
#define VALENCIA_DELEGATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_DELEGATE, ValenciaDelegateClass))

typedef struct _ValenciaDelegate ValenciaDelegate;
typedef struct _ValenciaDelegateClass ValenciaDelegateClass;

#define VALENCIA_TYPE_PROPERTY (valencia_property_get_type ())
#define VALENCIA_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PROPERTY, ValenciaProperty))
#define VALENCIA_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PROPERTY, ValenciaPropertyClass))
#define VALENCIA_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PROPERTY))
#define VALENCIA_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PROPERTY))
#define VALENCIA_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PROPERTY, ValenciaPropertyClass))

typedef struct _ValenciaProperty ValenciaProperty;
typedef struct _ValenciaPropertyClass ValenciaPropertyClass;
typedef struct _ValenciaPropertyPrivate ValenciaPropertyPrivate;

#define VALENCIA_TYPE_CONSTRUCT (valencia_construct_get_type ())
#define VALENCIA_CONSTRUCT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONSTRUCT, ValenciaConstruct))
#define VALENCIA_CONSTRUCT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONSTRUCT, ValenciaConstructClass))
#define VALENCIA_IS_CONSTRUCT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONSTRUCT))
#define VALENCIA_IS_CONSTRUCT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONSTRUCT))
#define VALENCIA_CONSTRUCT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONSTRUCT, ValenciaConstructClass))

typedef struct _ValenciaConstruct ValenciaConstruct;
typedef struct _ValenciaConstructClass ValenciaConstructClass;
typedef struct _ValenciaTypeSymbolPrivate ValenciaTypeSymbolPrivate;
typedef struct _ValenciaNamespacePrivate ValenciaNamespacePrivate;

#define VALENCIA_TYPE_INTERFACE (valencia_interface_get_type ())
#define VALENCIA_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_INTERFACE, ValenciaInterface))
#define VALENCIA_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_INTERFACE, ValenciaInterfaceClass))
#define VALENCIA_IS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_INTERFACE))
#define VALENCIA_IS_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_INTERFACE))
#define VALENCIA_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_INTERFACE, ValenciaInterfaceClass))

typedef struct _ValenciaInterface ValenciaInterface;
typedef struct _ValenciaInterfaceClass ValenciaInterfaceClass;
typedef struct _ValenciaClassPrivate ValenciaClassPrivate;
typedef struct _ValenciaSourceFilePrivate ValenciaSourceFilePrivate;

#define VALENCIA_TYPE_PROGRAM (valencia_program_get_type ())
#define VALENCIA_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgram))
#define VALENCIA_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))
#define VALENCIA_IS_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_IS_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_PROGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))

typedef struct _ValenciaProgram ValenciaProgram;
typedef struct _ValenciaProgramClass ValenciaProgramClass;

#define TYPE_STACK (stack_get_type ())
#define STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STACK, Stack))
#define STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STACK, StackClass))
#define IS_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STACK))
#define IS_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STACK))
#define STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STACK, StackClass))

typedef struct _Stack Stack;
typedef struct _StackClass StackClass;

struct _ValenciaScanScope {
	GObject parent_instance;
	ValenciaScanScopePrivate * priv;
	gint depth;
	gint start_pos;
	gint end_pos;
};

struct _ValenciaScanScopeClass {
	GObjectClass parent_class;
};

struct _ValenciaParseInfo {
	GObject parent_instance;
	ValenciaParseInfoPrivate * priv;
	ValenciaExpression* inner;
	ValenciaExpression* outer;
	gint outer_pos;
};

struct _ValenciaParseInfoClass {
	GObjectClass parent_class;
};

struct _ValenciaParser {
	GObject parent_instance;
	ValenciaParserPrivate * priv;
};

struct _ValenciaParserClass {
	GObjectClass parent_class;
};

struct _ValenciaParserPrivate {
	ValenciaSourceFile* source;
	ValenciaScanner* scanner;
	ValenciaNamespace* current_namespace;
};

typedef enum  {
	VALENCIA_TOKEN_NONE,
	VALENCIA_TOKEN_EOF,
	VALENCIA_TOKEN_CHAR,
	VALENCIA_TOKEN_CHAR_LITERAL,
	VALENCIA_TOKEN_STRING_LITERAL,
	VALENCIA_TOKEN_ID,
	VALENCIA_TOKEN_ASTERISK,
	VALENCIA_TOKEN_LEFT_BRACE,
	VALENCIA_TOKEN_RIGHT_BRACE,
	VALENCIA_TOKEN_LEFT_BRACKET,
	VALENCIA_TOKEN_RIGHT_BRACKET,
	VALENCIA_TOKEN_COLON,
	VALENCIA_TOKEN_COMMA,
	VALENCIA_TOKEN_EQUALS,
	VALENCIA_TOKEN_ELLIPSIS,
	VALENCIA_TOKEN_HASH,
	VALENCIA_TOKEN_LEFT_PAREN,
	VALENCIA_TOKEN_RIGHT_PAREN,
	VALENCIA_TOKEN_PERIOD,
	VALENCIA_TOKEN_QUESTION_MARK,
	VALENCIA_TOKEN_SEMICOLON,
	VALENCIA_TOKEN_LESS_THAN,
	VALENCIA_TOKEN_GREATER_THAN,
	VALENCIA_TOKEN_ABSTRACT,
	VALENCIA_TOKEN_BASE,
	VALENCIA_TOKEN_CLASS,
	VALENCIA_TOKEN_CONST,
	VALENCIA_TOKEN_CONSTRUCT,
	VALENCIA_TOKEN_DELEGATE,
	VALENCIA_TOKEN_ELSE,
	VALENCIA_TOKEN_ENUM,
	VALENCIA_TOKEN_EXTERN,
	VALENCIA_TOKEN_FOR,
	VALENCIA_TOKEN_FOREACH,
	VALENCIA_TOKEN_IF,
	VALENCIA_TOKEN_INLINE,
	VALENCIA_TOKEN_INTERFACE,
	VALENCIA_TOKEN_INTERNAL,
	VALENCIA_TOKEN_NAMESPACE,
	VALENCIA_TOKEN_NEW,
	VALENCIA_TOKEN_OUT,
	VALENCIA_TOKEN_OVERRIDE,
	VALENCIA_TOKEN_OWNED,
	VALENCIA_TOKEN_PRIVATE,
	VALENCIA_TOKEN_PROTECTED,
	VALENCIA_TOKEN_PUBLIC,
	VALENCIA_TOKEN_REF,
	VALENCIA_TOKEN_RETURN,
	VALENCIA_TOKEN_SIGNAL,
	VALENCIA_TOKEN_STATIC,
	VALENCIA_TOKEN_STRUCT,
	VALENCIA_TOKEN_THIS,
	VALENCIA_TOKEN_UNOWNED,
	VALENCIA_TOKEN_USING,
	VALENCIA_TOKEN_VIRTUAL,
	VALENCIA_TOKEN_WEAK,
	VALENCIA_TOKEN_WHILE
} ValenciaToken;

struct _ValenciaScanner {
	GObject parent_instance;
	ValenciaScannerPrivate * priv;
	gint start;
	gint end;
};

struct _ValenciaScannerClass {
	GObjectClass parent_class;
};

struct _ValenciaNode {
	GObject parent_instance;
	ValenciaNodePrivate * priv;
	gint start;
	gint end;
};

struct _ValenciaNodeClass {
	GObjectClass parent_class;
	GeeArrayList* (*children) (ValenciaNode* self);
	void (*print) (ValenciaNode* self, gint level);
};

struct _ValenciaSymbol {
	ValenciaNode parent_instance;
	ValenciaSymbolPrivate * priv;
	ValenciaSourceFile* source;
	char* name;
};

struct _ValenciaSymbolClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaVariable {
	ValenciaSymbol parent_instance;
	ValenciaVariablePrivate * priv;
	ValenciaExpression* type;
};

struct _ValenciaVariableClass {
	ValenciaSymbolClass parent_class;
	char* (*kind) (ValenciaVariable* self);
};

struct _ValenciaStatement {
	ValenciaNode parent_instance;
	ValenciaStatementPrivate * priv;
};

struct _ValenciaStatementClass {
	ValenciaNodeClass parent_class;
	gboolean (*defines_symbol) (ValenciaStatement* self, ValenciaSymbolSet* symbols);
};

struct _ValenciaScopeIface {
	GTypeInterface parent_iface;
	gboolean (*lookup) (ValenciaScope* self, ValenciaSymbolSet* symbols, gint pos);
};

struct _ValenciaBlock {
	ValenciaStatement parent_instance;
	ValenciaBlockPrivate * priv;
	GeeArrayList* statements;
};

struct _ValenciaBlockClass {
	ValenciaStatementClass parent_class;
};

struct _ValenciaMethod {
	ValenciaSymbol parent_instance;
	ValenciaMethodPrivate * priv;
	GeeArrayList* parameters;
	ValenciaExpression* return_type;
	ValenciaBlock* body;
};

struct _ValenciaMethodClass {
	ValenciaSymbolClass parent_class;
	void (*print_type) (ValenciaMethod* self, gint level);
};

struct _ValenciaExpression {
	GObject parent_instance;
	ValenciaExpressionPrivate * priv;
};

struct _ValenciaExpressionClass {
	GObjectClass parent_class;
	char* (*to_string) (ValenciaExpression* self);
};

struct _ValenciaCompoundExpression {
	ValenciaExpression parent_instance;
	ValenciaCompoundExpressionPrivate * priv;
	ValenciaExpression* left;
	char* right;
};

struct _ValenciaCompoundExpressionClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaProperty {
	ValenciaVariable parent_instance;
	ValenciaPropertyPrivate * priv;
	ValenciaBlock* body;
};

struct _ValenciaPropertyClass {
	ValenciaVariableClass parent_class;
};

struct _ValenciaTypeSymbol {
	ValenciaSymbol parent_instance;
	ValenciaTypeSymbolPrivate * priv;
};

struct _ValenciaTypeSymbolClass {
	ValenciaSymbolClass parent_class;
};

/* A Namespace is a TypeSymbol since namespaces can be used in type names.*/
struct _ValenciaNamespace {
	ValenciaTypeSymbol parent_instance;
	ValenciaNamespacePrivate * priv;
	char* full_name;
	GeeArrayList* symbols;
};

struct _ValenciaNamespaceClass {
	ValenciaTypeSymbolClass parent_class;
};

/* a class, struct, interface or enum*/
struct _ValenciaClass {
	ValenciaTypeSymbol parent_instance;
	ValenciaClassPrivate * priv;
	GeeArrayList* super;
	GeeArrayList* members;
};

struct _ValenciaClassClass {
	ValenciaTypeSymbolClass parent_class;
};

struct _ValenciaSourceFile {
	ValenciaNode parent_instance;
	ValenciaSourceFilePrivate * priv;
	ValenciaProgram* program;
	char* filename;
	GeeArrayList* namespaces;
	ValenciaNamespace* top;
};

struct _ValenciaSourceFileClass {
	ValenciaNodeClass parent_class;
};


static gpointer valencia_scan_scope_parent_class = NULL;
static gpointer valencia_parse_info_parent_class = NULL;
static gpointer valencia_parser_parent_class = NULL;

GType valencia_scan_scope_get_type (void);
enum  {
	VALENCIA_SCAN_SCOPE_DUMMY_PROPERTY
};
ValenciaScanScope* valencia_scan_scope_new (gint depth, gint start_pos, gint end_pos);
ValenciaScanScope* valencia_scan_scope_construct (GType object_type, gint depth, gint start_pos, gint end_pos);
static void valencia_scan_scope_finalize (GObject* obj);
GType valencia_parse_info_get_type (void);
GType valencia_expression_get_type (void);
enum  {
	VALENCIA_PARSE_INFO_DUMMY_PROPERTY
};
ValenciaParseInfo* valencia_parse_info_new (ValenciaExpression* inner);
ValenciaParseInfo* valencia_parse_info_construct (GType object_type, ValenciaExpression* inner);
static void valencia_parse_info_finalize (GObject* obj);
GType valencia_parser_get_type (void);
GType valencia_node_get_type (void);
GType valencia_source_file_get_type (void);
GType valencia_scanner_get_type (void);
GType valencia_symbol_get_type (void);
GType valencia_typesymbol_get_type (void);
GType valencia_namespace_get_type (void);
#define VALENCIA_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_PARSER, ValenciaParserPrivate))
enum  {
	VALENCIA_PARSER_DUMMY_PROPERTY
};
GType valencia_token_get_type (void);
ValenciaToken valencia_scanner_peek_token (ValenciaScanner* self);
static ValenciaToken valencia_parser_peek_token (ValenciaParser* self);
ValenciaToken valencia_scanner_next_token (ValenciaScanner* self);
static ValenciaToken valencia_parser_next_token (ValenciaParser* self);
gboolean valencia_scanner_accept_token (ValenciaScanner* self, ValenciaToken t);
static gboolean valencia_parser_accept (ValenciaParser* self, ValenciaToken t);
static void valencia_parser_skip (ValenciaParser* self);
char* valencia_scanner_val (ValenciaScanner* self);
ValenciaId* valencia_id_new (const char* name);
ValenciaId* valencia_id_construct (GType object_type, const char* name);
GType valencia_id_get_type (void);
ValenciaCompoundExpression* valencia_compound_expression_new (ValenciaExpression* left, const char* right);
ValenciaCompoundExpression* valencia_compound_expression_construct (GType object_type, ValenciaExpression* left, const char* right);
GType valencia_compound_expression_get_type (void);
static ValenciaExpression* valencia_parser_parse_type (ValenciaParser* self);
gboolean valencia_scanner_eof (ValenciaScanner* self);
static void valencia_parser_skip_expression (ValenciaParser* self);
static void valencia_parser_skip_attributes (ValenciaParser* self);
ValenciaParameter* valencia_parameter_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaParameter* valencia_parameter_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_variable_get_type (void);
GType valencia_parameter_get_type (void);
static ValenciaParameter* valencia_parser_parse_parameter (ValenciaParser* self);
static ValenciaExpression* valencia_parser_parse_expression (ValenciaParser* self);
ValenciaLocalVariable* valencia_local_variable_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaLocalVariable* valencia_local_variable_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_local_variable_get_type (void);
char* valencia_expression_to_string (ValenciaExpression* self);
static ValenciaLocalVariable* valencia_parser_parse_local_variable (ValenciaParser* self, ValenciaExpression* type);
ValenciaDeclarationStatement* valencia_declaration_statement_new (GeeArrayList* variables, gint start, gint end);
ValenciaDeclarationStatement* valencia_declaration_statement_construct (GType object_type, GeeArrayList* variables, gint start, gint end);
GType valencia_statement_get_type (void);
GType valencia_declaration_statement_get_type (void);
static ValenciaStatement* valencia_parser_parse_statement (ValenciaParser* self);
ValenciaFor* valencia_for_new (ValenciaDeclarationStatement* declaration, ValenciaStatement* statement, gint start, gint end);
ValenciaFor* valencia_for_construct (GType object_type, ValenciaDeclarationStatement* declaration, ValenciaStatement* statement, gint start, gint end);
GType valencia_for_get_type (void);
static ValenciaFor* valencia_parser_parse_foreach (ValenciaParser* self);
GType valencia_block_get_type (void);
static ValenciaBlock* valencia_parser_parse_block (ValenciaParser* self);
ValenciaBlock* valencia_block_new (void);
ValenciaBlock* valencia_block_construct (GType object_type);
GType valencia_symbol_set_get_type (void);
GType valencia_scope_get_type (void);
GType valencia_method_get_type (void);
void valencia_method_update_prototype (ValenciaMethod* self, const char* proto);
const char* valencia_scanner_get_start (ValenciaScanner* self);
static ValenciaMethod* valencia_parser_parse_method (ValenciaParser* self, ValenciaMethod* m, const char* input);
const char* valencia_scanner_get_start_after_comments (ValenciaScanner* self);
GType valencia_class_get_type (void);
ValenciaConstructor* valencia_constructor_new (const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source);
ValenciaConstructor* valencia_constructor_construct (GType object_type, const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source);
GType valencia_constructor_get_type (void);
ValenciaField* valencia_field_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaField* valencia_field_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_field_get_type (void);
ValenciaVSignal* valencia_vsignal_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaVSignal* valencia_vsignal_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
GType valencia_vsignal_get_type (void);
ValenciaDelegate* valencia_delegate_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaDelegate* valencia_delegate_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
GType valencia_delegate_get_type (void);
ValenciaMethod* valencia_method_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaMethod* valencia_method_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaProperty* valencia_property_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaProperty* valencia_property_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
GType valencia_property_get_type (void);
static ValenciaSymbol* valencia_parser_parse_method_or_field (ValenciaParser* self, ValenciaClass* enclosing_class);
static gboolean valencia_parser_is_modifier (ValenciaParser* self, ValenciaToken t);
static void valencia_parser_skip_modifiers (ValenciaParser* self);
GType valencia_construct_get_type (void);
ValenciaConstruct* valencia_construct_new (ValenciaBlock* body, gint start, gint end);
ValenciaConstruct* valencia_construct_construct (GType object_type, ValenciaBlock* body, gint start, gint end);
static ValenciaConstruct* valencia_parser_parse_construct (ValenciaParser* self);
static ValenciaNamespace* valencia_parser_parse_namespace (ValenciaParser* self);
static ValenciaTypeSymbol* valencia_parser_parse_class (ValenciaParser* self, ValenciaToken container_type, ValenciaClass* enclosing_class);
static ValenciaNode* valencia_parser_parse_member (ValenciaParser* self, ValenciaClass* enclosing_class);
static ValenciaNamespace* valencia_parser_open_namespace (ValenciaParser* self, const char* name);
static void valencia_parser_close_namespace (ValenciaParser* self, ValenciaNamespace* n);
static ValenciaNamespace* valencia_parser_parse_containing_namespace (ValenciaParser* self, const char* name, ValenciaToken container_type, ValenciaClass* enclosing_class);
ValenciaInterface* valencia_interface_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
ValenciaInterface* valencia_interface_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
GType valencia_interface_get_type (void);
ValenciaClass* valencia_class_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
ValenciaClass* valencia_class_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
static char* valencia_parser_join (const char* a, const char* b);
ValenciaNamespace* valencia_namespace_new (const char* name, const char* full_name, ValenciaSourceFile* source);
ValenciaNamespace* valencia_namespace_construct (GType object_type, const char* name, const char* full_name, ValenciaSourceFile* source);
GType valencia_program_get_type (void);
static char* valencia_parser_parse_using (ValenciaParser* self);
ValenciaScanner* valencia_scanner_new (const char* input);
ValenciaScanner* valencia_scanner_construct (GType object_type, const char* input);
void valencia_source_file_add_using_namespace (ValenciaSourceFile* self, const char* name);
void valencia_parser_parse (ValenciaParser* self, ValenciaSourceFile* source, const char* input);
Stack* stack_new (GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func);
Stack* stack_construct (GType object_type, GType g_type, GBoxedCopyFunc g_dup_func, GDestroyNotify g_destroy_func);
GType stack_get_type (void);
gint stack_size (Stack* self);
gpointer stack_top (Stack* self);
void stack_pop (Stack* self);
void stack_push (Stack* self, gconstpointer item);
ValenciaScanScope* valencia_parser_find_enclosing_scope (ValenciaParser* self, const char* input, gint pos, gboolean classes_only);
ValenciaParser* valencia_parser_new (void);
ValenciaParser* valencia_parser_construct (GType object_type);
static void valencia_parser_finalize (GObject* obj);
ValenciaSourceFile* valencia_source_file_new (ValenciaProgram* program, const char* filename);
ValenciaSourceFile* valencia_source_file_construct (GType object_type, ValenciaProgram* program, const char* filename);
void valencia_node_print (ValenciaNode* self, gint level);
void _main (char** args, int args_length1);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 16 "parser.vala"
ValenciaScanScope* valencia_scan_scope_construct (GType object_type, gint depth, gint start_pos, gint end_pos) {
#line 761 "parser.c"
	ValenciaScanScope * self;
	self = g_object_newv (object_type, 0, NULL);
#line 17 "parser.vala"
	self->depth = depth;
#line 18 "parser.vala"
	self->start_pos = start_pos;
#line 19 "parser.vala"
	self->end_pos = end_pos;
#line 770 "parser.c"
	return self;
}


#line 16 "parser.vala"
ValenciaScanScope* valencia_scan_scope_new (gint depth, gint start_pos, gint end_pos) {
#line 16 "parser.vala"
	return valencia_scan_scope_construct (VALENCIA_TYPE_SCAN_SCOPE, depth, start_pos, end_pos);
#line 779 "parser.c"
}


static void valencia_scan_scope_class_init (ValenciaScanScopeClass * klass) {
	valencia_scan_scope_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_scan_scope_finalize;
}


static void valencia_scan_scope_instance_init (ValenciaScanScope * self) {
}


static void valencia_scan_scope_finalize (GObject* obj) {
	ValenciaScanScope * self;
	self = VALENCIA_SCAN_SCOPE (obj);
	G_OBJECT_CLASS (valencia_scan_scope_parent_class)->finalize (obj);
}


GType valencia_scan_scope_get_type (void) {
	static GType valencia_scan_scope_type_id = 0;
	if (valencia_scan_scope_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaScanScopeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_scan_scope_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaScanScope), 0, (GInstanceInitFunc) valencia_scan_scope_instance_init, NULL };
		valencia_scan_scope_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaScanScope", &g_define_type_info, 0);
	}
	return valencia_scan_scope_type_id;
}


#line 28 "parser.vala"
ValenciaParseInfo* valencia_parse_info_construct (GType object_type, ValenciaExpression* inner) {
#line 812 "parser.c"
	ValenciaParseInfo * self;
	ValenciaExpression* _tmp1_;
	ValenciaExpression* _tmp0_;
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 29 "parser.vala"
	_tmp0_ = NULL;
#line 29 "parser.vala"
	self->inner = (_tmp1_ = (_tmp0_ = inner, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->inner == NULL) ? NULL : (self->inner = (g_object_unref (self->inner), NULL)), _tmp1_);
#line 822 "parser.c"
	return self;
}


#line 28 "parser.vala"
ValenciaParseInfo* valencia_parse_info_new (ValenciaExpression* inner) {
#line 28 "parser.vala"
	return valencia_parse_info_construct (VALENCIA_TYPE_PARSE_INFO, inner);
#line 831 "parser.c"
}


static void valencia_parse_info_class_init (ValenciaParseInfoClass * klass) {
	valencia_parse_info_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_parse_info_finalize;
}


static void valencia_parse_info_instance_init (ValenciaParseInfo * self) {
}


static void valencia_parse_info_finalize (GObject* obj) {
	ValenciaParseInfo * self;
	self = VALENCIA_PARSE_INFO (obj);
	(self->inner == NULL) ? NULL : (self->inner = (g_object_unref (self->inner), NULL));
	(self->outer == NULL) ? NULL : (self->outer = (g_object_unref (self->outer), NULL));
	G_OBJECT_CLASS (valencia_parse_info_parent_class)->finalize (obj);
}


GType valencia_parse_info_get_type (void) {
	static GType valencia_parse_info_type_id = 0;
	if (valencia_parse_info_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaParseInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_parse_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaParseInfo), 0, (GInstanceInitFunc) valencia_parse_info_instance_init, NULL };
		valencia_parse_info_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaParseInfo", &g_define_type_info, 0);
	}
	return valencia_parse_info_type_id;
}


#line 38 "parser.vala"
static ValenciaToken valencia_parser_peek_token (ValenciaParser* self) {
#line 866 "parser.c"
	ValenciaToken result;
#line 38 "parser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 870 "parser.c"
	result = valencia_scanner_peek_token (self->priv->scanner);
	return result;
}


#line 39 "parser.vala"
static ValenciaToken valencia_parser_next_token (ValenciaParser* self) {
#line 878 "parser.c"
	ValenciaToken result;
#line 39 "parser.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 882 "parser.c"
	result = valencia_scanner_next_token (self->priv->scanner);
	return result;
}


#line 41 "parser.vala"
static gboolean valencia_parser_accept (ValenciaParser* self, ValenciaToken t) {
#line 890 "parser.c"
	gboolean result;
#line 41 "parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 894 "parser.c"
	result = valencia_scanner_accept_token (self->priv->scanner, t);
	return result;
}


/* Skip to a right brace or semicolon.*/
#line 44 "parser.vala"
static void valencia_parser_skip (ValenciaParser* self) {
#line 903 "parser.c"
	gint depth;
#line 44 "parser.vala"
	g_return_if_fail (self != NULL);
#line 907 "parser.c"
	depth = 0;
#line 46 "parser.vala"
	while (TRUE) {
#line 47 "parser.vala"
		switch (valencia_parser_next_token (self)) {
#line 913 "parser.c"
			case VALENCIA_TOKEN_EOF:
			{
				return;
			}
			case VALENCIA_TOKEN_LEFT_BRACE:
			{
#line 51 "parser.vala"
				depth = depth + 1;
#line 52 "parser.vala"
				break;
#line 924 "parser.c"
			}
			case VALENCIA_TOKEN_RIGHT_BRACE:
			{
#line 54 "parser.vala"
				if ((depth = depth - 1) <= 0) {
#line 55 "parser.vala"
					valencia_parser_accept (self, VALENCIA_TOKEN_SEMICOLON);
#line 932 "parser.c"
					return;
				}
#line 58 "parser.vala"
				break;
#line 937 "parser.c"
			}
			case VALENCIA_TOKEN_SEMICOLON:
			{
#line 60 "parser.vala"
				if (depth == 0) {
#line 943 "parser.c"
					return;
				}
#line 62 "parser.vala"
				break;
#line 948 "parser.c"
			}
		}
	}
}


#line 66 "parser.vala"
static ValenciaExpression* valencia_parser_parse_type (ValenciaParser* self) {
#line 957 "parser.c"
	ValenciaExpression* result;
	gboolean _tmp0_;
	char* _tmp1_;
	ValenciaExpression* _tmp2_;
	ValenciaExpression* t;
#line 66 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 965 "parser.c"
	_tmp0_ = FALSE;
#line 67 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_UNOWNED)) {
#line 67 "parser.vala"
		_tmp0_ = TRUE;
#line 971 "parser.c"
	} else {
#line 67 "parser.vala"
		_tmp0_ = valencia_parser_accept (self, VALENCIA_TOKEN_WEAK);
#line 975 "parser.c"
	}
#line 67 "parser.vala"
	_tmp0_;
#line 68 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 981 "parser.c"
		result = NULL;
		return result;
	}
#line 301 "scanner.vala"
	_tmp1_ = NULL;
#line 70 "parser.vala"
	_tmp2_ = NULL;
#line 989 "parser.c"
	t = (_tmp2_ = (ValenciaExpression*) valencia_id_new (_tmp1_ = valencia_scanner_val (self->priv->scanner)), _tmp1_ = (g_free (_tmp1_), NULL), _tmp2_);
#line 71 "parser.vala"
	while (TRUE) {
#line 993 "parser.c"
		ValenciaExpression* _tmp4_;
		char* _tmp3_;
#line 71 "parser.vala"
		if (!valencia_parser_accept (self, VALENCIA_TOKEN_PERIOD)) {
#line 71 "parser.vala"
			break;
#line 1000 "parser.c"
		}
#line 72 "parser.vala"
		if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 1004 "parser.c"
			result = NULL;
			(t == NULL) ? NULL : (t = (g_object_unref (t), NULL));
			return result;
		}
		_tmp4_ = NULL;
#line 301 "scanner.vala"
		_tmp3_ = NULL;
#line 74 "parser.vala"
		t = (_tmp4_ = (ValenciaExpression*) valencia_compound_expression_new (t, _tmp3_ = valencia_scanner_val (self->priv->scanner)), (t == NULL) ? NULL : (t = (g_object_unref (t), NULL)), _tmp4_);
#line 1014 "parser.c"
		_tmp3_ = (g_free (_tmp3_), NULL);
	}
#line 76 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_LESS_THAN)) {
#line 1019 "parser.c"
		ValenciaExpression* _tmp5_;
		gboolean _tmp6_;
		/* parameterized type*/
#line 66 "parser.vala"
		_tmp5_ = NULL;
#line 77 "parser.vala"
		if ((_tmp6_ = (_tmp5_ = valencia_parser_parse_type (self)) == NULL, (_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_object_unref (_tmp5_), NULL)), _tmp6_)) {
#line 1027 "parser.c"
			result = NULL;
			(t == NULL) ? NULL : (t = (g_object_unref (t), NULL));
			return result;
		}
#line 79 "parser.vala"
		while (TRUE) {
#line 1034 "parser.c"
			gboolean _tmp7_;
#line 79 "parser.vala"
			if (!(!valencia_parser_accept (self, VALENCIA_TOKEN_GREATER_THAN))) {
#line 79 "parser.vala"
				break;
#line 1040 "parser.c"
			}
			_tmp7_ = FALSE;
#line 80 "parser.vala"
			if (!valencia_parser_accept (self, VALENCIA_TOKEN_COMMA)) {
#line 80 "parser.vala"
				_tmp7_ = TRUE;
#line 1047 "parser.c"
			} else {
				ValenciaExpression* _tmp8_;
#line 66 "parser.vala"
				_tmp8_ = NULL;
#line 80 "parser.vala"
				_tmp7_ = (_tmp8_ = valencia_parser_parse_type (self)) == NULL;
#line 1054 "parser.c"
				(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_object_unref (_tmp8_), NULL));
			}
#line 80 "parser.vala"
			if (_tmp7_) {
#line 1059 "parser.c"
				result = NULL;
				(t == NULL) ? NULL : (t = (g_object_unref (t), NULL));
				return result;
			}
		}
	}
#line 84 "parser.vala"
	while (TRUE) {
#line 1068 "parser.c"
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp9_ = FALSE;
		_tmp10_ = FALSE;
#line 85 "parser.vala"
		if (valencia_parser_accept (self, VALENCIA_TOKEN_QUESTION_MARK)) {
#line 85 "parser.vala"
			_tmp10_ = TRUE;
#line 1077 "parser.c"
		} else {
#line 85 "parser.vala"
			_tmp10_ = valencia_parser_accept (self, VALENCIA_TOKEN_ASTERISK);
#line 1081 "parser.c"
		}
#line 85 "parser.vala"
		if (_tmp10_) {
#line 85 "parser.vala"
			_tmp9_ = TRUE;
#line 1087 "parser.c"
		} else {
#line 85 "parser.vala"
			_tmp9_ = valencia_parser_accept (self, VALENCIA_TOKEN_HASH);
#line 1091 "parser.c"
		}
#line 85 "parser.vala"
		if (_tmp9_) {
#line 86 "parser.vala"
			continue;
#line 1097 "parser.c"
		}
#line 87 "parser.vala"
		if (valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_BRACKET)) {
#line 88 "parser.vala"
			valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_BRACKET);
#line 89 "parser.vala"
			continue;
#line 1105 "parser.c"
		}
#line 91 "parser.vala"
		break;
#line 1109 "parser.c"
	}
	result = t;
	return result;
}


/* Skip an expression, looking for a following comma, right parenthesis,
 semicolon or right brace.*/
#line 98 "parser.vala"
static void valencia_parser_skip_expression (ValenciaParser* self) {
#line 1120 "parser.c"
	gint depth;
#line 98 "parser.vala"
	g_return_if_fail (self != NULL);
#line 1124 "parser.c"
	depth = 0;
#line 100 "parser.vala"
	while (TRUE) {
#line 100 "parser.vala"
		if (!(!valencia_scanner_eof (self->priv->scanner))) {
#line 100 "parser.vala"
			break;
#line 1132 "parser.c"
		}
#line 101 "parser.vala"
		switch (valencia_parser_peek_token (self)) {
#line 1136 "parser.c"
			case VALENCIA_TOKEN_COMMA:
			case VALENCIA_TOKEN_RIGHT_BRACE:
			case VALENCIA_TOKEN_SEMICOLON:
			{
#line 105 "parser.vala"
				if (depth == 0) {
#line 1143 "parser.c"
					return;
				}
#line 107 "parser.vala"
				break;
#line 1148 "parser.c"
			}
			case VALENCIA_TOKEN_LEFT_PAREN:
			{
#line 109 "parser.vala"
				depth = depth + 1;
#line 110 "parser.vala"
				break;
#line 1156 "parser.c"
			}
			case VALENCIA_TOKEN_RIGHT_PAREN:
			{
#line 112 "parser.vala"
				if (depth == 0) {
#line 1162 "parser.c"
					return;
				}
#line 114 "parser.vala"
				depth = depth - 1;
#line 115 "parser.vala"
				break;
#line 1169 "parser.c"
			}
		}
#line 117 "parser.vala"
		valencia_parser_next_token (self);
#line 1174 "parser.c"
	}
}


#line 121 "parser.vala"
static ValenciaParameter* valencia_parser_parse_parameter (ValenciaParser* self) {
#line 1181 "parser.c"
	ValenciaParameter* result;
	gboolean _tmp0_;
	gboolean _tmp1_;
	ValenciaExpression* type;
	gboolean _tmp2_;
	char* _tmp3_;
	ValenciaParameter* _tmp4_;
	ValenciaParameter* p;
#line 121 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_ELLIPSIS)) {
#line 1194 "parser.c"
		result = NULL;
		return result;
	}
	/* end of parameter list*/
#line 124 "parser.vala"
	valencia_parser_skip_attributes (self);
#line 1201 "parser.c"
	_tmp0_ = FALSE;
	_tmp1_ = FALSE;
#line 125 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_OUT)) {
#line 125 "parser.vala"
		_tmp1_ = TRUE;
#line 1208 "parser.c"
	} else {
#line 125 "parser.vala"
		_tmp1_ = valencia_parser_accept (self, VALENCIA_TOKEN_REF);
#line 1212 "parser.c"
	}
#line 125 "parser.vala"
	if (_tmp1_) {
#line 125 "parser.vala"
		_tmp0_ = TRUE;
#line 1218 "parser.c"
	} else {
#line 125 "parser.vala"
		_tmp0_ = valencia_parser_accept (self, VALENCIA_TOKEN_OWNED);
#line 1222 "parser.c"
	}
#line 125 "parser.vala"
	_tmp0_;
#line 1226 "parser.c"
	type = valencia_parser_parse_type (self);
	_tmp2_ = FALSE;
#line 127 "parser.vala"
	if (type == NULL) {
#line 127 "parser.vala"
		_tmp2_ = TRUE;
#line 1233 "parser.c"
	} else {
#line 127 "parser.vala"
		_tmp2_ = !valencia_parser_accept (self, VALENCIA_TOKEN_ID);
#line 1237 "parser.c"
	}
#line 127 "parser.vala"
	if (_tmp2_) {
#line 1241 "parser.c"
		result = NULL;
		(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
		return result;
	}
#line 301 "scanner.vala"
	_tmp3_ = NULL;
#line 129 "parser.vala"
	_tmp4_ = NULL;
#line 1250 "parser.c"
	p = (_tmp4_ = valencia_parameter_new (type, _tmp3_ = valencia_scanner_val (self->priv->scanner), self->priv->source, self->priv->scanner->start, self->priv->scanner->end), _tmp3_ = (g_free (_tmp3_), NULL), _tmp4_);
#line 130 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_EQUALS)) {
#line 131 "parser.vala"
		valencia_parser_skip_expression (self);
#line 1256 "parser.c"
	}
	result = p;
	(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
	return result;
}


/* Parse an expression, returning the expression's type if known.*/
#line 136 "parser.vala"
static ValenciaExpression* valencia_parser_parse_expression (ValenciaParser* self) {
#line 1267 "parser.c"
	ValenciaExpression* result;
#line 136 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 137 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_NEW)) {
#line 1273 "parser.c"
		ValenciaExpression* type;
		type = valencia_parser_parse_type (self);
#line 139 "parser.vala"
		if (valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_PAREN)) {
#line 1278 "parser.c"
			ValenciaToken token;
			gboolean _tmp0_;
#line 140 "parser.vala"
			while (TRUE) {
#line 141 "parser.vala"
				valencia_parser_skip_expression (self);
#line 142 "parser.vala"
				if (!valencia_parser_accept (self, VALENCIA_TOKEN_COMMA)) {
#line 143 "parser.vala"
					break;
#line 1289 "parser.c"
				}
			}
			token = valencia_parser_peek_token (self);
			_tmp0_ = FALSE;
#line 146 "parser.vala"
			if (valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_PAREN)) {
#line 1296 "parser.c"
				gboolean _tmp1_;
				_tmp1_ = FALSE;
#line 146 "parser.vala"
				if (token == VALENCIA_TOKEN_SEMICOLON) {
#line 146 "parser.vala"
					_tmp1_ = TRUE;
#line 1303 "parser.c"
				} else {
#line 146 "parser.vala"
					_tmp1_ = token == VALENCIA_TOKEN_COMMA;
#line 1307 "parser.c"
				}
#line 146 "parser.vala"
				_tmp0_ = _tmp1_;
#line 1311 "parser.c"
			} else {
#line 146 "parser.vala"
				_tmp0_ = FALSE;
#line 1315 "parser.c"
			}
#line 146 "parser.vala"
			if (_tmp0_) {
#line 1319 "parser.c"
				result = type;
				return result;
			}
		}
		(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
	}
	/* Parse struct/array initializers*/
#line 152 "parser.vala"
	if (valencia_parser_peek_token (self) == VALENCIA_TOKEN_LEFT_BRACE) {
#line 1329 "parser.c"
		gint depth;
		depth = 0;
#line 155 "parser.vala"
		while (TRUE) {
#line 1334 "parser.c"
			gboolean _tmp2_;
			_tmp2_ = FALSE;
#line 155 "parser.vala"
			if (!valencia_scanner_eof (self->priv->scanner)) {
#line 155 "parser.vala"
				_tmp2_ = valencia_parser_peek_token (self) != VALENCIA_TOKEN_SEMICOLON;
#line 1341 "parser.c"
			} else {
#line 155 "parser.vala"
				_tmp2_ = FALSE;
#line 1345 "parser.c"
			}
#line 155 "parser.vala"
			if (!_tmp2_) {
#line 155 "parser.vala"
				break;
#line 1351 "parser.c"
			}
#line 156 "parser.vala"
			if (valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_BRACE)) {
#line 157 "parser.vala"
				depth = depth + 1;
#line 1357 "parser.c"
			} else {
				gboolean _tmp3_;
				_tmp3_ = FALSE;
#line 158 "parser.vala"
				if (valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_BRACE)) {
#line 158 "parser.vala"
					_tmp3_ = (depth = depth - 1) == 0;
#line 1365 "parser.c"
				} else {
#line 158 "parser.vala"
					_tmp3_ = FALSE;
#line 1369 "parser.c"
				}
#line 158 "parser.vala"
				if (_tmp3_) {
#line 159 "parser.vala"
					break;
#line 1375 "parser.c"
				} else {
#line 160 "parser.vala"
					valencia_parser_next_token (self);
#line 1379 "parser.c"
				}
			}
		}
	} else {
#line 162 "parser.vala"
		valencia_parser_skip_expression (self);
#line 1386 "parser.c"
	}
	result = NULL;
	return result;
}


#line 166 "parser.vala"
static ValenciaLocalVariable* valencia_parser_parse_local_variable (ValenciaParser* self, ValenciaExpression* type) {
#line 1395 "parser.c"
	ValenciaLocalVariable* result;
	char* name;
	ValenciaLocalVariable* v;
#line 166 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 166 "parser.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 167 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 1405 "parser.c"
		result = NULL;
		return result;
	}
	name = valencia_scanner_val (self->priv->scanner);
	v = valencia_local_variable_new (type, name, self->priv->source, self->priv->scanner->start, self->priv->scanner->end);
#line 172 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_EQUALS)) {
#line 1413 "parser.c"
		ValenciaExpression* inferred_type;
		gboolean _tmp0_;
		char* _tmp1_;
		gboolean _tmp2_;
		inferred_type = valencia_parser_parse_expression (self);
		_tmp0_ = FALSE;
#line 10 "expression.vala"
		_tmp1_ = NULL;
#line 174 "parser.vala"
		if ((_tmp2_ = _vala_strcmp0 (_tmp1_ = valencia_expression_to_string (((ValenciaVariable*) v)->type), "var") == 0, _tmp1_ = (g_free (_tmp1_), NULL), _tmp2_)) {
#line 174 "parser.vala"
			_tmp0_ = inferred_type != NULL;
#line 1426 "parser.c"
		} else {
#line 174 "parser.vala"
			_tmp0_ = FALSE;
#line 1430 "parser.c"
		}
#line 174 "parser.vala"
		if (_tmp0_) {
#line 1434 "parser.c"
			ValenciaExpression* _tmp4_;
			ValenciaExpression* _tmp3_;
			_tmp4_ = NULL;
#line 175 "parser.vala"
			_tmp3_ = NULL;
#line 175 "parser.vala"
			((ValenciaVariable*) v)->type = (_tmp4_ = (_tmp3_ = inferred_type, (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_)), (((ValenciaVariable*) v)->type == NULL) ? NULL : (((ValenciaVariable*) v)->type = (g_object_unref (((ValenciaVariable*) v)->type), NULL)), _tmp4_);
#line 1442 "parser.c"
		}
		(inferred_type == NULL) ? NULL : (inferred_type = (g_object_unref (inferred_type), NULL));
	}
	result = v;
	name = (g_free (name), NULL);
	return result;
}


#line 181 "parser.vala"
static ValenciaFor* valencia_parser_parse_foreach (ValenciaParser* self) {
#line 1454 "parser.c"
	ValenciaFor* result;
	gint start;
	ValenciaExpression* type;
	gint declaration_start;
	GeeArrayList* variables;
	ValenciaLocalVariable* v;
	ValenciaDeclarationStatement* declaration;
	ValenciaStatement* s;
#line 181 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1465 "parser.c"
	start = self->priv->scanner->start;
#line 183 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_PAREN)) {
#line 1469 "parser.c"
		result = NULL;
		return result;
	}
	type = valencia_parser_parse_type (self);
#line 186 "parser.vala"
	if (type == NULL) {
#line 187 "parser.vala"
		valencia_parser_skip (self);
#line 1478 "parser.c"
		result = NULL;
		(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
		return result;
	}
	declaration_start = self->priv->scanner->start;
	variables = gee_array_list_new (VALENCIA_TYPE_LOCAL_VARIABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
	v = valencia_parser_parse_local_variable (self, type);
#line 194 "parser.vala"
	if (v == NULL) {
#line 1488 "parser.c"
		result = NULL;
		(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
		(variables == NULL) ? NULL : (variables = (gee_collection_object_unref (variables), NULL));
		(v == NULL) ? NULL : (v = (g_object_unref (v), NULL));
		return result;
	}
#line 197 "parser.vala"
	while (TRUE) {
#line 1497 "parser.c"
		ValenciaLocalVariable* _tmp0_;
#line 197 "parser.vala"
		if (!(v != NULL)) {
#line 197 "parser.vala"
			break;
#line 1503 "parser.c"
		}
#line 198 "parser.vala"
		gee_collection_add ((GeeCollection*) variables, v);
#line 199 "parser.vala"
		if (!valencia_parser_accept (self, VALENCIA_TOKEN_COMMA)) {
#line 200 "parser.vala"
			break;
#line 1511 "parser.c"
		}
		_tmp0_ = NULL;
#line 201 "parser.vala"
		v = (_tmp0_ = valencia_parser_parse_local_variable (self, type), (v == NULL) ? NULL : (v = (g_object_unref (v), NULL)), _tmp0_);
#line 1516 "parser.c"
	}
	declaration = valencia_declaration_statement_new (variables, declaration_start, self->priv->scanner->end);
	{
		gboolean _tmp1_;
		_tmp1_ = TRUE;
#line 208 "parser.vala"
		while (TRUE) {
#line 208 "parser.vala"
			if (!_tmp1_) {
#line 1526 "parser.c"
				gboolean _tmp2_;
				_tmp2_ = FALSE;
#line 210 "parser.vala"
				if (!valencia_scanner_eof (self->priv->scanner)) {
#line 210 "parser.vala"
					_tmp2_ = valencia_parser_accept (self, VALENCIA_TOKEN_SEMICOLON);
#line 1533 "parser.c"
				} else {
#line 210 "parser.vala"
					_tmp2_ = FALSE;
#line 1537 "parser.c"
				}
#line 210 "parser.vala"
				if (!_tmp2_) {
#line 210 "parser.vala"
					break;
#line 1543 "parser.c"
				}
			}
#line 208 "parser.vala"
			_tmp1_ = FALSE;
#line 209 "parser.vala"
			valencia_parser_skip_expression (self);
#line 1550 "parser.c"
		}
	}
#line 212 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_PAREN)) {
#line 213 "parser.vala"
		valencia_parser_skip (self);
#line 1557 "parser.c"
		result = NULL;
		(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
		(variables == NULL) ? NULL : (variables = (gee_collection_object_unref (variables), NULL));
		(v == NULL) ? NULL : (v = (g_object_unref (v), NULL));
		(declaration == NULL) ? NULL : (declaration = (g_object_unref (declaration), NULL));
		return result;
	}
	s = valencia_parser_parse_statement (self);
	result = valencia_for_new (declaration, s, start, self->priv->scanner->end);
	(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
	(variables == NULL) ? NULL : (variables = (gee_collection_object_unref (variables), NULL));
	(v == NULL) ? NULL : (v = (g_object_unref (v), NULL));
	(declaration == NULL) ? NULL : (declaration = (g_object_unref (declaration), NULL));
	(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
	return result;
}


#line 220 "parser.vala"
static ValenciaStatement* valencia_parser_parse_statement (ValenciaParser* self) {
#line 1578 "parser.c"
	ValenciaStatement* result;
	gboolean _tmp0_;
	ValenciaExpression* type;
	gboolean _tmp1_;
#line 220 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1585 "parser.c"
	_tmp0_ = FALSE;
#line 221 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_FOREACH)) {
#line 221 "parser.vala"
		_tmp0_ = TRUE;
#line 1591 "parser.c"
	} else {
#line 221 "parser.vala"
		_tmp0_ = valencia_parser_accept (self, VALENCIA_TOKEN_FOR);
#line 1595 "parser.c"
	}
#line 221 "parser.vala"
	if (_tmp0_) {
#line 1599 "parser.c"
		result = (ValenciaStatement*) valencia_parser_parse_foreach (self);
		return result;
	}
	type = valencia_parser_parse_type (self);
	_tmp1_ = FALSE;
#line 225 "parser.vala"
	if (type != NULL) {
#line 225 "parser.vala"
		_tmp1_ = valencia_parser_peek_token (self) == VALENCIA_TOKEN_ID;
#line 1609 "parser.c"
	} else {
#line 225 "parser.vala"
		_tmp1_ = FALSE;
#line 1613 "parser.c"
	}
#line 225 "parser.vala"
	if (_tmp1_) {
#line 1617 "parser.c"
		gint start;
		GeeArrayList* variables;
		ValenciaLocalVariable* v;
		start = self->priv->scanner->start;
		variables = gee_array_list_new (VALENCIA_TYPE_LOCAL_VARIABLE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
		v = valencia_parser_parse_local_variable (self, type);
#line 230 "parser.vala"
		while (TRUE) {
#line 1626 "parser.c"
			ValenciaLocalVariable* _tmp2_;
#line 230 "parser.vala"
			if (!(v != NULL)) {
#line 230 "parser.vala"
				break;
#line 1632 "parser.c"
			}
#line 231 "parser.vala"
			gee_collection_add ((GeeCollection*) variables, v);
#line 232 "parser.vala"
			if (!valencia_parser_accept (self, VALENCIA_TOKEN_COMMA)) {
#line 233 "parser.vala"
				break;
#line 1640 "parser.c"
			}
			_tmp2_ = NULL;
#line 234 "parser.vala"
			v = (_tmp2_ = valencia_parser_parse_local_variable (self, type), (v == NULL) ? NULL : (v = (g_object_unref (v), NULL)), _tmp2_);
#line 1645 "parser.c"
		}
#line 237 "parser.vala"
		if (valencia_parser_accept (self, VALENCIA_TOKEN_SEMICOLON)) {
#line 1649 "parser.c"
			result = (ValenciaStatement*) valencia_declaration_statement_new (variables, start, self->priv->scanner->end);
			(variables == NULL) ? NULL : (variables = (gee_collection_object_unref (variables), NULL));
			(v == NULL) ? NULL : (v = (g_object_unref (v), NULL));
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
			return result;
		}
		(variables == NULL) ? NULL : (variables = (gee_collection_object_unref (variables), NULL));
		(v == NULL) ? NULL : (v = (g_object_unref (v), NULL));
	}
#line 243 "parser.vala"
	while (TRUE) {
#line 1661 "parser.c"
		ValenciaToken t;
		gboolean _tmp3_;
		t = valencia_parser_peek_token (self);
		_tmp3_ = FALSE;
#line 245 "parser.vala"
		if (t == VALENCIA_TOKEN_EOF) {
#line 245 "parser.vala"
			_tmp3_ = TRUE;
#line 1670 "parser.c"
		} else {
#line 245 "parser.vala"
			_tmp3_ = t == VALENCIA_TOKEN_RIGHT_BRACE;
#line 1674 "parser.c"
		}
#line 245 "parser.vala"
		if (_tmp3_) {
#line 1678 "parser.c"
			result = NULL;
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
			return result;
		}
#line 250 "parser.vala"
		switch (valencia_parser_next_token (self)) {
#line 1685 "parser.c"
			case VALENCIA_TOKEN_SEMICOLON:
			{
				result = NULL;
				(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
				return result;
			}
			case VALENCIA_TOKEN_LEFT_BRACE:
			{
				result = (ValenciaStatement*) valencia_parser_parse_block (self);
				(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
				return result;
			}
		}
	}
	(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
}


/* Parse a block after the opening brace.    */
#line 260 "parser.vala"
static ValenciaBlock* valencia_parser_parse_block (ValenciaParser* self) {
#line 1707 "parser.c"
	ValenciaBlock* result;
	ValenciaBlock* b;
#line 260 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1712 "parser.c"
	b = valencia_block_new ();
#line 262 "parser.vala"
	((ValenciaNode*) b)->start = self->priv->scanner->start;
#line 263 "parser.vala"
	while (TRUE) {
#line 1718 "parser.c"
		gboolean _tmp0_;
		ValenciaStatement* s;
		_tmp0_ = FALSE;
#line 263 "parser.vala"
		if (!valencia_scanner_eof (self->priv->scanner)) {
#line 263 "parser.vala"
			_tmp0_ = !valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_BRACE);
#line 1726 "parser.c"
		} else {
#line 263 "parser.vala"
			_tmp0_ = FALSE;
#line 1730 "parser.c"
		}
#line 263 "parser.vala"
		if (!_tmp0_) {
#line 263 "parser.vala"
			break;
#line 1736 "parser.c"
		}
		s = valencia_parser_parse_statement (self);
#line 265 "parser.vala"
		if (s != NULL) {
#line 266 "parser.vala"
			gee_collection_add ((GeeCollection*) b->statements, s);
#line 1743 "parser.c"
		}
		(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
	}
#line 268 "parser.vala"
	((ValenciaNode*) b)->end = self->priv->scanner->end;
#line 1749 "parser.c"
	result = b;
	return result;
}


/* Parse a method.  Return the method object, or null on error.*/
#line 273 "parser.vala"
static ValenciaMethod* valencia_parser_parse_method (ValenciaParser* self, ValenciaMethod* m, const char* input) {
#line 1758 "parser.c"
	ValenciaMethod* result;
	ValenciaToken t;
	char* _tmp2_;
	ValenciaMethod* _tmp4_;
#line 273 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 273 "parser.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 273 "parser.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 274 "parser.vala"
	((ValenciaNode*) m)->start = self->priv->scanner->start;
#line 275 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_PAREN)) {
#line 276 "parser.vala"
		valencia_parser_skip (self);
#line 1775 "parser.c"
		result = NULL;
		return result;
	}
#line 279 "parser.vala"
	while (TRUE) {
#line 1781 "parser.c"
		ValenciaParameter* p;
		p = valencia_parser_parse_parameter (self);
#line 281 "parser.vala"
		if (p == NULL) {
#line 1786 "parser.c"
			(p == NULL) ? NULL : (p = (g_object_unref (p), NULL));
#line 282 "parser.vala"
			break;
#line 1790 "parser.c"
		}
#line 283 "parser.vala"
		gee_collection_add ((GeeCollection*) m->parameters, p);
#line 284 "parser.vala"
		if (!valencia_parser_accept (self, VALENCIA_TOKEN_COMMA)) {
#line 1796 "parser.c"
			(p == NULL) ? NULL : (p = (g_object_unref (p), NULL));
#line 285 "parser.vala"
			break;
#line 1800 "parser.c"
		}
		(p == NULL) ? NULL : (p = (g_object_unref (p), NULL));
	}
#line 287 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_PAREN)) {
#line 288 "parser.vala"
		valencia_parser_skip (self);
#line 1808 "parser.c"
		result = NULL;
		return result;
	}
	/* Look for a semicolon or left brace.  (There may be a throws clause in between.)*/
	t = VALENCIA_TOKEN_NONE;
	{
		gboolean _tmp0_;
		_tmp0_ = TRUE;
#line 294 "parser.vala"
		while (TRUE) {
#line 294 "parser.vala"
			if (!_tmp0_) {
#line 1821 "parser.c"
				gboolean _tmp1_;
				_tmp1_ = FALSE;
#line 298 "parser.vala"
				if (t != VALENCIA_TOKEN_LEFT_BRACE) {
#line 298 "parser.vala"
					_tmp1_ = t != VALENCIA_TOKEN_SEMICOLON;
#line 1828 "parser.c"
				} else {
#line 298 "parser.vala"
					_tmp1_ = FALSE;
#line 1832 "parser.c"
				}
#line 298 "parser.vala"
				if (!_tmp1_) {
#line 298 "parser.vala"
					break;
#line 1838 "parser.c"
				}
			}
#line 294 "parser.vala"
			_tmp0_ = FALSE;
#line 295 "parser.vala"
			t = valencia_parser_next_token (self);
#line 296 "parser.vala"
			if (t == VALENCIA_TOKEN_EOF) {
#line 1847 "parser.c"
				result = NULL;
				return result;
			}
		}
	}
	/* Take the string from the return type all the way to the last ')'*/
#line 920 "glib-2.0.vapi"
	_tmp2_ = NULL;
#line 301 "parser.vala"
	valencia_method_update_prototype (m, _tmp2_ = g_strndup (input, ((gchar*) valencia_scanner_get_start (self->priv->scanner)) - ((gchar*) input)));
#line 1858 "parser.c"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 303 "parser.vala"
	if (t == VALENCIA_TOKEN_LEFT_BRACE) {
#line 1862 "parser.c"
		ValenciaBlock* _tmp3_;
		_tmp3_ = NULL;
#line 304 "parser.vala"
		m->body = (_tmp3_ = valencia_parser_parse_block (self), (m->body == NULL) ? NULL : (m->body = (g_object_unref (m->body), NULL)), _tmp3_);
#line 1867 "parser.c"
	}
#line 306 "parser.vala"
	((ValenciaNode*) m)->end = self->priv->scanner->end;
#line 307 "parser.vala"
	_tmp4_ = NULL;
#line 1873 "parser.c"
	result = (_tmp4_ = m, (_tmp4_ == NULL) ? NULL : g_object_ref (_tmp4_));
	return result;
}


#line 310 "parser.vala"
static ValenciaSymbol* valencia_parser_parse_method_or_field (ValenciaParser* self, ValenciaClass* enclosing_class) {
#line 1881 "parser.c"
	ValenciaSymbol* result;
	gboolean parse_signal;
	gboolean parse_delegate;
	const char* input;
	ValenciaExpression* type;
#line 310 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1889 "parser.c"
	parse_signal = FALSE;
	parse_delegate = FALSE;
	input = valencia_scanner_get_start_after_comments (self->priv->scanner);
#line 313 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_SIGNAL)) {
#line 314 "parser.vala"
		parse_signal = TRUE;
#line 1897 "parser.c"
	} else {
#line 315 "parser.vala"
		if (valencia_parser_accept (self, VALENCIA_TOKEN_DELEGATE)) {
#line 316 "parser.vala"
			parse_delegate = TRUE;
#line 1903 "parser.c"
		}
	}
	type = valencia_parser_parse_type (self);
#line 319 "parser.vala"
	if (type == NULL) {
#line 320 "parser.vala"
		valencia_parser_skip (self);
#line 1911 "parser.c"
		result = NULL;
		(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
		return result;
	}
#line 324 "parser.vala"
	if (enclosing_class != NULL) {
#line 1918 "parser.c"
		gboolean _tmp0_;
		_tmp0_ = FALSE;
#line 325 "parser.vala"
		if (valencia_parser_peek_token (self) == VALENCIA_TOKEN_LEFT_PAREN) {
#line 1923 "parser.c"
			char* _tmp1_;
#line 10 "expression.vala"
			_tmp1_ = NULL;
#line 325 "parser.vala"
			_tmp0_ = _vala_strcmp0 (_tmp1_ = valencia_expression_to_string (type), ((ValenciaSymbol*) enclosing_class)->name) == 0;
#line 1929 "parser.c"
			_tmp1_ = (g_free (_tmp1_), NULL);
		} else {
#line 325 "parser.vala"
			_tmp0_ = FALSE;
#line 1934 "parser.c"
		}
#line 325 "parser.vala"
		if (_tmp0_) {
#line 1938 "parser.c"
			ValenciaConstructor* _tmp2_;
			ValenciaSymbol* _tmp3_;
			_tmp2_ = NULL;
#line 326 "parser.vala"
			_tmp3_ = NULL;
#line 1944 "parser.c"
			result = (_tmp3_ = (ValenciaSymbol*) valencia_parser_parse_method (self, (ValenciaMethod*) (_tmp2_ = valencia_constructor_new (NULL, enclosing_class, self->priv->source)), input), (_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_object_unref (_tmp2_), NULL)), _tmp3_);
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
			return result;
		} else {
#line 328 "parser.vala"
			if (VALENCIA_IS_COMPOUND_EXPRESSION (type)) {
#line 1951 "parser.c"
				ValenciaCompoundExpression* _tmp5_;
				ValenciaExpression* _tmp4_;
				ValenciaCompoundExpression* qualified_type;
				char* _tmp6_;
				gboolean _tmp7_;
#line 329 "parser.vala"
				_tmp5_ = NULL;
#line 329 "parser.vala"
				_tmp4_ = NULL;
#line 1961 "parser.c"
				qualified_type = (_tmp5_ = (_tmp4_ = type, VALENCIA_IS_COMPOUND_EXPRESSION (_tmp4_) ? ((ValenciaCompoundExpression*) _tmp4_) : NULL), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_));
#line 10 "expression.vala"
				_tmp6_ = NULL;
#line 330 "parser.vala"
				if ((_tmp7_ = _vala_strcmp0 (_tmp6_ = valencia_expression_to_string (qualified_type->left), ((ValenciaSymbol*) enclosing_class)->name) == 0, _tmp6_ = (g_free (_tmp6_), NULL), _tmp7_)) {
#line 1967 "parser.c"
					ValenciaConstructor* _tmp8_;
					ValenciaSymbol* _tmp9_;
					_tmp8_ = NULL;
#line 331 "parser.vala"
					_tmp9_ = NULL;
#line 1973 "parser.c"
					result = (_tmp9_ = (ValenciaSymbol*) valencia_parser_parse_method (self, (ValenciaMethod*) (_tmp8_ = valencia_constructor_new (qualified_type->right, enclosing_class, self->priv->source)), input), (_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_object_unref (_tmp8_), NULL)), _tmp9_);
					(qualified_type == NULL) ? NULL : (qualified_type = (g_object_unref (qualified_type), NULL));
					(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
					return result;
				}
				(qualified_type == NULL) ? NULL : (qualified_type = (g_object_unref (qualified_type), NULL));
			}
		}
	}
#line 335 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 336 "parser.vala"
		valencia_parser_skip (self);
#line 1987 "parser.c"
		result = NULL;
		(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
		return result;
	}
#line 339 "parser.vala"
	switch (valencia_parser_peek_token (self)) {
#line 1994 "parser.c"
		case VALENCIA_TOKEN_SEMICOLON:
		case VALENCIA_TOKEN_EQUALS:
		{
			char* _tmp10_;
			ValenciaField* _tmp11_;
			ValenciaField* f;
#line 301 "scanner.vala"
			_tmp10_ = NULL;
#line 342 "parser.vala"
			_tmp11_ = NULL;
#line 2005 "parser.c"
			f = (_tmp11_ = valencia_field_new (type, _tmp10_ = valencia_scanner_val (self->priv->scanner), self->priv->source, self->priv->scanner->start, 0), _tmp10_ = (g_free (_tmp10_), NULL), _tmp11_);
#line 343 "parser.vala"
			valencia_parser_skip (self);
#line 344 "parser.vala"
			((ValenciaNode*) f)->end = self->priv->scanner->end;
#line 2011 "parser.c"
			result = (ValenciaSymbol*) f;
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
			return result;
		}
		case VALENCIA_TOKEN_LEFT_PAREN:
		{
			ValenciaMethod* m;
			m = NULL;
#line 348 "parser.vala"
			if (parse_signal) {
#line 2022 "parser.c"
				ValenciaMethod* _tmp13_;
				char* _tmp12_;
				_tmp13_ = NULL;
#line 301 "scanner.vala"
				_tmp12_ = NULL;
#line 349 "parser.vala"
				m = (_tmp13_ = (ValenciaMethod*) valencia_vsignal_new (_tmp12_ = valencia_scanner_val (self->priv->scanner), type, self->priv->source), (m == NULL) ? NULL : (m = (g_object_unref (m), NULL)), _tmp13_);
#line 2030 "parser.c"
				_tmp12_ = (g_free (_tmp12_), NULL);
			} else {
#line 350 "parser.vala"
				if (parse_delegate) {
#line 2035 "parser.c"
					ValenciaMethod* _tmp15_;
					char* _tmp14_;
					_tmp15_ = NULL;
#line 301 "scanner.vala"
					_tmp14_ = NULL;
#line 351 "parser.vala"
					m = (_tmp15_ = (ValenciaMethod*) valencia_delegate_new (_tmp14_ = valencia_scanner_val (self->priv->scanner), type, self->priv->source), (m == NULL) ? NULL : (m = (g_object_unref (m), NULL)), _tmp15_);
#line 2043 "parser.c"
					_tmp14_ = (g_free (_tmp14_), NULL);
				} else {
					ValenciaMethod* _tmp17_;
					char* _tmp16_;
					_tmp17_ = NULL;
#line 301 "scanner.vala"
					_tmp16_ = NULL;
#line 352 "parser.vala"
					m = (_tmp17_ = valencia_method_new (_tmp16_ = valencia_scanner_val (self->priv->scanner), type, self->priv->source), (m == NULL) ? NULL : (m = (g_object_unref (m), NULL)), _tmp17_);
#line 2053 "parser.c"
					_tmp16_ = (g_free (_tmp16_), NULL);
				}
			}
			result = (ValenciaSymbol*) valencia_parser_parse_method (self, m, input);
			(m == NULL) ? NULL : (m = (g_object_unref (m), NULL));
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
			return result;
		}
		case VALENCIA_TOKEN_LEFT_BRACE:
		{
			char* _tmp18_;
			ValenciaProperty* _tmp19_;
			ValenciaProperty* p;
			ValenciaBlock* _tmp20_;
#line 301 "scanner.vala"
			_tmp18_ = NULL;
#line 355 "parser.vala"
			_tmp19_ = NULL;
#line 2072 "parser.c"
			p = (_tmp19_ = valencia_property_new (type, _tmp18_ = valencia_scanner_val (self->priv->scanner), self->priv->source, self->priv->scanner->start, 0), _tmp18_ = (g_free (_tmp18_), NULL), _tmp19_);
#line 356 "parser.vala"
			valencia_parser_next_token (self);
#line 2076 "parser.c"
			_tmp20_ = NULL;
#line 357 "parser.vala"
			p->body = (_tmp20_ = valencia_parser_parse_block (self), (p->body == NULL) ? NULL : (p->body = (g_object_unref (p->body), NULL)), _tmp20_);
#line 358 "parser.vala"
			((ValenciaNode*) p)->end = self->priv->scanner->end;
#line 2082 "parser.c"
			result = (ValenciaSymbol*) p;
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
			return result;
		}
		default:
		{
#line 361 "parser.vala"
			valencia_parser_skip (self);
#line 2091 "parser.c"
			result = NULL;
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
			return result;
		}
	}
	(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
}


#line 366 "parser.vala"
static gboolean valencia_parser_is_modifier (ValenciaParser* self, ValenciaToken t) {
#line 2103 "parser.c"
	gboolean result;
#line 366 "parser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 367 "parser.vala"
	switch (t) {
#line 2109 "parser.c"
		case VALENCIA_TOKEN_ABSTRACT:
		case VALENCIA_TOKEN_CONST:
		case VALENCIA_TOKEN_EXTERN:
		case VALENCIA_TOKEN_INLINE:
		case VALENCIA_TOKEN_INTERNAL:
		case VALENCIA_TOKEN_NEW:
		case VALENCIA_TOKEN_OVERRIDE:
		case VALENCIA_TOKEN_PRIVATE:
		case VALENCIA_TOKEN_PROTECTED:
		case VALENCIA_TOKEN_PUBLIC:
		case VALENCIA_TOKEN_STATIC:
		case VALENCIA_TOKEN_VIRTUAL:
		{
			result = TRUE;
			return result;
		}
		default:
		{
			result = FALSE;
			return result;
		}
	}
}


#line 386 "parser.vala"
static void valencia_parser_skip_attributes (ValenciaParser* self) {
#line 386 "parser.vala"
	g_return_if_fail (self != NULL);
#line 387 "parser.vala"
	while (TRUE) {
#line 387 "parser.vala"
		if (!valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_BRACKET)) {
#line 387 "parser.vala"
			break;
#line 2145 "parser.c"
		}
#line 388 "parser.vala"
		while (TRUE) {
#line 388 "parser.vala"
			if (!(valencia_parser_next_token (self) != VALENCIA_TOKEN_RIGHT_BRACKET)) {
#line 388 "parser.vala"
				break;
#line 2153 "parser.c"
			}
			;
		}
	}
}


#line 392 "parser.vala"
static void valencia_parser_skip_modifiers (ValenciaParser* self) {
#line 392 "parser.vala"
	g_return_if_fail (self != NULL);
#line 393 "parser.vala"
	while (TRUE) {
#line 393 "parser.vala"
		if (!valencia_parser_is_modifier (self, valencia_parser_peek_token (self))) {
#line 393 "parser.vala"
			break;
#line 2171 "parser.c"
		}
#line 394 "parser.vala"
		valencia_parser_next_token (self);
#line 2175 "parser.c"
	}
}


#line 397 "parser.vala"
static ValenciaConstruct* valencia_parser_parse_construct (ValenciaParser* self) {
#line 2182 "parser.c"
	ValenciaConstruct* result;
	gint start;
	ValenciaBlock* b;
	ValenciaConstruct* _tmp0_;
#line 397 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 398 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_CONSTRUCT)) {
#line 2191 "parser.c"
		result = NULL;
		return result;
	}
	start = self->priv->scanner->start;
#line 401 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_BRACE)) {
#line 2198 "parser.c"
		result = NULL;
		return result;
	}
	b = valencia_parser_parse_block (self);
	_tmp0_ = NULL;
#line 404 "parser.vala"
	if (b == NULL) {
#line 2206 "parser.c"
		ValenciaConstruct* _tmp1_;
		_tmp1_ = NULL;
#line 404 "parser.vala"
		_tmp0_ = (_tmp1_ = NULL, (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_);
#line 2211 "parser.c"
	} else {
		ValenciaConstruct* _tmp2_;
		_tmp2_ = NULL;
#line 404 "parser.vala"
		_tmp0_ = (_tmp2_ = valencia_construct_new (b, start, self->priv->scanner->end), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp2_);
#line 2217 "parser.c"
	}
	result = _tmp0_;
	(b == NULL) ? NULL : (b = (g_object_unref (b), NULL));
	return result;
}


#line 407 "parser.vala"
static ValenciaNode* valencia_parser_parse_member (ValenciaParser* self, ValenciaClass* enclosing_class) {
#line 2227 "parser.c"
	ValenciaNode* result;
	ValenciaToken t;
#line 407 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 408 "parser.vala"
	valencia_parser_skip_attributes (self);
#line 409 "parser.vala"
	valencia_parser_skip_modifiers (self);
#line 2236 "parser.c"
	t = valencia_parser_peek_token (self);
#line 411 "parser.vala"
	switch (t) {
#line 2240 "parser.c"
		case VALENCIA_TOKEN_NAMESPACE:
		{
#line 413 "parser.vala"
			if (enclosing_class == NULL) {
#line 414 "parser.vala"
				valencia_parser_next_token (self);
#line 2247 "parser.c"
				/* move past 'namespace'*/
				result = (ValenciaNode*) valencia_parser_parse_namespace (self);
				return result;
			}
#line 417 "parser.vala"
			valencia_parser_skip (self);
#line 2254 "parser.c"
			result = NULL;
			return result;
		}
		case VALENCIA_TOKEN_CLASS:
		case VALENCIA_TOKEN_INTERFACE:
		case VALENCIA_TOKEN_STRUCT:
		case VALENCIA_TOKEN_ENUM:
		{
#line 423 "parser.vala"
			valencia_parser_next_token (self);
#line 2265 "parser.c"
			result = (ValenciaNode*) valencia_parser_parse_class (self, t, enclosing_class);
			return result;
		}
		case VALENCIA_TOKEN_CONSTRUCT:
		{
			result = (ValenciaNode*) valencia_parser_parse_construct (self);
			return result;
		}
		default:
		{
			result = (ValenciaNode*) valencia_parser_parse_method_or_field (self, enclosing_class);
			return result;
		}
	}
}


#line 432 "parser.vala"
static ValenciaNamespace* valencia_parser_parse_containing_namespace (ValenciaParser* self, const char* name, ValenciaToken container_type, ValenciaClass* enclosing_class) {
#line 2285 "parser.c"
	ValenciaNamespace* result;
	ValenciaNamespace* n;
	ValenciaNamespace* _tmp0_;
	ValenciaNamespace* parent;
	ValenciaNamespace* _tmp2_;
	ValenciaNamespace* _tmp1_;
	ValenciaTypeSymbol* inner;
	ValenciaNamespace* _tmp5_;
	ValenciaNamespace* _tmp4_;
#line 432 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 432 "parser.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 2299 "parser.c"
	n = valencia_parser_open_namespace (self, name);
#line 436 "parser.vala"
	_tmp0_ = NULL;
#line 2303 "parser.c"
	parent = (_tmp0_ = self->priv->current_namespace, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	_tmp2_ = NULL;
#line 437 "parser.vala"
	_tmp1_ = NULL;
#line 437 "parser.vala"
	self->priv->current_namespace = (_tmp2_ = (_tmp1_ = n, (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_)), (self->priv->current_namespace == NULL) ? NULL : (self->priv->current_namespace = (g_object_unref (self->priv->current_namespace), NULL)), _tmp2_);
#line 2310 "parser.c"
	inner = valencia_parser_parse_class (self, container_type, enclosing_class);
#line 440 "parser.vala"
	if (inner == NULL) {
#line 2314 "parser.c"
		ValenciaNamespace* _tmp3_;
		_tmp3_ = NULL;
#line 441 "parser.vala"
		n = (_tmp3_ = NULL, (n == NULL) ? NULL : (n = (g_object_unref (n), NULL)), _tmp3_);
#line 2319 "parser.c"
	} else {
#line 443 "parser.vala"
		gee_collection_add ((GeeCollection*) n->symbols, (ValenciaSymbol*) inner);
#line 444 "parser.vala"
		valencia_parser_close_namespace (self, n);
#line 2325 "parser.c"
	}
	_tmp5_ = NULL;
#line 447 "parser.vala"
	_tmp4_ = NULL;
#line 447 "parser.vala"
	self->priv->current_namespace = (_tmp5_ = (_tmp4_ = parent, (_tmp4_ == NULL) ? NULL : g_object_ref (_tmp4_)), (self->priv->current_namespace == NULL) ? NULL : (self->priv->current_namespace = (g_object_unref (self->priv->current_namespace), NULL)), _tmp5_);
#line 2332 "parser.c"
	result = n;
	(parent == NULL) ? NULL : (parent = (g_object_unref (parent), NULL));
	(inner == NULL) ? NULL : (inner = (g_object_unref (inner), NULL));
	return result;
}


#line 451 "parser.vala"
static ValenciaTypeSymbol* valencia_parser_parse_class (ValenciaParser* self, ValenciaToken container_type, ValenciaClass* enclosing_class) {
#line 2342 "parser.c"
	ValenciaTypeSymbol* result;
	char* name;
	ValenciaClass* cl;
#line 451 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 452 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 453 "parser.vala"
		valencia_parser_skip (self);
#line 2352 "parser.c"
		result = NULL;
		return result;
	}
	name = valencia_scanner_val (self->priv->scanner);
#line 458 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_PERIOD)) {
#line 2359 "parser.c"
		result = (ValenciaTypeSymbol*) valencia_parser_parse_containing_namespace (self, name, container_type, enclosing_class);
		name = (g_free (name), NULL);
		return result;
	}
	cl = NULL;
#line 462 "parser.vala"
	if (container_type == VALENCIA_TOKEN_INTERFACE) {
#line 2367 "parser.c"
		ValenciaClass* _tmp0_;
		_tmp0_ = NULL;
#line 463 "parser.vala"
		cl = (_tmp0_ = (ValenciaClass*) valencia_interface_new (name, self->priv->source, enclosing_class), (cl == NULL) ? NULL : (cl = (g_object_unref (cl), NULL)), _tmp0_);
#line 2372 "parser.c"
	} else {
		ValenciaClass* _tmp1_;
		_tmp1_ = NULL;
#line 464 "parser.vala"
		cl = (_tmp1_ = valencia_class_new (name, self->priv->source, enclosing_class), (cl == NULL) ? NULL : (cl = (g_object_unref (cl), NULL)), _tmp1_);
#line 2378 "parser.c"
	}
#line 465 "parser.vala"
	((ValenciaNode*) cl)->start = self->priv->scanner->start;
#line 2382 "parser.c"
	/* Make sure to discard any generic qualifiers*/
#line 468 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_LESS_THAN)) {
#line 469 "parser.vala"
		while (TRUE) {
#line 2388 "parser.c"
			gboolean _tmp2_;
			_tmp2_ = FALSE;
#line 469 "parser.vala"
			if (valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 469 "parser.vala"
				_tmp2_ = TRUE;
#line 2395 "parser.c"
			} else {
#line 469 "parser.vala"
				_tmp2_ = valencia_parser_accept (self, VALENCIA_TOKEN_COMMA);
#line 2399 "parser.c"
			}
#line 469 "parser.vala"
			if (!_tmp2_) {
#line 469 "parser.vala"
				break;
#line 2405 "parser.c"
			}
			;
		}
#line 471 "parser.vala"
		valencia_parser_accept (self, VALENCIA_TOKEN_GREATER_THAN);
#line 2411 "parser.c"
	}
#line 474 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_COLON)) {
#line 475 "parser.vala"
		while (TRUE) {
#line 2417 "parser.c"
			ValenciaExpression* type;
			type = valencia_parser_parse_type (self);
#line 477 "parser.vala"
			if (type == NULL) {
#line 478 "parser.vala"
				valencia_parser_skip (self);
#line 2424 "parser.c"
				result = NULL;
				(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
				name = (g_free (name), NULL);
				(cl == NULL) ? NULL : (cl = (g_object_unref (cl), NULL));
				return result;
			}
#line 481 "parser.vala"
			gee_collection_add ((GeeCollection*) cl->super, type);
#line 482 "parser.vala"
			if (!valencia_parser_accept (self, VALENCIA_TOKEN_COMMA)) {
#line 2435 "parser.c"
				(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
#line 483 "parser.vala"
				break;
#line 2439 "parser.c"
			}
			(type == NULL) ? NULL : (type = (g_object_unref (type), NULL));
		}
	}
#line 485 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_BRACE)) {
#line 2446 "parser.c"
		result = NULL;
		name = (g_free (name), NULL);
		(cl == NULL) ? NULL : (cl = (g_object_unref (cl), NULL));
		return result;
	}
#line 488 "parser.vala"
	if (container_type == VALENCIA_TOKEN_ENUM) {
#line 489 "parser.vala"
		while (TRUE) {
#line 2456 "parser.c"
			char* _tmp4_;
			ValenciaId* _tmp3_;
			ValenciaField* _tmp5_;
			ValenciaField* f;
#line 490 "parser.vala"
			valencia_parser_skip_attributes (self);
#line 491 "parser.vala"
			if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 492 "parser.vala"
				break;
#line 2467 "parser.c"
			}
#line 301 "scanner.vala"
			_tmp4_ = NULL;
#line 2471 "parser.c"
			_tmp3_ = NULL;
#line 493 "parser.vala"
			_tmp5_ = NULL;
#line 2475 "parser.c"
			f = (_tmp5_ = valencia_field_new ((ValenciaExpression*) (_tmp3_ = valencia_id_new (name)), _tmp4_ = valencia_scanner_val (self->priv->scanner), self->priv->source, self->priv->scanner->start, 0), _tmp4_ = (g_free (_tmp4_), NULL), (_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_object_unref (_tmp3_), NULL)), _tmp5_);
#line 494 "parser.vala"
			if (valencia_parser_accept (self, VALENCIA_TOKEN_EQUALS)) {
#line 495 "parser.vala"
				valencia_parser_skip_expression (self);
#line 2481 "parser.c"
			}
#line 496 "parser.vala"
			((ValenciaNode*) f)->end = self->priv->scanner->end;
#line 497 "parser.vala"
			gee_collection_add ((GeeCollection*) cl->members, (ValenciaNode*) f);
#line 498 "parser.vala"
			if (!valencia_parser_accept (self, VALENCIA_TOKEN_COMMA)) {
#line 2489 "parser.c"
				(f == NULL) ? NULL : (f = (g_object_unref (f), NULL));
#line 499 "parser.vala"
				break;
#line 2493 "parser.c"
			}
			(f == NULL) ? NULL : (f = (g_object_unref (f), NULL));
		}
#line 501 "parser.vala"
		valencia_parser_accept (self, VALENCIA_TOKEN_SEMICOLON);
#line 2499 "parser.c"
	}
#line 504 "parser.vala"
	while (TRUE) {
#line 2503 "parser.c"
		gboolean _tmp6_;
		ValenciaNode* n;
		_tmp6_ = FALSE;
#line 504 "parser.vala"
		if (!valencia_scanner_eof (self->priv->scanner)) {
#line 504 "parser.vala"
			_tmp6_ = !valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_BRACE);
#line 2511 "parser.c"
		} else {
#line 504 "parser.vala"
			_tmp6_ = FALSE;
#line 2515 "parser.c"
		}
#line 504 "parser.vala"
		if (!_tmp6_) {
#line 504 "parser.vala"
			break;
#line 2521 "parser.c"
		}
		n = valencia_parser_parse_member (self, cl);
#line 506 "parser.vala"
		if (n != NULL) {
#line 507 "parser.vala"
			gee_collection_add ((GeeCollection*) cl->members, n);
#line 2528 "parser.c"
		}
		(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
	}
	/* make sure the class has a constructor, if not, add a default one*/
#line 511 "parser.vala"
	if (container_type == VALENCIA_TOKEN_CLASS) {
#line 2535 "parser.c"
		gboolean found_constructor;
		found_constructor = FALSE;
		{
			GeeIterator* _n_it;
			_n_it = gee_iterable_iterator ((GeeIterable*) cl->members);
#line 513 "parser.vala"
			while (TRUE) {
#line 2543 "parser.c"
				ValenciaNode* n;
				ValenciaConstructor* _tmp8_;
				ValenciaNode* _tmp7_;
				ValenciaConstructor* c;
#line 513 "parser.vala"
				if (!gee_iterator_next (_n_it)) {
#line 513 "parser.vala"
					break;
#line 2552 "parser.c"
				}
				n = (ValenciaNode*) gee_iterator_get (_n_it);
#line 514 "parser.vala"
				_tmp8_ = NULL;
#line 514 "parser.vala"
				_tmp7_ = NULL;
#line 2559 "parser.c"
				c = (_tmp8_ = (_tmp7_ = n, VALENCIA_IS_CONSTRUCTOR (_tmp7_) ? ((ValenciaConstructor*) _tmp7_) : NULL), (_tmp8_ == NULL) ? NULL : g_object_ref (_tmp8_));
#line 515 "parser.vala"
				if (c == NULL) {
#line 2563 "parser.c"
					(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
					(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
#line 516 "parser.vala"
					continue;
#line 2568 "parser.c"
				}
#line 518 "parser.vala"
				if (((ValenciaSymbol*) c)->name == NULL) {
#line 519 "parser.vala"
					found_constructor = TRUE;
#line 2574 "parser.c"
					(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
					(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
#line 520 "parser.vala"
					break;
#line 2579 "parser.c"
				}
				(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
				(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
			}
			(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
		}
#line 524 "parser.vala"
		if (!found_constructor) {
#line 2588 "parser.c"
			ValenciaConstructor* c;
			char* _tmp9_;
			c = valencia_constructor_new (NULL, cl, self->priv->source);
#line 526 "parser.vala"
			((ValenciaNode*) c)->start = ((ValenciaNode*) cl)->start;
#line 527 "parser.vala"
			((ValenciaNode*) c)->end = ((ValenciaNode*) c)->start;
#line 2596 "parser.c"
			_tmp9_ = NULL;
#line 528 "parser.vala"
			valencia_method_update_prototype ((ValenciaMethod*) c, _tmp9_ = g_strconcat (((ValenciaSymbol*) cl)->name, "()", NULL));
#line 2600 "parser.c"
			_tmp9_ = (g_free (_tmp9_), NULL);
#line 529 "parser.vala"
			gee_collection_add ((GeeCollection*) cl->members, (ValenciaNode*) c);
#line 2604 "parser.c"
			(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
		}
	}
#line 533 "parser.vala"
	((ValenciaNode*) cl)->end = self->priv->scanner->end;
#line 2610 "parser.c"
	result = (ValenciaTypeSymbol*) cl;
	name = (g_free (name), NULL);
	return result;
}


#line 537 "parser.vala"
static char* valencia_parser_join (const char* a, const char* b) {
#line 2619 "parser.c"
	char* result;
	char* _tmp0_;
#line 537 "parser.vala"
	g_return_val_if_fail (b != NULL, NULL);
#line 2624 "parser.c"
	_tmp0_ = NULL;
#line 538 "parser.vala"
	if (a == NULL) {
#line 2628 "parser.c"
		char* _tmp2_;
		const char* _tmp1_;
		_tmp2_ = NULL;
#line 538 "parser.vala"
		_tmp1_ = NULL;
#line 538 "parser.vala"
		_tmp0_ = (_tmp2_ = (_tmp1_ = b, (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp2_);
#line 2636 "parser.c"
	} else {
		char* _tmp4_;
		char* _tmp3_;
		_tmp4_ = NULL;
		_tmp3_ = NULL;
#line 538 "parser.vala"
		_tmp0_ = (_tmp4_ = g_strconcat (_tmp3_ = g_strconcat (a, ".", NULL), b, NULL), _tmp0_ = (g_free (_tmp0_), NULL), _tmp4_);
#line 2644 "parser.c"
		_tmp3_ = (g_free (_tmp3_), NULL);
	}
	result = _tmp0_;
	return result;
}


#line 541 "parser.vala"
static ValenciaNamespace* valencia_parser_open_namespace (ValenciaParser* self, const char* name) {
#line 2654 "parser.c"
	ValenciaNamespace* result;
	char* _tmp0_;
	ValenciaNamespace* _tmp1_;
	ValenciaNamespace* n;
#line 541 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 541 "parser.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 537 "parser.vala"
	_tmp0_ = NULL;
#line 542 "parser.vala"
	_tmp1_ = NULL;
#line 2667 "parser.c"
	n = (_tmp1_ = valencia_namespace_new (name, _tmp0_ = valencia_parser_join (self->priv->current_namespace->full_name, name), self->priv->source), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
#line 543 "parser.vala"
	((ValenciaNode*) n)->start = self->priv->scanner->start;
#line 2671 "parser.c"
	result = n;
	return result;
}


#line 547 "parser.vala"
static void valencia_parser_close_namespace (ValenciaParser* self, ValenciaNamespace* n) {
#line 547 "parser.vala"
	g_return_if_fail (self != NULL);
#line 547 "parser.vala"
	g_return_if_fail (n != NULL);
#line 548 "parser.vala"
	gee_collection_add ((GeeCollection*) self->priv->source->namespaces, n);
#line 549 "parser.vala"
	((ValenciaNode*) n)->end = self->priv->scanner->end;
#line 2687 "parser.c"
}


#line 552 "parser.vala"
static ValenciaNamespace* valencia_parser_parse_namespace (ValenciaParser* self) {
#line 2693 "parser.c"
	ValenciaNamespace* result;
	char* name;
	ValenciaNamespace* n;
	ValenciaNamespace* _tmp0_;
	ValenciaNamespace* parent;
	ValenciaNamespace* _tmp2_;
	ValenciaNamespace* _tmp1_;
	ValenciaNamespace* _tmp8_;
	ValenciaNamespace* _tmp7_;
#line 552 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 553 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 554 "parser.vala"
		valencia_parser_skip (self);
#line 2709 "parser.c"
		result = NULL;
		return result;
	}
	name = valencia_scanner_val (self->priv->scanner);
	n = valencia_parser_open_namespace (self, name);
#line 561 "parser.vala"
	_tmp0_ = NULL;
#line 2717 "parser.c"
	parent = (_tmp0_ = self->priv->current_namespace, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	_tmp2_ = NULL;
#line 562 "parser.vala"
	_tmp1_ = NULL;
#line 562 "parser.vala"
	self->priv->current_namespace = (_tmp2_ = (_tmp1_ = n, (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_)), (self->priv->current_namespace == NULL) ? NULL : (self->priv->current_namespace = (g_object_unref (self->priv->current_namespace), NULL)), _tmp2_);
#line 564 "parser.vala"
	if (valencia_parser_accept (self, VALENCIA_TOKEN_PERIOD)) {
#line 2726 "parser.c"
		ValenciaNamespace* inner;
		inner = valencia_parser_parse_namespace (self);
#line 566 "parser.vala"
		if (inner == NULL) {
#line 2731 "parser.c"
			ValenciaNamespace* _tmp3_;
			_tmp3_ = NULL;
#line 567 "parser.vala"
			n = (_tmp3_ = NULL, (n == NULL) ? NULL : (n = (g_object_unref (n), NULL)), _tmp3_);
#line 2736 "parser.c"
		} else {
#line 568 "parser.vala"
			gee_collection_add ((GeeCollection*) n->symbols, (ValenciaSymbol*) inner);
#line 2740 "parser.c"
		}
		(inner == NULL) ? NULL : (inner = (g_object_unref (inner), NULL));
	} else {
#line 569 "parser.vala"
		if (valencia_parser_accept (self, VALENCIA_TOKEN_LEFT_BRACE)) {
#line 570 "parser.vala"
			while (TRUE) {
#line 2748 "parser.c"
				gboolean _tmp4_;
				ValenciaNode* _tmp5_;
				ValenciaSymbol* s;
				_tmp4_ = FALSE;
#line 570 "parser.vala"
				if (!valencia_scanner_eof (self->priv->scanner)) {
#line 570 "parser.vala"
					_tmp4_ = !valencia_parser_accept (self, VALENCIA_TOKEN_RIGHT_BRACE);
#line 2757 "parser.c"
				} else {
#line 570 "parser.vala"
					_tmp4_ = FALSE;
#line 2761 "parser.c"
				}
#line 570 "parser.vala"
				if (!_tmp4_) {
#line 570 "parser.vala"
					break;
#line 2767 "parser.c"
				}
#line 571 "parser.vala"
				_tmp5_ = NULL;
#line 2771 "parser.c"
				s = (_tmp5_ = valencia_parser_parse_member (self, NULL), VALENCIA_IS_SYMBOL (_tmp5_) ? ((ValenciaSymbol*) _tmp5_) : NULL);
#line 572 "parser.vala"
				if (s != NULL) {
#line 573 "parser.vala"
					gee_collection_add ((GeeCollection*) n->symbols, s);
#line 2777 "parser.c"
				}
				(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
			}
		} else {
			ValenciaNamespace* _tmp6_;
#line 576 "parser.vala"
			valencia_parser_skip (self);
#line 2785 "parser.c"
			_tmp6_ = NULL;
#line 577 "parser.vala"
			n = (_tmp6_ = NULL, (n == NULL) ? NULL : (n = (g_object_unref (n), NULL)), _tmp6_);
#line 2789 "parser.c"
		}
	}
#line 580 "parser.vala"
	if (n != NULL) {
#line 581 "parser.vala"
		valencia_parser_close_namespace (self, n);
#line 2796 "parser.c"
	}
	_tmp8_ = NULL;
#line 583 "parser.vala"
	_tmp7_ = NULL;
#line 583 "parser.vala"
	self->priv->current_namespace = (_tmp8_ = (_tmp7_ = parent, (_tmp7_ == NULL) ? NULL : g_object_ref (_tmp7_)), (self->priv->current_namespace == NULL) ? NULL : (self->priv->current_namespace = (g_object_unref (self->priv->current_namespace), NULL)), _tmp8_);
#line 2803 "parser.c"
	result = n;
	name = (g_free (name), NULL);
	(parent == NULL) ? NULL : (parent = (g_object_unref (parent), NULL));
	return result;
}


#line 587 "parser.vala"
static char* valencia_parser_parse_using (ValenciaParser* self) {
#line 2813 "parser.c"
	char* result;
	char* s;
#line 587 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 588 "parser.vala"
	if (!valencia_parser_accept (self, VALENCIA_TOKEN_ID)) {
#line 589 "parser.vala"
		valencia_parser_skip (self);
#line 2822 "parser.c"
		result = NULL;
		return result;
	}
	s = valencia_scanner_val (self->priv->scanner);
#line 593 "parser.vala"
	valencia_parser_skip (self);
#line 2829 "parser.c"
	result = s;
	return result;
}


#line 597 "parser.vala"
void valencia_parser_parse (ValenciaParser* self, ValenciaSourceFile* source, const char* input) {
#line 2837 "parser.c"
	ValenciaSourceFile* _tmp1_;
	ValenciaSourceFile* _tmp0_;
	ValenciaScanner* _tmp2_;
	ValenciaNamespace* _tmp4_;
	ValenciaNamespace* _tmp3_;
#line 597 "parser.vala"
	g_return_if_fail (self != NULL);
#line 597 "parser.vala"
	g_return_if_fail (source != NULL);
#line 597 "parser.vala"
	g_return_if_fail (input != NULL);
#line 2849 "parser.c"
	_tmp1_ = NULL;
#line 598 "parser.vala"
	_tmp0_ = NULL;
#line 598 "parser.vala"
	self->priv->source = (_tmp1_ = (_tmp0_ = source, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->source == NULL) ? NULL : (self->priv->source = (g_object_unref (self->priv->source), NULL)), _tmp1_);
#line 2855 "parser.c"
	_tmp2_ = NULL;
#line 599 "parser.vala"
	self->priv->scanner = (_tmp2_ = valencia_scanner_new (input), (self->priv->scanner == NULL) ? NULL : (self->priv->scanner = (g_object_unref (self->priv->scanner), NULL)), _tmp2_);
#line 600 "parser.vala"
	while (TRUE) {
#line 2861 "parser.c"
		char* s;
#line 600 "parser.vala"
		if (!valencia_parser_accept (self, VALENCIA_TOKEN_USING)) {
#line 600 "parser.vala"
			break;
#line 2867 "parser.c"
		}
		s = valencia_parser_parse_using (self);
#line 602 "parser.vala"
		if (s != NULL) {
#line 603 "parser.vala"
			valencia_source_file_add_using_namespace (source, s);
#line 2874 "parser.c"
		}
		s = (g_free (s), NULL);
	}
	_tmp4_ = NULL;
#line 605 "parser.vala"
	_tmp3_ = NULL;
#line 605 "parser.vala"
	self->priv->current_namespace = (_tmp4_ = (_tmp3_ = source->top, (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_)), (self->priv->current_namespace == NULL) ? NULL : (self->priv->current_namespace = (g_object_unref (self->priv->current_namespace), NULL)), _tmp4_);
#line 606 "parser.vala"
	while (TRUE) {
#line 2885 "parser.c"
		ValenciaNode* _tmp5_;
		ValenciaSymbol* s;
#line 606 "parser.vala"
		if (!(!valencia_scanner_eof (self->priv->scanner))) {
#line 606 "parser.vala"
			break;
#line 2892 "parser.c"
		}
#line 607 "parser.vala"
		_tmp5_ = NULL;
#line 2896 "parser.c"
		s = (_tmp5_ = valencia_parser_parse_member (self, NULL), VALENCIA_IS_SYMBOL (_tmp5_) ? ((ValenciaSymbol*) _tmp5_) : NULL);
#line 608 "parser.vala"
		if (s != NULL) {
#line 609 "parser.vala"
			gee_collection_add ((GeeCollection*) source->top->symbols, s);
#line 2902 "parser.c"
		}
		(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
	}
#line 611 "parser.vala"
	((ValenciaNode*) source->top)->end = self->priv->scanner->end;
#line 2908 "parser.c"
}


/* namespaces, interfaces/classes/structs/enums, and methods count as enclosing scopes*/
#line 615 "parser.vala"
ValenciaScanScope* valencia_parser_find_enclosing_scope (ValenciaParser* self, const char* input, gint pos, gboolean classes_only) {
#line 2915 "parser.c"
	ValenciaScanScope* result;
	ValenciaScanner* _tmp0_;
	Stack* scopes;
	gint depth;
	gboolean token_is_class;
	gboolean token_is_namespace;
	ValenciaScanScope* _tmp14_;
#line 615 "parser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 615 "parser.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 2927 "parser.c"
	_tmp0_ = NULL;
#line 616 "parser.vala"
	self->priv->scanner = (_tmp0_ = valencia_scanner_new (input), (self->priv->scanner == NULL) ? NULL : (self->priv->scanner = (g_object_unref (self->priv->scanner), NULL)), _tmp0_);
#line 2931 "parser.c"
	scopes = stack_new (VALENCIA_TYPE_SCAN_SCOPE, (GBoxedCopyFunc) g_object_ref, g_object_unref);
	depth = 0;
	token_is_class = FALSE;
	token_is_namespace = FALSE;
#line 623 "parser.vala"
	while (TRUE) {
#line 2938 "parser.c"
		ValenciaToken t;
#line 623 "parser.vala"
		if (!(self->priv->scanner->end < pos)) {
#line 623 "parser.vala"
			break;
#line 2944 "parser.c"
		}
		t = valencia_parser_next_token (self);
#line 625 "parser.vala"
		if (t == VALENCIA_TOKEN_EOF) {
#line 626 "parser.vala"
			break;
#line 2951 "parser.c"
		}
#line 627 "parser.vala"
		if (t == VALENCIA_TOKEN_CLASS) {
#line 628 "parser.vala"
			token_is_class = TRUE;
#line 2957 "parser.c"
		} else {
#line 629 "parser.vala"
			if (t == VALENCIA_TOKEN_NAMESPACE) {
#line 630 "parser.vala"
				token_is_namespace = TRUE;
#line 2963 "parser.c"
			} else {
#line 631 "parser.vala"
				if (t == VALENCIA_TOKEN_LEFT_BRACE) {
#line 632 "parser.vala"
					depth = depth + 1;
#line 2969 "parser.c"
				} else {
#line 633 "parser.vala"
					if (t == VALENCIA_TOKEN_RIGHT_BRACE) {
#line 2973 "parser.c"
						gboolean _tmp1_;
						gboolean _tmp2_;
#line 634 "parser.vala"
						depth = depth - 1;
#line 2978 "parser.c"
						_tmp1_ = FALSE;
						_tmp2_ = FALSE;
#line 635 "parser.vala"
						if (stack_size (scopes) > 0) {
#line 2983 "parser.c"
							ValenciaScanScope* _tmp3_;
#line 618 "parser.vala"
							_tmp3_ = NULL;
#line 635 "parser.vala"
							_tmp2_ = (_tmp3_ = (ValenciaScanScope*) stack_top (scopes))->depth == depth;
#line 2989 "parser.c"
							(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_object_unref (_tmp3_), NULL));
						} else {
#line 635 "parser.vala"
							_tmp2_ = FALSE;
#line 2994 "parser.c"
						}
#line 635 "parser.vala"
						if (_tmp2_) {
#line 635 "parser.vala"
							_tmp1_ = self->priv->scanner->end < pos;
#line 3000 "parser.c"
						} else {
#line 635 "parser.vala"
							_tmp1_ = FALSE;
#line 3004 "parser.c"
						}
#line 635 "parser.vala"
						if (_tmp1_) {
#line 636 "parser.vala"
							stack_pop (scopes);
#line 3010 "parser.c"
						}
					} else {
						gboolean _tmp4_;
						_tmp4_ = FALSE;
#line 638 "parser.vala"
						if (t == VALENCIA_TOKEN_ID) {
#line 3017 "parser.c"
							gboolean _tmp5_;
							gboolean _tmp6_;
							_tmp5_ = FALSE;
							_tmp6_ = FALSE;
#line 638 "parser.vala"
							if (!classes_only) {
#line 638 "parser.vala"
								_tmp6_ = !token_is_class;
#line 3026 "parser.c"
							} else {
#line 638 "parser.vala"
								_tmp6_ = FALSE;
#line 3030 "parser.c"
							}
#line 638 "parser.vala"
							if (_tmp6_) {
#line 638 "parser.vala"
								_tmp5_ = TRUE;
#line 3036 "parser.c"
							} else {
#line 638 "parser.vala"
								_tmp5_ = token_is_class;
#line 3040 "parser.c"
							}
#line 638 "parser.vala"
							_tmp4_ = _tmp5_;
#line 3044 "parser.c"
						} else {
#line 638 "parser.vala"
							_tmp4_ = FALSE;
#line 3048 "parser.c"
						}
#line 638 "parser.vala"
						if (_tmp4_) {
#line 3052 "parser.c"
							gint position;
							gint end;
							gboolean _tmp11_;
							gboolean _tmp12_;
							position = self->priv->scanner->start;
#line 640 "parser.vala"
							while (TRUE) {
#line 3060 "parser.c"
								gboolean _tmp10_;
#line 641 "parser.vala"
								if (self->priv->scanner->end >= pos) {
#line 3064 "parser.c"
									ValenciaScanScope* _tmp7_;
									_tmp7_ = NULL;
#line 642 "parser.vala"
									if (stack_size (scopes) > 0) {
#line 3069 "parser.c"
										ValenciaScanScope* _tmp8_;
										_tmp8_ = NULL;
#line 642 "parser.vala"
										_tmp7_ = (_tmp8_ = (ValenciaScanScope*) stack_top (scopes), (_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_object_unref (_tmp7_), NULL)), _tmp8_);
#line 3074 "parser.c"
									} else {
										ValenciaScanScope* _tmp9_;
										_tmp9_ = NULL;
#line 642 "parser.vala"
										_tmp7_ = (_tmp9_ = NULL, (_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_object_unref (_tmp7_), NULL)), _tmp9_);
#line 3080 "parser.c"
									}
									result = _tmp7_;
									(scopes == NULL) ? NULL : (scopes = (g_object_unref (scopes), NULL));
									return result;
								}
								_tmp10_ = FALSE;
#line 643 "parser.vala"
								if (!valencia_parser_accept (self, VALENCIA_TOKEN_PERIOD)) {
#line 643 "parser.vala"
									_tmp10_ = TRUE;
#line 3091 "parser.c"
								} else {
#line 643 "parser.vala"
									_tmp10_ = !valencia_parser_accept (self, VALENCIA_TOKEN_ID);
#line 3095 "parser.c"
								}
#line 643 "parser.vala"
								if (_tmp10_) {
#line 644 "parser.vala"
									break;
#line 3101 "parser.c"
								}
							}
							end = self->priv->scanner->end;
							_tmp11_ = FALSE;
#line 648 "parser.vala"
							if (!classes_only) {
#line 648 "parser.vala"
								_tmp11_ = valencia_parser_peek_token (self) == VALENCIA_TOKEN_LEFT_PAREN;
#line 3110 "parser.c"
							} else {
#line 648 "parser.vala"
								_tmp11_ = FALSE;
#line 3114 "parser.c"
							}
#line 648 "parser.vala"
							if (_tmp11_) {
#line 3118 "parser.c"
								gint unmatched_parens;
								/* skip to the end of the method declaration to check for a left brace*/
								unmatched_parens = 0;
#line 651 "parser.vala"
								while (TRUE) {
#line 651 "parser.vala"
									if (!(self->priv->scanner->end < pos)) {
#line 651 "parser.vala"
										break;
#line 3128 "parser.c"
									}
#line 652 "parser.vala"
									t = valencia_parser_next_token (self);
#line 653 "parser.vala"
									if (t == VALENCIA_TOKEN_SEMICOLON) {
#line 654 "parser.vala"
										break;
#line 3136 "parser.c"
									} else {
#line 655 "parser.vala"
										if (t == VALENCIA_TOKEN_LEFT_PAREN) {
#line 656 "parser.vala"
											unmatched_parens = unmatched_parens + 1;
#line 3142 "parser.c"
										} else {
#line 657 "parser.vala"
											if (t == VALENCIA_TOKEN_RIGHT_PAREN) {
#line 658 "parser.vala"
												if ((unmatched_parens = unmatched_parens - 1) == 0) {
#line 659 "parser.vala"
													break;
#line 3150 "parser.c"
												}
											}
										}
									}
								}
								/* Borrow the token_is_class variable temporarily - there's no need to use 
								 another variable when this will be reset to false*/
#line 664 "parser.vala"
								if (valencia_parser_peek_token (self) == VALENCIA_TOKEN_LEFT_BRACE) {
#line 665 "parser.vala"
									token_is_class = TRUE;
#line 3162 "parser.c"
								}
							}
							_tmp12_ = FALSE;
#line 668 "parser.vala"
							if (token_is_class) {
#line 668 "parser.vala"
								_tmp12_ = TRUE;
#line 3170 "parser.c"
							} else {
#line 668 "parser.vala"
								_tmp12_ = token_is_namespace;
#line 3174 "parser.c"
							}
#line 668 "parser.vala"
							if (_tmp12_) {
#line 3178 "parser.c"
								ValenciaScanScope* _tmp13_;
								_tmp13_ = NULL;
#line 669 "parser.vala"
								stack_push (scopes, _tmp13_ = valencia_scan_scope_new (depth, position, end));
#line 3183 "parser.c"
								(_tmp13_ == NULL) ? NULL : (_tmp13_ = (g_object_unref (_tmp13_), NULL));
							}
#line 670 "parser.vala"
							token_is_class = FALSE;
#line 671 "parser.vala"
							token_is_namespace = FALSE;
#line 3190 "parser.c"
						} else {
#line 673 "parser.vala"
							token_is_class = FALSE;
#line 674 "parser.vala"
							token_is_namespace = FALSE;
#line 3196 "parser.c"
						}
					}
				}
			}
		}
	}
	_tmp14_ = NULL;
#line 678 "parser.vala"
	if (stack_size (scopes) > 0) {
#line 3206 "parser.c"
		ValenciaScanScope* _tmp15_;
		_tmp15_ = NULL;
#line 678 "parser.vala"
		_tmp14_ = (_tmp15_ = (ValenciaScanScope*) stack_top (scopes), (_tmp14_ == NULL) ? NULL : (_tmp14_ = (g_object_unref (_tmp14_), NULL)), _tmp15_);
#line 3211 "parser.c"
	} else {
		ValenciaScanScope* _tmp16_;
		_tmp16_ = NULL;
#line 678 "parser.vala"
		_tmp14_ = (_tmp16_ = NULL, (_tmp14_ == NULL) ? NULL : (_tmp14_ = (g_object_unref (_tmp14_), NULL)), _tmp16_);
#line 3217 "parser.c"
	}
	result = _tmp14_;
	(scopes == NULL) ? NULL : (scopes = (g_object_unref (scopes), NULL));
	return result;
}


#line 33 "parser.vala"
ValenciaParser* valencia_parser_construct (GType object_type) {
#line 3227 "parser.c"
	ValenciaParser * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 33 "parser.vala"
ValenciaParser* valencia_parser_new (void) {
#line 33 "parser.vala"
	return valencia_parser_construct (VALENCIA_TYPE_PARSER);
#line 3238 "parser.c"
}


static void valencia_parser_class_init (ValenciaParserClass * klass) {
	valencia_parser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaParserPrivate));
	G_OBJECT_CLASS (klass)->finalize = valencia_parser_finalize;
}


static void valencia_parser_instance_init (ValenciaParser * self) {
	self->priv = VALENCIA_PARSER_GET_PRIVATE (self);
}


static void valencia_parser_finalize (GObject* obj) {
	ValenciaParser * self;
	self = VALENCIA_PARSER (obj);
	(self->priv->source == NULL) ? NULL : (self->priv->source = (g_object_unref (self->priv->source), NULL));
	(self->priv->scanner == NULL) ? NULL : (self->priv->scanner = (g_object_unref (self->priv->scanner), NULL));
	(self->priv->current_namespace == NULL) ? NULL : (self->priv->current_namespace = (g_object_unref (self->priv->current_namespace), NULL));
	G_OBJECT_CLASS (valencia_parser_parent_class)->finalize (obj);
}


GType valencia_parser_get_type (void) {
	static GType valencia_parser_type_id = 0;
	if (valencia_parser_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaParser), 0, (GInstanceInitFunc) valencia_parser_instance_init, NULL };
		valencia_parser_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaParser", &g_define_type_info, 0);
	}
	return valencia_parser_type_id;
}


#line 685 "parser.vala"
void _main (char** args, int args_length1) {
#line 3276 "parser.c"
	GError * _inner_error_;
	const char* _tmp0_;
	char* filename;
	char* source;
	char* _tmp3_;
	gboolean _tmp2_;
	char* _tmp1_;
	gboolean _tmp4_;
	ValenciaSourceFile* sf;
	ValenciaParser* _tmp5_;
	_inner_error_ = NULL;
#line 686 "parser.vala"
	if (args_length1 < 2) {
#line 687 "parser.vala"
		fputs ("usage: symbol <file>\n", stderr);
#line 3292 "parser.c"
		return;
	}
#line 690 "parser.vala"
	_tmp0_ = NULL;
#line 3297 "parser.c"
	filename = (_tmp0_ = args[1], (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	source = NULL;
	_tmp3_ = NULL;
	_tmp1_ = NULL;
	_tmp4_ = (_tmp2_ = g_file_get_contents (filename, &_tmp1_, NULL, &_inner_error_), source = (_tmp3_ = _tmp1_, source = (g_free (source), NULL), _tmp3_), _tmp2_);
	if (_inner_error_ != NULL) {
		filename = (g_free (filename), NULL);
		source = (g_free (source), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
#line 692 "parser.vala"
	if (!_tmp4_) {
#line 693 "parser.vala"
		fputs ("can't read file\n", stderr);
#line 3314 "parser.c"
		filename = (g_free (filename), NULL);
		source = (g_free (source), NULL);
		return;
	}
	sf = valencia_source_file_new (NULL, filename);
	_tmp5_ = NULL;
#line 697 "parser.vala"
	valencia_parser_parse (_tmp5_ = valencia_parser_new (), sf, source);
#line 3323 "parser.c"
	(_tmp5_ == NULL) ? NULL : (_tmp5_ = (g_object_unref (_tmp5_), NULL));
#line 698 "parser.vala"
	valencia_node_print ((ValenciaNode*) sf, 0);
#line 3327 "parser.c"
	filename = (g_free (filename), NULL);
	source = (g_free (source), NULL);
	(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
}


#line 685 "parser.vala"
int main (int argc, char ** argv) {
#line 685 "parser.vala"
	g_type_init ();
#line 685 "parser.vala"
	_main (argv, argc);
#line 685 "parser.vala"
	return 0;
#line 3342 "parser.c"
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




