/* Copyright 2009 Yorba Foundation
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution. 
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <vala.h>
#include <float.h>
#include <math.h>


#define VALENCIA_TYPE_SYMBOL_SET (valencia_symbol_set_get_type ())
#define VALENCIA_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSet))
#define VALENCIA_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))
#define VALENCIA_IS_SYMBOL_SET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_IS_SYMBOL_SET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL_SET))
#define VALENCIA_SYMBOL_SET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetClass))

typedef struct _ValenciaSymbolSet ValenciaSymbolSet;
typedef struct _ValenciaSymbolSetClass ValenciaSymbolSetClass;
typedef struct _ValenciaSymbolSetPrivate ValenciaSymbolSetPrivate;

#define VALENCIA_TYPE_NODE (valencia_node_get_type ())
#define VALENCIA_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NODE, ValenciaNode))
#define VALENCIA_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NODE, ValenciaNodeClass))
#define VALENCIA_IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NODE))
#define VALENCIA_IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NODE))
#define VALENCIA_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NODE, ValenciaNodeClass))

typedef struct _ValenciaNode ValenciaNode;
typedef struct _ValenciaNodeClass ValenciaNodeClass;

#define VALENCIA_TYPE_SYMBOL (valencia_symbol_get_type ())
#define VALENCIA_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbol))
#define VALENCIA_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))
#define VALENCIA_IS_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_IS_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SYMBOL))
#define VALENCIA_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SYMBOL, ValenciaSymbolClass))

typedef struct _ValenciaSymbol ValenciaSymbol;
typedef struct _ValenciaSymbolClass ValenciaSymbolClass;

#define VALENCIA_TYPE_TYPESYMBOL (valencia_typesymbol_get_type ())
#define VALENCIA_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbol))
#define VALENCIA_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))
#define VALENCIA_IS_TYPESYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_IS_TYPESYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_TYPESYMBOL))
#define VALENCIA_TYPESYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_TYPESYMBOL, ValenciaTypeSymbolClass))

typedef struct _ValenciaTypeSymbol ValenciaTypeSymbol;
typedef struct _ValenciaTypeSymbolClass ValenciaTypeSymbolClass;

#define VALENCIA_TYPE_CLASS (valencia_class_get_type ())
#define VALENCIA_CLASS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CLASS, ValenciaClass))
#define VALENCIA_CLASS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CLASS, ValenciaClassClass))
#define VALENCIA_IS_CLASS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CLASS))
#define VALENCIA_IS_CLASS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CLASS))
#define VALENCIA_CLASS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CLASS, ValenciaClassClass))

typedef struct _ValenciaClass ValenciaClass;
typedef struct _ValenciaClassClass ValenciaClassClass;
typedef struct _ValenciaNodePrivate ValenciaNodePrivate;
typedef struct _ValenciaSymbolPrivate ValenciaSymbolPrivate;

#define VALENCIA_TYPE_SOURCE_FILE (valencia_source_file_get_type ())
#define VALENCIA_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFile))
#define VALENCIA_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))
#define VALENCIA_IS_SOURCE_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_IS_SOURCE_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_SOURCE_FILE))
#define VALENCIA_SOURCE_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFileClass))

typedef struct _ValenciaSourceFile ValenciaSourceFile;
typedef struct _ValenciaSourceFileClass ValenciaSourceFileClass;
typedef struct _ValenciaTypeSymbolPrivate ValenciaTypeSymbolPrivate;

#define VALENCIA_TYPE_SCOPE (valencia_scope_get_type ())
#define VALENCIA_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_SCOPE, ValenciaScope))
#define VALENCIA_IS_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_SCOPE))
#define VALENCIA_SCOPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), VALENCIA_TYPE_SCOPE, ValenciaScopeIface))

typedef struct _ValenciaScope ValenciaScope;
typedef struct _ValenciaScopeIface ValenciaScopeIface;
typedef struct _ValenciaClassPrivate ValenciaClassPrivate;

#define VALENCIA_TYPE_EXPRESSION (valencia_expression_get_type ())
#define VALENCIA_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpression))
#define VALENCIA_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))
#define VALENCIA_IS_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_IS_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_EXPRESSION))
#define VALENCIA_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_EXPRESSION, ValenciaExpressionClass))

typedef struct _ValenciaExpression ValenciaExpression;
typedef struct _ValenciaExpressionClass ValenciaExpressionClass;

#define VALENCIA_TYPE_METHOD (valencia_method_get_type ())
#define VALENCIA_METHOD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_METHOD, ValenciaMethod))
#define VALENCIA_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_METHOD, ValenciaMethodClass))
#define VALENCIA_IS_METHOD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_METHOD))
#define VALENCIA_IS_METHOD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_METHOD))
#define VALENCIA_METHOD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_METHOD, ValenciaMethodClass))

typedef struct _ValenciaMethod ValenciaMethod;
typedef struct _ValenciaMethodClass ValenciaMethodClass;

#define VALENCIA_TYPE_CONSTRUCTOR (valencia_constructor_get_type ())
#define VALENCIA_CONSTRUCTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructor))
#define VALENCIA_CONSTRUCTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructorClass))
#define VALENCIA_IS_CONSTRUCTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONSTRUCTOR))
#define VALENCIA_IS_CONSTRUCTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONSTRUCTOR))
#define VALENCIA_CONSTRUCTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONSTRUCTOR, ValenciaConstructorClass))

typedef struct _ValenciaConstructor ValenciaConstructor;
typedef struct _ValenciaConstructorClass ValenciaConstructorClass;

#define VALENCIA_TYPE_CHAIN (valencia_chain_get_type ())
#define VALENCIA_CHAIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CHAIN, ValenciaChain))
#define VALENCIA_CHAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CHAIN, ValenciaChainClass))
#define VALENCIA_IS_CHAIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CHAIN))
#define VALENCIA_IS_CHAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CHAIN))
#define VALENCIA_CHAIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CHAIN, ValenciaChainClass))

typedef struct _ValenciaChain ValenciaChain;
typedef struct _ValenciaChainClass ValenciaChainClass;
typedef struct _ValenciaMethodPrivate ValenciaMethodPrivate;

#define VALENCIA_TYPE_VARIABLE (valencia_variable_get_type ())
#define VALENCIA_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_VARIABLE, ValenciaVariable))
#define VALENCIA_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_VARIABLE, ValenciaVariableClass))
#define VALENCIA_IS_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_VARIABLE))
#define VALENCIA_IS_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_VARIABLE))
#define VALENCIA_VARIABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_VARIABLE, ValenciaVariableClass))

typedef struct _ValenciaVariable ValenciaVariable;
typedef struct _ValenciaVariableClass ValenciaVariableClass;

#define VALENCIA_TYPE_PARAMETER (valencia_parameter_get_type ())
#define VALENCIA_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARAMETER, ValenciaParameter))
#define VALENCIA_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARAMETER, ValenciaParameterClass))
#define VALENCIA_IS_PARAMETER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARAMETER))
#define VALENCIA_IS_PARAMETER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARAMETER))
#define VALENCIA_PARAMETER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARAMETER, ValenciaParameterClass))

typedef struct _ValenciaParameter ValenciaParameter;
typedef struct _ValenciaParameterClass ValenciaParameterClass;

#define VALENCIA_TYPE_STATEMENT (valencia_statement_get_type ())
#define VALENCIA_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_STATEMENT, ValenciaStatement))
#define VALENCIA_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_STATEMENT, ValenciaStatementClass))
#define VALENCIA_IS_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_STATEMENT))
#define VALENCIA_IS_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_STATEMENT))
#define VALENCIA_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_STATEMENT, ValenciaStatementClass))

typedef struct _ValenciaStatement ValenciaStatement;
typedef struct _ValenciaStatementClass ValenciaStatementClass;

#define VALENCIA_TYPE_BLOCK (valencia_block_get_type ())
#define VALENCIA_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_BLOCK, ValenciaBlock))
#define VALENCIA_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_BLOCK, ValenciaBlockClass))
#define VALENCIA_IS_BLOCK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_BLOCK))
#define VALENCIA_IS_BLOCK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_BLOCK))
#define VALENCIA_BLOCK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_BLOCK, ValenciaBlockClass))

typedef struct _ValenciaBlock ValenciaBlock;
typedef struct _ValenciaBlockClass ValenciaBlockClass;
typedef struct _ValenciaConstructorPrivate ValenciaConstructorPrivate;
typedef struct _ValenciaStatementPrivate ValenciaStatementPrivate;
typedef struct _ValenciaVariablePrivate ValenciaVariablePrivate;

#define VALENCIA_TYPE_LOCAL_VARIABLE (valencia_local_variable_get_type ())
#define VALENCIA_LOCAL_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariable))
#define VALENCIA_LOCAL_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariableClass))
#define VALENCIA_IS_LOCAL_VARIABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_LOCAL_VARIABLE))
#define VALENCIA_IS_LOCAL_VARIABLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_LOCAL_VARIABLE))
#define VALENCIA_LOCAL_VARIABLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_LOCAL_VARIABLE, ValenciaLocalVariableClass))

typedef struct _ValenciaLocalVariable ValenciaLocalVariable;
typedef struct _ValenciaLocalVariableClass ValenciaLocalVariableClass;
typedef struct _ValenciaLocalVariablePrivate ValenciaLocalVariablePrivate;

#define VALENCIA_TYPE_DECLARATION_STATEMENT (valencia_declaration_statement_get_type ())
#define VALENCIA_DECLARATION_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatement))
#define VALENCIA_DECLARATION_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatementClass))
#define VALENCIA_IS_DECLARATION_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT))
#define VALENCIA_IS_DECLARATION_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_DECLARATION_STATEMENT))
#define VALENCIA_DECLARATION_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_DECLARATION_STATEMENT, ValenciaDeclarationStatementClass))

typedef struct _ValenciaDeclarationStatement ValenciaDeclarationStatement;
typedef struct _ValenciaDeclarationStatementClass ValenciaDeclarationStatementClass;
typedef struct _ValenciaDeclarationStatementPrivate ValenciaDeclarationStatementPrivate;

#define VALENCIA_TYPE_FOR (valencia_for_get_type ())
#define VALENCIA_FOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_FOR, ValenciaFor))
#define VALENCIA_FOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_FOR, ValenciaForClass))
#define VALENCIA_IS_FOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_FOR))
#define VALENCIA_IS_FOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_FOR))
#define VALENCIA_FOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_FOR, ValenciaForClass))

typedef struct _ValenciaFor ValenciaFor;
typedef struct _ValenciaForClass ValenciaForClass;
typedef struct _ValenciaForPrivate ValenciaForPrivate;
typedef struct _ValenciaChainPrivate ValenciaChainPrivate;

#define VALENCIA_TYPE_INTERFACE (valencia_interface_get_type ())
#define VALENCIA_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_INTERFACE, ValenciaInterface))
#define VALENCIA_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_INTERFACE, ValenciaInterfaceClass))
#define VALENCIA_IS_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_INTERFACE))
#define VALENCIA_IS_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_INTERFACE))
#define VALENCIA_INTERFACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_INTERFACE, ValenciaInterfaceClass))

typedef struct _ValenciaInterface ValenciaInterface;
typedef struct _ValenciaInterfaceClass ValenciaInterfaceClass;
typedef struct _ValenciaBlockPrivate ValenciaBlockPrivate;
typedef struct _ValenciaParameterPrivate ValenciaParameterPrivate;

#define VALENCIA_TYPE_CONSTRUCT (valencia_construct_get_type ())
#define VALENCIA_CONSTRUCT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONSTRUCT, ValenciaConstruct))
#define VALENCIA_CONSTRUCT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONSTRUCT, ValenciaConstructClass))
#define VALENCIA_IS_CONSTRUCT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONSTRUCT))
#define VALENCIA_IS_CONSTRUCT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONSTRUCT))
#define VALENCIA_CONSTRUCT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONSTRUCT, ValenciaConstructClass))

typedef struct _ValenciaConstruct ValenciaConstruct;
typedef struct _ValenciaConstructClass ValenciaConstructClass;
typedef struct _ValenciaConstructPrivate ValenciaConstructPrivate;

#define VALENCIA_TYPE_VSIGNAL (valencia_vsignal_get_type ())
#define VALENCIA_VSIGNAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_VSIGNAL, ValenciaVSignal))
#define VALENCIA_VSIGNAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_VSIGNAL, ValenciaVSignalClass))
#define VALENCIA_IS_VSIGNAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_VSIGNAL))
#define VALENCIA_IS_VSIGNAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_VSIGNAL))
#define VALENCIA_VSIGNAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_VSIGNAL, ValenciaVSignalClass))

typedef struct _ValenciaVSignal ValenciaVSignal;
typedef struct _ValenciaVSignalClass ValenciaVSignalClass;
typedef struct _ValenciaVSignalPrivate ValenciaVSignalPrivate;

#define VALENCIA_TYPE_DELEGATE (valencia_delegate_get_type ())
#define VALENCIA_DELEGATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_DELEGATE, ValenciaDelegate))
#define VALENCIA_DELEGATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_DELEGATE, ValenciaDelegateClass))
#define VALENCIA_IS_DELEGATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_DELEGATE))
#define VALENCIA_IS_DELEGATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_DELEGATE))
#define VALENCIA_DELEGATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_DELEGATE, ValenciaDelegateClass))

typedef struct _ValenciaDelegate ValenciaDelegate;
typedef struct _ValenciaDelegateClass ValenciaDelegateClass;
typedef struct _ValenciaDelegatePrivate ValenciaDelegatePrivate;

#define VALENCIA_TYPE_FIELD (valencia_field_get_type ())
#define VALENCIA_FIELD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_FIELD, ValenciaField))
#define VALENCIA_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_FIELD, ValenciaFieldClass))
#define VALENCIA_IS_FIELD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_FIELD))
#define VALENCIA_IS_FIELD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_FIELD))
#define VALENCIA_FIELD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_FIELD, ValenciaFieldClass))

typedef struct _ValenciaField ValenciaField;
typedef struct _ValenciaFieldClass ValenciaFieldClass;
typedef struct _ValenciaFieldPrivate ValenciaFieldPrivate;

#define VALENCIA_TYPE_PROPERTY (valencia_property_get_type ())
#define VALENCIA_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PROPERTY, ValenciaProperty))
#define VALENCIA_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PROPERTY, ValenciaPropertyClass))
#define VALENCIA_IS_PROPERTY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PROPERTY))
#define VALENCIA_IS_PROPERTY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PROPERTY))
#define VALENCIA_PROPERTY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PROPERTY, ValenciaPropertyClass))

typedef struct _ValenciaProperty ValenciaProperty;
typedef struct _ValenciaPropertyClass ValenciaPropertyClass;
typedef struct _ValenciaPropertyPrivate ValenciaPropertyPrivate;
typedef struct _ValenciaInterfacePrivate ValenciaInterfacePrivate;

#define VALENCIA_TYPE_NAMESPACE (valencia_namespace_get_type ())
#define VALENCIA_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespace))
#define VALENCIA_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))
#define VALENCIA_IS_NAMESPACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_IS_NAMESPACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NAMESPACE))
#define VALENCIA_NAMESPACE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NAMESPACE, ValenciaNamespaceClass))

typedef struct _ValenciaNamespace ValenciaNamespace;
typedef struct _ValenciaNamespaceClass ValenciaNamespaceClass;
typedef struct _ValenciaNamespacePrivate ValenciaNamespacePrivate;
typedef struct _ValenciaSourceFilePrivate ValenciaSourceFilePrivate;

#define VALENCIA_TYPE_PROGRAM (valencia_program_get_type ())
#define VALENCIA_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgram))
#define VALENCIA_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))
#define VALENCIA_IS_PROGRAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_IS_PROGRAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PROGRAM))
#define VALENCIA_PROGRAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PROGRAM, ValenciaProgramClass))

typedef struct _ValenciaProgram ValenciaProgram;
typedef struct _ValenciaProgramClass ValenciaProgramClass;

#define VALENCIA_TYPE_THIS (valencia_this_get_type ())
#define VALENCIA_THIS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_THIS, ValenciaThis))
#define VALENCIA_THIS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_THIS, ValenciaThisClass))
#define VALENCIA_IS_THIS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_THIS))
#define VALENCIA_IS_THIS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_THIS))
#define VALENCIA_THIS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_THIS, ValenciaThisClass))

typedef struct _ValenciaThis ValenciaThis;
typedef struct _ValenciaThisClass ValenciaThisClass;

#define VALENCIA_TYPE_BASE (valencia_base_get_type ())
#define VALENCIA_BASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_BASE, ValenciaBase))
#define VALENCIA_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_BASE, ValenciaBaseClass))
#define VALENCIA_IS_BASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_BASE))
#define VALENCIA_IS_BASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_BASE))
#define VALENCIA_BASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_BASE, ValenciaBaseClass))

typedef struct _ValenciaBase ValenciaBase;
typedef struct _ValenciaBaseClass ValenciaBaseClass;

#define VALENCIA_TYPE_METHOD_CALL (valencia_method_call_get_type ())
#define VALENCIA_METHOD_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCall))
#define VALENCIA_METHOD_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCallClass))
#define VALENCIA_IS_METHOD_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_METHOD_CALL))
#define VALENCIA_IS_METHOD_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_METHOD_CALL))
#define VALENCIA_METHOD_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_METHOD_CALL, ValenciaMethodCallClass))

typedef struct _ValenciaMethodCall ValenciaMethodCall;
typedef struct _ValenciaMethodCallClass ValenciaMethodCallClass;
typedef struct _ValenciaExpressionPrivate ValenciaExpressionPrivate;
typedef struct _ValenciaMethodCallPrivate ValenciaMethodCallPrivate;

#define VALENCIA_TYPE_ID (valencia_id_get_type ())
#define VALENCIA_ID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ID, ValenciaId))
#define VALENCIA_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ID, ValenciaIdClass))
#define VALENCIA_IS_ID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ID))
#define VALENCIA_IS_ID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ID))
#define VALENCIA_ID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ID, ValenciaIdClass))

typedef struct _ValenciaId ValenciaId;
typedef struct _ValenciaIdClass ValenciaIdClass;
typedef struct _ValenciaIdPrivate ValenciaIdPrivate;

#define VALENCIA_TYPE_NEW (valencia_new_get_type ())
#define VALENCIA_NEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_NEW, ValenciaNew))
#define VALENCIA_NEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_NEW, ValenciaNewClass))
#define VALENCIA_IS_NEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_NEW))
#define VALENCIA_IS_NEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_NEW))
#define VALENCIA_NEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_NEW, ValenciaNewClass))

typedef struct _ValenciaNew ValenciaNew;
typedef struct _ValenciaNewClass ValenciaNewClass;
typedef struct _ValenciaNewPrivate ValenciaNewPrivate;

#define VALENCIA_TYPE_COMPOUND_EXPRESSION (valencia_compound_expression_get_type ())
#define VALENCIA_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpression))
#define VALENCIA_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))
#define VALENCIA_IS_COMPOUND_EXPRESSION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_IS_COMPOUND_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_COMPOUND_EXPRESSION))
#define VALENCIA_COMPOUND_EXPRESSION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_COMPOUND_EXPRESSION, ValenciaCompoundExpressionClass))

typedef struct _ValenciaCompoundExpression ValenciaCompoundExpression;
typedef struct _ValenciaCompoundExpressionClass ValenciaCompoundExpressionClass;
typedef struct _ValenciaCompoundExpressionPrivate ValenciaCompoundExpressionPrivate;

#define VALENCIA_TYPE_ERROR_INFO (valencia_error_info_get_type ())
#define VALENCIA_ERROR_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ERROR_INFO, ValenciaErrorInfo))
#define VALENCIA_ERROR_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ERROR_INFO, ValenciaErrorInfoClass))
#define VALENCIA_IS_ERROR_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ERROR_INFO))
#define VALENCIA_IS_ERROR_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ERROR_INFO))
#define VALENCIA_ERROR_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ERROR_INFO, ValenciaErrorInfoClass))

typedef struct _ValenciaErrorInfo ValenciaErrorInfo;
typedef struct _ValenciaErrorInfoClass ValenciaErrorInfoClass;
typedef struct _ValenciaErrorInfoPrivate ValenciaErrorInfoPrivate;

#define VALENCIA_TYPE_ERROR_PAIR (valencia_error_pair_get_type ())
#define VALENCIA_ERROR_PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ERROR_PAIR, ValenciaErrorPair))
#define VALENCIA_ERROR_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ERROR_PAIR, ValenciaErrorPairClass))
#define VALENCIA_IS_ERROR_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ERROR_PAIR))
#define VALENCIA_IS_ERROR_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ERROR_PAIR))
#define VALENCIA_ERROR_PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ERROR_PAIR, ValenciaErrorPairClass))

typedef struct _ValenciaErrorPair ValenciaErrorPair;
typedef struct _ValenciaErrorPairClass ValenciaErrorPairClass;
typedef struct _ValenciaErrorPairPrivate ValenciaErrorPairPrivate;

#define VALENCIA_TYPE_ERROR_LIST (valencia_error_list_get_type ())
#define VALENCIA_ERROR_LIST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_ERROR_LIST, ValenciaErrorList))
#define VALENCIA_ERROR_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_ERROR_LIST, ValenciaErrorListClass))
#define VALENCIA_IS_ERROR_LIST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_ERROR_LIST))
#define VALENCIA_IS_ERROR_LIST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_ERROR_LIST))
#define VALENCIA_ERROR_LIST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_ERROR_LIST, ValenciaErrorListClass))

typedef struct _ValenciaErrorList ValenciaErrorList;
typedef struct _ValenciaErrorListClass ValenciaErrorListClass;
typedef struct _ValenciaErrorListPrivate ValenciaErrorListPrivate;

#define VALENCIA_TYPE_MAKEFILE (valencia_makefile_get_type ())
#define VALENCIA_MAKEFILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_MAKEFILE, ValenciaMakefile))
#define VALENCIA_MAKEFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_MAKEFILE, ValenciaMakefileClass))
#define VALENCIA_IS_MAKEFILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_MAKEFILE))
#define VALENCIA_IS_MAKEFILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_MAKEFILE))
#define VALENCIA_MAKEFILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_MAKEFILE, ValenciaMakefileClass))

typedef struct _ValenciaMakefile ValenciaMakefile;
typedef struct _ValenciaMakefileClass ValenciaMakefileClass;
typedef struct _ValenciaMakefilePrivate ValenciaMakefilePrivate;

#define VALENCIA_TYPE_CONFIGURATION_FILE (valencia_configuration_file_get_type ())
#define VALENCIA_CONFIGURATION_FILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_CONFIGURATION_FILE, ValenciaConfigurationFile))
#define VALENCIA_CONFIGURATION_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_CONFIGURATION_FILE, ValenciaConfigurationFileClass))
#define VALENCIA_IS_CONFIGURATION_FILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_CONFIGURATION_FILE))
#define VALENCIA_IS_CONFIGURATION_FILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_CONFIGURATION_FILE))
#define VALENCIA_CONFIGURATION_FILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_CONFIGURATION_FILE, ValenciaConfigurationFileClass))

typedef struct _ValenciaConfigurationFile ValenciaConfigurationFile;
typedef struct _ValenciaConfigurationFileClass ValenciaConfigurationFileClass;
typedef struct _ValenciaConfigurationFilePrivate ValenciaConfigurationFilePrivate;

#define VALENCIA_CONFIGURATION_FILE_TYPE_MATCH_VALUE (valencia_configuration_file_match_value_get_type ())
typedef struct _ValenciaProgramPrivate ValenciaProgramPrivate;

#define VALENCIA_TYPE_PARSER (valencia_parser_get_type ())
#define VALENCIA_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALENCIA_TYPE_PARSER, ValenciaParser))
#define VALENCIA_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALENCIA_TYPE_PARSER, ValenciaParserClass))
#define VALENCIA_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALENCIA_TYPE_PARSER))
#define VALENCIA_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALENCIA_TYPE_PARSER))
#define VALENCIA_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALENCIA_TYPE_PARSER, ValenciaParserClass))

typedef struct _ValenciaParser ValenciaParser;
typedef struct _ValenciaParserClass ValenciaParserClass;

struct _ValenciaSymbolSet {
	GObject parent_instance;
	ValenciaSymbolSetPrivate * priv;
};

struct _ValenciaSymbolSetClass {
	GObjectClass parent_class;
};

struct _ValenciaSymbolSetPrivate {
	GeeHashSet* symbols;
	char* name;
	gboolean exact;
	gboolean type;
	gboolean constructor;
	gboolean local_symbols;
};

struct _ValenciaNode {
	GObject parent_instance;
	ValenciaNodePrivate * priv;
	gint start;
	gint end;
};

struct _ValenciaNodeClass {
	GObjectClass parent_class;
	GeeArrayList* (*children) (ValenciaNode* self);
	void (*print) (ValenciaNode* self, gint level);
};

struct _ValenciaSymbol {
	ValenciaNode parent_instance;
	ValenciaSymbolPrivate * priv;
	ValenciaSourceFile* source;
	char* name;
};

struct _ValenciaSymbolClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaTypeSymbol {
	ValenciaSymbol parent_instance;
	ValenciaTypeSymbolPrivate * priv;
};

struct _ValenciaTypeSymbolClass {
	ValenciaSymbolClass parent_class;
};

struct _ValenciaScopeIface {
	GTypeInterface parent_iface;
	gboolean (*lookup) (ValenciaScope* self, ValenciaSymbolSet* symbols, gint pos);
};

/* a class, struct, interface or enum*/
struct _ValenciaClass {
	ValenciaTypeSymbol parent_instance;
	ValenciaClassPrivate * priv;
	GeeArrayList* super;
	GeeArrayList* members;
};

struct _ValenciaClassClass {
	ValenciaTypeSymbolClass parent_class;
};

struct _ValenciaMethod {
	ValenciaSymbol parent_instance;
	ValenciaMethodPrivate * priv;
	GeeArrayList* parameters;
	ValenciaExpression* return_type;
	ValenciaBlock* body;
};

struct _ValenciaMethodClass {
	ValenciaSymbolClass parent_class;
	void (*print_type) (ValenciaMethod* self, gint level);
};

struct _ValenciaConstructor {
	ValenciaMethod parent_instance;
	ValenciaConstructorPrivate * priv;
	ValenciaClass* parent;
};

struct _ValenciaConstructorClass {
	ValenciaMethodClass parent_class;
};

struct _ValenciaStatement {
	ValenciaNode parent_instance;
	ValenciaStatementPrivate * priv;
};

struct _ValenciaStatementClass {
	ValenciaNodeClass parent_class;
	gboolean (*defines_symbol) (ValenciaStatement* self, ValenciaSymbolSet* symbols);
};

struct _ValenciaVariable {
	ValenciaSymbol parent_instance;
	ValenciaVariablePrivate * priv;
	ValenciaExpression* type;
};

struct _ValenciaVariableClass {
	ValenciaSymbolClass parent_class;
	char* (*kind) (ValenciaVariable* self);
};

struct _ValenciaLocalVariable {
	ValenciaVariable parent_instance;
	ValenciaLocalVariablePrivate * priv;
};

struct _ValenciaLocalVariableClass {
	ValenciaVariableClass parent_class;
};

struct _ValenciaDeclarationStatement {
	ValenciaStatement parent_instance;
	ValenciaDeclarationStatementPrivate * priv;
	GeeArrayList* variables;
};

struct _ValenciaDeclarationStatementClass {
	ValenciaStatementClass parent_class;
};

/* The For class will handle both for and foreach statements*/
struct _ValenciaFor {
	ValenciaStatement parent_instance;
	ValenciaForPrivate * priv;
	ValenciaDeclarationStatement* declaration;
	ValenciaStatement* statement;
};

struct _ValenciaForClass {
	ValenciaStatementClass parent_class;
};

struct _ValenciaChain {
	GObject parent_instance;
	ValenciaChainPrivate * priv;
};

struct _ValenciaChainClass {
	GObjectClass parent_class;
};

struct _ValenciaChainPrivate {
	ValenciaScope* scope;
	ValenciaChain* parent;
};

struct _ValenciaBlock {
	ValenciaStatement parent_instance;
	ValenciaBlockPrivate * priv;
	GeeArrayList* statements;
};

struct _ValenciaBlockClass {
	ValenciaStatementClass parent_class;
};

struct _ValenciaParameter {
	ValenciaVariable parent_instance;
	ValenciaParameterPrivate * priv;
};

struct _ValenciaParameterClass {
	ValenciaVariableClass parent_class;
};

/* a construct block*/
struct _ValenciaConstruct {
	ValenciaNode parent_instance;
	ValenciaConstructPrivate * priv;
	ValenciaBlock* body;
};

struct _ValenciaConstructClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaMethodPrivate {
	char* prototype;
};

/* We use the name "VSignal" to avoid a name conflict with GLib.Signal.*/
struct _ValenciaVSignal {
	ValenciaMethod parent_instance;
	ValenciaVSignalPrivate * priv;
};

struct _ValenciaVSignalClass {
	ValenciaMethodClass parent_class;
};

struct _ValenciaDelegate {
	ValenciaMethod parent_instance;
	ValenciaDelegatePrivate * priv;
};

struct _ValenciaDelegateClass {
	ValenciaMethodClass parent_class;
};

struct _ValenciaField {
	ValenciaVariable parent_instance;
	ValenciaFieldPrivate * priv;
};

struct _ValenciaFieldClass {
	ValenciaVariableClass parent_class;
};

struct _ValenciaProperty {
	ValenciaVariable parent_instance;
	ValenciaPropertyPrivate * priv;
	ValenciaBlock* body;
};

struct _ValenciaPropertyClass {
	ValenciaVariableClass parent_class;
};

struct _ValenciaClassPrivate {
	ValenciaClass* enclosing_class;
};

struct _ValenciaInterface {
	ValenciaClass parent_instance;
	ValenciaInterfacePrivate * priv;
};

struct _ValenciaInterfaceClass {
	ValenciaClassClass parent_class;
};

/* A Namespace is a TypeSymbol since namespaces can be used in type names.*/
struct _ValenciaNamespace {
	ValenciaTypeSymbol parent_instance;
	ValenciaNamespacePrivate * priv;
	char* full_name;
	GeeArrayList* symbols;
};

struct _ValenciaNamespaceClass {
	ValenciaTypeSymbolClass parent_class;
};

struct _ValenciaSourceFile {
	ValenciaNode parent_instance;
	ValenciaSourceFilePrivate * priv;
	ValenciaProgram* program;
	char* filename;
	GeeArrayList* namespaces;
	ValenciaNamespace* top;
};

struct _ValenciaSourceFileClass {
	ValenciaNodeClass parent_class;
};

struct _ValenciaSourceFilePrivate {
	GeeArrayList* using_namespaces;
};

struct _ValenciaExpression {
	GObject parent_instance;
	ValenciaExpressionPrivate * priv;
};

struct _ValenciaExpressionClass {
	GObjectClass parent_class;
	char* (*to_string) (ValenciaExpression* self);
};

struct _ValenciaMethodCall {
	ValenciaExpression parent_instance;
	ValenciaMethodCallPrivate * priv;
	ValenciaExpression* method;
};

struct _ValenciaMethodCallClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaId {
	ValenciaExpression parent_instance;
	ValenciaIdPrivate * priv;
	char* name;
};

struct _ValenciaIdClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaNew {
	ValenciaExpression parent_instance;
	ValenciaNewPrivate * priv;
	ValenciaExpression* class_name;
};

struct _ValenciaNewClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaCompoundExpression {
	ValenciaExpression parent_instance;
	ValenciaCompoundExpressionPrivate * priv;
	ValenciaExpression* left;
	char* right;
};

struct _ValenciaCompoundExpressionClass {
	ValenciaExpressionClass parent_class;
};

struct _ValenciaErrorInfo {
	GObject parent_instance;
	ValenciaErrorInfoPrivate * priv;
	char* filename;
	char* start_line;
	char* start_char;
	char* end_line;
	char* end_char;
};

struct _ValenciaErrorInfoClass {
	GObjectClass parent_class;
};

struct _ValenciaErrorPair {
	GObject parent_instance;
	ValenciaErrorPairPrivate * priv;
	GtkTextMark* document_pane_error;
	GtkTextMark* build_pane_error;
	ValenciaErrorInfo* error_info;
};

struct _ValenciaErrorPairClass {
	GObjectClass parent_class;
};

struct _ValenciaErrorList {
	GObject parent_instance;
	ValenciaErrorListPrivate * priv;
	GeeArrayList* errors;
	gint error_index;
};

struct _ValenciaErrorListClass {
	GObjectClass parent_class;
};

struct _ValenciaMakefile {
	GObject parent_instance;
	ValenciaMakefilePrivate * priv;
	char* path;
	char* relative_binary_run_path;
};

struct _ValenciaMakefileClass {
	GObjectClass parent_class;
};

struct _ValenciaConfigurationFile {
	GObject parent_instance;
	ValenciaConfigurationFilePrivate * priv;
};

struct _ValenciaConfigurationFileClass {
	GObjectClass parent_class;
};

struct _ValenciaConfigurationFilePrivate {
	ValenciaProgram* parent_program;
	char* build_command;
	char* clean_command;
};

typedef enum  {
	VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_MATCHED,
	VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_UNMATCHED,
	VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_ERROR
} ValenciaConfigurationFileMatchValue;

struct _ValenciaProgram {
	GObject parent_instance;
	ValenciaProgramPrivate * priv;
	ValenciaErrorList* error_list;
	ValenciaConfigurationFile* config_file;
};

struct _ValenciaProgramClass {
	GObjectClass parent_class;
};

struct _ValenciaProgramPrivate {
	char* top_directory;
	gint total_filesize;
	gint parse_list_index;
	GeeArrayList* sourcefile_paths;
	gboolean parsing;
	GeeArrayList* sources;
	ValenciaMakefile* makefile;
	gboolean recursive_project;
};


static gpointer valencia_symbol_set_parent_class = NULL;
static gpointer valencia_node_parent_class = NULL;
static gpointer valencia_symbol_parent_class = NULL;
static gpointer valencia_typesymbol_parent_class = NULL;
static gpointer valencia_statement_parent_class = NULL;
static gpointer valencia_variable_parent_class = NULL;
static gpointer valencia_local_variable_parent_class = NULL;
static gpointer valencia_declaration_statement_parent_class = NULL;
static gpointer valencia_for_parent_class = NULL;
static ValenciaScopeIface* valencia_for_valencia_scope_parent_iface = NULL;
static gpointer valencia_chain_parent_class = NULL;
static gpointer valencia_block_parent_class = NULL;
static ValenciaScopeIface* valencia_block_valencia_scope_parent_iface = NULL;
static gpointer valencia_parameter_parent_class = NULL;
static gpointer valencia_construct_parent_class = NULL;
static gpointer valencia_method_parent_class = NULL;
static ValenciaScopeIface* valencia_method_valencia_scope_parent_iface = NULL;
static gpointer valencia_vsignal_parent_class = NULL;
static gpointer valencia_delegate_parent_class = NULL;
static gpointer valencia_constructor_parent_class = NULL;
static gpointer valencia_field_parent_class = NULL;
static gpointer valencia_property_parent_class = NULL;
static gpointer valencia_class_parent_class = NULL;
static ValenciaScopeIface* valencia_class_valencia_scope_parent_iface = NULL;
static gpointer valencia_interface_parent_class = NULL;
static gpointer valencia_namespace_parent_class = NULL;
static ValenciaScopeIface* valencia_namespace_valencia_scope_parent_iface = NULL;
static gpointer valencia_source_file_parent_class = NULL;
static ValenciaScopeIface* valencia_source_file_valencia_scope_parent_iface = NULL;
static gpointer valencia_error_info_parent_class = NULL;
static gpointer valencia_error_pair_parent_class = NULL;
static gpointer valencia_error_list_parent_class = NULL;
static gpointer valencia_makefile_parent_class = NULL;
static gpointer valencia_configuration_file_parent_class = NULL;
static GeeArrayList* valencia_program_system_sources;
static GeeArrayList* valencia_program_system_sources = NULL;
static GeeArrayList* valencia_program_programs;
static GeeArrayList* valencia_program_programs = NULL;
static gpointer valencia_program_parent_class = NULL;

GType valencia_symbol_set_get_type (void);
GType valencia_node_get_type (void);
GType valencia_symbol_get_type (void);
#define VALENCIA_SYMBOL_SET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_SYMBOL_SET, ValenciaSymbolSetPrivate))
enum  {
	VALENCIA_SYMBOL_SET_DUMMY_PROPERTY
};
guint valencia_symbol_hash (void* item);
static guint _valencia_symbol_hash_ghash_func (void* key);
gboolean valencia_symbol_equal (void* a, void* b);
static gboolean _valencia_symbol_equal_gequal_func (void* a, void* b);
ValenciaSymbolSet* valencia_symbol_set_new (const char* name, gboolean type, gboolean exact, gboolean constructor, gboolean local_symbols);
ValenciaSymbolSet* valencia_symbol_set_construct (GType object_type, const char* name, gboolean type, gboolean exact, gboolean constructor, gboolean local_symbols);
ValenciaSymbolSet* valencia_symbol_set_new_empty (void);
ValenciaSymbolSet* valencia_symbol_set_construct_empty (GType object_type);
GType valencia_typesymbol_get_type (void);
GType valencia_class_get_type (void);
ValenciaSymbol* valencia_class_lookup_constructor (ValenciaClass* self);
GType valencia_source_file_get_type (void);
GType valencia_scope_get_type (void);
GType valencia_expression_get_type (void);
static void valencia_symbol_set_add_constructor (ValenciaSymbolSet* self, ValenciaSymbol* sym);
GType valencia_method_get_type (void);
GType valencia_constructor_get_type (void);
gboolean valencia_symbol_set_add (ValenciaSymbolSet* self, ValenciaSymbol* sym);
ValenciaSymbol* valencia_symbol_set_first (ValenciaSymbolSet* self);
GeeHashSet* valencia_symbol_set_get_symbols (ValenciaSymbolSet* self);
char* valencia_symbol_set_get_name (ValenciaSymbolSet* self);
ValenciaSymbol* valencia_symbol_set_get_symbol (ValenciaSymbolSet* self, const char* name);
gboolean valencia_symbol_set_local_symbols_only (ValenciaSymbolSet* self);
static void valencia_symbol_set_finalize (GObject* obj);
enum  {
	VALENCIA_NODE_DUMMY_PROPERTY
};
static ValenciaNode* valencia_node_new (gint start, gint end);
static ValenciaNode* valencia_node_construct (GType object_type, gint start, gint end);
GeeArrayList* valencia_node_children (ValenciaNode* self);
static GeeArrayList* valencia_node_real_children (ValenciaNode* self);
GeeArrayList* valencia_node_single_node (ValenciaNode* n);
GType valencia_chain_get_type (void);
ValenciaChain* valencia_chain_new (ValenciaScope* scope, ValenciaChain* parent);
ValenciaChain* valencia_chain_construct (GType object_type, ValenciaScope* scope, ValenciaChain* parent);
ValenciaChain* valencia_node_find (ValenciaNode* self, ValenciaChain* parent, gint pos);
gboolean valencia_node_lookup_in_array (GeeArrayList* a, ValenciaSymbolSet* symbols);
void valencia_node_print (ValenciaNode* self, gint level);
static void valencia_node_real_print (ValenciaNode* self, gint level);
void valencia_node_do_print (ValenciaNode* self, gint level, const char* s);
static void valencia_node_finalize (GObject* obj);
enum  {
	VALENCIA_SYMBOL_DUMMY_PROPERTY
};
ValenciaSymbol* valencia_symbol_new (const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaSymbol* valencia_symbol_construct (GType object_type, const char* name, ValenciaSourceFile* source, gint start, gint end);
void valencia_symbol_print_name (ValenciaSymbol* self, gint level, const char* s);
GType valencia_variable_get_type (void);
GType valencia_parameter_get_type (void);
GType valencia_statement_get_type (void);
GType valencia_block_get_type (void);
gint valencia_symbol_name_length (ValenciaSymbol* self);
static void valencia_symbol_finalize (GObject* obj);
gboolean valencia_scope_lookup (ValenciaScope* self, ValenciaSymbolSet* symbols, gint pos);
enum  {
	VALENCIA_TYPESYMBOL_DUMMY_PROPERTY
};
ValenciaTypeSymbol* valencia_typesymbol_new (const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaTypeSymbol* valencia_typesymbol_construct (GType object_type, const char* name, ValenciaSourceFile* source, gint start, gint end);
enum  {
	VALENCIA_STATEMENT_DUMMY_PROPERTY
};
ValenciaStatement* valencia_statement_new (gint start, gint end);
ValenciaStatement* valencia_statement_construct (GType object_type, gint start, gint end);
gboolean valencia_statement_defines_symbol (ValenciaStatement* self, ValenciaSymbolSet* symbols);
static gboolean valencia_statement_real_defines_symbol (ValenciaStatement* self, ValenciaSymbolSet* symbols);
enum  {
	VALENCIA_VARIABLE_DUMMY_PROPERTY
};
ValenciaVariable* valencia_variable_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaVariable* valencia_variable_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
char* valencia_variable_kind (ValenciaVariable* self);
static char* valencia_variable_real_kind (ValenciaVariable* self);
char* valencia_expression_to_string (ValenciaExpression* self);
static void valencia_variable_real_print (ValenciaNode* base, gint level);
static void valencia_variable_finalize (GObject* obj);
GType valencia_local_variable_get_type (void);
enum  {
	VALENCIA_LOCAL_VARIABLE_DUMMY_PROPERTY
};
ValenciaLocalVariable* valencia_local_variable_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaLocalVariable* valencia_local_variable_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
static char* valencia_local_variable_real_kind (ValenciaVariable* base);
GType valencia_declaration_statement_get_type (void);
enum  {
	VALENCIA_DECLARATION_STATEMENT_DUMMY_PROPERTY
};
ValenciaDeclarationStatement* valencia_declaration_statement_new (GeeArrayList* variables, gint start, gint end);
ValenciaDeclarationStatement* valencia_declaration_statement_construct (GType object_type, GeeArrayList* variables, gint start, gint end);
static gboolean valencia_declaration_statement_real_defines_symbol (ValenciaStatement* base, ValenciaSymbolSet* symbols);
static void valencia_declaration_statement_real_print (ValenciaNode* base, gint level);
static void valencia_declaration_statement_finalize (GObject* obj);
GType valencia_for_get_type (void);
enum  {
	VALENCIA_FOR_DUMMY_PROPERTY
};
ValenciaFor* valencia_for_new (ValenciaDeclarationStatement* declaration, ValenciaStatement* statement, gint start, gint end);
ValenciaFor* valencia_for_construct (GType object_type, ValenciaDeclarationStatement* declaration, ValenciaStatement* statement, gint start, gint end);
static GeeArrayList* valencia_for_real_children (ValenciaNode* base);
static gboolean valencia_for_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos);
static void valencia_for_real_print (ValenciaNode* base, gint level);
static void valencia_for_finalize (GObject* obj);
#define VALENCIA_CHAIN_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_CHAIN, ValenciaChainPrivate))
enum  {
	VALENCIA_CHAIN_DUMMY_PROPERTY
};
void valencia_chain_lookup (ValenciaChain* self, ValenciaSymbolSet* symbols, gint pos);
ValenciaSymbol* valencia_chain_lookup_this (ValenciaChain* self);
ValenciaSymbol* valencia_source_file_resolve_type (ValenciaSourceFile* self, ValenciaExpression* type, gint pos);
GType valencia_interface_get_type (void);
ValenciaSymbol* valencia_chain_lookup_base (ValenciaChain* self, ValenciaSourceFile* sf);
static void valencia_chain_finalize (GObject* obj);
enum  {
	VALENCIA_BLOCK_DUMMY_PROPERTY
};
static GeeArrayList* valencia_block_real_children (ValenciaNode* base);
static gboolean valencia_block_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos);
static void valencia_block_real_print (ValenciaNode* base, gint level);
ValenciaBlock* valencia_block_new (void);
ValenciaBlock* valencia_block_construct (GType object_type);
static void valencia_block_finalize (GObject* obj);
enum  {
	VALENCIA_PARAMETER_DUMMY_PROPERTY
};
ValenciaParameter* valencia_parameter_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaParameter* valencia_parameter_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
static char* valencia_parameter_real_kind (ValenciaVariable* base);
GType valencia_construct_get_type (void);
enum  {
	VALENCIA_CONSTRUCT_DUMMY_PROPERTY
};
ValenciaConstruct* valencia_construct_new (ValenciaBlock* body, gint start, gint end);
ValenciaConstruct* valencia_construct_construct (GType object_type, ValenciaBlock* body, gint start, gint end);
static GeeArrayList* valencia_construct_real_children (ValenciaNode* base);
static void valencia_construct_real_print (ValenciaNode* base, gint level);
static void valencia_construct_finalize (GObject* obj);
#define VALENCIA_METHOD_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_METHOD, ValenciaMethodPrivate))
enum  {
	VALENCIA_METHOD_DUMMY_PROPERTY
};
ValenciaMethod* valencia_method_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaMethod* valencia_method_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
static GeeArrayList* valencia_method_real_children (ValenciaNode* base);
static gboolean valencia_method_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos);
void valencia_method_print_type (ValenciaMethod* self, gint level);
static void valencia_method_real_print_type (ValenciaMethod* self, gint level);
static void valencia_method_real_print (ValenciaNode* base, gint level);
void valencia_method_update_prototype (ValenciaMethod* self, const char* proto);
char* valencia_method_to_string (ValenciaMethod* self);
static void valencia_method_finalize (GObject* obj);
GType valencia_vsignal_get_type (void);
enum  {
	VALENCIA_VSIGNAL_DUMMY_PROPERTY
};
ValenciaVSignal* valencia_vsignal_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaVSignal* valencia_vsignal_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
GType valencia_delegate_get_type (void);
enum  {
	VALENCIA_DELEGATE_DUMMY_PROPERTY
};
ValenciaDelegate* valencia_delegate_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
ValenciaDelegate* valencia_delegate_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source);
enum  {
	VALENCIA_CONSTRUCTOR_DUMMY_PROPERTY
};
ValenciaConstructor* valencia_constructor_new (const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source);
ValenciaConstructor* valencia_constructor_construct (GType object_type, const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source);
static void valencia_constructor_real_print_type (ValenciaMethod* base, gint level);
static void valencia_constructor_finalize (GObject* obj);
GType valencia_field_get_type (void);
enum  {
	VALENCIA_FIELD_DUMMY_PROPERTY
};
ValenciaField* valencia_field_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaField* valencia_field_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
static char* valencia_field_real_kind (ValenciaVariable* base);
GType valencia_property_get_type (void);
enum  {
	VALENCIA_PROPERTY_DUMMY_PROPERTY
};
ValenciaProperty* valencia_property_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
ValenciaProperty* valencia_property_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end);
static GeeArrayList* valencia_property_real_children (ValenciaNode* base);
static char* valencia_property_real_kind (ValenciaVariable* base);
static void valencia_property_real_print (ValenciaNode* base, gint level);
static void valencia_property_finalize (GObject* obj);
#define VALENCIA_CLASS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_CLASS, ValenciaClassPrivate))
enum  {
	VALENCIA_CLASS_DUMMY_PROPERTY
};
ValenciaClass* valencia_class_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
ValenciaClass* valencia_class_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
static GeeArrayList* valencia_class_real_children (ValenciaNode* base);
static gboolean valencia_class_lookup1 (ValenciaClass* self, ValenciaSymbolSet* symbols, GeeHashSet* seen);
static gboolean valencia_class_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos);
static void valencia_class_real_print (ValenciaNode* base, gint level);
char* valencia_class_to_string (ValenciaClass* self);
static void valencia_class_finalize (GObject* obj);
enum  {
	VALENCIA_INTERFACE_DUMMY_PROPERTY
};
ValenciaInterface* valencia_interface_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
ValenciaInterface* valencia_interface_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class);
GType valencia_namespace_get_type (void);
enum  {
	VALENCIA_NAMESPACE_DUMMY_PROPERTY
};
ValenciaNamespace* valencia_namespace_new (const char* name, const char* full_name, ValenciaSourceFile* source);
ValenciaNamespace* valencia_namespace_construct (GType object_type, const char* name, const char* full_name, ValenciaSourceFile* source);
static GeeArrayList* valencia_namespace_real_children (ValenciaNode* base);
GType valencia_program_get_type (void);
gboolean valencia_program_lookup_in_namespace (ValenciaProgram* self, const char* namespace_name, ValenciaSymbolSet* symbols);
static gboolean valencia_namespace_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos);
gboolean valencia_namespace_lookup1 (ValenciaNamespace* self, ValenciaSymbolSet* symbols);
void valencia_namespace_lookup_all_toplevel_symbols (ValenciaNamespace* self, ValenciaSymbolSet* symbols);
static void valencia_namespace_real_print (ValenciaNode* base, gint level);
static void valencia_namespace_finalize (GObject* obj);
#define VALENCIA_SOURCE_FILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_SOURCE_FILE, ValenciaSourceFilePrivate))
enum  {
	VALENCIA_SOURCE_FILE_DUMMY_PROPERTY
};
static void valencia_source_file_alloc_top (ValenciaSourceFile* self);
ValenciaSourceFile* valencia_source_file_new (ValenciaProgram* program, const char* filename);
ValenciaSourceFile* valencia_source_file_construct (GType object_type, ValenciaProgram* program, const char* filename);
void valencia_source_file_clear (ValenciaSourceFile* self);
static GeeArrayList* valencia_source_file_real_children (ValenciaNode* base);
void valencia_source_file_add_using_namespace (ValenciaSourceFile* self, const char* name);
static gboolean valencia_source_file_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos);
gboolean valencia_source_file_lookup_in_namespace (ValenciaSourceFile* self, const char* namespace_name, ValenciaSymbolSet* symbols);
GType valencia_this_get_type (void);
GType valencia_base_get_type (void);
GType valencia_method_call_get_type (void);
ValenciaSymbolSet* valencia_source_file_resolve1 (ValenciaSourceFile* self, ValenciaExpression* name, ValenciaChain* chain, gint pos, gboolean find_type, gboolean exact, gboolean constructor, gboolean local_symbols);
GType valencia_id_get_type (void);
GType valencia_new_get_type (void);
ValenciaSymbolSet* valencia_source_file_resolve_non_compound (ValenciaSourceFile* self, ValenciaExpression* name, ValenciaChain* chain, gint pos, gboolean find_type, gboolean exact, gboolean constructor, gboolean local_symbols);
GType valencia_compound_expression_get_type (void);
ValenciaSymbol* valencia_source_file_resolve (ValenciaSourceFile* self, ValenciaExpression* name, gint pos, gboolean constructor);
ValenciaSymbolSet* valencia_source_file_resolve_prefix (ValenciaSourceFile* self, ValenciaExpression* prefix, gint pos, gboolean constructor);
ValenciaSymbolSet* valencia_source_file_resolve_all_locals (ValenciaSourceFile* self, ValenciaExpression* prefix, gint pos);
ValenciaSymbol* valencia_source_file_resolve_local (ValenciaSourceFile* self, ValenciaExpression* name, gint pos);
static void valencia_source_file_real_print (ValenciaNode* base, gint level);
static void valencia_source_file_finalize (GObject* obj);
GType valencia_error_info_get_type (void);
enum  {
	VALENCIA_ERROR_INFO_DUMMY_PROPERTY
};
ValenciaErrorInfo* valencia_error_info_new (void);
ValenciaErrorInfo* valencia_error_info_construct (GType object_type);
static void valencia_error_info_finalize (GObject* obj);
GType valencia_error_pair_get_type (void);
enum  {
	VALENCIA_ERROR_PAIR_DUMMY_PROPERTY
};
ValenciaErrorPair* valencia_error_pair_new (GtkTextMark* document_err, GtkTextMark* build_err, ValenciaErrorInfo* err_info);
ValenciaErrorPair* valencia_error_pair_construct (GType object_type, GtkTextMark* document_err, GtkTextMark* build_err, ValenciaErrorInfo* err_info);
static void valencia_error_pair_finalize (GObject* obj);
GType valencia_error_list_get_type (void);
enum  {
	VALENCIA_ERROR_LIST_DUMMY_PROPERTY
};
ValenciaErrorList* valencia_error_list_new (void);
ValenciaErrorList* valencia_error_list_construct (GType object_type);
static void valencia_error_list_finalize (GObject* obj);
GType valencia_makefile_get_type (void);
enum  {
	VALENCIA_MAKEFILE_DUMMY_PROPERTY
};
static gboolean valencia_makefile_regex_parse (ValenciaMakefile* self, GDataInputStream* datastream);
gboolean valencia_makefile_parse (ValenciaMakefile* self, GFile* makefile);
void valencia_makefile_reparse (ValenciaMakefile* self);
void valencia_makefile_reset_paths (ValenciaMakefile* self);
ValenciaMakefile* valencia_makefile_new (void);
ValenciaMakefile* valencia_makefile_construct (GType object_type);
static void valencia_makefile_finalize (GObject* obj);
GType valencia_configuration_file_get_type (void);
#define VALENCIA_CONFIGURATION_FILE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_CONFIGURATION_FILE, ValenciaConfigurationFilePrivate))
enum  {
	VALENCIA_CONFIGURATION_FILE_DUMMY_PROPERTY
};
static GType valencia_configuration_file_match_value_get_type (void);
#define VALENCIA_CONFIGURATION_FILE_version_keyword "version"
#define VALENCIA_CONFIGURATION_FILE_version "1"
#define VALENCIA_CONFIGURATION_FILE_build_command_keyword "build_command"
#define VALENCIA_CONFIGURATION_FILE_clean_command_keyword "clean_command"
#define VALENCIA_CONFIGURATION_FILE_default_build_command "make"
#define VALENCIA_CONFIGURATION_FILE_default_clean_command "make clean"
ValenciaConfigurationFile* valencia_configuration_file_new (ValenciaProgram* parent_program);
ValenciaConfigurationFile* valencia_configuration_file_construct (GType object_type, ValenciaProgram* parent_program);
char* valencia_program_get_top_directory (ValenciaProgram* self);
static char* valencia_configuration_file_get_file_path (ValenciaConfigurationFile* self);
static void valencia_configuration_file_load (ValenciaConfigurationFile* self);
char* valencia_configuration_file_get_build_command (ValenciaConfigurationFile* self);
char* valencia_configuration_file_get_clean_command (ValenciaConfigurationFile* self);
void valencia_configuration_file_update (ValenciaConfigurationFile* self, const char* new_build_command, const char* new_clean_command);
void valencia_configuration_file_update_location (ValenciaConfigurationFile* self, const char* old_directory);
static void valencia_configuration_file_finalize (GObject* obj);
#define VALENCIA_PROGRAM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALENCIA_TYPE_PROGRAM, ValenciaProgramPrivate))
enum  {
	VALENCIA_PROGRAM_DUMMY_PROPERTY
};
static gboolean valencia_program_get_build_root_directory (ValenciaProgram* self, GFile* makefile_dir);
static gboolean valencia_program_parse_local_vala_files_idle_callback (ValenciaProgram* self);
static gboolean _valencia_program_parse_local_vala_files_idle_callback_gsource_func (gpointer self);
static ValenciaProgram* valencia_program_new (const char* directory);
static ValenciaProgram* valencia_program_construct (GType object_type, const char* directory);
static gboolean valencia_program_configure_exists_in_directory (ValenciaProgram* self, GFile* configure_dir);
static gboolean valencia_program_goto_parent_directory (ValenciaProgram* self, GFile* base_directory);
static void valencia_program_set_paths (ValenciaProgram* self, GFile* makefile_file);
static char* valencia_program_get_system_vapi_directory (ValenciaProgram* self);
static void valencia_program_finish_local_parse (ValenciaProgram* self);
gboolean dir_has_parent (const char* dir, const char* parent);
static gint valencia_program_cache_source_paths_in_directory (ValenciaProgram* self, const char* directory, gboolean recursive);
static gboolean valencia_program_parse_vala_file (ValenciaProgram* self, GeeArrayList* source_list);
static void valencia_program_sort_system_files (ValenciaProgram* self);
static gboolean valencia_program_parse_system_vala_files_idle_callback (ValenciaProgram* self);
ValenciaParser* valencia_parser_new (void);
ValenciaParser* valencia_parser_construct (GType object_type);
GType valencia_parser_get_type (void);
void valencia_parser_parse (ValenciaParser* self, ValenciaSourceFile* source, const char* input);
gboolean valencia_program_is_vala (const char* filename);
gboolean valencia_program_is_parsing (ValenciaProgram* self);
static void valencia_program_parse_system_vapi_files (ValenciaProgram* self);
static void _valencia_program_parse_system_vapi_files_valencia_program_local_parse_complete (ValenciaProgram* _sender, gpointer self);
static gboolean _valencia_program_parse_system_vala_files_idle_callback_gsource_func (gpointer self);
gboolean valencia_program_lookup_in_namespace1 (ValenciaProgram* self, GeeArrayList* source_list, const char* namespace_name, ValenciaSymbolSet* symbols, gboolean vapi);
static ValenciaSourceFile* valencia_program_find_source1 (ValenciaProgram* self, const char* path, GeeArrayList* source_list);
ValenciaSourceFile* valencia_program_find_source (ValenciaProgram* self, const char* path);
static void valencia_program_update1 (ValenciaProgram* self, const char* path, const char* contents);
void valencia_program_update (ValenciaProgram* self, const char* path, const char* contents);
static ValenciaProgram* valencia_program_find_program (const char* dir);
ValenciaProgram* valencia_program_find_containing (const char* path, gboolean parse_system_vapi);
ValenciaProgram* valencia_program_null_find_containing (const char* path);
void valencia_program_update_any (const char* path, const char* contents);
void valencia_program_rescan_build_root (const char* sourcefile_path);
char* valencia_program_get_binary_run_path (ValenciaProgram* self);
gboolean valencia_program_get_binary_is_executable (ValenciaProgram* self);
void valencia_program_reparse_makefile (ValenciaProgram* self);
char* valencia_program_get_path_for_filename (ValenciaProgram* self, const char* filename);
static void valencia_program_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 200 "program.vala"
static guint _valencia_symbol_hash_ghash_func (void* key) {
#line 1246 "program.c"
	return valencia_symbol_hash (key);
}


#line 211 "program.vala"
static gboolean _valencia_symbol_equal_gequal_func (void* a, void* b) {
#line 1253 "program.c"
	return valencia_symbol_equal (a, b);
}


#line 19 "program.vala"
ValenciaSymbolSet* valencia_symbol_set_construct (GType object_type, const char* name, gboolean type, gboolean exact, gboolean constructor, gboolean local_symbols) {
#line 1260 "program.c"
	ValenciaSymbolSet * self;
	char* _tmp0_;
	char* _tmp5_;
	const char* _tmp4_;
#line 19 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1267 "program.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp0_ = NULL;
#line 20 "program.vala"
	if (exact) {
#line 1272 "program.c"
		char* _tmp2_;
		const char* _tmp1_;
		_tmp2_ = NULL;
#line 20 "program.vala"
		_tmp1_ = NULL;
#line 20 "program.vala"
		_tmp0_ = (_tmp2_ = (_tmp1_ = name, (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp2_);
#line 1280 "program.c"
	} else {
		char* _tmp3_;
		_tmp3_ = NULL;
#line 20 "program.vala"
		_tmp0_ = (_tmp3_ = g_utf8_strdown (name, -1), _tmp0_ = (g_free (_tmp0_), NULL), _tmp3_);
#line 1286 "program.c"
	}
	_tmp5_ = NULL;
#line 20 "program.vala"
	_tmp4_ = NULL;
#line 20 "program.vala"
	self->priv->name = (_tmp5_ = (_tmp4_ = _tmp0_, (_tmp4_ == NULL) ? NULL : g_strdup (_tmp4_)), self->priv->name = (g_free (self->priv->name), NULL), _tmp5_);
#line 21 "program.vala"
	self->priv->type = type;
#line 22 "program.vala"
	self->priv->exact = exact;
#line 23 "program.vala"
	self->priv->constructor = constructor;
#line 24 "program.vala"
	self->priv->local_symbols = local_symbols;
#line 28 "program.vala"
	gee_hash_set_set_hash_func (self->priv->symbols, _valencia_symbol_hash_ghash_func);
#line 29 "program.vala"
	gee_hash_set_set_equal_func (self->priv->symbols, _valencia_symbol_equal_gequal_func);
#line 1305 "program.c"
	_tmp0_ = (g_free (_tmp0_), NULL);
	return self;
}


#line 19 "program.vala"
ValenciaSymbolSet* valencia_symbol_set_new (const char* name, gboolean type, gboolean exact, gboolean constructor, gboolean local_symbols) {
#line 19 "program.vala"
	return valencia_symbol_set_construct (VALENCIA_TYPE_SYMBOL_SET, name, type, exact, constructor, local_symbols);
#line 1315 "program.c"
}


#line 32 "program.vala"
ValenciaSymbolSet* valencia_symbol_set_construct_empty (GType object_type) {
#line 1321 "program.c"
	ValenciaSymbolSet * self;
	char* _tmp0_;
	self = g_object_newv (object_type, 0, NULL);
	_tmp0_ = NULL;
#line 33 "program.vala"
	self->priv->name = (_tmp0_ = g_strdup (""), self->priv->name = (g_free (self->priv->name), NULL), _tmp0_);
#line 34 "program.vala"
	self->priv->type = FALSE;
#line 35 "program.vala"
	self->priv->exact = FALSE;
#line 36 "program.vala"
	self->priv->constructor = FALSE;
#line 37 "program.vala"
	self->priv->local_symbols = FALSE;
#line 1336 "program.c"
	return self;
}


#line 32 "program.vala"
ValenciaSymbolSet* valencia_symbol_set_new_empty (void) {
#line 32 "program.vala"
	return valencia_symbol_set_construct_empty (VALENCIA_TYPE_SYMBOL_SET);
#line 1345 "program.c"
}


#line 40 "program.vala"
static void valencia_symbol_set_add_constructor (ValenciaSymbolSet* self, ValenciaSymbol* sym) {
#line 1351 "program.c"
	ValenciaClass* _tmp1_;
	ValenciaSymbol* _tmp0_;
	ValenciaClass* c;
#line 40 "program.vala"
	g_return_if_fail (self != NULL);
#line 40 "program.vala"
	g_return_if_fail (sym != NULL);
#line 41 "program.vala"
	_tmp1_ = NULL;
#line 41 "program.vala"
	_tmp0_ = NULL;
#line 1363 "program.c"
	c = (_tmp1_ = (_tmp0_ = sym, VALENCIA_IS_CLASS (_tmp0_) ? ((ValenciaClass*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
#line 42 "program.vala"
	if (c != NULL) {
#line 43 "program.vala"
		if (self->priv->exact) {
#line 1369 "program.c"
			ValenciaSymbol* s;
			s = valencia_class_lookup_constructor (c);
#line 45 "program.vala"
			g_assert (s != NULL);
#line 46 "program.vala"
			gee_collection_add ((GeeCollection*) self->priv->symbols, s);
#line 1376 "program.c"
			(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
		} else {
			/* Recursively add subclass constructors to the set*/
			{
				GeeIterator* _n_it;
				/* Recursively add subclass constructors to the set*/
				_n_it = gee_iterable_iterator ((GeeIterable*) c->members);
				/* Recursively add subclass constructors to the set*/
#line 49 "program.vala"
				while (TRUE) {
#line 1387 "program.c"
					ValenciaNode* n;
					ValenciaClass* _tmp3_;
					ValenciaNode* _tmp2_;
					ValenciaClass* subclass;
					/* Recursively add subclass constructors to the set*/
#line 49 "program.vala"
					if (!gee_iterator_next (_n_it)) {
#line 1395 "program.c"
						/* Recursively add subclass constructors to the set*/
#line 49 "program.vala"
						break;
#line 1399 "program.c"
					}
					/* Recursively add subclass constructors to the set*/
					n = (ValenciaNode*) gee_iterator_get (_n_it);
#line 50 "program.vala"
					_tmp3_ = NULL;
#line 50 "program.vala"
					_tmp2_ = NULL;
#line 1407 "program.c"
					subclass = (_tmp3_ = (_tmp2_ = n, VALENCIA_IS_CLASS (_tmp2_) ? ((ValenciaClass*) _tmp2_) : NULL), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
#line 51 "program.vala"
					if (subclass != NULL) {
#line 52 "program.vala"
						valencia_symbol_set_add_constructor (self, (ValenciaSymbol*) subclass);
#line 1413 "program.c"
					} else {
#line 53 "program.vala"
						if (VALENCIA_IS_CONSTRUCTOR (n)) {
#line 54 "program.vala"
							gee_collection_add ((GeeCollection*) self->priv->symbols, VALENCIA_SYMBOL (n));
#line 1419 "program.c"
						}
					}
					(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
					(subclass == NULL) ? NULL : (subclass = (g_object_unref (subclass), NULL));
				}
				(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
			}
		}
	} else {
#line 58 "program.vala"
		if (VALENCIA_IS_CONSTRUCTOR (sym)) {
#line 59 "program.vala"
			gee_collection_add ((GeeCollection*) self->priv->symbols, sym);
#line 1433 "program.c"
		}
	}
	(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
}


#line 63 "program.vala"
gboolean valencia_symbol_set_add (ValenciaSymbolSet* self, ValenciaSymbol* sym) {
#line 1442 "program.c"
	gboolean result;
	gboolean _tmp2_;
#line 63 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 63 "program.vala"
	g_return_val_if_fail (sym != NULL, FALSE);
#line 64 "program.vala"
	if (sym->name == NULL) {
#line 1451 "program.c"
		result = FALSE;
		return result;
	}
	/* Case-insensitive matching for inexact matching*/
#line 68 "program.vala"
	if (self->priv->exact) {
#line 69 "program.vala"
		if (_vala_strcmp0 (sym->name, self->priv->name) != 0) {
#line 1460 "program.c"
			result = FALSE;
			return result;
		}
	} else {
		char* _tmp0_;
		gboolean _tmp1_;
#line 871 "glib-2.0.vapi"
		_tmp0_ = NULL;
#line 71 "program.vala"
		if ((_tmp1_ = !g_str_has_prefix (_tmp0_ = g_utf8_strdown (sym->name, -1), self->priv->name), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_)) {
#line 1471 "program.c"
			result = FALSE;
			return result;
		}
	}
	_tmp2_ = FALSE;
#line 75 "program.vala"
	if (self->priv->type) {
#line 1479 "program.c"
		ValenciaSymbol* _tmp3_;
#line 75 "program.vala"
		_tmp3_ = NULL;
#line 75 "program.vala"
		_tmp2_ = (_tmp3_ = sym, VALENCIA_IS_TYPESYMBOL (_tmp3_) ? ((ValenciaTypeSymbol*) _tmp3_) : NULL) == NULL;
#line 1485 "program.c"
	} else {
#line 75 "program.vala"
		_tmp2_ = FALSE;
#line 1489 "program.c"
	}
#line 75 "program.vala"
	if (_tmp2_) {
#line 1493 "program.c"
		result = FALSE;
		return result;
	}
#line 78 "program.vala"
	if (self->priv->constructor) {
#line 79 "program.vala"
		valencia_symbol_set_add_constructor (self, sym);
#line 1501 "program.c"
	} else {
#line 81 "program.vala"
		if (!VALENCIA_IS_CONSTRUCTOR (sym)) {
#line 82 "program.vala"
			gee_collection_add ((GeeCollection*) self->priv->symbols, sym);
#line 1507 "program.c"
		}
	}
	result = self->priv->exact;
	return result;
}


/* Convenience function for getting the first element without having to use iterators.
 This is mostly for users expecting exact matches.*/
#line 89 "program.vala"
ValenciaSymbol* valencia_symbol_set_first (ValenciaSymbolSet* self) {
#line 1519 "program.c"
	ValenciaSymbol* result;
#line 89 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1523 "program.c"
	{
		GeeIterator* _s_it;
		_s_it = gee_iterable_iterator ((GeeIterable*) self->priv->symbols);
#line 90 "program.vala"
		while (TRUE) {
#line 1529 "program.c"
			ValenciaSymbol* s;
#line 90 "program.vala"
			if (!gee_iterator_next (_s_it)) {
#line 90 "program.vala"
				break;
#line 1535 "program.c"
			}
			s = (ValenciaSymbol*) gee_iterator_get (_s_it);
			result = s;
			(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
			return result;
		}
		(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
	}
	result = NULL;
	return result;
}


#line 95 "program.vala"
GeeHashSet* valencia_symbol_set_get_symbols (ValenciaSymbolSet* self) {
#line 1551 "program.c"
	GeeHashSet* result;
	gboolean _tmp0_;
#line 95 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1556 "program.c"
	_tmp0_ = FALSE;
#line 98 "program.vala"
	if (gee_collection_get_size ((GeeCollection*) self->priv->symbols) == 0) {
#line 98 "program.vala"
		_tmp0_ = TRUE;
#line 1562 "program.c"
	} else {
		gboolean _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		_tmp1_ = FALSE;
		_tmp2_ = FALSE;
		_tmp3_ = FALSE;
#line 98 "program.vala"
		if (gee_collection_get_size ((GeeCollection*) self->priv->symbols) == 1) {
#line 98 "program.vala"
			_tmp3_ = !self->priv->exact;
#line 1574 "program.c"
		} else {
#line 98 "program.vala"
			_tmp3_ = FALSE;
#line 1578 "program.c"
		}
#line 98 "program.vala"
		if (_tmp3_) {
#line 98 "program.vala"
			_tmp2_ = !self->priv->local_symbols;
#line 1584 "program.c"
		} else {
#line 98 "program.vala"
			_tmp2_ = FALSE;
#line 1588 "program.c"
		}
#line 98 "program.vala"
		if (_tmp2_) {
#line 1592 "program.c"
			ValenciaSymbol* _tmp4_;
#line 89 "program.vala"
			_tmp4_ = NULL;
#line 99 "program.vala"
			_tmp1_ = _vala_strcmp0 ((_tmp4_ = valencia_symbol_set_first (self))->name, self->priv->name) == 0;
#line 1598 "program.c"
			(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_object_unref (_tmp4_), NULL));
		} else {
#line 98 "program.vala"
			_tmp1_ = FALSE;
#line 1603 "program.c"
		}
#line 98 "program.vala"
		_tmp0_ = _tmp1_;
#line 1607 "program.c"
	}
	/* It doesn't make sense to display the exact match of a partial search if there is only
	 one symbol found that matches perfectly (only for autocomplete!)*/
#line 98 "program.vala"
	if (_tmp0_) {
#line 1613 "program.c"
		result = NULL;
		return result;
	}
	result = self->priv->symbols;
	return result;
}


#line 105 "program.vala"
char* valencia_symbol_set_get_name (ValenciaSymbolSet* self) {
#line 1624 "program.c"
	char* result;
	const char* _tmp0_;
#line 105 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "program.vala"
	_tmp0_ = NULL;
#line 1631 "program.c"
	result = (_tmp0_ = self->priv->name, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	return result;
}


#line 109 "program.vala"
ValenciaSymbol* valencia_symbol_set_get_symbol (ValenciaSymbolSet* self, const char* name) {
#line 1639 "program.c"
	ValenciaSymbol* result;
#line 109 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 109 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 1645 "program.c"
	{
		GeeIterator* _symbol_it;
		_symbol_it = gee_iterable_iterator ((GeeIterable*) self->priv->symbols);
#line 110 "program.vala"
		while (TRUE) {
#line 1651 "program.c"
			ValenciaSymbol* symbol;
#line 110 "program.vala"
			if (!gee_iterator_next (_symbol_it)) {
#line 110 "program.vala"
				break;
#line 1657 "program.c"
			}
			symbol = (ValenciaSymbol*) gee_iterator_get (_symbol_it);
#line 111 "program.vala"
			if (_vala_strcmp0 (symbol->name, name) == 0) {
#line 1662 "program.c"
				result = symbol;
				(_symbol_it == NULL) ? NULL : (_symbol_it = (gee_collection_object_unref (_symbol_it), NULL));
				return result;
			}
			(symbol == NULL) ? NULL : (symbol = (g_object_unref (symbol), NULL));
		}
		(_symbol_it == NULL) ? NULL : (_symbol_it = (gee_collection_object_unref (_symbol_it), NULL));
	}
	result = NULL;
	return result;
}


#line 117 "program.vala"
gboolean valencia_symbol_set_local_symbols_only (ValenciaSymbolSet* self) {
#line 1678 "program.c"
	gboolean result;
#line 117 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1682 "program.c"
	result = self->priv->local_symbols;
	return result;
}


static void valencia_symbol_set_class_init (ValenciaSymbolSetClass * klass) {
	valencia_symbol_set_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaSymbolSetPrivate));
	G_OBJECT_CLASS (klass)->finalize = valencia_symbol_set_finalize;
}


static void valencia_symbol_set_instance_init (ValenciaSymbolSet * self) {
	self->priv = VALENCIA_SYMBOL_SET_GET_PRIVATE (self);
	self->priv->symbols = gee_hash_set_new (VALENCIA_TYPE_SYMBOL, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_hash, g_direct_equal);
}


static void valencia_symbol_set_finalize (GObject* obj) {
	ValenciaSymbolSet * self;
	self = VALENCIA_SYMBOL_SET (obj);
	(self->priv->symbols == NULL) ? NULL : (self->priv->symbols = (gee_collection_object_unref (self->priv->symbols), NULL));
	self->priv->name = (g_free (self->priv->name), NULL);
	G_OBJECT_CLASS (valencia_symbol_set_parent_class)->finalize (obj);
}


GType valencia_symbol_set_get_type (void) {
	static GType valencia_symbol_set_type_id = 0;
	if (valencia_symbol_set_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaSymbolSetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_symbol_set_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaSymbolSet), 0, (GInstanceInitFunc) valencia_symbol_set_instance_init, NULL };
		valencia_symbol_set_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaSymbolSet", &g_define_type_info, 0);
	}
	return valencia_symbol_set_type_id;
}


#line 126 "program.vala"
static ValenciaNode* valencia_node_construct (GType object_type, gint start, gint end) {
#line 1722 "program.c"
	ValenciaNode * self;
	self = g_object_newv (object_type, 0, NULL);
#line 127 "program.vala"
	self->start = start;
#line 128 "program.vala"
	self->end = end;
#line 1729 "program.c"
	return self;
}


#line 126 "program.vala"
static ValenciaNode* valencia_node_new (gint start, gint end) {
#line 126 "program.vala"
	return valencia_node_construct (VALENCIA_TYPE_NODE, start, end);
#line 1738 "program.c"
}


/* Return all children which may possibly contain a scope.*/
#line 132 "program.vala"
static GeeArrayList* valencia_node_real_children (ValenciaNode* self) {
#line 1745 "program.c"
	GeeArrayList* result;
#line 132 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1749 "program.c"
	result = NULL;
	return result;
}


#line 132 "program.vala"
GeeArrayList* valencia_node_children (ValenciaNode* self) {
#line 132 "program.vala"
	return VALENCIA_NODE_GET_CLASS (self)->children (self);
#line 1759 "program.c"
}


#line 134 "program.vala"
GeeArrayList* valencia_node_single_node (ValenciaNode* n) {
#line 1765 "program.c"
	GeeArrayList* result;
	GeeArrayList* a;
#line 135 "program.vala"
	if (n == NULL) {
#line 1770 "program.c"
		result = NULL;
		return result;
	}
	a = gee_array_list_new (VALENCIA_TYPE_NODE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
#line 138 "program.vala"
	gee_collection_add ((GeeCollection*) a, n);
#line 1777 "program.c"
	result = a;
	return result;
}


#line 142 "program.vala"
ValenciaChain* valencia_node_find (ValenciaNode* self, ValenciaChain* parent, gint pos) {
#line 1785 "program.c"
	ValenciaChain* result;
	ValenciaChain* _tmp0_;
	ValenciaChain* c;
	ValenciaScope* _tmp2_;
	ValenciaNode* _tmp1_;
	ValenciaScope* s;
	GeeArrayList* nodes;
#line 142 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 143 "program.vala"
	_tmp0_ = NULL;
#line 1797 "program.c"
	c = (_tmp0_ = parent, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 144 "program.vala"
	_tmp2_ = NULL;
#line 144 "program.vala"
	_tmp1_ = NULL;
#line 1803 "program.c"
	s = (_tmp2_ = (_tmp1_ = self, VALENCIA_IS_SCOPE (_tmp1_) ? ((ValenciaScope*) _tmp1_) : NULL), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
#line 145 "program.vala"
	if (s != NULL) {
#line 1807 "program.c"
		ValenciaChain* _tmp3_;
		_tmp3_ = NULL;
#line 146 "program.vala"
		c = (_tmp3_ = valencia_chain_new (s, parent), (c == NULL) ? NULL : (c = (g_object_unref (c), NULL)), _tmp3_);
#line 1812 "program.c"
	}
	/* link this scope in*/
	nodes = valencia_node_children (self);
#line 149 "program.vala"
	if (nodes != NULL) {
#line 1818 "program.c"
		{
			GeeIterator* _n_it;
			_n_it = gee_iterable_iterator ((GeeIterable*) nodes);
#line 150 "program.vala"
			while (TRUE) {
#line 1824 "program.c"
				ValenciaNode* n;
				gboolean _tmp4_;
#line 150 "program.vala"
				if (!gee_iterator_next (_n_it)) {
#line 150 "program.vala"
					break;
#line 1831 "program.c"
				}
				n = (ValenciaNode*) gee_iterator_get (_n_it);
				_tmp4_ = FALSE;
#line 151 "program.vala"
				if (n->start <= pos) {
#line 151 "program.vala"
					_tmp4_ = pos <= n->end;
#line 1839 "program.c"
				} else {
#line 151 "program.vala"
					_tmp4_ = FALSE;
#line 1843 "program.c"
				}
#line 151 "program.vala"
				if (_tmp4_) {
#line 1847 "program.c"
					result = valencia_node_find (n, c, pos);
					(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
					(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
					(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
					(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
					(nodes == NULL) ? NULL : (nodes = (gee_collection_object_unref (nodes), NULL));
					return result;
				}
				(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
			}
			(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
		}
	}
	result = c;
	(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
	(nodes == NULL) ? NULL : (nodes = (gee_collection_object_unref (nodes), NULL));
	return result;
}


#line 156 "program.vala"
gboolean valencia_node_lookup_in_array (GeeArrayList* a, ValenciaSymbolSet* symbols) {
#line 1870 "program.c"
	gboolean result;
#line 156 "program.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 156 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 1876 "program.c"
	{
		GeeIterator* _n_it;
		_n_it = gee_iterable_iterator ((GeeIterable*) a);
#line 157 "program.vala"
		while (TRUE) {
#line 1882 "program.c"
			ValenciaNode* n;
			ValenciaSymbol* _tmp1_;
			ValenciaNode* _tmp0_;
			ValenciaSymbol* s;
			gboolean _tmp2_;
#line 157 "program.vala"
			if (!gee_iterator_next (_n_it)) {
#line 157 "program.vala"
				break;
#line 1892 "program.c"
			}
			n = (ValenciaNode*) gee_iterator_get (_n_it);
#line 158 "program.vala"
			_tmp1_ = NULL;
#line 158 "program.vala"
			_tmp0_ = NULL;
#line 1899 "program.c"
			s = (_tmp1_ = (_tmp0_ = n, VALENCIA_IS_SYMBOL (_tmp0_) ? ((ValenciaSymbol*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
			_tmp2_ = FALSE;
#line 159 "program.vala"
			if (s != NULL) {
#line 159 "program.vala"
				_tmp2_ = valencia_symbol_set_add (symbols, s);
#line 1906 "program.c"
			} else {
#line 159 "program.vala"
				_tmp2_ = FALSE;
#line 1910 "program.c"
			}
#line 159 "program.vala"
			if (_tmp2_) {
#line 1914 "program.c"
				result = TRUE;
				(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
				(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
				(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
				return result;
			}
			(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
			(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
		}
		(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
	}
	result = FALSE;
	return result;
}


#line 165 "program.vala"
static void valencia_node_real_print (ValenciaNode* self, gint level) {
#line 1933 "program.c"
	g_return_if_fail (self != NULL);
	g_critical ("Type `%s' does not implement abstract method `valencia_node_print'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}


#line 165 "program.vala"
void valencia_node_print (ValenciaNode* self, gint level) {
#line 165 "program.vala"
	VALENCIA_NODE_GET_CLASS (self)->print (self, level);
#line 1944 "program.c"
}


#line 167 "program.vala"
void valencia_node_do_print (ValenciaNode* self, gint level, const char* s) {
#line 1950 "program.c"
	char* _tmp0_;
#line 167 "program.vala"
	g_return_if_fail (self != NULL);
#line 167 "program.vala"
	g_return_if_fail (s != NULL);
#line 840 "glib-2.0.vapi"
	_tmp0_ = NULL;
#line 168 "program.vala"
	fprintf (stdout, "%s%s\n", _tmp0_ = g_strnfill ((gsize) (level * 2), ' '), s);
#line 1960 "program.c"
	_tmp0_ = (g_free (_tmp0_), NULL);
}


static void valencia_node_class_init (ValenciaNodeClass * klass) {
	valencia_node_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_NODE_CLASS (klass)->children = valencia_node_real_children;
	VALENCIA_NODE_CLASS (klass)->print = valencia_node_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_node_finalize;
}


static void valencia_node_instance_init (ValenciaNode * self) {
}


static void valencia_node_finalize (GObject* obj) {
	ValenciaNode * self;
	self = VALENCIA_NODE (obj);
	G_OBJECT_CLASS (valencia_node_parent_class)->finalize (obj);
}


GType valencia_node_get_type (void) {
	static GType valencia_node_type_id = 0;
	if (valencia_node_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaNode), 0, (GInstanceInitFunc) valencia_node_instance_init, NULL };
		valencia_node_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaNode", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return valencia_node_type_id;
}


/* symbol name, or null for a constructor*/
#line 176 "program.vala"
ValenciaSymbol* valencia_symbol_construct (GType object_type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 1997 "program.c"
	ValenciaSymbol * self;
	ValenciaSourceFile* _tmp1_;
	ValenciaSourceFile* _tmp0_;
	char* _tmp3_;
	const char* _tmp2_;
#line 176 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 177 "program.vala"
	self = (ValenciaSymbol*) valencia_node_construct (object_type, start, end);
#line 2007 "program.c"
	_tmp1_ = NULL;
#line 178 "program.vala"
	_tmp0_ = NULL;
#line 178 "program.vala"
	self->source = (_tmp1_ = (_tmp0_ = source, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->source == NULL) ? NULL : (self->source = (g_object_unref (self->source), NULL)), _tmp1_);
#line 2013 "program.c"
	_tmp3_ = NULL;
#line 179 "program.vala"
	_tmp2_ = NULL;
#line 179 "program.vala"
	self->name = (_tmp3_ = (_tmp2_ = name, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), self->name = (g_free (self->name), NULL), _tmp3_);
#line 2019 "program.c"
	return self;
}


#line 176 "program.vala"
ValenciaSymbol* valencia_symbol_new (const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 176 "program.vala"
	return valencia_symbol_construct (VALENCIA_TYPE_SYMBOL, name, source, start, end);
#line 2028 "program.c"
}


#line 182 "program.vala"
void valencia_symbol_print_name (ValenciaSymbol* self, gint level, const char* s) {
#line 2034 "program.c"
	char* _tmp1_;
	char* _tmp0_;
#line 182 "program.vala"
	g_return_if_fail (self != NULL);
#line 182 "program.vala"
	g_return_if_fail (s != NULL);
#line 2041 "program.c"
	_tmp1_ = NULL;
	_tmp0_ = NULL;
#line 183 "program.vala"
	valencia_node_do_print ((ValenciaNode*) self, level, _tmp1_ = g_strconcat (_tmp0_ = g_strconcat (s, " ", NULL), self->name, NULL));
#line 2046 "program.c"
	_tmp1_ = (g_free (_tmp1_), NULL);
	_tmp0_ = (g_free (_tmp0_), NULL);
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, -1);
	return result;
}


#line 186 "program.vala"
gint valencia_symbol_name_length (ValenciaSymbol* self) {
#line 2062 "program.c"
	gint result;
	gint length;
#line 186 "program.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 2067 "program.c"
	length = 0;
	/* Since unnamed constructors' names are null, just use the parent class' name*/
#line 189 "program.vala"
	if (self->name == NULL) {
#line 190 "program.vala"
		if (VALENCIA_IS_CONSTRUCTOR (self)) {
#line 2074 "program.c"
			ValenciaConstructor* _tmp0_;
			ValenciaConstructor* c;
#line 191 "program.vala"
			_tmp0_ = NULL;
#line 2079 "program.c"
			c = (_tmp0_ = VALENCIA_CONSTRUCTOR (self), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 192 "program.vala"
			length = (gint) string_get_length (((ValenciaSymbol*) c->parent)->name);
#line 2083 "program.c"
			(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
		}
	} else {
#line 195 "program.vala"
		length = (gint) string_get_length (self->name);
#line 2089 "program.c"
	}
	result = length;
	return result;
}


#line 200 "program.vala"
guint valencia_symbol_hash (void* item) {
#line 2098 "program.c"
	guint result;
	ValenciaSymbol* symbol;
	symbol = VALENCIA_SYMBOL (item);
	/* Unnamed constructors always have null names, so hash their parent class' name*/
#line 204 "program.vala"
	if (symbol->name == NULL) {
#line 2105 "program.c"
		ValenciaConstructor* _tmp1_;
		ValenciaSymbol* _tmp0_;
		ValenciaConstructor* c;
#line 205 "program.vala"
		_tmp1_ = NULL;
#line 205 "program.vala"
		_tmp0_ = NULL;
#line 2113 "program.c"
		c = (_tmp1_ = (_tmp0_ = symbol, VALENCIA_IS_CONSTRUCTOR (_tmp0_) ? ((ValenciaConstructor*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
#line 206 "program.vala"
		g_assert (c != NULL);
#line 2117 "program.c"
		result = g_str_hash (((ValenciaSymbol*) c->parent)->name);
		(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
		return result;
	} else {
		result = g_str_hash (symbol->name);
		return result;
	}
}


#line 211 "program.vala"
gboolean valencia_symbol_equal (void* a, void* b) {
#line 2130 "program.c"
	gboolean result;
	ValenciaSymbol* a_symbol;
	ValenciaSymbol* b_symbol;
	a_symbol = VALENCIA_SYMBOL (a);
	b_symbol = VALENCIA_SYMBOL (b);
	result = _vala_strcmp0 (a_symbol->name, b_symbol->name) == 0;
	return result;
}


static void valencia_symbol_class_init (ValenciaSymbolClass * klass) {
	valencia_symbol_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_symbol_finalize;
}


static void valencia_symbol_instance_init (ValenciaSymbol * self) {
}


static void valencia_symbol_finalize (GObject* obj) {
	ValenciaSymbol * self;
	self = VALENCIA_SYMBOL (obj);
	(self->source == NULL) ? NULL : (self->source = (g_object_unref (self->source), NULL));
	self->name = (g_free (self->name), NULL);
	G_OBJECT_CLASS (valencia_symbol_parent_class)->finalize (obj);
}


GType valencia_symbol_get_type (void) {
	static GType valencia_symbol_type_id = 0;
	if (valencia_symbol_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaSymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_symbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaSymbol), 0, (GInstanceInitFunc) valencia_symbol_instance_init, NULL };
		valencia_symbol_type_id = g_type_register_static (VALENCIA_TYPE_NODE, "ValenciaSymbol", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return valencia_symbol_type_id;
}


/* Adds all members not past the position specified by 'pos' inside this scope to 'symbols'
 (members meaning fields, methods, classes, enums, etc...)*/
#line 221 "program.vala"
gboolean valencia_scope_lookup (ValenciaScope* self, ValenciaSymbolSet* symbols, gint pos) {
#line 221 "program.vala"
	return VALENCIA_SCOPE_GET_INTERFACE (self)->lookup (self, symbols, pos);
#line 2176 "program.c"
}


static void valencia_scope_base_init (ValenciaScopeIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType valencia_scope_get_type (void) {
	static GType valencia_scope_type_id = 0;
	if (valencia_scope_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaScopeIface), (GBaseInitFunc) valencia_scope_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		valencia_scope_type_id = g_type_register_static (G_TYPE_INTERFACE, "ValenciaScope", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (valencia_scope_type_id, G_TYPE_OBJECT);
	}
	return valencia_scope_type_id;
}


#line 225 "program.vala"
ValenciaTypeSymbol* valencia_typesymbol_construct (GType object_type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 2201 "program.c"
	ValenciaTypeSymbol * self;
#line 225 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 226 "program.vala"
	self = (ValenciaTypeSymbol*) valencia_symbol_construct (object_type, name, source, start, end);
#line 2207 "program.c"
	return self;
}


#line 225 "program.vala"
ValenciaTypeSymbol* valencia_typesymbol_new (const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 225 "program.vala"
	return valencia_typesymbol_construct (VALENCIA_TYPE_TYPESYMBOL, name, source, start, end);
#line 2216 "program.c"
}


static void valencia_typesymbol_class_init (ValenciaTypeSymbolClass * klass) {
	valencia_typesymbol_parent_class = g_type_class_peek_parent (klass);
}


static void valencia_typesymbol_instance_init (ValenciaTypeSymbol * self) {
}


GType valencia_typesymbol_get_type (void) {
	static GType valencia_typesymbol_type_id = 0;
	if (valencia_typesymbol_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaTypeSymbolClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_typesymbol_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaTypeSymbol), 0, (GInstanceInitFunc) valencia_typesymbol_instance_init, NULL };
		valencia_typesymbol_type_id = g_type_register_static (VALENCIA_TYPE_SYMBOL, "ValenciaTypeSymbol", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return valencia_typesymbol_type_id;
}


#line 231 "program.vala"
ValenciaStatement* valencia_statement_construct (GType object_type, gint start, gint end) {
#line 2241 "program.c"
	ValenciaStatement * self;
#line 231 "program.vala"
	self = (ValenciaStatement*) valencia_node_construct (object_type, start, end);
#line 2245 "program.c"
	return self;
}


#line 231 "program.vala"
ValenciaStatement* valencia_statement_new (gint start, gint end) {
#line 231 "program.vala"
	return valencia_statement_construct (VALENCIA_TYPE_STATEMENT, start, end);
#line 2254 "program.c"
}


#line 233 "program.vala"
static gboolean valencia_statement_real_defines_symbol (ValenciaStatement* self, ValenciaSymbolSet* symbols) {
#line 2260 "program.c"
	gboolean result;
#line 233 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 233 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 2266 "program.c"
	result = FALSE;
	return result;
}


#line 233 "program.vala"
gboolean valencia_statement_defines_symbol (ValenciaStatement* self, ValenciaSymbolSet* symbols) {
#line 233 "program.vala"
	return VALENCIA_STATEMENT_GET_CLASS (self)->defines_symbol (self, symbols);
#line 2276 "program.c"
}


static void valencia_statement_class_init (ValenciaStatementClass * klass) {
	valencia_statement_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_STATEMENT_CLASS (klass)->defines_symbol = valencia_statement_real_defines_symbol;
}


static void valencia_statement_instance_init (ValenciaStatement * self) {
}


GType valencia_statement_get_type (void) {
	static GType valencia_statement_type_id = 0;
	if (valencia_statement_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaStatement), 0, (GInstanceInitFunc) valencia_statement_instance_init, NULL };
		valencia_statement_type_id = g_type_register_static (VALENCIA_TYPE_NODE, "ValenciaStatement", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return valencia_statement_type_id;
}


#line 239 "program.vala"
ValenciaVariable* valencia_variable_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 2302 "program.c"
	ValenciaVariable * self;
	ValenciaExpression* _tmp1_;
	ValenciaExpression* _tmp0_;
#line 239 "program.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 239 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 239 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 240 "program.vala"
	self = (ValenciaVariable*) valencia_symbol_construct (object_type, name, source, start, end);
#line 2314 "program.c"
	_tmp1_ = NULL;
#line 241 "program.vala"
	_tmp0_ = NULL;
#line 241 "program.vala"
	self->type = (_tmp1_ = (_tmp0_ = type, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->type == NULL) ? NULL : (self->type = (g_object_unref (self->type), NULL)), _tmp1_);
#line 2320 "program.c"
	return self;
}


#line 239 "program.vala"
ValenciaVariable* valencia_variable_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 239 "program.vala"
	return valencia_variable_construct (VALENCIA_TYPE_VARIABLE, type, name, source, start, end);
#line 2329 "program.c"
}


#line 244 "program.vala"
static char* valencia_variable_real_kind (ValenciaVariable* self) {
#line 2335 "program.c"
	g_return_val_if_fail (self != NULL, NULL);
	g_critical ("Type `%s' does not implement abstract method `valencia_variable_kind'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}


#line 244 "program.vala"
char* valencia_variable_kind (ValenciaVariable* self) {
#line 244 "program.vala"
	return VALENCIA_VARIABLE_GET_CLASS (self)->kind (self);
#line 2346 "program.c"
}


#line 246 "program.vala"
static void valencia_variable_real_print (ValenciaNode* base, gint level) {
#line 2352 "program.c"
	ValenciaVariable * self;
	char* _tmp3_;
	char* _tmp2_;
	char* _tmp1_;
	char* _tmp0_;
	self = (ValenciaVariable*) base;
	_tmp3_ = NULL;
#line 10 "expression.vala"
	_tmp2_ = NULL;
#line 2362 "program.c"
	_tmp1_ = NULL;
#line 244 "program.vala"
	_tmp0_ = NULL;
#line 247 "program.vala"
	valencia_symbol_print_name ((ValenciaSymbol*) self, level, _tmp3_ = g_strconcat (_tmp1_ = g_strconcat (_tmp0_ = valencia_variable_kind (self), " ", NULL), _tmp2_ = valencia_expression_to_string (self->type), NULL));
#line 2368 "program.c"
	_tmp3_ = (g_free (_tmp3_), NULL);
	_tmp2_ = (g_free (_tmp2_), NULL);
	_tmp1_ = (g_free (_tmp1_), NULL);
	_tmp0_ = (g_free (_tmp0_), NULL);
}


static void valencia_variable_class_init (ValenciaVariableClass * klass) {
	valencia_variable_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_VARIABLE_CLASS (klass)->kind = valencia_variable_real_kind;
	VALENCIA_NODE_CLASS (klass)->print = valencia_variable_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_variable_finalize;
}


static void valencia_variable_instance_init (ValenciaVariable * self) {
}


static void valencia_variable_finalize (GObject* obj) {
	ValenciaVariable * self;
	self = VALENCIA_VARIABLE (obj);
	(self->type == NULL) ? NULL : (self->type = (g_object_unref (self->type), NULL));
	G_OBJECT_CLASS (valencia_variable_parent_class)->finalize (obj);
}


GType valencia_variable_get_type (void) {
	static GType valencia_variable_type_id = 0;
	if (valencia_variable_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaVariableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_variable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaVariable), 0, (GInstanceInitFunc) valencia_variable_instance_init, NULL };
		valencia_variable_type_id = g_type_register_static (VALENCIA_TYPE_SYMBOL, "ValenciaVariable", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	}
	return valencia_variable_type_id;
}


#line 252 "program.vala"
ValenciaLocalVariable* valencia_local_variable_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 2408 "program.c"
	ValenciaLocalVariable * self;
#line 252 "program.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 252 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 252 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 253 "program.vala"
	self = (ValenciaLocalVariable*) valencia_variable_construct (object_type, type, name, source, start, end);
#line 2418 "program.c"
	return self;
}


#line 252 "program.vala"
ValenciaLocalVariable* valencia_local_variable_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 252 "program.vala"
	return valencia_local_variable_construct (VALENCIA_TYPE_LOCAL_VARIABLE, type, name, source, start, end);
#line 2427 "program.c"
}


#line 256 "program.vala"
static char* valencia_local_variable_real_kind (ValenciaVariable* base) {
#line 2433 "program.c"
	ValenciaLocalVariable * self;
	char* result;
	self = (ValenciaLocalVariable*) base;
	result = g_strdup ("local");
	return result;
}


static void valencia_local_variable_class_init (ValenciaLocalVariableClass * klass) {
	valencia_local_variable_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_VARIABLE_CLASS (klass)->kind = valencia_local_variable_real_kind;
}


static void valencia_local_variable_instance_init (ValenciaLocalVariable * self) {
}


GType valencia_local_variable_get_type (void) {
	static GType valencia_local_variable_type_id = 0;
	if (valencia_local_variable_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaLocalVariableClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_local_variable_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaLocalVariable), 0, (GInstanceInitFunc) valencia_local_variable_instance_init, NULL };
		valencia_local_variable_type_id = g_type_register_static (VALENCIA_TYPE_VARIABLE, "ValenciaLocalVariable", &g_define_type_info, 0);
	}
	return valencia_local_variable_type_id;
}


#line 262 "program.vala"
ValenciaDeclarationStatement* valencia_declaration_statement_construct (GType object_type, GeeArrayList* variables, gint start, gint end) {
#line 2464 "program.c"
	ValenciaDeclarationStatement * self;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp0_;
#line 262 "program.vala"
	g_return_val_if_fail (variables != NULL, NULL);
#line 263 "program.vala"
	self = (ValenciaDeclarationStatement*) valencia_statement_construct (object_type, start, end);
#line 2472 "program.c"
	_tmp1_ = NULL;
#line 264 "program.vala"
	_tmp0_ = NULL;
#line 264 "program.vala"
	self->variables = (_tmp1_ = (_tmp0_ = variables, (_tmp0_ == NULL) ? NULL : gee_collection_object_ref (_tmp0_)), (self->variables == NULL) ? NULL : (self->variables = (gee_collection_object_unref (self->variables), NULL)), _tmp1_);
#line 2478 "program.c"
	return self;
}


#line 262 "program.vala"
ValenciaDeclarationStatement* valencia_declaration_statement_new (GeeArrayList* variables, gint start, gint end) {
#line 262 "program.vala"
	return valencia_declaration_statement_construct (VALENCIA_TYPE_DECLARATION_STATEMENT, variables, start, end);
#line 2487 "program.c"
}


#line 267 "program.vala"
static gboolean valencia_declaration_statement_real_defines_symbol (ValenciaStatement* base, ValenciaSymbolSet* symbols) {
#line 2493 "program.c"
	ValenciaDeclarationStatement * self;
	gboolean result;
	self = (ValenciaDeclarationStatement*) base;
#line 267 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 2499 "program.c"
	{
		GeeIterator* _variable_it;
		_variable_it = gee_iterable_iterator ((GeeIterable*) self->variables);
#line 268 "program.vala"
		while (TRUE) {
#line 2505 "program.c"
			ValenciaLocalVariable* variable;
#line 268 "program.vala"
			if (!gee_iterator_next (_variable_it)) {
#line 268 "program.vala"
				break;
#line 2511 "program.c"
			}
			variable = (ValenciaLocalVariable*) gee_iterator_get (_variable_it);
#line 269 "program.vala"
			if (valencia_symbol_set_add (symbols, (ValenciaSymbol*) variable)) {
#line 2516 "program.c"
				result = TRUE;
				(variable == NULL) ? NULL : (variable = (g_object_unref (variable), NULL));
				(_variable_it == NULL) ? NULL : (_variable_it = (gee_collection_object_unref (_variable_it), NULL));
				return result;
			}
			(variable == NULL) ? NULL : (variable = (g_object_unref (variable), NULL));
		}
		(_variable_it == NULL) ? NULL : (_variable_it = (gee_collection_object_unref (_variable_it), NULL));
	}
	result = FALSE;
	return result;
}


#line 274 "program.vala"
static void valencia_declaration_statement_real_print (ValenciaNode* base, gint level) {
#line 2533 "program.c"
	ValenciaDeclarationStatement * self;
	self = (ValenciaDeclarationStatement*) base;
	{
		GeeIterator* _variable_it;
		_variable_it = gee_iterable_iterator ((GeeIterable*) self->variables);
#line 275 "program.vala"
		while (TRUE) {
#line 2541 "program.c"
			ValenciaLocalVariable* variable;
#line 275 "program.vala"
			if (!gee_iterator_next (_variable_it)) {
#line 275 "program.vala"
				break;
#line 2547 "program.c"
			}
			variable = (ValenciaLocalVariable*) gee_iterator_get (_variable_it);
#line 276 "program.vala"
			valencia_node_print ((ValenciaNode*) variable, level);
#line 2552 "program.c"
			(variable == NULL) ? NULL : (variable = (g_object_unref (variable), NULL));
		}
		(_variable_it == NULL) ? NULL : (_variable_it = (gee_collection_object_unref (_variable_it), NULL));
	}
}


static void valencia_declaration_statement_class_init (ValenciaDeclarationStatementClass * klass) {
	valencia_declaration_statement_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_STATEMENT_CLASS (klass)->defines_symbol = valencia_declaration_statement_real_defines_symbol;
	VALENCIA_NODE_CLASS (klass)->print = valencia_declaration_statement_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_declaration_statement_finalize;
}


static void valencia_declaration_statement_instance_init (ValenciaDeclarationStatement * self) {
}


static void valencia_declaration_statement_finalize (GObject* obj) {
	ValenciaDeclarationStatement * self;
	self = VALENCIA_DECLARATION_STATEMENT (obj);
	(self->variables == NULL) ? NULL : (self->variables = (gee_collection_object_unref (self->variables), NULL));
	G_OBJECT_CLASS (valencia_declaration_statement_parent_class)->finalize (obj);
}


GType valencia_declaration_statement_get_type (void) {
	static GType valencia_declaration_statement_type_id = 0;
	if (valencia_declaration_statement_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaDeclarationStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_declaration_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaDeclarationStatement), 0, (GInstanceInitFunc) valencia_declaration_statement_instance_init, NULL };
		valencia_declaration_statement_type_id = g_type_register_static (VALENCIA_TYPE_STATEMENT, "ValenciaDeclarationStatement", &g_define_type_info, 0);
	}
	return valencia_declaration_statement_type_id;
}


#line 285 "program.vala"
ValenciaFor* valencia_for_construct (GType object_type, ValenciaDeclarationStatement* declaration, ValenciaStatement* statement, gint start, gint end) {
#line 2592 "program.c"
	ValenciaFor * self;
	ValenciaDeclarationStatement* _tmp1_;
	ValenciaDeclarationStatement* _tmp0_;
	ValenciaStatement* _tmp3_;
	ValenciaStatement* _tmp2_;
#line 285 "program.vala"
	g_return_val_if_fail (declaration != NULL, NULL);
#line 286 "program.vala"
	self = (ValenciaFor*) valencia_statement_construct (object_type, start, end);
#line 2602 "program.c"
	_tmp1_ = NULL;
#line 287 "program.vala"
	_tmp0_ = NULL;
#line 287 "program.vala"
	self->declaration = (_tmp1_ = (_tmp0_ = declaration, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->declaration == NULL) ? NULL : (self->declaration = (g_object_unref (self->declaration), NULL)), _tmp1_);
#line 2608 "program.c"
	_tmp3_ = NULL;
#line 288 "program.vala"
	_tmp2_ = NULL;
#line 288 "program.vala"
	self->statement = (_tmp3_ = (_tmp2_ = statement, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (self->statement == NULL) ? NULL : (self->statement = (g_object_unref (self->statement), NULL)), _tmp3_);
#line 2614 "program.c"
	return self;
}


#line 285 "program.vala"
ValenciaFor* valencia_for_new (ValenciaDeclarationStatement* declaration, ValenciaStatement* statement, gint start, gint end) {
#line 285 "program.vala"
	return valencia_for_construct (VALENCIA_TYPE_FOR, declaration, statement, start, end);
#line 2623 "program.c"
}


#line 291 "program.vala"
static GeeArrayList* valencia_for_real_children (ValenciaNode* base) {
#line 2629 "program.c"
	ValenciaFor * self;
	GeeArrayList* result;
	self = (ValenciaFor*) base;
	result = valencia_node_single_node ((ValenciaNode*) self->statement);
	return result;
}


#line 293 "program.vala"
static gboolean valencia_for_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos) {
#line 2640 "program.c"
	ValenciaFor * self;
	gboolean result;
	self = (ValenciaFor*) base;
#line 293 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 2646 "program.c"
	result = valencia_statement_defines_symbol ((ValenciaStatement*) self->declaration, symbols);
	return result;
}


#line 297 "program.vala"
static void valencia_for_real_print (ValenciaNode* base, gint level) {
#line 2654 "program.c"
	ValenciaFor * self;
	self = (ValenciaFor*) base;
#line 298 "program.vala"
	valencia_node_do_print ((ValenciaNode*) self, level, "foreach");
#line 2659 "program.c"
	{
		GeeIterator* _variable_it;
		_variable_it = gee_iterable_iterator ((GeeIterable*) self->declaration->variables);
#line 300 "program.vala"
		while (TRUE) {
#line 2665 "program.c"
			ValenciaLocalVariable* variable;
#line 300 "program.vala"
			if (!gee_iterator_next (_variable_it)) {
#line 300 "program.vala"
				break;
#line 2671 "program.c"
			}
			variable = (ValenciaLocalVariable*) gee_iterator_get (_variable_it);
#line 301 "program.vala"
			valencia_node_print ((ValenciaNode*) variable, level + 1);
#line 302 "program.vala"
			if (self->statement != NULL) {
#line 303 "program.vala"
				valencia_node_print ((ValenciaNode*) self->statement, level + 1);
#line 2680 "program.c"
			}
			(variable == NULL) ? NULL : (variable = (g_object_unref (variable), NULL));
		}
		(_variable_it == NULL) ? NULL : (_variable_it = (gee_collection_object_unref (_variable_it), NULL));
	}
}


static void valencia_for_class_init (ValenciaForClass * klass) {
	valencia_for_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_NODE_CLASS (klass)->children = valencia_for_real_children;
	VALENCIA_NODE_CLASS (klass)->print = valencia_for_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_for_finalize;
}


static void valencia_for_valencia_scope_interface_init (ValenciaScopeIface * iface) {
	valencia_for_valencia_scope_parent_iface = g_type_interface_peek_parent (iface);
	iface->lookup = valencia_for_real_lookup;
}


static void valencia_for_instance_init (ValenciaFor * self) {
}


static void valencia_for_finalize (GObject* obj) {
	ValenciaFor * self;
	self = VALENCIA_FOR (obj);
	(self->declaration == NULL) ? NULL : (self->declaration = (g_object_unref (self->declaration), NULL));
	(self->statement == NULL) ? NULL : (self->statement = (g_object_unref (self->statement), NULL));
	G_OBJECT_CLASS (valencia_for_parent_class)->finalize (obj);
}


GType valencia_for_get_type (void) {
	static GType valencia_for_type_id = 0;
	if (valencia_for_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaForClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_for_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaFor), 0, (GInstanceInitFunc) valencia_for_instance_init, NULL };
		static const GInterfaceInfo valencia_scope_info = { (GInterfaceInitFunc) valencia_for_valencia_scope_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valencia_for_type_id = g_type_register_static (VALENCIA_TYPE_STATEMENT, "ValenciaFor", &g_define_type_info, 0);
		g_type_add_interface_static (valencia_for_type_id, VALENCIA_TYPE_SCOPE, &valencia_scope_info);
	}
	return valencia_for_type_id;
}


#line 312 "program.vala"
ValenciaChain* valencia_chain_construct (GType object_type, ValenciaScope* scope, ValenciaChain* parent) {
#line 2730 "program.c"
	ValenciaChain * self;
	ValenciaScope* _tmp1_;
	ValenciaScope* _tmp0_;
	ValenciaChain* _tmp3_;
	ValenciaChain* _tmp2_;
#line 312 "program.vala"
	g_return_val_if_fail (scope != NULL, NULL);
#line 2738 "program.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 313 "program.vala"
	_tmp0_ = NULL;
#line 313 "program.vala"
	self->priv->scope = (_tmp1_ = (_tmp0_ = scope, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->priv->scope == NULL) ? NULL : (self->priv->scope = (g_object_unref (self->priv->scope), NULL)), _tmp1_);
#line 2745 "program.c"
	_tmp3_ = NULL;
#line 314 "program.vala"
	_tmp2_ = NULL;
#line 314 "program.vala"
	self->priv->parent = (_tmp3_ = (_tmp2_ = parent, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (self->priv->parent == NULL) ? NULL : (self->priv->parent = (g_object_unref (self->priv->parent), NULL)), _tmp3_);
#line 2751 "program.c"
	return self;
}


#line 312 "program.vala"
ValenciaChain* valencia_chain_new (ValenciaScope* scope, ValenciaChain* parent) {
#line 312 "program.vala"
	return valencia_chain_construct (VALENCIA_TYPE_CHAIN, scope, parent);
#line 2760 "program.c"
}


#line 317 "program.vala"
void valencia_chain_lookup (ValenciaChain* self, ValenciaSymbolSet* symbols, gint pos) {
#line 317 "program.vala"
	g_return_if_fail (self != NULL);
#line 317 "program.vala"
	g_return_if_fail (symbols != NULL);
#line 318 "program.vala"
	if (valencia_scope_lookup (self->priv->scope, symbols, pos)) {
#line 2772 "program.c"
		return;
	}
#line 321 "program.vala"
	if (self->priv->parent != NULL) {
#line 322 "program.vala"
		valencia_chain_lookup (self->priv->parent, symbols, pos);
#line 2779 "program.c"
	}
}


/* Returns the symbol of the first parent class it finds*/
#line 326 "program.vala"
ValenciaSymbol* valencia_chain_lookup_this (ValenciaChain* self) {
#line 2787 "program.c"
	ValenciaSymbol* result;
#line 326 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 327 "program.vala"
	if (self->priv->parent == NULL) {
#line 2793 "program.c"
		result = NULL;
		return result;
	}
#line 330 "program.vala"
	if (VALENCIA_IS_CLASS (self->priv->parent->priv->scope)) {
#line 2799 "program.c"
		ValenciaSymbol* _tmp0_;
#line 331 "program.vala"
		_tmp0_ = NULL;
#line 2803 "program.c"
		result = (_tmp0_ = VALENCIA_SYMBOL (self->priv->parent->priv->scope), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
		return result;
	}
	result = valencia_chain_lookup_this (self->priv->parent);
	return result;
}


/* Returns the symbol of the base class of the parent class*/
#line 338 "program.vala"
ValenciaSymbol* valencia_chain_lookup_base (ValenciaChain* self, ValenciaSourceFile* sf) {
#line 2815 "program.c"
	ValenciaSymbol* result;
	ValenciaClass* parent_class;
#line 338 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 338 "program.vala"
	g_return_val_if_fail (sf != NULL, NULL);
#line 2822 "program.c"
	parent_class = VALENCIA_CLASS (valencia_chain_lookup_this (self));
#line 340 "program.vala"
	if (parent_class == NULL) {
#line 2826 "program.c"
		result = NULL;
		(parent_class == NULL) ? NULL : (parent_class = (g_object_unref (parent_class), NULL));
		return result;
	}
	{
		GeeIterator* _base_name_it;
		_base_name_it = gee_iterable_iterator ((GeeIterable*) parent_class->super);
#line 343 "program.vala"
		while (TRUE) {
#line 2836 "program.c"
			ValenciaExpression* base_name;
			ValenciaSymbol* base_class;
			gboolean _tmp0_;
#line 343 "program.vala"
			if (!gee_iterator_next (_base_name_it)) {
#line 343 "program.vala"
				break;
#line 2844 "program.c"
			}
			base_name = (ValenciaExpression*) gee_iterator_get (_base_name_it);
			base_class = valencia_source_file_resolve_type (sf, base_name, ((ValenciaNode*) parent_class)->start - 1);
			_tmp0_ = FALSE;
#line 345 "program.vala"
			if (base_class != NULL) {
#line 345 "program.vala"
				_tmp0_ = !VALENCIA_IS_INTERFACE (base_class);
#line 2853 "program.c"
			} else {
#line 345 "program.vala"
				_tmp0_ = FALSE;
#line 2857 "program.c"
			}
#line 345 "program.vala"
			if (_tmp0_) {
#line 2861 "program.c"
				result = base_class;
				(base_name == NULL) ? NULL : (base_name = (g_object_unref (base_name), NULL));
				(_base_name_it == NULL) ? NULL : (_base_name_it = (gee_collection_object_unref (_base_name_it), NULL));
				(parent_class == NULL) ? NULL : (parent_class = (g_object_unref (parent_class), NULL));
				return result;
			}
			(base_name == NULL) ? NULL : (base_name = (g_object_unref (base_name), NULL));
			(base_class == NULL) ? NULL : (base_class = (g_object_unref (base_class), NULL));
		}
		(_base_name_it == NULL) ? NULL : (_base_name_it = (gee_collection_object_unref (_base_name_it), NULL));
	}
	result = NULL;
	(parent_class == NULL) ? NULL : (parent_class = (g_object_unref (parent_class), NULL));
	return result;
}


static void valencia_chain_class_init (ValenciaChainClass * klass) {
	valencia_chain_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaChainPrivate));
	G_OBJECT_CLASS (klass)->finalize = valencia_chain_finalize;
}


static void valencia_chain_instance_init (ValenciaChain * self) {
	self->priv = VALENCIA_CHAIN_GET_PRIVATE (self);
}


static void valencia_chain_finalize (GObject* obj) {
	ValenciaChain * self;
	self = VALENCIA_CHAIN (obj);
	(self->priv->scope == NULL) ? NULL : (self->priv->scope = (g_object_unref (self->priv->scope), NULL));
	(self->priv->parent == NULL) ? NULL : (self->priv->parent = (g_object_unref (self->priv->parent), NULL));
	G_OBJECT_CLASS (valencia_chain_parent_class)->finalize (obj);
}


GType valencia_chain_get_type (void) {
	static GType valencia_chain_type_id = 0;
	if (valencia_chain_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaChainClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_chain_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaChain), 0, (GInstanceInitFunc) valencia_chain_instance_init, NULL };
		valencia_chain_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaChain", &g_define_type_info, 0);
	}
	return valencia_chain_type_id;
}


#line 357 "program.vala"
static GeeArrayList* valencia_block_real_children (ValenciaNode* base) {
#line 2912 "program.c"
	ValenciaBlock * self;
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	self = (ValenciaBlock*) base;
#line 357 "program.vala"
	_tmp0_ = NULL;
#line 2919 "program.c"
	result = (_tmp0_ = self->statements, (_tmp0_ == NULL) ? NULL : gee_collection_object_ref (_tmp0_));
	return result;
}


#line 359 "program.vala"
static gboolean valencia_block_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos) {
#line 2927 "program.c"
	ValenciaBlock * self;
	gboolean result;
	self = (ValenciaBlock*) base;
#line 359 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 2933 "program.c"
	{
		GeeIterator* _s_it;
		_s_it = gee_iterable_iterator ((GeeIterable*) self->statements);
#line 360 "program.vala"
		while (TRUE) {
#line 2939 "program.c"
			ValenciaStatement* s;
#line 360 "program.vala"
			if (!gee_iterator_next (_s_it)) {
#line 360 "program.vala"
				break;
#line 2945 "program.c"
			}
			s = (ValenciaStatement*) gee_iterator_get (_s_it);
#line 361 "program.vala"
			if (((ValenciaNode*) s)->start > pos) {
#line 2950 "program.c"
				result = FALSE;
				(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
				(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
				return result;
			}
#line 363 "program.vala"
			if (valencia_statement_defines_symbol (s, symbols)) {
#line 2958 "program.c"
				result = TRUE;
				(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
				(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
				return result;
			}
			(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
		}
		(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
	}
	result = FALSE;
	return result;
}


#line 369 "program.vala"
static void valencia_block_real_print (ValenciaNode* base, gint level) {
#line 2975 "program.c"
	ValenciaBlock * self;
	self = (ValenciaBlock*) base;
#line 370 "program.vala"
	valencia_node_do_print ((ValenciaNode*) self, level, "block");
#line 2980 "program.c"
	{
		GeeIterator* _s_it;
		_s_it = gee_iterable_iterator ((GeeIterable*) self->statements);
#line 372 "program.vala"
		while (TRUE) {
#line 2986 "program.c"
			ValenciaStatement* s;
#line 372 "program.vala"
			if (!gee_iterator_next (_s_it)) {
#line 372 "program.vala"
				break;
#line 2992 "program.c"
			}
			s = (ValenciaStatement*) gee_iterator_get (_s_it);
#line 373 "program.vala"
			valencia_node_print ((ValenciaNode*) s, level + 1);
#line 2997 "program.c"
			(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
		}
		(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
	}
}


#line 354 "program.vala"
ValenciaBlock* valencia_block_construct (GType object_type) {
#line 3007 "program.c"
	ValenciaBlock * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 354 "program.vala"
ValenciaBlock* valencia_block_new (void) {
#line 354 "program.vala"
	return valencia_block_construct (VALENCIA_TYPE_BLOCK);
#line 3018 "program.c"
}


static void valencia_block_class_init (ValenciaBlockClass * klass) {
	valencia_block_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_NODE_CLASS (klass)->children = valencia_block_real_children;
	VALENCIA_NODE_CLASS (klass)->print = valencia_block_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_block_finalize;
}


static void valencia_block_valencia_scope_interface_init (ValenciaScopeIface * iface) {
	valencia_block_valencia_scope_parent_iface = g_type_interface_peek_parent (iface);
	iface->lookup = valencia_block_real_lookup;
}


static void valencia_block_instance_init (ValenciaBlock * self) {
	self->statements = gee_array_list_new (VALENCIA_TYPE_STATEMENT, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
}


static void valencia_block_finalize (GObject* obj) {
	ValenciaBlock * self;
	self = VALENCIA_BLOCK (obj);
	(self->statements == NULL) ? NULL : (self->statements = (gee_collection_object_unref (self->statements), NULL));
	G_OBJECT_CLASS (valencia_block_parent_class)->finalize (obj);
}


GType valencia_block_get_type (void) {
	static GType valencia_block_type_id = 0;
	if (valencia_block_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaBlockClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_block_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaBlock), 0, (GInstanceInitFunc) valencia_block_instance_init, NULL };
		static const GInterfaceInfo valencia_scope_info = { (GInterfaceInitFunc) valencia_block_valencia_scope_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valencia_block_type_id = g_type_register_static (VALENCIA_TYPE_STATEMENT, "ValenciaBlock", &g_define_type_info, 0);
		g_type_add_interface_static (valencia_block_type_id, VALENCIA_TYPE_SCOPE, &valencia_scope_info);
	}
	return valencia_block_type_id;
}


#line 378 "program.vala"
ValenciaParameter* valencia_parameter_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 3063 "program.c"
	ValenciaParameter * self;
#line 378 "program.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 378 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 378 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 379 "program.vala"
	self = (ValenciaParameter*) valencia_variable_construct (object_type, type, name, source, start, end);
#line 3073 "program.c"
	return self;
}


#line 378 "program.vala"
ValenciaParameter* valencia_parameter_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 378 "program.vala"
	return valencia_parameter_construct (VALENCIA_TYPE_PARAMETER, type, name, source, start, end);
#line 3082 "program.c"
}


#line 382 "program.vala"
static char* valencia_parameter_real_kind (ValenciaVariable* base) {
#line 3088 "program.c"
	ValenciaParameter * self;
	char* result;
	self = (ValenciaParameter*) base;
	result = g_strdup ("parameter");
	return result;
}


static void valencia_parameter_class_init (ValenciaParameterClass * klass) {
	valencia_parameter_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_VARIABLE_CLASS (klass)->kind = valencia_parameter_real_kind;
}


static void valencia_parameter_instance_init (ValenciaParameter * self) {
}


GType valencia_parameter_get_type (void) {
	static GType valencia_parameter_type_id = 0;
	if (valencia_parameter_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaParameterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_parameter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaParameter), 0, (GInstanceInitFunc) valencia_parameter_instance_init, NULL };
		valencia_parameter_type_id = g_type_register_static (VALENCIA_TYPE_VARIABLE, "ValenciaParameter", &g_define_type_info, 0);
	}
	return valencia_parameter_type_id;
}


#line 389 "program.vala"
ValenciaConstruct* valencia_construct_construct (GType object_type, ValenciaBlock* body, gint start, gint end) {
#line 3119 "program.c"
	ValenciaConstruct * self;
	ValenciaBlock* _tmp1_;
	ValenciaBlock* _tmp0_;
#line 389 "program.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 390 "program.vala"
	self = (ValenciaConstruct*) valencia_node_construct (object_type, start, end);
#line 3127 "program.c"
	_tmp1_ = NULL;
#line 391 "program.vala"
	_tmp0_ = NULL;
#line 391 "program.vala"
	self->body = (_tmp1_ = (_tmp0_ = body, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->body == NULL) ? NULL : (self->body = (g_object_unref (self->body), NULL)), _tmp1_);
#line 3133 "program.c"
	return self;
}


#line 389 "program.vala"
ValenciaConstruct* valencia_construct_new (ValenciaBlock* body, gint start, gint end) {
#line 389 "program.vala"
	return valencia_construct_construct (VALENCIA_TYPE_CONSTRUCT, body, start, end);
#line 3142 "program.c"
}


#line 394 "program.vala"
static GeeArrayList* valencia_construct_real_children (ValenciaNode* base) {
#line 3148 "program.c"
	ValenciaConstruct * self;
	GeeArrayList* result;
	self = (ValenciaConstruct*) base;
	result = valencia_node_single_node ((ValenciaNode*) self->body);
	return result;
}


#line 398 "program.vala"
static void valencia_construct_real_print (ValenciaNode* base, gint level) {
#line 3159 "program.c"
	ValenciaConstruct * self;
	self = (ValenciaConstruct*) base;
#line 399 "program.vala"
	valencia_node_do_print ((ValenciaNode*) self, level, "construct");
#line 400 "program.vala"
	if (self->body != NULL) {
#line 401 "program.vala"
		valencia_node_print ((ValenciaNode*) self->body, level + 1);
#line 3168 "program.c"
	}
}


static void valencia_construct_class_init (ValenciaConstructClass * klass) {
	valencia_construct_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_NODE_CLASS (klass)->children = valencia_construct_real_children;
	VALENCIA_NODE_CLASS (klass)->print = valencia_construct_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_construct_finalize;
}


static void valencia_construct_instance_init (ValenciaConstruct * self) {
}


static void valencia_construct_finalize (GObject* obj) {
	ValenciaConstruct * self;
	self = VALENCIA_CONSTRUCT (obj);
	(self->body == NULL) ? NULL : (self->body = (g_object_unref (self->body), NULL));
	G_OBJECT_CLASS (valencia_construct_parent_class)->finalize (obj);
}


GType valencia_construct_get_type (void) {
	static GType valencia_construct_type_id = 0;
	if (valencia_construct_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaConstructClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_construct_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaConstruct), 0, (GInstanceInitFunc) valencia_construct_instance_init, NULL };
		valencia_construct_type_id = g_type_register_static (VALENCIA_TYPE_NODE, "ValenciaConstruct", &g_define_type_info, 0);
	}
	return valencia_construct_type_id;
}


#line 411 "program.vala"
ValenciaMethod* valencia_method_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source) {
#line 3205 "program.c"
	ValenciaMethod * self;
	ValenciaExpression* _tmp1_;
	ValenciaExpression* _tmp0_;
#line 411 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 412 "program.vala"
	self = (ValenciaMethod*) valencia_symbol_construct (object_type, name, source, 0, 0);
#line 3213 "program.c"
	_tmp1_ = NULL;
#line 413 "program.vala"
	_tmp0_ = NULL;
#line 413 "program.vala"
	self->return_type = (_tmp1_ = (_tmp0_ = return_type, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->return_type == NULL) ? NULL : (self->return_type = (g_object_unref (self->return_type), NULL)), _tmp1_);
#line 3219 "program.c"
	return self;
}


#line 411 "program.vala"
ValenciaMethod* valencia_method_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source) {
#line 411 "program.vala"
	return valencia_method_construct (VALENCIA_TYPE_METHOD, name, return_type, source);
#line 3228 "program.c"
}


#line 416 "program.vala"
static GeeArrayList* valencia_method_real_children (ValenciaNode* base) {
#line 3234 "program.c"
	ValenciaMethod * self;
	GeeArrayList* result;
	self = (ValenciaMethod*) base;
	result = valencia_node_single_node ((ValenciaNode*) self->body);
	return result;
}


#line 417 "program.vala"
static gboolean valencia_method_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos) {
#line 3245 "program.c"
	ValenciaMethod * self;
	gboolean result;
	self = (ValenciaMethod*) base;
#line 417 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 3251 "program.c"
	result = valencia_node_lookup_in_array (self->parameters, symbols);
	return result;
}


#line 421 "program.vala"
static void valencia_method_real_print_type (ValenciaMethod* self, gint level) {
#line 421 "program.vala"
	g_return_if_fail (self != NULL);
#line 422 "program.vala"
	valencia_symbol_print_name ((ValenciaSymbol*) self, level, "method");
#line 3263 "program.c"
}


#line 421 "program.vala"
void valencia_method_print_type (ValenciaMethod* self, gint level) {
#line 421 "program.vala"
	VALENCIA_METHOD_GET_CLASS (self)->print_type (self, level);
#line 3271 "program.c"
}


#line 425 "program.vala"
static void valencia_method_real_print (ValenciaNode* base, gint level) {
#line 3277 "program.c"
	ValenciaMethod * self;
	self = (ValenciaMethod*) base;
#line 426 "program.vala"
	valencia_method_print_type (self, level);
#line 3282 "program.c"
	{
		GeeIterator* _p_it;
		_p_it = gee_iterable_iterator ((GeeIterable*) self->parameters);
#line 428 "program.vala"
		while (TRUE) {
#line 3288 "program.c"
			ValenciaParameter* p;
#line 428 "program.vala"
			if (!gee_iterator_next (_p_it)) {
#line 428 "program.vala"
				break;
#line 3294 "program.c"
			}
			p = (ValenciaParameter*) gee_iterator_get (_p_it);
#line 429 "program.vala"
			valencia_node_print ((ValenciaNode*) p, level + 1);
#line 3299 "program.c"
			(p == NULL) ? NULL : (p = (g_object_unref (p), NULL));
		}
		(_p_it == NULL) ? NULL : (_p_it = (gee_collection_object_unref (_p_it), NULL));
	}
#line 430 "program.vala"
	if (self->body != NULL) {
#line 431 "program.vala"
		valencia_node_print ((ValenciaNode*) self->body, level + 1);
#line 3308 "program.c"
	}
}


#line 938 "glib-2.0.vapi"
static gboolean string_contains (const char* self, const char* needle) {
#line 3315 "program.c"
	gboolean result;
#line 938 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 938 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 3321 "program.c"
	result = strstr (self, needle) != NULL;
	return result;
}


#line 434 "program.vala"
void valencia_method_update_prototype (ValenciaMethod* self, const char* proto) {
#line 3329 "program.c"
	char* _tmp1_;
	const char* _tmp0_;
#line 434 "program.vala"
	g_return_if_fail (self != NULL);
#line 434 "program.vala"
	g_return_if_fail (proto != NULL);
#line 3336 "program.c"
	_tmp1_ = NULL;
#line 435 "program.vala"
	_tmp0_ = NULL;
#line 435 "program.vala"
	self->priv->prototype = (_tmp1_ = (_tmp0_ = proto, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->priv->prototype = (g_free (self->priv->prototype), NULL), _tmp1_);
#line 436 "program.vala"
	g_strchomp (self->priv->prototype);
#line 3344 "program.c"
	/* Clean up newlines and remove extra spaces*/
#line 439 "program.vala"
	if (string_contains (self->priv->prototype, "\n")) {
#line 3348 "program.c"
		char** _tmp3_;
		gint split_lines_size;
		gint split_lines_length1;
		char** _tmp2_;
		char** split_lines;
		char* _tmp4_;
#line 440 "program.vala"
		_tmp3_ = NULL;
#line 3357 "program.c"
		_tmp2_ = NULL;
		split_lines = (_tmp3_ = _tmp2_ = g_strsplit (self->priv->prototype, "\n", 0), split_lines_length1 = _vala_array_length (_tmp2_), split_lines_size = split_lines_length1, _tmp3_);
		_tmp4_ = NULL;
#line 441 "program.vala"
		self->priv->prototype = (_tmp4_ = g_strdup (""), self->priv->prototype = (g_free (self->priv->prototype), NULL), _tmp4_);
#line 3363 "program.c"
		{
			gint i;
			i = 0;
			{
				gboolean _tmp5_;
				_tmp5_ = TRUE;
#line 442 "program.vala"
				while (TRUE) {
#line 3372 "program.c"
					const char* str;
					char* _tmp6_;
#line 442 "program.vala"
					if (!_tmp5_) {
#line 442 "program.vala"
						i = i + 1;
#line 3379 "program.c"
					}
#line 442 "program.vala"
					_tmp5_ = FALSE;
#line 442 "program.vala"
					if (!(split_lines[i] != NULL)) {
#line 442 "program.vala"
						break;
#line 3387 "program.c"
					}
					str = split_lines[i];
#line 444 "program.vala"
					g_strstrip (str);
#line 3392 "program.c"
					_tmp6_ = NULL;
#line 445 "program.vala"
					self->priv->prototype = (_tmp6_ = g_strconcat (self->priv->prototype, str, NULL), self->priv->prototype = (g_free (self->priv->prototype), NULL), _tmp6_);
#line 446 "program.vala"
					if (split_lines[i + 1] != NULL) {
#line 3398 "program.c"
						char* _tmp7_;
						_tmp7_ = NULL;
#line 447 "program.vala"
						self->priv->prototype = (_tmp7_ = g_strconcat (self->priv->prototype, " ", NULL), self->priv->prototype = (g_free (self->priv->prototype), NULL), _tmp7_);
#line 3403 "program.c"
					}
				}
			}
		}
		split_lines = (_vala_array_free (split_lines, split_lines_length1, (GDestroyNotify) g_free), NULL);
	}
}


#line 452 "program.vala"
char* valencia_method_to_string (ValenciaMethod* self) {
#line 3415 "program.c"
	char* result;
	const char* _tmp0_;
#line 452 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 453 "program.vala"
	_tmp0_ = NULL;
#line 3422 "program.c"
	result = (_tmp0_ = self->priv->prototype, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	return result;
}


static void valencia_method_class_init (ValenciaMethodClass * klass) {
	valencia_method_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaMethodPrivate));
	VALENCIA_NODE_CLASS (klass)->children = valencia_method_real_children;
	VALENCIA_METHOD_CLASS (klass)->print_type = valencia_method_real_print_type;
	VALENCIA_NODE_CLASS (klass)->print = valencia_method_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_method_finalize;
}


static void valencia_method_valencia_scope_interface_init (ValenciaScopeIface * iface) {
	valencia_method_valencia_scope_parent_iface = g_type_interface_peek_parent (iface);
	iface->lookup = valencia_method_real_lookup;
}


static void valencia_method_instance_init (ValenciaMethod * self) {
	self->priv = VALENCIA_METHOD_GET_PRIVATE (self);
	self->parameters = gee_array_list_new (VALENCIA_TYPE_PARAMETER, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
	self->priv->prototype = g_strdup ("");
}


static void valencia_method_finalize (GObject* obj) {
	ValenciaMethod * self;
	self = VALENCIA_METHOD (obj);
	(self->parameters == NULL) ? NULL : (self->parameters = (gee_collection_object_unref (self->parameters), NULL));
	(self->return_type == NULL) ? NULL : (self->return_type = (g_object_unref (self->return_type), NULL));
	(self->body == NULL) ? NULL : (self->body = (g_object_unref (self->body), NULL));
	self->priv->prototype = (g_free (self->priv->prototype), NULL);
	G_OBJECT_CLASS (valencia_method_parent_class)->finalize (obj);
}


GType valencia_method_get_type (void) {
	static GType valencia_method_type_id = 0;
	if (valencia_method_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaMethodClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_method_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaMethod), 0, (GInstanceInitFunc) valencia_method_instance_init, NULL };
		static const GInterfaceInfo valencia_scope_info = { (GInterfaceInitFunc) valencia_method_valencia_scope_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valencia_method_type_id = g_type_register_static (VALENCIA_TYPE_SYMBOL, "ValenciaMethod", &g_define_type_info, 0);
		g_type_add_interface_static (valencia_method_type_id, VALENCIA_TYPE_SCOPE, &valencia_scope_info);
	}
	return valencia_method_type_id;
}


#line 460 "program.vala"
ValenciaVSignal* valencia_vsignal_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source) {
#line 3476 "program.c"
	ValenciaVSignal * self;
#line 460 "program.vala"
	g_return_val_if_fail (return_type != NULL, NULL);
#line 460 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 461 "program.vala"
	self = (ValenciaVSignal*) valencia_method_construct (object_type, name, return_type, source);
#line 3484 "program.c"
	return self;
}


#line 460 "program.vala"
ValenciaVSignal* valencia_vsignal_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source) {
#line 460 "program.vala"
	return valencia_vsignal_construct (VALENCIA_TYPE_VSIGNAL, name, return_type, source);
#line 3493 "program.c"
}


static void valencia_vsignal_class_init (ValenciaVSignalClass * klass) {
	valencia_vsignal_parent_class = g_type_class_peek_parent (klass);
}


static void valencia_vsignal_instance_init (ValenciaVSignal * self) {
}


GType valencia_vsignal_get_type (void) {
	static GType valencia_vsignal_type_id = 0;
	if (valencia_vsignal_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaVSignalClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_vsignal_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaVSignal), 0, (GInstanceInitFunc) valencia_vsignal_instance_init, NULL };
		valencia_vsignal_type_id = g_type_register_static (VALENCIA_TYPE_METHOD, "ValenciaVSignal", &g_define_type_info, 0);
	}
	return valencia_vsignal_type_id;
}


#line 466 "program.vala"
ValenciaDelegate* valencia_delegate_construct (GType object_type, const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source) {
#line 3518 "program.c"
	ValenciaDelegate * self;
#line 466 "program.vala"
	g_return_val_if_fail (return_type != NULL, NULL);
#line 466 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 467 "program.vala"
	self = (ValenciaDelegate*) valencia_method_construct (object_type, name, return_type, source);
#line 3526 "program.c"
	return self;
}


#line 466 "program.vala"
ValenciaDelegate* valencia_delegate_new (const char* name, ValenciaExpression* return_type, ValenciaSourceFile* source) {
#line 466 "program.vala"
	return valencia_delegate_construct (VALENCIA_TYPE_DELEGATE, name, return_type, source);
#line 3535 "program.c"
}


static void valencia_delegate_class_init (ValenciaDelegateClass * klass) {
	valencia_delegate_parent_class = g_type_class_peek_parent (klass);
}


static void valencia_delegate_instance_init (ValenciaDelegate * self) {
}


GType valencia_delegate_get_type (void) {
	static GType valencia_delegate_type_id = 0;
	if (valencia_delegate_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaDelegateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_delegate_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaDelegate), 0, (GInstanceInitFunc) valencia_delegate_instance_init, NULL };
		valencia_delegate_type_id = g_type_register_static (VALENCIA_TYPE_METHOD, "ValenciaDelegate", &g_define_type_info, 0);
	}
	return valencia_delegate_type_id;
}


#line 474 "program.vala"
ValenciaConstructor* valencia_constructor_construct (GType object_type, const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source) {
#line 3560 "program.c"
	ValenciaConstructor * self;
#line 474 "program.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 474 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 475 "program.vala"
	self = (ValenciaConstructor*) valencia_method_construct (object_type, unqualified_name, NULL, source);
#line 476 "program.vala"
	self->parent = parent;
#line 3570 "program.c"
	return self;
}


#line 474 "program.vala"
ValenciaConstructor* valencia_constructor_new (const char* unqualified_name, ValenciaClass* parent, ValenciaSourceFile* source) {
#line 474 "program.vala"
	return valencia_constructor_construct (VALENCIA_TYPE_CONSTRUCTOR, unqualified_name, parent, source);
#line 3579 "program.c"
}


#line 479 "program.vala"
static void valencia_constructor_real_print_type (ValenciaMethod* base, gint level) {
#line 3585 "program.c"
	ValenciaConstructor * self;
	self = (ValenciaConstructor*) base;
#line 480 "program.vala"
	valencia_node_do_print ((ValenciaNode*) self, level, "constructor");
#line 3590 "program.c"
}


static void valencia_constructor_class_init (ValenciaConstructorClass * klass) {
	valencia_constructor_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_METHOD_CLASS (klass)->print_type = valencia_constructor_real_print_type;
	G_OBJECT_CLASS (klass)->finalize = valencia_constructor_finalize;
}


static void valencia_constructor_instance_init (ValenciaConstructor * self) {
}


static void valencia_constructor_finalize (GObject* obj) {
	ValenciaConstructor * self;
	self = VALENCIA_CONSTRUCTOR (obj);
	G_OBJECT_CLASS (valencia_constructor_parent_class)->finalize (obj);
}


GType valencia_constructor_get_type (void) {
	static GType valencia_constructor_type_id = 0;
	if (valencia_constructor_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaConstructorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_constructor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaConstructor), 0, (GInstanceInitFunc) valencia_constructor_instance_init, NULL };
		valencia_constructor_type_id = g_type_register_static (VALENCIA_TYPE_METHOD, "ValenciaConstructor", &g_define_type_info, 0);
	}
	return valencia_constructor_type_id;
}


#line 485 "program.vala"
ValenciaField* valencia_field_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 3624 "program.c"
	ValenciaField * self;
#line 485 "program.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 485 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 485 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 486 "program.vala"
	self = (ValenciaField*) valencia_variable_construct (object_type, type, name, source, start, end);
#line 3634 "program.c"
	return self;
}


#line 485 "program.vala"
ValenciaField* valencia_field_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 485 "program.vala"
	return valencia_field_construct (VALENCIA_TYPE_FIELD, type, name, source, start, end);
#line 3643 "program.c"
}


#line 489 "program.vala"
static char* valencia_field_real_kind (ValenciaVariable* base) {
#line 3649 "program.c"
	ValenciaField * self;
	char* result;
	self = (ValenciaField*) base;
	result = g_strdup ("field");
	return result;
}


static void valencia_field_class_init (ValenciaFieldClass * klass) {
	valencia_field_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_VARIABLE_CLASS (klass)->kind = valencia_field_real_kind;
}


static void valencia_field_instance_init (ValenciaField * self) {
}


GType valencia_field_get_type (void) {
	static GType valencia_field_type_id = 0;
	if (valencia_field_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaFieldClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_field_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaField), 0, (GInstanceInitFunc) valencia_field_instance_init, NULL };
		valencia_field_type_id = g_type_register_static (VALENCIA_TYPE_VARIABLE, "ValenciaField", &g_define_type_info, 0);
	}
	return valencia_field_type_id;
}


#line 496 "program.vala"
ValenciaProperty* valencia_property_construct (GType object_type, ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 3680 "program.c"
	ValenciaProperty * self;
#line 496 "program.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 496 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 496 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 497 "program.vala"
	self = (ValenciaProperty*) valencia_variable_construct (object_type, type, name, source, start, end);
#line 3690 "program.c"
	return self;
}


#line 496 "program.vala"
ValenciaProperty* valencia_property_new (ValenciaExpression* type, const char* name, ValenciaSourceFile* source, gint start, gint end) {
#line 496 "program.vala"
	return valencia_property_construct (VALENCIA_TYPE_PROPERTY, type, name, source, start, end);
#line 3699 "program.c"
}


#line 500 "program.vala"
static GeeArrayList* valencia_property_real_children (ValenciaNode* base) {
#line 3705 "program.c"
	ValenciaProperty * self;
	GeeArrayList* result;
	self = (ValenciaProperty*) base;
	result = valencia_node_single_node ((ValenciaNode*) self->body);
	return result;
}


#line 504 "program.vala"
static char* valencia_property_real_kind (ValenciaVariable* base) {
#line 3716 "program.c"
	ValenciaProperty * self;
	char* result;
	self = (ValenciaProperty*) base;
	result = g_strdup ("property");
	return result;
}


#line 506 "program.vala"
static void valencia_property_real_print (ValenciaNode* base, gint level) {
#line 3727 "program.c"
	ValenciaProperty * self;
	self = (ValenciaProperty*) base;
#line 507 "program.vala"
	VALENCIA_NODE_CLASS (valencia_property_parent_class)->print ((ValenciaNode*) VALENCIA_VARIABLE (self), level);
#line 508 "program.vala"
	valencia_node_print ((ValenciaNode*) self->body, level + 1);
#line 3734 "program.c"
}


static void valencia_property_class_init (ValenciaPropertyClass * klass) {
	valencia_property_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_NODE_CLASS (klass)->children = valencia_property_real_children;
	VALENCIA_VARIABLE_CLASS (klass)->kind = valencia_property_real_kind;
	VALENCIA_NODE_CLASS (klass)->print = valencia_property_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_property_finalize;
}


static void valencia_property_instance_init (ValenciaProperty * self) {
}


static void valencia_property_finalize (GObject* obj) {
	ValenciaProperty * self;
	self = VALENCIA_PROPERTY (obj);
	(self->body == NULL) ? NULL : (self->body = (g_object_unref (self->body), NULL));
	G_OBJECT_CLASS (valencia_property_parent_class)->finalize (obj);
}


GType valencia_property_get_type (void) {
	static GType valencia_property_type_id = 0;
	if (valencia_property_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaPropertyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_property_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaProperty), 0, (GInstanceInitFunc) valencia_property_instance_init, NULL };
		valencia_property_type_id = g_type_register_static (VALENCIA_TYPE_VARIABLE, "ValenciaProperty", &g_define_type_info, 0);
	}
	return valencia_property_type_id;
}


#line 518 "program.vala"
ValenciaClass* valencia_class_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class) {
#line 3771 "program.c"
	ValenciaClass * self;
#line 518 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 518 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 519 "program.vala"
	self = (ValenciaClass*) valencia_typesymbol_construct (object_type, name, source, 0, 0);
#line 520 "program.vala"
	self->priv->enclosing_class = enclosing_class;
#line 3781 "program.c"
	return self;
}


#line 518 "program.vala"
ValenciaClass* valencia_class_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class) {
#line 518 "program.vala"
	return valencia_class_construct (VALENCIA_TYPE_CLASS, name, source, enclosing_class);
#line 3790 "program.c"
}


#line 523 "program.vala"
static GeeArrayList* valencia_class_real_children (ValenciaNode* base) {
#line 3796 "program.c"
	ValenciaClass * self;
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	self = (ValenciaClass*) base;
#line 523 "program.vala"
	_tmp0_ = NULL;
#line 3803 "program.c"
	result = (_tmp0_ = self->members, (_tmp0_ == NULL) ? NULL : gee_collection_object_ref (_tmp0_));
	return result;
}


#line 525 "program.vala"
ValenciaSymbol* valencia_class_lookup_constructor (ValenciaClass* self) {
#line 3811 "program.c"
	ValenciaSymbol* result;
#line 525 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3815 "program.c"
	{
		GeeIterator* _n_it;
		_n_it = gee_iterable_iterator ((GeeIterable*) self->members);
#line 526 "program.vala"
		while (TRUE) {
#line 3821 "program.c"
			ValenciaNode* n;
			ValenciaConstructor* _tmp1_;
			ValenciaNode* _tmp0_;
			ValenciaConstructor* c;
			gboolean _tmp2_;
#line 526 "program.vala"
			if (!gee_iterator_next (_n_it)) {
#line 526 "program.vala"
				break;
#line 3831 "program.c"
			}
			n = (ValenciaNode*) gee_iterator_get (_n_it);
#line 527 "program.vala"
			_tmp1_ = NULL;
#line 527 "program.vala"
			_tmp0_ = NULL;
#line 3838 "program.c"
			c = (_tmp1_ = (_tmp0_ = n, VALENCIA_IS_CONSTRUCTOR (_tmp0_) ? ((ValenciaConstructor*) _tmp0_) : NULL), (_tmp1_ == NULL) ? NULL : g_object_ref (_tmp1_));
			_tmp2_ = FALSE;
#line 529 "program.vala"
			if (c != NULL) {
#line 529 "program.vala"
				_tmp2_ = ((ValenciaSymbol*) c)->name == NULL;
#line 3845 "program.c"
			} else {
#line 529 "program.vala"
				_tmp2_ = FALSE;
#line 3849 "program.c"
			}
			/* Don't accept named constructors*/
#line 529 "program.vala"
			if (_tmp2_) {
#line 3854 "program.c"
				ValenciaSymbol* _tmp3_;
#line 530 "program.vala"
				_tmp3_ = NULL;
#line 3858 "program.c"
				result = (_tmp3_ = VALENCIA_SYMBOL (c), (_tmp3_ == NULL) ? NULL : g_object_ref (_tmp3_));
				(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
				(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
				(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
				return result;
			}
			(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
			(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
		}
		(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
	}
	result = NULL;
	return result;
}


#line 536 "program.vala"
static gboolean valencia_class_lookup1 (ValenciaClass* self, ValenciaSymbolSet* symbols, GeeHashSet* seen) {
#line 3877 "program.c"
	gboolean result;
#line 536 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 536 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 536 "program.vala"
	g_return_val_if_fail (seen != NULL, FALSE);
#line 537 "program.vala"
	if (valencia_node_lookup_in_array (self->members, symbols)) {
#line 3887 "program.c"
		result = TRUE;
		return result;
	}
	/* Make sure we don't run into an infinite loop if a user makes this mistake:
	 class Foo : Foo { ...*/
#line 542 "program.vala"
	gee_collection_add ((GeeCollection*) seen, self);
#line 3895 "program.c"
	/* look in superclasses        */
	{
		GeeIterator* _s_it;
		/* look in superclasses        */
		_s_it = gee_iterable_iterator ((GeeIterable*) self->super);
		/* look in superclasses        */
#line 545 "program.vala"
		while (TRUE) {
#line 3904 "program.c"
			ValenciaExpression* s;
			ValenciaSymbol* _tmp0_;
			ValenciaClass* c;
			gboolean _tmp1_;
			/* look in superclasses        */
#line 545 "program.vala"
			if (!gee_iterator_next (_s_it)) {
#line 3912 "program.c"
				/* look in superclasses        */
#line 545 "program.vala"
				break;
#line 3916 "program.c"
			}
			/* look in superclasses        */
			s = (ValenciaExpression*) gee_iterator_get (_s_it);
			/* We look up the parent class in the scope at (start - 1); that excludes
			 this class itself (but will include the containing sourcefile,
			 even if start == 0.)*/
#line 549 "program.vala"
			_tmp0_ = NULL;
#line 3925 "program.c"
			c = (_tmp0_ = valencia_source_file_resolve_type (((ValenciaSymbol*) self)->source, s, ((ValenciaNode*) self)->start - 1), VALENCIA_IS_CLASS (_tmp0_) ? ((ValenciaClass*) _tmp0_) : NULL);
			_tmp1_ = FALSE;
#line 551 "program.vala"
			if (c != NULL) {
#line 551 "program.vala"
				_tmp1_ = !gee_collection_contains ((GeeCollection*) seen, c);
#line 3932 "program.c"
			} else {
#line 551 "program.vala"
				_tmp1_ = FALSE;
#line 3936 "program.c"
			}
#line 551 "program.vala"
			if (_tmp1_) {
#line 552 "program.vala"
				if (valencia_class_lookup1 (c, symbols, seen)) {
#line 3942 "program.c"
					result = TRUE;
					(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
					(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
					(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
					return result;
				}
			}
			(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
			(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
		}
		(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
	}
	result = FALSE;
	return result;
}


#line 560 "program.vala"
static gboolean valencia_class_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos) {
#line 3962 "program.c"
	ValenciaClass * self;
	gboolean result;
	GeeHashSet* _tmp0_;
	gboolean _tmp1_;
	self = (ValenciaClass*) base;
#line 560 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 3970 "program.c"
	_tmp0_ = NULL;
	result = (_tmp1_ = valencia_class_lookup1 (self, symbols, _tmp0_ = gee_hash_set_new (VALENCIA_TYPE_CLASS, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_hash, g_direct_equal)), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (gee_collection_object_unref (_tmp0_), NULL)), _tmp1_);
	return result;
}


#line 564 "program.vala"
static void valencia_class_real_print (ValenciaNode* base, gint level) {
#line 3979 "program.c"
	ValenciaClass * self;
	GString* sb;
	char* _tmp0_;
	self = (ValenciaClass*) base;
	sb = g_string_new ("");
	_tmp0_ = NULL;
#line 566 "program.vala"
	g_string_append (sb, _tmp0_ = g_strconcat ("class ", ((ValenciaSymbol*) self)->name, NULL));
#line 3988 "program.c"
	_tmp0_ = (g_free (_tmp0_), NULL);
	{
		gint i;
		i = 0;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
#line 567 "program.vala"
			while (TRUE) {
#line 3998 "program.c"
				const char* _tmp2_;
				char* _tmp4_;
				ValenciaExpression* _tmp3_;
#line 567 "program.vala"
				if (!_tmp1_) {
#line 567 "program.vala"
					i = i + 1;
#line 4006 "program.c"
				}
#line 567 "program.vala"
				_tmp1_ = FALSE;
#line 567 "program.vala"
				if (!(i < gee_collection_get_size ((GeeCollection*) self->super))) {
#line 567 "program.vala"
					break;
#line 4014 "program.c"
				}
				_tmp2_ = NULL;
#line 568 "program.vala"
				if (i == 0) {
#line 568 "program.vala"
					_tmp2_ = " : ";
#line 4021 "program.c"
				} else {
#line 568 "program.vala"
					_tmp2_ = ", ";
#line 4025 "program.c"
				}
#line 568 "program.vala"
				g_string_append (sb, _tmp2_);
#line 10 "expression.vala"
				_tmp4_ = NULL;
#line 514 "program.vala"
				_tmp3_ = NULL;
#line 569 "program.vala"
				g_string_append (sb, _tmp4_ = valencia_expression_to_string (_tmp3_ = (ValenciaExpression*) gee_list_get ((GeeList*) self->super, i)));
#line 4035 "program.c"
				_tmp4_ = (g_free (_tmp4_), NULL);
				(_tmp3_ == NULL) ? NULL : (_tmp3_ = (g_object_unref (_tmp3_), NULL));
			}
		}
	}
#line 571 "program.vala"
	valencia_node_do_print ((ValenciaNode*) self, level, sb->str);
#line 4043 "program.c"
	{
		GeeIterator* _n_it;
		_n_it = gee_iterable_iterator ((GeeIterable*) self->members);
#line 573 "program.vala"
		while (TRUE) {
#line 4049 "program.c"
			ValenciaNode* n;
#line 573 "program.vala"
			if (!gee_iterator_next (_n_it)) {
#line 573 "program.vala"
				break;
#line 4055 "program.c"
			}
			n = (ValenciaNode*) gee_iterator_get (_n_it);
#line 574 "program.vala"
			valencia_node_print (n, level + 1);
#line 4060 "program.c"
			(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
		}
		(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
	}
	(sb == NULL) ? NULL : (sb = (g_string_free (sb, TRUE), NULL));
}


#line 577 "program.vala"
char* valencia_class_to_string (ValenciaClass* self) {
#line 4071 "program.c"
	char* result;
	char* _tmp0_;
#line 577 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 4076 "program.c"
	_tmp0_ = NULL;
#line 578 "program.vala"
	if (self->priv->enclosing_class != NULL) {
#line 4080 "program.c"
		char* _tmp3_;
		char* _tmp2_;
		char* _tmp1_;
		_tmp3_ = NULL;
		_tmp2_ = NULL;
#line 577 "program.vala"
		_tmp1_ = NULL;
#line 578 "program.vala"
		_tmp0_ = (_tmp3_ = g_strconcat (_tmp2_ = g_strconcat (_tmp1_ = valencia_class_to_string (self->priv->enclosing_class), ".", NULL), ((ValenciaSymbol*) self)->name, NULL), _tmp0_ = (g_free (_tmp0_), NULL), _tmp3_);
#line 4090 "program.c"
		_tmp2_ = (g_free (_tmp2_), NULL);
		_tmp1_ = (g_free (_tmp1_), NULL);
	} else {
		char* _tmp5_;
		const char* _tmp4_;
		_tmp5_ = NULL;
#line 578 "program.vala"
		_tmp4_ = NULL;
#line 578 "program.vala"
		_tmp0_ = (_tmp5_ = (_tmp4_ = ((ValenciaSymbol*) self)->name, (_tmp4_ == NULL) ? NULL : g_strdup (_tmp4_)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp5_);
#line 4101 "program.c"
	}
	result = _tmp0_;
	return result;
}


static void valencia_class_class_init (ValenciaClassClass * klass) {
	valencia_class_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaClassPrivate));
	VALENCIA_NODE_CLASS (klass)->children = valencia_class_real_children;
	VALENCIA_NODE_CLASS (klass)->print = valencia_class_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_class_finalize;
}


static void valencia_class_valencia_scope_interface_init (ValenciaScopeIface * iface) {
	valencia_class_valencia_scope_parent_iface = g_type_interface_peek_parent (iface);
	iface->lookup = valencia_class_real_lookup;
}


static void valencia_class_instance_init (ValenciaClass * self) {
	self->priv = VALENCIA_CLASS_GET_PRIVATE (self);
	self->super = gee_array_list_new (VALENCIA_TYPE_EXPRESSION, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
	self->members = gee_array_list_new (VALENCIA_TYPE_NODE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
}


static void valencia_class_finalize (GObject* obj) {
	ValenciaClass * self;
	self = VALENCIA_CLASS (obj);
	(self->super == NULL) ? NULL : (self->super = (gee_collection_object_unref (self->super), NULL));
	(self->members == NULL) ? NULL : (self->members = (gee_collection_object_unref (self->members), NULL));
	G_OBJECT_CLASS (valencia_class_parent_class)->finalize (obj);
}


GType valencia_class_get_type (void) {
	static GType valencia_class_type_id = 0;
	if (valencia_class_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaClassClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_class_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaClass), 0, (GInstanceInitFunc) valencia_class_instance_init, NULL };
		static const GInterfaceInfo valencia_scope_info = { (GInterfaceInitFunc) valencia_class_valencia_scope_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valencia_class_type_id = g_type_register_static (VALENCIA_TYPE_TYPESYMBOL, "ValenciaClass", &g_define_type_info, 0);
		g_type_add_interface_static (valencia_class_type_id, VALENCIA_TYPE_SCOPE, &valencia_scope_info);
	}
	return valencia_class_type_id;
}


#line 583 "program.vala"
ValenciaInterface* valencia_interface_construct (GType object_type, const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class) {
#line 4153 "program.c"
	ValenciaInterface * self;
#line 583 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 583 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 584 "program.vala"
	self = (ValenciaInterface*) valencia_class_construct (object_type, name, source, enclosing_class);
#line 4161 "program.c"
	return self;
}


#line 583 "program.vala"
ValenciaInterface* valencia_interface_new (const char* name, ValenciaSourceFile* source, ValenciaClass* enclosing_class) {
#line 583 "program.vala"
	return valencia_interface_construct (VALENCIA_TYPE_INTERFACE, name, source, enclosing_class);
#line 4170 "program.c"
}


static void valencia_interface_class_init (ValenciaInterfaceClass * klass) {
	valencia_interface_parent_class = g_type_class_peek_parent (klass);
}


static void valencia_interface_instance_init (ValenciaInterface * self) {
}


GType valencia_interface_get_type (void) {
	static GType valencia_interface_type_id = 0;
	if (valencia_interface_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaInterfaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_interface_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaInterface), 0, (GInstanceInitFunc) valencia_interface_instance_init, NULL };
		valencia_interface_type_id = g_type_register_static (VALENCIA_TYPE_CLASS, "ValenciaInterface", &g_define_type_info, 0);
	}
	return valencia_interface_type_id;
}


#line 592 "program.vala"
ValenciaNamespace* valencia_namespace_construct (GType object_type, const char* name, const char* full_name, ValenciaSourceFile* source) {
#line 4195 "program.c"
	ValenciaNamespace * self;
	char* _tmp1_;
	const char* _tmp0_;
#line 592 "program.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 593 "program.vala"
	self = (ValenciaNamespace*) valencia_typesymbol_construct (object_type, name, source, 0, 0);
#line 4203 "program.c"
	_tmp1_ = NULL;
#line 594 "program.vala"
	_tmp0_ = NULL;
#line 594 "program.vala"
	self->full_name = (_tmp1_ = (_tmp0_ = full_name, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->full_name = (g_free (self->full_name), NULL), _tmp1_);
#line 4209 "program.c"
	return self;
}


#line 592 "program.vala"
ValenciaNamespace* valencia_namespace_new (const char* name, const char* full_name, ValenciaSourceFile* source) {
#line 592 "program.vala"
	return valencia_namespace_construct (VALENCIA_TYPE_NAMESPACE, name, full_name, source);
#line 4218 "program.c"
}


#line 599 "program.vala"
static GeeArrayList* valencia_namespace_real_children (ValenciaNode* base) {
#line 4224 "program.c"
	ValenciaNamespace * self;
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
	self = (ValenciaNamespace*) base;
#line 599 "program.vala"
	_tmp0_ = NULL;
#line 4231 "program.c"
	result = (_tmp0_ = self->symbols, (_tmp0_ == NULL) ? NULL : gee_collection_object_ref (_tmp0_));
	return result;
}


#line 601 "program.vala"
static gboolean valencia_namespace_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos) {
#line 4239 "program.c"
	ValenciaNamespace * self;
	gboolean result;
	self = (ValenciaNamespace*) base;
#line 601 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 4245 "program.c"
	result = valencia_program_lookup_in_namespace (((ValenciaSymbol*) self)->source->program, self->full_name, symbols);
	return result;
}


#line 605 "program.vala"
gboolean valencia_namespace_lookup1 (ValenciaNamespace* self, ValenciaSymbolSet* symbols) {
#line 4253 "program.c"
	gboolean result;
#line 605 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 605 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 4259 "program.c"
	result = valencia_node_lookup_in_array (self->symbols, symbols);
	return result;
}


#line 609 "program.vala"
void valencia_namespace_lookup_all_toplevel_symbols (ValenciaNamespace* self, ValenciaSymbolSet* symbols) {
#line 609 "program.vala"
	g_return_if_fail (self != NULL);
#line 609 "program.vala"
	g_return_if_fail (symbols != NULL);
#line 4271 "program.c"
	{
		GeeIterator* _s_it;
		_s_it = gee_iterable_iterator ((GeeIterable*) self->symbols);
#line 610 "program.vala"
		while (TRUE) {
#line 4277 "program.c"
			ValenciaSymbol* s;
#line 610 "program.vala"
			if (!gee_iterator_next (_s_it)) {
#line 610 "program.vala"
				break;
#line 4283 "program.c"
			}
			s = (ValenciaSymbol*) gee_iterator_get (_s_it);
#line 611 "program.vala"
			if (VALENCIA_IS_NAMESPACE (s)) {
#line 4288 "program.c"
				ValenciaNamespace* _tmp0_;
				ValenciaNamespace* n;
#line 612 "program.vala"
				_tmp0_ = NULL;
#line 4293 "program.c"
				n = (_tmp0_ = VALENCIA_NAMESPACE (s), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
#line 613 "program.vala"
				valencia_namespace_lookup_all_toplevel_symbols (n, symbols);
#line 4297 "program.c"
				(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
			} else {
#line 615 "program.vala"
				valencia_symbol_set_add (symbols, s);
#line 4302 "program.c"
			}
			(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
		}
		(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
	}
}


#line 620 "program.vala"
static void valencia_namespace_real_print (ValenciaNode* base, gint level) {
#line 4313 "program.c"
	ValenciaNamespace * self;
	self = (ValenciaNamespace*) base;
#line 621 "program.vala"
	valencia_symbol_print_name ((ValenciaSymbol*) self, level, "namespace");
#line 4318 "program.c"
	{
		GeeIterator* _s_it;
		_s_it = gee_iterable_iterator ((GeeIterable*) self->symbols);
#line 622 "program.vala"
		while (TRUE) {
#line 4324 "program.c"
			ValenciaSymbol* s;
#line 622 "program.vala"
			if (!gee_iterator_next (_s_it)) {
#line 622 "program.vala"
				break;
#line 4330 "program.c"
			}
			s = (ValenciaSymbol*) gee_iterator_get (_s_it);
#line 623 "program.vala"
			valencia_node_print ((ValenciaNode*) s, level + 1);
#line 4335 "program.c"
			(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
		}
		(_s_it == NULL) ? NULL : (_s_it = (gee_collection_object_unref (_s_it), NULL));
	}
}


static void valencia_namespace_class_init (ValenciaNamespaceClass * klass) {
	valencia_namespace_parent_class = g_type_class_peek_parent (klass);
	VALENCIA_NODE_CLASS (klass)->children = valencia_namespace_real_children;
	VALENCIA_NODE_CLASS (klass)->print = valencia_namespace_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_namespace_finalize;
}


static void valencia_namespace_valencia_scope_interface_init (ValenciaScopeIface * iface) {
	valencia_namespace_valencia_scope_parent_iface = g_type_interface_peek_parent (iface);
	iface->lookup = valencia_namespace_real_lookup;
}


static void valencia_namespace_instance_init (ValenciaNamespace * self) {
	self->symbols = gee_array_list_new (VALENCIA_TYPE_SYMBOL, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
}


static void valencia_namespace_finalize (GObject* obj) {
	ValenciaNamespace * self;
	self = VALENCIA_NAMESPACE (obj);
	self->full_name = (g_free (self->full_name), NULL);
	(self->symbols == NULL) ? NULL : (self->symbols = (gee_collection_object_unref (self->symbols), NULL));
	G_OBJECT_CLASS (valencia_namespace_parent_class)->finalize (obj);
}


GType valencia_namespace_get_type (void) {
	static GType valencia_namespace_type_id = 0;
	if (valencia_namespace_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaNamespaceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_namespace_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaNamespace), 0, (GInstanceInitFunc) valencia_namespace_instance_init, NULL };
		static const GInterfaceInfo valencia_scope_info = { (GInterfaceInitFunc) valencia_namespace_valencia_scope_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valencia_namespace_type_id = g_type_register_static (VALENCIA_TYPE_TYPESYMBOL, "ValenciaNamespace", &g_define_type_info, 0);
		g_type_add_interface_static (valencia_namespace_type_id, VALENCIA_TYPE_SCOPE, &valencia_scope_info);
	}
	return valencia_namespace_type_id;
}


#line 635 "program.vala"
ValenciaSourceFile* valencia_source_file_construct (GType object_type, ValenciaProgram* program, const char* filename) {
#line 4385 "program.c"
	ValenciaSourceFile * self;
	char* _tmp1_;
	const char* _tmp0_;
#line 635 "program.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 4391 "program.c"
	self = g_object_newv (object_type, 0, NULL);
#line 636 "program.vala"
	self->program = program;
#line 4395 "program.c"
	_tmp1_ = NULL;
#line 637 "program.vala"
	_tmp0_ = NULL;
#line 637 "program.vala"
	self->filename = (_tmp1_ = (_tmp0_ = filename, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->filename = (g_free (self->filename), NULL), _tmp1_);
#line 638 "program.vala"
	valencia_source_file_alloc_top (self);
#line 4403 "program.c"
	return self;
}


#line 635 "program.vala"
ValenciaSourceFile* valencia_source_file_new (ValenciaProgram* program, const char* filename) {
#line 635 "program.vala"
	return valencia_source_file_construct (VALENCIA_TYPE_SOURCE_FILE, program, filename);
#line 4412 "program.c"
}


#line 641 "program.vala"
static void valencia_source_file_alloc_top (ValenciaSourceFile* self) {
#line 4418 "program.c"
	ValenciaNamespace* _tmp0_;
#line 641 "program.vala"
	g_return_if_fail (self != NULL);
#line 4422 "program.c"
	_tmp0_ = NULL;
#line 642 "program.vala"
	self->top = (_tmp0_ = valencia_namespace_new (NULL, NULL, self), (self->top == NULL) ? NULL : (self->top = (g_object_unref (self->top), NULL)), _tmp0_);
#line 643 "program.vala"
	gee_collection_add ((GeeCollection*) self->namespaces, self->top);
#line 644 "program.vala"
	gee_collection_add ((GeeCollection*) self->priv->using_namespaces, "GLib");
#line 4430 "program.c"
}


#line 647 "program.vala"
void valencia_source_file_clear (ValenciaSourceFile* self) {
#line 647 "program.vala"
	g_return_if_fail (self != NULL);
#line 648 "program.vala"
	gee_collection_clear ((GeeCollection*) self->priv->using_namespaces);
#line 649 "program.vala"
	gee_collection_clear ((GeeCollection*) self->namespaces);
#line 650 "program.vala"
	valencia_source_file_alloc_top (self);
#line 4444 "program.c"
}


#line 653 "program.vala"
static GeeArrayList* valencia_source_file_real_children (ValenciaNode* base) {
#line 4450 "program.c"
	ValenciaSourceFile * self;
	GeeArrayList* result;
	self = (ValenciaSourceFile*) base;
	result = valencia_node_single_node ((ValenciaNode*) self->top);
	return result;
}


#line 655 "program.vala"
void valencia_source_file_add_using_namespace (ValenciaSourceFile* self, const char* name) {
#line 655 "program.vala"
	g_return_if_fail (self != NULL);
#line 655 "program.vala"
	g_return_if_fail (name != NULL);
#line 4465 "program.c"
	/* Make sure there isn't a duplicate, since GLib is always added*/
#line 657 "program.vala"
	if (_vala_strcmp0 (name, "GLib") == 0) {
#line 4469 "program.c"
		return;
	}
#line 659 "program.vala"
	gee_collection_add ((GeeCollection*) self->priv->using_namespaces, name);
#line 4474 "program.c"
}


#line 662 "program.vala"
static gboolean valencia_source_file_real_lookup (ValenciaScope* base, ValenciaSymbolSet* symbols, gint pos) {
#line 4480 "program.c"
	ValenciaSourceFile * self;
	gboolean result;
	self = (ValenciaSourceFile*) base;
#line 662 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 4486 "program.c"
	{
		GeeIterator* _ns_it;
		_ns_it = gee_iterable_iterator ((GeeIterable*) self->priv->using_namespaces);
#line 663 "program.vala"
		while (TRUE) {
#line 4492 "program.c"
			char* ns;
#line 663 "program.vala"
			if (!gee_iterator_next (_ns_it)) {
#line 663 "program.vala"
				break;
#line 4498 "program.c"
			}
			ns = (char*) gee_iterator_get (_ns_it);
#line 664 "program.vala"
			if (valencia_program_lookup_in_namespace (self->program, ns, symbols)) {
#line 4503 "program.c"
				result = TRUE;
				ns = (g_free (ns), NULL);
				(_ns_it == NULL) ? NULL : (_ns_it = (gee_collection_object_unref (_ns_it), NULL));
				return result;
			}
			ns = (g_free (ns), NULL);
		}
		(_ns_it == NULL) ? NULL : (_ns_it = (gee_collection_object_unref (_ns_it), NULL));
	}
	result = FALSE;
	return result;
}


#line 670 "program.vala"
gboolean valencia_source_file_lookup_in_namespace (ValenciaSourceFile* self, const char* namespace_name, ValenciaSymbolSet* symbols) {
#line 4520 "program.c"
	gboolean result;
#line 670 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 670 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 4526 "program.c"
	{
		GeeIterator* _n_it;
		_n_it = gee_iterable_iterator ((GeeIterable*) self->namespaces);
#line 671 "program.vala"
		while (TRUE) {
#line 4532 "program.c"
			ValenciaNamespace* n;
#line 671 "program.vala"
			if (!gee_iterator_next (_n_it)) {
#line 671 "program.vala"
				break;
#line 4538 "program.c"
			}
			n = (ValenciaNamespace*) gee_iterator_get (_n_it);
#line 672 "program.vala"
			if (_vala_strcmp0 (n->full_name, namespace_name) == 0) {
#line 673 "program.vala"
				if (valencia_symbol_set_local_symbols_only (symbols)) {
#line 674 "program.vala"
					valencia_namespace_lookup_all_toplevel_symbols (n, symbols);
#line 4547 "program.c"
				} else {
#line 675 "program.vala"
					if (valencia_namespace_lookup1 (n, symbols)) {
#line 4551 "program.c"
						result = TRUE;
						(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
						(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
						return result;
					}
				}
			}
			(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
		}
		(_n_it == NULL) ? NULL : (_n_it = (gee_collection_object_unref (_n_it), NULL));
	}
	result = FALSE;
	return result;
}


#line 681 "program.vala"
ValenciaSymbolSet* valencia_source_file_resolve_non_compound (ValenciaSourceFile* self, ValenciaExpression* name, ValenciaChain* chain, gint pos, gboolean find_type, gboolean exact, gboolean constructor, gboolean local_symbols) {
#line 4570 "program.c"
	ValenciaSymbolSet* result;
	ValenciaSymbol* s;
	ValenciaSymbolSet* symbols;
#line 681 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 681 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 681 "program.vala"
	g_return_val_if_fail (chain != NULL, NULL);
#line 4580 "program.c"
	s = NULL;
	symbols = NULL;
#line 686 "program.vala"
	if (VALENCIA_IS_THIS (name)) {
#line 4585 "program.c"
		ValenciaSymbol* _tmp0_;
		_tmp0_ = NULL;
#line 687 "program.vala"
		s = (_tmp0_ = valencia_chain_lookup_this (chain), (s == NULL) ? NULL : (s = (g_object_unref (s), NULL)), _tmp0_);
#line 4590 "program.c"
	} else {
#line 688 "program.vala"
		if (VALENCIA_IS_BASE (name)) {
#line 4594 "program.c"
			ValenciaSymbol* _tmp1_;
			_tmp1_ = NULL;
#line 689 "program.vala"
			s = (_tmp1_ = valencia_chain_lookup_base (chain, self), (s == NULL) ? NULL : (s = (g_object_unref (s), NULL)), _tmp1_);
#line 4599 "program.c"
		} else {
#line 690 "program.vala"
			if (VALENCIA_IS_METHOD_CALL (name)) {
#line 4603 "program.c"
				ValenciaMethodCall* _tmp2_;
				ValenciaMethodCall* method_call;
				ValenciaSymbolSet* _tmp3_;
				ValenciaSymbol* _tmp4_;
				ValenciaConstructor* _tmp6_;
				ValenciaSymbol* _tmp5_;
				ValenciaConstructor* c;
				/* First find the method symbol... (doesn't support constructors yet)*/
#line 692 "program.vala"
				_tmp2_ = NULL;
#line 4614 "program.c"
				method_call = (_tmp2_ = VALENCIA_METHOD_CALL (name), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
				_tmp3_ = NULL;
#line 693 "program.vala"
				symbols = (_tmp3_ = valencia_source_file_resolve1 (self, method_call->method, chain, pos, FALSE, exact, FALSE, local_symbols), (symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL)), _tmp3_);
#line 4619 "program.c"
				_tmp4_ = NULL;
#line 694 "program.vala"
				s = (_tmp4_ = valencia_symbol_set_first (symbols), (s == NULL) ? NULL : (s = (g_object_unref (s), NULL)), _tmp4_);
#line 696 "program.vala"
				_tmp6_ = NULL;
#line 696 "program.vala"
				_tmp5_ = NULL;
#line 4627 "program.c"
				c = (_tmp6_ = (_tmp5_ = s, VALENCIA_IS_CONSTRUCTOR (_tmp5_) ? ((ValenciaConstructor*) _tmp5_) : NULL), (_tmp6_ == NULL) ? NULL : g_object_ref (_tmp6_));
#line 697 "program.vala"
				if (c != NULL) {
#line 4631 "program.c"
					ValenciaSymbol* _tmp8_;
					ValenciaSymbol* _tmp7_;
					_tmp8_ = NULL;
#line 698 "program.vala"
					_tmp7_ = NULL;
#line 698 "program.vala"
					s = (_tmp8_ = (_tmp7_ = (ValenciaSymbol*) c->parent, (_tmp7_ == NULL) ? NULL : g_object_ref (_tmp7_)), (s == NULL) ? NULL : (s = (g_object_unref (s), NULL)), _tmp8_);
#line 4639 "program.c"
				} else {
					ValenciaMethod* _tmp10_;
					ValenciaSymbol* _tmp9_;
					ValenciaMethod* m;
#line 700 "program.vala"
					_tmp10_ = NULL;
#line 700 "program.vala"
					_tmp9_ = NULL;
#line 4648 "program.c"
					m = (_tmp10_ = (_tmp9_ = s, VALENCIA_IS_METHOD (_tmp9_) ? ((ValenciaMethod*) _tmp9_) : NULL), (_tmp10_ == NULL) ? NULL : g_object_ref (_tmp10_));
#line 701 "program.vala"
					if (m != NULL) {
#line 4652 "program.c"
						ValenciaChain* _tmp11_;
						ValenciaSymbolSet* _tmp12_;
#line 142 "program.vala"
						_tmp11_ = NULL;
#line 703 "program.vala"
						_tmp12_ = NULL;
#line 4659 "program.c"
						result = (_tmp12_ = valencia_source_file_resolve1 (self, m->return_type, _tmp11_ = valencia_node_find ((ValenciaNode*) self, NULL, ((ValenciaNode*) m)->start), ((ValenciaNode*) m)->start, TRUE, exact, FALSE, local_symbols), (_tmp11_ == NULL) ? NULL : (_tmp11_ = (g_object_unref (_tmp11_), NULL)), _tmp12_);
						(m == NULL) ? NULL : (m = (g_object_unref (m), NULL));
						(method_call == NULL) ? NULL : (method_call = (g_object_unref (method_call), NULL));
						(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
						(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
						(symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL));
						return result;
					}
					result = valencia_symbol_set_new_empty ();
					(m == NULL) ? NULL : (m = (g_object_unref (m), NULL));
					(method_call == NULL) ? NULL : (method_call = (g_object_unref (method_call), NULL));
					(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
					(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
					(symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL));
					return result;
				}
				(method_call == NULL) ? NULL : (method_call = (g_object_unref (method_call), NULL));
				(c == NULL) ? NULL : (c = (g_object_unref (c), NULL));
			} else {
#line 706 "program.vala"
				if (VALENCIA_IS_ID (name)) {
#line 4681 "program.c"
					ValenciaId* _tmp13_;
					ValenciaId* id;
					ValenciaSymbolSet* _tmp14_;
#line 707 "program.vala"
					_tmp13_ = NULL;
#line 4687 "program.c"
					id = (_tmp13_ = VALENCIA_ID (name), (_tmp13_ == NULL) ? NULL : g_object_ref (_tmp13_));
					_tmp14_ = NULL;
#line 708 "program.vala"
					symbols = (_tmp14_ = valencia_symbol_set_new (id->name, find_type, exact, constructor, local_symbols), (symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL)), _tmp14_);
#line 709 "program.vala"
					valencia_chain_lookup (chain, symbols, pos);
#line 4694 "program.c"
					result = symbols;
					(id == NULL) ? NULL : (id = (g_object_unref (id), NULL));
					(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
					return result;
				} else {
					ValenciaNew* _tmp15_;
					ValenciaNew* n;
					/* name is New*/
#line 712 "program.vala"
					_tmp15_ = NULL;
#line 4705 "program.c"
					n = (_tmp15_ = VALENCIA_NEW (name), (_tmp15_ == NULL) ? NULL : g_object_ref (_tmp15_));
					result = valencia_source_file_resolve1 (self, n->class_name, chain, pos, find_type, exact, TRUE, local_symbols);
					(n == NULL) ? NULL : (n = (g_object_unref (n), NULL));
					(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
					(symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL));
					return result;
				}
			}
		}
	}
#line 716 "program.vala"
	if (s != NULL) {
#line 4718 "program.c"
		ValenciaSymbolSet* _tmp16_;
		_tmp16_ = NULL;
#line 717 "program.vala"
		symbols = (_tmp16_ = valencia_symbol_set_new (s->name, find_type, TRUE, constructor, local_symbols), (symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL)), _tmp16_);
#line 718 "program.vala"
		valencia_symbol_set_add (symbols, s);
#line 4725 "program.c"
	} else {
		ValenciaSymbolSet* _tmp17_;
		_tmp17_ = NULL;
#line 719 "program.vala"
		symbols = (_tmp17_ = valencia_symbol_set_new_empty (), (symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL)), _tmp17_);
#line 4731 "program.c"
	}
	/* return an "empty" set*/
	result = symbols;
	(s == NULL) ? NULL : (s = (g_object_unref (s), NULL));
	return result;
}


#line 724 "program.vala"
ValenciaSymbolSet* valencia_source_file_resolve1 (ValenciaSourceFile* self, ValenciaExpression* name, ValenciaChain* chain, gint pos, gboolean find_type, gboolean exact, gboolean constructor, gboolean local_symbols) {
#line 4742 "program.c"
	ValenciaSymbolSet* result;
	ValenciaCompoundExpression* _tmp0_;
	ValenciaCompoundExpression* compound;
	ValenciaSymbolSet* left_set;
	ValenciaSymbol* left;
	ValenciaScope* _tmp5_;
	ValenciaSymbol* _tmp4_;
	ValenciaScope* scope;
	ValenciaSymbolSet* symbols;
#line 724 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 724 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 724 "program.vala"
	g_return_val_if_fail (chain != NULL, NULL);
#line 726 "program.vala"
	if (!VALENCIA_IS_COMPOUND_EXPRESSION (name)) {
#line 4760 "program.c"
		result = valencia_source_file_resolve_non_compound (self, name, chain, pos, find_type, exact, constructor, local_symbols);
		return result;
	}
	/* The basename of a qualified name is always going to be an exact match, and never a
	 constructor*/
#line 732 "program.vala"
	_tmp0_ = NULL;
#line 4768 "program.c"
	compound = (_tmp0_ = VALENCIA_COMPOUND_EXPRESSION (name), (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_));
	left_set = valencia_source_file_resolve1 (self, compound->left, chain, pos, find_type, TRUE, FALSE, local_symbols);
	left = valencia_symbol_set_first (left_set);
#line 735 "program.vala"
	if (!find_type) {
#line 4774 "program.c"
		ValenciaVariable* _tmp2_;
		ValenciaSymbol* _tmp1_;
		ValenciaVariable* v;
#line 736 "program.vala"
		_tmp2_ = NULL;
#line 736 "program.vala"
		_tmp1_ = NULL;
#line 4782 "program.c"
		v = (_tmp2_ = (_tmp1_ = left, VALENCIA_IS_VARIABLE (_tmp1_) ? ((ValenciaVariable*) _tmp1_) : NULL), (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_));
#line 737 "program.vala"
		if (v != NULL) {
#line 4786 "program.c"
			ValenciaSymbol* _tmp3_;
			_tmp3_ = NULL;
#line 738 "program.vala"
			left = (_tmp3_ = valencia_source_file_resolve_type (((ValenciaSymbol*) v)->source, v->type, ((ValenciaNode*) v)->start), (left == NULL) ? NULL : (left = (g_object_unref (left), NULL)), _tmp3_);
#line 4791 "program.c"
		}
		(v == NULL) ? NULL : (v = (g_object_unref (v), NULL));
	}
#line 741 "program.vala"
	_tmp5_ = NULL;
#line 741 "program.vala"
	_tmp4_ = NULL;
#line 4799 "program.c"
	scope = (_tmp5_ = (_tmp4_ = left, VALENCIA_IS_SCOPE (_tmp4_) ? ((ValenciaScope*) _tmp4_) : NULL), (_tmp5_ == NULL) ? NULL : g_object_ref (_tmp5_));
	/* It doesn't make sense to be looking up members of a method as a qualified name*/
#line 744 "program.vala"
	if (VALENCIA_IS_METHOD (scope)) {
#line 4804 "program.c"
		result = valencia_symbol_set_new_empty ();
		(compound == NULL) ? NULL : (compound = (g_object_unref (compound), NULL));
		(left_set == NULL) ? NULL : (left_set = (g_object_unref (left_set), NULL));
		(left == NULL) ? NULL : (left = (g_object_unref (left), NULL));
		(scope == NULL) ? NULL : (scope = (g_object_unref (scope), NULL));
		return result;
	}
	symbols = valencia_symbol_set_new (compound->right, find_type, exact, constructor, local_symbols);
#line 748 "program.vala"
	if (scope != NULL) {
#line 749 "program.vala"
		valencia_scope_lookup (scope, symbols, 0);
#line 4817 "program.c"
	}
	result = symbols;
	(compound == NULL) ? NULL : (compound = (g_object_unref (compound), NULL));
	(left_set == NULL) ? NULL : (left_set = (g_object_unref (left_set), NULL));
	(left == NULL) ? NULL : (left = (g_object_unref (left), NULL));
	(scope == NULL) ? NULL : (scope = (g_object_unref (scope), NULL));
	return result;
}


#line 754 "program.vala"
ValenciaSymbol* valencia_source_file_resolve (ValenciaSourceFile* self, ValenciaExpression* name, gint pos, gboolean constructor) {
#line 4830 "program.c"
	ValenciaSymbol* result;
	ValenciaChain* _tmp0_;
	ValenciaSymbolSet* _tmp1_;
	ValenciaSymbolSet* symbols;
#line 754 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 754 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 142 "program.vala"
	_tmp0_ = NULL;
#line 755 "program.vala"
	_tmp1_ = NULL;
#line 4843 "program.c"
	symbols = (_tmp1_ = valencia_source_file_resolve1 (self, name, _tmp0_ = valencia_node_find ((ValenciaNode*) self, NULL, pos), pos, FALSE, TRUE, constructor, FALSE), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_);
	result = valencia_symbol_set_first (symbols);
	(symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL));
	return result;
}


#line 759 "program.vala"
ValenciaSymbol* valencia_source_file_resolve_type (ValenciaSourceFile* self, ValenciaExpression* type, gint pos) {
#line 4853 "program.c"
	ValenciaSymbol* result;
	ValenciaChain* _tmp0_;
	ValenciaSymbolSet* _tmp1_;
	ValenciaSymbolSet* symbols;
#line 759 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 759 "program.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 142 "program.vala"
	_tmp0_ = NULL;
#line 760 "program.vala"
	_tmp1_ = NULL;
#line 4866 "program.c"
	symbols = (_tmp1_ = valencia_source_file_resolve1 (self, type, _tmp0_ = valencia_node_find ((ValenciaNode*) self, NULL, pos), 0, TRUE, TRUE, FALSE, FALSE), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_);
	result = valencia_symbol_set_first (symbols);
	(symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL));
	return result;
}


#line 764 "program.vala"
ValenciaSymbolSet* valencia_source_file_resolve_prefix (ValenciaSourceFile* self, ValenciaExpression* prefix, gint pos, gboolean constructor) {
#line 4876 "program.c"
	ValenciaSymbolSet* result;
	ValenciaChain* _tmp0_;
	ValenciaSymbolSet* _tmp1_;
#line 764 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 764 "program.vala"
	g_return_val_if_fail (prefix != NULL, NULL);
#line 142 "program.vala"
	_tmp0_ = NULL;
#line 765 "program.vala"
	_tmp1_ = NULL;
#line 4888 "program.c"
	result = (_tmp1_ = valencia_source_file_resolve1 (self, prefix, _tmp0_ = valencia_node_find ((ValenciaNode*) self, NULL, pos), pos, FALSE, FALSE, constructor, FALSE), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_);
	return result;
}


#line 768 "program.vala"
ValenciaSymbolSet* valencia_source_file_resolve_all_locals (ValenciaSourceFile* self, ValenciaExpression* prefix, gint pos) {
#line 4896 "program.c"
	ValenciaSymbolSet* result;
	ValenciaChain* _tmp0_;
	ValenciaSymbolSet* _tmp1_;
#line 768 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 768 "program.vala"
	g_return_val_if_fail (prefix != NULL, NULL);
#line 142 "program.vala"
	_tmp0_ = NULL;
#line 769 "program.vala"
	_tmp1_ = NULL;
#line 4908 "program.c"
	result = (_tmp1_ = valencia_source_file_resolve1 (self, prefix, _tmp0_ = valencia_node_find ((ValenciaNode*) self, NULL, pos), pos, FALSE, FALSE, FALSE, TRUE), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_);
	return result;
}


#line 772 "program.vala"
ValenciaSymbol* valencia_source_file_resolve_local (ValenciaSourceFile* self, ValenciaExpression* name, gint pos) {
#line 4916 "program.c"
	ValenciaSymbol* result;
	ValenciaChain* _tmp0_;
	ValenciaSymbolSet* _tmp1_;
	ValenciaSymbolSet* symbols;
#line 772 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 772 "program.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 142 "program.vala"
	_tmp0_ = NULL;
#line 773 "program.vala"
	_tmp1_ = NULL;
#line 4929 "program.c"
	symbols = (_tmp1_ = valencia_source_file_resolve1 (self, name, _tmp0_ = valencia_node_find ((ValenciaNode*) self, NULL, pos), pos, FALSE, TRUE, FALSE, TRUE), (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_);
	result = valencia_symbol_set_first (symbols);
	(symbols == NULL) ? NULL : (symbols = (g_object_unref (symbols), NULL));
	return result;
}


#line 777 "program.vala"
static void valencia_source_file_real_print (ValenciaNode* base, gint level) {
#line 4939 "program.c"
	ValenciaSourceFile * self;
	self = (ValenciaSourceFile*) base;
#line 778 "program.vala"
	valencia_node_print ((ValenciaNode*) self->top, level);
#line 4944 "program.c"
}


static void valencia_source_file_class_init (ValenciaSourceFileClass * klass) {
	valencia_source_file_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaSourceFilePrivate));
	VALENCIA_NODE_CLASS (klass)->children = valencia_source_file_real_children;
	VALENCIA_NODE_CLASS (klass)->print = valencia_source_file_real_print;
	G_OBJECT_CLASS (klass)->finalize = valencia_source_file_finalize;
}


static void valencia_source_file_valencia_scope_interface_init (ValenciaScopeIface * iface) {
	valencia_source_file_valencia_scope_parent_iface = g_type_interface_peek_parent (iface);
	iface->lookup = valencia_source_file_real_lookup;
}


static void valencia_source_file_instance_init (ValenciaSourceFile * self) {
	self->priv = VALENCIA_SOURCE_FILE_GET_PRIVATE (self);
	self->priv->using_namespaces = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
	self->namespaces = gee_array_list_new (VALENCIA_TYPE_NAMESPACE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
}


static void valencia_source_file_finalize (GObject* obj) {
	ValenciaSourceFile * self;
	self = VALENCIA_SOURCE_FILE (obj);
	self->filename = (g_free (self->filename), NULL);
	(self->priv->using_namespaces == NULL) ? NULL : (self->priv->using_namespaces = (gee_collection_object_unref (self->priv->using_namespaces), NULL));
	(self->namespaces == NULL) ? NULL : (self->namespaces = (gee_collection_object_unref (self->namespaces), NULL));
	(self->top == NULL) ? NULL : (self->top = (g_object_unref (self->top), NULL));
	G_OBJECT_CLASS (valencia_source_file_parent_class)->finalize (obj);
}


GType valencia_source_file_get_type (void) {
	static GType valencia_source_file_type_id = 0;
	if (valencia_source_file_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaSourceFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_source_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaSourceFile), 0, (GInstanceInitFunc) valencia_source_file_instance_init, NULL };
		static const GInterfaceInfo valencia_scope_info = { (GInterfaceInitFunc) valencia_source_file_valencia_scope_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		valencia_source_file_type_id = g_type_register_static (VALENCIA_TYPE_NODE, "ValenciaSourceFile", &g_define_type_info, 0);
		g_type_add_interface_static (valencia_source_file_type_id, VALENCIA_TYPE_SCOPE, &valencia_scope_info);
	}
	return valencia_source_file_type_id;
}


#line 782 "program.vala"
ValenciaErrorInfo* valencia_error_info_construct (GType object_type) {
#line 4995 "program.c"
	ValenciaErrorInfo * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 782 "program.vala"
ValenciaErrorInfo* valencia_error_info_new (void) {
#line 782 "program.vala"
	return valencia_error_info_construct (VALENCIA_TYPE_ERROR_INFO);
#line 5006 "program.c"
}


static void valencia_error_info_class_init (ValenciaErrorInfoClass * klass) {
	valencia_error_info_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_error_info_finalize;
}


static void valencia_error_info_instance_init (ValenciaErrorInfo * self) {
}


static void valencia_error_info_finalize (GObject* obj) {
	ValenciaErrorInfo * self;
	self = VALENCIA_ERROR_INFO (obj);
	self->filename = (g_free (self->filename), NULL);
	self->start_line = (g_free (self->start_line), NULL);
	self->start_char = (g_free (self->start_char), NULL);
	self->end_line = (g_free (self->end_line), NULL);
	self->end_char = (g_free (self->end_char), NULL);
	G_OBJECT_CLASS (valencia_error_info_parent_class)->finalize (obj);
}


GType valencia_error_info_get_type (void) {
	static GType valencia_error_info_type_id = 0;
	if (valencia_error_info_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaErrorInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_error_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaErrorInfo), 0, (GInstanceInitFunc) valencia_error_info_instance_init, NULL };
		valencia_error_info_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaErrorInfo", &g_define_type_info, 0);
	}
	return valencia_error_info_type_id;
}


#line 795 "program.vala"
ValenciaErrorPair* valencia_error_pair_construct (GType object_type, GtkTextMark* document_err, GtkTextMark* build_err, ValenciaErrorInfo* err_info) {
#line 5044 "program.c"
	ValenciaErrorPair * self;
	GtkTextMark* _tmp1_;
	GtkTextMark* _tmp0_;
	GtkTextMark* _tmp3_;
	GtkTextMark* _tmp2_;
	ValenciaErrorInfo* _tmp5_;
	ValenciaErrorInfo* _tmp4_;
#line 795 "program.vala"
	g_return_val_if_fail (document_err != NULL, NULL);
#line 795 "program.vala"
	g_return_val_if_fail (build_err != NULL, NULL);
#line 795 "program.vala"
	g_return_val_if_fail (err_info != NULL, NULL);
#line 5058 "program.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp1_ = NULL;
#line 796 "program.vala"
	_tmp0_ = NULL;
#line 796 "program.vala"
	self->document_pane_error = (_tmp1_ = (_tmp0_ = document_err, (_tmp0_ == NULL) ? NULL : g_object_ref (_tmp0_)), (self->document_pane_error == NULL) ? NULL : (self->document_pane_error = (g_object_unref (self->document_pane_error), NULL)), _tmp1_);
#line 5065 "program.c"
	_tmp3_ = NULL;
#line 797 "program.vala"
	_tmp2_ = NULL;
#line 797 "program.vala"
	self->build_pane_error = (_tmp3_ = (_tmp2_ = build_err, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (self->build_pane_error == NULL) ? NULL : (self->build_pane_error = (g_object_unref (self->build_pane_error), NULL)), _tmp3_);
#line 5071 "program.c"
	_tmp5_ = NULL;
#line 798 "program.vala"
	_tmp4_ = NULL;
#line 798 "program.vala"
	self->error_info = (_tmp5_ = (_tmp4_ = err_info, (_tmp4_ == NULL) ? NULL : g_object_ref (_tmp4_)), (self->error_info == NULL) ? NULL : (self->error_info = (g_object_unref (self->error_info), NULL)), _tmp5_);
#line 5077 "program.c"
	return self;
}


#line 795 "program.vala"
ValenciaErrorPair* valencia_error_pair_new (GtkTextMark* document_err, GtkTextMark* build_err, ValenciaErrorInfo* err_info) {
#line 795 "program.vala"
	return valencia_error_pair_construct (VALENCIA_TYPE_ERROR_PAIR, document_err, build_err, err_info);
#line 5086 "program.c"
}


static void valencia_error_pair_class_init (ValenciaErrorPairClass * klass) {
	valencia_error_pair_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_error_pair_finalize;
}


static void valencia_error_pair_instance_init (ValenciaErrorPair * self) {
}


static void valencia_error_pair_finalize (GObject* obj) {
	ValenciaErrorPair * self;
	self = VALENCIA_ERROR_PAIR (obj);
	(self->document_pane_error == NULL) ? NULL : (self->document_pane_error = (g_object_unref (self->document_pane_error), NULL));
	(self->build_pane_error == NULL) ? NULL : (self->build_pane_error = (g_object_unref (self->build_pane_error), NULL));
	(self->error_info == NULL) ? NULL : (self->error_info = (g_object_unref (self->error_info), NULL));
	G_OBJECT_CLASS (valencia_error_pair_parent_class)->finalize (obj);
}


GType valencia_error_pair_get_type (void) {
	static GType valencia_error_pair_type_id = 0;
	if (valencia_error_pair_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaErrorPairClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_error_pair_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaErrorPair), 0, (GInstanceInitFunc) valencia_error_pair_instance_init, NULL };
		valencia_error_pair_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaErrorPair", &g_define_type_info, 0);
	}
	return valencia_error_pair_type_id;
}


#line 806 "program.vala"
ValenciaErrorList* valencia_error_list_construct (GType object_type) {
#line 5122 "program.c"
	ValenciaErrorList * self;
	GeeArrayList* _tmp0_;
	self = g_object_newv (object_type, 0, NULL);
	_tmp0_ = NULL;
#line 807 "program.vala"
	self->errors = (_tmp0_ = gee_array_list_new (VALENCIA_TYPE_ERROR_PAIR, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal), (self->errors == NULL) ? NULL : (self->errors = (gee_collection_object_unref (self->errors), NULL)), _tmp0_);
#line 808 "program.vala"
	self->error_index = -1;
#line 5131 "program.c"
	return self;
}


#line 806 "program.vala"
ValenciaErrorList* valencia_error_list_new (void) {
#line 806 "program.vala"
	return valencia_error_list_construct (VALENCIA_TYPE_ERROR_LIST);
#line 5140 "program.c"
}


static void valencia_error_list_class_init (ValenciaErrorListClass * klass) {
	valencia_error_list_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_error_list_finalize;
}


static void valencia_error_list_instance_init (ValenciaErrorList * self) {
}


static void valencia_error_list_finalize (GObject* obj) {
	ValenciaErrorList * self;
	self = VALENCIA_ERROR_LIST (obj);
	(self->errors == NULL) ? NULL : (self->errors = (gee_collection_object_unref (self->errors), NULL));
	G_OBJECT_CLASS (valencia_error_list_parent_class)->finalize (obj);
}


GType valencia_error_list_get_type (void) {
	static GType valencia_error_list_type_id = 0;
	if (valencia_error_list_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaErrorListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_error_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaErrorList), 0, (GInstanceInitFunc) valencia_error_list_instance_init, NULL };
		valencia_error_list_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaErrorList", &g_define_type_info, 0);
	}
	return valencia_error_list_type_id;
}


#line 816 "program.vala"
static gboolean valencia_makefile_regex_parse (ValenciaMakefile* self, GDataInputStream* datastream) {
#line 5174 "program.c"
	gboolean result;
	GError * _inner_error_;
	GRegex* program_regex;
	GRegex* rule_regex;
	GRegex* root_regex;
	gboolean rule_matched;
	gboolean program_matched;
	gboolean root_matched;
	GMatchInfo* info;
	GMatchInfo* _tmp8_;
	gboolean _tmp7_;
	GMatchInfo* _tmp6_;
#line 816 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 816 "program.vala"
	g_return_val_if_fail (datastream != NULL, FALSE);
#line 5191 "program.c"
	_inner_error_ = NULL;
	program_regex = NULL;
	rule_regex = NULL;
	root_regex = NULL;
	{
		GRegex* _tmp0_;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		GRegex* _tmp5_;
		_tmp0_ = g_regex_new ("^\\s*BUILD_ROOT\\s*=\\s*1\\s*$", 0, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			goto __finally0;
		}
		_tmp1_ = NULL;
#line 819 "program.vala"
		root_regex = (_tmp1_ = _tmp0_, (root_regex == NULL) ? NULL : (root_regex = (g_regex_unref (root_regex), NULL)), _tmp1_);
#line 5213 "program.c"
		_tmp2_ = g_regex_new ("^\\s*PROGRAM\\s*=\\s*(\\S+)\\s*$", 0, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			goto __finally0;
		}
		_tmp3_ = NULL;
#line 820 "program.vala"
		program_regex = (_tmp3_ = _tmp2_, (program_regex == NULL) ? NULL : (program_regex = (g_regex_unref (program_regex), NULL)), _tmp3_);
#line 5224 "program.c"
		_tmp4_ = g_regex_new ("^ *([^: ]+) *:", 0, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			goto __finally0;
		}
		_tmp5_ = NULL;
#line 821 "program.vala"
		rule_regex = (_tmp5_ = _tmp4_, (rule_regex == NULL) ? NULL : (rule_regex = (g_regex_unref (rule_regex), NULL)), _tmp5_);
#line 5235 "program.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 823 "program.vala"
			g_warning ("program.vala:823: A RegexError occured when creating a new regular expression.\n");
#line 5246 "program.c"
			result = FALSE;
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			(program_regex == NULL) ? NULL : (program_regex = (g_regex_unref (program_regex), NULL));
			(rule_regex == NULL) ? NULL : (rule_regex = (g_regex_unref (rule_regex), NULL));
			(root_regex == NULL) ? NULL : (root_regex = (g_regex_unref (root_regex), NULL));
			return result;
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		(program_regex == NULL) ? NULL : (program_regex = (g_regex_unref (program_regex), NULL));
		(rule_regex == NULL) ? NULL : (rule_regex = (g_regex_unref (rule_regex), NULL));
		(root_regex == NULL) ? NULL : (root_regex = (g_regex_unref (root_regex), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	/* TODO: report error*/
	rule_matched = FALSE;
	program_matched = FALSE;
	root_matched = FALSE;
	info = NULL;
	/* this line is necessary because of a vala compiler bug that thinks info is uninitialized
	 within the block: if (!program_matched && program_regex.match(line, 0, out info)) {*/
	_tmp8_ = NULL;
	_tmp6_ = NULL;
#line 834 "program.vala"
	_tmp7_ = g_regex_match (program_regex, " ", 0, &_tmp6_);
#line 834 "program.vala"
	info = (_tmp8_ = _tmp6_, (info == NULL) ? NULL : (info = (g_match_info_free (info), NULL)), _tmp8_);
#line 834 "program.vala"
	_tmp7_;
#line 836 "program.vala"
	while (TRUE) {
#line 5281 "program.c"
		gsize length;
		char* line;
		gboolean _tmp12_;
		gboolean _tmp27_;
		length = 0UL;
		line = NULL;
		{
			const char* _tmp9_;
			char* _tmp11_;
			const char* _tmp10_;
			_tmp9_ = g_data_input_stream_read_line (datastream, &length, NULL, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
				goto __finally1;
			}
			_tmp11_ = NULL;
#line 841 "program.vala"
			_tmp10_ = NULL;
#line 841 "program.vala"
			line = (_tmp11_ = (_tmp10_ = _tmp9_, (_tmp10_ == NULL) ? NULL : g_strdup (_tmp10_)), line = (g_free (line), NULL), _tmp11_);
#line 5302 "program.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError * err;
			err = _inner_error_;
			_inner_error_ = NULL;
			{
#line 843 "program.vala"
				g_warning ("program.vala:843: An unexpected error occurred while parsing the Makefile.\n");
#line 5313 "program.c"
				result = FALSE;
				(err == NULL) ? NULL : (err = (g_error_free (err), NULL));
				line = (g_free (line), NULL);
				(program_regex == NULL) ? NULL : (program_regex = (g_regex_unref (program_regex), NULL));
				(rule_regex == NULL) ? NULL : (rule_regex = (g_regex_unref (rule_regex), NULL));
				(root_regex == NULL) ? NULL : (root_regex = (g_regex_unref (root_regex), NULL));
				(info == NULL) ? NULL : (info = (g_match_info_free (info), NULL));
				return result;
			}
		}
		__finally1:
		if (_inner_error_ != NULL) {
			line = (g_free (line), NULL);
			(program_regex == NULL) ? NULL : (program_regex = (g_regex_unref (program_regex), NULL));
			(rule_regex == NULL) ? NULL : (rule_regex = (g_regex_unref (rule_regex), NULL));
			(root_regex == NULL) ? NULL : (root_regex = (g_regex_unref (root_regex), NULL));
			(info == NULL) ? NULL : (info = (g_match_info_free (info), NULL));
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		/* The end of the document was reached, ending...*/
#line 848 "program.vala"
		if (line == NULL) {
#line 5338 "program.c"
			line = (g_free (line), NULL);
#line 849 "program.vala"
			break;
#line 5342 "program.c"
		}
		_tmp12_ = FALSE;
#line 851 "program.vala"
		if (!program_matched) {
#line 5347 "program.c"
			GMatchInfo* _tmp15_;
			gboolean _tmp14_;
			GMatchInfo* _tmp13_;
			_tmp15_ = NULL;
			_tmp13_ = NULL;
#line 851 "program.vala"
			_tmp12_ = (_tmp14_ = g_regex_match (program_regex, line, 0, &_tmp13_), info = (_tmp15_ = _tmp13_, (info == NULL) ? NULL : (info = (g_match_info_free (info), NULL)), _tmp15_), _tmp14_);
#line 5355 "program.c"
		} else {
#line 851 "program.vala"
			_tmp12_ = FALSE;
#line 5359 "program.c"
		}
#line 851 "program.vala"
		if (_tmp12_) {
#line 5363 "program.c"
			char* _tmp16_;
			/* The 'PROGRAM = xyz' regex can be matched anywhere in the makefile, where the rule
			 regex can only be matched the first time.*/
			_tmp16_ = NULL;
#line 854 "program.vala"
			self->relative_binary_run_path = (_tmp16_ = g_match_info_fetch (info, 1), self->relative_binary_run_path = (g_free (self->relative_binary_run_path), NULL), _tmp16_);
#line 855 "program.vala"
			program_matched = TRUE;
#line 5372 "program.c"
		} else {
			gboolean _tmp17_;
			gboolean _tmp18_;
			_tmp17_ = FALSE;
			_tmp18_ = FALSE;
#line 856 "program.vala"
			if (!rule_matched) {
#line 856 "program.vala"
				_tmp18_ = !program_matched;
#line 5382 "program.c"
			} else {
#line 856 "program.vala"
				_tmp18_ = FALSE;
#line 5386 "program.c"
			}
#line 856 "program.vala"
			if (_tmp18_) {
#line 5390 "program.c"
				GMatchInfo* _tmp21_;
				gboolean _tmp20_;
				GMatchInfo* _tmp19_;
				_tmp21_ = NULL;
				_tmp19_ = NULL;
#line 856 "program.vala"
				_tmp17_ = (_tmp20_ = g_regex_match (rule_regex, line, 0, &_tmp19_), info = (_tmp21_ = _tmp19_, (info == NULL) ? NULL : (info = (g_match_info_free (info), NULL)), _tmp21_), _tmp20_);
#line 5398 "program.c"
			} else {
#line 856 "program.vala"
				_tmp17_ = FALSE;
#line 5402 "program.c"
			}
#line 856 "program.vala"
			if (_tmp17_) {
#line 5406 "program.c"
				char* _tmp22_;
#line 857 "program.vala"
				rule_matched = TRUE;
#line 5410 "program.c"
				_tmp22_ = NULL;
#line 858 "program.vala"
				self->relative_binary_run_path = (_tmp22_ = g_match_info_fetch (info, 1), self->relative_binary_run_path = (g_free (self->relative_binary_run_path), NULL), _tmp22_);
#line 5414 "program.c"
			} else {
				gboolean _tmp23_;
				_tmp23_ = FALSE;
#line 859 "program.vala"
				if (!root_matched) {
#line 5420 "program.c"
					GMatchInfo* _tmp26_;
					gboolean _tmp25_;
					GMatchInfo* _tmp24_;
					_tmp26_ = NULL;
					_tmp24_ = NULL;
#line 859 "program.vala"
					_tmp23_ = (_tmp25_ = g_regex_match (root_regex, line, 0, &_tmp24_), info = (_tmp26_ = _tmp24_, (info == NULL) ? NULL : (info = (g_match_info_free (info), NULL)), _tmp26_), _tmp25_);
#line 5428 "program.c"
				} else {
#line 859 "program.vala"
					_tmp23_ = FALSE;
#line 5432 "program.c"
				}
#line 859 "program.vala"
				if (_tmp23_) {
#line 860 "program.vala"
					root_matched = TRUE;
#line 5438 "program.c"
				}
			}
		}
		_tmp27_ = FALSE;
#line 863 "program.vala"
		if (program_matched) {
#line 863 "program.vala"
			_tmp27_ = root_matched;
#line 5447 "program.c"
		} else {
#line 863 "program.vala"
			_tmp27_ = FALSE;
#line 5451 "program.c"
		}
#line 863 "program.vala"
		if (_tmp27_) {
#line 5455 "program.c"
			line = (g_free (line), NULL);
#line 864 "program.vala"
			break;
#line 5459 "program.c"
		}
		line = (g_free (line), NULL);
	}
	result = root_matched;
	(program_regex == NULL) ? NULL : (program_regex = (g_regex_unref (program_regex), NULL));
	(rule_regex == NULL) ? NULL : (rule_regex = (g_regex_unref (rule_regex), NULL));
	(root_regex == NULL) ? NULL : (root_regex = (g_regex_unref (root_regex), NULL));
	(info == NULL) ? NULL : (info = (g_match_info_free (info), NULL));
	return result;
}


/* Return: true if current directory will be root, false if not*/
#line 871 "program.vala"
gboolean valencia_makefile_parse (ValenciaMakefile* self, GFile* makefile) {
#line 5475 "program.c"
	gboolean result;
	GError * _inner_error_;
	GFileInputStream* stream;
	GDataInputStream* datastream;
#line 871 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 871 "program.vala"
	g_return_val_if_fail (makefile != NULL, FALSE);
#line 5484 "program.c"
	_inner_error_ = NULL;
	stream = NULL;
	{
		GFileInputStream* _tmp0_;
		GFileInputStream* _tmp1_;
		_tmp0_ = g_file_read (makefile, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
			goto __finally2;
		}
		_tmp1_ = NULL;
#line 874 "program.vala"
		stream = (_tmp1_ = _tmp0_, (stream == NULL) ? NULL : (stream = (g_object_unref (stream), NULL)), _tmp1_);
#line 5498 "program.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError * err;
		err = _inner_error_;
		_inner_error_ = NULL;
		{
#line 876 "program.vala"
			g_warning ("program.vala:876: Unable to open %s for parsing.\n", self->path);
#line 5509 "program.c"
			result = FALSE;
			(err == NULL) ? NULL : (err = (g_error_free (err), NULL));
			(stream == NULL) ? NULL : (stream = (g_object_unref (stream), NULL));
			return result;
		}
	}
	__finally2:
	if (_inner_error_ != NULL) {
		(stream == NULL) ? NULL : (stream = (g_object_unref (stream), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	datastream = g_data_input_stream_new ((GInputStream*) stream);
	result = valencia_makefile_regex_parse (self, datastream);
	(stream == NULL) ? NULL : (stream = (g_object_unref (stream), NULL));
	(datastream == NULL) ? NULL : (datastream = (g_object_unref (datastream), NULL));
	return result;
}


#line 884 "program.vala"
void valencia_makefile_reparse (ValenciaMakefile* self) {
#line 5533 "program.c"
	GFile* makefile;
#line 884 "program.vala"
	g_return_if_fail (self != NULL);
#line 885 "program.vala"
	if (self->path == NULL) {
#line 5539 "program.c"
		return;
	}
	makefile = g_file_new_for_path (self->path);
#line 889 "program.vala"
	valencia_makefile_parse (self, makefile);
#line 5545 "program.c"
	(makefile == NULL) ? NULL : (makefile = (g_object_unref (makefile), NULL));
}


#line 892 "program.vala"
void valencia_makefile_reset_paths (ValenciaMakefile* self) {
#line 5552 "program.c"
	char* _tmp0_;
	char* _tmp1_;
#line 892 "program.vala"
	g_return_if_fail (self != NULL);
#line 5557 "program.c"
	_tmp0_ = NULL;
#line 893 "program.vala"
	self->path = (_tmp0_ = NULL, self->path = (g_free (self->path), NULL), _tmp0_);
#line 5561 "program.c"
	_tmp1_ = NULL;
#line 894 "program.vala"
	self->relative_binary_run_path = (_tmp1_ = NULL, self->relative_binary_run_path = (g_free (self->relative_binary_run_path), NULL), _tmp1_);
#line 5565 "program.c"
}


#line 812 "program.vala"
ValenciaMakefile* valencia_makefile_construct (GType object_type) {
#line 5571 "program.c"
	ValenciaMakefile * self;
	self = g_object_newv (object_type, 0, NULL);
	return self;
}


#line 812 "program.vala"
ValenciaMakefile* valencia_makefile_new (void) {
#line 812 "program.vala"
	return valencia_makefile_construct (VALENCIA_TYPE_MAKEFILE);
#line 5582 "program.c"
}


static void valencia_makefile_class_init (ValenciaMakefileClass * klass) {
	valencia_makefile_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = valencia_makefile_finalize;
}


static void valencia_makefile_instance_init (ValenciaMakefile * self) {
}


static void valencia_makefile_finalize (GObject* obj) {
	ValenciaMakefile * self;
	self = VALENCIA_MAKEFILE (obj);
	self->path = (g_free (self->path), NULL);
	self->relative_binary_run_path = (g_free (self->relative_binary_run_path), NULL);
	G_OBJECT_CLASS (valencia_makefile_parent_class)->finalize (obj);
}


GType valencia_makefile_get_type (void) {
	static GType valencia_makefile_type_id = 0;
	if (valencia_makefile_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaMakefileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_makefile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaMakefile), 0, (GInstanceInitFunc) valencia_makefile_instance_init, NULL };
		valencia_makefile_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaMakefile", &g_define_type_info, 0);
	}
	return valencia_makefile_type_id;
}



static GType valencia_configuration_file_match_value_get_type (void) {
	static GType valencia_configuration_file_match_value_type_id = 0;
	if (G_UNLIKELY (valencia_configuration_file_match_value_type_id == 0)) {
		static const GEnumValue values[] = {{VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_MATCHED, "VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_MATCHED", "matched"}, {VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_UNMATCHED, "VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_UNMATCHED", "unmatched"}, {VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_ERROR, "VALENCIA_CONFIGURATION_FILE_MATCH_VALUE_ERROR", "error"}, {0, NULL, NULL}};
		valencia_configuration_file_match_value_type_id = g_enum_register_static ("ValenciaConfigurationFileMatchValue", values);
	}
	return valencia_configuration_file_match_value_type_id;
}


#line 918 "program.vala"
ValenciaConfigurationFile* valencia_configuration_file_construct (GType object_type, ValenciaProgram* parent_program) {
#line 5628 "program.c"
	ValenciaConfigurationFile * self;
	char* _tmp0_;
	char* _tmp1_;
#line 918 "program.vala"
	g_return_val_if_fail (parent_program != NULL, NULL);
#line 5634 "program.c"
	self = g_object_newv (object_type, 0, NULL);
#line 919 "program.vala"
	self->priv->parent_program = parent_program;
#line 5638 "program.c"
	_tmp0_ = NULL;
#line 920 "program.vala"
	self->priv->build_command = (_tmp0_ = NULL, self->priv->build_command = (g_free (self->priv->build_command), NULL), _tmp0_);
#line 5642 "program.c"
	_tmp1_ = NULL;
#line 921 "program.vala"
	self->priv->clean_command = (_tmp1_ = NULL, self->priv->clean_command = (g_free (self->priv->clean_command), NULL), _tmp1_);
#line 5646 "program.c"
	return self;
}


#line 918 "program.vala"
ValenciaConfigurationFile* valencia_configuration_file_new (ValenciaProgram* parent_program) {
#line 918 "program.vala"
	return valencia_configuration_file_construct (VALENCIA_TYPE_CONFIGURATION_FILE, parent_program);
#line 5655 "program.c"
}


#line 924 "program.vala"
static char* valencia_configuration_file_get_file_path (ValenciaConfigurationFile* self) {
#line 5661 "program.c"
	char* result;
	char* _tmp0_;
	char* _tmp1_;
#line 924 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1495 "program.vala"
	_tmp0_ = NULL;
#line 925 "program.vala"
	_tmp1_ = NULL;
#line 5671 "program.c"
	result = (_tmp1_ = g_build_filename (_tmp0_ = valencia_program_get_top_directory (self->priv->parent_program), ".valencia", NULL), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
	return result;
}


#line 928 "program.vala"
static void valencia_configuration_file_load (ValenciaConfigurationFile* self) {
#line 5679 "program.c"
	GError * _inner_error_;
	char* file_path;
	char* contents;
	GRegex* config_regex;
	char** _tmp6_;
	gint lines_size;
	gint lines_length1;
	char** _tmp5_;
	char** lines;
	gboolean matched_version;
	gboolean matched_build;
	gboolean matched_clean;
#line 928 "program.vala"
	g_return_if_fail (self != NULL);
#line 5694 "program.c"
	_inner_error_ = NULL;
	file_path = valencia_configuration_file_get_file_path (self);
#line 931 "program.vala"
	if (!g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 5699 "program.c"
		file_path = (g_free (file_path), NULL);
		return;
	}
	contents = NULL;
	{
		char* _tmp2_;
		gboolean _tmp1_;
		char* _tmp0_;
		_tmp2_ = NULL;
		_tmp0_ = NULL;
#line 936 "program.vala"
		_tmp1_ = g_file_get_contents (file_path, &_tmp0_, NULL, &_inner_error_);
#line 936 "program.vala"
		contents = (_tmp2_ = _tmp0_, contents = (g_free (contents), NULL), _tmp2_);
#line 936 "program.vala"
		_tmp1_;
#line 5716 "program.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch3_g_file_error;
			}
			goto __finally3;
		}
	}
	goto __finally3;
	__catch3_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 938 "program.vala"
			g_warning ("program.vala:938: Problem while trying to read %s\n", file_path);
#line 5733 "program.c"
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			file_path = (g_free (file_path), NULL);
			contents = (g_free (contents), NULL);
			return;
		}
	}
	__finally3:
	if (_inner_error_ != NULL) {
		file_path = (g_free (file_path), NULL);
		contents = (g_free (contents), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	config_regex = NULL;
	{
		GRegex* _tmp3_;
		GRegex* _tmp4_;
		_tmp3_ = g_regex_new ("^\\s*([^\\s]+)\\s*=\\s*(.+)\\s*$", 0, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch4_g_regex_error;
			}
			goto __finally4;
		}
		/* Match something like: "word_group = value"*/
		_tmp4_ = NULL;
#line 945 "program.vala"
		config_regex = (_tmp4_ = _tmp3_, (config_regex == NULL) ? NULL : (config_regex = (g_regex_unref (config_regex), NULL)), _tmp4_);
#line 5763 "program.c"
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 947 "program.vala"
			g_warning ("program.vala:947: Problem creating a regex to parse the config file\n");
#line 5774 "program.c"
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			file_path = (g_free (file_path), NULL);
			contents = (g_free (contents), NULL);
			(config_regex == NULL) ? NULL : (config_regex = (g_regex_unref (config_regex), NULL));
			return;
		}
	}
	__finally4:
	if (_inner_error_ != NULL) {
		file_path = (g_free (file_path), NULL);
		contents = (g_free (contents), NULL);
		(config_regex == NULL) ? NULL : (config_regex = (g_regex_unref (config_regex), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
#line 951 "program.vala"
	_tmp6_ = NULL;
#line 5793 "program.c"
	_tmp5_ = NULL;
	lines = (_tmp6_ = _tmp5_ = g_strsplit (contents, "\n", 0), lines_length1 = _vala_array_length (_tmp5_), lines_size = lines_length1, _tmp6_);
	matched_version = FALSE;
	matched_build = FALSE;
	matched_clean = FALSE;
	{
		char** line_collection;
		int line_collection_length1;
		int line_it;
#line 956 "program.vala"
		line_collection = lines;
#line 5805 "program.c"
		line_collection_length1 = lines_length1;
		for (line_it = 0; line_it < lines_length1; line_it = line_it + 1) {
			const char* _tmp21_;
			char* line;
#line 951 "program.vala"
			_tmp21_ = NULL;
#line 5812 "program.c"
			line = (_tmp21_ = line_collection[line_it], (_tmp21_ == NULL) ? NULL : g_strdup (_tmp21_));
			{
				GMatchInfo* match_info;
				GMatchInfo* _tmp9_;
				gboolean _tmp8_;
				GMatchInfo* _tmp7_;
				char* match1;
				char* match2;
				gboolean _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
				/* Ignore lines with whitespace*/
#line 958 "program.vala"
				g_strchomp (line);
#line 959 "program.vala"
				if (_vala_strcmp0 (line, "") == 0) {
#line 5831 "program.c"
					line = (g_free (line), NULL);
#line 960 "program.vala"
					continue;
#line 5835 "program.c"
				}
				match_info = NULL;
				_tmp9_ = NULL;
				_tmp7_ = NULL;
#line 964 "program.vala"
				if (!(_tmp8_ = g_regex_match (config_regex, line, 0, &_tmp7_), match_info = (_tmp9_ = _tmp7_, (match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL)), _tmp9_), _tmp8_)) {
#line 965 "program.vala"
					g_warning ("program.vala:965: Incorrect file format, ignoring...\n");
#line 5844 "program.c"
					line = (g_free (line), NULL);
					(match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL));
					file_path = (g_free (file_path), NULL);
					contents = (g_free (contents), NULL);
					(config_regex == NULL) ? NULL : (config_regex = (g_regex_unref (config_regex), NULL));
					lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
					return;
				}
				match1 = g_match_info_fetch (match_info, 1);
				match2 = g_match_info_fetch (match_info, 2);
				_tmp10_ = FALSE;
				_tmp11_ = FALSE;
				_tmp12_ = FALSE;
#line 973 "program.vala"
				if (!matched_build) {
#line 973 "program.vala"
					_tmp12_ = !matched_clean;
#line 5862 "program.c"
				} else {
#line 973 "program.vala"
					_tmp12_ = FALSE;
#line 5866 "program.c"
				}
#line 973 "program.vala"
				if (_tmp12_) {
#line 973 "program.vala"
					_tmp11_ = _vala_strcmp0 (match1, VALENCIA_CONFIGURATION_FILE_version_keyword) == 0;
#line 5872 "program.c"
				} else {
#line 973 "program.vala"
					_tmp11_ = FALSE;
#line 5876 "program.c"
				}
#line 973 "program.vala"
				if (_tmp11_) {
#line 973 "program.vala"
					_tmp10_ = _vala_strcmp0 (match2, VALENCIA_CONFIGURATION_FILE_version) == 0;
#line 5882 "program.c"
				} else {
#line 973 "program.vala"
					_tmp10_ = FALSE;
#line 5886 "program.c"
				}
				/* Only match the version on the first line with text, any other line is a parse error*/
#line 973 "program.vala"
				if (_tmp10_) {
#line 974 "program.vala"
					matched_version = TRUE;
#line 5893 "program.c"
					line = (g_free (line), NULL);
					(match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL));
					match1 = (g_free (match1), NULL);
					match2 = (g_free (match2), NULL);
#line 975 "program.vala"
					continue;
#line 5900 "program.c"
				} else {
#line 976 "program.vala"
					if (!matched_version) {
#line 977 "program.vala"
						g_warning ("program.vala:977: Mismatched config file version, ignoring...\n");
#line 5906 "program.c"
						line = (g_free (line), NULL);
						(match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL));
						match1 = (g_free (match1), NULL);
						match2 = (g_free (match2), NULL);
						file_path = (g_free (file_path), NULL);
						contents = (g_free (contents), NULL);
						(config_regex == NULL) ? NULL : (config_regex = (g_regex_unref (config_regex), NULL));
						lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
						return;
					}
				}
				_tmp13_ = FALSE;
				_tmp14_ = FALSE;
#line 981 "program.vala"
				if (_vala_strcmp0 (match1, VALENCIA_CONFIGURATION_FILE_build_command_keyword) == 0) {
#line 981 "program.vala"
					_tmp14_ = match2 != NULL;
#line 5924 "program.c"
				} else {
#line 981 "program.vala"
					_tmp14_ = FALSE;
#line 5928 "program.c"
				}
#line 981 "program.vala"
				if (_tmp14_) {
#line 981 "program.vala"
					_tmp13_ = self->priv->build_command == NULL;
#line 5934 "program.c"
				} else {
#line 981 "program.vala"
					_tmp13_ = FALSE;
#line 5938 "program.c"
				}
#line 981 "program.vala"
				if (_tmp13_) {
#line 5942 "program.c"
					char* _tmp16_;
					const char* _tmp15_;
					_tmp16_ = NULL;
#line 982 "program.vala"
					_tmp15_ = NULL;
#line 982 "program.vala"
					self->priv->build_command = (_tmp16_ = (_tmp15_ = match2, (_tmp15_ == NULL) ? NULL : g_strdup (_tmp15_)), self->priv->build_command = (g_free (self->priv->build_command), NULL), _tmp16_);
#line 5950 "program.c"
				} else {
					gboolean _tmp17_;
					gboolean _tmp18_;
					_tmp17_ = FALSE;
					_tmp18_ = FALSE;
#line 983 "program.vala"
					if (_vala_strcmp0 (match1, VALENCIA_CONFIGURATION_FILE_clean_command_keyword) == 0) {
#line 983 "program.vala"
						_tmp18_ = match2 != NULL;
#line 5960 "program.c"
					} else {
#line 983 "program.vala"
						_tmp18_ = FALSE;
#line 5964 "program.c"
					}
#line 983 "program.vala"
					if (_tmp18_) {
#line 983 "program.vala"
						_tmp17_ = self->priv->clean_command == NULL;
#line 5970 "program.c"
					} else {
#line 983 "program.vala"
						_tmp17_ = FALSE;
#line 5974 "program.c"
					}
#line 983 "program.vala"
					if (_tmp17_) {
#line 5978 "program.c"
						char* _tmp20_;
						const char* _tmp19_;
						_tmp20_ = NULL;
#line 984 "program.vala"
						_tmp19_ = NULL;
#line 984 "program.vala"
						self->priv->clean_command = (_tmp20_ = (_tmp19_ = match2, (_tmp19_ == NULL) ? NULL : g_strdup (_tmp19_)), self->priv->clean_command = (g_free (self->priv->clean_command), NULL), _tmp20_);
#line 5986 "program.c"
					} else {
#line 986 "program.vala"
						g_warning ("program.vala:986: Incorrect file format, ignoring...\n");
#line 5990 "program.c"
						line = (g_free (line), NULL);
						(match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL));
						match1 = (g_free (match1), NULL);
						match2 = (g_free (match2), NULL);
						file_path = (g_free (file_path), NULL);
						contents = (g_free (contents), NULL);
						(config_regex == NULL) ? NULL : (config_regex = (g_regex_unref (config_regex), NULL));
						lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
						return;
					}
				}
				line = (g_free (line), NULL);
				(match_info == NULL) ? NULL : (match_info = (g_match_info_free (match_info), NULL));
				match1 = (g_free (match1), NULL);
				match2 = (g_free (match2), NULL);
			}
		}
	}
	file_path = (g_free (file_path), NULL);
	contents = (g_free (contents), NULL);
	(config_regex == NULL) ? NULL : (config_regex = (g_regex_unref (config_regex), NULL));
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
}


#line 992 "program.vala"
char* valencia_configuration_file_get_build_command (ValenciaConfigurationFile* self) {
#line 6018 "program.c"
	char* result;
	const char* _tmp0_;
	const char* _tmp1_;
#line 992 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 993 "program.vala"
	if (self->priv->build_command == NULL) {
#line 994 "program.vala"
		valencia_configuration_file_load (self);
#line 6028 "program.c"
	}
	_tmp0_ = NULL;
#line 996 "program.vala"
	if (self->priv->build_command == NULL) {
#line 996 "program.vala"
		_tmp0_ = VALENCIA_CONFIGURATION_FILE_default_build_command;
#line 6035 "program.c"
	} else {
#line 996 "program.vala"
		_tmp0_ = self->priv->build_command;
#line 6039 "program.c"
	}
#line 996 "program.vala"
	_tmp1_ = NULL;
#line 6043 "program.c"
	result = (_tmp1_ = _tmp0_, (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_));
	return result;
}


#line 999 "program.vala"
char* valencia_configuration_file_get_clean_command (ValenciaConfigurationFile* self) {
#line 6051 "program.c"
	char* result;
	const char* _tmp0_;
	const char* _tmp1_;
#line 999 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1000 "program.vala"
	if (self->priv->clean_command == NULL) {
#line 1001 "program.vala"
		valencia_configuration_file_load (self);
#line 6061 "program.c"
	}
	_tmp0_ = NULL;
#line 1003 "program.vala"
	if (self->priv->clean_command == NULL) {
#line 1003 "program.vala"
		_tmp0_ = VALENCIA_CONFIGURATION_FILE_default_clean_command;
#line 6068 "program.c"
	} else {
#line 1003 "program.vala"
		_tmp0_ = self->priv->clean_command;
#line 6072 "program.c"
	}
#line 1003 "program.vala"
	_tmp1_ = NULL;
#line 6076 "program.c"
	result = (_tmp1_ = _tmp0_, (_tmp1_ == NULL) ? NULL : g_strdup (_tmp1_));
	return result;
}


#line 1006 "program.vala"
void valencia_configuration_file_update (ValenciaConfigurationFile* self, const char* new_build_command, const char* new_clean_command) {
#line 6084 "program.c"
	char* _tmp1_;
	const char* _tmp0_;
	char* _tmp3_;
	const char* _tmp2_;
	char* file_path;
	FILE* file;
#line 1006 "program.vala"
	g_return_if_fail (self != NULL);
#line 1006 "program.vala"
	g_return_if_fail (new_build_command != NULL);
#line 1006 "program.vala"
	g_return_if_fail (new_clean_command != NULL);
#line 6097 "program.c"
	_tmp1_ = NULL;
#line 1007 "program.vala"
	_tmp0_ = NULL;
#line 1007 "program.vala"
	self->priv->build_command = (_tmp1_ = (_tmp0_ = new_build_command, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_)), self->priv->build_command = (g_free (self->priv->build_command), NULL), _tmp1_);
#line 6103 "program.c"
	_tmp3_ = NULL;
#line 1008 "program.vala"
	_tmp2_ = NULL;
#line 1008 "program.vala"
	self->priv->clean_command = (_tmp3_ = (_tmp2_ = new_clean_command, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), self->priv->clean_command = (g_free (self->priv->clean_command), NULL), _tmp3_);
#line 6109 "program.c"
	file_path = valencia_configuration_file_get_file_path (self);
	file = fopen (file_path, "w");
#line 1013 "program.vala"
	if (file == NULL) {
#line 1014 "program.vala"
		g_warning ("program.vala:1014: Could not open %s for writing\n", file_path);
#line 6116 "program.c"
		file_path = (g_free (file_path), NULL);
		(file == NULL) ? NULL : (file = (fclose (file), NULL));
		return;
	}
#line 1018 "program.vala"
	fprintf (file, "%s = %s\n", VALENCIA_CONFIGURATION_FILE_version_keyword, VALENCIA_CONFIGURATION_FILE_version);
#line 1019 "program.vala"
	fprintf (file, "%s = %s\n", VALENCIA_CONFIGURATION_FILE_build_command_keyword, self->priv->build_command);
#line 1020 "program.vala"
	fprintf (file, "%s = %s\n", VALENCIA_CONFIGURATION_FILE_clean_command_keyword, self->priv->clean_command);
#line 6127 "program.c"
	file_path = (g_free (file_path), NULL);
	(file == NULL) ? NULL : (file = (fclose (file), NULL));
}


#line 1023 "program.vala"
void valencia_configuration_file_update_location (ValenciaConfigurationFile* self, const char* old_directory) {
#line 6135 "program.c"
	GError * _inner_error_;
	char* _tmp0_;
	GFile* _tmp1_;
	GFile* old_file;
	char* _tmp2_;
	GFile* _tmp3_;
	GFile* new_file;
	char* _tmp4_;
	gboolean _tmp5_;
#line 1023 "program.vala"
	g_return_if_fail (self != NULL);
#line 1023 "program.vala"
	g_return_if_fail (old_directory != NULL);
#line 6149 "program.c"
	_inner_error_ = NULL;
#line 2034 "glib-2.0.vapi"
	_tmp0_ = NULL;
#line 1024 "program.vala"
	_tmp1_ = NULL;
#line 6155 "program.c"
	old_file = (_tmp1_ = g_file_new_for_path (_tmp0_ = g_build_filename (old_directory, ".valencia", NULL)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
#line 924 "program.vala"
	_tmp2_ = NULL;
#line 1025 "program.vala"
	_tmp3_ = NULL;
#line 6161 "program.c"
	new_file = (_tmp3_ = g_file_new_for_path (_tmp2_ = valencia_configuration_file_get_file_path (self)), _tmp2_ = (g_free (_tmp2_), NULL), _tmp3_);
#line 952 "gio-2.0.vapi"
	_tmp4_ = NULL;
#line 1027 "program.vala"
	if ((_tmp5_ = !g_file_test (_tmp4_ = g_file_get_path (old_file), G_FILE_TEST_EXISTS), _tmp4_ = (g_free (_tmp4_), NULL), _tmp5_)) {
#line 6167 "program.c"
		(old_file == NULL) ? NULL : (old_file = (g_object_unref (old_file), NULL));
		(new_file == NULL) ? NULL : (new_file = (g_object_unref (new_file), NULL));
		return;
	}
	{
#line 1031 "program.vala"
		g_file_copy (old_file, new_file, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 6175 "program.c"
		if (_inner_error_ != NULL) {
			goto __catch5_g_error;
			goto __finally5;
		}
	}
	goto __finally5;
	__catch5_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp6_;
#line 952 "gio-2.0.vapi"
			_tmp6_ = NULL;
#line 1033 "program.vala"
			g_warning ("program.vala:1033: Problem while copying old .valencia to %s\n", _tmp6_ = g_file_get_path (new_file));
#line 6193 "program.c"
			_tmp6_ = (g_free (_tmp6_), NULL);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally5:
	if (_inner_error_ != NULL) {
		(old_file == NULL) ? NULL : (old_file = (g_object_unref (old_file), NULL));
		(new_file == NULL) ? NULL : (new_file = (g_object_unref (new_file), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	{
#line 1037 "program.vala"
		g_file_delete (old_file, NULL, &_inner_error_);
#line 6209 "program.c"
		if (_inner_error_ != NULL) {
			goto __catch6_g_error;
			goto __finally6;
		}
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			char* _tmp7_;
#line 952 "gio-2.0.vapi"
			_tmp7_ = NULL;
#line 1039 "program.vala"
			g_warning ("program.vala:1039: Problem while deleting %s\n", _tmp7_ = g_file_get_path (old_file));
#line 6227 "program.c"
			_tmp7_ = (g_free (_tmp7_), NULL);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
		}
	}
	__finally6:
	if (_inner_error_ != NULL) {
		(old_file == NULL) ? NULL : (old_file = (g_object_unref (old_file), NULL));
		(new_file == NULL) ? NULL : (new_file = (g_object_unref (new_file), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return;
	}
	(old_file == NULL) ? NULL : (old_file = (g_object_unref (old_file), NULL));
	(new_file == NULL) ? NULL : (new_file = (g_object_unref (new_file), NULL));
}


static void valencia_configuration_file_class_init (ValenciaConfigurationFileClass * klass) {
	valencia_configuration_file_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaConfigurationFilePrivate));
	G_OBJECT_CLASS (klass)->finalize = valencia_configuration_file_finalize;
}


static void valencia_configuration_file_instance_init (ValenciaConfigurationFile * self) {
	self->priv = VALENCIA_CONFIGURATION_FILE_GET_PRIVATE (self);
}


static void valencia_configuration_file_finalize (GObject* obj) {
	ValenciaConfigurationFile * self;
	self = VALENCIA_CONFIGURATION_FILE (obj);
	self->priv->build_command = (g_free (self->priv->build_command), NULL);
	self->priv->clean_command = (g_free (self->priv->clean_command), NULL);
	G_OBJECT_CLASS (valencia_configuration_file_parent_class)->finalize (obj);
}


GType valencia_configuration_file_get_type (void) {
	static GType valencia_configuration_file_type_id = 0;
	if (valencia_configuration_file_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaConfigurationFileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_configuration_file_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaConfigurationFile), 0, (GInstanceInitFunc) valencia_configuration_file_instance_init, NULL };
		valencia_configuration_file_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaConfigurationFile", &g_define_type_info, 0);
	}
	return valencia_configuration_file_type_id;
}


#line 1165 "program.vala"
static gboolean _valencia_program_parse_local_vala_files_idle_callback_gsource_func (gpointer self) {
#line 6278 "program.c"
	return valencia_program_parse_local_vala_files_idle_callback (self);
}


#line 1069 "program.vala"
static ValenciaProgram* valencia_program_construct (GType object_type, const char* directory) {
#line 6285 "program.c"
	ValenciaProgram * self;
	ValenciaErrorList* _tmp0_;
	char* _tmp1_;
	ValenciaMakefile* _tmp2_;
	ValenciaConfigurationFile* _tmp3_;
	GFile* root_dir;
#line 1069 "program.vala"
	g_return_val_if_fail (directory != NULL, NULL);
#line 6294 "program.c"
	self = g_object_newv (object_type, 0, NULL);
	_tmp0_ = NULL;
#line 1070 "program.vala"
	self->error_list = (_tmp0_ = NULL, (self->error_list == NULL) ? NULL : (self->error_list = (g_object_unref (self->error_list), NULL)), _tmp0_);
#line 6299 "program.c"
	_tmp1_ = NULL;
#line 1071 "program.vala"
	self->priv->top_directory = (_tmp1_ = NULL, self->priv->top_directory = (g_free (self->priv->top_directory), NULL), _tmp1_);
#line 1072 "program.vala"
	self->priv->parsing = TRUE;
#line 6305 "program.c"
	_tmp2_ = NULL;
#line 1073 "program.vala"
	self->priv->makefile = (_tmp2_ = valencia_makefile_new (), (self->priv->makefile == NULL) ? NULL : (self->priv->makefile = (g_object_unref (self->priv->makefile), NULL)), _tmp2_);
#line 6309 "program.c"
	_tmp3_ = NULL;
#line 1074 "program.vala"
	self->config_file = (_tmp3_ = valencia_configuration_file_new (self), (self->config_file == NULL) ? NULL : (self->config_file = (g_object_unref (self->config_file), NULL)), _tmp3_);
#line 6313 "program.c"
	root_dir = g_file_new_for_path (directory);
#line 1079 "program.vala"
	if (valencia_program_get_build_root_directory (self, root_dir)) {
#line 1080 "program.vala"
		self->priv->recursive_project = TRUE;
#line 6319 "program.c"
	} else {
		char* _tmp5_;
		const char* _tmp4_;
		/* If no root directory was found, make sure there is a local top directory, and 
		 scan only that directory for sources*/
		_tmp5_ = NULL;
#line 1084 "program.vala"
		_tmp4_ = NULL;
#line 1084 "program.vala"
		self->priv->top_directory = (_tmp5_ = (_tmp4_ = directory, (_tmp4_ == NULL) ? NULL : g_strdup (_tmp4_)), self->priv->top_directory = (g_free (self->priv->top_directory), NULL), _tmp5_);
#line 1085 "program.vala"
		self->priv->recursive_project = FALSE;
#line 6332 "program.c"
	}
#line 1088 "program.vala"
	g_idle_add (_valencia_program_parse_local_vala_files_idle_callback_gsource_func, self);
#line 1090 "program.vala"
	gee_collection_add ((GeeCollection*) valencia_program_programs, self);
#line 6338 "program.c"
	(root_dir == NULL) ? NULL : (root_dir = (g_object_unref (root_dir), NULL));
	return self;
}


#line 1069 "program.vala"
static ValenciaProgram* valencia_program_new (const char* directory) {
#line 1069 "program.vala"
	return valencia_program_construct (VALENCIA_TYPE_PROGRAM, directory);
#line 6348 "program.c"
}


/* Returns true if a BUILD_ROOT or configure.ac was found: files should be found recursively
 False if only the local directory will be used*/
#line 1095 "program.vala"
static gboolean valencia_program_get_build_root_directory (ValenciaProgram* self, GFile* makefile_dir) {
#line 6356 "program.c"
	gboolean result;
	GFile* makefile_file;
#line 1095 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1095 "program.vala"
	g_return_val_if_fail (makefile_dir != NULL, FALSE);
#line 1096 "program.vala"
	if (valencia_program_configure_exists_in_directory (self, makefile_dir)) {
#line 6365 "program.c"
		result = TRUE;
		return result;
	}
	makefile_file = g_file_get_child (makefile_dir, "Makefile");
#line 1100 "program.vala"
	if (!g_file_query_exists (makefile_file, NULL)) {
#line 6372 "program.c"
		GFile* _tmp0_;
		_tmp0_ = NULL;
#line 1101 "program.vala"
		makefile_file = (_tmp0_ = g_file_get_child (makefile_dir, "makefile"), (makefile_file == NULL) ? NULL : (makefile_file = (g_object_unref (makefile_file), NULL)), _tmp0_);
#line 1103 "program.vala"
		if (!g_file_query_exists (makefile_file, NULL)) {
#line 6379 "program.c"
			GFile* _tmp1_;
			_tmp1_ = NULL;
#line 1104 "program.vala"
			makefile_file = (_tmp1_ = g_file_get_child (makefile_dir, "GNUmakefile"), (makefile_file == NULL) ? NULL : (makefile_file = (g_object_unref (makefile_file), NULL)), _tmp1_);
#line 1106 "program.vala"
			if (!g_file_query_exists (makefile_file, NULL)) {
#line 6386 "program.c"
				result = valencia_program_goto_parent_directory (self, makefile_dir);
				(makefile_file == NULL) ? NULL : (makefile_file = (g_object_unref (makefile_file), NULL));
				return result;
			}
		}
	}
	/* Set the top_directory to be the first BUILD_ROOT we come across*/
#line 1113 "program.vala"
	if (valencia_makefile_parse (self->priv->makefile, makefile_file)) {
#line 1114 "program.vala"
		valencia_program_set_paths (self, makefile_file);
#line 6398 "program.c"
		result = TRUE;
		(makefile_file == NULL) ? NULL : (makefile_file = (g_object_unref (makefile_file), NULL));
		return result;
	}
	result = valencia_program_goto_parent_directory (self, makefile_dir);
	(makefile_file == NULL) ? NULL : (makefile_file = (g_object_unref (makefile_file), NULL));
	return result;
}


#line 1121 "program.vala"
static gboolean valencia_program_goto_parent_directory (ValenciaProgram* self, GFile* base_directory) {
#line 6411 "program.c"
	gboolean result;
	GFile* parent_dir;
	gboolean _tmp0_;
#line 1121 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1121 "program.vala"
	g_return_val_if_fail (base_directory != NULL, FALSE);
#line 6419 "program.c"
	parent_dir = g_file_get_parent (base_directory);
	_tmp0_ = FALSE;
#line 1123 "program.vala"
	if (parent_dir != NULL) {
#line 1123 "program.vala"
		_tmp0_ = valencia_program_get_build_root_directory (self, parent_dir);
#line 6426 "program.c"
	} else {
#line 1123 "program.vala"
		_tmp0_ = FALSE;
#line 6430 "program.c"
	}
	result = _tmp0_;
	(parent_dir == NULL) ? NULL : (parent_dir = (g_object_unref (parent_dir), NULL));
	return result;
}


#line 1126 "program.vala"
static gboolean valencia_program_configure_exists_in_directory (ValenciaProgram* self, GFile* configure_dir) {
#line 6440 "program.c"
	gboolean result;
	GFile* configure;
	char* _tmp1_;
#line 1126 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1126 "program.vala"
	g_return_val_if_fail (configure_dir != NULL, FALSE);
#line 6448 "program.c"
	configure = g_file_get_child (configure_dir, "configure.ac");
#line 1129 "program.vala"
	if (!g_file_query_exists (configure, NULL)) {
#line 6452 "program.c"
		GFile* _tmp0_;
		_tmp0_ = NULL;
#line 1130 "program.vala"
		configure = (_tmp0_ = g_file_get_child (configure_dir, "configure.in"), (configure == NULL) ? NULL : (configure = (g_object_unref (configure), NULL)), _tmp0_);
#line 1132 "program.vala"
		if (!g_file_query_exists (configure, NULL)) {
#line 6459 "program.c"
			result = FALSE;
			(configure == NULL) ? NULL : (configure = (g_object_unref (configure), NULL));
			return result;
		}
	}
	/* If there's a configure file, don't bother parsing for a makefile        */
	_tmp1_ = NULL;
#line 1137 "program.vala"
	self->priv->top_directory = (_tmp1_ = g_file_get_path (configure_dir), self->priv->top_directory = (g_free (self->priv->top_directory), NULL), _tmp1_);
#line 1138 "program.vala"
	valencia_makefile_reset_paths (self->priv->makefile);
#line 6471 "program.c"
	result = TRUE;
	(configure == NULL) ? NULL : (configure = (g_object_unref (configure), NULL));
	return result;
}


#line 1143 "program.vala"
static void valencia_program_set_paths (ValenciaProgram* self, GFile* makefile_file) {
#line 6480 "program.c"
	char* _tmp0_;
	char* _tmp1_;
#line 1143 "program.vala"
	g_return_if_fail (self != NULL);
#line 1143 "program.vala"
	g_return_if_fail (makefile_file != NULL);
#line 6487 "program.c"
	_tmp0_ = NULL;
#line 1144 "program.vala"
	self->priv->makefile->path = (_tmp0_ = g_file_get_path (makefile_file), self->priv->makefile->path = (g_free (self->priv->makefile->path), NULL), _tmp0_);
#line 6491 "program.c"
	_tmp1_ = NULL;
#line 1145 "program.vala"
	self->priv->top_directory = (_tmp1_ = g_path_get_dirname (self->priv->makefile->path), self->priv->top_directory = (g_free (self->priv->top_directory), NULL), _tmp1_);
#line 6495 "program.c"
}


#line 1148 "program.vala"
static char* valencia_program_get_system_vapi_directory (ValenciaProgram* self) {
#line 6501 "program.c"
	char* result;
	char** _tmp1_;
	gint null_dirs_size;
	gint null_dirs_length1;
	char** _tmp0_;
	char** null_dirs;
	ValaCodeContext* context;
	char* path;
#line 1148 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 6512 "program.c"
	/* Sort of a hack to get the path to the system vapi file directory. Gedit may hang or 
	 crash if the vala compiler .so is not present...*/
#line 1151 "program.vala"
	_tmp1_ = NULL;
#line 1151 "program.vala"
	_tmp0_ = NULL;
#line 6519 "program.c"
	null_dirs = (_tmp1_ = (_tmp0_ = g_new0 (char*, 0 + 1), _tmp0_), null_dirs_length1 = 0, null_dirs_size = null_dirs_length1, _tmp1_);
	context = vala_code_context_new ();
	path = vala_code_context_get_package_path (context, "gobject-2.0", null_dirs, null_dirs_length1);
	result = g_path_get_dirname (path);
	null_dirs = (_vala_array_free (null_dirs, null_dirs_length1, (GDestroyNotify) g_free), NULL);
	(context == NULL) ? NULL : (context = (vala_code_context_unref (context), NULL));
	path = (g_free (path), NULL);
	return result;
}


#line 1157 "program.vala"
static void valencia_program_finish_local_parse (ValenciaProgram* self) {
#line 1157 "program.vala"
	g_return_if_fail (self != NULL);
#line 1158 "program.vala"
	self->priv->parsing = FALSE;
#line 1159 "program.vala"
	g_signal_emit_by_name (self, "local-parse-complete");
#line 6539 "program.c"
	/* Emit this now, otherwise it will never be emitted, since the system parsing is done*/
#line 1161 "program.vala"
	if (gee_collection_get_size ((GeeCollection*) valencia_program_system_sources) > 0) {
#line 1162 "program.vala"
		g_signal_emit_by_name (self, "system-parse-complete");
#line 6545 "program.c"
	}
}


#line 1165 "program.vala"
static gboolean valencia_program_parse_local_vala_files_idle_callback (ValenciaProgram* self) {
#line 6552 "program.c"
	gboolean result;
#line 1165 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1166 "program.vala"
	if (gee_collection_get_size ((GeeCollection*) self->priv->sourcefile_paths) == 0) {
#line 6558 "program.c"
		char* system_directory;
		gboolean _tmp0_;
		/* Don't parse system files locally!*/
		system_directory = valencia_program_get_system_vapi_directory (self);
		_tmp0_ = FALSE;
#line 1169 "program.vala"
		if (_vala_strcmp0 (self->priv->top_directory, system_directory) == 0) {
#line 1169 "program.vala"
			_tmp0_ = TRUE;
#line 6568 "program.c"
		} else {
			gboolean _tmp1_;
			_tmp1_ = FALSE;
#line 1170 "program.vala"
			if (self->priv->recursive_project) {
#line 1170 "program.vala"
				_tmp1_ = dir_has_parent (system_directory, self->priv->top_directory);
#line 6576 "program.c"
			} else {
#line 1170 "program.vala"
				_tmp1_ = FALSE;
#line 6580 "program.c"
			}
#line 1170 "program.vala"
			_tmp0_ = _tmp1_;
#line 6584 "program.c"
		}
#line 1169 "program.vala"
		if (_tmp0_) {
#line 1171 "program.vala"
			valencia_program_finish_local_parse (self);
#line 6590 "program.c"
			result = FALSE;
			system_directory = (g_free (system_directory), NULL);
			return result;
		}
#line 1175 "program.vala"
		valencia_program_cache_source_paths_in_directory (self, self->priv->top_directory, self->priv->recursive_project);
#line 6597 "program.c"
		system_directory = (g_free (system_directory), NULL);
	}
	{
		gint i;
		/* We can reasonably parse 3 files in one go to take a load off of X11*/
		i = 0;
		{
			gboolean _tmp2_;
			_tmp2_ = TRUE;
#line 1179 "program.vala"
			while (TRUE) {
#line 1179 "program.vala"
				if (!_tmp2_) {
#line 1179 "program.vala"
					i = i + 1;
#line 6613 "program.c"
				}
#line 1179 "program.vala"
				_tmp2_ = FALSE;
#line 1179 "program.vala"
				if (!(i < 3)) {
#line 1179 "program.vala"
					break;
#line 6621 "program.c"
				}
#line 1180 "program.vala"
				if (!valencia_program_parse_vala_file (self, self->priv->sources)) {
#line 1181 "program.vala"
					valencia_program_finish_local_parse (self);
#line 6627 "program.c"
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}


#line 1189 "program.vala"
static gboolean valencia_program_parse_system_vala_files_idle_callback (ValenciaProgram* self) {
#line 6641 "program.c"
	gboolean result;
#line 1189 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1190 "program.vala"
	if (gee_collection_get_size ((GeeCollection*) self->priv->sourcefile_paths) == 0) {
#line 6647 "program.c"
		char* system_directory;
		system_directory = valencia_program_get_system_vapi_directory (self);
#line 1192 "program.vala"
		valencia_program_cache_source_paths_in_directory (self, system_directory, TRUE);
#line 6652 "program.c"
		system_directory = (g_free (system_directory), NULL);
	}
	{
		gint i;
		i = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
#line 1195 "program.vala"
			while (TRUE) {
#line 1195 "program.vala"
				if (!_tmp0_) {
#line 1195 "program.vala"
					i = i + 1;
#line 6667 "program.c"
				}
#line 1195 "program.vala"
				_tmp0_ = FALSE;
#line 1195 "program.vala"
				if (!(i < 3)) {
#line 1195 "program.vala"
					break;
#line 6675 "program.c"
				}
#line 1196 "program.vala"
				if (!valencia_program_parse_vala_file (self, valencia_program_system_sources)) {
#line 1197 "program.vala"
					self->priv->parsing = FALSE;
#line 1198 "program.vala"
					valencia_program_sort_system_files (self);
#line 1199 "program.vala"
					g_signal_emit_by_name (self, "system-parse-complete");
#line 6685 "program.c"
					result = FALSE;
					return result;
				}
			}
		}
	}
	result = TRUE;
	return result;
}


/* Takes the next vala file in the sources path list and parses it. Returns true if there are
 more files to parse, false if there are not.*/
#line 1209 "program.vala"
static gboolean valencia_program_parse_vala_file (ValenciaProgram* self, GeeArrayList* source_list) {
#line 6701 "program.c"
	gboolean result;
	GError * _inner_error_;
	char* path;
	ValenciaSourceFile* source;
	char* contents;
	ValenciaParser* parser;
#line 1209 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1209 "program.vala"
	g_return_val_if_fail (source_list != NULL, FALSE);
#line 6712 "program.c"
	_inner_error_ = NULL;
#line 1210 "program.vala"
	if (gee_collection_get_size ((GeeCollection*) self->priv->sourcefile_paths) == 0) {
#line 6716 "program.c"
		result = FALSE;
		return result;
	}
	path = (char*) gee_list_get ((GeeList*) self->priv->sourcefile_paths, self->priv->parse_list_index);
	/* The index is incremented here because if an error happens, we want to skip this file
	 next time around*/
#line 1218 "program.vala"
	self->priv->parse_list_index = self->priv->parse_list_index + 1;
#line 6725 "program.c"
	source = valencia_source_file_new (self, path);
	contents = NULL;
	{
		char* _tmp2_;
		gboolean _tmp1_;
		char* _tmp0_;
		_tmp2_ = NULL;
		_tmp0_ = NULL;
#line 1224 "program.vala"
		_tmp1_ = g_file_get_contents (path, &_tmp0_, NULL, &_inner_error_);
#line 1224 "program.vala"
		contents = (_tmp2_ = _tmp0_, contents = (g_free (contents), NULL), _tmp2_);
#line 1224 "program.vala"
		_tmp1_;
#line 6740 "program.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch7_g_file_error;
			}
			goto __finally7;
		}
	}
	goto __finally7;
	__catch7_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			/* needs a message box? stderr.printf message?*/
			result = self->priv->parse_list_index == gee_collection_get_size ((GeeCollection*) self->priv->sourcefile_paths);
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			path = (g_free (path), NULL);
			(source == NULL) ? NULL : (source = (g_object_unref (source), NULL));
			contents = (g_free (contents), NULL);
			return result;
		}
	}
	__finally7:
	if (_inner_error_ != NULL) {
		path = (g_free (path), NULL);
		(source == NULL) ? NULL : (source = (g_object_unref (source), NULL));
		contents = (g_free (contents), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	parser = valencia_parser_new ();
#line 1231 "program.vala"
	valencia_parser_parse (parser, source, contents);
#line 1232 "program.vala"
	gee_collection_add ((GeeCollection*) source_list, source);
#line 6778 "program.c"
	/* Only show parsing progress if the filesize is over 1MB (1048576 bytes == 1 megabyte)*/
#line 1234 "program.vala"
	if (self->priv->total_filesize > 1048576) {
#line 1235 "program.vala"
		g_signal_emit_by_name (self, "parsed-file", ((double) self->priv->parse_list_index) / gee_collection_get_size ((GeeCollection*) self->priv->sourcefile_paths));
#line 6784 "program.c"
	}
	result = self->priv->parse_list_index != gee_collection_get_size ((GeeCollection*) self->priv->sourcefile_paths);
	path = (g_free (path), NULL);
	(source == NULL) ? NULL : (source = (g_object_unref (source), NULL));
	contents = (g_free (contents), NULL);
	(parser == NULL) ? NULL : (parser = (g_object_unref (parser), NULL));
	return result;
}


/* returns the total size of the files*/
#line 1241 "program.vala"
static gint valencia_program_cache_source_paths_in_directory (ValenciaProgram* self, const char* directory, gboolean recursive) {
#line 6798 "program.c"
	gint result;
	GError * _inner_error_;
	GDir* dir;
#line 1241 "program.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1241 "program.vala"
	g_return_val_if_fail (directory != NULL, 0);
#line 6806 "program.c"
	_inner_error_ = NULL;
#line 1242 "program.vala"
	self->priv->parse_list_index = 0;
#line 6810 "program.c"
	dir = NULL;
	{
		GDir* _tmp0_;
		GDir* _tmp1_;
		_tmp0_ = g_dir_open (directory, 0, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_FILE_ERROR) {
				goto __catch8_g_file_error;
			}
			goto __finally8;
		}
		_tmp1_ = NULL;
#line 1246 "program.vala"
		dir = (_tmp1_ = _tmp0_, (dir == NULL) ? NULL : (dir = (g_dir_close (dir), NULL)), _tmp1_);
#line 6825 "program.c"
	}
	goto __finally8;
	__catch8_g_file_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1248 "program.vala"
			g_warning ("program.vala:1248: Error opening directory: %s\n", directory);
#line 6836 "program.c"
			result = 0;
			(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			(dir == NULL) ? NULL : (dir = (g_dir_close (dir), NULL));
			return result;
		}
	}
	__finally8:
	if (_inner_error_ != NULL) {
		(dir == NULL) ? NULL : (dir = (g_dir_close (dir), NULL));
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
		g_clear_error (&_inner_error_);
		return 0;
	}
#line 1252 "program.vala"
	self->priv->total_filesize = 0;
#line 1254 "program.vala"
	while (TRUE) {
#line 6854 "program.c"
		const char* _tmp2_;
		char* file;
		char* path;
#line 1255 "program.vala"
		_tmp2_ = NULL;
#line 6860 "program.c"
		file = (_tmp2_ = g_dir_read_name (dir), (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_));
#line 1257 "program.vala"
		if (file == NULL) {
#line 6864 "program.c"
			file = (g_free (file), NULL);
#line 1258 "program.vala"
			break;
#line 6868 "program.c"
		}
		path = g_build_filename (directory, file, NULL);
#line 1262 "program.vala"
		if (valencia_program_is_vala (file)) {
#line 1263 "program.vala"
			gee_collection_add ((GeeCollection*) self->priv->sourcefile_paths, path);
#line 6875 "program.c"
			{
				GFile* sourcefile;
				GFileInfo* info;
				sourcefile = g_file_new_for_path (path);
				info = g_file_query_info (sourcefile, "standard::size", G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
				if (_inner_error_ != NULL) {
					(sourcefile == NULL) ? NULL : (sourcefile = (g_object_unref (sourcefile), NULL));
					goto __catch9_g_error;
					goto __finally9;
				}
#line 1269 "program.vala"
				self->priv->total_filesize = self->priv->total_filesize + ((gint) g_file_info_get_size (info));
#line 6888 "program.c"
				(sourcefile == NULL) ? NULL : (sourcefile = (g_object_unref (sourcefile), NULL));
				(info == NULL) ? NULL : (info = (g_object_unref (info), NULL));
			}
			goto __finally9;
			__catch9_g_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
					(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
				}
			}
			__finally9:
			if (_inner_error_ != NULL) {
				file = (g_free (file), NULL);
				path = (g_free (path), NULL);
				(dir == NULL) ? NULL : (dir = (g_dir_close (dir), NULL));
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return 0;
			}
		} else {
			gboolean _tmp3_;
			_tmp3_ = FALSE;
#line 1273 "program.vala"
			if (recursive) {
#line 1273 "program.vala"
				_tmp3_ = g_file_test (path, G_FILE_TEST_IS_DIR);
#line 6918 "program.c"
			} else {
#line 1273 "program.vala"
				_tmp3_ = FALSE;
#line 6922 "program.c"
			}
#line 1273 "program.vala"
			if (_tmp3_) {
#line 1274 "program.vala"
				self->priv->total_filesize = self->priv->total_filesize + valencia_program_cache_source_paths_in_directory (self, path, TRUE);
#line 6928 "program.c"
			}
		}
		file = (g_free (file), NULL);
		path = (g_free (path), NULL);
	}
	result = self->priv->total_filesize;
	(dir == NULL) ? NULL : (dir = (g_dir_close (dir), NULL));
	return result;
}


#line 1280 "program.vala"
static void _valencia_program_parse_system_vapi_files_valencia_program_local_parse_complete (ValenciaProgram* _sender, gpointer self) {
#line 6942 "program.c"
	valencia_program_parse_system_vapi_files (self);
}


#line 1189 "program.vala"
static gboolean _valencia_program_parse_system_vala_files_idle_callback_gsource_func (gpointer self) {
#line 6949 "program.c"
	return valencia_program_parse_system_vala_files_idle_callback (self);
}


#line 1280 "program.vala"
static void valencia_program_parse_system_vapi_files (ValenciaProgram* self) {
#line 1280 "program.vala"
	g_return_if_fail (self != NULL);
#line 6958 "program.c"
	/* Don't parse system vapi files twice*/
#line 1282 "program.vala"
	if (gee_collection_get_size ((GeeCollection*) valencia_program_system_sources) > 0) {
#line 6962 "program.c"
		return;
	}
	/* Only begin parsing vapi files after the local vapi files have been parsed        */
#line 1286 "program.vala"
	if (valencia_program_is_parsing (self)) {
#line 1287 "program.vala"
		g_signal_connect_object (self, "local-parse-complete", (GCallback) _valencia_program_parse_system_vapi_files_valencia_program_local_parse_complete, self, 0);
#line 6970 "program.c"
	} else {
#line 1289 "program.vala"
		self->priv->parsing = TRUE;
#line 1290 "program.vala"
		self->priv->parse_list_index = 0;
#line 1291 "program.vala"
		gee_collection_clear ((GeeCollection*) self->priv->sourcefile_paths);
#line 1292 "program.vala"
		g_idle_add (_valencia_program_parse_system_vala_files_idle_callback_gsource_func, self);
#line 6980 "program.c"
	}
}


#line 1296 "program.vala"
static void valencia_program_sort_system_files (ValenciaProgram* self) {
#line 1296 "program.vala"
	g_return_if_fail (self != NULL);
#line 6989 "program.c"
	{
		gint i;
		/* puts glib.vapi first in the list to avoid built-in type vala profile conflicts 
		 (posix.vapi contains definitions for 'int', jumping to definition may open posix.vapi
		 instead of glib.vapi. Perhaps one day we will be smart enough to know which profile
		 to use)*/
		i = 0;
		{
			gboolean _tmp0_;
			_tmp0_ = TRUE;
#line 1302 "program.vala"
			while (TRUE) {
#line 7002 "program.c"
				ValenciaSourceFile* glib_file;
				ValenciaSourceFile* swap_file;
#line 1302 "program.vala"
				if (!_tmp0_) {
#line 1302 "program.vala"
					i = i + 1;
#line 7009 "program.c"
				}
#line 1302 "program.vala"
				_tmp0_ = FALSE;
#line 1302 "program.vala"
				if (!(i < gee_collection_get_size ((GeeCollection*) valencia_program_system_sources))) {
#line 1302 "program.vala"
					break;
#line 7017 "program.c"
				}
				glib_file = (ValenciaSourceFile*) gee_list_get ((GeeList*) valencia_program_system_sources, i);
#line 1304 "program.vala"
				g_assert (glib_file != NULL);
#line 1306 "program.vala"
				if (!g_str_has_suffix (glib_file->filename, "glib-2.0.vapi")) {
#line 7024 "program.c"
					(glib_file == NULL) ? NULL : (glib_file = (g_object_unref (glib_file), NULL));
#line 1307 "program.vala"
					continue;
#line 7028 "program.c"
				}
#line 1309 "program.vala"
				if (i == 0) {
#line 7032 "program.c"
					(glib_file == NULL) ? NULL : (glib_file = (g_object_unref (glib_file), NULL));
					return;
				}
				swap_file = (ValenciaSourceFile*) gee_list_get ((GeeList*) valencia_program_system_sources, 0);
#line 1313 "program.vala"
				g_assert (swap_file != NULL);
#line 1315 "program.vala"
				gee_list_set ((GeeList*) valencia_program_system_sources, 0, glib_file);
#line 1316 "program.vala"
				gee_list_set ((GeeList*) valencia_program_system_sources, i, swap_file);
#line 7043 "program.c"
				(glib_file == NULL) ? NULL : (glib_file = (g_object_unref (glib_file), NULL));
				(swap_file == NULL) ? NULL : (swap_file = (g_object_unref (swap_file), NULL));
#line 1317 "program.vala"
				break;
#line 7048 "program.c"
			}
		}
	}
}


#line 1321 "program.vala"
gboolean valencia_program_is_vala (const char* filename) {
#line 7057 "program.c"
	gboolean result;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 1321 "program.vala"
	g_return_val_if_fail (filename != NULL, FALSE);
#line 7063 "program.c"
	_tmp0_ = FALSE;
	_tmp1_ = FALSE;
#line 1322 "program.vala"
	if (g_str_has_suffix (filename, ".vala")) {
#line 1322 "program.vala"
		_tmp1_ = TRUE;
#line 7070 "program.c"
	} else {
#line 1323 "program.vala"
		_tmp1_ = g_str_has_suffix (filename, ".vapi");
#line 7074 "program.c"
	}
#line 1322 "program.vala"
	if (_tmp1_) {
#line 1322 "program.vala"
		_tmp0_ = TRUE;
#line 7080 "program.c"
	} else {
#line 1324 "program.vala"
		_tmp0_ = g_str_has_suffix (filename, ".cs");
#line 7084 "program.c"
	}
	result = _tmp0_;
	return result;
}


/* C#*/
#line 1327 "program.vala"
gboolean valencia_program_lookup_in_namespace1 (ValenciaProgram* self, GeeArrayList* source_list, const char* namespace_name, ValenciaSymbolSet* symbols, gboolean vapi) {
#line 7094 "program.c"
	gboolean result;
#line 1327 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1327 "program.vala"
	g_return_val_if_fail (source_list != NULL, FALSE);
#line 1327 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 7102 "program.c"
	{
		GeeIterator* _source_it;
		_source_it = gee_iterable_iterator ((GeeIterable*) source_list);
#line 1329 "program.vala"
		while (TRUE) {
#line 7108 "program.c"
			ValenciaSourceFile* source;
#line 1329 "program.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1329 "program.vala"
				break;
#line 7114 "program.c"
			}
			source = (ValenciaSourceFile*) gee_iterator_get (_source_it);
#line 1330 "program.vala"
			if (g_str_has_suffix (source->filename, ".vapi") == vapi) {
#line 1331 "program.vala"
				if (valencia_source_file_lookup_in_namespace (source, namespace_name, symbols)) {
#line 7121 "program.c"
					result = TRUE;
					(source == NULL) ? NULL : (source = (g_object_unref (source), NULL));
					(_source_it == NULL) ? NULL : (_source_it = (gee_collection_object_unref (_source_it), NULL));
					return result;
				}
			}
			(source == NULL) ? NULL : (source = (g_object_unref (source), NULL));
		}
		(_source_it == NULL) ? NULL : (_source_it = (gee_collection_object_unref (_source_it), NULL));
	}
	result = FALSE;
	return result;
}


#line 1337 "program.vala"
gboolean valencia_program_lookup_in_namespace (ValenciaProgram* self, const char* namespace_name, ValenciaSymbolSet* symbols) {
#line 7139 "program.c"
	gboolean result;
#line 1337 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1337 "program.vala"
	g_return_val_if_fail (symbols != NULL, FALSE);
#line 7145 "program.c"
	/* First look in non-vapi files; we'd like definitions here to have precedence.*/
#line 1339 "program.vala"
	if (!valencia_program_lookup_in_namespace1 (self, self->priv->sources, namespace_name, symbols, FALSE)) {
#line 1340 "program.vala"
		if (valencia_symbol_set_local_symbols_only (symbols)) {
#line 7151 "program.c"
			result = FALSE;
			return result;
		}
#line 1342 "program.vala"
		if (!valencia_program_lookup_in_namespace1 (self, self->priv->sources, namespace_name, symbols, TRUE)) {
#line 7157 "program.c"
			;
		}
		/* .vapi files*/
#line 1343 "program.vala"
		if (!valencia_program_lookup_in_namespace1 (self, valencia_program_system_sources, namespace_name, symbols, TRUE)) {
#line 7163 "program.c"
			result = FALSE;
			return result;
		}
	}
	result = TRUE;
	return result;
}


#line 1349 "program.vala"
static ValenciaSourceFile* valencia_program_find_source1 (ValenciaProgram* self, const char* path, GeeArrayList* source_list) {
#line 7175 "program.c"
	ValenciaSourceFile* result;
#line 1349 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1349 "program.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 1349 "program.vala"
	g_return_val_if_fail (source_list != NULL, NULL);
#line 7183 "program.c"
	{
		GeeIterator* _source_it;
		_source_it = gee_iterable_iterator ((GeeIterable*) source_list);
#line 1350 "program.vala"
		while (TRUE) {
#line 7189 "program.c"
			ValenciaSourceFile* source;
#line 1350 "program.vala"
			if (!gee_iterator_next (_source_it)) {
#line 1350 "program.vala"
				break;
#line 7195 "program.c"
			}
			source = (ValenciaSourceFile*) gee_iterator_get (_source_it);
#line 1351 "program.vala"
			if (_vala_strcmp0 (source->filename, path) == 0) {
#line 7200 "program.c"
				result = source;
				(_source_it == NULL) ? NULL : (_source_it = (gee_collection_object_unref (_source_it), NULL));
				return result;
			}
			(source == NULL) ? NULL : (source = (g_object_unref (source), NULL));
		}
		(_source_it == NULL) ? NULL : (_source_it = (gee_collection_object_unref (_source_it), NULL));
	}
	result = NULL;
	return result;
}


#line 1357 "program.vala"
ValenciaSourceFile* valencia_program_find_source (ValenciaProgram* self, const char* path) {
#line 7216 "program.c"
	ValenciaSourceFile* result;
	ValenciaSourceFile* sf;
#line 1357 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1357 "program.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 7223 "program.c"
	sf = valencia_program_find_source1 (self, path, self->priv->sources);
#line 1359 "program.vala"
	if (sf == NULL) {
#line 7227 "program.c"
		ValenciaSourceFile* _tmp0_;
		_tmp0_ = NULL;
#line 1360 "program.vala"
		sf = (_tmp0_ = valencia_program_find_source1 (self, path, valencia_program_system_sources), (sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL)), _tmp0_);
#line 7232 "program.c"
	}
	result = sf;
	return result;
}


/* Update the text of a (possibly new) source file in this program.*/
#line 1366 "program.vala"
static void valencia_program_update1 (ValenciaProgram* self, const char* path, const char* contents) {
#line 7242 "program.c"
	ValenciaSourceFile* source;
	ValenciaParser* _tmp1_;
#line 1366 "program.vala"
	g_return_if_fail (self != NULL);
#line 1366 "program.vala"
	g_return_if_fail (path != NULL);
#line 1366 "program.vala"
	g_return_if_fail (contents != NULL);
#line 7251 "program.c"
	source = valencia_program_find_source (self, path);
#line 1368 "program.vala"
	if (source == NULL) {
#line 7255 "program.c"
		ValenciaSourceFile* _tmp0_;
		_tmp0_ = NULL;
#line 1369 "program.vala"
		source = (_tmp0_ = valencia_source_file_new (self, path), (source == NULL) ? NULL : (source = (g_object_unref (source), NULL)), _tmp0_);
#line 1370 "program.vala"
		gee_collection_add ((GeeCollection*) self->priv->sources, source);
#line 7262 "program.c"
	} else {
#line 1371 "program.vala"
		valencia_source_file_clear (source);
#line 7266 "program.c"
	}
	_tmp1_ = NULL;
#line 1372 "program.vala"
	valencia_parser_parse (_tmp1_ = valencia_parser_new (), source, contents);
#line 7271 "program.c"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL));
	(source == NULL) ? NULL : (source = (g_object_unref (source), NULL));
}


#line 1375 "program.vala"
void valencia_program_update (ValenciaProgram* self, const char* path, const char* contents) {
#line 7279 "program.c"
	gboolean _tmp0_;
	char* path_dir;
#line 1375 "program.vala"
	g_return_if_fail (self != NULL);
#line 1375 "program.vala"
	g_return_if_fail (path != NULL);
#line 1375 "program.vala"
	g_return_if_fail (contents != NULL);
#line 1376 "program.vala"
	if (!valencia_program_is_vala (path)) {
#line 7290 "program.c"
		return;
	}
	_tmp0_ = FALSE;
#line 1379 "program.vala"
	if (self->priv->recursive_project) {
#line 1379 "program.vala"
		_tmp0_ = dir_has_parent (path, self->priv->top_directory);
#line 7298 "program.c"
	} else {
#line 1379 "program.vala"
		_tmp0_ = FALSE;
#line 7302 "program.c"
	}
#line 1379 "program.vala"
	if (_tmp0_) {
#line 1380 "program.vala"
		valencia_program_update1 (self, path, contents);
#line 7308 "program.c"
		return;
	}
	path_dir = g_path_get_dirname (path);
#line 1385 "program.vala"
	if (_vala_strcmp0 (self->priv->top_directory, path_dir) == 0) {
#line 1386 "program.vala"
		valencia_program_update1 (self, path, contents);
#line 7316 "program.c"
	}
	path_dir = (g_free (path_dir), NULL);
}


#line 1389 "program.vala"
static ValenciaProgram* valencia_program_find_program (const char* dir) {
#line 7324 "program.c"
	ValenciaProgram* result;
#line 1389 "program.vala"
	g_return_val_if_fail (dir != NULL, NULL);
#line 1390 "program.vala"
	if (valencia_program_programs == NULL) {
#line 7330 "program.c"
		GeeArrayList* _tmp0_;
		_tmp0_ = NULL;
#line 1391 "program.vala"
		valencia_program_programs = (_tmp0_ = gee_array_list_new (VALENCIA_TYPE_PROGRAM, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal), (valencia_program_programs == NULL) ? NULL : (valencia_program_programs = (gee_collection_object_unref (valencia_program_programs), NULL)), _tmp0_);
#line 7335 "program.c"
	}
	{
		GeeIterator* _p_it;
		_p_it = gee_iterable_iterator ((GeeIterable*) valencia_program_programs);
#line 1393 "program.vala"
		while (TRUE) {
#line 7342 "program.c"
			ValenciaProgram* p;
			gboolean _tmp1_;
#line 1393 "program.vala"
			if (!gee_iterator_next (_p_it)) {
#line 1393 "program.vala"
				break;
#line 7349 "program.c"
			}
			p = (ValenciaProgram*) gee_iterator_get (_p_it);
			_tmp1_ = FALSE;
#line 1394 "program.vala"
			if (p->priv->recursive_project) {
#line 7355 "program.c"
				char* _tmp2_;
#line 1495 "program.vala"
				_tmp2_ = NULL;
#line 1394 "program.vala"
				_tmp1_ = dir_has_parent (dir, _tmp2_ = valencia_program_get_top_directory (p));
#line 7361 "program.c"
				_tmp2_ = (g_free (_tmp2_), NULL);
			} else {
#line 1394 "program.vala"
				_tmp1_ = FALSE;
#line 7366 "program.c"
			}
#line 1394 "program.vala"
			if (_tmp1_) {
#line 7370 "program.c"
				result = p;
				(_p_it == NULL) ? NULL : (_p_it = (gee_collection_object_unref (_p_it), NULL));
				return result;
			} else {
#line 1396 "program.vala"
				if (_vala_strcmp0 (p->priv->top_directory, dir) == 0) {
#line 7377 "program.c"
					result = p;
					(_p_it == NULL) ? NULL : (_p_it = (gee_collection_object_unref (_p_it), NULL));
					return result;
				}
			}
			(p == NULL) ? NULL : (p = (g_object_unref (p), NULL));
		}
		(_p_it == NULL) ? NULL : (_p_it = (gee_collection_object_unref (_p_it), NULL));
	}
	result = NULL;
	return result;
}


#line 1402 "program.vala"
ValenciaProgram* valencia_program_find_containing (const char* path, gboolean parse_system_vapi) {
#line 7394 "program.c"
	ValenciaProgram* result;
	char* dir;
	ValenciaProgram* p;
	ValenciaProgram* _tmp1_;
#line 1402 "program.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 7401 "program.c"
	dir = g_path_get_dirname (path);
	p = valencia_program_find_program (dir);
#line 1406 "program.vala"
	if (parse_system_vapi) {
#line 1407 "program.vala"
		if (p == NULL) {
#line 7408 "program.c"
			ValenciaProgram* _tmp0_;
			_tmp0_ = NULL;
#line 1408 "program.vala"
			p = (_tmp0_ = valencia_program_new (dir), (p == NULL) ? NULL : (p = (g_object_unref (p), NULL)), _tmp0_);
#line 7413 "program.c"
		}
#line 1409 "program.vala"
		valencia_program_parse_system_vapi_files (p);
#line 7417 "program.c"
	}
	_tmp1_ = NULL;
#line 1412 "program.vala"
	if (p != NULL) {
#line 7422 "program.c"
		ValenciaProgram* _tmp3_;
		ValenciaProgram* _tmp2_;
		_tmp3_ = NULL;
#line 1412 "program.vala"
		_tmp2_ = NULL;
#line 1412 "program.vala"
		_tmp1_ = (_tmp3_ = (_tmp2_ = p, (_tmp2_ == NULL) ? NULL : g_object_ref (_tmp2_)), (_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL)), _tmp3_);
#line 7430 "program.c"
	} else {
		ValenciaProgram* _tmp4_;
		_tmp4_ = NULL;
#line 1412 "program.vala"
		_tmp1_ = (_tmp4_ = valencia_program_new (dir), (_tmp1_ == NULL) ? NULL : (_tmp1_ = (g_object_unref (_tmp1_), NULL)), _tmp4_);
#line 7436 "program.c"
	}
	result = _tmp1_;
	dir = (g_free (dir), NULL);
	(p == NULL) ? NULL : (p = (g_object_unref (p), NULL));
	return result;
}


#line 1415 "program.vala"
ValenciaProgram* valencia_program_null_find_containing (const char* path) {
#line 7447 "program.c"
	ValenciaProgram* result;
	char* dir;
#line 1416 "program.vala"
	if (path == NULL) {
#line 7452 "program.c"
		result = NULL;
		return result;
	}
	dir = g_path_get_dirname (path);
	result = valencia_program_find_program (dir);
	dir = (g_free (dir), NULL);
	return result;
}


/* Update the text of a (possibly new) source file in any existing program.
 If (contents) is null, we read the file's contents from disk.*/
#line 1424 "program.vala"
void valencia_program_update_any (const char* path, const char* contents) {
#line 7467 "program.c"
	GError * _inner_error_;
	char* dir;
	ValenciaProgram* _tmp0_;
	gboolean _tmp1_;
	char* contents1;
#line 1424 "program.vala"
	g_return_if_fail (path != NULL);
#line 7475 "program.c"
	_inner_error_ = NULL;
#line 1425 "program.vala"
	if (!valencia_program_is_vala (path)) {
#line 7479 "program.c"
		return;
	}
	/* If no program exists for this file, don't even bother looking*/
	dir = g_path_get_dirname (path);
#line 1389 "program.vala"
	_tmp0_ = NULL;
#line 1430 "program.vala"
	if ((_tmp1_ = (_tmp0_ = valencia_program_find_program (dir)) == NULL, (_tmp0_ == NULL) ? NULL : (_tmp0_ = (g_object_unref (_tmp0_), NULL)), _tmp1_)) {
#line 7488 "program.c"
		dir = (g_free (dir), NULL);
		return;
	}
	contents1 = NULL;
	/* owning variable*/
#line 1434 "program.vala"
	if (contents == NULL) {
#line 7496 "program.c"
		{
			char* _tmp4_;
			gboolean _tmp3_;
			char* _tmp2_;
			_tmp4_ = NULL;
			_tmp2_ = NULL;
#line 1436 "program.vala"
			_tmp3_ = g_file_get_contents (path, &_tmp2_, NULL, &_inner_error_);
#line 1436 "program.vala"
			contents1 = (_tmp4_ = _tmp2_, contents1 = (g_free (contents1), NULL), _tmp4_);
#line 1436 "program.vala"
			_tmp3_;
#line 7509 "program.c"
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_FILE_ERROR) {
					goto __catch10_g_file_error;
				}
				goto __finally10;
			}
		}
		goto __finally10;
		__catch10_g_file_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			{
#line 1438 "program.vala"
				g_warning ("program.vala:1438: Unable to open %s for updating\n", path);
#line 7526 "program.c"
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
				dir = (g_free (dir), NULL);
				contents1 = (g_free (contents1), NULL);
				return;
			}
		}
		__finally10:
		if (_inner_error_ != NULL) {
			dir = (g_free (dir), NULL);
			contents1 = (g_free (contents1), NULL);
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
			g_clear_error (&_inner_error_);
			return;
		}
#line 1441 "program.vala"
		contents = contents1;
#line 7543 "program.c"
	}
	/* Make sure to update the file for each sourcefile*/
	{
		GeeIterator* _program_it;
		/* Make sure to update the file for each sourcefile*/
		_program_it = gee_iterable_iterator ((GeeIterable*) valencia_program_programs);
		/* Make sure to update the file for each sourcefile*/
#line 1445 "program.vala"
		while (TRUE) {
#line 7553 "program.c"
			ValenciaProgram* program;
			ValenciaSourceFile* sf;
			/* Make sure to update the file for each sourcefile*/
#line 1445 "program.vala"
			if (!gee_iterator_next (_program_it)) {
#line 7559 "program.c"
				/* Make sure to update the file for each sourcefile*/
#line 1445 "program.vala"
				break;
#line 7563 "program.c"
			}
			/* Make sure to update the file for each sourcefile*/
			program = (ValenciaProgram*) gee_iterator_get (_program_it);
			sf = valencia_program_find_source (program, path);
#line 1447 "program.vala"
			if (sf != NULL) {
#line 1448 "program.vala"
				valencia_program_update1 (program, path, contents);
#line 7572 "program.c"
			}
			(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
			(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
		}
		(_program_it == NULL) ? NULL : (_program_it = (gee_collection_object_unref (_program_it), NULL));
	}
	dir = (g_free (dir), NULL);
	contents1 = (g_free (contents1), NULL);
}


#line 1452 "program.vala"
void valencia_program_rescan_build_root (const char* sourcefile_path) {
#line 7586 "program.c"
	char* _tmp0_;
	ValenciaProgram* _tmp1_;
	ValenciaProgram* program;
	char* _tmp2_;
	GFile* _tmp3_;
	GFile* current_dir;
	const char* _tmp4_;
	char* old_top_directory;
	char* local_directory;
	gboolean found_root;
	gboolean _tmp5_;
	gboolean _tmp6_;
	ValenciaProgram* _tmp9_;
#line 1452 "program.vala"
	g_return_if_fail (sourcefile_path != NULL);
#line 2032 "glib-2.0.vapi"
	_tmp0_ = NULL;
#line 1453 "program.vala"
	_tmp1_ = NULL;
#line 7606 "program.c"
	program = (_tmp1_ = valencia_program_find_program (_tmp0_ = g_path_get_dirname (sourcefile_path)), _tmp0_ = (g_free (_tmp0_), NULL), _tmp1_);
#line 1455 "program.vala"
	if (program == NULL) {
#line 7610 "program.c"
		(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
		return;
	}
#line 2032 "glib-2.0.vapi"
	_tmp2_ = NULL;
#line 1458 "program.vala"
	_tmp3_ = NULL;
#line 7618 "program.c"
	current_dir = (_tmp3_ = g_file_new_for_path (_tmp2_ = g_path_get_dirname (sourcefile_path)), _tmp2_ = (g_free (_tmp2_), NULL), _tmp3_);
#line 1459 "program.vala"
	_tmp4_ = NULL;
#line 7622 "program.c"
	old_top_directory = (_tmp4_ = program->priv->top_directory, (_tmp4_ == NULL) ? NULL : g_strdup (_tmp4_));
	local_directory = g_file_get_path (current_dir);
	/* get_makefile_directory will set top_directory to the path of the makefile it found - 
	 if the path is the same as the old top_directory, then no changes have been made*/
	found_root = valencia_program_get_build_root_directory (program, current_dir);
	_tmp5_ = FALSE;
#line 1468 "program.vala"
	if (found_root) {
#line 1468 "program.vala"
		_tmp5_ = _vala_strcmp0 (old_top_directory, program->priv->top_directory) == 0;
#line 7633 "program.c"
	} else {
#line 1468 "program.vala"
		_tmp5_ = FALSE;
#line 7637 "program.c"
	}
	/* If a root was found and the new and old directories are the same, the old root was found:
	 nothing changes.*/
#line 1468 "program.vala"
	if (_tmp5_) {
#line 7643 "program.c"
		(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
		(current_dir == NULL) ? NULL : (current_dir = (g_object_unref (current_dir), NULL));
		old_top_directory = (g_free (old_top_directory), NULL);
		local_directory = (g_free (local_directory), NULL);
		return;
	}
	_tmp6_ = FALSE;
#line 1470 "program.vala"
	if (!found_root) {
#line 1470 "program.vala"
		_tmp6_ = _vala_strcmp0 (old_top_directory, local_directory) == 0;
#line 7655 "program.c"
	} else {
#line 1470 "program.vala"
		_tmp6_ = FALSE;
#line 7659 "program.c"
	}
#line 1470 "program.vala"
	if (_tmp6_) {
#line 7663 "program.c"
		(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
		(current_dir == NULL) ? NULL : (current_dir = (g_object_unref (current_dir), NULL));
		old_top_directory = (g_free (old_top_directory), NULL);
		local_directory = (g_free (local_directory), NULL);
		return;
	}
	/* If a new root was found, get_makefile_directory() will have changed program.top_directory
	 already; if not, then we need to set it to the local directory manually*/
#line 1475 "program.vala"
	if (!found_root) {
#line 7674 "program.c"
		char* _tmp8_;
		const char* _tmp7_;
		_tmp8_ = NULL;
#line 1476 "program.vala"
		_tmp7_ = NULL;
#line 1476 "program.vala"
		program->priv->top_directory = (_tmp8_ = (_tmp7_ = local_directory, (_tmp7_ == NULL) ? NULL : g_strdup (_tmp7_)), program->priv->top_directory = (g_free (program->priv->top_directory), NULL), _tmp8_);
#line 7682 "program.c"
	}
	/* Make sure to move any .valencia files from the old root to the new root*/
#line 1479 "program.vala"
	valencia_configuration_file_update_location (program->config_file, old_top_directory);
#line 7687 "program.c"
	/* The build root has changed, so: 
	 1) delete the old root*/
#line 1483 "program.vala"
	g_assert (gee_collection_get_size ((GeeCollection*) valencia_program_programs) > 0);
#line 1484 "program.vala"
	gee_collection_remove ((GeeCollection*) valencia_program_programs, program);
#line 7694 "program.c"
	/* 2) delete a program rooted at the new directory if one exists*/
	{
		GeeIterator* _p_it;
		/* 2) delete a program rooted at the new directory if one exists*/
		_p_it = gee_iterable_iterator ((GeeIterable*) valencia_program_programs);
		/* 2) delete a program rooted at the new directory if one exists*/
#line 1487 "program.vala"
		while (TRUE) {
#line 7703 "program.c"
			ValenciaProgram* p;
			/* 2) delete a program rooted at the new directory if one exists*/
#line 1487 "program.vala"
			if (!gee_iterator_next (_p_it)) {
#line 7708 "program.c"
				/* 2) delete a program rooted at the new directory if one exists*/
#line 1487 "program.vala"
				break;
#line 7712 "program.c"
			}
			/* 2) delete a program rooted at the new directory if one exists*/
			p = (ValenciaProgram*) gee_iterator_get (_p_it);
#line 1488 "program.vala"
			if (_vala_strcmp0 (p->priv->top_directory, program->priv->top_directory) == 0) {
#line 1489 "program.vala"
				gee_collection_remove ((GeeCollection*) valencia_program_programs, p);
#line 7720 "program.c"
			}
			(p == NULL) ? NULL : (p = (g_object_unref (p), NULL));
		}
		(_p_it == NULL) ? NULL : (_p_it = (gee_collection_object_unref (_p_it), NULL));
	}
	/* 3) create a new program at new build root*/
	_tmp9_ = NULL;
#line 1492 "program.vala"
	_tmp9_ = valencia_program_new (program->priv->top_directory);
#line 7730 "program.c"
	(_tmp9_ == NULL) ? NULL : (_tmp9_ = (g_object_unref (_tmp9_), NULL));
	(program == NULL) ? NULL : (program = (g_object_unref (program), NULL));
	(current_dir == NULL) ? NULL : (current_dir = (g_object_unref (current_dir), NULL));
	old_top_directory = (g_free (old_top_directory), NULL);
	local_directory = (g_free (local_directory), NULL);
}


#line 1495 "program.vala"
char* valencia_program_get_top_directory (ValenciaProgram* self) {
#line 7741 "program.c"
	char* result;
	const char* _tmp0_;
#line 1495 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1496 "program.vala"
	_tmp0_ = NULL;
#line 7748 "program.c"
	result = (_tmp0_ = self->priv->top_directory, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
	return result;
}


#line 1499 "program.vala"
char* valencia_program_get_binary_run_path (ValenciaProgram* self) {
#line 7756 "program.c"
	char* result;
#line 1499 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1500 "program.vala"
	if (self->priv->makefile->relative_binary_run_path == NULL) {
#line 7762 "program.c"
		result = NULL;
		return result;
	}
	result = g_build_filename (self->priv->top_directory, self->priv->makefile->relative_binary_run_path, NULL);
	return result;
}


#line 1505 "program.vala"
gboolean valencia_program_get_binary_is_executable (ValenciaProgram* self) {
#line 7773 "program.c"
	gboolean result;
	char* binary_path;
	gboolean _tmp0_;
#line 1505 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 7779 "program.c"
	binary_path = valencia_program_get_binary_run_path (self);
	_tmp0_ = FALSE;
#line 1507 "program.vala"
	if (binary_path != NULL) {
#line 1507 "program.vala"
		_tmp0_ = !g_str_has_suffix (binary_path, ".so");
#line 7786 "program.c"
	} else {
#line 1507 "program.vala"
		_tmp0_ = FALSE;
#line 7790 "program.c"
	}
	result = _tmp0_;
	binary_path = (g_free (binary_path), NULL);
	return result;
}


#line 1510 "program.vala"
void valencia_program_reparse_makefile (ValenciaProgram* self) {
#line 1510 "program.vala"
	g_return_if_fail (self != NULL);
#line 1511 "program.vala"
	valencia_makefile_reparse (self->priv->makefile);
#line 7804 "program.c"
}


/* Tries to find a full path for a filename that may be a sourcefile (or another file that
 happens to reside in a sourcefile directory, like a generated .c file)*/
#line 1516 "program.vala"
char* valencia_program_get_path_for_filename (ValenciaProgram* self, const char* filename) {
#line 7812 "program.c"
	char* result;
	GError * _inner_error_;
	char* _tmp1_;
	const char* _tmp5_;
	char* relative_path;
	char* basename;
	GeeArrayList* dirs;
#line 1516 "program.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1516 "program.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 7824 "program.c"
	_inner_error_ = NULL;
#line 1517 "program.vala"
	if (g_path_is_absolute (filename)) {
#line 7828 "program.c"
		const char* _tmp0_;
#line 1518 "program.vala"
		_tmp0_ = NULL;
#line 7832 "program.c"
		result = (_tmp0_ = filename, (_tmp0_ == NULL) ? NULL : g_strdup (_tmp0_));
		return result;
	}
	_tmp1_ = NULL;
#line 1521 "program.vala"
	if (string_contains (filename, G_DIR_SEPARATOR_S)) {
#line 7839 "program.c"
		char* _tmp3_;
		const char* _tmp2_;
		_tmp3_ = NULL;
#line 1522 "program.vala"
		_tmp2_ = NULL;
#line 1522 "program.vala"
		_tmp1_ = (_tmp3_ = (_tmp2_ = filename, (_tmp2_ == NULL) ? NULL : g_strdup (_tmp2_)), _tmp1_ = (g_free (_tmp1_), NULL), _tmp3_);
#line 7847 "program.c"
	} else {
		char* _tmp4_;
		_tmp4_ = NULL;
#line 1522 "program.vala"
		_tmp1_ = (_tmp4_ = g_strconcat (G_DIR_SEPARATOR_S, filename, NULL), _tmp1_ = (g_free (_tmp1_), NULL), _tmp4_);
#line 7853 "program.c"
	}
	/* Make sure the whole basename is matched, not just part of it*/
#line 1521 "program.vala"
	_tmp5_ = NULL;
#line 7858 "program.c"
	relative_path = (_tmp5_ = _tmp1_, (_tmp5_ == NULL) ? NULL : g_strdup (_tmp5_));
	/* Search for the best partial match possible*/
	{
		GeeIterator* _sf_it;
		/* Search for the best partial match possible*/
		_sf_it = gee_iterable_iterator ((GeeIterable*) self->priv->sources);
		/* Search for the best partial match possible*/
#line 1525 "program.vala"
		while (TRUE) {
#line 7868 "program.c"
			ValenciaSourceFile* sf;
			/* Search for the best partial match possible*/
#line 1525 "program.vala"
			if (!gee_iterator_next (_sf_it)) {
#line 7873 "program.c"
				/* Search for the best partial match possible*/
#line 1525 "program.vala"
				break;
#line 7877 "program.c"
			}
			/* Search for the best partial match possible*/
			sf = (ValenciaSourceFile*) gee_iterator_get (_sf_it);
#line 1526 "program.vala"
			if (g_str_has_suffix (sf->filename, relative_path)) {
#line 7883 "program.c"
				const char* _tmp6_;
#line 1527 "program.vala"
				_tmp6_ = NULL;
#line 7887 "program.c"
				result = (_tmp6_ = sf->filename, (_tmp6_ == NULL) ? NULL : g_strdup (_tmp6_));
				(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
				(_sf_it == NULL) ? NULL : (_sf_it = (gee_collection_object_unref (_sf_it), NULL));
				_tmp1_ = (g_free (_tmp1_), NULL);
				relative_path = (g_free (relative_path), NULL);
				return result;
			}
			(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
		}
		(_sf_it == NULL) ? NULL : (_sf_it = (gee_collection_object_unref (_sf_it), NULL));
	}
	/* If no direct match could be made, try searching all directories that the source files
	 are in for a file that matches the basename*/
	basename = g_path_get_basename (filename);
	dirs = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
	{
		GeeIterator* _sf_it;
		_sf_it = gee_iterable_iterator ((GeeIterable*) self->priv->sources);
#line 1534 "program.vala"
		while (TRUE) {
#line 7908 "program.c"
			ValenciaSourceFile* sf;
			char* dir;
#line 1534 "program.vala"
			if (!gee_iterator_next (_sf_it)) {
#line 1534 "program.vala"
				break;
#line 7915 "program.c"
			}
			sf = (ValenciaSourceFile*) gee_iterator_get (_sf_it);
			dir = g_path_get_dirname (sf->filename);
#line 1536 "program.vala"
			if (!gee_collection_contains ((GeeCollection*) dirs, dir)) {
#line 1537 "program.vala"
				gee_collection_add ((GeeCollection*) dirs, dir);
#line 7923 "program.c"
			}
			(sf == NULL) ? NULL : (sf = (g_object_unref (sf), NULL));
			dir = (g_free (dir), NULL);
		}
		(_sf_it == NULL) ? NULL : (_sf_it = (gee_collection_object_unref (_sf_it), NULL));
	}
	{
		GeeIterator* _dir_str_it;
		_dir_str_it = gee_iterable_iterator ((GeeIterable*) dirs);
#line 1539 "program.vala"
		while (TRUE) {
#line 7935 "program.c"
			char* dir_str;
			GDir* directory;
			const char* _tmp9_;
			char* file;
#line 1539 "program.vala"
			if (!gee_iterator_next (_dir_str_it)) {
#line 1539 "program.vala"
				break;
#line 7944 "program.c"
			}
			dir_str = (char*) gee_iterator_get (_dir_str_it);
			directory = NULL;
			{
				GDir* _tmp7_;
				GDir* _tmp8_;
				_tmp7_ = g_dir_open (dir_str, 0, &_inner_error_);
				if (_inner_error_ != NULL) {
					if (_inner_error_->domain == G_FILE_ERROR) {
						goto __catch11_g_file_error;
					}
					goto __finally11;
				}
				_tmp8_ = NULL;
#line 1542 "program.vala"
				directory = (_tmp8_ = _tmp7_, (directory == NULL) ? NULL : (directory = (g_dir_close (directory), NULL)), _tmp8_);
#line 7961 "program.c"
			}
			goto __finally11;
			__catch11_g_file_error:
			{
				GError * e;
				e = _inner_error_;
				_inner_error_ = NULL;
				{
#line 1544 "program.vala"
					g_warning ("program.vala:1544: Could not open %s for reading.\n", dir_str);
#line 7972 "program.c"
					result = NULL;
					(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
					dir_str = (g_free (dir_str), NULL);
					(directory == NULL) ? NULL : (directory = (g_dir_close (directory), NULL));
					(_dir_str_it == NULL) ? NULL : (_dir_str_it = (gee_collection_object_unref (_dir_str_it), NULL));
					_tmp1_ = (g_free (_tmp1_), NULL);
					relative_path = (g_free (relative_path), NULL);
					basename = (g_free (basename), NULL);
					(dirs == NULL) ? NULL : (dirs = (gee_collection_object_unref (dirs), NULL));
					return result;
				}
			}
			__finally11:
			if (_inner_error_ != NULL) {
				dir_str = (g_free (dir_str), NULL);
				(directory == NULL) ? NULL : (directory = (g_dir_close (directory), NULL));
				(_dir_str_it == NULL) ? NULL : (_dir_str_it = (gee_collection_object_unref (_dir_str_it), NULL));
				_tmp1_ = (g_free (_tmp1_), NULL);
				relative_path = (g_free (relative_path), NULL);
				basename = (g_free (basename), NULL);
				(dirs == NULL) ? NULL : (dirs = (gee_collection_object_unref (dirs), NULL));
				g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, _inner_error_->message);
				g_clear_error (&_inner_error_);
				return NULL;
			}
#line 1547 "program.vala"
			_tmp9_ = NULL;
#line 8000 "program.c"
			file = (_tmp9_ = g_dir_read_name (directory), (_tmp9_ == NULL) ? NULL : g_strdup (_tmp9_));
#line 1548 "program.vala"
			while (TRUE) {
#line 8004 "program.c"
				char* _tmp11_;
				const char* _tmp10_;
#line 1548 "program.vala"
				if (!(file != NULL)) {
#line 1548 "program.vala"
					break;
#line 8011 "program.c"
				}
#line 1549 "program.vala"
				if (_vala_strcmp0 (basename, file) == 0) {
#line 8015 "program.c"
					result = g_build_filename (dir_str, file, NULL);
					dir_str = (g_free (dir_str), NULL);
					(directory == NULL) ? NULL : (directory = (g_dir_close (directory), NULL));
					file = (g_free (file), NULL);
					(_dir_str_it == NULL) ? NULL : (_dir_str_it = (gee_collection_object_unref (_dir_str_it), NULL));
					_tmp1_ = (g_free (_tmp1_), NULL);
					relative_path = (g_free (relative_path), NULL);
					basename = (g_free (basename), NULL);
					(dirs == NULL) ? NULL : (dirs = (gee_collection_object_unref (dirs), NULL));
					return result;
				}
				_tmp11_ = NULL;
#line 1551 "program.vala"
				_tmp10_ = NULL;
#line 1551 "program.vala"
				file = (_tmp11_ = (_tmp10_ = g_dir_read_name (directory), (_tmp10_ == NULL) ? NULL : g_strdup (_tmp10_)), file = (g_free (file), NULL), _tmp11_);
#line 8032 "program.c"
			}
			dir_str = (g_free (dir_str), NULL);
			(directory == NULL) ? NULL : (directory = (g_dir_close (directory), NULL));
			file = (g_free (file), NULL);
		}
		(_dir_str_it == NULL) ? NULL : (_dir_str_it = (gee_collection_object_unref (_dir_str_it), NULL));
	}
	result = NULL;
	_tmp1_ = (g_free (_tmp1_), NULL);
	relative_path = (g_free (relative_path), NULL);
	basename = (g_free (basename), NULL);
	(dirs == NULL) ? NULL : (dirs = (gee_collection_object_unref (dirs), NULL));
	return result;
}


#line 1558 "program.vala"
gboolean valencia_program_is_parsing (ValenciaProgram* self) {
#line 8051 "program.c"
	gboolean result;
#line 1558 "program.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 8055 "program.c"
	result = self->priv->parsing;
	return result;
}


static void valencia_program_class_init (ValenciaProgramClass * klass) {
	valencia_program_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValenciaProgramPrivate));
	G_OBJECT_CLASS (klass)->finalize = valencia_program_finalize;
	g_signal_new ("local_parse_complete", VALENCIA_TYPE_PROGRAM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("system_parse_complete", VALENCIA_TYPE_PROGRAM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	g_signal_new ("parsed_file", VALENCIA_TYPE_PROGRAM, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__DOUBLE, G_TYPE_NONE, 1, G_TYPE_DOUBLE);
	valencia_program_system_sources = gee_array_list_new (VALENCIA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
}


static void valencia_program_instance_init (ValenciaProgram * self) {
	self->priv = VALENCIA_PROGRAM_GET_PRIVATE (self);
	self->priv->sourcefile_paths = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, g_direct_equal);
	self->priv->sources = gee_array_list_new (VALENCIA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) g_object_ref, g_object_unref, g_direct_equal);
}


static void valencia_program_finalize (GObject* obj) {
	ValenciaProgram * self;
	self = VALENCIA_PROGRAM (obj);
	(self->error_list == NULL) ? NULL : (self->error_list = (g_object_unref (self->error_list), NULL));
	self->priv->top_directory = (g_free (self->priv->top_directory), NULL);
	(self->priv->sourcefile_paths == NULL) ? NULL : (self->priv->sourcefile_paths = (gee_collection_object_unref (self->priv->sourcefile_paths), NULL));
	(self->priv->sources == NULL) ? NULL : (self->priv->sources = (gee_collection_object_unref (self->priv->sources), NULL));
	(self->priv->makefile == NULL) ? NULL : (self->priv->makefile = (g_object_unref (self->priv->makefile), NULL));
	(self->config_file == NULL) ? NULL : (self->config_file = (g_object_unref (self->config_file), NULL));
	G_OBJECT_CLASS (valencia_program_parent_class)->finalize (obj);
}


GType valencia_program_get_type (void) {
	static GType valencia_program_type_id = 0;
	if (valencia_program_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (ValenciaProgramClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valencia_program_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValenciaProgram), 0, (GInstanceInitFunc) valencia_program_instance_init, NULL };
		valencia_program_type_id = g_type_register_static (G_TYPE_OBJECT, "ValenciaProgram", &g_define_type_info, 0);
	}
	return valencia_program_type_id;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




